@echo off

::------------------------------------------------------------------------------
:: MSMG ToolKit v11.2
:: Copyright (c) 2013-2021 MSMG. All rights reserved.
::------------------------------------------------------------------------------
::
:: Credits: CREDITS.TXT
:: License: LICENSE.TXT
:: 3rd Party License: <Bin\LICENSES>
::
::-------------------------------------------------------------------------------------------

color 1f
title MSMG Toolkit v11.2

reg add "HKCU\Console\%%SystemRoot%%_system32_cmd.exe" /v "ScreenBufferSize" /t REG_DWORD /d "0x23290050" /f >nul
reg add "HKCU\Console\%%SystemRoot%%_system32_cmd.exe" /v "WindowSize" /t REG_DWORD /d "0x190050" /f >nul

setlocal EnableExtensions EnableDelayedExpansion

:: Setting Toolkit environment path variables
set "Bin=%~dp0Bin"
set "Custom=%~dp0Custom"
set "Drivers=%~dp0Drivers"
set "DVD=%~dp0DVD"
set "ISO=%~dp0ISO"
set "Logs=%~dp0Logs"
set "Mount=%~dp0Mount"
set "Packs=%~dp0Packs"
set "ROOT=%~dp0"
set "Temp=%~dp0Temp"
set "Updates=%~dp0Updates"
set "WHD=%~dp0WHD"

:: Setting Host OS version, architecture and language variables
for /f "tokens=4-5 delims=. " %%i in ('ver 2^>nul') do set "HostVersion=%%i.%%j"
If exist "%WinDir%\SysWOW64" set "HostArchitecture=x64"
If not exist "%WinDir%\SysWOW64" set "HostArchitecture=x86"
set HostLanguage=

:: Setting WADK tools environment path variables
if "%HostVersion%" equ "6.1" set "DISM=%Bin%\%HostArchitecture%\DISM81\Dism.exe"
if "%HostVersion%" neq "6.1" set "DISM=%Bin%\%HostArchitecture%\DISM10\Dism.exe"
set "DismScratch=%Temp%\DISM"
set "DismFormat=/English /ScratchDir:%DismScratch% /LogPath:%Logs%\Dism.txt /LogLevel:3 /NoRestart"
set "Imagex=%Bin%\%HostArchitecture%\imagex.exe"
set "Oscdimg=%Bin%\%HostArchitecture%\oscdimg.exe"
set "Dvdburn=%Bin%\dvdburn.exe"
set "WimConfigFile=%Bin%\wimscript.ini"

:: Setting Source OS variables
set SelectedSourceOS=
set "BootWim=%DVD%\sources\boot.wim"
set "InstallWim=%DVD%\sources\install.wim"
set "InstallEsd=%DVD%\sources\install.esd"
set "WinReWim=Windows\System32\Recovery\winre.wim"
set "BootMount=%Mount%\Boot"
set "InstallMount=%Mount%\Install"
set "WinReMount=%Mount%\WinRE"

:: Setting Source Image information variables
set ImageCount=
set ImageIndexNo=
set ImageArchitecture=
set ImageName=
set ImageDescription=
set ImageFlag=
set ImageEdition=
set ImageInstallationType=
set ImageDefaultLanguage=
set ImageMajorVersion=
set ImageMinorVersion=
set ImageBuild=
set ImageVersion=
set ImageServicePackBuild=
set ImageServicePackLevel=
set PackageBuild=
set PackageServicePackBuild=

:: Setting Toolkit's control flag variables
set IsSourceSelected=No
set IsBootImageSelected=No
set IsRecoveryImageSelected=No
set IsRecoveryImageModified=
set IsDialogsEnabled=Yes
set IsLogsEnabled=Yes
set IsImageRegistryLoaded=No
set IsW7SP1CRUSelected=

set "PreActTokens=%Custom%\ActivationTokens"
set "CustomFiles=%Custom%\Files"
set "CustomFonts=%Custom%\Fonts"
set "CustomRecoveryImage=%Custom%\RecoveryImage"
set "CustomRegistry=%Custom%\Registry"
set "CustomTerminalServer=%Custom%\TerminalServer"
set "CustomUxTheme=%Custom%\UxTheme"

:: Setting Toolkit's packs environment path variables
set "Apps=%Packs%\Apps"
set "Braille=%Packs%\Braille"
set "DaRT=%Packs%\DaRT"
set "Dedup=%Packs%\Dedup"
set "DirectX9c=%Packs%\DirectX9c"
set "EdgeClassic=%Packs%\EdgeBrowser"
set "EdgeChromium=%Packs%\EdgeChromium"
set "Games=%Packs%\Games"
set "IE11=%Packs%\IE11"
set "LanguagePacks=%Packs%\LanguagePacks"
set "MediaFeaturePack=%Packs%\MediaFeaturePack"
set "MMRC=%Packs%\MultimediaRestrictedCodecs"
set "NetFx35=%Packs%\NetFX35"
set "NetFx462=%Packs%\NetFX462"
set "NetFx48=%Packs%\NetFX48"
set "NET5=%Packs%\NET5"
set "OfficeUWP=%Packs%\OfficeUWP"
set "OpenSSH=%Packs%\OpenSSH"
set "PortableDevices=%Packs%\PortableDevices"
set "PowerShell7=%Packs%\PowerShell7"
set "RDP81=%Packs%\RDP81"
set "RSAT=%Packs%\RSAT"
set "Sidebar=%Packs%\Sidebar"
set "Skins=%Packs%\Skins"
set "SystemRestore=%Packs%\SystemRestore"
set "ThinPC=%Packs%\ThinPC"
set "UAP=%Packs%\UAP"
set "VCRuntime=%Packs%\VCRuntime"
set "Win32Calc=%Packs%\Win32Calc"
set "WinToGo=%Packs%\WinToGo"
set "WMF=%Packs%\WMF"
set "WMR=%Packs%\WMR"
set "WSL=%Packs%\WSL"

:: Setting Toolkit's dependent tools environment path variables
set "Lists=%Bin%\Lists"
set "Patches=%Bin%\Patches"
set "ResourceHacker=%Bin%\ResourceHacker.exe"
set "ToolKitHelper=%Bin%\ToolKitHelper.exe"
set "W10EsdDecrypter=%Bin%\Dism++CUI.exe /ESDFile"
set "W81EsdDecrypter=%Bin%\esddecrypt.exe"
set "WimlibImagex=%Bin%\%HostArchitecture%\wimlib-imagex.exe"
set "XCopy=xcopy.exe /E /I /H /R /Y /J"
set "XMLs=%Bin%\XMLs"
set "W10CUFix=%Bin%\Patches\W10CUFix"
set "WMCGActTokens=%Bin%\Patches\WMCGActTokens.tpk"
set "Zip=%Bin%\%HostArchitecture%\7z.exe"

:: Setting Components status flags
for %%i in (C_AdobeFlashForWindows,C_EdgeChromium,C_InternetExplorer,C_FirstLogonAnimation,C_GameExplorer,C_SnippingTool,C_SpeechRecognition,C_WindowsMediaPlayer,C_WindowsPhotoViewer,C_WinSAT,C_AssignedAccess,C_CEIP,C_FaceRecognition,C_KernelDebugging,C_LocationService,C_PicturePassword,C_PinEnrollment,C_UnifiedTelemetryClient,C_WiFiNetworkManager,C_WindowsErrorReporting,C_WindowsInsiderHub,C_HomeGroup,C_MultiPointConnector,C_RemoteAssistance,C_DeviceLockdown,C_EaseOfAccessThemes,C_EasyTransfer,C_FileHistory,C_ManualSetup,C_Paint,C_SecurityCenter,C_StepsRecorder,C_SystemRestore,C_WindowsBackup,C_WindowsFirewall,C_WindowsSubsystemForLinux,C_WindowsToGo,C_Wordpad,C_AADBrokerPlugin,C_AssignedAccessLockApp,C_BioEnrollment,C_CallingShellApp,C_CBSPreview,C_ContentDeliveryManager,C_Cortana,C_ECApp,C_EdgeDevToolsClient,C_Edge,C_FileExplorer,C_LockApp,C_MapControl,C_NarratorQuickStart,C_OneDrive,C_ParentalControls,C_PeopleExperienceHost,C_PPIProjection,C_QuickAssist,C_RetailDemoContent,C_SecureAssessmentBrowser,C_SettingSync,C_SkypeORTC,C_SmartScreen,C_Win32WebViewHost,C_WindowsDefender,C_WindowsMixedReality,C_WindowsReaderPDF,C_XboxGameCallableUI,C_3DViewer,C_AdvertisingXaml,C_Alarms,C_BingWeather,C_Calculator,C_Camera,C_CommunicationsApps,C_DesktopAppInstaller,C_FeedbackHub,C_GetHelp,C_Getstarted,C_HEIFImageExtension,C_Maps,C_Messaging,C_MixedRealityPortal,C_OfficeHub,C_OfficeOneNote,C_OneConnect,C_Paint3D,C_People,C_Photos,C_Print3D,C_ScreenSketch,C_SkypeApp,C_SolitaireCollection,C_SoundRecorder,C_StickyNotes,C_VP9VideoExtensions,C_WalletService,C_WebMediaExtensions,C_WebpImageExtensions,C_WindowsStore,C_XboxApp,C_XboxIdentityProvider,C_YourPhone,C_ZuneMusic,C_ZuneVideo) do (
	set "%%i=+"
)

::-------------------------------------------------------------------------------------------
:: MSMG ToolKit - EULA
::-------------------------------------------------------------------------------------------
cls

echo.===============================================================================
echo.########################## MSMG ToolKit - EULA ################################
echo.===============================================================================
echo.
echo.
echo. La boite a outils MSMG est essentiellement un outil pour entretenir, 
echo. personnaliser, ajouter ou supprimer des fonctionnalites et des composants,
echo. activer ou desactiver des fonctionnalites sur le systeme d'exploitation
echo. Windows.
echo.
echo. La boite a outils MSMG est conçue pour etre utilisee uniquement 
echo. avec les systemes d'exploitation Microsoft Windows sous licence.
echo.
echo. Cette boite a outils MSMG est fournie "telle quelle", sans aucune garantie
echo. expresse ou implicite. En aucun cas, l'auteur ne pourra etre tenu responsable
echo. des dommages resultant de l'utilisation de ce script.
echo.
echo. La boite a outils MSMG utilise divers outils tiers pour accomplir certaines
echo. de ses taches.
echo.
echo. MSMG ToolKit, Windows sont des marques deposees de leurs auteurs ou societes 
echo. respectifs. 
echo.
echo.
echo.===============================================================================
choice /C:AR /N /M "###########################[ 'A'ccept / 'R'eject ]############################"
if errorlevel 2 (
	reg delete "HKCU\Console\%%SystemRoot%%_system32_cmd.exe" /f >nul

	color 00
	endlocal EnableExtensions
	endlocal EnableDelayedExpansion

	exit
)

::-------------------------------------------------------------------------------------------
:: MSMG Toolkit - Startup function
::-------------------------------------------------------------------------------------------
cls

echo.
echo.Execution de l'operation de pre-nettoyage de Toolkit, veuillez patienter...
call :Cleanup >nul
cls
echo.===============================================================================
echo.                           MSMG ToolKit - Demarrage
echo.===============================================================================
echo.
echo.Lecture des informations du systeme d'exploitation hote...
for /f "tokens=6 delims= " %%a in ('DISM /Online /English /Get-Intl ^| findstr /i /C:"Default system UI language"') do (set HostLanguage=%%a)
echo.
if "%HostArchitecture%" equ "x86" (
	if "%HostVersion%" equ "6.1" echo. - Microsoft Windows 7 ^(%HostArchitecture%^) [%HostLanguage%]
	if "%HostVersion%" equ "6.3" echo. - Microsoft Windows 8.1 ^(%HostArchitecture%^) [%HostLanguage%]
	if "%HostVersion%" equ "10.0" echo. - Microsoft Windows 10 ^(%HostArchitecture%^) [%HostLanguage%]
)

if "%HostArchitecture%" equ "x64" (
	if "%HostVersion%" equ "6.1" echo. - Microsoft Windows 7 / Server 2008 R2 ^(%HostArchitecture%^) [%HostLanguage%]
	if "%HostVersion%" equ "6.3" echo. - Microsoft Windows 8.1 / Server 2012 R2 ^(%HostArchitecture%^) [%HostLanguage%]
	if "%HostVersion%" equ "10.0" echo. - Microsoft Windows 10 / Server 2016/2019 ^(%HostArchitecture%^) [%HostLanguage%]
)

:: Setting DOS character codepage
if "%HostLanguage%" equ "en-GB" chcp 437 >nul
if "%HostLanguage%" equ "en-US" chcp 437 >nul
if "%HostLanguage%" equ "zh-CN" chcp 936 >nul
if "%HostLanguage%" equ "fr-FR" chcp 040 >nul

echo.
echo.Definition des variables de chemin d'environnement des outils Toolkit et WADK... 
echo.DISM.exe           =  %DISM%
call :CreateFolder "%DismScratch%"
set "DISM=%DISM% %DismFormat%"
echo.Imagex.exe         =  %Imagex%
echo.Oscdimg.exe        =  %Oscdimg%
echo.Dvdburn.exe        =  %Dvdburn%
echo.7zip.exe           =  %Zip%
echo.Dism++CUI.exe      =  %W10EsdDecrypter%
echo.EsdDecrypt.exe     =  %W81EsdDecrypter%
echo.ToolKitHelper.exe  =  %ToolKitHelper%
echo.ResourceHacker.exe =  %ResourceHacker%
echo.WimlibImagex.exe   =  %WimlibImagex%
echo.
echo.===============================================================================
echo.
pause
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: MSMG Toolkit - Main Menu
::-------------------------------------------------------------------------------------------
:MainMenu

cls
echo.===============================================================================
echo.                           MSMG ToolKit - Menu Principal
echo.===============================================================================
echo.
echo.                             [1]   Source
echo.
echo.                             [2]   Integrer 
echo.
echo.                             [3]   Retirer
echo.
echo.                             [4]   Personnaliser
echo.
echo.                             [5]   Appliquer
echo.
echo.                             [6]   Cible
echo.
echo.                             [7]   Outils
echo.
echo.
echo.                             [X]   Quitter
echo.
echo.===============================================================================
echo.
choice /C:1234567X /N /M "Entrer votre choix : "
if errorlevel 8 goto :Quit
if errorlevel 7 goto :ToolsMenu
if errorlevel 6 goto :TargetMenu
if errorlevel 5 goto :ApplyMenu
if errorlevel 4 goto :CustomizeMenu
if errorlevel 3 goto :RemoveMenu
if errorlevel 2 goto :IntegrateMenu
if errorlevel 1 goto :SourceMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: MSMG Toolkit - Select Source Menu
::-------------------------------------------------------------------------------------------
:SourceMenu

cls
echo.===============================================================================
echo.                         MSMG ToolKit - Menu Source
echo.===============================================================================
echo.

:: Checking whether Source OS is selected
if "%IsSourceSelected%" equ "Yes" (
	echo.Le systeme d'exploitation source a deja ete selectionne..
	echo.
	echo.===============================================================================
	echo.
	pause
	goto :MainMenu
)

:: Checking whether Image Registry is loaded
if "%IsImageRegistryLoaded%" equ "Yes" (
	echo.Le registre d'images du systeme d'exploitation source est charge,
	echo.veuillez le decharger a l'aide des outils-^>Options...
	echo.
	echo.===============================================================================
	echo.
	pause
	goto :MainMenu
)

echo.  [1]   Selectionner la source dans le dossier ^<DVD^>
echo.
echo.  [2]   Copier la source du lecteur DVD 
echo.
echo.  [3]   Extraire la source de l'image ISO du DVD
echo.
echo.  [4]   Extraire la source de l'image OEM IMG
echo.
echo.  [5]   Extraire la source de l'image ESD du magasin
echo.
echo.  [6]   Extraire la source de l'image de l'outil de creation de media
echo.
echo.  [7]   Extraire la source d'une image Windows ESD personnalisee 
echo.
echo.
echo.  [X]   Retour
echo.
echo.===============================================================================
echo.
choice /C:1234567X /N /M "Entrer votre choix : "
if errorlevel 8 goto :MainMenu
if errorlevel 7 goto :ExtractSourceESD
if errorlevel 6 goto :ExtractSourceMCT
if errorlevel 5 goto :ExtractSourceStoreESD
if errorlevel 4 goto :ExtractSourceIMG
if errorlevel 3 goto :ExtractSourceISO
if errorlevel 2 goto :CopySourceDVD
if errorlevel 1 goto :SelectSourceDVD
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: MSMG ToolKit - Integrate Menu
::-------------------------------------------------------------------------------------------
:IntegrateMenu

cls
echo.===============================================================================
echo.                         MSMG ToolKit - Menu Integration
echo.===============================================================================
echo.
:: Checking whether Source OS is selected
if "%IsSourceSelected%" equ "No" (
	echo.Le systeme d'exploitation source n'est pas selectionne,
	echo.veuillez sélectionner la source dans le menu "Source". 
	echo.
	echo.===============================================================================
	echo.
	pause
	goto :MainMenu
)

:: Checking whether Image Registry is loaded
if "%IsImageRegistryLoaded%" equ "Yes" (
	echo.Le registre d'images du systeme d'exploitation source est chargé,
	echo.veuillez le decharger en utilisant Outils - ^>Options. 
	echo.
	echo.===============================================================================
	echo.
	pause
	goto :MainMenu
)

echo.  [1] Packs linguistiques Windows
echo.
echo.  [2] Pilotes Windows
echo.
echo.  [3] Fonctionnalites Windows
echo.
echo.  [4] Mises a jour Windows
echo.
echo.  [5] Fonctionnalites personnalisees de Windows 
echo.
echo.
echo.
echo.
echo.
echo.
echo.  [X] Retour
echo.
echo.===============================================================================
echo.
choice /C:12345X /N /M "Entrer votre choix : "
if errorlevel 6 goto :MainMenu
if errorlevel 5 goto :IntCustomFeaturesMenu
if errorlevel 4 goto :IntUpdatesMenu
if errorlevel 3 goto :IntFeaturesMenu
if errorlevel 2 goto :IntDriversMenu
if errorlevel 1 goto :IntLanguagePacksMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: MSMG ToolKit - Integrate Windows Features Menu
::-------------------------------------------------------------------------------------------
:IntFeaturesMenu

cls
echo.===============================================================================
echo.        MSMG ToolKit - Integrer le menu des fonctionnalites de Windows 
echo.===============================================================================

:: Checking whether the selected Source OS is a Windows 7 Client/Embedded
if "%SelectedSourceOS%" equ "w7" if "%ImageInstallationType:~,6%" neq "Server" (
	echo.
	echo.  [A]   Microsoft .NET Framework 4.8
	echo.  [B]   Microsoft .NET 5
	echo.  [C]   Microsoft Internet Explorer 11
	echo.  [D]   Microsoft Edge Chromium Browser
	echo.  [E]   Remote Desktop Protocol ^(RDP^) 8.0 ^& 8.1
	echo.  [F]   Windows Media Feature Pack
	echo.  [G]   Windows Management Framework ^(WMF^) 5.1 ^| Depends on .NET Framework 4.8
	echo.  [H]   Windows PowerShell 7.1 ^| Depends on Windows Management Framework 5.1
	echo.  [I]   Windows Thin PC Add-on Features
	echo.  [J]   Remote Server Administration Tool ^(RSAT^)
	echo.  [K]   Microsoft DaRT 7.0 Tools
	echo.  [L]   Microsoft DirectX 9.0c
	echo.  [M]   Microsoft Games
	echo.  [N]   Microsoft Visual C++ Runtime
	echo.
	echo.  [X]   Retour
	echo.
	echo.===============================================================================
	echo.
	choice /C:ABCDEFGHIJKLMNX /N /M "Entrer votre choix : "
	if errorlevel 15 goto :IntegrateMenu
	if errorlevel 14 goto :IntVCRuntime
	if errorlevel 13 goto :IntGames
	if errorlevel 12 goto :IntDirectX9c
	if errorlevel 11 goto :IntDaRT
	if errorlevel 10 goto :IntRSAT
	if errorlevel 9  goto :IntThinPcPkgs
	if errorlevel 8  goto :IntPowerShell7
	if errorlevel 7  goto :IntWMF
	if errorlevel 6  goto :IntMediaFeaturePack
	if errorlevel 5  goto :IntRDP81
	if errorlevel 4  goto :IntEdgeChromium
	if errorlevel 3  goto :IntIE11
	if errorlevel 2  goto :IntNET5
	if errorlevel 1  goto :IntNetFX48
)

:: Checking whether the selected Source OS is a Windows Server 2008 R2 Core/Non Core Edition
if "%SelectedSourceOS%" equ "w7" if "%ImageInstallationType%" neq "Client" if "%ImageInstallationType%" neq "Embedded" (
	echo.
	echo.  [A]   Microsoft .NET Framework 4.8
	echo.  [B]   Microsoft .NET 5
	echo.  [C]   Microsoft Internet Explorer 11
	echo.  [D]   Microsoft Edge Chromium Browser
	echo.  [E]   Remote Desktop Protocol ^(RDP^) 8.0 ^& 8.1
	echo.  [F]   Windows Management Framework ^(WMF^) 5.1 ^| Depends de .NET Framework 4.8
	echo.  [G]   Windows PowerShell 7.1 ^| Depend de Windows Management Framework 5.1
	echo.  [H]   Windows Restauration Systeme
	echo.  [I]   Microsoft DaRT 7.0 Tools
	echo.  [J]   Microsoft DirectX 9.0c
	echo.  [K]   Microsoft Games
	echo.  [L]   Windows Sidebar
	echo.  [M]   Microsoft Visual C++ Runtime
	echo.
	echo.
	echo.  [X]   Retour
	echo.
	echo.===============================================================================
	echo.
	choice /C:ABCDEFGHIJKLMX /N /M "Entrer votre choix : "
	if errorlevel 14 goto :IntegrateMenu
	if errorlevel 13 goto :IntVCRuntime
	if errorlevel 12 goto :IntSidebar
	if errorlevel 11 goto :IntGames
	if errorlevel 10 goto :IntDirectX9c
	if errorlevel 9  goto :IntDaRT
	if errorlevel 8  goto :IntSystemRestore
	if errorlevel 7  goto :IntPowerShell7
	if errorlevel 6  goto :IntWMF
	if errorlevel 5  goto :IntRDP81
	if errorlevel 4  goto :IntEdgeChromium
	if errorlevel 3  goto :IntIE11
	if errorlevel 2  goto :IntNET5
	if errorlevel 1  goto :IntNetFX48
)

:: Checking whether the selected Source OS is a Windows 8.1 RT (ARM)
if "%SelectedSourceOS%" equ "w81" if "%ImageArchitecture%" equ "arm" (
	echo.
	echo.  [1]   Microsoft .NET Framework 4.8
	echo.
	echo.  [2]   Applications de la boîte de reception de Microsoft 
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.  [X]   Retour
	echo.
	echo.===============================================================================
	echo.
	choice /C:12X /N /M "Entrer votre choix : "
	if errorlevel 3 goto :IntegrateMenu
	if errorlevel 2 goto :IntInboxApps
	if errorlevel 1 goto :IntNetFX48
)

:: Checking whether the selected Source OS is a Windows 8.1 Client Edition
if "%SelectedSourceOS%" equ "w81" if "%ImageArchitecture%" neq "arm" if "%ImageInstallationType:~,6%" neq "Server" (
	echo.  [A]   Microsoft .NET Framework 3.5
	echo.  [B]   Microsoft .NET Framework 4.8
	echo.  [C]   Microsoft .NET 5
	echo.  [D]   Microsoft Edge Chromium Browser
	echo.  [E]   Windows Data Deduplication
	echo.  [F]   Windows To Go Workspace
	echo.  [G]   Windows Media Feature Pack
	echo.  [H]   Microsoft Default Inbox Apps
	echo.  [I]   Windows Management Framework ^(WMF^) 5.1
	echo.  [J]   Windows PowerShell 7.1
	echo.  [K]   Remote Server Administration Tool ^(RSAT^)
	echo.  [L]   Microsoft DaRT 8.1 Tools
	echo.  [M]   Microsoft DirectX 9.0c
	echo.  [N]   Microsoft Games
	echo.  [O]   Windows Sidebar
	echo.  [P]   Microsoft Visual C++ Runtime
	echo.
	echo.  [X]   Retour
	echo.===============================================================================
	echo.
	choice /C:ABCDEFGHIJKLMNOPX /N /M "Entrer votre choix : "
	if errorlevel 17 goto :IntegrateMenu
	if errorlevel 16 goto :IntVCRuntime
	if errorlevel 15 goto :IntSidebar
	if errorlevel 14 goto :IntGames
	if errorlevel 13 goto :IntDirectX9c
	if errorlevel 12 goto :IntDaRT
	if errorlevel 11 goto :IntRSAT
	if errorlevel 10 goto :IntPowerShell7
	if errorlevel 9  goto :IntWMF
	if errorlevel 8  goto :IntInboxApps
	if errorlevel 7  goto :IntMediaFeaturePack
	if errorlevel 6  goto :IntWinToGo
	if errorlevel 5  goto :IntDedup
	if errorlevel 4  goto :IntEdgeChromium
	if errorlevel 3  goto :IntNET5
	if errorlevel 2  goto :IntNetFX48
	if errorlevel 1  goto :IntNetFX35
)

:: Checking whether the selected Source OS is a Windows Server 2012 R2 Core/None Core Edition
if "%SelectedSourceOS%" equ "w81" if "%ImageInstallationType%" neq "Client" (
	echo.
	echo.  [A] Microsoft .NET Framework 3.5
	echo.  [B] Microsoft .NET Framework 4.8
	echo.  [C] Microsoft .NET 5
	echo.  [D] Microsoft Edge Chromium Browser
	echo.  [E] Microsoft Default Inbox Apps
	echo.  [F] Windows Management Framework ^(WMF^) 5.1
	echo.  [G] Windows PowerShell 7.1
	echo.  [H] Microsoft DaRT 8.1 Tools
	echo.  [I] Microsoft DirectX 9.0c
	echo.  [J] Microsoft Games
	echo.  [K] Windows Sidebar
	echo.  [L] Microsoft Visual C++ Runtime
	echo.
	echo.
	echo.
	echo.  [X] Retour
	echo.
	echo.===============================================================================
	echo.
	choice /C:ABCDEFGHIJKLX /N /M "Entrer votre choix : "
	if errorlevel 13 goto :IntegrateMenu
	if errorlevel 12 goto :IntVCRuntime
	if errorlevel 11 goto :IntSidebar
	if errorlevel 10 goto :IntGames
	if errorlevel 9  goto :IntDirectX9c
	if errorlevel 8  goto :IntDaRT
	if errorlevel 7  goto :IntPowerShell7
	if errorlevel 6  goto :IntWMF
	if errorlevel 5  goto :IntInboxApps
	if errorlevel 4  goto :IntEdgeChromium
	if errorlevel 3  goto :IntNET5
	if errorlevel 2  goto :IntNetFX48
	if errorlevel 1  goto :IntNetFX35
)

:: Checking whether the selected Source OS is a Windows 10 v1507 Client Edition
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "10240" if "%ImageInstallationType%" equ "Client" if "%ImageArchitecture%" neq "arm64" (
	echo.
	echo.  [A] Microsoft .NET Framework 3.5
	echo.  [B] Microsoft .NET Framework 4.6.2
	echo.  [C] Microsoft Edge Classic Browser
	echo.  [D] Microsoft Edge Chromium Browser
	echo.  [E] Microsoft Win32 Calculator
	echo.  [F] Windows To Go Workspace
	echo.  [G] Windows Media Feature Pack
	echo.  [H] Windows PowerShell 7.1
	echo.  [I] Remote Server Administration Tool ^(RSAT^)
	echo.  [J] Microsoft Default Inbox Apps
	echo.  [K] Microsoft DaRT 10.0 Tools
	echo.  [L] Microsoft DirectX 9.0c
	echo.  [M] Microsoft Games
	echo.  [N] Windows Sidebar ^| Depends on: Windows Mail App
	echo.  [O] Microsoft Visual C++ Runtime
	echo.
	echo.  [X] Retour
	echo.
	echo.===============================================================================
	choice /C:ABCDEFGHIJKLMNOX /N /M "Entrer votre choix : "
	if errorlevel 16 goto :IntegrateMenu
	if errorlevel 15 goto :IntVCRuntime
	if errorlevel 14 goto :IntSidebar
	if errorlevel 13 goto :IntGames
	if errorlevel 12 goto :IntDirectX9c
	if errorlevel 11 goto :IntDaRT
	if errorlevel 10 goto :IntInboxApps
	if errorlevel 9  goto :IntRSAT
	if errorlevel 8  goto :IntPowerShell7
	if errorlevel 7  goto :IntMediaFeaturePack
	if errorlevel 6  goto :IntWinToGo
	if errorlevel 5  goto :IntWin32Calc
	if errorlevel 4  goto :IntEdgeChromium
	if errorlevel 3  goto :IntEdgeClassic
	if errorlevel 2  goto :IntNetFX462
	if errorlevel 1  goto :IntNetFX35
)

:: Checking whether the selected Source OS is a Windows 10 v1511 Client Edition
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "10586" if "%ImageInstallationType%" equ "Client" if "%ImageArchitecture%" neq "arm64" (
	echo.  [A]   Microsoft .NET Framework 3.5
	echo.  [B]   Microsoft .NET Framework 4.6.2
	echo.  [C]   Microsoft Edge Chromium Browser
	echo.  [D]   Microsoft Win32 Calculator
	echo.  [E]   Windows Data Deduplication
	echo.  [F]   Windows To Go Workspace
	echo.  [G]   Windows Media Feature Pack
	echo.  [H]   Windows PowerShell 7.1
	echo.  [I]   Remote Server Administration Tool ^(RSAT^)
	echo.  [J]   Microsoft Default Inbox Apps
	echo.  [K]   Microsoft DaRT 10.0 Tools
	echo.  [L]   Microsoft DirectX 9.0c
	echo.  [M]   Microsoft Games
	echo.  [N]   Windows Sidebar
	echo.  [O]   Microsoft Visual C++ Runtime
	echo.
	echo.
	echo.  [X]   Retour
	echo.===============================================================================
	echo.
	choice /C:ABCDEFGHIJKLMNOX /N /M "Entrer votre choix : "
	if errorlevel 16 goto :IntegrateMenu
	if errorlevel 15 goto :IntVCRuntime
	if errorlevel 14 goto :IntSidebar
	if errorlevel 13 goto :IntGames
	if errorlevel 12 goto :IntDirectX9c
	if errorlevel 11 goto :IntDaRT
	if errorlevel 10 goto :IntInboxApps
	if errorlevel 9  goto :IntRSAT
	if errorlevel 8  goto :IntPowerShell7
	if errorlevel 7  goto :IntMediaFeaturePack
	if errorlevel 6  goto :IntWinToGo
	if errorlevel 5  goto :IntDedup
	if errorlevel 4  goto :IntWin32Calc
	if errorlevel 3  goto :IntEdgeChromium
	if errorlevel 2  goto :IntNetFX462
	if errorlevel 1  goto :IntNetFX35
)

:: Checking whether the selected Source OS is a Windows 10 v1607 Client Edition
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "14393" if "%ImageInstallationType%" equ "Client" if "%ImageArchitecture%" neq "arm64" (
	echo.  [A]   Microsoft .NET Framework 3.5
	echo.  [B]   Microsoft .NET Framework 4.8
	echo.  [C]   Microsoft .NET 5
	echo.  [D]   Microsoft Edge Classic Browser
	echo.  [E]   Microsoft Edge Chromium Browser
	echo.  [F]   Microsoft Win32 Calculator
	echo.  [G]   Windows Data Deduplication
	echo.  [H]   Windows To Go Workspace
	echo.  [I]   Windows Media Feature Pack
	echo.  [J]   Windows PowerShell 7.1
	echo.  [K]   Remote Server Administration Tool ^(RSAT^)
	echo.  [L]   Microsoft Default Inbox Apps
	echo.  [M]   Microsoft DaRT 10.0 Tools
	echo.  [N]   Microsoft DirectX 9.0c
	echo.  [O]   Microsoft Games
	echo.  [P]   Windows Sidebar
	echo.  [Q]   Microsoft Visual C++ Runtime
	echo.
	echo.  [X]   Retour
	echo.===============================================================================
	choice /C:ABCDEFGHIJKLMNOPQX /N /M "Entrer votre choix : "
	if errorlevel 18 goto :IntegrateMenu
	if errorlevel 17 goto :IntVCRuntime
	if errorlevel 16 goto :IntSidebar
	if errorlevel 15 goto :IntGames
	if errorlevel 14 goto :IntDirectX9c
	if errorlevel 13 goto :IntDaRT
	if errorlevel 12 goto :IntInboxApps
	if errorlevel 11 goto :IntRSAT
	if errorlevel 10 goto :IntPowerShell7
	if errorlevel 9  goto :IntMediaFeaturePack
	if errorlevel 8  goto :IntWinToGo
	if errorlevel 7  goto :IntDedup
	if errorlevel 6  goto :IntWin32Calc
	if errorlevel 5  goto :IntEdgeChromium
	if errorlevel 4  goto :IntEdgeClassic
	if errorlevel 3  goto :IntNET5
	if errorlevel 2  goto :IntNetFX48
	if errorlevel 1  goto :IntNetFX35
)

:: Checking whether the selected Source OS is a Windows 10 v1703 Client Edition
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "15063" if "%ImageInstallationType%" equ "Client" if "%ImageArchitecture%" neq "arm64" (
	echo.  [A] Microsoft .NET Framework 3.5
	echo.  [B] Microsoft .NET Framework 4.8
	echo.  [C] Microsoft .NET 5
	echo.  [D] Microsoft Edge Chromium Browser
	echo.  [E] Microsoft Win32 Calculator
	echo.  [F] Windows Accessibility Braille
	echo.  [G] Windows Data Deduplication
	echo.  [H] Windows To Go Workspace
	echo.  [I] Windows Media Feature Pack
	echo.  [J] Windows PowerShell 7.1
	echo.  [K] Remote Server Administration Tool ^(RSAT^)
	echo.  [L] Microsoft Default Inbox Apps
	echo.  [M] Microsoft DaRT 10.0 Tools
	echo.  [N] Microsoft DirectX 9.0c
	echo.  [O] Microsoft Games
	echo.  [P] Windows Sidebar
	echo.  [Q] Microsoft Visual C++ Runtime
	echo.  [X] Retour
	echo.===============================================================================
	echo.
	choice /C:ABCDEFGHIJKLMNOPQX /N /M "Entrer votre choix : "
	if errorlevel 18 goto :IntegrateMenu
	if errorlevel 17 goto :IntVCRuntime
	if errorlevel 16 goto :IntSidebar
	if errorlevel 15 goto :IntGames
	if errorlevel 14 goto :IntDirectX9c
	if errorlevel 13 goto :IntDaRT
	if errorlevel 12 goto :IntInboxApps
	if errorlevel 11 goto :IntRSAT
	if errorlevel 10 goto :IntPowerShell7
	if errorlevel 9  goto :IntMediaFeaturePack
	if errorlevel 8  goto :IntWinToGo
	if errorlevel 7  goto :IntDedup
	if errorlevel 6  goto :IntBraille
	if errorlevel 5  goto :IntWin32Calc
	if errorlevel 4  goto :IntEdgeChromium
	if errorlevel 3  goto :IntNET5
	if errorlevel 2  goto :IntNetFX48
	if errorlevel 1  goto :IntNetFX35
)

:: Checking whether the selected Source OS is a Windows 10 v1709 Client Edition
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "16299" if "%ImageInstallationType%" equ "Client" if "%ImageArchitecture%" neq "arm64" (
	echo.  [A] Microsoft .NET Framework 3.5
	echo.  [B] Microsoft .NET Framework 4.8
	echo.  [C] Microsoft .NET 5
	echo.  [D] Microsoft Edge Chromium Browser
	echo.  [E] Microsoft Win32 Calculator
	echo.  [F] Windows Accessibility Braille
	echo.  [G] Windows Data Deduplication
	echo.  [H] Windows To Go Workspace
	echo.  [I] Windows Media Feature Pack
	echo.  [J] Windows PowerShell 7.1
	echo.  [K] Remote Server Administration Tool ^(RSAT^)
	echo.  [L] Open Secure Shell ^(SSH^) Client ^& Server
	echo.  [M] Microsoft Default Inbox Apps
	echo.  [N] Microsoft DaRT 10.0 Tools
	echo.  [O] Microsoft DirectX 9.0c
	echo.  [P] Microsoft Games
	echo.  [Q] Windows Sidebar
	echo.  [R] Microsoft Visual C++ Runtime
	echo.  [X] Retour
	echo.===============================================================================
	choice /C:ABCDEFGHIJKLMNOPQRX /N /M "Entrer votre choix : "
	if errorlevel 19 goto :IntegrateMenu
	if errorlevel 18 goto :IntVCRuntime
	if errorlevel 17 goto :IntSidebar
	if errorlevel 16 goto :IntGames
	if errorlevel 15 goto :IntDirectX9c
	if errorlevel 14 goto :IntDaRT
	if errorlevel 13 goto :IntInboxApps
	if errorlevel 12 goto :IntOpenSSH
	if errorlevel 11 goto :IntRSAT
	if errorlevel 10 goto :IntPowerShell7
	if errorlevel 9  goto :IntMediaFeaturePack
	if errorlevel 8  goto :IntWinToGo
	if errorlevel 7  goto :IntDedup
	if errorlevel 6  goto :IntBraille
	if errorlevel 5  goto :IntWin32Calc
	if errorlevel 4  goto :IntEdgeChromium
	if errorlevel 3  goto :IntNET5
	if errorlevel 2  goto :IntNetFX48
	if errorlevel 1  goto :IntNetFX35
)

:: Checking whether the selected Source OS is a Windows 10 v1803 Client Edition
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "17134" if "%ImageInstallationType%" equ "Client" if "%ImageArchitecture%" neq "arm64" (
	echo.  [A] Microsoft .NET Framework 3.5
	echo.  [B] Microsoft .NET Framework 4.8
	echo.  [C] Microsoft .NET 5
	echo.  [D] Microsoft Edge Chromium Browser
	echo.  [E] Microsoft Win32 Calculator
	echo.  [F] Windows Accessibility Braille
	echo.  [G] Windows Data Deduplication
	echo.  [H] Windows To Go Workspace
	echo.  [I] Windows Media Feature Pack
	echo.  [J] Windows PowerShell 7.1
	echo.  [K] Remote Server Administration Tool ^(RSAT^)
	echo.  [L] Open Secure Shell ^(SSH^) Client ^& Server
	echo.  [M] Microsoft Default Inbox Apps
	echo.  [N] Microsoft Office Desktop UWP Apps
	echo.  [O] Microsoft DaRT 10.0 Tools
	echo.  [P] Microsoft DirectX 9.0c
	echo.  [Q] Microsoft Games
	echo.  [R] Windows Sidebar
	echo.  [S] Microsoft Visual C++ Runtime
	echo.  [X] Retour
	echo.===============================================================================
	choice /C:ABCDEFGHIJKLMNOPQRSX /N /M "Entrer votre choix : "
	if errorlevel 20 goto :IntegrateMenu
	if errorlevel 19 goto :IntVCRuntime
	if errorlevel 18 goto :IntSidebar
	if errorlevel 17 goto :IntGames
	if errorlevel 16 goto :IntDirectX9c
	if errorlevel 15 goto :IntDaRT
	if errorlevel 14 goto :IntOfficeUWPApps
	if errorlevel 13 goto :IntInboxApps
	if errorlevel 12 goto :IntOpenSSH
	if errorlevel 11 goto :IntRSAT
	if errorlevel 10 goto :IntPowerShell7
	if errorlevel 9  goto :IntMediaFeaturePack
	if errorlevel 8  goto :IntWinToGo
	if errorlevel 7  goto :IntDedup
	if errorlevel 6  goto :IntBraille
	if errorlevel 5  goto :IntWin32Calc
	if errorlevel 4  goto :IntEdgeChromium
	if errorlevel 3  goto :IntNET5
	if errorlevel 2  goto :IntNetFX48
	if errorlevel 1  goto :IntNetFX35
)

:: Checking whether the selected Source OS is a Windows 10 v1809 Client Edition
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "17763" if "%ImageInstallationType%" equ "Client" if "%ImageArchitecture%" neq "arm64" (
	echo.  [A] Microsoft .NET Framework 3.5
	echo.  [B] Microsoft .NET Framework 4.8
	echo.  [C] Microsoft .NET 5
	echo.  [D] Microsoft Edge Classic Browser
	echo.  [E] Microsoft Edge Chromium Browser
	echo.  [F] Microsoft Win32 Calculator
	echo.  [G] Windows Accessibility Braille
	echo.  [H] Windows Data Deduplication
	echo.  [I] Windows To Go Workspace
	echo.  [J] Windows Media Feature Pack
	echo.  [K] Windows Mixed Reality
	echo.  [L] Windows Portable Devices
	echo.  [M] Windows PowerShell 7.1
	echo.  [N] Open Secure Shell ^(SSH^) Client ^& Server
	echo.  [O] Microsoft Default Inbox Apps
	echo.  [P] Microsoft Office Desktop UWP Apps
	echo.  [Q] Microsoft DaRT 10.0 Tools
	echo.  [R] Microsoft DirectX 9.0c
	echo.  [S] Microsoft Games
	echo.  [T] Windows Sidebar
	echo.  [U] Microsoft Visual C++ Runtime
	echo.  [X] Retour
	echo.===============================================================================
	choice /C:ABCDEFGHIJKLMNOPQRSTUX /N /M "Entrer votre choix : "
	if errorlevel 22 goto :IntegrateMenu
	if errorlevel 21 goto :IntVCRuntime
	if errorlevel 20 goto :IntSidebar
	if errorlevel 19 goto :IntGames
	if errorlevel 18 goto :IntDirectX9c
	if errorlevel 17 goto :IntDaRT
	if errorlevel 16 goto :IntOfficeUWPApps
	if errorlevel 15 goto :IntInboxApps
	if errorlevel 14 goto :IntOpenSSH
	if errorlevel 13 goto :IntPowerShell7
	if errorlevel 12 goto :IntPortableDevices
	if errorlevel 11 goto :IntWindowsMixedReality
	if errorlevel 10 goto :IntMediaFeaturePack
	if errorlevel 9  goto :IntWinToGo
	if errorlevel 8  goto :IntDedup
	if errorlevel 7  goto :IntBraille
	if errorlevel 6  goto :IntWin32Calc
	if errorlevel 5  goto :IntEdgeChromium
	if errorlevel 4  goto :IntEdgeClassic
	if errorlevel 3  goto :IntNET5
	if errorlevel 2  goto :IntNetFX48
	if errorlevel 1  goto :IntNetFX35
)

:: Checking whether the selected Source OS is a Windows 10 v1903/v1909 Client Edition
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "18362" if "%ImageBuild%" leq "18363" if "%ImageInstallationType%" equ "Client" if "%ImageArchitecture%" neq "arm64" (
	echo.  [A]   Microsoft .NET Framework 3.5
	echo.  [B]   Microsoft .NET 5
	echo.  [C]   Microsoft Edge Chromium Browser
	echo.  [D]   Microsoft Win32 Calculator
	echo.  [E]   Windows Accessibility Braille
	echo.  [F]   Windows Data Deduplication
	echo.  [G]   Windows To Go Workspace
	echo.  [H]   Windows Media Feature Pack
	echo.  [I]   Windows Portable Devices
	echo.  [J]   Windows PowerShell 7.1
	echo.  [K]   Open Secure Shell ^(SSH^) Client ^& Server
	echo.  [L]   Microsoft Default Inbox Apps
	echo.  [M]   Microsoft Office Desktop UWP Apps
	echo.  [N]   Microsoft DaRT 10.0 Tools
	echo.  [O]   Microsoft DirectX 9.0c
	echo.  [P]   Microsoft Games
	echo.  [Q]   Windows Sidebar
	echo.  [R]   Microsoft Visual C++ Runtime
	echo.  [X]   Retour
	echo.===============================================================================
	choice /C:ABCDEFGHIJKLMNOPQRX /N /M "Entrer votre choix : "
	if errorlevel 19 goto :IntegrateMenu
	if errorlevel 18 goto :IntVCRuntime
	if errorlevel 17 goto :IntSidebar
	if errorlevel 16 goto :IntGames
	if errorlevel 15 goto :IntDirectX9c
	if errorlevel 14 goto :IntDaRT
	if errorlevel 13 goto :IntOfficeUWPApps
	if errorlevel 12 goto :IntInboxApps
	if errorlevel 11 goto :IntOpenSSH
	if errorlevel 10 goto :IntPowerShell7
	if errorlevel 9  goto :IntPortableDevices
	if errorlevel 8  goto :IntMediaFeaturePack
	if errorlevel 7  goto :IntWinToGo
	if errorlevel 6  goto :IntDedup
	if errorlevel 5  goto :IntBraille
	if errorlevel 4  goto :IntWin32Calc
	if errorlevel 3  goto :IntEdgeChromium
	if errorlevel 2  goto :IntNET5
	if errorlevel 1  goto :IntNetFX35
)

:: Checking whether the selected Source OS is a Windows 10 v2004/v20H2/v21H1/v21H2 Client Edition
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "19041" if "%ImageInstallationType%" equ "Client" if "%ImageArchitecture%" neq "arm64" (
	echo.  [A]   Microsoft .NET Framework 3.5
	echo.  [B]   Microsoft .NET 5
	echo.  [C]   Microsoft Edge Chromium Browser
	echo.  [D]   Microsoft Win32 Calculator
	echo.  [E]   Windows Accessibility Braille
	echo.  [F]   Windows Data Deduplication
	echo.  [G]   Windows Media Feature Pack
	echo.  [H]   Windows Portable Devices
	echo.  [I]   Windows PowerShell 7.1
	echo.  [J]   Open Secure Shell ^(SSH^) Client ^& Server
	echo.  [K]   Microsoft Default Inbox Apps
	echo.  [L]   Microsoft Office Desktop UWP Apps
	echo.  [M]   Microsoft DaRT 10.0 Tools
	echo.  [N]   Microsoft DirectX 9.0c
	echo.  [O]   Microsoft Games
	echo.  [P]   Windows Sidebar
	echo.  [Q]   Microsoft Visual C++ Runtime
	echo.
	echo.  [X]   Retour
	echo.===============================================================================
	choice /C:ABCDEFGHIJKLMNOPQX /N /M "Entrer votre choix : "
	if errorlevel 18 goto :IntegrateMenu
	if errorlevel 17 goto :IntVCRuntime
	if errorlevel 16 goto :IntSidebar
	if errorlevel 15 goto :IntGames
	if errorlevel 14 goto :IntDirectX9c
	if errorlevel 13 goto :IntDaRT
	if errorlevel 12 goto :IntOfficeUWPApps
	if errorlevel 11 goto :IntInboxApps
	if errorlevel 10 goto :IntOpenSSH
	if errorlevel 9  goto :IntPowerShell7
	if errorlevel 8  goto :IntPortableDevices
	if errorlevel 7  goto :IntMediaFeaturePack
	if errorlevel 6  goto :IntDedup
	if errorlevel 5  goto :IntBraille
	if errorlevel 4  goto :IntWin32Calc
	if errorlevel 3  goto :IntEdgeChromium
	if errorlevel 2  goto :IntNET5
	if errorlevel 1  goto :IntNetFX35
)

:: Checking whether the selected Source OS is a Windows 10 v1803/v1809/v1903/v1909 ARM64-Bit Client
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "17134" if "%ImageArchitecture%" equ "arm64" (
	echo.
	echo.  [1]   Microsoft .NET Framework 3.5
	echo.
	echo.  [2]   Microsoft .NET 5
	echo.
	echo.  [3]   Microsoft Default Inbox Apps
	echo.
	echo.  [4]   Microsoft Office Desktop UWP Apps
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.  [X]   Retour
	echo.
	echo.===============================================================================
	echo.
	choice /C:1234X /N /M "Entrer votre choix : "
	if errorlevel 5 goto :IntegrateMenu
	if errorlevel 4 goto :IntOfficeUWPApps
	if errorlevel 3 goto :IntInboxApps
	if errorlevel 2 goto :IntNET5
	if errorlevel 1 goto :IntNetFX35
)

:: Checking whether the selected Source OS is a Windows Server 2016/2019, Server v1709/v1803/v1809 Core Edition
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "14393" if "%ImageBuild%" leq "17763" if "%ImageInstallationType%" equ "Server Core" (
	echo.  [1]   Microsoft .NET Framework 3.5
	echo.
	echo.  [2]   Microsoft .NET Framework 4.8
	echo.
	echo.  [3]   Microsoft .NET 5
	echo.
	echo.  [4]   Windows PowerShell 7.1
	echo.
	echo.  [5]   Windows Subsystem for Linux ^(WSL^)
	echo.
	echo.  [6]   Microsoft DaRT 10.0 Tools
	echo.
	echo.  [7]   Microsoft DirectX 9.0c
	echo.
	echo.  [8]   Microsoft Visual C++ Runtime
	echo.
	echo.
	echo.  [X]   Retour
	echo.===============================================================================
	echo.
	choice /C:12345678X /N /M "Entrer votre choix : "
	if errorlevel 9 goto :IntegrateMenu
	if errorlevel 8 goto :IntVCRuntime
	if errorlevel 7 goto :IntDirectX9c
	if errorlevel 6 goto :IntDaRT
	if errorlevel 5 goto :IntWSL
	if errorlevel 4 goto :IntPowerShell7
	if errorlevel 3 goto :IntNET5
	if errorlevel 2 goto :IntNetFX48
	if errorlevel 1 goto :IntNetFX35
)

:: Checking whether the selected Source OS is a Windows Server 2016/2019 Non Core Edition
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "14393" if "%ImageBuild%" leq "17763" if "%ImageInstallationType%" equ "Server" (
	echo.  [A]   Microsoft .NET Framework 3.5
	echo.  [B]   Microsoft .NET Framework 4.8
	echo.  [C]   Microsoft .NET 5
	echo.  [D]   Microsoft Edge Classic Browser
	echo.  [E]   Microsoft Edge Chromium Browser
	echo.  [F]   Windows Multimedia Restricted Codecs
	echo.  [G]   Windows System Restore
	echo.  [H]   Windows Subsystem for Linux ^(WSL^)
	echo.  [I]   Windows To Go Workspace
	echo.  [J]   Windows PowerShell 7.1
	echo.  [K]   Microsoft Default Inbox Apps
	echo.  [L]   Microsoft DaRT 10.0 Tools
	echo.  [M]   Microsoft DirectX 9.0c
	echo.  [N]   Microsoft Games
	echo.  [O]   Windows Sidebar
	echo.  [P]   Microsoft Visual C++ Runtime
	echo.
	echo.  [X]   Retour
	echo.===============================================================================
	echo.
	choice /C:ABCDEFGHIJKLMNOPX /N /M "Entrer votre choix : "
	if errorlevel 17 goto :IntegrateMenu
	if errorlevel 16 goto :IntVCRuntime
	if errorlevel 15 goto :IntSidebar
	if errorlevel 14 goto :IntGames
	if errorlevel 13 goto :IntDirectX9c
	if errorlevel 12 goto :IntDaRT
	if errorlevel 11 goto :IntInboxApps
	if errorlevel 10 goto :IntPowerShell7
	if errorlevel 9  goto :IntWinToGo
	if errorlevel 8  goto :IntWSL
	if errorlevel 7  goto :IntSystemRestore
	if errorlevel 6  goto :IntMMRC
	if errorlevel 5  goto :IntEdgeChromium
	if errorlevel 4  goto :IntEdgeClassic
	if errorlevel 3  goto :IntNET5
	if errorlevel 2  goto :IntNetFX48
	if errorlevel 1  goto :IntNetFX35
)

:: Checking whether the selected Source OS is a Windows Server v1903/v1909/v2004/v20H2/v21H1/v21H2 Core Edition
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "18362" if "%ImageInstallationType%" equ "Server Core" (
	echo.
	echo.  [1]   Microsoft .NET Framework 3.5
	echo.
	echo.  [2]   Microsoft .NET 5
	echo.
	echo.  [3]   Windows PowerShell 7.1
	echo.
	echo.  [4]   Windows Subsystem for Linux ^(WSL^)
	echo.
	echo.  [5]   Microsoft DaRT 10.0 Tools
	echo.
	echo.  [6]   Microsoft DirectX 9.0c
	echo.
	echo.  [7]   Microsoft Visual C++ Runtime
	echo.
	echo.
	echo.  [X]   Retour
	echo.
	echo.===============================================================================
	echo.
	choice /C:1234567X /N /M "Entrer votre choix : "
	if errorlevel 8 goto :IntegrateMenu
	if errorlevel 7 goto :IntVCRuntime
	if errorlevel 6 goto :IntDirectX9c
	if errorlevel 5 goto :IntDaRT
	if errorlevel 4 goto :IntWSL
	if errorlevel 3 goto :IntPowerShell7
	if errorlevel 2 goto :IntNET5
	if errorlevel 1 goto :IntNetFX35
)

:: Checking whether the selected Source OS is a Windows Server v1903/v1909 Non Core Edition
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "18362" if "%ImageBuild%" leq "18363" if "%ImageInstallationType%" equ "Server" (
	echo.
	echo.  [A]   Microsoft .NET Framework 3.5
	echo.  [B]   Microsoft .NET 5
	echo.  [C]   Microsoft Edge Classic Browser
	echo.  [D]   Microsoft Edge Chromium Browser
	echo.  [E]   Windows Multimedia Restricted Codecs
	echo.  [F]   Windows Subsystem for Linux ^(WSL^)
	echo.  [G]   Windows To Go Workspace
	echo.  [H]   Windows PowerShell 7.1
	echo.  [I]   Microsoft Default Inbox Apps
	echo.  [J]   Microsoft DaRT 10.0 Tools
	echo.  [K]   Microsoft DirectX 9.0c
	echo.  [L]   Microsoft Games
	echo.  [M]   Windows Sidebar
	echo.  [N]   Microsoft Visual C++ Runtime
	echo.
	echo.  [X]   Retour
	echo.
	echo.===============================================================================
	echo.
	choice /C:ABCDEFGHIJKLMNX /N /M "Entrer votre choix : "
	if errorlevel 15 goto :IntegrateMenu
	if errorlevel 14 goto :IntVCRuntime
	if errorlevel 13 goto :IntSidebar
	if errorlevel 12 goto :IntGames
	if errorlevel 11 goto :IntDirectX9c
	if errorlevel 10 goto :IntDaRT
	if errorlevel 9  goto :IntInboxApps
	if errorlevel 8  goto :IntPowerShell7
	if errorlevel 7  goto :IntWinToGo
	if errorlevel 6  goto :IntWSL
	if errorlevel 5  goto :IntMMRC
	if errorlevel 4  goto :IntEdgeChromium
	if errorlevel 3  goto :IntEdgeClassic
	if errorlevel 2  goto :IntNET5
	if errorlevel 1  goto :IntNetFX35
)

:: Checking whether the selected Source OS is a Windows Server v2004/v20H2/v21H1/v21H2 Non Core Edition
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "19041" if "%ImageInstallationType%" equ "Server" (
	echo.
	echo.  [A]   Microsoft .NET Framework 3.5
	echo.  [B]   Microsoft .NET 5
	echo.  [C]   Microsoft Edge Classic Browser
	echo.  [D]   Microsoft Edge Chromium Browser
	echo.  [E]   Windows Multimedia Restricted Codecs
	echo.  [F]   Windows Subsystem for Linux ^(WSL^)
	echo.  [G]   Windows PowerShell 7.1
	echo.  [H]   Microsoft Default Inbox Apps
	echo.  [I]   Microsoft DaRT 10.0 Tools
	echo.  [J]   Microsoft DirectX 9.0c
	echo.  [K]   Microsoft Games
	echo.  [L]   Windows Sidebar
	echo.  [M]   Microsoft Visual C++ Runtime
	echo.
	echo.
	echo.  [X]   Retour
	echo.
	echo.===============================================================================
	echo.
	choice /C:ABCDEFGHIJKLMX /N /M "Entrer votre choix : "
	if errorlevel 14 goto :IntegrateMenu
	if errorlevel 13 goto :IntVCRuntime
	if errorlevel 12 goto :IntSidebar
	if errorlevel 11 goto :IntGames
	if errorlevel 10 goto :IntDirectX9c
	if errorlevel 9  goto :IntDaRT
	if errorlevel 8  goto :IntInboxApps
	if errorlevel 7  goto :IntPowerShell7
	if errorlevel 6  goto :IntWSL
	if errorlevel 5  goto :IntMMRC
	if errorlevel 4  goto :IntEdgeChromium
	if errorlevel 3  goto :IntEdgeClassic
	if errorlevel 2  goto :IntNET5
	if errorlevel 1  goto :IntNetFX35
)

::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: MSMG Toolkit - Integrate Windows Custom Features Menu
::-------------------------------------------------------------------------------------------
:IntCustomFeaturesMenu

cls
echo.===============================================================================
echo.    MSMG ToolKit - Menu Integrer Fonctionnalités personnalisées de Windows
echo.===============================================================================

if "%IsDialogsEnabled%" equ "Yes" (
	cls
	echo.===============================================================================
	echo.    MSMG ToolKit - Menu Integrer Fonctionnalités personnalisées de Windows
	echo.===============================================================================
	echo.
	echo.
	echo.
	echo.                             A T T E N T I O N
	echo.                             =================
	echo.
	echo.   L'integration des fonctionnalites personnalisees de Windows implique 
	echo.   la correction des fichiers systeme et le SFC peut donc signaler 
	echo.   la corruption des fichiers système Windows. Ceci est normal. 
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.   Pour desactiver les boîtes de dialogue d'avertissement, choisissez 
	echo.	Desactiver les boites de dialogue dans Outils-^>Menu Options 
	echo.
	echo.===============================================================================
	echo.
	choice /C:YN /N /M "Voulez-vous continuer ? ['Y'es/'N'o] : "
	if errorlevel 2 goto :IntegrateMenu
)

cls
echo.===============================================================================
echo.    MSMG ToolKit - Menu Integrer Fonctionnalités personnalisées de Windows 
echo.===============================================================================
:: Checking whether the selected Source OS is a Windows 7 Client/Server 2008 R2 Non-Core Edition
if "%selectedSourceOS%" equ "w7" if "%ImageInstallationType%" neq "Embedded" if "%ImageInstallationType%" neq "Server Core" (
	echo.
	echo.  [1]   Correctif Microsoft Terminal Server
	echo.
	echo.  [2]   Patch UxTheme de themes personnalises
	echo.
	echo.  [3]   Environnement de recuperation Windows personnalise ^(WinRE^)
	echo.
	echo.  [4]   Images de compte utilisateur par defaut personnalisees
	echo.
	echo.  [5]   Fichiers systeme personnalises
	echo.
	echo.  [6]   Polices personnalisees
	echo.
	echo.
	echo.
	echo.
	echo.  [X]   Go Back
	echo.
	echo.===============================================================================
	echo.
	choice /C:123456X /N /M "Entrer votre choix : "
	if errorlevel 7 goto :IntegrateMenu
	if errorlevel 6 goto :IntCustomFonts
	if errorlevel 5 goto :IntCustomFiles
	if errorlevel 4 goto :IntUAP
	if errorlevel 3 goto :IntCustomRecoveryImage
	if errorlevel 2 goto :IntCustomUxTheme
	if errorlevel 1 goto :IntCustomTerminalServer
)

:: Checking whether the selected Source OS is a Windows 7 Embedded Edition
if "%selectedSourceOS%" equ "w7" if "%ImageInstallationType%" equ "Embedded" (
	echo.
	echo.  [1]   Correctif Microsoft Terminal Server
	echo.
	echo.  [2]   Patch UxTheme de themes personnalises
	echo.
	echo.  [3]   Images de compte utilisateur par defaut personnalisees
	echo.
	echo.  [4]   Fichiers systeme personnalises
	echo.
	echo.  [5]   Polices personnalisees
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.  [X]   Retour
	echo.
	echo.===============================================================================
	echo.
	choice /C:12345X /N /M "Entrer votre choix : "
	if errorlevel 6 goto :IntegrateMenu
	if errorlevel 5 goto :IntCustomFonts
	if errorlevel 4 goto :IntCustomFiles
	if errorlevel 3 goto :IntUAP
	if errorlevel 2 goto :IntCustomUxTheme
	if errorlevel 1 goto :IntCustomTerminalServer
)

:: Checking whether the selected Source OS is a Windows Server 2008 Core Edition
if "%selectedSourceOS%" equ "w7" if "%ImageInstallationType%" equ "Server Core" (
	echo.
	echo.  [1]   Correctif Microsoft Terminal Server
	echo.
	echo.  [2]   Environnement de recuperation Windows personnalise ^(WinRE^)
	echo.
	echo.  [3]   Fichiers systeme personnalises
	echo.
	echo.  [4]   Polices personnalisees
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.  [X]   Retour
	echo.
	echo.===============================================================================
	echo.
	choice /C:1234X /N /M "Entrer votre choix : "
	if errorlevel 5 goto :IntegrateMenu
	if errorlevel 4 goto :IntCustomFonts
	if errorlevel 3 goto :IntCustomFiles
	if errorlevel 2 goto :IntCustomRecoveryImage
	if errorlevel 1 goto :IntCustomTerminalServer
)

:: Checking whether the selected Source OS is a Windows 8.1 Client Non-Professioanl WMC/Server 2012 R2 Non-Core Edition
if "%selectedSourceOS%" equ "w81" if "%ImageFlag%" neq "ProfessionalWMC" if "%ImageInstallationType%" neq "Server Core" (
	echo.
	echo.  [1]   Données de pre-activation de Windows 8.1 
	echo.
	echo.  [2]   Correctif Microsoft Terminal Server
	echo.
	echo.  [3]   Patch UxTheme de themes personnalises
	echo.
	echo.  [4]   Environnement de recuperation Windows personnalise ^(WinRE^)
	echo.
	echo.  [5]   Images de compte utilisateur par defaut personnalisees
	echo.
	echo.  [6]   Fichiers systeme personnalises
	echo.
	echo.  [7]   Polices personnalisees
	echo.
	echo.
	echo.  [X]   Retour
	echo.
	echo.===============================================================================
	echo.
	choice /C:1234567X /N /M "Entrer votre choix : "
	if errorlevel 8 goto :IntegrateMenu
	if errorlevel 7 goto :IntCustomFonts
	if errorlevel 6 goto :IntCustomFiles
	if errorlevel 5 goto :IntUAP
	if errorlevel 4 goto :IntCustomRecoveryImage
	if errorlevel 3 goto :IntCustomUxTheme
	if errorlevel 2 goto :IntCustomTerminalServer
	if errorlevel 1 goto :IntPreActTokens
)

:: Checking whether the selected Source OS is a Windows 8.1 Professioanl WMC Edition
if "%selectedSourceOS%" equ "w81" if "%ImageEdition%" equ "ProfessionalWMC" (
	echo.
	echo.  [1]   Jetons d'activation de Windows 8.1 Media Center
	echo.
	echo.  [2]   Données de pre-activation de Windows 8.1 
	echo.
	echo.  [3]   Correctif Microsoft Terminal Server
	echo.
	echo.  [4]   Patch UxTheme de themes personnalises
	echo.
	echo.  [5]   Environnement de recuperation Windows personnalise ^(WinRE^)
	echo.
	echo.  [6]   Images de compte utilisateur par defaut personnalisees
	echo.
	echo.  [7]   Fichiers systeme personnalises
	echo.
	echo.  [8]   Polices personnalisees
	echo.
	echo.  [X]   Retour
	echo.
	echo.===============================================================================
	choice /C:12345678X /N /M "Enter Your Choice : "
	if errorlevel 9 goto :IntegrateMenu
	if errorlevel 8 goto :IntCustomFonts
	if errorlevel 7 goto :IntCustomFiles
	if errorlevel 6 goto :IntUAP
	if errorlevel 5 goto :IntCustomRecoveryImage
	if errorlevel 4 goto :IntCustomUxTheme
	if errorlevel 3 goto :IntCustomTerminalServer
	if errorlevel 2 goto :IntPreActTokens
	if errorlevel 1 goto :IntWMCGActTokens
)

:: Checking whether the selected Source OS is a Windows Server 2012 R2 Core Edition
if "%selectedSourceOS%" equ "w81" if "%ImageInstallationType%" equ "Server Core" (
	echo.
	echo.  [1]   Correctif Microsoft Terminal Server
	echo.
	echo.  [2]   Environnement de recuperation Windows personnalise ^(WinRE^)
	echo.
	echo.  [3]   Fichiers systeme personnalises
	echo.
	echo.  [4]   Polices personnalisees
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.  [X]   Go Back
	echo.
	echo.===============================================================================
	echo.
	choice /C:1234X /N /M "Entrer votre choix : "
	if errorlevel 5 goto :IntegrateMenu
	if errorlevel 4 goto :IntCustomFonts
	if errorlevel 3 goto :IntCustomFiles
	if errorlevel 2 goto :IntCustomRecoveryImage
	if errorlevel 1 goto :IntCustomTerminalServer
)

:: Checking whether the selected Source OS is a Windows Server Core Edition
if "%selectedSourceOS%" equ "w10" if "%ImageInstallationType%" equ "Server Core" (
	echo.
	echo.  [1]   Correctif Microsoft Terminal Server
	echo.
	echo.  [2]   Environnement de recuperation Windows personnalise ^(WinRE^)
	echo.
	echo.  [3]   Fichiers systeme personnalises
	echo.
	echo.  [4]   Polices personnalisees
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.  [X]   Retour
	echo.
	echo.===============================================================================
	echo.
	choice /C:1234X /N /M "Entrer votre choix : "
	if errorlevel 5 goto :IntegrateMenu
	if errorlevel 4 goto :IntCustomFonts
	if errorlevel 3 goto :IntCustomFiles
	if errorlevel 2 goto :IntCustomRecoveryImage
	if errorlevel 1 goto :IntCustomTerminalServer
)

:: Checking whether the selected Source OS is a Windows 10 Client/Server Non-Core Edition
if "%selectedSourceOS%" equ "w10" if "%ImageInstallationType%" neq "Server Core" (
	echo.  [1]   Correctif Microsoft Terminal Server
	echo.
	echo.  [2]   Patch UxTheme de themes personnalises
	echo.
	echo.  [3]   Environnement de recuperation Windows personnalise ^(WinRE^)
	echo.
	echo.  [4]   Images de compte utilisateur par defaut personnalisees
	echo.
	echo.  [5]   Fichiers systeme personnalises
	echo.
	echo.  [6]   Polices personnalisees
	echo.
	echo.  [7]   Skin Metro de Microsoft Win32Calc
	echo.
	echo.  [8]   Skin Metro de la Visionneuse de photos Windows
	echo.
	echo.  [9]   Skin Metro du lecteur Windows Media 
	echo.
	echo.  [X]   Retour
	echo.===============================================================================
	choice /C:123456789X /N /M "Entrer votre choix : "
	if errorlevel 10 goto :IntegrateMenu
	if errorlevel 9  goto :IntWMPMetroSkin
	if errorlevel 8  goto :IntWPVMetroSkin
	if errorlevel 7  goto :IntWin32CalcMetroSkin
	if errorlevel 6  goto :IntCustomFonts
	if errorlevel 5  goto :IntCustomFiles
	if errorlevel 4  goto :IntUAP
	if errorlevel 3  goto :IntCustomRecoveryImage
	if errorlevel 2  goto :IntCustomUxTheme
	if errorlevel 1  goto :IntCustomTerminalServer
)
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: MSMG Toolkit - Remove Menu
::-------------------------------------------------------------------------------------------
:RemoveMenu

cls
echo.===============================================================================
echo.                          MSMG ToolKit - Menu Supprimer
echo.===============================================================================
echo.

:: Checking whether Source OS is selected
if "%IsSourceselected%" equ "No" (
	echo.Le systeme d'exploitation source n'est pas selectionne, 
	echo.veuillez selectionner la source dans le menu "Source". 
	echo.
	echo.===============================================================================
	echo.
	pause
	goto :MainMenu
)

:: Checking whether Image Registry is loaded
if "%IsImageRegistryLoaded%" equ "Yes" (
	echo.Le registre d'images du systeme d'exploitation source est charge, 
	echo.veuillez le decharger en utilisant Outils-^>Options. 
	echo.
	echo.===============================================================================
	echo.
	pause
	goto :MainMenu
)

:: Checking whether the selected Source OS is Windows 7 Source OS
if "%selectedSourceOS%" equ "w7" (
	echo.  [1]   Supprimer des composants Windows via la liste des packages 
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
)

:: Checking whether the selected Source OS is Windows 8.1 Source OS
if "%selectedSourceOS%" equ "w81" (
	echo.  [1]   Supprimer les applications Windows via la liste des applications
	echo.
	echo.  [2]   Supprimer des composants Windows via la liste des packages 
	echo.
	echo.
	echo.
	echo.
)

:: Checking whether the selected Source OS is Windows 10 Enterprise 2015/2016 LTSB Edition
if "%selectedSourceOS%" equ "w10" if "%ImageBuild%" leq "17134" if "%ImageFlag%" equ "EnterpriseS" (
	echo.  [1]   Supprimer les applications Windows via la liste des applications
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
)

:: Checking whether the selected Source OS is Windows 10 Enterprise N 2015/2016 LTSB Edition
if "%selectedSourceOS%" equ "w10" if "%ImageBuild%" leq "17134" if "%ImageFlag%" equ "EnterpriseSN" (
	echo.  [1]   Supprimer les applications Windows via la liste des applications
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
)

:: Checking whether the selected Source OS is Windows 10 v1507/v1511/v1607/v1703/v1709/v1803 Client Edition
if "%selectedSourceOS%" equ "w10" if "%ImageBuild%" leq "17134" if "%ImageInstallationType%" equ "Client" if "%ImageFlag%" neq "EnterpriseS" if "%ImageFlag%" neq "EnterpriseSN" (
	echo.  [1]   Supprimer les composants Windows
	echo.
	echo.  [2]   Supprimer les applications Windows via la liste des applications
	echo.
	echo.
	echo.
	echo.
)

:: Checking whether the selected Source OS is a Windows 10 Enterprise 2019 LTSC Edition
if "%selectedSourceOS%" equ "w10" if "%ImageBuild%" equ "17763" if "%ImageFlag%" equ "EnterpriseS" (
	echo.  [1]   Supprimer les composants Windows
	echo.
	echo.  [2]   Supprimer les applications Windows via la liste des applications
	echo.
	echo.
	echo.
	echo.
)

:: Checking whether the selected Source OS is a Windows 10 Enterprise N 2019 LTSC Edition
if "%selectedSourceOS%" equ "w10" if "%ImageBuild%" equ "17763" if "%ImageFlag%" equ "EnterpriseSN" (
	echo.  [1]   Supprimer les composants Windows
	echo.
	echo.  [2]   Supprimer les applications Windows via la liste des applications
	echo.
	echo.
	echo.
	echo.
)

:: Checking whether the selected Source OS is a Windows 10 Client Non-EnterpriseS/EnterpriseSN Edition
if "%selectedSourceOS%" equ "w10" if "%ImageBuild%" equ "17763" if "%ImageInstallationType%" equ "Client" if "%ImageFlag%" neq "EnterpriseS" if "%ImageFlag%" neq "EnterpriseSN" (
	echo.  [1]   Supprimer les composants Windows
	echo.
	echo.  [2]   Supprimer les applications Windows via la liste des applications
	echo.
	echo.  [3]   Supprimer des composants Windows via la liste des packages 
	echo.
	echo.
)

:: Checking whether the selected Source OS is a Windows 10 Client
if "%selectedSourceOS%" equ "w10" if "%ImageBuild%" geq "18362" if "%ImageBuild%" leq "18363" if "%ImageInstallationType%" equ "Client" (
	echo.  [1]   Supprimer les composants Windows
	echo.
	echo.  [2]   Supprimer les applications Windows via la liste des applications
	echo.
	echo.  [3]   Supprimer des composants Windows via la liste des packages 
	echo.
	echo.
)

:: Checking whether the selected Source OS is a Windows 10 Client
if "%selectedSourceOS%" equ "w10" if "%ImageBuild%" geq "19041" if "%ImageBuild%" leq "19042" if "%ImageInstallationType%" equ "Client" (
	echo.  [1]   Supprimer les composants Windows
	echo.
	echo.  [2]   Supprimer les applications Windows via la liste des applications
	echo.
	echo.  [3]   Supprimer des composants Windows via la liste des packages 
	echo.
	echo.
)

:: Checking whether the selected Source OS is a Windows 10 Client
if "%selectedSourceOS%" equ "w10" if "%ImageBuild%" gtr "19042" if "%ImageInstallationType%" equ "Client" (
	echo.  [1]   Supprimer les applications Windows via la liste des applications
	echo.
	echo.  [2]   Supprimer les composants Windows via la liste des packages
	echo.
	echo.
	echo.
)

:: Checking whether the selected Source OS is a Windows Server Edition
if "%selectedSourceOS%" equ "w10" if "%ImageInstallationType:~,6%" equ "Server" (
	echo.  [1]   Supprimer les composants Windows via la liste des packages 
	echo.
	echo.
	echo.
	echo.
	echo.
)

echo.
echo.
echo.
echo.
echo.
echo.
echo.
echo.
echo.  [X]   Retour
echo.
echo.===============================================================================
echo.
:: Checking whether the selected Source OS is Windows 7 Source OS
if "%selectedSourceOS%" equ "w7" (
	choice /C:1X /N /M "Entrer votre choix : "
	if errorlevel 2 goto :MainMenu
	if errorlevel 1 goto :RemoveWindowsComponentsList
)

:: Checking whether the selected Source OS is Windows 8.1 Source OS
if "%selectedSourceOS%" equ "w81" (
	choice /C:12X /N /M "Entrer votre choix : "
	if errorlevel 3 goto :MainMenu
	if errorlevel 2 goto :RemoveWindowsComponentsList
	if errorlevel 1 goto :RemoveWindowsAppsList
)

:: Checking whether the selected Source OS is Windows 10 Enterprise 2015/2016 LTSB Edition
if "%selectedSourceOS%" equ "w10" if "%ImageBuild%" leq "17134" if "%ImageFlag%" equ "EnterpriseS" (
	choice /C:1X /N /M "Entrer votre choix : "
	if errorlevel 2 goto :MainMenu
	if errorlevel 1 goto :RemoveWindowsComponentsList
)

:: Checking whether the selected Source OS is Windows 10 Enterprise N 2015/2016 LTSB Edition
if "%selectedSourceOS%" equ "w10" if "%ImageBuild%" leq "17134" if "%ImageFlag%" equ "EnterpriseSN" (
	choice /C:1X /N /M "Entrer votre choix : "
	if errorlevel 2 goto :MainMenu
	if errorlevel 1 goto :RemoveWindowsComponentsList
)

:: Checking whether the selected Source OS is Windows 10 v1507/v1511/v1607/v1703/v1709/v1803 Client Edition
if "%selectedSourceOS%" equ "w10" if "%ImageBuild%" leq "17134" if "%ImageInstallationType%" equ "Client" if "%ImageFlag%" neq "EnterpriseS" if "%ImageFlag%" neq "EnterpriseSN" (
	choice /C:12X /N /M "Entrer votre choix : "
	if errorlevel 3 goto :MainMenu
	if errorlevel 2 goto :RemoveWindowsComponentsList
	if errorlevel 1 goto :RemoveWindowsAppsList
)

:: Checking whether the selected Source OS is a Windows 10 Enterprise 2019 LTSC Edition
if "%selectedSourceOS%" equ "w10" if "%ImageBuild%" equ "17763" if "%ImageFlag%" equ "EnterpriseS" (
	choice /C:12X /N /M "Entrer votre choix : "
	if errorlevel 3 goto :MainMenu
	if errorlevel 2 goto :RemoveWindowsComponentsList
	if errorlevel 1 goto :RemoveWindowsComponentsMenu
)

:: Checking whether the selected Source OS is a Windows 10 Enterprise N 2019 LTSC Edition
if "%selectedSourceOS%" equ "w10" if "%ImageBuild%" equ "17763" if "%ImageFlag%" equ "EnterpriseSN" (
	choice /C:12X /N /M "Entrer votre choix : "
	if errorlevel 3 goto :MainMenu
	if errorlevel 2 goto :RemoveWindowsComponentsList
	if errorlevel 1 goto :RemoveWindowsComponentsMenu
)

:: Checking whether the selected Source OS is a Windows 10 Client Non-EnterpriseS/EnterpriseSN Edition
if "%selectedSourceOS%" equ "w10" if "%ImageBuild%" equ "17763" if "%ImageInstallationType%" equ "Client" if "%ImageFlag%" neq "EnterpriseS" if "%ImageFlag%" neq "EnterpriseSN" (
	choice /C:123X /N /M "Entrer votre choix : "
	if errorlevel 4 goto :MainMenu
	if errorlevel 3 goto :RemoveWindowsComponentsList
	if errorlevel 2 goto :RemoveWindowsAppsList
	if errorlevel 1 goto :RemoveWindowsComponentsMenu
)

:: Checking whether the selected Source OS is a Windows 10 Client
if "%selectedSourceOS%" equ "w10" if "%ImageBuild%" geq "18362" if "%ImageBuild%" leq "18363" if "%ImageInstallationType%" equ "Client" (
	choice /C:123X /N /M "Entrer votre choix : "
	if errorlevel 4 goto :MainMenu
	if errorlevel 3 goto :RemoveWindowsComponentsList
	if errorlevel 2 goto :RemoveWindowsAppsList
	if errorlevel 1 goto :RemoveWindowsComponentsMenu
)

:: Checking whether the selected Source OS is a Windows 10 Client
if "%selectedSourceOS%" equ "w10" if "%ImageBuild%" geq "19041" if "%ImageBuild%" leq "19042" if "%ImageInstallationType%" equ "Client" (
	choice /C:123X /N /M "Entrer votre choix : "
	if errorlevel 4 goto :MainMenu
	if errorlevel 3 goto :RemoveWindowsComponentsList
	if errorlevel 2 goto :RemoveWindowsAppsList
	if errorlevel 1 goto :RemoveWindowsComponentsMenu
)

:: Checking whether the selected Source OS is a Windows 10 Client
if "%selectedSourceOS%" equ "w10" if "%ImageBuild%" gtr "19042" if "%ImageInstallationType%" equ "Client" (
	choice /C:12X /N /M "Entrer votre choix : "
	if errorlevel 3 goto :MainMenu
	if errorlevel 2 goto :RemoveWindowsComponentsList
	if errorlevel 1 goto :RemoveWindowsAppsList
)

:: Checking whether the selected Source OS is a Windows Server Edition
if "%selectedSourceOS%" equ "w10" if "%ImageInstallationType:~,6%" equ "Server" (
	choice /C:1X /N /M "Entrer votre choix : "
	if errorlevel 2 goto :MainMenu
	if errorlevel 1 goto :RemoveWindowsComponentsList
)
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: MSMG Toolkit - Customize Menu
::-------------------------------------------------------------------------------------------
:CustomizeMenu

cls
echo.===============================================================================
echo.                         MSMG ToolKit - Menu personnalise
echo.===============================================================================
echo.
:: Checking whether Source OS is selected
if "%IsSourceselected%" equ "No" (
	echo.Le systeme d'exploitation source n'est pas selectionne,
	echo.veuillez selectionner la source dans le menu "Source". 
	echo.
	echo.===============================================================================
	echo.
	pause
	goto :MainMenu
)

:: Checking whether Image Registry is loaded
if "%IsImageRegistryLoaded%" equ "Yes" (
	echo.Le registre d'images du systeme d'exploitation source est charge,
	echo.veuillez le decharger en utilisant Outils-^>Options. 
	echo.
	echo.===============================================================================
	echo.
	pause
	goto :MainMenu
)

:: Checking whether the selected Source OS is a Windows 7/Server 2008 R2 Edition
if "%selectedSourceOS%" equ "w7" (
	echo.Cette fonctionnalite n'est pas encore implémentee
	echo.
	echo.===============================================================================
	echo.
	pause
	goto :MainMenu
)

echo.  [1]   Activer les fonctionnalites Windows via la liste des fonctionnalites
echo.  [2]   Desactiver les fonctionnalites Windows via la liste des fonctionnalites
echo.  [3]   Importer l'association d'applications de la boite de reception 
echo.   	par defaut personnalisee a partir d'un fichier XML
echo.  [4]   Exporter l'association des applications de la boite de reception  
echo.   	par defaut vers un fichier XML
echo.  [5]   Supprimer le code XML de l'association d'applications de la boite de 
echo.	reception par defaut
echo.  [6]   Importer une disposition de menu de demarrage personnalisee a partir
echo.   	d'un fichier XML
echo.  [7]   Importer le parametre de registre personnalise a partir du fichier
echo.   	de registre
echo.  [8]   Appliquer des ajustements 
echo.
echo.
echo.
echo.
echo.
echo.
echo.
echo.  [X]   Retour
echo.
echo.===============================================================================
echo.
choice /C:12345678X /N /M "Entrer votre choix : "
if errorlevel 9 goto :MainMenu
if errorlevel 8 goto :ApplyTweaksMenu
if errorlevel 7 goto :ImportCustomRegistry
if errorlevel 6 goto :ImportStartMenuLayout
if errorlevel 5 goto :RemoveMetroAppsAssociation
if errorlevel 4 goto :ExportMetroAppsAssociation
if errorlevel 3 goto :ImportMetroAppsAssociation
if errorlevel 2 goto :DisableFeatures
if errorlevel 1 goto :EnableFeatures
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: MSMG Toolkit - Apply Source Menu
::-------------------------------------------------------------------------------------------
:ApplyMenu

cls
echo.===============================================================================
echo.                       MSMG ToolKit - Apply Source Menu
echo.===============================================================================
echo.
:: Checking whether Source OS is selected
if "%IsSourceselected%" equ "No" (
	echo.Le systeme d'exploitation source n'est pas selectionne, 
	echo.veuillez selectionner la source dans le menu "Source". 
	echo.
	echo.===============================================================================
	echo.
	pause
	goto :MainMenu
)

:: Checking whether Image Registry is loaded
if "%IsImageRegistryLoaded%" equ "Yes" (
	echo.Le registre d'images du systeme d'exploitation source est charge, 
	echo.veuillez le decharger en utilisant Outils - ^>Options. 
	echo.
	echo.===============================================================================
	echo.
	pause
	goto :MainMenu
)

if "%IsSourceselected%" equ "Yes" if "%selectedSourceOS%" equ "w7" (
	echo.  [1]   Appliquer ^& enregistrer les modifications aux images source 
	echo.
	echo.  [2]   Annuler les modifications ^& demonter les images source 
	echo.
	echo.
)

if "%IsSourceselected%" equ "Yes" if "%selectedSourceOS%" neq "w7" (
	echo.  [1]   Nettoyer les images sources
	echo.
	echo.  [2]   Appliquer ^& enregistrer les modifications aux images source
	echo.
	echo.  [3]   Ignorer les modifications ^& demonter les images sources 
)
echo.
echo.
echo.
echo.
echo.
echo.
echo.
echo.
echo.
echo.
echo.  [X]   Retour
echo.
echo.===============================================================================
echo.

if "%IsSourceselected%" equ "Yes" if "%selectedSourceOS%" equ "w7" (
	choice /C:12X /N /M "Entrer votre choix : "
	if errorlevel 3 goto :MainMenu
	if errorlevel 2 goto :DiscardSource
	if errorlevel 1 goto :SaveSource
)

if "%IsSourceselected%" equ "Yes" if "%selectedSourceOS%" neq "w7" (
	choice /C:1234X /N /M "Entrer votre choix : "
	if errorlevel 5 goto :MainMenu
	if errorlevel 3 goto :DiscardSource
	if errorlevel 2 goto :SaveSource
	if errorlevel 1 goto :CleanupSource
)
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: MSMG Toolkit - Select Target Menu
::-------------------------------------------------------------------------------------------
:TargetMenu

cls
echo.===============================================================================
echo.                   MSMG ToolKit - Selectionner le menu cible 
echo.===============================================================================
echo.
:: Checking whether Source OS is selected
if "%IsSourceselected%" equ "Yes" (
	echo.Le systeme d'exploitation source est selectionne, veuillez enregistrer 
	echo.ou supprimer la source dans le menu "Appliquer". 
	echo.
	echo.===============================================================================
	echo.
	pause
	goto :MainMenu
)

echo.  [1]   Creer une image ISO DVD
echo.
echo.  [2]   Graver une image ISO sur DVD
echo.
echo.  [3]   Copier la source sur la cle USB
echo.
echo.  [4]   Synchroniser la source et installer l'image sur une cle USB
echo.
echo.  [5]   Graver une image ISO sur une cle USB amorcable
echo.
echo.  [6]   Formater une cle USB 
echo.
echo.
echo.
echo.
echo.  [X]   Retour
echo.
echo.===============================================================================
echo.
choice /C:123456X /N /M "Entrer votre choix : "
if errorlevel 7 goto :MainMenu
if errorlevel 6 goto :FormatUSB
if errorlevel 5 goto :BurnUSB
if errorlevel 4 goto :SyncUSB
if errorlevel 3 goto :CopyUSB
if errorlevel 2 goto :BurnISO
if errorlevel 1 goto :MakeISO
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: MSMG Toolkit - Tools Menu
::-------------------------------------------------------------------------------------------
:ToolsMenu

cls
echo.===============================================================================
echo.                         MSMG ToolKit - Tools Menu
echo.===============================================================================
echo.
echo.  [1]   WIM Manager
echo.
echo.  [2]   Debug Info
echo.
echo.  [3]   Options
echo.
echo.
echo.
echo.
echo.
echo.
echo.
echo.
echo.
echo.
echo.  [X]   Retour
echo.
echo.===============================================================================
echo.
choice /C:123X /N /M "Enter Your Choice : "
if errorlevel 4 goto :MainMenu
if errorlevel 3 goto :Options
if errorlevel 2 goto :Debug
if errorlevel 1 goto :WIMManager
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: MSMG Toolkit - Select Source from <DVD> folder
::-------------------------------------------------------------------------------------------
:SelectSourceDVD

cls
echo.===============================================================================
echo.         MSMG ToolKit - Selectionner la source dans le dossier ^<DVD^> 
echo.===============================================================================
echo.

:: Checking whether Windows Source Boot Image exist
if not exist "%BootWim%" (
	echo.Impossible de trouver l'image "Boot.wim" du programme d'installation
	echo.de Windows dans le dossier ^<DVD\Sources^>... 
	echo.
	echo.Veuillez copier l'image "Boot.wim" de l'installation de Windows 
	echo.dans le dossier ^<DVD\Sources^>...
	goto :Stop
)

:: Checking whether Windows Source Install Image is a ESD Image
if exist "%InstallEsd%" (
	echo.ToolKit a trouve une image d'installation Windows au format .esd,
	echo.une image ESD est une image hautement compressee qui ne peut pas 
	echo.etre directement desservie.
	echo.
	echo.Le Toolkit necessite que l'image d'installation Windows soit 
	echo.au format .wim pour la maintenance.
	echo.
	echo.Veuillez utiliser une image d'installation Windows au format .wim 
	echo.ou utiliser le menu Extraire la source de l'image ESD du magasin 
	echo.dans le menu Source.
	goto :Stop
)

:: Checking whether Windows Source Install Image exist
if not exist "%InstallWim%" (
	echo.echo.Impossible de trouver l'image "Install.wim" du programme d'installation
	echo.de Windows dans le dossier ^<DVD\Sources^>... 
	echo.
	echo.Veuillez copier l'image "Install.wim" de l'installation de Windows 
	echo.dans le dossier ^<DVD\Sources^>...
	goto :Stop
)

echo.-------------------------------------------------------------------------------
echo.####Selection des images sources ##############################################
echo.-------------------------------------------------------------------------------

:: Getting Image Index Number to Service
call :GetImageIndexNo "%InstallWim%"

:: Checking for Image Index Validation
if not defined ImageIndexNo (
	echo.
	echo.numero d'index entre non valide, la plage valide est [1,...%ImageCount%, 'A'll, 'Q'uit]
	echo.
	pause
	goto :SelectSourceDVD
)

if /i "%ImageIndexNo%" equ "Q" goto :MainMenu

:: Getting first Image Index Information
call :GetImageIndexInfo "%InstallWim%", 1 >nul

:: Setting selected Source OS version
if "%ImageVersion%" equ "6.1.7601" set "SelectedSourceOS=w7"
if "%ImageVersion%" equ "6.3.9600" set "SelectedSourceOS=w81"
if "%ImageVersion:~0,-6%" equ "10.0" set "SelectedSourceOS=w10"

:: Checking whether the HOST OS is Windows 7 and selected Source OS is Windows 10
if "%HostVersion%" equ "6.1" if "%SelectedSourceOS%" equ "w10" (
	echo.
	echo.ToolKit ne peut pas entretenir le systeme d'exploitation source 
	echo.Windows 10 sur le système d'exploitation Windows 7 HOST. 
	echo.
	echo.ToolKit necessite un systeme d'exploitation Windows 8.1/10 HOST
	echo.pour la maintenance du systeme d'exploitation source Windows 10.
	goto :Stop
)

echo.
choice /C:YN /N /M "Voulez-vous monter l'image de demarrage de Windows ? ['Y'es/'N'o] : "
if errorlevel 2 set "IsBootImageSelected=No"
if errorlevel 1 set "IsBootImageSelected=Yes"

choice /C:YN /N /M "Voulez-vous monter l'image de recuperation Windows ? ['Y'es/'N'o] : "
if errorlevel 2 set "IsRecoveryImageSelected=No"
if errorlevel 1 set "IsRecoveryImageSelected=Yes"

echo.
echo.-------------------------------------------------------------------------------
echo.####Informations sur l'image source ###########################################
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    :  Install.wim
if /i "%ImageIndexNo%" equ "A" if %ImageCount% neq 1 echo.    numero Index des images          :  1-%ImageCount%
if /i "%ImageIndexNo%" neq "A" 	echo.    numero Index des images           :  %ImageIndexNo%
echo.    Image Architecture       :  %ImageArchitecture%
echo.    Image Version            :  %ImageVersion%
echo.    Image Service Pack Build :  %ImageServicePackBuild%
echo.    Image Service Pack Level :  %ImageServicePackLevel%
echo.    Image Build              :  %ImageBuild%
echo.    Image Default Language   :  %ImageDefaultLanguage%
echo.
echo.-------------------------------------------------------------------------------
echo.####Montage des images sources ################################################
echo.-------------------------------------------------------------------------------
echo.
if "%IsBootImageSelected%" equ "Yes" (
   for /l %%i in (1, 1, 2) do (
       echo.-------------------------------------------------------------------------------
       echo.Montage de l'image [Boot.wim, Index : %%i] sur ^<\Mount\Boot\ %%i^>. 
       echo.-------------------------------------------------------------------------------
       call :MountImage "%BootWim%", %%i, "%BootMount%\%%i"
   )
)

:: Mounting Source Install & Recovery Images Index to Service
if /i "%ImageIndexNo%" equ "A" (
	for /l %%i in (1, 1, %ImageCount%) do (
		call :CreateFolder "%InstallMount%\%%i"

		:: Mounting Source Install Image Indexes to Service
		echo.-------------------------------------------------------------------------------
		echo.Montage de l'image [Install.wim, Index : %%i] sur ^<\Mount\Install\ %%i^>.
		echo.-------------------------------------------------------------------------------
		call :MountImage "%InstallWim%", %%i, "%InstallMount%\%%i"

		if "%IsRecoveryImageSelected%" equ "Yes" (
			call :CreateFolder "%WinReMount%\%%i"

			:: Mounting Source Recovery Image Indexes to Service
			echo.-------------------------------------------------------------------------------
			echo.Montage de l'image [Install.wim, Index : %%i -^> WinRE.wim] sur ^<\Mount\WinRE\ %%i^>. 
			echo.-------------------------------------------------------------------------------
			call :MountImage "%InstallMount%\%%i\%WinReWim%", 1, "%WinReMount%\%%i"
		)
	)
) else (
	for %%i in (%ImageIndexNo%) do (
		call :CreateFolder "%InstallMount%\%%i"

		:: Mounting Source Install Image Indexes to Service
		echo.-------------------------------------------------------------------------------
		echo.Montage de l'image [Install.wim, Index : %%i] sur ^<\Mount\Install\ %%i^>.
		echo.-------------------------------------------------------------------------------
		call :MountImage "%InstallWim%", %%i, "%InstallMount%\%%i"

		if "%IsRecoveryImageSelected%" equ "Yes" (
			call :CreateFolder "%WinReMount%\%%i"

			:: Mounting Source Recovery Image Indexes to Service
			echo.-------------------------------------------------------------------------------
			echo.Montage de l'image [Install.wim, Index : %%i -^> WinRE.wim] sur ^<\Mount\WinRE\ %%i^>. 
			echo.-------------------------------------------------------------------------------
			call :MountImage "%InstallMount%\%%i\%WinReWim%", 1, "%WinReMount%\%%i"
		)
	)
)
echo.-------------------------------------------------------------------------------
echo.####Fin de la sélection de ^& du montage des images sources ###################
echo.-------------------------------------------------------------------------------

set "IsSourceSelected=Yes"

:Stop
echo.
echo.===============================================================================
echo.
pause

goto :MainMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: MSMG Toolkit - Copy Source from DVD Drive to ^<DVD^> folder
::-------------------------------------------------------------------------------------------
:CopySourceDVD

setlocal

set DriveLetter=

cls
echo.===============================================================================
echo.    MSMG ToolKit - Copier la source du lecteur DVD vers le dossier ^<DVD^> 
echo.===============================================================================
echo.

:: Checking whether Windows Source DVD folder is empty
if exist "%DVD%\sources\*.wim" (
	echo.Le dossier Source ^<DVD^> de Toolkit n'est pas vide
	echo.
	choice /C:YN /N /M "Voulez-vous le supprimer et continuer ? ['Y'es/'N'o] : "
	if errorlevel 2 goto :Stop
)

echo.-------------------------------------------------------------------------------
echo.####Demarrage de la copie de la source DVD vers le dossier ^<DVD^> ############
echo.-------------------------------------------------------------------------------
echo.
echo.-------------------------------------------------------------------------------
echo.####Obtention des options de lecteur de DVD ###################################
echo.-------------------------------------------------------------------------------
echo.
:: Getting DVD Drive Letter
set /p DriveLetter=Entrer la lettre du lecteur DVD : 

:: Setting DVD Drive Letter
set "DriveLetter=%DriveLetter%:"
echo.

:: Checking whether the specified DVD Drive letter is empty
if not exist "%DriveLetter%\sources\boot.wim" (
	echo.Impossible de trouver les fichiers d'installation de Windows dans la lettre 
	echo.de lecteur specifiee. 
	echo.
	echo.Veuillez saisir la lettre de lecteur DVD correcte. 
	goto :Stop
)

:: Checking whether the specified DVD Drive Letter is empty
if not exist "%DriveLetter%\sources\install.wim" (
	echo.Impossible de trouver les fichiers d'installation de Windows dans la lettre 
	echo.de lecteur specifiee. 
	echo.
	echo.Veuillez saisir la lettre de lecteur DVD correcte
	goto :Stop
)

echo.-------------------------------------------------------------------------------
echo.####Copie de la source du lecteur DVD vers le dossier ^<DVD^> #################
echo.-------------------------------------------------------------------------------
echo.
call :RemoveFolder "%DVD%"
echo.Copie de la source du lecteur DVD ^<%DriveLetter%^> vers le dossier Source ^<DVD^>. 
echo.
echo.La copie à partir du lecteur DVD peut prendre un certain temps, veuillez donc patienter. 
%XCopy% %DriveLetter% "%DVD%" >nul
echo.
echo.Copie terminee.
echo.
echo.-------------------------------------------------------------------------------
echo.####Fin de la copie de la source du lecteur DVD vers le dossier ^<DVD^> #######
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set DriveLetter=

endlocal

:: Returning to Main Menu
goto :MainMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: MSMG Toolkit - Extract Source from DVD ISO Image to <DVD> folder
::-------------------------------------------------------------------------------------------
:ExtractSourceISO

setlocal

set ISOFileName=

cls
echo.===============================================================================
echo.MSMG ToolKit - Extraire la source de l'image ISO du DVD dans le dossier ^<DVD^> 
echo.===============================================================================
echo.

:: Checking whether Windows Source DVD folder is empty
if exist "%DVD%\sources\*.wim" (
	echo.Le dossier Source ^<DVD^> de Toolkit n'est pas vide 
	echo.
	choice /C:YN /N /M "Voulez-vous le supprimer et continuer ? ['Y'es/'N'o] : "
	if errorlevel 2 goto :Stop
	echo.
)

:: Checking whether DVD ISO Image folder is empty
if not exist "%ISO%\*.iso" (
	echo.Le dossier d'images ISO du DVD ^<ISO^> est vide .
	echo.
	echo.Veuillez copier les images ISO du DVD dans le dossier ^<ISO^>.
	goto :Stop
)

echo.-------------------------------------------------------------------------------
echo.####Demarrage de l'extraction de l'image ISO du DVD vers le dossier ^<DVD^>  ##
echo.-------------------------------------------------------------------------------
echo.
echo.-------------------------------------------------------------------------------
echo.####Obtention des options d'image ISO DVD #####################################
echo.-------------------------------------------------------------------------------
echo.
:: Getting DVD ISO Image file Name
set /p ISOFileName=Enter the ISO Image filename without .iso : 

:: Setting DVD ISO Image file Name
set "ISOFileName=%ISOFileName%.iso"
echo.

:: Checking whether the specified DVD ISO Image file exist
if not exist "%ISO%\%ISOFileName%" (
	echo.Can't find the specified DVD ISO Image in ^<ISO^> folder...
	echo.
	echo.Please enter the correct DVD ISO Image filename...
	goto :Stop
)

echo.-------------------------------------------------------------------------------
echo.####Extracting Source from DVD ISO Image to ^<DVD^> folder#######################
echo.-------------------------------------------------------------------------------
echo.
call :RemoveFolder "%DVD%"
echo.Extracting DVD ISO Image contents to Source ^<DVD^> folder...
echo.
echo.Extraction may take some time, so please wait...
%Zip% x -y "%ISO%\%ISOFileName%" -o"%DVD%" >nul
echo.
set /a n=0
if exist "%DVD%\sources\boot.wim" set /a n+=1
if exist "%DVD%\sources\install.wim" set /a n+=1
if exist "%DVD%\sources\install.esd" set /a n+=1
if "%n%" equ "2" (echo.Extraction Complete...) else echo.Extraction Failed...
echo.
echo.-------------------------------------------------------------------------------
echo.####Finished Extracting Source from DVD ISO Image to ^<DVD^> folder##############
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set ISOFileName=

endlocal

:: Returning to Main Menu
goto :MainMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: MSMG Toolkit - Extract Source from OEM IMG Image to <DVD> folder
::-------------------------------------------------------------------------------------------
:ExtractSourceIMG

setlocal

set IMGFileName=

cls
echo.===============================================================================
echo.      MSMG ToolKit - Extract Source from OEM IMG Image to ^<DVD^> folder
echo.===============================================================================
echo.

:: Checking whether Windows Source DVD folder is empty
if exist "%DVD%\sources\*.wim" (
	echo.Toolkit's Source ^<DVD^> folder is not empty...
	echo.
	choice /C:YN /N /M "Do you want to remove it & continue ? ['Y'es/'N'o] : "
	if errorlevel 2 goto :Stop
)

:: Checking whether OEM IMG folder is empty
if not exist "%ISO%\*.img" (
	echo.Can't find Windows Install OEM IMG Image file in ^<ISO^> folder...
	echo.
	echo.Please copy Windows Install OEM IMG Image file to ^<ISO^> folder...
	goto :Stop
)

echo.-------------------------------------------------------------------------------
echo.####Starting Extracting Source from OEM IMG Image to ^<DVD^> folder##############
echo.-------------------------------------------------------------------------------
echo.
echo.-------------------------------------------------------------------------------
echo.####Getting OEM IMG Image Options##############################################
echo.-------------------------------------------------------------------------------
echo.
:: Getting OEM IMG file Name
set /p IMGFileName=Enter the OEM IMG filename without .img : 

:: Setting OEM IMG file Name
set "IMGFileName=%IMGFileName%.img"
echo.

:: Checking whether the specified OEM IMG Image file exist
if not exist "%ISO%\%IMGFileName%" (
	echo.Can't find the specified OEM IMG Image file...
	echo.
	echo.Please enter the correct OEM IMG Image filename...
	goto :Stop
)

echo.-------------------------------------------------------------------------------
echo.####Extracting Source from OEM IMG Image to ^<DVD^> folder#######################
echo.-------------------------------------------------------------------------------
echo.
call :RemoveFolder "%DVD%"
echo.Extracting OEM IMG Image Contents to Source ^<DVD^> folder...
echo.
echo.Extraction may take some time, so please wait...
%Zip% x -y "%ISO%\%IMGFileName%" -o"%DVD%" >nul
echo.
set /a n=0
if exist "%DVD%\sources\boot.wim" set /a n+=1
if exist "%DVD%\sources\install.wim" set /a n+=1
if "%n%" equ "2" (echo.Extraction Complete...) else echo.Extraction Failed...
echo.
echo.-------------------------------------------------------------------------------
echo.####Finished Extracting Source from OEM IMG Image to ^<DVD^> folder##############
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set IMGFileName=

endlocal

:: Returning to Main Menu
goto :MainMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: MSMG Toolkit - Extract Source from Store ESD Image
::-------------------------------------------------------------------------------------------
:ExtractSourceStoreESD

setlocal

set ImageBuild=

cls
echo.===============================================================================
echo.         MSMG ToolKit - Extraire la source de l'image ESD du magasin 
echo.===============================================================================
echo.

:: Checking whether Windows Source DVD folder is empty
if not exist "%InstallEsd%" (
	echo.Impossible de trouver le fichier d'image ESD du Windows Store
	echo."Install.esd" dans le dossier ^<DVD\Sources^>. 
	echo.
	echo.Veuillez copier le fichier image ESD du Windows Store 
	echo.dans le dossier ^<DVD\Sources^>. 
	goto :Stop
)
echo.-------------------------------------------------------------------------------
echo.####Demarrage de l'extraction de la source via l'image ESD du magasin  ########
echo.-------------------------------------------------------------------------------
echo.
echo.Lecture des informations sur l'image 
echo.
echo.===============================================================================
echo.^|Index^| Arch ^| Name
echo.===============================================================================
for /f "tokens=2 delims=: " %%a in ('%DISM% /Get-WimInfo /WimFile:"%InstallEsd%" ^| findstr /i Index') do (
	for /f "tokens=2 delims=:" %%b in ('%DISM% /Get-WimInfo /WimFile:"%InstallEsd%" /Index:%%a ^| findstr /i Architecture') do (
		for /f "tokens=2 delims=:  " %%c in ('%DISM% /Get-WimInfo /WimFile:"%InstallEsd%" /Index:%%a ^| findstr /i Name') do (
			if %%a equ 1 echo.^|  %%a  ^|  -   ^|%%c
			if %%a gtr 1 if %%a leq 9 echo.^|  %%a  ^|%%b  ^|%%c
			if %%a gtr 9 echo.^|  %%a ^|%%b  ^|%%c
		)
	)
)
echo.===============================================================================
echo.

:: Finding total no of indexes present inside the ESD Image
call :GetImageCount "%InstallEsd%"

if %ImageCount% equ 4 set ImageIndexNo=4

if %ImageCount% gtr 4 (
	:: Getting Image Index Number to Service
	set /p ImageIndexNo=Entrer le numero d'index d'image [Range : 4,...%ImageCount%, 'A'll, 'Q'uit] : 

	:: Checking for Image Index Validation
	if not defined ImageIndexNo (
		echo.
		echo.numero d'index entre non valide, la plage valide est [4,...%ImageCount%, 'A'll, 'Q'uit]
		echo.
		pause
		goto :ExtractSourceStoreESD
	)

	if /i "%ImageIndexNo%" equ "Q" goto :MainMenu
)
echo.
echo.-------------------------------------------------------------------------------
echo.####Extraction de la source a partir de l'image ESD du magasin ################
echo.-------------------------------------------------------------------------------
echo.
echo.Decryptage de l'image ESD du Windows Store si elle a ete cryptee. 
attrib -r -h -s -a "%InstallEsd%" >nul
for /f "skip=1 tokens=4 delims=:." %%e in ('%DISM% /Get-WimInfo /WimFile:"%InstallEsd%" /Index:4 ^| find /i "Version"') do set ImageBuild=%%e
if %ImageBuild% equ 9600 %W81EsdDecrypter% "%InstallEsd%" 2>nul
if %ImageBuild% gtr 9600 %W10EsdDecrypter% "%InstallEsd%" >nul
echo.
:: Creating Temporary Boot and Install Images
echo.Creating Temporary Container Images...
call :RemoveFolder "%Temp%\ESD"
call :CreateFolder "%Temp%\ESD"
call :CaptureImage "%BootWim%", "%Temp%\ESD", "BootWim", "BootWim", "No" >nul
call :CaptureImage "%InstallWim%", "%Temp%\ESD", "InstallWim", "InstallWim", "No" >nul
call :RemoveFolder "%Temp%\ESD"
echo.
echo.-------------------------------------------------------------------------------
echo.Application de l'image du Store [Install.esd, Index: 1] a ^<Temp\DVD^> 
echo.-------------------------------------------------------------------------------
:: Creating Windows Setup Installation Media folder "%Temp%\DVD"
call :RemoveFolder "%Temp%\DVD"
call :CreateFolder "%Temp%\DVD"
call :ApplyImage "%InstallEsd%", 1, "%Temp%\DVD"
move /y "%DVD%\sources\*.wim" "%Temp%\DVD\sources" >nul
echo.-------------------------------------------------------------------------------
echo.Export de l'image du Store [Install.esd, Index: 2] vers l'image de demarrage
echo.-------------------------------------------------------------------------------
call :ExportImageIndex "%InstallEsd%", 2, "%Temp%\DVD\sources\boot.wim", "WIM", "Yes"
call :DeleteImage "%Temp%\DVD\sources\boot.wim", 1 >nul
echo.-------------------------------------------------------------------------------
echo.Export de l'image du Store [Install.esd, Index: 3] vers l'image de demarrage
echo.-------------------------------------------------------------------------------
call :ExportImageIndex "%InstallEsd%", 3, "%Temp%\DVD\sources\boot.wim", "WIM", "Yes"

if %ImageBuild% equ 9600 (
	echo.-------------------------------------------------------------------------------
	echo.Export de l'image du Store [Install.esd, Index: 4] vers l'image de demarrage
	echo.-------------------------------------------------------------------------------
	call :ExportImageIndex "%InstallEsd%", 4, "%Temp%\DVD\sources\install.wim", "WIM", "No"
)

if %ImageBuild% gtr 9600 (
	if /i "%ImageIndexNo%" equ "A" (
		for /l %%i in (3, 1, ImageCount) do (
			echo.-------------------------------------------------------------------------------
			echo.Export de l'image du Store [Install.esd, Index: %%i] vers l'image d'installation
			echo.-------------------------------------------------------------------------------
			call :ExportImageIndex "%InstallEsd%", %%i, "%Temp%\DVD\sources\install.wim", "WIM", "No"
		)
	) else (
		for %%i in (%ImageIndexNo%) do (
			echo.-------------------------------------------------------------------------------
			echo.Export de l'image du Store [Install.esd, Index: %%i] vers l'image d'installation
			echo.-------------------------------------------------------------------------------
			call :ExportImageIndex "%InstallEsd%", %%i, "%Temp%\DVD\sources\install.wim", "WIM", "No"
		)
	)
)

:: Deleting the First Empty Index
call :DeleteImage "%Temp%\DVD\sources\install.wim", 1 >nul

:: Moving ESD to WIM converted folder <Temp\DVD> to <DVD> Source Folder
call :RemoveFolder "%DVD%"
move /y "%Temp%\DVD" "%ROOT%" >nul

echo.-------------------------------------------------------------------------------
echo.####Copie du fichier de configuration EI.CFG dans le dossier ^<DVD\sources^> ##
echo.-------------------------------------------------------------------------------
echo.
:: Getting Install Image Index Edition
call :GetImageEdition "%InstallWim%", 1

:: Writing EI.cfg Config file to <DVD\sources> folder
echo.Copie du fichier EI.CFG dans le dossier ^<DVD\sources^>. 

if exist "%DVD%\sources\EI.CFG" del /f /q "%DVD%\sources\EI.CFG" >nul
(
	echo.[EditionID]
	if /i "%ImageIndexNo%" neq "A" echo.%ImageEdition%
	if /i "%ImageIndexNo%" equ "A" echo.
	echo.
	echo.[Channel]
	echo.Retail
	echo.
	echo.[VL]
	echo.0
	echo.
)>"%DVD%\sources\EI.CFG"

:: Cleaning Up Unwanted files from Source folder
call :RemoveFile "%DVD%\MediaMeta.xml"
echo.
echo.-------------------------------------------------------------------------------
echo.####Fin de l'extraction de la source a partir de l'image ESD du magasin  ######
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set ImageBuild=

endlocal

:: Returning to Main Menu
goto :MainMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: MSMG Toolkit - Extract Source from Microsoft's Media Creation Tool Image
::-------------------------------------------------------------------------------------------
:ExtractSourceMCT

setlocal

cls
echo.===============================================================================
echo.      MSMG ToolKit - Extraire l'image de l'outil de creation multimedia 
echo.===============================================================================
echo.

:: Checking whether Windows Source Boot Image exist
if not exist "%BootWim%" (
	echo.Impossible de trouver l'image d'installation de Windows "Install.esd" 
	echo.dans le dossier ^<DVD\Sources^>.
	echo.
	echo.Veuillez copier l'image "Install.esd" de l'installation de Windows 
	echo.dans le dossier ^<DVD\Sources^>. 
	goto :Stop
)

:: Checking whether Windows Source Install Image exist
if not exist "%InstallEsd%" (
	echo.Impossible de trouver l'image d'installation de Windows "Install.esd" 
	echo.dans le dossier ^<DVD\Sources^>.
	echo.
	echo.Veuillez copier l'image "Install.esd" de l'installation de Windows 
	echo.dans le dossier ^<DVD\Sources^>. 
	goto :Stop
)

echo.-------------------------------------------------------------------------------
echo.####Demarrage de l'extraction de la source via l'image Windows personnalisee ##
echo.-------------------------------------------------------------------------------
echo.
echo.Lecture des informations sur l'image 
echo.
echo.===============================================================================
echo.^|Index^| Arch ^| Name
echo.===============================================================================
for /f "tokens=2 delims=: " %%a in ('%DISM% /Get-WimInfo /WimFile:"%InstallEsd%" ^| findstr /i Index') do (
	for /f "tokens=2 delims=:" %%b in ('%DISM% /Get-WimInfo /WimFile:"%InstallEsd%" /Index:%%a ^| findstr /i Architecture') do (
		for /f "tokens=2 delims=:  " %%c in ('%DISM% /Get-WimInfo /WimFile:"%InstallEsd%" /Index:%%a ^| findstr /i Name') do (
			if %%a leq 9 echo.^|  %%a  ^|%%b  ^|%%c
			if %%a gtr 9 echo.^|  %%a ^|%%b  ^|%%c
		)
	)
)
echo.===============================================================================
echo.

:: Finding total no of indexes present inside the ESD Image
call :GetImageCount "%InstallEsd%"

if %ImageCount% equ 1 (
	set /p ImageIndexNo=Entrer le numero d'index d'image ESD ['Q'uit] : 
) else set /p ImageIndexNo=Entrez le numero d'index d'image ESD [Range : 1,2,...%ImageCount%, 'A'll, 'Q'uit] : 

:: Checking for Image Index Validation
if not defined ImageIndexNo (
	echo.
	echo.Invalid Index # Entered, Valid Range is [1,2,...%ImageCount%, 'A'll, 'Q'uit]
	echo.
	pause
	goto :ExtractSourceMCT
)

if /i "%ImageIndexNo%" equ "Q" goto :MainMenu
echo.
echo.-------------------------------------------------------------------------------
echo.####Starting Extracting Source from Microsoft's Media Creation Tool Image######
echo.-------------------------------------------------------------------------------

:: Creating Temporary Install Images
call :RemoveFolder "%Temp%\ESD"
call :CreateFolder "%Temp%\ESD"

call :CaptureImage "%InstallWim%", "%Temp%\ESD", "InstallWim", "InstallWim", "No" >nul
call :RemoveFolder "%Temp%\ESD"

:: Converting Windows Media Creation Tool Install ESD Image to WIM Image
if /i "%ImageIndexNo%" equ "A" (
	call :ExportImage "%InstallEsd%", "%InstallWim%", "WIM", "No"
) else (
	for %%i in (%ImageIndexNo%) do (
		echo.-------------------------------------------------------------------------------
		echo.Exporting Media Creation Tool [Install.esd, Index : %%i] to Install Image...
		echo.-------------------------------------------------------------------------------
		call :ExportImageIndex "%InstallEsd%", %%i, "%InstallWim%", "WIM", "No"
	)
)

:: Deleting converted Windows Media Creation Tool Install WIM Image Index 1 which is an empty Index
call :DeleteImage "%InstallWim%", 1 >nul

:: Deleting original Windows Media Creation Tool Install ESD Image
call :RemoveFile "%InstallEsd%"

echo.-------------------------------------------------------------------------------
echo.####Finished Extracting Source from Microsoft's Media Creation Tool Image######
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

endlocal

:: Returning to Main Menu
goto :MainMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: MSMG Toolkit - Extract Source from Custom Windows ESD Image
::-------------------------------------------------------------------------------------------
:ExtractSourceESD

setlocal

cls
echo.===============================================================================
echo.         MSMG ToolKit - Extract Source from Custom Windows ESD Image
echo.===============================================================================
echo.

:: Checking whether Windows Source Boot Image exist
if not exist "%BootWim%" (
	echo.Impossible de trouver l'image d'installation de Windows "Boot.wim" 
	echo.dans le dossier ^<DVD\Sources^>. 
	echo.
	echo.Veuillez copier l'image "Boot.wim" de l'installation de Windows dans 
	echo.le dossier ^<DVD\Sources^>.
	goto :Stop
)

:: Checking whether Windows Source Install ESD Image exist
if not exist "%InstallEsd%" (
	echo.Impossible de trouver l'image d'installation de Windows "Install.esd" 
	echo.dans le dossier ^<DVD\Sources^>. 
	echo.
	echo.Veuillez copier l'image "Install.esd" de l'installation de Windows dans 
	echo.le dossier ^<DVD\Sources^>.
	goto :Stop
)

echo.-------------------------------------------------------------------------------
echo.####Demarrage de l'extraction de la source via une image ESD personnalisee  ###
echo.-------------------------------------------------------------------------------
echo.
echo.Lecture des informations sur l'image 
echo.
echo.===============================================================================
echo.^|Index^| Arch ^| Name
echo.===============================================================================
for /f "tokens=2 delims=: " %%a in ('%DISM% /Get-WimInfo /WimFile:"%InstallEsd%" ^| findstr /i Index') do (
	for /f "tokens=2 delims=:" %%b in ('%DISM% /Get-WimInfo /WimFile:"%InstallEsd%" /Index:%%a ^| findstr /i Architecture') do (
		for /f "tokens=2 delims=:  " %%c in ('%DISM% /Get-WimInfo /WimFile:"%InstallEsd%" /Index:%%a ^| findstr /i Name') do (
			if %%a leq 9 echo.^|  %%a  ^|%%b  ^|%%c
			if %%a gtr 9 echo.^|  %%a ^|%%b  ^|%%c
		)
	)
)
echo.===============================================================================
echo.

:: Finding total no of indexes present inside the ESD Image
call :GetImageCount "%InstallEsd%"

if %ImageCount% equ 1 (
	set /p ImageIndexNo=Entrer le numero d'index d'image ESD ['Q'uit] : 
) else set /p ImageIndexNo=Entrer le numero d'index d'image ESD [Range : 1,2,...%ImageCount%, 'A'll, 'Q'uit] : 

:: Checking for Image Index Validation
if not defined ImageIndexNo (
	echo.
	echo.numero d'index entre non valide, la plage valide est [1,2,...%ImageCount%, 'A'll, 'Q'uit]
	echo.
	pause
	goto :ExtractSourceESD
)

if /i "%ImageIndexNo%" equ "Q" goto :MainMenu
echo.
echo.-------------------------------------------------------------------------------
echo.####Extraction de la source via une image Windows ESD personnalisee  ##########
echo.-------------------------------------------------------------------------------

:: Creating Temporary Boot and Install Images
call :RemoveFolder "%Temp%\ESD"
call :CreateFolder "%Temp%\ESD"

call :CaptureImage "%InstallWim%", "%Temp%\ESD", "InstallWim", "InstallWim", "No" >nul
call :RemoveFolder "%Temp%\ESD"

:: Converting Windows Install ESD Image to WIM Image
if /i "%ImageIndexNo%" equ "A" (
	call :ExportImage "%InstallEsd%", "%InstallWim%", "WIM", "No"
) else (
	for %%i in (%ImageIndexNo%) do (
		call :ExportImageIndex "%InstallEsd%", %%i, "%InstallWim%", "WIM", "No"
	)
)

:: Deleting converted Windows Install WIM Image Index 1 which is an empty Index
call :DeleteImage "%InstallWim%", 1 >nul

:: Deleting original Windows Install ESD Image
call :RemoveFile "%InstallEsd%"

echo.-------------------------------------------------------------------------------
echo.####Fin de l'extraction de la source via l'image ESD Windows personnalisee  ###
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

endlocal

:: Returning to Main Menu
goto :MainMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Integrate Windows Language Packs Menu
::-------------------------------------------------------------------------------------------
:IntLanguagePacksMenu

if "%IsDialogsEnabled%" equ "Yes" (
	cls
	echo.===============================================================================
	echo.           MSMG ToolKit - Integrer les modules linguistiques Windows
	echo.===============================================================================
	echo.
	echo.
	echo.
	echo.                              A T T E N T I O N
	echo.                              =================
	echo.
	echo.  N'integrez pas de module linguistique apres une mise a jour. Si vous integrez
	echo.  un mises a jour ^(Hotfix, General Distribution Release [GDR], Zero Day Patch
	echo.  [ZDP] ou Service Pack [SP]^) qui contient des ressources dependant de la 
	echo.  langue avant vous integrez un pack de langue, les changements specifiques a 
	echo.  la langue qui sont contenus dans la mise a jour ne sont pas appliqués et vous 
	echo.  devrez reintegrer la mise a jour. integrez toujours les modules linguistiques 
	echo.  avant d'integrer les mises a jour. 
	echo.
	echo.
	echo.
	echo.  Pour desactiver les boites de dialogue d'avertissement, choisissez Desactiver
	echo.  les boites de dialogue dans Outils -^> Menu Options 
	echo.
	echo.===============================================================================
	echo.
	choice /C:YN /N /M "Voulez-vous continuer ? ['Y'es/'N'o] : "
	if errorlevel 2 goto :IntegrateMenu
)

setlocal

set LanguagePackType=
set LanguagePackCode=

cls
echo.===============================================================================
echo.      MSMG ToolKit - Menu d'integration des modules linguistiques Windows 
echo.===============================================================================
echo.
echo.  [1]   Integrer a l'image de demarrage de l'installation de Windows
echo.
echo.  [2]   Integrer a l'image d'installation Windows
echo.
echo.  [3]   Integrer a l'image de recuperation Windows 
echo.
echo.
echo.
echo.
echo.
echo.
echo.
echo.
echo.
echo.
echo.  [X]   Retour
echo.
echo.===============================================================================
echo.
choice /C:123X /N /M "Entrer votre choix : "
if errorlevel 4 goto :IntegrateMenu
if errorlevel 3 set "LanguagePackType=Recovery"
if errorlevel 2 set "LanguagePackType=Install"
if errorlevel 1 set "LanguagePackType=Boot"

cls
echo.===============================================================================
echo.      MSMG ToolKit - Menu d'integration des modules linguistiques Windows  
echo.===============================================================================
echo.

if "%LanguagePackType%" equ "Boot" if "%IsBootImageSelected%" equ "No" (
	echo.L'image de demarrage de l'installation de Windows n'est pas selectionnee. 
	echo.
	echo.Veuillez choisir l'image de demarrage de Windows en sélectionnant Source. 
	goto :Stop
)

if "%LanguagePackType%" equ "Recovery" if "%IsRecoveryImageSelected%" equ "No" (
	echo.L'image de recuperation Windows n'est pas selectionnee. 
	echo.
	echo.Veuillez choisir l'image de recuperation Windows en selectionnant la source. 
	goto :Stop
)

cls
echo.===============================================================================
echo.    MSMG ToolKit - Integrer les modules linguistiques - Choisir la Langue 
echo.===============================================================================

if "%SelectedSourceOS%" equ "w7" (
	echo. Arabic - Saudi Arabia    [ar-SA]    Latvian - Latvia         [lv-LV]
	echo. Bulgarian - Bulgaria     [bg-BG]    Lithuanian - Lithuania   [lt-LT]
	echo. Chinese - Hong Kong SAR  [zh-HK]    Norwegian - Norway       [nb-NO]
	echo. Chinese - Simplified     [zh-CN]    Polish - Poland          [pl-PL]
	echo. Chinese - Taiwan         [zh-TW]    Portuguese - Brazil      [pt-BR]
	echo. Croatian - Croatia       [hr-HR]    Portuguese - Portugal    [pt-PT]
	echo. Czech - Czech Republic   [cs-CZ]    Romanian - Romania       [ro-RO]
	echo. Danish - Denmark         [da-DK]    Russian - Russia         [ru-RU]
	echo. Dutch - The Netherlands  [nl-NL]    Serbian - Serbia         [sr-Latn-CS]
	echo. English - United States  [en-US]    Slovak - Slovakia        [sk-SK]
	echo. Estonian - Estonia       [et-EE]    Slovenian - Slovenia     [sl-SI]
	echo. Finnish - Finland        [fi-FI]    Spanish - Spain          [es-ES]
	echo. French - France          [fr-FR]    Swedish - Sweden         [sv-SE]
	echo. German - Germany         [de-DE]    Thai - Thailand          [th-TH]
	echo. Greek - Greece           [el-GR]    Turkish - Turkey         [tr-TR]
	echo. Hebrew - israel          [he-IL]    Ukrainian - Ukraine      [uk-UA]
	echo. Hungarian - Hungary      [hu-HU]
	echo. Italian - Italy          [it-IT]
	echo. Japanese - Japan         [ja-JP]
	echo. Korean - Korea           [ko-KR]   [X] Go-Back
)

if "%SelectedSourceOS%" equ "w81" (
	echo. Arabic - Saudi Arabia    [ar-SA]    Korean - Korea           [ko-KR]
	echo. Bulgarian - Bulgaria     [bg-BG]    Latvian - Latvia         [lv-LV]
	echo. Chinese - Hong Kong SAR  [zh-HK]    Lithuanian - Lithuania   [lt-LT]
	echo. Chinese - Simplified     [zh-CN]    Norwegian - Norway       [nb-NO]
	echo. Chinese - Taiwan         [zh-TW]    Polish - Poland          [pl-PL]
	echo. Croatian - Croatia       [hr-HR]    Portuguese - Brazil      [pt-BR]
	echo. Czech - Czech Republic   [cs-CZ]    Portuguese - Portugal    [pt-PT]
	echo. Danish - Denmark         [da-DK]    Romanian - Romania       [ro-RO]
	echo. Dutch - The Netherlands  [nl-NL]    Russian - Russia         [ru-RU]
	echo. English - United Kingdom [en-GB]    Serbian - Serbia         [sr-Latn-CS]
	echo. English - United States  [en-US]    Slovak - Slovakia        [sk-SK]
	echo. Estonian - Estonia       [et-EE]    Slovenian - Slovenia     [sl-SI]
	echo. Finnish - Finland        [fi-FI]    Spanish - Spain          [es-ES]
	echo. French - France          [fr-FR]    Swedish - Sweden         [sv-SE]
	echo. German - Germany         [de-DE]    Thai - Thailand          [th-TH]
	echo. Greek - Greece           [el-GR]    Turkish - Turkey         [tr-TR]
	echo. Hebrew - israel          [he-IL]    Ukrainian - Ukraine      [uk-UA]
	echo. Hungarian - Hungary      [hu-HU]
	echo. Italian - Italy          [it-IT]
	echo. Japanese - Japan         [ja-JP]	  [X] Go-Back
)

if "%SelectedSourceOS%" equ "w10" (
	echo. Arabic - Saudi Arabia    [ar-SA]    Japanese - Japan         [ja-JP]
	echo. Bulgarian - Bulgaria     [bg-BG]    Korean - Korea           [ko-KR]
	echo. Chinese - Hong Kong SAR  [zh-HK]    Latvian - Latvia         [lv-LV]
	echo. Chinese - Simplified     [zh-CN]    Lithuanian - Lithuania   [lt-LT]
	echo. Chinese - Taiwan         [zh-TW]    Norwegian - Norway       [nb-NO]
	echo. Croatian - Croatia       [hr-HR]    Polish - Poland          [pl-PL]
	echo. Czech - Czech Republic   [cs-CZ]    Portuguese - Brazil      [pt-BR]
	echo. Danish - Denmark         [da-DK]    Portuguese - Portugal    [pt-PT]
	echo. Dutch - The Netherlands  [nl-NL]    Romanian - Romania       [ro-RO]
	echo. English - United Kingdom [en-GB]    Russian - Russia         [ru-RU]
	echo. English - United States  [en-US]    Serbian - Serbia         [sr-Latn-RS]
	echo. Estonian - Estonia       [et-EE]    Slovak - Slovakia        [sk-SK]
	echo. Finnish - Finland        [fi-FI]    Slovenian - Slovenia     [sl-SI]
	echo. French - Canada          [fr-CA]    Spanish - Mexico         [es-MX]
	echo. French - France          [fr-FR]    Spanish - Spain          [es-ES]
	echo. German - Germany         [de-DE]    Swedish - Sweden         [sv-SE]
	echo. Greek - Greece           [el-GR]    Thai - Thailand          [th-TH]
	echo. Hebrew - israel          [he-IL]    Turkish - Turkey         [tr-TR]
	echo. Hungarian - Hungary      [hu-HU]    Ukrainian - Ukraine      [uk-UA]
	echo. Italian - Italy          [it-IT]    [X] Go-Back
)
echo.===============================================================================
set /p LanguagePackCode=Enter Language Code without '[' ']' : 

if /i "%LanguagePackCode%" equ "X" goto :IntegrateMenu

cls
echo.===============================================================================
if "%LanguagePackType%" equ "Boot" echo.  MSMG ToolKit - Integrate Windows Language Packs to Windows Setup Boot Image
if "%LanguagePackType%" equ "Install" echo. MSMG ToolKit - Integrate Windows Language Packs to Windows Installation Image
if "%LanguagePackType%" equ "Recovery" echo.   MSMG ToolKit - Integrate Windows Language Packs to Windows Recovery Image
echo.===============================================================================
echo.

:: Getting Source Image Index Architecture
if "%LanguagePackType%" equ "Boot" call :GetImageArchitecture "%BootWim%", 1 >nul

if "%LanguagePackType%" equ "Install" (
	for /l %%i in (1, 1, %ImageCount%) do (
		if exist "%InstallMount%\%%i" call :GetImageArchitecture "%InstallWim%", %%i >nul
	)
)

if "%LanguagePackType%" equ "Recovery" (
	for /l %%i in (1, 1, %ImageCount%) do (
		if exist "%WinReMount%\%%i" call :GetImageArchitecture "%WinReMount%\%%i\%WinReWim%", 1 >nul
	)
)

:: Setting Package Build and Service Pack Build Version
if "%SelectedSourceOS%" equ "w10" (
	if "%ImageBuild%" leq "17763" set "PackageBuild=%ImageBuild%"
	if "%ImageBuild%" geq "18362" if "%ImageBuild%" leq "18363" set "PackageBuild=18362"
	if "%ImageBuild%" geq "19041" if "%ImageBuild%" leq "19042" set "PackageBuild=19041"
)

:: Setting Package Build and Service Pack Build Version
if "%SelectedSourceOS%" equ "w7" set "PackageServicePackBuild=17514"
if "%SelectedSourceOS%" equ "w81" set "PackageServicePackBuild=16384"
if "%SelectedSourceOS%" equ "w10" (
	if "%ImageBuild%" equ "10240" set "PackageServicePackBuild=16384"
	if "%ImageBuild%" equ "10586" set "PackageServicePackBuild=0"
	if "%ImageBuild%" equ "14393" set "PackageServicePackBuild=0"
	if "%ImageBuild%" equ "15063" set "PackageServicePackBuild=0"
	if "%ImageBuild%" equ "16299" set "PackageServicePackBuild=15"
	if "%ImageBuild%" equ "17134" set "PackageServicePackBuild=1"
	if "%ImageBuild%" equ "17763" set "PackageServicePackBuild=1"
	if "%ImageBuild%" equ "18362" set "PackageServicePackBuild=1"
	if "%ImageBuild%" equ "18363" set "PackageServicePackBuild=1"
	if "%ImageBuild%" equ "19041" set "PackageServicePackBuild=1"
	if "%ImageBuild%" equ "19042" set "PackageServicePackBuild=1"
)

:: Setting Package Architecture
if "%ImageArchitecture%" equ "x86" set "PackageArchitecture=x86"
if "%ImageArchitecture%" equ "x64" set "PackageArchitecture=amd64"
if "%ImageArchitecture%" equ "arm" set "PackageArchitecture=arm"
if "%ImageArchitecture%" equ "arm64" set "PackageArchitecture=arm64"

:: Settings Windows Language Packs folder path
if "%SelectedSourceOS%" neq "w10" set "LanguagePacks=%LanguagePacks%\%SelectedSourceOS%\%ImageArchitecture%\%LanguagePackCode%"
if "%SelectedSourceOS%" equ "w10" set "LanguagePacks=%LanguagePacks%\%SelectedSourceOS%\10.0.%PackageBuild%\%ImageArchitecture%\%LanguagePackCode%"

:: Checking whether Windows PE Language Packs folder is empty
if "%LanguagePackType%" equ "Boot" (
	if "%SelectedSourceOS%" equ "w7" if not exist "%LanguagePacks%\Microsoft-Windows-WinPE-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."Microsoft-Windows-WinPE-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w7" if not exist "%LanguagePacks%\WinPE-Scripting-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-Scripting-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w7" if "%ImageInstallationType:~,6%" neq "Server" if not exist "%LanguagePacks%\WinPE-Setup-Client-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-Setup-Client-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w7" if "%ImageInstallationType:~,6%" equ "Server" if not exist "%LanguagePacks%\WinPE-Setup-Server-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-Setup-Server-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w7" if not exist "%LanguagePacks%\WinPE-Setup-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-Setup-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w7" if not exist "%LanguagePacks%\WinPE-SRT-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-SRT-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w7" if not exist "%LanguagePacks%\WinPE-WDS-Tools-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-WDS-Tools-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w7" if not exist "%LanguagePacks%\WinPE-WMI-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-WMI-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w81" if not exist "%LanguagePacks%\Microsoft-Windows-WinPE-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."Microsoft-Windows-WinPE-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w81" if not exist "%LanguagePacks%\WinPE-EnhancedStorage-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-EnhancedStorage-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w81" if "%PackageArchitecture%" neq "arm" if not exist "%LanguagePacks%\WinPE-Rejuv-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-Rejuv-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w81" if not exist "%LanguagePacks%\WinPE-Scripting-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-Scripting-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w81" if not exist "%LanguagePacks%\WinPE-SecureStartup-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-SecureStartup-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w81" if "%ImageInstallationType:~,6%" neq "Server" if not exist "%LanguagePacks%\WinPE-Setup-Client-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-Setup-Client-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w81" if "%ImageInstallationType:~,6%" equ "Server" if not exist "%LanguagePacks%\WinPE-Setup-Server-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-Setup-Server-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w81" if not exist "%LanguagePacks%\WinPE-Setup-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-Setup-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w81" if not exist "%LanguagePacks%\WinPE-SRT-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-SRT-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w81" if "%PackageArchitecture%" neq "arm" if not exist "%LanguagePacks%\WinPE-StorageWMI-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-StorageWMI-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w81" if not exist "%LanguagePacks%\WinPE-WDS-Tools-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-WDS-Tools-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w81" if not exist "%LanguagePacks%\WinPE-WMI-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-WMI-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w10" if not exist "%LanguagePacks%\Microsoft-Windows-WinPE-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."Microsoft-Windows-WinPE-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\10.0.%PackageBuild%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "15063" if not exist "%LanguagePacks%\WinPE-ATBroker-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-ATBroker-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\10.0.%PackageBuild%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "15063" if not exist "%LanguagePacks%\WinPE-AudioCore-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-AudioCore-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\10.0.%PackageBuild%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "15063" if not exist "%LanguagePacks%\WinPE-AudioDrivers-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-AudioDrivers-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\10.0.%PackageBuild%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w10" if not exist "%LanguagePacks%\WinPE-EnhancedStorage-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-EnhancedStorage-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\10.0.%PackageBuild%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "15063" if not exist "%LanguagePacks%\WinPE-Narrator-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-Narrator-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\10.0.%PackageBuild%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w10" if not exist "%LanguagePacks%\WinPE-Scripting-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-Scripting-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\10.0.%PackageBuild%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w10" if not exist "%LanguagePacks%\WinPE-SecureStartup-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-SecureStartup-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\10.0.%PackageBuild%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w10" if "%ImageInstallationType:~,6%" neq "Server" if not exist "%LanguagePacks%\WinPE-Setup-Client-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-Setup-Client-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\10.0.%PackageBuild%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w10" if "%ImageInstallationType:~,6%" equ "Server" if not exist "%LanguagePacks%\WinPE-Setup-Server-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-Setup-Server-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\10.0.%PackageBuild%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w10" if not exist "%LanguagePacks%\WinPE-Setup-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-Setup-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\10.0.%PackageBuild%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "15063" if "%ImageBuild%" leq "17134" (
		for /d %%i in (de-DE, en-GB, en-IN, es-ES, es-MX, fr-CA, fr-FR, it-IT, ja-JP, ko-KR, pl-PL, pt-BR, pt-PT, ru-RU, zh-CN, zh-HK, zh-TW) do (
			if "%LanguagePackCode%" equ "%%i" if not exist "%LanguagePacks%\WinPE-Speech-TTS-%LanguagePackCode%-Package~31bf3856ad364e35~%PackageArchitecture%~~10.0.%PackageBuild%.%PackageServicePackBuild%.cab" (
				echo.Windows Language Pack folder is missing the below file...
				echo.
				echo."WinPE-Speech-TTS-%LanguagePackCode%-Package~31bf3856ad364e35~%PackageArchitecture%~~10.0.%PackageBuild%.%PackageServicePackBuild%.cab"
				echo.
				echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\10.0.%PackageBuild%\%ImageArchitecture%\%LanguagePackCode%^> folder...
				goto :Stop
			)
		)
	)
	if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "15063" if not exist "%LanguagePacks%\WinPE-Speech-TTS-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-Speech-TTS-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\10.0.%PackageBuild%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "15063" if not exist "%LanguagePacks%\WinPE-SRH-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-SRH-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\10.0.%PackageBuild%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w10" if not exist "%LanguagePacks%\WinPE-SRT-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-SRT-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\10.0.%PackageBuild%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w10" if not exist "%LanguagePacks%\WinPE-WDS-Tools-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-WDS-Tools-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\10.0.%PackageBuild%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w10" if not exist "%LanguagePacks%\WinPE-WMI-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-WMI-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\10.0.%PackageBuild%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
)

:: Checking whether Windows Language or Language Features Packs folder is empty
if "%LanguagePackType%" equ "Install" (
	if "%SelectedSourceOS%" equ "w7" if "%ImageInstallationType%" equ "Client" if not exist "%LanguagePacks%\Microsoft-Windows-Client-Refresh-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."Microsoft-Windows-Client-Refresh-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w7" if "%ImageInstallationType%" equ "Embedded" if not exist "%LanguagePacks%\Microsoft-Windows-Embedded-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."Microsoft-Windows-Embedded-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w7" if "%ImageInstallationType:~,6%" equ "Server" if not exist "%LanguagePacks%\Microsoft-Windows-Server-Refresh-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."Microsoft-Windows-Server-Refresh-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w81" if "%ImageInstallationType:~,6%" neq "Server" if not exist "%LanguagePacks%\Microsoft-Windows-Client-Refresh-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."Microsoft-Windows-Client-Refresh-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w81" if "%ImageInstallationType:~,6%" equ "Server" if not exist "%LanguagePacks%\Microsoft-Windows-Server-Refresh-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."Microsoft-Windows-Server-Refresh-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w10" if "%ImageInstallationType%" equ "Client" if not exist "%LanguagePacks%\Microsoft-Windows-Client-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."Microsoft-Windows-Client-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\10.0.%PackageBuild%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w10" if "%ImageInstallationType:~,6%" equ "Server" if not exist "%LanguagePacks%\Microsoft-Windows-Server-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."Microsoft-Windows-Server-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\10.0.%PackageBuild%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
)

:: Checking whether Windows PE Language Packs folder is empty
if "%LanguagePackType%" equ "Recovery" (
	if "%SelectedSourceOS%" equ "w7" if not exist "%LanguagePacks%\Microsoft-Windows-WinPE-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."Microsoft-Windows-WinPE-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w7" if not exist "%LanguagePacks%\WinPE-Scripting-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-Scripting-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w7" if not exist "%LanguagePacks%\WinPE-Setup-Client-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-Setup-Client-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w7" if not exist "%LanguagePacks%\WinPE-Setup-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-Setup-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w7" if not exist "%LanguagePacks%\WinPE-SRT-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-SRT-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w7" if not exist "%LanguagePacks%\WinPE-WDS-Tools-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-WDS-Tools-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w7" if not exist "%LanguagePacks%\WinPE-WMI-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-WMI-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w81" if not exist "%LanguagePacks%\Microsoft-Windows-WinPE-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."Microsoft-Windows-WinPE-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w81" if not exist "%LanguagePacks%\WinPE-EnhancedStorage-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-EnhancedStorage-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w81" if not exist "%LanguagePacks%\WinPE-Rejuv-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-Rejuv-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w81" if not exist "%LanguagePacks%\WinPE-Scripting-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-Scripting-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w81" if not exist "%LanguagePacks%\WinPE-SecureStartup-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-SecureStartup-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w81" if "%PackageArchitecture%" neq "arm" if "%ImageInstallationType:~,6%" neq "Server" if not exist "%LanguagePacks%\WinPE-Setup-Client-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-Setup-Client-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w81" if "%ImageInstallationType:~,6%" equ "Server" if not exist "%LanguagePacks%\WinPE-Setup-Server-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-Setup-Server-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w81" if "%PackageArchitecture%" neq "arm" if not exist "%LanguagePacks%\WinPE-Setup-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-Setup-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w81" if not exist "%LanguagePacks%\WinPE-SRT-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-SRT-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w81" if not exist "%LanguagePacks%\WinPE-StorageWMI-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-StorageWMI-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w81" if not exist "%LanguagePacks%\WinPE-WDS-Tools-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-WDS-Tools-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w81" if not exist "%LanguagePacks%\WinPE-WMI-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-WMI-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w10" if not exist "%LanguagePacks%\Microsoft-Windows-WinPE-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."Microsoft-Windows-WinPE-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\10.0.%PackageBuild%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "17134" if not exist "%LanguagePacks%\WinPE-AppxPackaging-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-AppxPackaging-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\10.0.%PackageBuild%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "15063" if not exist "%LanguagePacks%\WinPE-ATBroker-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-ATBroker-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\10.0.%PackageBuild%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "15063" if not exist "%LanguagePacks%\WinPE-AudioCore-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-AudioCore-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\10.0.%PackageBuild%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "15063" if not exist "%LanguagePacks%\WinPE-AudioDrivers-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-AudioDrivers-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\10.0.%PackageBuild%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w10" if not exist "%LanguagePacks%\WinPE-EnhancedStorage-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-EnhancedStorage-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\10.0.%PackageBuild%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w10" if not exist "%LanguagePacks%\WinPE-HTA-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-HTA-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\10.0.%PackageBuild%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "15063" if not exist "%LanguagePacks%\WinPE-Narrator-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-Narrator-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\10.0.%PackageBuild%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "17134" if not exist "%LanguagePacks%\WinPE-OpcServices-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-OpcServices-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\10.0.%PackageBuild%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w10" if not exist "%LanguagePacks%\WinPE-Rejuv-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-Rejuv-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\10.0.%PackageBuild%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w10" if not exist "%LanguagePacks%\WinPE-Scripting-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-Scripting-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\10.0.%PackageBuild%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w10" if not exist "%LanguagePacks%\WinPE-SecureStartup-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-SecureStartup-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\10.0.%PackageBuild%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "15063" if "%ImageBuild%" leq "17134" (
		for /d %%i in (de-DE, en-GB, en-IN, es-ES, es-MX, fr-CA, fr-FR, it-IT, ja-JP, ko-KR, pl-PL, pt-BR, pt-PT, ru-RU, zh-CN, zh-HK, zh-TW) do (
			if "%LanguagePackCode%" equ "%%i" if not exist "%LanguagePacks%\WinPE-Speech-TTS-%LanguagePackCode%-Package~31bf3856ad364e35~%PackageArchitecture%~~10.0.%PackageBuild%.%PackageServicePackBuild%.cab" (
				echo.Windows Language Pack folder is missing the below file...
				echo.
				echo."WinPE-Speech-TTS-%LanguagePackCode%-Package~31bf3856ad364e35~%PackageArchitecture%~~10.0.%PackageBuild%.%PackageServicePackBuild%.cab"
				echo.
				echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\10.0.%PackageBuild%\%ImageArchitecture%\%LanguagePackCode%^> folder...
				goto :Stop
			)
		)
	)
	if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "15063" if not exist "%LanguagePacks%\WinPE-Speech-TTS-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-Speech-TTS-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\10.0.%PackageBuild%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "15063" if not exist "%LanguagePacks%\WinPE-SRH-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-SRH-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\10.0.%PackageBuild%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w10" if not exist "%LanguagePacks%\WinPE-SRT-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-SRT-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\10.0.%PackageBuild%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w10" if not exist "%LanguagePacks%\WinPE-StorageWMI-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-StorageWMI-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\10.0.%PackageBuild%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w10" if not exist "%LanguagePacks%\WinPE-WDS-Tools-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-WDS-Tools-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\10.0.%PackageBuild%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "14393" if not exist "%LanguagePacks%\WinPE-WiFi-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-WiFi-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\10.0.%PackageBuild%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
	if "%SelectedSourceOS%" equ "w10" if not exist "%LanguagePacks%\WinPE-WMI-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab" (
		echo.Windows Language Pack folder is missing the below file...
		echo.
		echo."WinPE-WMI-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\LanguagePacks\%SelectedSourceOS%\10.0.%PackageBuild%\%ImageArchitecture%\%LanguagePackCode%^> folder...
		goto :Stop
	)
)
echo.-------------------------------------------------------------------------------
if "%LanguagePackType%" equ "Boot" echo.####Starting Integrating Windows Language Packs to Windows Boot Image##########
if "%LanguagePackType%" equ "Install" echo.####Starting Integrating Windows Language Packs to Windows Installation Image##
if "%LanguagePackType%" equ "Recovery" echo.####Starting Integrating Windows Language Packs to Windows Reocvery Image######
echo.-------------------------------------------------------------------------------
echo.
if "%LanguagePackType%" equ "Boot" (
	echo.    Image                    : Boot.wim
	echo.    Image Index              : 1, 2
)
if "%LanguagePackType%" equ "Install" (
	echo.    Image                    : Install.wim
	if /i "%ImageIndexNo%" equ "A" echo.    Image Indexes            : 1-%ImageCount%
	if /i "%ImageIndexNo%" neq "A" echo.    Image Index              : %ImageIndexNo%
)
if "%LanguagePackType%" equ "Recovery" (
	echo.    Image                    : WinRE.wim
	echo.    Image Index              : 1
)
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
echo.
echo.-------------------------------------------------------------------------------
if "%LanguagePackType%" equ "Boot" echo.####Integrating Windows Language Packs to Windows Boot Image###################
if "%LanguagePackType%" equ "Install" echo.####Integrating Windows Language Packs to Windows Installation Image###########
if "%LanguagePackType%" equ "Recovery" echo.####Integrating Windows Language Packs to Windows Reocvery Image###############
echo.-------------------------------------------------------------------------------
echo.
if "%LanguagePackType%" equ "Boot" (
	for /l %%i in (1, 1, 2) do (
		echo.=============================[Boot.wim, Index : %%i]=============================
		echo.
		echo.-------------------------------------------------------------------------------
		echo.Integrating WinPE Language Pack [%LanguagePackCode%] to Windows Boot Image...
		echo.-------------------------------------------------------------------------------
		if "%SelectedSourceOS%" equ "w7" call :AddPackage "%BootMount%\%%i", "%LanguagePacks%\Microsoft-Windows-WinPE-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab"
		if "%SelectedSourceOS%" equ "w81" call :AddPackage "%BootMount%\%%i", "%LanguagePacks%\Microsoft-Windows-WinPE-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
		
		if "%SelectedSourceOS%" equ "w10" (
			call :AddPackage "%BootMount%\%%i", "%LanguagePacks%\Microsoft-Windows-WinPE-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab"

			if "%ImageBuild%" geq "15063" (
				echo.-------------------------------------------------------------------------------
				echo.Integrating WinPE - AT Broker [%LanguagePackCode%] to Windows Boot Image...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%BootMount%\%%i", "%LanguagePacks%\WinPE-ATBroker-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab"
				echo.-------------------------------------------------------------------------------
				echo.Integrating WinPE - Audio Core [%LanguagePackCode%] to Windows Boot Image...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%BootMount%\%%i", "%LanguagePacks%\WinPE-AudioCore-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab"
				echo.-------------------------------------------------------------------------------
				echo.Integrating WinPE - Audio Drivers [%LanguagePackCode%] to Windows Boot Image...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%BootMount%\%%i", "%LanguagePacks%\WinPE-AudioDrivers-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab"
			)
		)

		if "%SelectedSourceOS%" neq "w7" (
			echo.-------------------------------------------------------------------------------
			echo.Integrating WinPE - Enhanced Storage Pack [%LanguagePackCode%] to Windows Boot Image...
			echo.-------------------------------------------------------------------------------
			if "%SelectedSourceOS%" equ "w81" call :AddPackage "%BootMount%\%%i", "%LanguagePacks%\WinPE-EnhancedStorage-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
			if "%SelectedSourceOS%" equ "w10" call :AddPackage "%BootMount%\%%i", "%LanguagePacks%\WinPE-EnhancedStorage-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab"
		)
		
		if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "15063" (
			echo.-------------------------------------------------------------------------------
			echo.Integrating WinPE - Narrator [%LanguagePackCode%] to Windows Boot Image...
			echo.-------------------------------------------------------------------------------
			call :AddPackage "%BootMount%\%%i", "%LanguagePacks%\WinPE-Narrator-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab"
		)

		if "%SelectedSourceOS%" equ "w81" if exist "%LanguagePacks%\WinPE-IbsProvider-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab" (
			echo.-------------------------------------------------------------------------------
			echo.Integrating WinPE - IBS Provider Pack [%LanguagePackCode%] to Windows Boot Image...
			echo.-------------------------------------------------------------------------------
			call :AddPackage "%BootMount%\%%i", "%LanguagePacks%\WinPE-IbsProvider-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
		)

		echo.-------------------------------------------------------------------------------
		echo.Integrating WinPE - Scripting Pack [%LanguagePackCode%] to Windows Boot Image...
		echo.-------------------------------------------------------------------------------
		if "%SelectedSourceOS%" equ "w7" call :AddPackage "%BootMount%\%%i", "%LanguagePacks%\WinPE-Scripting-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab"
		if "%SelectedSourceOS%" equ "w81" call :AddPackage "%BootMount%\%%i", "%LanguagePacks%\WinPE-Scripting-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
		if "%SelectedSourceOS%" equ "w10" call :AddPackage "%BootMount%\%%i", "%LanguagePacks%\WinPE-Scripting-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab"

		if "%SelectedSourceOS%" neq "w7" (
			echo.-------------------------------------------------------------------------------
			echo.Integrating WinPE - Secure Startup Pack [%LanguagePackCode%] to Windows Boot Image...
			echo.-------------------------------------------------------------------------------
			if "%SelectedSourceOS%" equ "w81" call :AddPackage "%BootMount%\%%i", "%LanguagePacks%\WinPE-SecureStartup-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
			if "%SelectedSourceOS%" equ "w10" call :AddPackage "%BootMount%\%%i", "%LanguagePacks%\WinPE-SecureStartup-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab"
		)
	)

	echo.=============================[Boot.wim, Index : 2]=============================
	echo.
	if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "18362" if not exist "%BootMount%\2\Windows\servicing\Packages\WinPE-Setup-Package~31bf3856ad364e35~%PackageArchitecture%~~10.0.%PackageBuild%.%PackageServicePackBuild%.cab" (
		echo.-------------------------------------------------------------------------------
		echo.Integrating WinPE - Setup Pack to Windows Boot Image...
		echo.-------------------------------------------------------------------------------
		call :AddPackage "%BootMount%\2", "%Patches%\WinPE\WinPE-Setup-Package~31bf3856ad364e35~%PackageArchitecture%~~10.0.%PackageBuild%.%PackageServicePackBuild%.cab"
	)

	echo.-------------------------------------------------------------------------------
	echo.Integrating WinPE - Setup Pack [%LanguagePackCode%] to Windows Boot Image...
	echo.-------------------------------------------------------------------------------
	if "%SelectedSourceOS%" equ "w7" call :AddPackage "%BootMount%\2", "%LanguagePacks%\WinPE-Setup-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab"
	if "%SelectedSourceOS%" equ "w81" call :AddPackage "%BootMount%\2", "%LanguagePacks%\WinPE-Setup-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
	if "%SelectedSourceOS%" equ "w10" call :AddPackage "%BootMount%\2", "%LanguagePacks%\WinPE-Setup-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab"

	if "%ImageInstallationType:~,6%" neq "Server" (
		if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "18362" if not exist "%BootMount%\2\Windows\servicing\Packages\WinPE-Setup-Client-Package~31bf3856ad364e35~%PackageArchitecture%~~10.0.%PackageBuild%.%PackageServicePackBuild%.cab" (
			echo.-------------------------------------------------------------------------------
			echo.Integrating WinPE - Setup Client Pack to Windows Boot Image...
			echo.-------------------------------------------------------------------------------
			call :AddPackage "%BootMount%\2", "%Patches%\WinPE\WinPE-Setup-Client-Package~31bf3856ad364e35~%PackageArchitecture%~~10.0.%PackageBuild%.%PackageServicePackBuild%.cab"
		)

		echo.-------------------------------------------------------------------------------
		echo.Integrating WinPE - Setup Client Pack [%LanguagePackCode%] to Windows Boot Image...
		echo.-------------------------------------------------------------------------------
		if "%SelectedSourceOS%" equ "w7" call :AddPackage "%BootMount%\2", "%LanguagePacks%\WinPE-Setup-Client-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab"
		if "%SelectedSourceOS%" equ "w81" call :AddPackage "%BootMount%\2", "%LanguagePacks%\WinPE-Setup-Client-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
		if "%SelectedSourceOS%" equ "w10" call :AddPackage "%BootMount%\2", "%LanguagePacks%\WinPE-Setup-Client-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab"
	)

	if "%ImageInstallationType:~,6%" equ "Server" (
		if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "18362" if not exist "%BootMount%\2\Windows\servicing\Packages\WinPE-Setup-Server-Package~31bf3856ad364e35~%PackageArchitecture%~~10.0.%PackageBuild%.%PackageServicePackBuild%.cab" (
			echo.-------------------------------------------------------------------------------
			echo.Integrating WinPE - Setup Server Pack to Windows Boot Image...
			echo.-------------------------------------------------------------------------------
			call :AddPackage "%BootMount%\2", "%Patches%\WinPE\WinPE-Setup-Server-Package~31bf3856ad364e35~%PackageArchitecture%~~10.0.%PackageBuild%.%PackageServicePackBuild%.cab"
		)

		echo.-------------------------------------------------------------------------------
		echo.Integrating WinPE - Setup Server Pack [%LanguagePackCode%] to Windows Boot Image...
		echo.-------------------------------------------------------------------------------
		if "%SelectedSourceOS%" equ "w7" call :AddPackage "%BootMount%\2", "%LanguagePacks%\WinPE-Setup-Server-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab"
		if "%SelectedSourceOS%" equ "w81" call :AddPackage "%BootMount%\2", "%LanguagePacks%\WinPE-Setup-Server-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
		if "%SelectedSourceOS%" equ "w10" call :AddPackage "%BootMount%\2", "%LanguagePacks%\WinPE-Setup-Server-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab"
	)

	for /l %%i in (1, 1, 2) do (
		echo.=============================[Boot.wim, Index : %%i]=============================
		echo.
		if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "15063" if "%ImageBuild%" leq "17134" (
			for /d %%z in (de-DE, en-GB, en-IN, es-ES, es-MX, fr-CA, fr-FR, it-IT, ja-JP, ko-KR, pl-PL, pt-BR, pt-PT, ru-RU, zh-CN, zh-HK, zh-TW) do (
				if "%LanguagePackCode%" equ "%%z" (
					echo.-------------------------------------------------------------------------------
					echo.Integrating WinPE - Speech TextToSpeech [%LanguagePackCode%] to Windows Boot Image...
					echo.-------------------------------------------------------------------------------
					call :AddPackage "%BootMount%\%%i", "%LanguagePacks%\WinPE-Speech-TTS-%LanguagePackCode%-Package~31bf3856ad364e35~%PackageArchitecture%~~10.0.%PackageBuild%.%PackageServicePackBuild%.cab"
				)
			)
		)

		if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "15063" (
			echo.-------------------------------------------------------------------------------
			echo.Integrating WinPE - Speech TextToSpeech [%LanguagePackCode%] to Windows Boot Image...
			echo.-------------------------------------------------------------------------------
			call :AddPackage "%BootMount%\%%i", "%LanguagePacks%\WinPE-Speech-TTS-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab"
			echo.-------------------------------------------------------------------------------
			echo.Integrating WinPE - SRH [%LanguagePackCode%] to Windows Boot Image...
			echo.-------------------------------------------------------------------------------
			call :AddPackage "%BootMount%\%%i", "%LanguagePacks%\WinPE-SRH-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab"
		)

		echo.-------------------------------------------------------------------------------
		echo.Integrating WinPE - SRT Pack [%LanguagePackCode%] to Windows Boot Image...
		echo.-------------------------------------------------------------------------------
		if "%SelectedSourceOS%" equ "w7" call :AddPackage "%BootMount%\%%i", "%LanguagePacks%\WinPE-SRT-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab"
		if "%SelectedSourceOS%" equ "w81" call :AddPackage "%BootMount%\%%i", "%LanguagePacks%\WinPE-SRT-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
		if "%SelectedSourceOS%" equ "w10" call :AddPackage "%BootMount%\%%i", "%LanguagePacks%\WinPE-SRT-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating WinPE - WDS Pack [%LanguagePackCode%] to Windows Boot Image...
		echo.-------------------------------------------------------------------------------
		if "%SelectedSourceOS%" equ "w7" call :AddPackage "%BootMount%\%%i", "%LanguagePacks%\WinPE-WDS-Tools-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab"
		if "%SelectedSourceOS%" equ "w81" call :AddPackage "%BootMount%\%%i", "%LanguagePacks%\WinPE-WDS-Tools-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
		if "%SelectedSourceOS%" equ "w10" call :AddPackage "%BootMount%\%%i", "%LanguagePacks%\WinPE-WDS-Tools-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating WinPE - WMI Pack [%LanguagePackCode%] to Windows Boot Image...
		echo.-------------------------------------------------------------------------------
		if "%SelectedSourceOS%" equ "w7" call :AddPackage "%BootMount%\%%i", "%LanguagePacks%\WinPE-WMI-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab"
		if "%SelectedSourceOS%" equ "w81" call :AddPackage "%BootMount%\%%i", "%LanguagePacks%\WinPE-WMI-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
		if "%SelectedSourceOS%" equ "w10" call :AddPackage "%BootMount%\%%i", "%LanguagePacks%\WinPE-WMI-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab"

		for /d %%z in (ja-JP, ko-KR, zh-HK, zh-CN, zh-TW) do (
			if "%LanguagePackCode%" equ "%%z" (
				echo.-------------------------------------------------------------------------------
				echo.Integrating WinPE - Font Support Pack [%LanguagePackCode%] to Windows Boot Image...
				echo.-------------------------------------------------------------------------------
				if "%SelectedSourceOS%" equ "w7" call :AddPackage "%BootMount%\%%i", "%LanguagePacks%\WinPE-FontSupport-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab"
				if "%SelectedSourceOS%" equ "w81" call :AddPackage "%BootMount%\%%i", "%LanguagePacks%\WinPE-FontSupport-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
				if "%SelectedSourceOS%" equ "w10" call :AddPackage "%BootMount%\%%i", "%LanguagePacks%\WinPE-FontSupport-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab"
			)
		)

		echo.-------------------------------------------------------------------------------
		echo.Generating Windows Boot Language Packs Integration Log File...
		echo.-------------------------------------------------------------------------------
		echo.
		echo.Writing Windows Boot Language Packs Integration Log...
		call :GetPackages "%BootMount%\%%i", "Boot-%%i.txt"
		echo.
	)

	echo.-------------------------------------------------------------------------------
	echo.Creating Windows Setup language configuration file [Lang.ini]...
	echo.-------------------------------------------------------------------------------
	%DISM% /Image:"%BootMount%\2" /Gen-LangINI /Distribution:"%DVD%"
	echo.

	if "%SelectedSourceOS%" neq "w10" (
		echo.-------------------------------------------------------------------------------
		echo.Integrating [%LanguagePackCode%] Localized Windows Setup resources to the Source DVD...
		echo.-------------------------------------------------------------------------------
		echo.
		echo.Extracting Windows PE Language Pack [%LanguagePackCode%] to Temporary folder...
		call :RemoveFolder "%Temp%\LanguagePack"
		call :CreateFolder "%Temp%\LanguagePack"
		if "%SelectedSourceOS%" equ "w7" expand "%LanguagePacks%\Microsoft-Windows-WinPE-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab" -f:* "%Temp%\LanguagePack" >nul
		if "%SelectedSourceOS%" equ "w81" expand "%LanguagePacks%\Microsoft-Windows-WinPE-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab" -f:* "%Temp%\LanguagePack" >nul
		echo.
		echo.Copying Localized Windows Setup resources files to the Source DVD...
		call :CreateFolder "%DVD%\sources\%LanguagePackCode%"
		if "%SelectedSourceOS%" equ "w81" if "%ImageInstallationType:~,6%" neq "Server" call :CreateFolder "%DVD%\sources\cli"
		if "%ImageArchitecture%" equ "x86" call :CreateFolder "%DVD%\sources\dlmanifests\microsoft-windows-iasserver-migplugin\%LanguagePackCode%"
		call :CreateFolder "%DVD%\sources\dlmanifests\microsoft-windows-storagemigration\%LanguagePackCode%"
		if "%SelectedSourceOS%" equ "w81" call :CreateFolder "%DVD%\sources\dlmanifests\microsoft-windows-sxs\%LanguagePackCode%"
		call :CreateFolder "%DVD%\sources\etwproviders\%LanguagePackCode%"
		call :CreateFolder "%DVD%\sources\replacementmanifests\microsoft-windows-offlinefiles-core\%LanguagePackCode%"
		if "%SelectedSourceOS%" equ "w81" call :CreateFolder "%DVD%\sources\replacementmanifests\microsoft-windows-storagemigration\%LanguagePackCode%"
		if "%SelectedSourceOS%" equ "w81" call :CreateFolder "%DVD%\sources\replacementmanifests\microsoft-windows-sxs\%LanguagePackCode%"
		xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\*.*" "%DVD%\sources\%LanguagePackCode%" >nul
		if "%SelectedSourceOS%" equ "w81" if "%ImageInstallationType:~,6%" neq "Server" xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\cli\*.*" "%DVD%\sources\cli" >nul
		if "%ImageArchitecture%" equ "x86" xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\dlmanifests\microsoft-windows-iasserver-migplugin\*.*" "%DVD%\sources\dlmanifests\microsoft-windows-iasserver-migplugin\%LanguagePackCode%" >nul
		xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\dlmanifests\microsoft-windows-storagemigration\*.*" "%DVD%\sources\dlmanifests\microsoft-windows-storagemigration\%LanguagePackCode%" >nul
		if "%SelectedSourceOS%" equ "w81" xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\dlmanifests\microsoft-windows-sxs\*.*" "%DVD%\sources\dlmanifests\microsoft-windows-sxs\%LanguagePackCode%" >nul
		xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\etwproviders\*.*" "%DVD%\sources\etwproviders\%LanguagePackCode%" >nul
		xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\replacementmanifests\microsoft-windows-offlinefiles-core\*.*" "%DVD%\sources\replacementmanifests\microsoft-windows-offlinefiles-core\%LanguagePackCode%" >nul
		if "%SelectedSourceOS%" equ "w81" xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\replacementmanifests\microsoft-windows-storagemigration\*.*" "%DVD%\sources\replacementmanifests\microsoft-windows-storagemigration\%LanguagePackCode%" >nul
		if "%SelectedSourceOS%" equ "w81" xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\replacementmanifests\microsoft-windows-sxs\*.*" "%DVD%\sources\replacementmanifests\microsoft-windows-sxs\%LanguagePackCode%" >nul
		echo.
	)

	if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" leq "15063" (
		echo.-------------------------------------------------------------------------------
		echo.Integrating [%LanguagePackCode%] Localized Windows Setup resources to the Source DVD...
		echo.-------------------------------------------------------------------------------
		echo.
		echo.Extracting Windows PE Language Pack [%LanguagePackCode%] to Temporary folder...
		call :RemoveFolder "%Temp%\LanguagePack"
		call :CreateFolder "%Temp%\LanguagePack"
		if "%SelectedSourceOS%" equ "w10" expand "%LanguagePacks%\Microsoft-Windows-WinPE-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab" -f:* "%Temp%\LanguagePack" >nul
		echo.
		echo.Copying Localized Windows Setup resources files to the Source DVD...
		call :CreateFolder "%DVD%\sources\%LanguagePackCode%"
		if "%ImageBuild%" leq 10586 if "%ImageInstallationType:~,6%" neq "Server" call :CreateFolder "%DVD%\sources\cli\%LanguagePackCode%"
		if "%ImageArchitecture%" equ "x86" call :CreateFolder "%DVD%\sources\dlmanifests\microsoft-windows-iasserver-migplugin\%LanguagePackCode%"
		call :CreateFolder "%DVD%\sources\dlmanifests\microsoft-windows-shmig-dl\%LanguagePackCode%"
		call :CreateFolder "%DVD%\sources\dlmanifests\microsoft-windows-storagemigration\%LanguagePackCode%"
		call :CreateFolder "%DVD%\sources\dlmanifests\microsoft-windows-sxs\%LanguagePackCode%"
		call :CreateFolder "%DVD%\sources\etwproviders\%LanguagePackCode%"
		if "%ImageBuild%" neq "10240" if "%ImageBuild%" neq "10586" if "%ImageArchitecture%" equ "x64" call :CreateFolder "%DVD%\sources\replacementmanifests\microsoft-windows-fabric-core\%LanguagePackCode%"
		call :CreateFolder "%DVD%\sources\replacementmanifests\microsoft-windows-offlinefiles-core\%LanguagePackCode%"
		call :CreateFolder "%DVD%\sources\replacementmanifests\microsoft-windows-shmig\%LanguagePackCode%"
		call :CreateFolder "%DVD%\sources\replacementmanifests\microsoft-windows-storagemigration\%LanguagePackCode%"
		call :CreateFolder "%DVD%\sources\replacementmanifests\microsoft-windows-sxs\%LanguagePackCode%"
		xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\*.*" "%DVD%\sources\%LanguagePackCode%" >nul
		if "%ImageBuild%" leq 10586 if "%ImageInstallationType:~,6%" neq "Server" xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\cli\*.*" "%DVD%\sources\cli\%LanguagePackCode%" >nul
		if "%ImageArchitecture%" equ "x86" xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\dlmanifests\microsoft-windows-iasserver-migplugin\*.*" "%DVD%\sources\dlmanifests\microsoft-windows-iasserver-migplugin\%LanguagePackCode%" >nul
		xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\dlmanifests\microsoft-windows-shmig-dl\*.*" "%DVD%\sources\dlmanifests\microsoft-windows-shmig-dl\%LanguagePackCode%" >nul
		xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\dlmanifests\microsoft-windows-storagemigration\*.*" "%DVD%\sources\dlmanifests\microsoft-windows-storagemigration\%LanguagePackCode%" >nul
		xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\dlmanifests\microsoft-windows-sxs\*.*" "%DVD%\sources\dlmanifests\microsoft-windows-sxs\%LanguagePackCode%" >nul
		xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\etwproviders\*.*" "%DVD%\sources\etwproviders\%LanguagePackCode%" >nul
		if "%ImageBuild%" neq "10240" if "%ImageBuild%" neq "10586" if "%ImageArchitecture%" equ "x64" xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\replacementmanifests\microsoft-windows-fabric-core\*.*" "%DVD%\sources\replacementmanifests\microsoft-windows-fabric-core\%LanguagePackCode%" >nul
		xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\replacementmanifests\microsoft-windows-offlinefiles-core\*.*" "%DVD%\sources\replacementmanifests\microsoft-windows-offlinefiles-core\%LanguagePackCode%" >nul
		xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\replacementmanifests\microsoft-windows-shmig\*.*" "%DVD%\sources\replacementmanifests\microsoft-windows-shmig\%LanguagePackCode%" >nul
		xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\replacementmanifests\microsoft-windows-storagemigration\*.*" "%DVD%\sources\replacementmanifests\microsoft-windows-storagemigration\%LanguagePackCode%" >nul
		xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\replacementmanifests\microsoft-windows-sxs\*.*" "%DVD%\sources\replacementmanifests\microsoft-windows-sxs\%LanguagePackCode%" >nul
		echo.
	)

	if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "16299" if "%ImageBuild%" leq "17763" if "%LanguagePackCode%" neq "en-US" (
		echo.-------------------------------------------------------------------------------
		echo.Integrating [%LanguagePackCode%] Localized Windows Setup resources to the Source DVD...
		echo.-------------------------------------------------------------------------------
		echo.
		echo.Extracting Windows PE Language Pack [%LanguagePackCode%] to Temporary folder...
		call :RemoveFolder "%Temp%\LanguagePack"
		call :CreateFolder "%Temp%\LanguagePack"
		if "%SelectedSourceOS%" equ "w10" expand "%LanguagePacks%\Microsoft-Windows-WinPE-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab" -f:* "%Temp%\LanguagePack" >nul
		echo.
		echo.Copying Localized Windows Setup resources files to the Source DVD...
		call :CreateFolder "%DVD%\sources\%LanguagePackCode%"
		if "%ImageBuild%" leq "17134" if "%ImageArchitecture%" equ "x86" call :CreateFolder "%DVD%\sources\dlmanifests\microsoft-windows-iasserver-migplugin\%LanguagePackCode%"
		if "%ImageBuild%" leq "17134" call :CreateFolder "%DVD%\sources\dlmanifests\microsoft-windows-storagemigration\%LanguagePackCode%"
		call :CreateFolder "%DVD%\sources\etwproviders\%LanguagePackCode%"
		if "%ImageBuild%" equ "16299" if "%ImageArchitecture%" equ "x64" call :CreateFolder "%DVD%\sources\replacementmanifests\microsoft-windows-fabric-core\%LanguagePackCode%"
		call :CreateFolder "%DVD%\sources\replacementmanifests\microsoft-windows-offlinefiles-core\%LanguagePackCode%"
		call :CreateFolder "%DVD%\sources\replacementmanifests\microsoft-windows-shmig\%LanguagePackCode%"
		if "%ImageBuild%" leq "17134" call :CreateFolder "%DVD%\sources\replacementmanifests\microsoft-windows-storagemigration\%LanguagePackCode%"
		call :CreateFolder "%DVD%\sources\replacementmanifests\microsoft-windows-sxs\%LanguagePackCode%"
		xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\*.*" "%DVD%\sources\%LanguagePackCode%" >nul
		if "%ImageBuild%" leq "17134" if "%ImageArchitecture%" equ "x86" xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\dlmanifests\microsoft-windows-iasserver-migplugin\*.*" "%DVD%\sources\dlmanifests\microsoft-windows-iasserver-migplugin\%LanguagePackCode%" >nul
		if "%ImageBuild%" leq "17134" xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\dlmanifests\microsoft-windows-storagemigration\*.*" "%DVD%\sources\dlmanifests\microsoft-windows-storagemigration\%LanguagePackCode%" >nul
		xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\etwproviders\*.*" "%DVD%\sources\etwproviders\%LanguagePackCode%" >nul
		if "%ImageBuild%" equ "16299" if "%ImageArchitecture%" equ "x64" xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\replacementmanifests\microsoft-windows-fabric-core\*.*" "%DVD%\sources\replacementmanifests\microsoft-windows-fabric-core\%LanguagePackCode%" >nul
		xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\replacementmanifests\microsoft-windows-offlinefiles-core\*.*" "%DVD%\sources\replacementmanifests\microsoft-windows-offlinefiles-core\%LanguagePackCode%" >nul
		xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\replacementmanifests\microsoft-windows-shmig\*.*" "%DVD%\sources\replacementmanifests\microsoft-windows-shmig\%LanguagePackCode%" >nul
		if "%ImageBuild%" leq "17134" xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\replacementmanifests\microsoft-windows-storagemigration\*.*" "%DVD%\sources\replacementmanifests\microsoft-windows-storagemigration\%LanguagePackCode%" >nul
		xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\replacementmanifests\microsoft-windows-sxs\*.*" "%DVD%\sources\replacementmanifests\microsoft-windows-sxs\%LanguagePackCode%" >nul
		echo.
	)

	echo.Copying Windows Setup language configuration file to the Boot Image...
	copy /y "%DVD%\sources\lang.ini" "%BootMount%\2\sources\lang.ini" >nul
	echo.
)

if "%LanguagePackType%" equ "Install" (
	for /l %%i in (1, 1, %ImageCount%) do (
		if exist "%InstallMount%\%%i" (
			if not %%i gtr 9 echo.===========================[Install.wim, Index : %%i]============================
			if %%i gtr 9 echo.==========================[Install.wim, Index : %%i]============================
			echo.
			echo.-------------------------------------------------------------------------------
			echo.Integrating Windows Language Pack [%LanguagePackCode%]...
			echo.-------------------------------------------------------------------------------
			if "%SelectedSourceOS%" equ "w7" if "%ImageInstallationType%" equ "Client" call :AddPackage "%InstallMount%\%%i", "%LanguagePacks%\Microsoft-Windows-Client-Refresh-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab"
			if "%SelectedSourceOS%" equ "w7" if "%ImageInstallationType%" equ "Embedded" call :AddPackage "%InstallMount%\%%i", "%LanguagePacks%\Microsoft-Windows-Embedded-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab"
			if "%SelectedSourceOS%" equ "w7" if "%ImageInstallationType:~,6%" equ "Server" call :AddPackage "%InstallMount%\%%i", "%LanguagePacks%\Microsoft-Windows-Server-Refresh-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab"
			if "%SelectedSourceOS%" equ "w81" if "%ImageInstallationType%" equ "Client" call :AddPackage "%InstallMount%\%%i", "%LanguagePacks%\Microsoft-Windows-Client-Refresh-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
			if "%SelectedSourceOS%" equ "w81" if "%ImageInstallationType:~,6%" equ "Server" call :AddPackage "%InstallMount%\%%i", "%LanguagePacks%\Microsoft-Windows-Server-Refresh-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"

			if "%SelectedSourceOS%" equ "w10" (
				if "%ImageInstallationType%" equ "Client" call :AddPackage "%InstallMount%\%%i", "%LanguagePacks%\Microsoft-Windows-Client-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab"
				if "%ImageInstallationType:~,6%" equ "Server" call :AddPackage "%InstallMount%\%%i", "%LanguagePacks%\Microsoft-Windows-Server-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab"

				if exist "%LanguagePacks%\Microsoft-Windows-LanguageFeatures-Basic-%LanguagePackCode%-Package~31bf3856ad364e35~%PackageArchitecture%~~10.0.%PackageBuild%.%PackageServicePackBuild%.cab" (
					echo.-------------------------------------------------------------------------------
					echo.Integrating Windows Language Features - Basic Pack [%LanguagePackCode%]...
					echo.-------------------------------------------------------------------------------
					if "%ImageBuild%" leq "17134" call :AddPackage "%InstallMount%\%%i", "%LanguagePacks%\Microsoft-Windows-LanguageFeatures-Basic-%LanguagePackCode%-Package~31bf3856ad364e35~%PackageArchitecture%~~10.0.%PackageBuild%.%PackageServicePackBuild%.cab"

					if "%ImageBuild%" geq "17763" (
						call :CreateFolder "%Temp%\LanguagePacks"
						copy /y "%LanguagePacks%\Microsoft-Windows-LanguageFeatures-Basic-%LanguagePackCode%-Package~31bf3856ad364e35~%PackageArchitecture%~~10.0.%PackageBuild%.%PackageServicePackBuild%.cab" "%Temp%\LanguagePacks\Microsoft-Windows-LanguageFeatures-Basic-%LanguagePackCode%-Package~31bf3856ad364e35~%PackageArchitecture%~~.cab" >nul
						call :AddPackage "%InstallMount%\%%i", "%Temp%\LanguagePacks\Microsoft-Windows-LanguageFeatures-Basic-%LanguagePackCode%-Package~31bf3856ad364e35~%PackageArchitecture%~~.cab"
					)
				)

				if exist "%LanguagePacks%\Microsoft-Windows-LanguageFeatures-Handwriting-%LanguagePackCode%-Package~31bf3856ad364e35~%PackageArchitecture%~~10.0.%PackageBuild%.%PackageServicePackBuild%.cab" (
					echo.-------------------------------------------------------------------------------
					echo.Integrating Windows Language Features - Handwriting Pack [%LanguagePackCode%]...
					echo.-------------------------------------------------------------------------------
					if "%ImageBuild%" leq "17134" call :AddPackage "%InstallMount%\%%i", "%LanguagePacks%\Microsoft-Windows-LanguageFeatures-Handwriting-%LanguagePackCode%-Package~31bf3856ad364e35~%PackageArchitecture%~~10.0.%PackageBuild%.%PackageServicePackBuild%.cab"

					if "%ImageBuild%" geq "17763" (
						call :CreateFolder "%Temp%\LanguagePacks"
						copy /y "%LanguagePacks%\Microsoft-Windows-LanguageFeatures-Handwriting-%LanguagePackCode%-Package~31bf3856ad364e35~%PackageArchitecture%~~10.0.%PackageBuild%.%PackageServicePackBuild%.cab" "%Temp%\LanguagePacks\Microsoft-Windows-LanguageFeatures-Handwriting-%LanguagePackCode%-Package~31bf3856ad364e35~%PackageArchitecture%~~.cab" >nul
						call :AddPackage "%InstallMount%\%%i", "%Temp%\LanguagePacks\Microsoft-Windows-LanguageFeatures-Handwriting-%LanguagePackCode%-Package~31bf3856ad364e35~%PackageArchitecture%~~.cab"
					)
				)

				if exist "%LanguagePacks%\Microsoft-Windows-LanguageFeatures-OCR-%LanguagePackCode%-Package~31bf3856ad364e35~%PackageArchitecture%~~10.0.%PackageBuild%.%PackageServicePackBuild%.cab" (
					echo.-------------------------------------------------------------------------------
					echo.Integrating Windows Language Features - OCR Pack [%LanguagePackCode%]...
					echo.-------------------------------------------------------------------------------
					if "%ImageBuild%" leq "17134" call :AddPackage "%InstallMount%\%%i", "%LanguagePacks%\Microsoft-Windows-LanguageFeatures-OCR-%LanguagePackCode%-Package~31bf3856ad364e35~%PackageArchitecture%~~10.0.%PackageBuild%.%PackageServicePackBuild%.cab"

					if "%ImageBuild%" geq "17763" (
						call :CreateFolder "%Temp%\LanguagePacks"
						copy /y "%LanguagePacks%\Microsoft-Windows-LanguageFeatures-OCR-%LanguagePackCode%-Package~31bf3856ad364e35~%PackageArchitecture%~~10.0.%PackageBuild%.%PackageServicePackBuild%.cab" "%Temp%\LanguagePacks\Microsoft-Windows-LanguageFeatures-OCR-%LanguagePackCode%-Package~31bf3856ad364e35~%PackageArchitecture%~~.cab" >nul
						call :AddPackage "%InstallMount%\%%i", "%Temp%\LanguagePacks\Microsoft-Windows-LanguageFeatures-OCR-%LanguagePackCode%-Package~31bf3856ad364e35~%PackageArchitecture%~~.cab"
					)
				)

				if exist "%LanguagePacks%\Microsoft-Windows-LanguageFeatures-TextToSpeech-%LanguagePackCode%-Package~31bf3856ad364e35~%PackageArchitecture%~~10.0.%PackageBuild%.%PackageServicePackBuild%.cab" (
					echo.-------------------------------------------------------------------------------
					echo.Integrating Windows Language Features - Text To Speech Pack [%LanguagePackCode%]...
					echo.-------------------------------------------------------------------------------
					if "%ImageBuild%" leq "17134" call :AddPackage "%InstallMount%\%%i", "%LanguagePacks%\Microsoft-Windows-LanguageFeatures-TextToSpeech-%LanguagePackCode%-Package~31bf3856ad364e35~%PackageArchitecture%~~10.0.%PackageBuild%.%PackageServicePackBuild%.cab"

					if "%ImageBuild%" geq "17763" (
						call :CreateFolder "%Temp%\LanguagePacks"
						copy /y "%LanguagePacks%\Microsoft-Windows-LanguageFeatures-TextToSpeech-%LanguagePackCode%-Package~31bf3856ad364e35~%PackageArchitecture%~~10.0.%PackageBuild%.%PackageServicePackBuild%.cab" "%Temp%\LanguagePacks\Microsoft-Windows-LanguageFeatures-TextToSpeech-%LanguagePackCode%-Package~31bf3856ad364e35~%PackageArchitecture%~~.cab" >nul
						call :AddPackage "%InstallMount%\%%i", "%Temp%\LanguagePacks\Microsoft-Windows-LanguageFeatures-TextToSpeech-%LanguagePackCode%-Package~31bf3856ad364e35~%PackageArchitecture%~~.cab"
					)
				)

				if exist "%LanguagePacks%\Microsoft-Windows-LanguageFeatures-Speech-%LanguagePackCode%-Package~31bf3856ad364e35~%PackageArchitecture%~~10.0.%PackageBuild%.%PackageServicePackBuild%.cab" (
					echo.-------------------------------------------------------------------------------
					echo.Integrating Windows Language Features - Speech Pack [%LanguagePackCode%]...
					echo.-------------------------------------------------------------------------------
					if "%ImageBuild%" leq "17134" call :AddPackage "%InstallMount%\%%i", "%LanguagePacks%\Microsoft-Windows-LanguageFeatures-Speech-%LanguagePackCode%-Package~31bf3856ad364e35~%PackageArchitecture%~~10.0.%PackageBuild%.%PackageServicePackBuild%.cab"

					if "%ImageBuild%" geq "17763" (
						call :CreateFolder "%Temp%\LanguagePacks"
						copy /y "%LanguagePacks%\Microsoft-Windows-LanguageFeatures-Speech-%LanguagePackCode%-Package~31bf3856ad364e35~%PackageArchitecture%~~10.0.%PackageBuild%.%PackageServicePackBuild%.cab" "%Temp%\LanguagePacks\Microsoft-Windows-LanguageFeatures-Speech-%LanguagePackCode%-Package~31bf3856ad364e35~%PackageArchitecture%~~.cab" >nul
						call :AddPackage "%InstallMount%\%%i", "%Temp%\LanguagePacks\Microsoft-Windows-LanguageFeatures-Speech-%LanguagePackCode%-Package~31bf3856ad364e35~%PackageArchitecture%~~.cab"
					)
				)
			)

			echo.-------------------------------------------------------------------------------
			echo.Updating Windows Setup language configuration file [Lang.ini]...
			echo.-------------------------------------------------------------------------------
			%DISM% /Image:"%InstallMount%\%%i" /Gen-LangINI /Distribution:"%DVD%"
			echo.
			echo.-------------------------------------------------------------------------------
			echo.Generating Windows Language Packs Integration Log File...
			echo.-------------------------------------------------------------------------------
			echo.
			echo.Writing Windows Language Packs Integration Log...
			call :GetPackages "%InstallMount%\%%i", "LanguagePacks_Install-%%i.txt"
			echo.
		)
	)

	echo.-------------------------------------------------------------------------------
	echo.Integrating [%LanguagePackCode%] Localized Windows Setup resources to Source DVD...
	echo.-------------------------------------------------------------------------------
	echo.
	echo.Extracting Windows Language Pack [%LanguagePackCode%] to Temporary folder...
	call :RemoveFolder "%Temp%\LanguagePack"
	call :CreateFolder "%Temp%\LanguagePack"
	if "%SelectedSourceOS%" equ "w7" if "%ImageInstallationType%" equ "Client" expand "%LanguagePacks%\Microsoft-Windows-Client-Refresh-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab" -f:* "%Temp%\LanguagePack" >nul
	if "%SelectedSourceOS%" equ "w7" if "%ImageInstallationType%" equ "Embedded" expand "%LanguagePacks%\Microsoft-Windows-Embedded-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab" -f:* "%Temp%\LanguagePack" >nul
	if "%SelectedSourceOS%" equ "w7" if "%ImageInstallationType:~,6%" equ "Server" expand "%LanguagePacks%\Microsoft-Windows-Server-Refresh-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab" -f:* "%Temp%\LanguagePack" >nul
	if "%SelectedSourceOS%" equ "w81" if "%ImageInstallationType%" equ "Client" expand "%LanguagePacks%\Microsoft-Windows-Client-Refresh-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab" -f:* "%Temp%\LanguagePack" >nul
	if "%SelectedSourceOS%" equ "w81" if "%ImageInstallationType:~,6%" equ "Server" expand "%LanguagePacks%\Microsoft-Windows-Server-Refresh-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab" -f:* "%Temp%\LanguagePack" >nul
	if "%SelectedSourceOS%" equ "w10" if "%ImageInstallationType%" equ "Client" expand "%LanguagePacks%\Microsoft-Windows-Client-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab" -f:* "%Temp%\LanguagePack" >nul
	if "%SelectedSourceOS%" equ "w10" if "%ImageInstallationType:~,6%" equ "Server" expand "%LanguagePacks%\Microsoft-Windows-Server-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab" -f:* "%Temp%\LanguagePack" >nul
	echo.
	echo.Copying Localized Windows Setup resources files to the Source DVD...
	call :CreateFolder "%DVD%\sources\%LanguagePackCode%"

	if "%SelectedSourceOS%" equ "w7" (
		if "%ImageArchitecture%" equ "x86" call :CreateFolder "%DVD%\sources\dlmanifests\microsoft-windows-iasserver-migplugin\%LanguagePackCode%"
		call :CreateFolder "%DVD%\sources\dlmanifests\microsoft-windows-storagemigration\%LanguagePackCode%"
		call :CreateFolder "%DVD%\sources\etwproviders\%LanguagePackCode%"
		call :CreateFolder "%DVD%\sources\replacementmanifests\microsoft-windows-offlinefiles-core\%LanguagePackCode%"
		call :CreateFolder "%DVD%\sources\replacementmanifests\microsoft-windows-storagemigration\%LanguagePackCode%"
		xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\*.*" "%DVD%\sources\%LanguagePackCode%" >nul
		if "%ImageArchitecture%" equ "x86" xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\dlmanifests\microsoft-windows-iasserver-migplugin\*.*" "%DVD%\sources\dlmanifests\microsoft-windows-iasserver-migplugin\%LanguagePackCode%" >nul
		xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\dlmanifests\microsoft-windows-storagemigration\*.*" "%DVD%\sources\dlmanifests\microsoft-windows-storagemigration\%LanguagePackCode%" >nul
		xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\etwproviders\*.*" "%DVD%\sources\etwproviders\%LanguagePackCode%" >nul
		xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\replacementmanifests\microsoft-windows-offlinefiles-core\*.*" "%DVD%\sources\replacementmanifests\microsoft-windows-offlinefiles-core\%LanguagePackCode%" >nul

		if "%ImageInstallationType%" neq "Embedded" (
			call :CreateFolder "%DVD%\sources\sp1\%LanguagePackCode%"
			call :CreateFolder "%DVD%\sources\sp1\dlmanifests\microsoft-windows-iasserver-migplugin\%LanguagePackCode%"
			call :CreateFolder "%DVD%\sources\sp1\dlmanifests\microsoft-windows-storagemigration\%LanguagePackCode%"
			call :CreateFolder "%DVD%\sources\sp1\etwproviders\%LanguagePackCode%"
			call :CreateFolder "%DVD%\sources\sp1\replacementmanifests\microsoft-windows-offlinefiles-core\%LanguagePackCode%"
			xcopy /y "%Temp%\LanguagePack\sp1\setup\sources\%LanguagePackCode%\*.*" "%DVD%\sources\sp1\%LanguagePackCode%" >nul
			if "%ImageArchitecture%" equ "x86" xcopy /y "%Temp%\LanguagePack\sp1\setup\sources\%LanguagePackCode%\dlmanifests\microsoft-windows-iasserver-migplugin\*.*" "%DVD%\sources\sp1\dlmanifests\microsoft-windows-iasserver-migplugin\%LanguagePackCode%" >nul
			xcopy /y "%Temp%\LanguagePack\sp1\setup\sources\%LanguagePackCode%\dlmanifests\microsoft-windows-storagemigration\*.*" "%DVD%\sources\sp1\dlmanifests\microsoft-windows-storagemigration\%LanguagePackCode%" >nul
			xcopy /y "%Temp%\LanguagePack\sp1\setup\sources\%LanguagePackCode%\etwproviders\*.*" "%DVD%\sources\sp1\etwproviders\%LanguagePackCode%" >nul
			xcopy /y "%Temp%\LanguagePack\sp1\setup\sources\%LanguagePackCode%\replacementmanifests\microsoft-windows-offlinefiles-core\*.*" "%DVD%\sources\sp1\replacementmanifests\microsoft-windows-offlinefiles-core\%LanguagePackCode%" >nul
			echo.Copying Localized Windows Setup license files to the Source DVD...
			call :CreateFolder "%DVD%\sources\license\%LanguagePackCode%"
			call :CreateFolder "%DVD%\sources\sp1\license\%LanguagePackCode%"
			xcopy /y "%Temp%\LanguagePack\sources\license\%LanguagePackCode%\*.*" "%DVD%\sources\license\%LanguagePackCode%" >nul
			xcopy /y "%Temp%\LanguagePack\sp1\sources\license\%LanguagePackCode%\*.*" "%DVD%\sources\sp1\license\%LanguagePackCode%" >nul
		)
	)

	if "%SelectedSourceOS%" equ "w81" (
		if "%ImageInstallationType:~,6%" neq "Server" call :CreateFolder "%DVD%\sources\cli\%LanguagePackCode%"
		if "%ImageArchitecture%" equ "x86" call :CreateFolder "%DVD%\sources\dlmanifests\microsoft-windows-iasserver-migplugin\%LanguagePackCode%"
		call :CreateFolder "%DVD%\sources\dlmanifests\microsoft-windows-storagemigration\%LanguagePackCode%"
		call :CreateFolder "%DVD%\sources\dlmanifests\microsoft-windows-sxs\%LanguagePackCode%"
		call :CreateFolder "%DVD%\sources\etwproviders\%LanguagePackCode%"
		call :CreateFolder "%DVD%\sources\replacementmanifests\microsoft-windows-offlinefiles-core\%LanguagePackCode%"
		call :CreateFolder "%DVD%\sources\replacementmanifests\microsoft-windows-sxs\%LanguagePackCode%"
		xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\*.*" "%DVD%\sources\%LanguagePackCode%" >nul
		if "%ImageInstallationType:~,6%" neq "Server" xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\cli\*.*" "%DVD%\sources\cli\%LanguagePackCode%" >nul
		if "%ImageArchitecture%" equ "x86" xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\dlmanifests\microsoft-windows-iasserver-migplugin\*.*" "%DVD%\sources\dlmanifests\microsoft-windows-iasserver-migplugin\%LanguagePackCode%" >nul
		xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\dlmanifests\microsoft-windows-storagemigration\*.*" "%DVD%\sources\dlmanifests\microsoft-windows-storagemigration\%LanguagePackCode%" >nul
		xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\dlmanifests\microsoft-windows-sxs\*.*" "%DVD%\sources\dlmanifests\microsoft-windows-sxs\%LanguagePackCode%" >nul
		xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\etwproviders\*.*" "%DVD%\sources\etwproviders\%LanguagePackCode%" >nul
		xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\replacementmanifests\microsoft-windows-offlinefiles-core\*.*" "%DVD%\sources\replacementmanifests\microsoft-windows-offlinefiles-core\%LanguagePackCode%" >nul
		xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\replacementmanifests\microsoft-windows-sxs\*.*" "%DVD%\sources\replacementmanifests\microsoft-windows-sxs\%LanguagePackCode%" >nul
	)

	if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" leq "15063" (
		if "%ImageBuild%" leq "10586" if "%ImageInstallationType:~,6%" neq "Server" call :CreateFolder "%DVD%\sources\cli\%LanguagePackCode%"
		if "%ImageArchitecture%" equ "x86" call :CreateFolder "%DVD%\sources\dlmanifests\microsoft-windows-iasserver-migplugin\%LanguagePackCode%"
		call :CreateFolder "%DVD%\sources\dlmanifests\microsoft-windows-shmig-dl\%LanguagePackCode%"
		call :CreateFolder "%DVD%\sources\dlmanifests\microsoft-windows-storagemigration\%LanguagePackCode%"
		call :CreateFolder "%DVD%\sources\dlmanifests\microsoft-windows-sxs\%LanguagePackCode%"
		call :CreateFolder "%DVD%\sources\etwproviders\%LanguagePackCode%"
		if "%ImageBuild%" neq "10240" if "%ImageBuild%" neq "10586" if "%ImageArchitecture%" equ "x64" call :CreateFolder "%DVD%\sources\replacementmanifests\microsoft-windows-fabric-core\%LanguagePackCode%"
		call :CreateFolder "%DVD%\sources\replacementmanifests\microsoft-windows-offlinefiles-core\%LanguagePackCode%"
		call :CreateFolder "%DVD%\sources\replacementmanifests\microsoft-windows-shmig\%LanguagePackCode%"
		call :CreateFolder "%DVD%\sources\replacementmanifests\microsoft-windows-storagemigration\%LanguagePackCode%"
		call :CreateFolder "%DVD%\sources\replacementmanifests\microsoft-windows-sxs\%LanguagePackCode%"
		xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\*.*" "%DVD%\sources\%LanguagePackCode%" >nul
		if "%ImageBuild%" leq "10586" if "%ImageInstallationType:~,6%" neq "Server" xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\cli\*.*" "%DVD%\sources\cli\%LanguagePackCode%" >nul
		if "%ImageArchitecture%" equ "x86" xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\dlmanifests\microsoft-windows-iasserver-migplugin\*.*" "%DVD%\sources\dlmanifests\microsoft-windows-iasserver-migplugin\%LanguagePackCode%" >nul
		xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\dlmanifests\microsoft-windows-shmig-dl\*.*" "%DVD%\sources\dlmanifests\microsoft-windows-shmig-dl\%LanguagePackCode%" >nul
		xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\dlmanifests\microsoft-windows-storagemigration\*.*" "%DVD%\sources\dlmanifests\microsoft-windows-storagemigration\%LanguagePackCode%" >nul
		xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\dlmanifests\microsoft-windows-sxs\*.*" "%DVD%\sources\dlmanifests\microsoft-windows-sxs\%LanguagePackCode%" >nul
		xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\etwproviders\*.*" "%DVD%\sources\etwproviders\%LanguagePackCode%" >nul
		if "%ImageBuild%" neq "10240" if "%ImageBuild%" neq "10586" if "%ImageArchitecture%" equ "x64" xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\replacementmanifests\microsoft-windows-fabric-core\*.*" "%DVD%\sources\replacementmanifests\microsoft-windows-fabric-core\%LanguagePackCode%" >nul
		xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\replacementmanifests\microsoft-windows-offlinefiles-core\*.*" "%DVD%\sources\replacementmanifests\microsoft-windows-offlinefiles-core\%LanguagePackCode%" >nul
		xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\replacementmanifests\microsoft-windows-shmig\*.*" "%DVD%\sources\replacementmanifests\microsoft-windows-shmig\%LanguagePackCode%" >nul
		xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\replacementmanifests\microsoft-windows-storagemigration\*.*" "%DVD%\sources\replacementmanifests\microsoft-windows-storagemigration\%LanguagePackCode%" >nul
		xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\replacementmanifests\microsoft-windows-sxs\*.*" "%DVD%\sources\replacementmanifests\microsoft-windows-sxs\%LanguagePackCode%" >nul
	)

	if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "16299" if "%ImageBuild%" leq "18363" (
		if "%ImageArchitecture%" equ "x86" call :CreateFolder "%DVD%\sources\dlmanifests\microsoft-windows-iasserver-migplugin\%LanguagePackCode%"
		if "%ImageBuild%" leq "17134" call :CreateFolder "%DVD%\sources\dlmanifests\microsoft-windows-storagemigration\%LanguagePackCode%"
		call :CreateFolder "%DVD%\sources\etwproviders\%LanguagePackCode%"
		if "%ImageBuild%" equ "16299" if "%ImageArchitecture%" equ "x64" call :CreateFolder "%DVD%\sources\replacementmanifests\microsoft-windows-fabric-core\%LanguagePackCode%"
		call :CreateFolder "%DVD%\sources\replacementmanifests\microsoft-windows-offlinefiles-core\%LanguagePackCode%"
		call :CreateFolder "%DVD%\sources\replacementmanifests\microsoft-windows-shmig\%LanguagePackCode%"
		if "%ImageBuild%" leq "17134" call :CreateFolder "%DVD%\sources\replacementmanifests\microsoft-windows-storagemigration\%LanguagePackCode%"
		call :CreateFolder "%DVD%\sources\replacementmanifests\microsoft-windows-sxs\%LanguagePackCode%"

		if "%LanguagePackCode%" neq "en-US" (
			xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\*.*" "%DVD%\sources\%LanguagePackCode%" >nul
			if "%ImageArchitecture%" equ "x86" xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\dlmanifests\microsoft-windows-iasserver-migplugin\*.*" "%DVD%\sources\dlmanifests\microsoft-windows-iasserver-migplugin\%LanguagePackCode%" >nul
			if "%ImageBuild%" leq "17134" xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\dlmanifests\microsoft-windows-storagemigration\*.*" "%DVD%\sources\dlmanifests\microsoft-windows-storagemigration\%LanguagePackCode%" >nul
			xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\etwproviders\*.*" "%DVD%\sources\etwproviders\%LanguagePackCode%" >nul
			if "%ImageBuild%" equ "16299" if "%ImageArchitecture%" equ "x64" xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\replacementmanifests\microsoft-windows-fabric-core\*.*" "%DVD%\sources\replacementmanifests\microsoft-windows-fabric-core\%LanguagePackCode%" >nul
			xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\replacementmanifests\microsoft-windows-offlinefiles-core\*.*" "%DVD%\sources\replacementmanifests\microsoft-windows-offlinefiles-core\%LanguagePackCode%" >nul
			xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\replacementmanifests\microsoft-windows-shmig\*.*" "%DVD%\sources\replacementmanifests\microsoft-windows-shmig\%LanguagePackCode%" >nul
			if "%ImageBuild%" leq "17134" xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\replacementmanifests\microsoft-windows-storagemigration\*.*" "%DVD%\sources\replacementmanifests\microsoft-windows-storagemigration\%LanguagePackCode%" >nul
			xcopy /y "%Temp%\LanguagePack\setup\sources\%LanguagePackCode%\replacementmanifests\microsoft-windows-sxs\*.*" "%DVD%\sources\replacementmanifests\microsoft-windows-sxs\%LanguagePackCode%" >nul
		)

		if "%LanguagePackCode%" equ "en-US" (
			xcopy /y "%Temp%\LanguagePack\setup\sources\*.*" "%DVD%\sources\%LanguagePackCode%" >nul
			if "%ImageArchitecture%" equ "x86" xcopy /y "%Temp%\LanguagePack\setup\sources\dlmanifests\microsoft-windows-iasserver-migplugin\*.*" "%DVD%\sources\dlmanifests\microsoft-windows-iasserver-migplugin\%LanguagePackCode%" >nul
			if "%ImageBuild%" leq "17134" xcopy /y "%Temp%\LanguagePack\setup\sources\dlmanifests\microsoft-windows-storagemigration\*.*" "%DVD%\sources\dlmanifests\microsoft-windows-storagemigration\%LanguagePackCode%" >nul
			xcopy /y "%Temp%\LanguagePack\setup\sources\etwproviders\*.*" "%DVD%\sources\etwproviders\%LanguagePackCode%" >nul
			if "%ImageBuild%" equ "16299" if "%ImageArchitecture%" equ "x64" xcopy /y "%Temp%\LanguagePack\setup\sources\replacementmanifests\microsoft-windows-fabric-core\*.*" "%DVD%\sources\replacementmanifests\microsoft-windows-fabric-core\%LanguagePackCode%" >nul
			xcopy /y "%Temp%\LanguagePack\setup\sources\replacementmanifests\microsoft-windows-offlinefiles-core\*.*" "%DVD%\sources\replacementmanifests\microsoft-windows-offlinefiles-core\%LanguagePackCode%" >nul
			xcopy /y "%Temp%\LanguagePack\setup\sources\replacementmanifests\microsoft-windows-shmig\*.*" "%DVD%\sources\replacementmanifests\microsoft-windows-shmig\%LanguagePackCode%" >nul
			if "%ImageBuild%" leq "17134" xcopy /y "%Temp%\LanguagePack\setup\sources\replacementmanifests\microsoft-windows-storagemigration\*.*" "%DVD%\sources\replacementmanifests\microsoft-windows-storagemigration\%LanguagePackCode%" >nul
			xcopy /y "%Temp%\LanguagePack\setup\sources\replacementmanifests\microsoft-windows-sxs\*.*" "%DVD%\sources\replacementmanifests\microsoft-windows-sxs\%LanguagePackCode%" >nul
		)
	)
	echo.
)

if "%LanguagePackType%" equ "Recovery" (
	for /l %%i in (1, 1, %ImageCount%) do (
		if exist "%WinReMount%\%%i" (
			if not %%i gtr 9 echo.=====================[Install.wim, Index : %%i -^> WinRE.wim]=====================
			if %%i gtr 9 echo.=====================[Install.wim, Index : %%i -^> WinRE.wim]===================
			echo.
			echo.-------------------------------------------------------------------------------
			echo.Integrating WinPE Language Pack [%LanguagePackCode%] to Windows Recovery Image...
			echo.-------------------------------------------------------------------------------
			if "%SelectedSourceOS%" equ "w7" call :AddPackage "%WinReMount%\%%i", "%LanguagePacks%\Microsoft-Windows-WinPE-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab"
			if "%SelectedSourceOS%" equ "w81" call :AddPackage "%WinReMount%\%%i", "%LanguagePacks%\Microsoft-Windows-WinPE-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
		
			if "%SelectedSourceOS%" equ "w10" (
				call :AddPackage "%WinReMount%\%%i", "%LanguagePacks%\Microsoft-Windows-WinPE-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab"
			
				if "%ImageBuild%" geq "17134" (
					if exist "%LanguagePacks%\Microsoft-Windows-WinPE-AppxPackaging-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab" (
						echo.-------------------------------------------------------------------------------
						echo.Integrating WinPE - Appx Packaging [%LanguagePackCode%] to Windows Recovery Image...
						echo.-------------------------------------------------------------------------------
						call :AddPackage "%WinReMount%\%%i", "%LanguagePacks%\Microsoft-Windows-WinPE-AppxPackaging-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab"
					)
				
					if exist "%LanguagePacks%\Microsoft-Windows-WinPE-OpcServices-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab" (
						echo.-------------------------------------------------------------------------------
						echo.Integrating WinPE - Opc Services [%LanguagePackCode%] to Windows Recovery Image...
						echo.-------------------------------------------------------------------------------
						call :AddPackage "%WinReMount%\%%i", "%LanguagePacks%\Microsoft-Windows-WinPE-OpcServices-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab"
					)
				
					echo.-------------------------------------------------------------------------------
					echo.Integrating WinPE - Appx Packaging [%LanguagePackCode%] to Windows Recovery Image...
					echo.-------------------------------------------------------------------------------
					call :AddPackage "%WinReMount%\%%i", "%LanguagePacks%\WinPE-AppxPackaging-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab"
				)

				if "%ImageBuild%" geq "15063" (
					echo.-------------------------------------------------------------------------------
					echo.Integrating WinPE - AT Broker [%LanguagePackCode%] to Windows Recovery Image...
					echo.-------------------------------------------------------------------------------
					call :AddPackage "%WinReMount%\%%i", "%LanguagePacks%\WinPE-ATBroker-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab"
					echo.-------------------------------------------------------------------------------
					echo.Integrating WinPE - Audio Core [%LanguagePackCode%] to Windows Recovery Image...
					echo.-------------------------------------------------------------------------------
					call :AddPackage "%WinReMount%\%%i", "%LanguagePacks%\WinPE-AudioCore-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab"
					echo.-------------------------------------------------------------------------------
					echo.Integrating WinPE - Audio Drivers [%LanguagePackCode%] to Windows Recovery Image...
					echo.-------------------------------------------------------------------------------
					call :AddPackage "%WinReMount%\%%i", "%LanguagePacks%\WinPE-AudioDrivers-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab"
				)
			)
		
			if "%SelectedSourceOS%" neq "w7" (
				echo.-------------------------------------------------------------------------------
				echo.Integrating WinPE - Enhanced Storage Pack [%LanguagePackCode%] to Windows Recovery Image...
				echo.-------------------------------------------------------------------------------
				if "%SelectedSourceOS%" equ "w81" call :AddPackage "%WinReMount%\%%i", "%LanguagePacks%\WinPE-EnhancedStorage-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
				if "%SelectedSourceOS%" equ "w10" call :AddPackage "%WinReMount%\%%i", "%LanguagePacks%\WinPE-EnhancedStorage-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab"
			)
		
			if "%SelectedSourceOS%" equ "w81" if exist "%LanguagePacks%\WinPE-IbsProvider-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab" (
				echo.-------------------------------------------------------------------------------
				echo.Integrating WinPE - IBS Provider Pack [%LanguagePackCode%] to Windows Recovery Image...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%WinReMount%\%%i", "%LanguagePacks%\WinPE-IbsProvider-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
			)
	
			if "%SelectedSourceOS%" equ "w10" (
				echo.-------------------------------------------------------------------------------
				echo.Integrating WinPE - HTA Pack [%LanguagePackCode%] to Windows Recovery Image...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%WinReMount%\%%i", "%LanguagePacks%\WinPE-HTA-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab"
			
				if "%ImageBuild%" geq "15063" (
					echo.-------------------------------------------------------------------------------
					echo.Integrating WinPE - Narrator [%LanguagePackCode%] to Windows Recovery Image...
					echo.-------------------------------------------------------------------------------
					call :AddPackage "%WinReMount%\%%i", "%LanguagePacks%\WinPE-Narrator-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab"
				)
		
				if "%ImageBuild%" geq "17134" (
					echo.-------------------------------------------------------------------------------
					echo.Integrating WinPE - Opc Services [%LanguagePackCode%] to Windows Recovery Image...
					echo.-------------------------------------------------------------------------------
					call :AddPackage "%WinReMount%\%%i", "%LanguagePacks%\WinPE-OpcServices-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab"
				)
			)
		
			if "%SelectedSourceOS%" neq "w7" (
				echo.-------------------------------------------------------------------------------
				echo.Integrating WinPE - Rejuv Pack [%LanguagePackCode%] to Windows Recovery Image...
				echo.-------------------------------------------------------------------------------
				if "%SelectedSourceOS%" equ "w81" call :AddPackage "%WinReMount%\%%i", "%LanguagePacks%\WinPE-Rejuv-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
				if "%SelectedSourceOS%" equ "w10" call :AddPackage "%WinReMount%\%%i", "%LanguagePacks%\WinPE-Rejuv-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab"
			)
		
			echo.-------------------------------------------------------------------------------
			echo.Integrating WinPE - Scripting Pack [%LanguagePackCode%] to Windows Recovery Image...
			echo.-------------------------------------------------------------------------------
			if "%SelectedSourceOS%" equ "w7" call :AddPackage "%WinReMount%\%%i", "%LanguagePacks%\WinPE-Scripting-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab"
			if "%SelectedSourceOS%" equ "w81" call :AddPackage "%WinReMount%\%%i", "%LanguagePacks%\WinPE-Scripting-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
			if "%SelectedSourceOS%" equ "w10" call :AddPackage "%WinReMount%\%%i", "%LanguagePacks%\WinPE-Scripting-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab"

			if "%SelectedSourceOS%" neq "w7" (
				echo.-------------------------------------------------------------------------------
				echo.Integrating WinPE - Secure Startup Pack [%LanguagePackCode%] to Windows Recovery Image...
				echo.-------------------------------------------------------------------------------
				if "%SelectedSourceOS%" equ "w81" call :AddPackage "%WinReMount%\%%i", "%LanguagePacks%\WinPE-SecureStartup-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
				if "%SelectedSourceOS%" equ "w10" call :AddPackage "%WinReMount%\%%i", "%LanguagePacks%\WinPE-SecureStartup-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab"
			)
		
			if "%SelectedSourceOS%" equ "w7" (
				echo.-------------------------------------------------------------------------------
				echo.Integrating WinPE - Setup Pack [%LanguagePackCode%] to Windows Recovery Image...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%WinReMount%\%%i", "%LanguagePacks%\WinPE-Setup-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab"
				echo.-------------------------------------------------------------------------------
				echo.Integrating WinPE - Setup Client Pack [%LanguagePackCode%] to Windows Recovery Image...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%WinReMount%\%%i", "%LanguagePacks%\WinPE-Setup-Client-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab"
			)
		
			if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "15063" if "%ImageBuild%" leq "17134" (
				for /d %%z in (de-DE, en-GB, en-IN, es-ES, es-MX, fr-CA, fr-FR, it-IT, ja-JP, ko-KR, pl-PL, pt-BR, pt-PT, ru-RU, zh-CN, zh-HK, zh-TW) do (
					if "%LanguagePackCode%" equ "%%z" (
						echo.-------------------------------------------------------------------------------
						echo.Integrating WinPE - Speech TextToSpeech [%LanguagePackCode%] to Windows Recovery Image...
						echo.-------------------------------------------------------------------------------
						call :AddPackage "%WinReMount%\%%i", "%LanguagePacks%\WinPE-Speech-TTS-%LanguagePackCode%-Package~31bf3856ad364e35~%PackageArchitecture%~~10.0.%PackageBuild%.%PackageServicePackBuild%.cab"
					)
				)
			)
		
			if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "15063" (
				echo.-------------------------------------------------------------------------------
				echo.Integrating WinPE - Speech TextToSpeech [%LanguagePackCode%] to Windows Recovery Image...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%WinReMount%\%%i", "%LanguagePacks%\WinPE-Speech-TTS-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab"
				echo.-------------------------------------------------------------------------------
				echo.Integrating WinPE - SRH [%LanguagePackCode%] to Windows Recovery Image...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%WinReMount%\%%i", "%LanguagePacks%\WinPE-SRH-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab"
			)
	
			echo.-------------------------------------------------------------------------------
			echo.Integrating WinPE - SRT Pack [%LanguagePackCode%] to Windows Recovery Image...
			echo.-------------------------------------------------------------------------------
			if "%SelectedSourceOS%" equ "w7" call :AddPackage "%WinReMount%\%%i", "%LanguagePacks%\WinPE-SRT-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab"
			if "%SelectedSourceOS%" equ "w81" call :AddPackage "%WinReMount%\%%i", "%LanguagePacks%\WinPE-SRT-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
			if "%SelectedSourceOS%" equ "w10" call :AddPackage "%WinReMount%\%%i", "%LanguagePacks%\WinPE-SRT-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab"
	
			if "%SelectedSourceOS%" neq "w7" (
				echo.-------------------------------------------------------------------------------
				echo.Integrating WinPE - Storage WMI Pack [%LanguagePackCode%] to Windows Recovery Image...
				echo.-------------------------------------------------------------------------------
				if "%SelectedSourceOS%" equ "w81" call :AddPackage "%WinReMount%\%%i", "%LanguagePacks%\WinPE-StorageWMI-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
				if "%SelectedSourceOS%" equ "w10" call :AddPackage "%WinReMount%\%%i", "%LanguagePacks%\WinPE-StorageWMI-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab"
			)
	
			echo.-------------------------------------------------------------------------------
			echo.Integrating WinPE - WDS Pack [%LanguagePackCode%] to Windows Recovery Image...
			echo.-------------------------------------------------------------------------------
			if "%SelectedSourceOS%" equ "w7" call :AddPackage "%WinReMount%\%%i", "%LanguagePacks%\WinPE-WDS-Tools-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab"
			if "%SelectedSourceOS%" equ "w81" call :AddPackage "%WinReMount%\%%i", "%LanguagePacks%\WinPE-WDS-Tools-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
			if "%SelectedSourceOS%" equ "w10" call :AddPackage "%WinReMount%\%%i", "%LanguagePacks%\WinPE-WDS-Tools-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab"

			if "%SelectedSourceOS%" equ "w10" if exist "%LanguagePacks%\WinPE-WiFi-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab" (
				echo.-------------------------------------------------------------------------------
				echo.Integrating WinPE - WiFi Pack [%LanguagePackCode%] to Windows Recovery Image...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%WinReMount%\%%i", "%LanguagePacks%\WinPE-WiFi-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab"
			)

			echo.-------------------------------------------------------------------------------
			echo.Integrating WinPE - WMI Pack [%LanguagePackCode%] to Windows Recovery Image...
			echo.-------------------------------------------------------------------------------
			if "%SelectedSourceOS%" equ "w7" call :AddPackage "%WinReMount%\%%i", "%LanguagePacks%\WinPE-WMI-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab"
			if "%SelectedSourceOS%" equ "w81" call :AddPackage "%WinReMount%\%%i", "%LanguagePacks%\WinPE-WMI-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
			if "%SelectedSourceOS%" equ "w10" call :AddPackage "%WinReMount%\%%i", "%LanguagePacks%\WinPE-WMI-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab"
			
			for /d %%z in (ja-JP, ko-KR, zh-HK, zh-CN, zh-TW) do (
				if "%LanguagePackCode%" equ "%%z" (
					echo.-------------------------------------------------------------------------------
					echo.Integrating WinPE - Font Support Pack [%LanguagePackCode%] to Windows Recovery Image...
					echo.-------------------------------------------------------------------------------
					if "%SelectedSourceOS%" equ "w7" call :AddPackage "%WinReMount%\%%i", "%LanguagePacks%\WinPE-FontSupport-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.1.7601.%PackageServicePackBuild%.cab"
					if "%SelectedSourceOS%" equ "w81" call :AddPackage "%WinReMount%\%%i", "%LanguagePacks%\WinPE-FontSupport-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~6.3.9600.%PackageServicePackBuild%.cab"
					if "%SelectedSourceOS%" equ "w10" call :AddPackage "%WinReMount%\%%i", "%LanguagePacks%\WinPE-FontSupport-Package~31bf3856ad364e35~%PackageArchitecture%~%LanguagePackCode%~10.0.%PackageBuild%.%PackageServicePackBuild%.cab"
				)
			)

			echo.-------------------------------------------------------------------------------
			echo.Generating Windows Recovery Language Packs Integration Log File...
			echo.-------------------------------------------------------------------------------
			echo.
			echo.Writing Windows Recovery Language Packs Integration Log...
			echo.
			call :GetPackages "%WinReMount%\%%i", "LanguagePacks_Install_WinRE.txt"
		)
	)
)

echo.-------------------------------------------------------------------------------
echo.####Cleaning Up Temporary Files ^& Folders######################################
echo.-------------------------------------------------------------------------------
echo.
echo.Cleaning Up Temporary folder...
call :RemoveFolder "%Temp%\LanguagePacks"
echo.
echo.-------------------------------------------------------------------------------
if "%LanguagePackType%" equ "Boot" echo.####Finished Integrating Windows Language Packs to Windows Boot Image##########
if "%LanguagePackType%" equ "Install" echo.####Finished Integrating Windows Language Packs to Windows Installation Image##
if "%LanguagePackType%" equ "Recovery" echo.####Finished Integrating Windows Language Packs to Windows Reocvery Image######
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set LanguagePacks=
set LanguagePackType=
set LanguagePackCode=
set PackageArchitecture=
set PackageBuild=
set PackageServicePackBuild=

endlocal

:: Returning to Integrate Language Packs Menu
goto :IntLanguagePacksMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Integrate Windows Drivers Menu
::-------------------------------------------------------------------------------------------
:IntDriversMenu

setlocal

set DriverType=

cls
echo.===============================================================================
echo.              MSMG ToolKit - Integrer le menu des pilotes Windows 
echo.===============================================================================
echo.
echo.  [1]   Integrer a l'image de demarrage de l'installation de Windows
echo.
echo.  [2]   Integrer a l'image d'installation Windows
echo.
echo.  [3]   Integrer a l'image de recuperation Windows 
echo.
echo.
echo.
echo.
echo.
echo.
echo.
echo.
echo.
echo.
echo.  [X]   Retour
echo.
echo.===============================================================================
echo.
choice /C:123X /N /M "Entrer votre choix : "
if errorlevel 4 goto :IntegrateMenu
if errorlevel 3 set DriverType=Recovery
if errorlevel 2 set DriverType=Install
if errorlevel 1 set DriverType=Boot

cls
echo.===============================================================================
if "%DriverType%" equ "Boot" echo.     MSMG ToolKit - Integrer les pilotes Windows a l'image de demarrage de l'installation de Windows 
if "%DriverType%" equ "Install" echo.    MSMG ToolKit - Integrer les pilotes Windows a l'image d'installation Windows 
if "%DriverType%" equ "Recovery" echo.      MSMG ToolKit - Integrer les pilotes Windows a l'image de recuperation Windows 
echo.===============================================================================
echo.

if "%DriverType%" equ "Boot" if "%IsBootImageSelected%" equ "No" (
	echo.L'image de demarrage de l'installation de Windows n'est pas sélectionnee. 
	echo.
	echo.Veuillez choisir l'image de demarrage du programme d'installation 
	echo.de Windows en selectionnant Source. 
	goto :Stop
)

if "%DriverType%" equ "Recovery" if "%IsRecoveryImageSelected%" equ "No" (
	echo.L'image de recuperation Windows n'est pas selectionnee.
	echo.
	echo.Veuillez choisir l'image de recuperation Windows en selectionnant Source. 
	goto :Stop
)

:: Getting Source Image Index Architecture
if "%DriverType%" equ "Boot" call :GetImageArchitecture "%BootWim%", 1 >nul

if "%DriverType%" equ "Install" (
	for /l %%i in (1, 1, %ImageCount%) do (
		if exist "%InstallMount%\%%i" call :GetImageArchitecture "%InstallWim%", %%i >nul
	)
)

if "%DriverType%" equ "Recovery" (
	for /l %%i in (1, 1, %ImageCount%) do (
		if exist "%WinReMount%\%%i" call :GetImageArchitecture "%WinReMount%\%%i\%WinReWim%", 1 >nul
	)
)

:: Settings Windows Drivers folder path
if "%DriverType%" equ "Boot" set "Drivers=%Drivers%\WinPE\%SelectedSourceOS%\%ImageArchitecture%"
if "%DriverType%" equ "Install" set "Drivers=%Drivers%\Install\%SelectedSourceOS%\%ImageArchitecture%"
if "%DriverType%" equ "Recovery" set "Drivers=%Drivers%\WinPE\%SelectedSourceOS%\%ImageArchitecture%"

:: Checking whether Windows Drivers folder is empty
for /f %%i in ('dir /b /s /a:-d "%Drivers%\*.*" 2^>nul ^| find /v /c ""') do (
	if "%%i" equ "0" (
		if "%DriverType%" equ "Boot" echo.Le dossier Pilotes Windows ^<Drivers\WinPE\%SelectedSourceOS%\%ImageArchitecture%^> est vide.
		if "%DriverType%" equ "Install" echo.Le dossier Pilotes Windows ^<Drivers\Install\%SelectedSourceOS%\%ImageArchitecture%^> est vide.
		if "%DriverType%" equ "Recovery" echo.Le dossier Pilotes Windows ^<Drivers\WinPE\%SelectedSourceOS%\%ImageArchitecture%^> est vide.
		echo.
		echo.Veuillez copier les fichiers des pilotes Windows dans le dossier respectif. 
		goto :Stop
	)
)

echo.-------------------------------------------------------------------------------
if "%DriverType%" equ "Boot" echo.####Demarrage de l'integration des pilotes Windows a l'image de demarrage Windows ##############
if "%DriverType%" equ "Install" echo.####Demarrage de l’integration des pilotes Windows a l’image d’installation Windows #########
if "%DriverType%" equ "Recovery" echo.####Demarrage de l'integration des pilotes Windows a l'image de recuperation Windows #######
echo.-------------------------------------------------------------------------------
echo.
if "%DriverType%" equ "Boot" (
	echo.    Image                    : Boot.wim
	echo.    Image Index              : 2
)
if "%DriverType%" equ "Install" (
	echo.    Image                    : Install.wim
	if /i "%ImageIndexNo%" equ "A" echo.    Image Indexes            : 1-%ImageCount%
	if /i "%ImageIndexNo%" neq "A" echo.    Image Index              : %ImageIndexNo%
)
if "%DriverType%" equ "Recovery" (
	echo.    Image                    : WinRE.wim
	echo.    Image Index              : 1
)
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
echo.
echo.-------------------------------------------------------------------------------
if "%DriverType%" equ "Boot" echo.####Integration des pilotes Windows a l'image de demarrage Windows ##########################
if "%DriverType%" equ "Install" echo.####Integration des pilotes Windows a l'image d'installation Windows ##################
if "%DriverType%" equ "Recovery" echo.####Integration des pilotes Windows a l'image de recuperation Windows ######################
echo.-------------------------------------------------------------------------------

if "%DriverType%" equ "Boot" (
	echo.
	echo.=============================[Boot.wim, Index : 2]=============================
	call :AddDriver "%BootMount%\2", "%Drivers%"
)

if "%DriverType%" equ "Install" (
	for /l %%i in (1, 1, %ImageCount%) do (
		if exist "%InstallMount%\%%i" (
			echo.
			if not %%i gtr 9 echo.===========================[Install.wim, Index : %%i]============================
			if %%i gtr 9 echo.==========================[Install.wim, Index : %%i]============================
			call :AddDriver "%InstallMount%\%%i", "%Drivers%"
		)
	)
)

if "%DriverType%" equ "Recovery" (
	for /l %%i in (1, 1, %ImageCount%) do (
		if exist "%WinReMount%\%%i" (
			echo.
			if not %%i gtr 9 echo.=====================[Install.wim, Index : %%i -^> WinRE.wim]=====================
			if %%i gtr 9 echo.=====================[Install.wim, Index : %%i -^> WinRE.wim]===================
			call :AddDriver "%WinReMount%\%%i", "%Drivers%"
		)
	)
)

echo.-------------------------------------------------------------------------------
if "%DriverType%" equ "Boot" echo.####Fin de l'integration des pilotes Windows a l'image de demarrage Windows #################
if "%DriverType%" equ "Install" echo.####Fin de l'Integration des pilotes Windows a l'image d'installation Windows terminee #########
if "%DriverType%" equ "Recovery" echo.####Fin de l'integration des pilotes Windows a l'image Windows Reocvery #############
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set Drivers=
set DriverType=

endlocal

:: Returning to Integrate Drivers Menu
goto :IntDriversMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Integrate Microsoft .NET Framework 3.5
::-------------------------------------------------------------------------------------------
:IntNetFX35

setlocal

set PackageArchitecture=

cls
echo.===============================================================================
echo.            MSMG ToolKit - Integrate Microsoft .NET Framework 3.5
echo.===============================================================================
echo.

:: Getting Install Image Index Architecture
for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" call :GetImageArchitecture "%InstallWim%", %%i >nul
)

:: Setting Package Service Pack Build
if "%SelectedSourceOS%" equ "w10" (
	if "%ImageBuild%" equ "10240" set "PackageServicePackBuild=16384"
	if "%ImageBuild%" equ "10586" set "PackageServicePackBuild=0"
	if "%ImageBuild%" equ "14393" set "PackageServicePackBuild=0"
	if "%ImageBuild%" equ "15063" set "PackageServicePackBuild=0"
	if "%ImageBuild%" equ "16299" set "PackageServicePackBuild=15"
	if "%ImageBuild%" equ "17134" set "PackageServicePackBuild=1"
	if "%ImageBuild%" equ "17763" set "PackageServicePackBuild=1"
	if "%ImageBuild%" equ "18362" set "PackageServicePackBuild=1"
	if "%ImageBuild%" equ "18363" set "PackageServicePackBuild=1"
	if "%ImageBuild%" equ "19041" set "PackageServicePackBuild=1"
	if "%ImageBuild%" equ "19042" set "PackageServicePackBuild=1"
)

:: Setting Package Architecture
if "%ImageArchitecture%" equ "x86" set "PackageArchitecture=x86"
if "%ImageArchitecture%" equ "x64" set "PackageArchitecture=amd64"
if "%ImageArchitecture%" equ "arm" set "PackageArchitecture=arm"
if "%ImageArchitecture%" equ "arm64" set "PackageArchitecture=arm64"

:: Setting Microsoft .NET Framework 3.5 Feature Pack folder path according to Source Image Architecture
if exist "%DVD%\sources\sxs" (
	if "%SelectedSourceOS%" equ "w81" set "NetFX35=%DVD%\sources\sxs"
	if "%SelectedSourceOS%" equ "w10" (
		if "%ImageBuild%" leq "16299" set "NetFX35=%DVD%\sources\sxs\microsoft-windows-netfx3-ondemand-package.cab"
		if "%ImageBuild%" geq "17134" set "NetFX35=%DVD%\sources\sxs\microsoft-windows-netfx3-ondemand-package~31bf3856ad364e35~%PackageArchitecture%~~.cab"
	)
) else (
	if "%SelectedSourceOS%" equ "w81" set "NetFX35=%NetFX35%\%SelectedSourceOS%\%ImageArchitecture%"
	if "%SelectedSourceOS%" equ "w10" set "NetFX35=%NetFX35%\%SelectedSourceOS%\10.0.%ImageBuild%\Microsoft-Windows-NetFx3-OnDemand-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab"
)

:: Checking whether Microsoft .NET Framework 3.5 Feature Pack folder exist
if "%SelectedSourceOS%" equ "w81" if not exist "%NetFX35%\msil_system.net_b03f5f7f11d50a3a_6.3.9600.16384_none_78f2900af99c8442\system.net.dll" (
	echo.Microsoft .NET Framework 3.5 Pack folder is missing or empty...
	echo.
	echo.Please copy the files to ^<Packs\NetFX35\w81\%ImageArchitecture%^> folder...
	echo.
	goto :Stop
)

:: Checking whether Microsoft .NET Framework 3.5 Feature Pack folder exist
if "%SelectedSourceOS%" equ "w10" if not exist %NetFX35% (
	echo.Microsoft .NET Framework 3.5 Pack file is missing...
	echo.
	if "%ImageBuild%" leq "16299" echo.Either copy the "microsoft-windows-netfx3-ondemand-package.cab" file from Source DVD to ^<DVD\sources\sxs^> folder
	if "%ImageBuild%" geq "17134" echo.Either copy the "microsoft-windows-netfx3-ondemand-package~31bf3856ad364e35~%PackageArchitecture%~~.cab" from Source DVD to ^<DVD\sources\sxs^> folder
	echo.
	echo.or Copy the below ToolKit Pack file to ^<Packs\NetFX35\%SelectedSourceOS%\10.0.%ImageBuild%^> folder..
	echo.
	echo."Microsoft-Windows-NetFx3-OnDemand-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab"
	echo.
	goto :Stop
)

if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "17763" if "%NetFX35%" neq "%DVD%\sources\sxs\microsoft-windows-netfx3-ondemand-package~31bf3856ad364e35~%PackageArchitecture%~~.cab" if exist %NetFX35% (
	copy /y %NetFX35% "%Temp%\microsoft-windows-netfx3-ondemand-package~31bf3856ad364e35~%PackageArchitecture%~~.cab" >nul
	set "NetFX35=%Temp%\microsoft-windows-netfx3-ondemand-package~31bf3856ad364e35~%PackageArchitecture%~~.cab"
)

echo.-------------------------------------------------------------------------------
echo.####Starting Integrating Microsoft .NET Framework 3.5##########################
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    : Install.wim
if /i "%ImageIndexNo%" equ "A" echo.    Image Indexes            : 1-%ImageCount%
if /i "%ImageIndexNo%" neq "A" echo.    Image Index              : %ImageIndexNo%
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
echo.
echo.-------------------------------------------------------------------------------
echo.####Integrating Microsoft .NET Framework 3.5###################################
echo.-------------------------------------------------------------------------------

for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" (
		echo.
		if not %%i gtr 9 echo.===========================[Install.wim, Index : %%i]============================
		if %%i gtr 9 echo.==========================[Install.wim, Index : %%i]============================
		echo.
		echo.-------------------------------------------------------------------------------
		echo.Checking whether Microsoft .NET Framework 3.5 is enabled...
		echo.-------------------------------------------------------------------------------
		echo.
		if "%SelectedSourceOS%" equ "w81" (
			%DISM% /Image:"%InstallMount%\%%i" /Get-FeatureInfo /FeatureName:NetFX3 | findstr /c:"State : Enable Pending" >nul
			if errorlevel 1 (
				echo.Microsoft .NET Framework 3.5 is not enabled.
				echo.
				echo.-------------------------------------------------------------------------------
				echo.Integrating Microsoft .NET Framework 3.5 Package...
				echo.-------------------------------------------------------------------------------
				%DISM% /Image:"%InstallMount%\%%i" /Enable-Feature /All /LimitAccess /FeatureName:NetFX3 /Source:%NetFX35%
				echo.
			) else (
				echo.Microsoft .NET Framework 3.5 has already been enabled.
			)
		)
		if "%SelectedSourceOS%" equ "w10" (
			%DISM% /Image:"%InstallMount%\%%i" /Get-FeatureInfo /FeatureName:NetFx3 | findstr /c:"State : Enabled" >nul
			if errorlevel 1 (
				echo.Microsoft .NET Framework 3.5 is not enabled.
				echo.
				echo.-------------------------------------------------------------------------------
				echo.Integrating Microsoft .NET Framework 3.5 Package...
				echo.-------------------------------------------------------------------------------
				%DISM% /Image:"%InstallMount%\%%i" /Add-Package:%NetFX35%
				echo.
			) else (
				echo.Microsoft .NET Framework 3.5 has already been enabled.
			)
		)
	)
)

call :RemoveFile "%Temp%\microsoft-windows-netfx3-ondemand-package~31bf3856ad364e35~%PackageArchitecture%~~.cab"

echo.
echo.-------------------------------------------------------------------------------
echo.####Finished Integrating Microsoft .NET Framework 3.5##########################
echo.-------------------------------------------------------------------------------
echo.

:Stop
echo.===============================================================================
echo.
pause

set NetFX35=
set PackageArchitecture=
set PackageServicePackBuild=

endlocal

:: Returning to Integrate Features Menu
goto :IntFeaturesMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Integrate Microsoft .NET Framework 4.6.2 for Windows 10 v1507 & v1511 Source OS
::-------------------------------------------------------------------------------------------
:IntNetFX462

setlocal

cls
echo.===============================================================================
echo.           MSMG ToolKit - Integrate Microsoft .NET Framework 4.6.2
echo.===============================================================================
echo.

:: Getting Install Image Index Architecture
for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" call :GetImageArchitecture "%InstallWim%", %%i >nul
)

:: Setting Image Package Architecture
if "%ImageArchitecture%" equ "x86" set "PackageArchitecture=x86"
if "%ImageArchitecture%" equ "x64" set "PackageArchitecture=amd64"

:: Checking whether Microsoft .NET Framework 4.6.2 Pack file exist
if not exist "%NetFX462%\Microsoft-Windows-NetFX462-Package~31bf3856ad364e35~%PackageArchitecture%.cab" (
	echo.Microsoft .NET Framework 4.6.2 Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-NetFX462-Package~31bf3856ad364e35~%PackageArchitecture%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\NetFX462^> folder...
	goto :Stop
)

:: Checking whether Microsoft .NET Framework 4.6.2 Pack file exist
if "%ImageBuild%" equ "10240" if "%ImageEdition%" neq "Core" if "%ImageEdition%" neq "CoreN" if "%ImageEdition%" neq "CoreSingleLanguage" if "%ImageEdition%" neq "Education" if "%ImageEdition%" neq "EducationN" if "%ImageEdition%" neq "Professional" if "%ImageEdition%" neq "ProfessionalN" if "%ImageEdition%" neq "Enterprise" if "%ImageEdition%" neq "EnterpriseN" (
	if not exist "%NetFX462%\Windows10.0-KB4051600-%ImageArchitecture%.cab" (
		echo.Microsoft .NET Framework 4.6.2 Pack folder is missing the below file...
		echo.
		echo."Windows10.0-KB4051600-%ImageArchitecture%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\NetFX462^> folder...
		goto :Stop
	)
)

:: Checking whether Microsoft .NET Framework 4.6.2 Pack file exist
if "%ImageBuild%" equ "10586" if "%ImageEdition%" neq "Core" if "%ImageEdition%" neq "CoreN" if "%ImageEdition%" neq "CoreSingleLanguage" if "%ImageEdition%" neq "Professional" if "%ImageEdition%" neq "ProfessionalN" (
	if not exist "%NetFX462%\Windows10.0-KB4054057-%ImageArchitecture%.cab" (
		echo.Microsoft .NET Framework 4.6.2 Pack folder is missing the below file...
		echo.
		echo."Windows10.0-KB4054057-%ImageArchitecture%.cab""
		echo.
		echo.Please copy the above file to ^<Packs\NetFX462^> folder...
		goto :Stop
	)
)

echo.-------------------------------------------------------------------------------
echo.####Starting Integrating Microsoft .NET Framework 4.6.2########################
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    : Install.wim
if /i "%ImageIndexNo%" equ "A" echo.    Image Indexes            : 1-%ImageCount%
if /i "%ImageIndexNo%" neq "A" echo.    Image Index              : %ImageIndexNo%
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
echo.
echo.-------------------------------------------------------------------------------
echo.####Integrating Microsoft .NET Framework 4.6.2#################################
echo.-------------------------------------------------------------------------------

for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" (
		echo.
		if not %%i gtr 9 echo.===========================[Install.wim, Index : %%i]============================
		if %%i gtr 9 echo.==========================[Install.wim, Index : %%i]============================
		echo.

		:: Getting Image Index Information
		call :GetImageIndexInfo "%InstallWim%", %%i >nul

		echo.
		echo.-------------------------------------------------------------------------------
		echo.Integrating Microsoft .NET Framework 4.6.2 Base Package...
		echo.-------------------------------------------------------------------------------
		call :AddPackage "%InstallMount%\%%i", "%NetFX462%\Microsoft-Windows-NetFX462-Package~31bf3856ad364e35~%PackageArchitecture%.cab"

		if exist "%NetFX462%\Microsoft-Windows-NetFX462-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%ImageDefaultLanguage%.cab" (
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft .NET Framework 4.6.2 [%ImageDefaultLanguage%] Language Package...
			echo.-------------------------------------------------------------------------------
			call :AddPackage "%InstallMount%\%%i", "%NetFX462%\Microsoft-Windows-NetFX462-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%ImageDefaultLanguage%.cab"
		)

		if "%ImageBuild%" equ "10240" if "%ImageEdition%" neq "Core" if "%ImageEdition%" neq "CoreN" if "%ImageEdition%" neq "CoreSingleLanguage" if "%ImageEdition%" neq "Education" if "%ImageEdition%" neq "EducationN" if "%ImageEdition%" neq "Professional" if "%ImageEdition%" neq "ProfessionalN" if "%ImageEdition%" neq "Enterprise" if "%ImageEdition%" neq "EnterpriseN" (
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft .NET Framework 4.6.2 Update Package...
			echo.-------------------------------------------------------------------------------
			call :AddPackage "%InstallMount%\%%i", "%NetFX462%\Windows10.0-KB4051600-%ImageArchitecture%.cab"
		)

		if "%ImageBuild%" equ "10586" if "%ImageEdition%" neq "Core" if "%ImageEdition%" neq "CoreN" if "%ImageEdition%" neq "CoreSingleLanguage" if "%ImageEdition%" neq "Professional" if "%ImageEdition%" neq "ProfessionalN" (
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft .NET Framework 4.6.2 Update Package...
			echo.-------------------------------------------------------------------------------
			call :AddPackage "%InstallMount%\%%i", "%NetFX462%\Windows10.0-KB4054057-%ImageArchitecture%.cab"
		)
	)
)

echo.-------------------------------------------------------------------------------
echo.####Finished Integrating Microsoft .NET Framework 4.6.2########################
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set NetFX462=

endlocal

:: Returning to Integrate Features Menu
goto :IntFeaturesMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Integrate Microsoft .NET Framework 4.8
::-------------------------------------------------------------------------------------------
:IntNetFX48

setlocal

set NetFX48Pkg=
set NetFX48LpPkg=

cls
echo.===============================================================================
echo.          MSMG ToolKit - Integrate Microsoft .NET Framework 4.8
echo.===============================================================================
echo.

:: Setting Microsoft .NET Framework 4.8 Pack folder path
set "NetFX48=%NetFX48%\%SelectedSourceOS%"

:: Getting Install Image Index Architecture
for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" call :GetImageArchitecture "%InstallWim%", %%i >nul
)

:: Setting Image Package Architecture
if "%ImageArchitecture%" equ "x86" set "PackageArchitecture=x86"
if "%ImageArchitecture%" equ "x64" set "PackageArchitecture=amd64"
if "%ImageArchitecture%" equ "arm" set "PackageArchitecture=arm"
if "%ImageArchitecture%" equ "arm64" set "PackageArchitecture=arm64"

:: Setting Image Package ServicePackBuildLevel
if "%SelectedSourceOS%" equ "w10" (
	if "%ImageBuild%" equ "14393" set "NetFX48Pkg=Microsoft-Windows-NetFX48-Package~31bf3856ad364e35~%PackageArchitecture%~~10.0.14393.0.cab"
	if "%ImageBuild%" equ "14393" set "NetFX48LpPkg=Microsoft-Windows-NetFX48-Package~31bf3856ad364e35~%PackageArchitecture%~%ImageDefaultLanguage%~10.0.14393.0.cab"
	if "%ImageBuild%" equ "15063" set "NetFX48Pkg=Microsoft-Windows-NetFX48-Package~31bf3856ad364e35~%PackageArchitecture%~~10.0.14393.0.cab"
	if "%ImageBuild%" equ "15063" set "NetFX48LpPkg=Microsoft-Windows-NetFX48-Package~31bf3856ad364e35~%PackageArchitecture%~%ImageDefaultLanguage%~10.0.14393.0.cab"
	if "%ImageBuild%" equ "16299" set "NetFX48Pkg=Microsoft-Windows-NetFX48-Package~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15.cab"
	if "%ImageBuild%" equ "16299" set "NetFX48LpPkg=Microsoft-Windows-NetFX48-Package~31bf3856ad364e35~%PackageArchitecture%~%ImageDefaultLanguage%~10.0.16299.15.cab"
	if "%ImageBuild%" equ "17134" set "NetFX48Pkg=Microsoft-Windows-NetFX48-Package~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15.cab"
	if "%ImageBuild%" equ "17134" set "NetFX48LpPkg=Microsoft-Windows-NetFX48-Package~31bf3856ad364e35~%PackageArchitecture%~%ImageDefaultLanguage%~10.0.16299.15.cab"
	if "%ImageBuild%" equ "17763" set "NetFX48Pkg=Microsoft-Windows-NetFX48-Package~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15.cab"
	if "%ImageBuild%" equ "17763" set "NetFX48LpPkg=Microsoft-Windows-NetFX48-Package~31bf3856ad364e35~%PackageArchitecture%~%ImageDefaultLanguage%~10.0.16299.15.cab"
)

:: Checking whether Microsoft .NET Framework 4.8 Pack file exist
if "%SelectedSourceOS%" equ "w7" if not exist "%NetFX48%\Windows6.1-KB4019990-%ImageArchitecture%.cab" (
	echo.Microsoft .NET Framework 4.8 Pack folder is missing the below file...
	echo.
	echo."Windows6.1-KB4019990-%ImageArchitecture%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\NetFX48\%SelectedSourceOS%^> folder...
	goto :Stop
)

:: Checking whether Microsoft .NET Framework 4.8 Pack file exist
if "%SelectedSourceOS%" equ "w7" if not exist "%NetFX48%\NetFX48.tpk" (
	echo.Microsoft .NET Framework 4.8 Pack folder is missing the below file...
	echo.
	echo."NetFX48.tpk"
	echo.
	echo.Please copy the above file to ^<Packs\NetFX48\%SelectedSourceOS%^> folder...
	goto :Stop
)

:: Checking whether Microsoft .NET Framework 4.8 Pack file exist
if "%SelectedSourceOS%" equ "w7" if not exist "%NetFX48%\NetFX48_%ImageArchitecture%.reg" (
	echo.Microsoft .NET Framework 4.8 Pack folder is missing the below file...
	echo.
	echo."NetFX48_%ImageArchitecture%.reg"
	echo.
	echo.Please copy the above file to ^<Packs\NetFX48\%SelectedSourceOS%^> folder...
	goto :Stop
)

:: Checking whether Microsoft .NET Framework 4.8 Pack file exist
if "%SelectedSourceOS%" equ "w81" if not exist "%NetFX48%\Microsoft-Windows-NetFx48-Package~31bf3856ad364e35~%PackageArchitecture%~~6.3.9600.16384.cab" (
	echo.Microsoft .NET Framework 4.8 Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-NetFx48-Package~31bf3856ad364e35~%PackageArchitecture%~~6.3.9600.16384.cab"
	echo.
	echo.Please copy the above file to ^<Packs\NetFX48\%SelectedSourceOS%^> folder...
	goto :Stop
)

:: Checking whether Microsoft .NET Framework 4.8 Pack file exist
if "%SelectedSourceOS%" equ "w10" if not exist "%NetFX48%\%NetFX48Pkg%" (
	echo.Microsoft .NET Framework 4.8 Pack folder is missing the below file...
	echo.
	echo."%NetFX48Pkg%"
	echo.
	echo.Please copy the above file to ^<Packs\NetFX48\%SelectedSourceOS%^> folder...
	goto :Stop
)

echo.-------------------------------------------------------------------------------
echo.####Starting Integrating Microsoft .NET Framework 4.8##########################
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    : Install.wim
if /i "%ImageIndexNo%" equ "A" echo.    Image Indexes            : 1-%ImageCount%
if /i "%ImageIndexNo%" neq "A" echo.    Image Index              : %ImageIndexNo%
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
echo.
echo.-------------------------------------------------------------------------------
echo.####Integrating Microsoft .NET Framework 4.8###################################
echo.-------------------------------------------------------------------------------

for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" (
		echo.
		if not %%i gtr 9 echo.===========================[Install.wim, Index : %%i]============================
		if %%i gtr 9 echo.==========================[Install.wim, Index : %%i]============================

		:: Getting Image Index Information
		call :GetImageIndexInfo "%InstallWim%", %%i >nul

		if "%SelectedSourceOS%" equ "w7" (
			echo.
			echo.-------------------------------------------------------------------------------
			echo.Integration du package de mise a jour des prerequis Microsoft .NET Framework 4.8 
			echo.-------------------------------------------------------------------------------
			call :AddPackage "%InstallMount%\%%i", "%NetFX48%\Windows6.1-KB4019990-%ImageArchitecture%.cab"
			echo.-------------------------------------------------------------------------------
			echo.Integration du package de base Microsoft .NET Framework 4.8 
			echo.-------------------------------------------------------------------------------
			if "%ImageArchitecture%" equ "x86" call :ApplyImage "%NetFX48%\NetFX48.tpk", 1, "%InstallMount%\%%i"
			if "%ImageArchitecture%" equ "x64" call :ApplyImage "%NetFX48%\NetFX48.tpk", 2, "%InstallMount%\%%i"

			if exist "%NetFX48%\NetFX48_%ImageDefaultLanguage%.tpk" (
				echo.-------------------------------------------------------------------------------
				echo.Integration du package de langue Microsoft .NET Framework 4.8 [%ImageDefaultLanguage%] 
				echo.-------------------------------------------------------------------------------
				if "%ImageArchitecture%" equ "x86" call :ApplyImage "%NetFX48%\NetFX48_%ImageDefaultLanguage%.tpk", 1, "%InstallMount%\%%i"
				if "%ImageArchitecture%" equ "x64" call :ApplyImage "%NetFX48%\NetFX48_%ImageDefaultLanguage%.tpk", 2, "%InstallMount%\%%i"
			)

			echo.-------------------------------------------------------------------------------
			echo.Importation des parametres de registre de Microsoft .NET Framework 4.8 
			echo.-------------------------------------------------------------------------------
			echo.
			echo.Montage du registre d'images 
			call :MountImageRegistry "%InstallMount%\%%i"
			echo.Importation des parametres de registre dans le registre d'images 
			call :ImportRegistry2Image "%NetFX48%\NetFX48_%ImageArchitecture%.reg"

			if exist "%NetFX48%\NetFX48_%ImageArchitecture%_%ImageDefaultLanguage%.reg" call :ImportRegistry2Image "%NetFX48%\NetFX48_%ImageArchitecture%_%ImageDefaultLanguage%.reg"

			echo.Demontage du registre d'images
			call :UnMountImageRegistry
			echo.
		)

		if "%SelectedSourceOS%" equ "w81" (
			if not exist "%NetFX48%\Microsoft-Windows-NetFX48-Package~31bf3856ad364e35~%PackageArchitecture%~%ImageDefaultLanguage%~6.3.9600.16384.cab" (
				call :AddPackage "%InstallMount%\%%i", "%NetFX48%\Microsoft-Windows-NetFX48-Package~31bf3856ad364e35~%PackageArchitecture%~~6.3.9600.16384.cab"
			)

			if exist "%NetFX48%\Microsoft-Windows-NetFX48-Package~31bf3856ad364e35~%PackageArchitecture%~%ImageDefaultLanguage%~6.3.9600.16384.cab" (
				echo.
				echo.-------------------------------------------------------------------------------
				echo.Integration du package de base Microsoft .NET Framework 4.8 
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%NetFX48%\Microsoft-Windows-NetFX48-Package~31bf3856ad364e35~%PackageArchitecture%~~6.3.9600.16384.cab"
				echo.-------------------------------------------------------------------------------
				echo.Integration du package de langue Microsoft .NET Framework 4.8 [%ImageDefaultLanguage%] 
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%NetFX48%\Microsoft-Windows-NetFX48-Package~31bf3856ad364e35~%PackageArchitecture%~%ImageDefaultLanguage%~6.3.9600.16384.cab"
			)
		)

		if "%SelectedSourceOS%" equ "w10" (
			if not exist "%NetFX48%\%NetFX48LpPkg%" call :AddPackage "%InstallMount%\%%i", "%NetFX48%\%NetFX48Pkg%"

			if exist "%NetFX48%\%NetFX48LpPkg%" (
				echo.-------------------------------------------------------------------------------
				echo.Integration du package de base Microsoft .NET Framework 4.8 
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%NetFX48%\%NetFX48Pkg%"
				echo.-------------------------------------------------------------------------------
				echo.Integration du package de langue Microsoft .NET Framework 4.8 [%ImageDefaultLanguage%] 
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%NetFX48%\%NetFX48LpPkg%"
			)
		)
	)
)

echo.-------------------------------------------------------------------------------
echo.####Integration de Microsoft .NET Framework 4.8 terminee ######################
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set NetFX48=
set NetFX48Pkg=
set NetFX48LpPkg=

endlocal

:: Returning to Integrate Features Menu
goto :IntFeaturesMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Integrate Microsoft .NET 5
::-------------------------------------------------------------------------------------------
:IntNET5

setlocal

cls
echo.===============================================================================
echo.                 MSMG ToolKit - Integrer Microsoft .NET 5 
echo.===============================================================================
echo.

:: Getting Install Image Index Architecture
for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" call :GetImageArchitecture "%InstallWim%", %%i >nul
)

:: Checking whether Microsoft .NET 5 Pack file exist
if not exist "%NET5%\NET5_%SelectedSourceOS%.tpk" (
	echo.Il manque le fichier ci-dessous dans le dossier Microsoft .NET 5 Pack. 
	echo.
	echo."NET5_%SelectedSourceOS%.tpk"
	echo.
	echo.Veuillez copier le fichier ci-dessus dans le dossier ^<Packs\NET5^>. 
	goto :Stop
)

if not exist "%NET5%\NET5_%SelectedSourceOS%_%ImageArchitecture%.reg" (
	echo.Il manque le fichier ci-dessous dans le dossier Microsoft .NET 5 Pack.
	echo.
	echo."NET5_%SelectedSourceOS%_%ImageArchitecture%.reg"
	echo.
	echo.Veuillez copier le fichier ci-dessus dans le dossier ^<Packs\NET5^>. 
	goto :Stop
)

echo.-------------------------------------------------------------------------------
echo.####Demarrage de l'integration de Microsoft .NET 5 ############################
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    : Install.wim
if /i "%ImageIndexNo%" equ "A" echo.    Image Indexes            : 1-%ImageCount%
if /i "%ImageIndexNo%" neq "A" echo.    Image Index              : %ImageIndexNo%
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
echo.
echo.-------------------------------------------------------------------------------
echo.####Integrating Microsoft .NET 5###############################################
echo.-------------------------------------------------------------------------------

for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" (
		echo.
		if not %%i gtr 9 echo.===========================[Install.wim, Index : %%i]============================
		if %%i gtr 9 echo.==========================[Install.wim, Index : %%i]============================
		echo.

		:: Getting Image Index Information
		call :GetImageIndexInfo "%InstallWim%", %%i >nul

		echo.-------------------------------------------------------------------------------
		echo.Integrating Microsoft .NET 5 Package...
		echo.-------------------------------------------------------------------------------
		if "%ImageArchitecture%" equ "x86" call :ApplyImage "%NET5%\NET5_%SelectedSourceOS%.tpk", 1, "%InstallMount%\%%i"
		if "%ImageArchitecture%" equ "x64" call :ApplyImage "%NET5%\NET5_%SelectedSourceOS%.tpk", 2, "%InstallMount%\%%i"
		echo.-------------------------------------------------------------------------------
		echo.Importing Microsoft .NET 5 Registry Settings...
		echo.-------------------------------------------------------------------------------
		echo.
		echo.Montage du registre d'images
		call :MountImageRegistry "%InstallMount%\%%i"
		echo.Importing Registry Settings to Image Registry...
		call :ImportRegistry2Image "%NET5%\NET5_%SelectedSourceOS%_%ImageArchitecture%.reg"

		echo.Demontage du registre d'images 
		call :UnMountImageRegistry
		echo.
	)
)

echo.-------------------------------------------------------------------------------
echo.####Finished Integrating Microsoft .NET 5######################################
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

endlocal

:: Returning to Integrate Features Menu
goto :IntFeaturesMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Integrate Microsoft Internet Explorer 11
::-------------------------------------------------------------------------------------------
:IntIE11

setlocal

cls
echo.===============================================================================
echo.             MSMG ToolKit - Integrate Microsoft Internet Explorer 11
echo.===============================================================================
echo.

:: Getting Install Image Index Architecture
for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" call :GetImageArchitecture "%InstallWim%", %%i >nul
)

:: Setting Image Package Architecture
if "%ImageArchitecture%" equ "x86" set "PackageArchitecture=x86"
if "%ImageArchitecture%" equ "x64" set "PackageArchitecture=amd64"

:: Checking whether Microsoft Internet Explorer 11 Pack file exist
if not exist "%IE11%\Microsoft-Windows-PlatformUpdate-Win7-SRV08R2-Package~31bf3856ad364e35~%PackageArchitecture%.cab" (
	echo.Microsoft Internet Explorer 11 Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-PlatformUpdate-Win7-SRV08R2-Package~31bf3856ad364e35~%PackageArchitecture%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\IE11^> folder...
	goto :Stop
)

:: Checking whether Microsoft Internet Explorer 11 Pack file exist
if not exist "%IE11%\Microsoft-Windows-InternetExplorer-Package~31bf3856ad364e35~%PackageArchitecture%.cab" (
	echo.Microsoft Internet Explorer 11 Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-InternetExplorer-Package~31bf3856ad364e35~%PackageArchitecture%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\IE11^> folder...
	goto :Stop
)

:: Checking whether Microsoft Internet Explorer 11 Pack file exist
if "%ImageDefaultLanguage%" equ "en-US" if not exist "%IE11%\Microsoft-Windows-IE-Hyphenation-Package~31bf3856ad364e35~en-US.cab" (
	echo.Microsoft Internet Explorer 11 Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-IE-Hyphenation-Package~31bf3856ad364e35~en-US.cab"
	echo.
	echo.Please copy the above file to ^<Packs\IE11^> folder...
	goto :Stop
)

:: Checking whether Microsoft Internet Explorer 11 Pack file exist
if "%ImageDefaultLanguage%" equ "en-US" if not exist "%IE11%\Microsoft-Windows-IE-Spelling-Package~31bf3856ad364e35~en-US.cab" (
	echo.Microsoft Internet Explorer 11 Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-IE-Spelling-Package~31bf3856ad364e35~en-US.cab"
	echo.
	echo.Please copy the above file to ^<Packs\IE11^> folder...
	goto :Stop
)

:: Checking whether Microsoft Internet Explorer 11 Pack file exist
if "%ImageDefaultLanguage%" neq "en-US" if not exist "%IE11%\Microsoft-Windows-InternetExplorer-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%ImageDefaultLanguage%.cab" (
	echo.Microsoft Internet Explorer 11 Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-InternetExplorer-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%ImageDefaultLanguage%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\IE11^> folder...
	goto :Stop
)

echo.-------------------------------------------------------------------------------
echo.####Starting Integrating Microsoft Internet Explorer 11########################
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    : Install.wim
if /i "%ImageIndexNo%" equ "A" echo.    Image Indexes            : 1-%ImageCount%
if /i "%ImageIndexNo%" neq "A" echo.    Image Index              : %ImageIndexNo%
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
echo.
echo.-------------------------------------------------------------------------------
echo.####Integrating Microsoft Internet Explorer 11#################################
echo.-------------------------------------------------------------------------------

for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" (
		echo.
		if not %%i gtr 9 echo.===========================[Install.wim, Index : %%i]============================
		if %%i gtr 9 echo.==========================[Install.wim, Index : %%i]============================
		echo.

		:: Getting Image Index Information
		call :GetImageIndexInfo "%InstallWim%", %%i >nul

		echo.-------------------------------------------------------------------------------
		echo.Integrating Microsoft Internet Explorer 11 Prerequisite Package...
		echo.-------------------------------------------------------------------------------
		call :AddPackage "%InstallMount%\%%i", "%IE11%\Microsoft-Windows-PlatformUpdate-Win7-SRV08R2-Package~31bf3856ad364e35~%PackageArchitecture%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating Microsoft Internet Explorer 11 Base Package...
		echo.-------------------------------------------------------------------------------
		call :AddPackage "%InstallMount%\%%i", "%IE11%\Microsoft-Windows-InternetExplorer-Package~31bf3856ad364e35~%PackageArchitecture%.cab"

		if "%ImageDefaultLanguage%" equ "en-US" (
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Internet Explorer 11 Hyphenation Package...
			echo.-------------------------------------------------------------------------------
			call :AddPackage "%InstallMount%\%%i", "%IE11%\Microsoft-Windows-IE-Hyphenation-Package~31bf3856ad364e35~en-US.cab"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Internet Explorer 11 Spelling Package...
			echo.-------------------------------------------------------------------------------
			call :AddPackage "%InstallMount%\%%i", "%IE11%\Microsoft-Windows-IE-Spelling-Package~31bf3856ad364e35~en-US.cab"
		) else (
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Internet Explorer 11 [%ImageDefaultLanguage%] Language Package...
			echo.-------------------------------------------------------------------------------
			call :AddPackage "%InstallMount%\%%i", "%IE11%\Microsoft-Windows-InternetExplorer-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%~%ImageDefaultLanguage%.cab"

			if exist "%IE11%\Microsoft-Windows-IE-Hyphenation-Package~31bf3856ad364e35~%ImageDefaultLanguage%.cab" (
				echo.-------------------------------------------------------------------------------
				echo.Integrating Microsoft Internet Explorer 11 Hyphenation Package...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%IE11%\Microsoft-Windows-IE-Hyphenation-Package~31bf3856ad364e35~%ImageDefaultLanguage%.cab"
			) else (
				echo.-------------------------------------------------------------------------------
				echo.Integrating Microsoft Internet Explorer 11 Hyphenation Package...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%IE11%\Microsoft-Windows-IE-Hyphenation-Package~31bf3856ad364e35~en-US.cab"
			)

			if exist "%IE11%\Microsoft-Windows-IE-Spelling-Package~31bf3856ad364e35~%ImageDefaultLanguage%.cab" (
				echo.-------------------------------------------------------------------------------
				echo.Integrating Microsoft Internet Explorer 11 Spelling Package...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%IE11%\Microsoft-Windows-IE-Spelling-Package~31bf3856ad364e35~%ImageDefaultLanguage%.cab"
			) else (
				echo.-------------------------------------------------------------------------------
				echo.Integrating Microsoft Internet Explorer 11 Spelling Package...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%IE11%\Microsoft-Windows-IE-Spelling-Package~31bf3856ad364e35~en-US.cab"
			)
		)
	)
)

echo.-------------------------------------------------------------------------------
echo.####Finished Integrating Internet Explorer 11##################################
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set IE11=

endlocal

:: Returning to Integrate Features Menu
goto :IntFeaturesMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Integrate Remote Desktop Protocol (RDP) 8.0 & 8.1
::-------------------------------------------------------------------------------------------
:IntRDP81

setlocal

cls
echo.===============================================================================
echo.       MSMG ToolKit - Integrate Remote Desktop Protocol ^(RDP^) 8.0 ^& 8.1
echo.===============================================================================
echo.

:: Getting Install Image Index Architecture
for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" call :GetImageArchitecture "%InstallWim%", %%i >nul
)

:: Setting Image Package Architecture
if "%ImageArchitecture%" equ "x86" set "PackageArchitecture=x86"
if "%ImageArchitecture%" equ "x64" set "PackageArchitecture=amd64"

:: Checking whether Remote Desktop Protocol (RDP) 8.0 & 8.1 Pack file exist
if not exist "%RDP81%\Microsoft-Windows-WinPE-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%.cab" (
	echo.Remote Desktop Protocol ^(RDP^) 8.0 ^& 8.1 Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-WinPE-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\RDP81^> folder...
	goto :Stop
)

:: Checking whether Remote Desktop Protocol (RDP) 8.0 & 8.1 Pack file exist
if not exist "%RDP81%\Microsoft-Windows-RDP-WinIP-Package~31bf3856ad364e35~%PackageArchitecture%.cab" (
	echo.Remote Desktop Protocol ^(RDP^) 8.0 ^& 8.1 Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-RDP-WinIP-Package~31bf3856ad364e35~%PackageArchitecture%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\RDP81^> folder...
	goto :Stop
)

:: Checking whether Remote Desktop Protocol (RDP) 8.0 & 8.1 Pack file exist
if not exist "%RDP81%\Microsoft-Windows-RDP-BlueIP-Package~31bf3856ad364e35~%PackageArchitecture%.cab" (
	echo.Remote Desktop Protocol ^(RDP^) 8.0 ^& 8.1 Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-RDP-BlueIP-Package~31bf3856ad364e35~%PackageArchitecture%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\RDP81^> folder...
	goto :Stop
)

echo.-------------------------------------------------------------------------------
echo.####Starting Integrating Remote Desktop Protocol ^(RDP^) 8.0 ^& 8.1###############
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    : Install.wim
if /i "%ImageIndexNo%" equ "A" echo.    Image Indexes            : 1-%ImageCount%
if /i "%ImageIndexNo%" neq "A" echo.    Image Index              : %ImageIndexNo%
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
echo.
echo.-------------------------------------------------------------------------------
echo.####Integrating Remote Desktop Protocol ^(RDP^) 8.0 ^& 8.1########################
echo.-------------------------------------------------------------------------------

for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" (
		echo.
		if not %%i gtr 9 echo.===========================[Install.wim, Index : %%i]============================
		if %%i gtr 9 echo.==========================[Install.wim, Index : %%i]============================
		echo.

		:: Getting Image Index Information
		call :GetImageIndexInfo "%InstallWim%", %%i >nul

		echo.-------------------------------------------------------------------------------
		echo.Integrating Remote Desktop Protocol ^(RDP^) 8.0 ^& 8.1 Prerequisite Package...
		echo.-------------------------------------------------------------------------------
		call :AddPackage "%InstallMount%\%%i", "%RDP81%\Microsoft-Windows-WinPE-LanguagePack-Package~31bf3856ad364e35~%PackageArchitecture%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating Remote Desktop Protocol ^(RDP^) 8.0 ^& 8.1 Prerequisite Package...
		echo.-------------------------------------------------------------------------------
		call :AddPackage "%InstallMount%\%%i", "%RDP81%\Microsoft-Windows-RDP-WinIP-Package~31bf3856ad364e35~%PackageArchitecture%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating Remote Desktop Protocol ^(RDP^) 8.0 ^& 8.1 Package...
		echo.-------------------------------------------------------------------------------
		call :AddPackage "%InstallMount%\%%i", "%RDP81%\Microsoft-Windows-RDP-BlueIP-Package~31bf3856ad364e35~%PackageArchitecture%.cab"
	)
)

echo.-------------------------------------------------------------------------------
echo.####Finished Integrating Remote Desktop Protocol ^(RDP^) 8.0 ^& 8.1###############
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set RDP81=

endlocal

:: Returning to Integrate Features Menu
goto :IntFeaturesMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Integrate Windows Management Framework (WMF) 5.1
::-------------------------------------------------------------------------------------------
:IntWMF

setlocal

cls
echo.===============================================================================
echo.       MSMG ToolKit - Integrate Windows Management Framework ^(WMF^) 5.1
echo.===============================================================================
echo.

:: Setting Windows Management Framework (WMF) 5.1 Pack folder path accroding to selected Source OS
set "WMF=%WMF%\%SelectedSourceOS%"

:: Getting Install Image Index Architecture
for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" call :GetImageArchitecture "%InstallWim%", %%i >nul
)

:: Checking whether Windows Management Framework (WMF) 5.1 Pack file exist
if "%SelectedSourceOS%" equ "w7" if "%ImageArchitecture%" equ "x64" if not exist "%WMF%\Windows6.1-KB2809215-%ImageArchitecture%.cab" (
	echo.Windows Management Framework 5 Pack folder is missing the below file...
	echo.
	echo."Windows6.1-KB2809215-%ImageArchitecture%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\WMF\%SelectedSourceOS%^> folder...
	goto :Stop
)

:: Checking whether Windows Management Framework (WMF) 5.1 Pack file exist
if "%SelectedSourceOS%" equ "w7" if not exist "%WMF%\Windows6.1-KB2872035-%ImageArchitecture%.cab" (
	echo.Windows Management Framework 5 Pack folder is missing the below file...
	echo.
	echo."Windows6.1-KB2872035-%ImageArchitecture%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\WMF\%SelectedSourceOS%^> folder...
	goto :Stop
)

:: Checking whether Windows Management Framework (WMF) 5.1 Pack file exist
if "%SelectedSourceOS%" equ "w7" if not exist "%WMF%\Windows6.1-KB3033929-%ImageArchitecture%.cab" (
	echo.Windows Management Framework 5 Pack folder is missing the below file...
	echo.
	echo."Windows6.1-KB3033929-%ImageArchitecture%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\WMF\%SelectedSourceOS%^> folder...
	goto :Stop
)

:: Checking whether Windows Management Framework (WMF) 5.1 Pack file exist
if "%SelectedSourceOS%" equ "w7" if not exist "%WMF%\Windows6.1-KB3191566-%ImageArchitecture%.cab" (
	echo.Windows Management Framework 5 Pack folder is missing the below file...
	echo.
	echo."Windows6.1-KB3191566-%ImageArchitecture%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\WMF\%SelectedSourceOS%^> folder...
	goto :Stop
)

:: Checking whether Windows Management Framework (WMF) 5.1 Pack file exist
if "%SelectedSourceOS%" equ "w81" if not exist "%WMF%\Windows8.1-KB3191564-%ImageArchitecture%.cab" (
	echo.Windows Management Framework 5 Pack folder is missing the below file...
	echo.
	echo."Windows8.1-KB3191564-%ImageArchitecture%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\WMF\%SelectedSourceOS%^> folder...
	goto :Stop
)

echo.-------------------------------------------------------------------------------
echo.####Starting Integrating Windows Management Framework ^(WMF^) 5.1################
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    : Install.wim
if /i "%ImageIndexNo%" equ "A" echo.    Image Indexes            : 1-%ImageCount%
if /i "%ImageIndexNo%" neq "A" echo.    Image Index              : %ImageIndexNo%
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
echo.
echo.-------------------------------------------------------------------------------
echo.####Integrating Windows Management Framework ^(WMF^) 5.1#########################
echo.-------------------------------------------------------------------------------

for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" (
		echo.
		if not %%i gtr 9 echo.===========================[Install.wim, Index : %%i]============================
		if %%i gtr 9 echo.==========================[Install.wim, Index : %%i]============================
		echo.

		:: Getting Image Index Information
		call :GetImageIndexInfo "%InstallWim%", %%i >nul

		if "%SelectedSourceOS%" equ "w7" (
			if "%ImageArchitecture%" equ "x64" (
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows Management Framework ^(WMF^) 5.1 Prerequisite Package...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%WMF%\Windows6.1-KB2809215-%ImageArchitecture%.cab"
			)

			echo.-------------------------------------------------------------------------------
			echo.Integrating Windows Management Framework ^(WMF^) 5.1 Prerequisite Package...
			echo.-------------------------------------------------------------------------------
			call :AddPackage "%InstallMount%\%%i", "%WMF%\Windows6.1-KB2872035-%ImageArchitecture%.cab"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Windows Management Framework ^(WMF^) 5.1 Prerequisite Package...
			echo.-------------------------------------------------------------------------------
			call :AddPackage "%InstallMount%\%%i", "%WMF%\Windows6.1-KB3033929-%ImageArchitecture%.cab"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Windows Management Framework ^(WMF^) 5.1 Feature Package...
			echo.-------------------------------------------------------------------------------
			call :AddPackage "%InstallMount%\%%i", "%WMF%\Windows6.1-KB3191566-%ImageArchitecture%.cab"
		)

		if "%SelectedSourceOS%" equ "w81" call :AddPackage "%InstallMount%\%%i", "%WMF%\Windows8.1-KB3191564-%ImageArchitecture%.cab"
	)
)

echo.-------------------------------------------------------------------------------
echo.####Finished Integrating Windows Management Framework ^(WMF^) 5.1################
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set WMF=

endlocal

:: Returning to Integrate Features Menu
goto :IntFeaturesMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Integrate Microsoft Win32 Calculator
::-------------------------------------------------------------------------------------------
:IntWin32Calc

setlocal

set PackageArchitecture=

cls
echo.===============================================================================
echo.             MSMG ToolKit - Integrate Microsoft Win32 Calculator
echo.===============================================================================
echo.

:: Getting Install Image Index Architecture
for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" call :GetImageArchitecture "%InstallWim%", %%i >nul
)

:: Setting Package Index
if "%ImageArchitecture%" equ "x86" set "PackageIndex=1"
if "%ImageArchitecture%" equ "x64" set "PackageIndex=2"
if "%ImageArchitecture%" equ "arm64" set "PackageIndex=3"

:: Checking whether Microsoft Win32 Calculator Pack file exist
if not exist "%Win32Calc%\Win32Calc.tpk" (
	echo.Microsoft Win32 Calculator Pack folder is missing the below file...
	echo.
	echo."Win32Calc.tpk"
	echo.
	echo.Please copy the above file to ^<Packs\Win32Calc^> folder...
	goto :Stop
)

:: Checking whether Microsoft Win32 Calculator Pack file exist
if not exist "%Win32Calc%\Win32Calc_%ImageDefaultLanguage%.tpk" (
	echo.Microsoft Win32 Calculator Pack folder is missing the below file...
	echo.
	echo."Win32Calc_%ImageDefaultLanguage%.tpk"
	echo.
	echo.Please copy the above file to ^<Packs\Win32Calc^> folder...
	goto :Stop
)

:: Checking whether Microsoft Win32 Calculator Pack file exist
if not exist "%Win32Calc%\Win32Calc_%ImageArchitecture%.reg" (
	echo.Microsoft Win32 Calculator Pack folder is missing the below file...
	echo.
	echo."Win32Calc_%ImageArchitecture%.reg"
	echo.
	echo.Please copy the above file to ^<Packs\Win32Calc^> folder...
	goto :Stop
)

echo.-------------------------------------------------------------------------------
echo.####Starting Integrating Microsoft Win32 Calculator############################
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    : Install.wim
if /i "%ImageIndexNo%" equ "A" echo.    Image Indexes            : 1-%ImageCount%
if /i "%ImageIndexNo%" neq "A" echo.    Image Index              : %ImageIndexNo%
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
echo.
echo.-------------------------------------------------------------------------------
echo.####Integrating Microsoft Win32 Calculator#####################################
echo.-------------------------------------------------------------------------------

for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" (
		echo.
		if not %%i gtr 9 echo.===========================[Install.wim, Index : %%i]============================
		if %%i gtr 9 echo.==========================[Install.wim, Index : %%i]============================
		echo.

		:: Getting Image Index Information
		call :GetImageIndexInfo "%InstallWim%", %%i >nul

		echo.-------------------------------------------------------------------------------
		echo.Integrating Microsoft Win32 Calculator Base Package...
		echo.-------------------------------------------------------------------------------
		call :ApplyImage "%Win32Calc%\Win32Calc.tpk", %PackageIndex%, "%InstallMount%\%%i"
		echo.-------------------------------------------------------------------------------
		echo.Integrating Microsoft Win32 Calculator [%ImageDefaultLanguage%] Language Package...
		echo.-------------------------------------------------------------------------------
		call :ApplyImage "%Win32Calc%\Win32Calc_%ImageDefaultLanguage%.tpk", %PackageIndex%, "%InstallMount%\%%i"
		echo.-------------------------------------------------------------------------------
		echo.Importing Microsoft Win32 Calculator Registry Settings...
		echo.-------------------------------------------------------------------------------
		echo.
		echo.Montage du registre d'images
		call :MountImageRegistry "%InstallMount%\%%i"
		echo.Importing Registry Settings to Image Registry...
		call :ImportRegistry2Image "%Win32Calc%\Win32Calc_%ImageArchitecture%.reg"
		echo.Demontage du registre d'images 
		call :UnMountImageRegistry
	)
)

echo.
echo.-------------------------------------------------------------------------------
echo.####Finished Integrating Microsoft Win32 Calculator############################
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set Win32Calc=
set PackageIndex=
set PackageArchitecture=

endlocal

:: Returning to Integrate Features Menu
goto :IntFeaturesMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Integrate Windows Data Deduplication
::-------------------------------------------------------------------------------------------
:IntDedup

setlocal

cls
echo.===============================================================================
echo.             MSMG ToolKit - Integrate Windows Data Deduplication
echo.===============================================================================
echo.

set "FSSMRESReg=%Dedup%\fssmres.dll.reg"

:: Setting Windows Data Deduplication Pack folder path accroding to selected Source OS
if "%SelectedSourceOS%"=="w81" set "Dedup=%Dedup%\%SelectedSourceOS%"
if "%SelectedSourceOS%"=="w10" set "Dedup=%Dedup%\%SelectedSourceOS%\10.0.%ImageBuild%"

:: Getting Install Image Index Architecture
for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" call :GetImageArchitecture "%InstallWim%", %%i >nul
)

:: Setting Package Service Pack Build
if "%SelectedSourceOS%" equ "w10" (
	if "%ImageBuild%" equ "10586" set "PackageServicePackBuild=0"
	if "%ImageBuild%" equ "14393" set "PackageServicePackBuild=0"
	if "%ImageBuild%" equ "15063" set "PackageServicePackBuild=0"
	if "%ImageBuild%" equ "16299" set "PackageServicePackBuild=15"
	if "%ImageBuild%" equ "17134" set "PackageServicePackBuild=1"
	if "%ImageBuild%" equ "17763" set "PackageServicePackBuild=1"
	if "%ImageBuild%" equ "18362" set "PackageServicePackBuild=1"
	if "%ImageBuild%" equ "18363" set "PackageServicePackBuild=1"
	if "%ImageBuild%" equ "19041" set "PackageServicePackBuild=1"
	if "%ImageBuild%" equ "19042" set "PackageServicePackBuild=1"
)

:: Checking whether the Source OS architecture is not 64-bit
if "%ImageArchitecture%" neq "x64" (
	echo.This feature is not applicable for 32-bit Source OS...
	goto :Stop
)

:: Checking whether Windows Data Deduplication Pack file exist
if "%SelectedSourceOS%" equ "w81" if not exist "%Dedup%\Microsoft-Windows-FileServer-Package~31bf3856ad364e35~amd64~~6.3.9600.16384.cab" (
	echo.Windows Data Deduplication Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-FileServer-Package~31bf3856ad364e35~amd64~~6.3.9600.16384.cab"
	echo.
	echo.Please copy the above file to ^<Packs\Dedup\%SelectedSourceOS%^> folder...
	goto :Stop
)

:: Checking whether Windows Data Deduplication Pack file exist
if "%SelectedSourceOS%" equ "w81" if not exist "%Dedup%\Microsoft-Windows-FileServer-Package~31bf3856ad364e35~amd64~%ImageDefaultLanguage%~6.3.9600.16384.cab" (
	echo.Windows Data Deduplication Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-FileServer-Package~31bf3856ad364e35~amd64~%ImageDefaultLanguage%~6.3.9600.16384.cab"
	echo.
	echo.Please copy the above file to ^<Packs\Dedup\%SelectedSourceOS%^> folder...
	goto :Stop
)

:: Checking whether Windows Data Deduplication Pack file exist
if "%SelectedSourceOS%" equ "w81" if not exist "%Dedup%\Microsoft-Windows-Dedup-Package~31bf3856ad364e35~amd64~~6.3.9600.16384.cab" (
	echo.Windows Data Deduplication Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-Dedup-Package~31bf3856ad364e35~amd64~~6.3.9600.16384.cab"
	echo.
	echo.Please copy the above file to ^<Packs\Dedup\%SelectedSourceOS%^> folder...
	goto :Stop
)

:: Checking whether Windows Data Deduplication Pack file exist
if "%SelectedSourceOS%" equ "w81" if not exist "%Dedup%\Microsoft-Windows-Dedup-Package~31bf3856ad364e35~amd64~%ImageDefaultLanguage%~6.3.9600.16384.cab" (
	echo.Windows Data Deduplication Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-Dedup-Package~31bf3856ad364e35~amd64~%ImageDefaultLanguage%~6.3.9600.16384.cab"
	echo.
	echo.Please copy the above file to ^<Packs\Dedup\%SelectedSourceOS%^> folder...
	goto :Stop
)

:: Checking whether Windows Data Deduplication Pack file exist
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "10586" if not exist "%Dedup%\Microsoft-Windows-FileServer-Package~31bf3856ad364e35~amd64~~%ImageVersion%.%PackageServicePackBuild%.cab" (
	echo.Windows Data Deduplication Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-FileServer-Package~31bf3856ad364e35~amd64~~%ImageVersion%.%PackageServicePackBuild%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\Dedup\%SelectedSourceOS%\10.0.%ImageBuild%^> folder...
	goto :Stop
)

:: Checking whether Windows Data Deduplication Pack file exist
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "10586" if not exist "%Dedup%\Microsoft-Windows-Dedup-Package~31bf3856ad364e35~amd64~~%ImageVersion%.%PackageServicePackBuild%.cab" (
	echo.Windows Data Deduplication Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-Dedup-Package~31bf3856ad364e35~amd64~~%ImageVersion%.%PackageServicePackBuild%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\Dedup\%SelectedSourceOS%\10.0.%ImageBuild%^> folder...
	goto :Stop
)

:: Checking whether Windows Data Deduplication Pack file exist
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "10586" if "%ImageDefaultLanguage%" neq "de-DE" if "%ImageDefaultLanguage%" neq "es-ES" if "%ImageDefaultLanguage%" neq "fr-FR" if "%ImageDefaultLanguage%" neq "it-IT" if "%ImageDefaultLanguage%" neq "ja-JP" if "%ImageDefaultLanguage%" neq "ko-KR" if "%ImageDefaultLanguage%" neq "pt-BR" if "%ImageDefaultLanguage%" neq "ru-RU" if "%ImageDefaultLanguage%" neq "tr-TR" if "%ImageDefaultLanguage%" neq "zh-CN" if "%ImageDefaultLanguage%" neq "zh-TW" (
	if not exist "%Dedup%\Microsoft-Windows-FileServer-Package~31bf3856ad364e35~amd64~en-US~%ImageVersion%.%PackageServicePackBuild%.cab" (
		echo.Windows Data Deduplication Pack folder is missing the below file...
		echo.
		echo."Microsoft-Windows-FileServer-Package~31bf3856ad364e35~amd64~en-US~%ImageVersion%.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\Dedup\%SelectedSourceOS%\10.0.%ImageBuild%^> folder...
		goto :Stop
	)

	if not exist "%Dedup%\Microsoft-Windows-Dedup-Package~31bf3856ad364e35~amd64~en-US~%ImageVersion%.%PackageServicePackBuild%.cab" (
		echo.Windows Data Deduplication Pack folder is missing the below file...
		echo.
		echo."Microsoft-Windows-Dedup-Package~31bf3856ad364e35~amd64~en-US~%ImageVersion%.%PackageServicePackBuild%.cab"
		echo.
		echo.Please copy the above file to ^<Packs\Dedup\%SelectedSourceOS%\10.0.%ImageBuild%^> folder...
		goto :Stop
	)
)

:: Checking whether Windows Data Deduplication Pack file exist
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "10586" (
	for %%j in (de-DE, es-ES, fr-FR, it-IT, ja-JP, ko-KR, pt-BR, ru-RU, tr-TR, zh-CN, zh-TW) do (
		if "%ImageDefaultLanguage%" equ "%%j" (
			if not exist "%Dedup%\Microsoft-Windows-FileServer-Package~31bf3856ad364e35~amd64~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab" (
				echo.Windows Data Deduplication Pack folder is missing the below file...
				echo.
				echo."Microsoft-Windows-FileServer-Package~31bf3856ad364e35~amd64~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab"
				echo.
				echo.Please copy the above file to ^<Packs\Dedup\%SelectedSourceOS%\10.0.%ImageBuild%^> folder...
				goto :Stop
			)

			if not exist "%Dedup%\Microsoft-Windows-Dedup-Package~31bf3856ad364e35~amd64~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab" (
				echo.Windows Data Deduplication Pack folder is missing the below file...
				echo.
				echo."Microsoft-Windows-Dedup-Package~31bf3856ad364e35~amd64~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab"
				echo.
				echo.Please copy the above file to ^<Packs\Dedup\%SelectedSourceOS%\10.0.%ImageBuild%^> folder...
				goto :Stop
			)
		)
	)
)

:: Checking whether Windows Data Deduplication Pack file exist
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "14393" if not exist "%Dedup%\Microsoft-Windows-FileServer-ServerCore-Package~31bf3856ad364e35~amd64~~%ImageVersion%.%PackageServicePackBuild%.cab" (
	echo.Windows Data Deduplication Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-FileServer-ServerCore-Package~31bf3856ad364e35~amd64~~%ImageVersion%.%PackageServicePackBuild%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\Dedup\%SelectedSourceOS%\10.0.%ImageBuild%^> folder...
	goto :Stop
)

:: Checking whether Windows Data Deduplication Pack file exist
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "14393" if not exist "%Dedup%\Microsoft-Windows-FileServer-ServerCore-Package~31bf3856ad364e35~amd64~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab" (
	echo.Windows Data Deduplication Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-FileServer-ServerCore-Package~31bf3856ad364e35~amd64~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\Dedup\%SelectedSourceOS%\10.0.%ImageBuild%^> folder...
	goto :Stop
)

:: Checking whether Windows Data Deduplication Pack file exist
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "14393" if not exist "%Dedup%\Microsoft-Windows-Dedup-Package~31bf3856ad364e35~amd64~~%ImageVersion%.%PackageServicePackBuild%.cab" (
	echo.Windows Data Deduplication Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-Dedup-Package~31bf3856ad364e35~amd64~~%ImageVersion%.%PackageServicePackBuild%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\Dedup\%SelectedSourceOS%\10.0.%ImageBuild%^> folder...
	goto :Stop
)

:: Checking whether Windows Data Deduplication Pack file exist
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "14393" if not exist "%Dedup%\Microsoft-Windows-Dedup-Package~31bf3856ad364e35~amd64~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab" (
	echo.Windows Data Deduplication Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-Dedup-Package~31bf3856ad364e35~amd64~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\Dedup\%SelectedSourceOS%\10.0.%ImageBuild%^> folder...
	goto :Stop
)

:: Checking whether Windows Data Deduplication Pack file exist
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "15063" if not exist "%Dedup%\Microsoft-Windows-FileServer-ServerCore-Package~31bf3856ad364e35~amd64~~%ImageVersion%.%PackageServicePackBuild%.cab" (
	echo.Windows Data Deduplication Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-FileServer-ServerCore-Package~31bf3856ad364e35~amd64~~%ImageVersion%.%PackageServicePackBuild%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\Dedup\%SelectedSourceOS%\10.0.%ImageBuild%^> folder...
	goto :Stop
)

:: Checking whether Windows Data Deduplication Pack file exist
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "15063" if not exist "%Dedup%\Microsoft-Windows-FileServer-ServerCore-Package~31bf3856ad364e35~amd64~en-US~%ImageVersion%.%PackageServicePackBuild%.cab" (
	echo.Windows Data Deduplication Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-FileServer-ServerCore-Package~31bf3856ad364e35~amd64~en-US~%ImageVersion%.%PackageServicePackBuild%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\Dedup\%SelectedSourceOS%\10.0.%ImageBuild%^> folder...
	goto :Stop
)

:: Checking whether Windows Data Deduplication Pack file exist
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "15063" if not exist "%Dedup%\Microsoft-Windows-Dedup-Package~31bf3856ad364e35~amd64~~%ImageVersion%.%PackageServicePackBuild%.cab" (
	echo.Windows Data Deduplication Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-Dedup-Package~31bf3856ad364e35~amd64~~%ImageVersion%.%PackageServicePackBuild%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\Dedup\%SelectedSourceOS%\10.0.%ImageBuild%^> folder...
	goto :Stop
)

:: Checking whether Windows Data Deduplication Pack file exist
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "15063" if not exist "%Dedup%\Microsoft-Windows-Dedup-Package~31bf3856ad364e35~amd64~en-US~%ImageVersion%.%PackageServicePackBuild%.cab" (
	echo.Windows Data Deduplication Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-Dedup-Package~31bf3856ad364e35~amd64~en-US~%ImageVersion%.%PackageServicePackBuild%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\Dedup\%SelectedSourceOS%\10.0.%ImageBuild%^> folder...
	goto :Stop
)

:: Checking whether Windows Data Deduplication Pack file exist
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "16299" if not exist "%Dedup%\Microsoft-Windows-FileServer-ServerCore-Package~31bf3856ad364e35~amd64~~%ImageVersion%.%PackageServicePackBuild%.cab" (
	echo.Windows Data Deduplication Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-FileServer-ServerCore-Package~31bf3856ad364e35~amd64~~%ImageVersion%.%PackageServicePackBuild%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\Dedup\%SelectedSourceOS%\10.0.%ImageBuild%^> folder...
	goto :Stop
)

:: Checking whether Windows Data Deduplication Pack file exist
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "16299" if not exist "%Dedup%\Microsoft-Windows-FileServer-ServerCore-Package~31bf3856ad364e35~amd64~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab" (
	echo.Windows Data Deduplication Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-FileServer-ServerCore-Package~31bf3856ad364e35~amd64~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\Dedup\%SelectedSourceOS%\10.0.%ImageBuild%^> folder...
	goto :Stop
)

:: Checking whether Windows Data Deduplication Pack file exist
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "16299" if not exist "%Dedup%\Microsoft-Windows-Dedup-Package~31bf3856ad364e35~amd64~~%ImageVersion%.%PackageServicePackBuild%.cab" (
	echo.Windows Data Deduplication Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-Dedup-Package~31bf3856ad364e35~amd64~~%ImageVersion%.%PackageServicePackBuild%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\Dedup\%SelectedSourceOS%\10.0.%ImageBuild%^> folder...
	goto :Stop
)

:: Checking whether Windows Data Deduplication Pack file exist
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "16299" if not exist "%Dedup%\Microsoft-Windows-Dedup-Package~31bf3856ad364e35~amd64~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab" (
	echo.Windows Data Deduplication Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-Dedup-Package~31bf3856ad364e35~amd64~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\Dedup\%SelectedSourceOS%\10.0.%ImageBuild%^> folder...
	goto :Stop
)

echo.-------------------------------------------------------------------------------
echo.####Starting Integrating Windows Data Deduplication############################
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    : Install.wim
if /i "%ImageIndexNo%" equ "A" echo.    Image Indexes            : 1-%ImageCount%
if /i "%ImageIndexNo%" neq "A" echo.    Image Index              : %ImageIndexNo%
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
echo.
echo.-------------------------------------------------------------------------------
echo.####Integrating Windows Data Deduplication#####################################
echo.-------------------------------------------------------------------------------

for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" (
		echo.
		if not %%i gtr 9 echo.===========================[Install.wim, Index : %%i]============================
		if %%i gtr 9 echo.==========================[Install.wim, Index : %%i]============================
		echo.

		:: Getting Image Index Information
		call :GetImageIndexInfo "%InstallWim%", %%i >nul

		if "%SelectedSourceOS%" equ "w81" (
			echo.-------------------------------------------------------------------------------
			echo.Integrating Windows File Server Base Package....
			echo.-------------------------------------------------------------------------------
			call :AddPackage "%InstallMount%\%%i", "%Dedup%\Microsoft-Windows-FileServer-Package~31bf3856ad364e35~amd64~~6.3.9600.16384.cab"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Windows File Server [%ImageDefaultLanguage%] Language Package...
			echo.-------------------------------------------------------------------------------
			call :AddPackage "%InstallMount%\%%i", "%Dedup%\Microsoft-Windows-FileServer-Package~31bf3856ad364e35~amd64~%ImageDefaultLanguage%~6.3.9600.16384.cab"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Windows Deduplication Base Package...
			echo.-------------------------------------------------------------------------------
			call :AddPackage "%InstallMount%\%%i", "%Dedup%\Microsoft-Windows-Dedup-Package~31bf3856ad364e35~amd64~~6.3.9600.16384.cab"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Windows Deduplication [%ImageDefaultLanguage%] Language Package...
			echo.-------------------------------------------------------------------------------
			call :AddPackage "%InstallMount%\%%i", "%Dedup%\Microsoft-Windows-Dedup-Package~31bf3856ad364e35~amd64~%ImageDefaultLanguage%~6.3.9600.16384.cab"
		)

		if "%SelectedSourceOS%" equ "w10" (
			if "%ImageBuild%" equ "10586" (
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows File Server Base Package....
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%Dedup%\Microsoft-Windows-FileServer-Package~31bf3856ad364e35~amd64~~%ImageVersion%.%PackageServicePackBuild%.cab"
				echo.-------------------------------------------------------------------------------

				if "%ImageDefaultLanguage%" neq "de-DE" if "%ImageDefaultLanguage%" neq "es-ES" if "%ImageDefaultLanguage%" neq "fr-FR" if "%ImageDefaultLanguage%" neq "it-IT" if "%ImageDefaultLanguage%" neq "ja-JP" if "%ImageDefaultLanguage%" neq "ko-KR" if "%ImageDefaultLanguage%" neq "pt-BR" if "%ImageDefaultLanguage%" neq "ru-RU" if "%ImageDefaultLanguage%" neq "tr-TR" if "%ImageDefaultLanguage%" neq "zh-CN" if "%ImageDefaultLanguage%" neq "zh-TW" (
					echo.Integrating Windows File Server [en-US] Language Package...
					echo.-------------------------------------------------------------------------------
					call :AddPackage "%InstallMount%\%%i", "%Dedup%\Microsoft-Windows-FileServer-Package~31bf3856ad364e35~amd64~en-US~%ImageVersion%.%PackageServicePackBuild%.cab"
				)

				for %%j in (de-DE, es-ES, fr-FR, it-IT, ja-JP, ko-KR, pt-BR, ru-RU, tr-TR, zh-CN, zh-TW) do (
					if "%ImageDefaultLanguage%" equ "%%j" (
						echo.Integrating Windows File Server [%ImageDefaultLanguage%] Language Package...
						echo.-------------------------------------------------------------------------------
						call :AddPackage "%InstallMount%\%%i", "%Dedup%\Microsoft-Windows-FileServer-Package~31bf3856ad364e35~amd64~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab"
					)
				)

				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows Deduplication Base Package...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%Dedup%\Microsoft-Windows-Dedup-Package~31bf3856ad364e35~amd64~~%ImageVersion%.%PackageServicePackBuild%.cab"
				echo.-------------------------------------------------------------------------------

				if "%ImageDefaultLanguage%" neq "de-DE" if "%ImageDefaultLanguage%" neq "es-ES" if "%ImageDefaultLanguage%" neq "fr-FR" if "%ImageDefaultLanguage%" neq "it-IT" if "%ImageDefaultLanguage%" neq "ja-JP" if "%ImageDefaultLanguage%" neq "ko-KR" if "%ImageDefaultLanguage%" neq "pt-BR" if "%ImageDefaultLanguage%" neq "ru-RU" if "%ImageDefaultLanguage%" neq "tr-TR" if "%ImageDefaultLanguage%" neq "zh-CN" if "%ImageDefaultLanguage%" neq "zh-TW" (
					echo.Integrating Windows Deduplication [en-US] Language Package...
					echo.-------------------------------------------------------------------------------
					call :AddPackage "%InstallMount%\%%i", "%Dedup%\Microsoft-Windows-Dedup-Package~31bf3856ad364e35~amd64~en-US~%ImageVersion%.%PackageServicePackBuild%.cab"
				)

				for %%j in (de-DE, es-ES, fr-FR, it-IT, ja-JP, ko-KR, pt-BR, ru-RU, tr-TR, zh-CN, zh-TW) do (
					if "%ImageDefaultLanguage%" equ "%%j" (
						echo.Integrating Windows Deduplication [%ImageDefaultLanguage%] Language Package...
						echo.-------------------------------------------------------------------------------
						call :AddPackage "%InstallMount%\%%i", "%Dedup%\Microsoft-Windows-Dedup-Package~31bf3856ad364e35~amd64~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab"
					)
				)
			)

			if "%ImageBuild%" equ "14393" (
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows File Server Core Base Package...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%Dedup%\Microsoft-Windows-FileServer-ServerCore-Package~31bf3856ad364e35~amd64~~%ImageVersion%.%PackageServicePackBuild%.cab"
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows File Server Core [%ImageDefaultLanguage%] Language Package...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%Dedup%\Microsoft-Windows-FileServer-ServerCore-Package~31bf3856ad364e35~amd64~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab"
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows Deduplication Base Package...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%Dedup%\Microsoft-Windows-Dedup-Package~31bf3856ad364e35~amd64~~%ImageVersion%.%PackageServicePackBuild%.cab"
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows Deduplication [%ImageDefaultLanguage%] Language Package...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%Dedup%\Microsoft-Windows-Dedup-Package~31bf3856ad364e35~amd64~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab"

				if exist "%Dedup%\Updates\*.cab" (
					echo.-------------------------------------------------------------------------------
					echo.Integrating Windows Deduplication Update Package...
					echo.-------------------------------------------------------------------------------
					call :AddPackage "%InstallMount%\%%i", "%Dedup%\Updates"
				)
			)

			if "%ImageBuild%" equ "15063" (
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows File Server Core Base Package...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%Dedup%\Microsoft-Windows-FileServer-ServerCore-Package~31bf3856ad364e35~amd64~~%ImageVersion%.%PackageServicePackBuild%.cab"
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows File Server Core [en-US] Package...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%Dedup%\Microsoft-Windows-FileServer-ServerCore-Package~31bf3856ad364e35~amd64~en-US~%ImageVersion%.%PackageServicePackBuild%.cab"
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows Deduplication Base Package...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%Dedup%\Microsoft-Windows-Dedup-Package~31bf3856ad364e35~amd64~~%ImageVersion%.%PackageServicePackBuild%.cab"
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows Deduplication [en-US] Package...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%Dedup%\Microsoft-Windows-Dedup-Package~31bf3856ad364e35~amd64~en-US~%ImageVersion%.%PackageServicePackBuild%.cab"
			)

			if "%ImageBuild%" geq "16299" (
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows File Server Core Base Package...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%Dedup%\Microsoft-Windows-FileServer-ServerCore-Package~31bf3856ad364e35~amd64~~%ImageVersion%.%PackageServicePackBuild%.cab"
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows File Server Core [en-US] Package...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%Dedup%\Microsoft-Windows-FileServer-ServerCore-Package~31bf3856ad364e35~amd64~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab"
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows Deduplication Base Package...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%Dedup%\Microsoft-Windows-Dedup-Package~31bf3856ad364e35~amd64~~%ImageVersion%.%PackageServicePackBuild%.cab"
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows Deduplication [en-US] Package...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%Dedup%\Microsoft-Windows-Dedup-Package~31bf3856ad364e35~amd64~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab"
			)
		)

		echo.-------------------------------------------------------------------------------
		echo.Enabling Windows Data Deduplication Feature...
		echo.-------------------------------------------------------------------------------
		if "%SelectedSourceOS%" equ "w81" (
			call :EnableFeature "%InstallMount%\%%i", "Dedup-Core /All"
			echo.-------------------------------------------------------------------------------
			echo.Enabling Windows File Services Search Service Feature...
			echo.-------------------------------------------------------------------------------
			call :EnableFeature "%InstallMount%\%%i", "File-Services-Search-Service /All"
		)

		if "%SelectedSourceOS%" equ "w10" call :EnableFeature "%InstallMount%\%%i", "Dedup-Core /All"

		echo.-------------------------------------------------------------------------------
		echo.Importing Windows File Server ^(fssmres.dll^) Fix Registry Settings...
		echo.-------------------------------------------------------------------------------
		echo.
		echo.Montage du registre d'images
		call :MountImageRegistry "%InstallMount%\%%i"
		echo.Importing Registry Settings to Image Registry...
		call :ImportRegistry2Image "%FSSMRESReg%"
		echo.Demontage du registre d'images 
		call :UnMountImageRegistry
	)
)

echo.
echo.-------------------------------------------------------------------------------
echo.####Finished Integrating Windows Data Deduplication############################
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set Dedup=
set PackageServicePackBuild=

endlocal

:: Returning to Integrate Features Menu
goto :IntFeaturesMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Integrate Windows To Go Workspace
::-------------------------------------------------------------------------------------------
:IntWinToGo

setlocal

cls
echo.===============================================================================
echo.              MSMG ToolKit - Integrate Windows To Go Workspace
echo.===============================================================================
echo.

:: Getting Install Image Index Architecture
for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" call :GetImageArchitecture "%InstallWim%", %%i >nul
)

:: Setting Windows To Go Workspace Pack path
if "%SelectedSourceOS%" equ "w81" set "WinToGo=%WinToGo%\%SelectedSourceOS%"
if "%SelectedSourceOS%" equ "w10" set "WinToGo=%WinToGo%\%SelectedSourceOS%\10.0.%ImageBuild%"

:: Setting Package Service Pack Build
if "%SelectedSourceOS%" equ "w10" (
	if "%ImageBuild%" equ "10240" set "PackageServicePackBuild=16384"
	if "%ImageBuild%" equ "10586" set "PackageServicePackBuild=0"
	if "%ImageBuild%" equ "14393" set "PackageServicePackBuild=0"
	if "%ImageBuild%" equ "15063" set "PackageServicePackBuild=0"
	if "%ImageBuild%" equ "16299" set "PackageServicePackBuild=15"
	if "%ImageBuild%" equ "17134" set "PackageServicePackBuild=1"
	if "%ImageBuild%" equ "17763" set "PackageServicePackBuild=1"
	if "%ImageBuild%" equ "18362" set "PackageServicePackBuild=1"
)

:: Setting Package Index and Architecture
if "%ImageArchitecture%" equ "x86" (
	set "PackageIndex=1"
	set "PackageArchitecture=x86"
)

if "%ImageArchitecture%" equ "x64" (
	set "PackageIndex=2"
	set "PackageArchitecture=amd64"
)

:: Checking whether Windows To Go Workspace Pack file exist
if "%SelectedSourceOS%" equ "w81" if not exist "%WinToGo%\WTG.tpk" (
	echo.Windows To Go Workspace Pack file "WTG.tpk" not found...
	echo.
	echo.Please copy the above file to ^<Packs\WinToGo\%SelectedSourceOS%^> folder...
	goto :Stop
)

:: Checking whether Windows To Go Workspace Pack file exist
if "%SelectedSourceOS%" equ "w81" if not exist "%WinToGo%\WTG_%ImageDefaultLanguage%.tpk" (
	echo.Windows To Go Workspace Pack file "WTG_%ImageDefaultLanguage%.tpk" not found...
	echo.
	echo.Please copy the above file to ^<Packs\WinToGo\%SelectedSourceOS%^> folder...
	goto :Stop
)

:: Checking whether Windows To Go Workspace Pack file exist
if "%SelectedSourceOS%" equ "w81" if not exist "%WinToGo%\WTG_%ImageArchitecture%.reg" (
	echo.Windows To Go Workspace Pack file "WTG_%ImageArchitecture%.reg" not found...
	echo.
	echo.Please copy the above file to ^<Packs\WinToGo\%SelectedSourceOS%^> folder...
	goto :Stop
)

:: Checking whether Windows To Go Workspace Pack file exist
if "%SelectedSourceOS%" equ "w10" if not exist "%WinToGo%\Microsoft-Windows-PortableWorkspaces-Creator-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab" (
	echo.Windows To Go Workspace Pack folder is missing the below file...
	echo.
	echo.Microsoft-Windows-PortableWorkspaces-Creator-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\WinToGo\%SelectedSourceOS%\10.0.%ImageBuild%^> folder...
	goto :Stop
)

:: Checking whether Windows To Go Workspace Pack file exist
if "%SelectedSourceOS%" equ "w10" if not exist "%WinToGo%\Microsoft-Windows-PortableWorkspaces-Creator-Package~31bf3856ad364e35~%PackageArchitecture%~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab" (
	echo.Windows To Go Workspace Pack folder is missing the below file...
	echo.
	echo.Microsoft-Windows-PortableWorkspaces-Creator-Package~31bf3856ad364e35~%PackageArchitecture%~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\WinToGo\%SelectedSourceOS%\10.0.%ImageBuild%^> folder...
	goto :Stop
)

echo.-------------------------------------------------------------------------------
echo.####Starting Integrating Windows To Go Workspace###############################
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    : Install.wim
if /i "%ImageIndexNo%" equ "A" echo.    Image Indexes            : 1-%ImageCount%
if /i "%ImageIndexNo%" neq "A" echo.    Image Index              : %ImageIndexNo%
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
echo.
echo.-------------------------------------------------------------------------------
echo.####Integrating Windows To Go Workspace########################################
echo.-------------------------------------------------------------------------------

for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" (
		echo.
		if not %%i gtr 9 echo.===========================[Install.wim, Index : %%i]============================
		if %%i gtr 9 echo.==========================[Install.wim, Index : %%i]============================
		echo.

		:: Getting Image Index Information
		call :GetImageIndexInfo "%InstallWim%", %%i >nul

		if "%SelectedSourceOS%" equ "w81" (
			echo.-------------------------------------------------------------------------------
			echo.Integrating Windows To Go Workspace Base Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%WinToGo%\WTG.tpk", %PackageIndex%, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Windows To Go Workspace [%ImageDefaultLanguage%] Language Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%WinToGo%\WTG_%ImageDefaultLanguage%.tpk", %PackageIndex%, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
			echo.Importing Windows To Go Workspace Registry Settings...
			echo.-------------------------------------------------------------------------------
			echo.
			echo.Montage du registre d'images
			call :MountImageRegistry "%InstallMount%\%%i"
			echo.Importing Registry Settings to Image Registry...
			call :ImportRegistry2Image "%WinToGo%\WTG_%ImageArchitecture%.reg"
			echo.Demontage du registre d'images 
			call :UnMountImageRegistry
		)

		if "%SelectedSourceOS%" equ "w10" (
			echo.-------------------------------------------------------------------------------
			echo.Integrating Windows To Go Workspace Base Package...
			echo.-------------------------------------------------------------------------------
			call :AddPackage "%InstallMount%\%%i", %WinToGo%\Microsoft-Windows-PortableWorkspaces-Creator-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab
			echo.-------------------------------------------------------------------------------
			echo.Integrating Windows To Go Workspace [%ImageDefaultLanguage%] Language Package...
			echo.-------------------------------------------------------------------------------
			call :AddPackage "%InstallMount%\%%i", %WinToGo%\Microsoft-Windows-PortableWorkspaces-Creator-Package~31bf3856ad364e35~%PackageArchitecture%~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab
		)
	)
)

echo.-------------------------------------------------------------------------------
echo.####Finished Integrating Windows To Go Workspace###############################
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set WinToGo=
set PackageServicePackBuild=
set PackageIndex=
set PackageArchitecture=

endlocal

:: Returning to Integrate Features Menu
goto :IntFeaturesMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Integrate Windows System Restore
::-------------------------------------------------------------------------------------------
:IntSystemRestore

setlocal

cls
echo.===============================================================================
echo.               MSMG ToolKit - Integrate Windows System Restore
echo.===============================================================================
echo.

:: Getting Install Image Index Architecture
for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" call :GetImageArchitecture "%InstallWim%", %%i >nul
)

:: Setting Windows System Restore Pack Path
if "%SelectedSourceOS%" equ "w7" set "SystemRestore=%SystemRestore%\%SelectedSourceOS%"
if "%SelectedSourceOS%" equ "w10" set "SystemRestore=%SystemRestore%\%SelectedSourceOS%\10.0.%ImageBuild%"

:: Setting Package Service Pack Build
if "%SelectedSourceOS%" equ "w7" set "PackageServicePackBuild=17514"

if "%SelectedSourceOS%" equ "w10" (
	if "%ImageBuild%" equ "14393" set "PackageServicePackBuild=0"
	if "%ImageBuild%" equ "15063" set "PackageServicePackBuild=0"
	if "%ImageBuild%" equ "16299" set "PackageServicePackBuild=15"
	if "%ImageBuild%" equ "17134" set "PackageServicePackBuild=1"
	if "%ImageBuild%" equ "17763" set "PackageServicePackBuild=1"
)

:: Checking whether Windows System Restore Pack file exist
if not exist "%SystemRestore%\Microsoft-Windows-SystemRestore-Package~31bf3856ad364e35~amd64~~%ImageVersion%.%PackageServicePackBuild%.cab" (
	echo.Windows System Restore Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-SystemRestore-Package~31bf3856ad364e35~amd64~~%ImageVersion%.%PackageServicePackBuild%.cab"
	echo.
	if "%SelectedSourceOS%" equ "w7" echo.Please copy the above file to ^<Packs\SystemRestore\%SelectedSourceOS%^> folder...
	if "%SelectedSourceOS%" equ "w10" echo.Please copy the above file to ^<Packs\SystemRestore\%SelectedSourceOS%\10.0.%ImageBuild%^> folder...
	goto :Stop
)

:: Checking whether Windows System Restore Pack file exist
if not exist "%SystemRestore%\Microsoft-Windows-SystemRestore-Package~31bf3856ad364e35~amd64~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab" (
	echo.Windows System Restore Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-SystemRestore-Package~31bf3856ad364e35~amd64~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab"
	echo.
	if "%SelectedSourceOS%" equ "w7" echo.Please copy the above file to ^<Packs\SystemRestore\%SelectedSourceOS%^> folder...
	if "%SelectedSourceOS%" equ "w10" echo.Please copy the above file to ^<Packs\SystemRestore\%SelectedSourceOS%\10.0.%ImageBuild%^> folder...
	goto :Stop
)

echo.-------------------------------------------------------------------------------
echo.####Starting Integrating Windows System Restore################################
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    : Install.wim
if /i "%ImageIndexNo%" equ "A" echo.    Image Indexes            : 1-%ImageCount%
if /i "%ImageIndexNo%" neq "A" echo.    Image Index              : %ImageIndexNo%
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
echo.
echo.-------------------------------------------------------------------------------
echo.####Integrating Windows System Restore#########################################
echo.-------------------------------------------------------------------------------

for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" (
		echo.
		if not %%i gtr 9 echo.===========================[Install.wim, Index : %%i]============================
		if %%i gtr 9 echo.==========================[Install.wim, Index : %%i]============================
		echo.

		:: Getting Image Index Information
		call :GetImageIndexInfo "%InstallWim%", %%i >nul

		echo.-------------------------------------------------------------------------------
		echo.Integrating Windows System Restore Base Package...
		echo.-------------------------------------------------------------------------------
		call :AddPackage "%InstallMount%\%%i", "%SystemRestore%\Microsoft-Windows-SystemRestore-Package~31bf3856ad364e35~amd64~~%ImageVersion%.%PackageServicePackBuild%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating Windows System Restore [%ImageDefaultLanguage%] Language Package...
		echo.-------------------------------------------------------------------------------
		call :AddPackage "%InstallMount%\%%i", "%SystemRestore%\Microsoft-Windows-SystemRestore-Package~31bf3856ad364e35~amd64~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab"
	)
)

echo.-------------------------------------------------------------------------------
echo.####Finished Integrating Windows System Restore################################
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set SystemRestore=
set PackageServicePackBuild=

endlocal

:: Returning to Integrate Features Menu
goto :IntFeaturesMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Integrate Microsoft Edge Classic Browser
::-------------------------------------------------------------------------------------------
:IntEdgeClassic

setlocal

cls
echo.===============================================================================
echo.            MSMG ToolKit - Integrate Microsoft Edge Classic Browser
echo.===============================================================================
echo.

:: Getting Install Image Index Architecture
for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" call :GetImageArchitecture "%InstallWim%", %%i >nul
)

:: Setting Microsoft Edge Classic Browser Pack path
set "EdgeClassic=%EdgeClassic%\10.0.%ImageBuild%"

:: Setting Package Service Pack Build
if "%ImageBuild%" equ "10240" set "PackageServicePackBuild=16384"
if "%ImageBuild%" equ "14393" set "PackageServicePackBuild=0"
if "%ImageBuild%" equ "15063" set "PackageServicePackBuild=0"
if "%ImageBuild%" equ "16299" set "PackageServicePackBuild=15"
if "%ImageBuild%" equ "17134" set "PackageServicePackBuild=1"
if "%ImageBuild%" equ "17763" set "PackageServicePackBuild=1"
if "%ImageBuild%" equ "18362" set "PackageServicePackBuild=1"
if "%ImageBuild%" equ "18363" set "PackageServicePackBuild=1"
if "%ImageBuild%" equ "19041" set "PackageServicePackBuild=1"
if "%ImageBuild%" equ "19042" set "PackageServicePackBuild=1"

:: Setting Package Architecture
if "%ImageArchitecture%" equ "x86" set "PackageArchitecture=x86"
if "%ImageArchitecture%" equ "x64" set "PackageArchitecture=amd64"

:: Checking whether Microsoft Edge Classic Browser Pack file exist
if "%SelectedSourceOS%" equ "w10" if not exist "%EdgeClassic%\Microsoft-Windows-Internet-Browser-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab" (
	echo.Microsoft Edge Classic Browser Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-Internet-Browser-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\EdgeBrowser\10.0.%ImageBuild%^> folder...
	goto :Stop
)

:: Checking whether Microsoft Edge Classic Browser Pack file exist
if "%SelectedSourceOS%" equ "w10" if not exist "%EdgeClassic%\Microsoft-Windows-Internet-Browser-Package~31bf3856ad364e35~%PackageArchitecture%~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab" (
	echo.Microsoft Edge Classic Browser Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-Internet-Browser-Package~31bf3856ad364e35~%PackageArchitecture%~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\EdgeBrowser\10.0.%ImageBuild%^> folder...
	goto :Stop
)

echo.-------------------------------------------------------------------------------
echo.####Starting Integrating Microsoft Edge Classic Browser########################
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    : Install.wim
if /i "%ImageIndexNo%" equ "A" echo.    Image Indexes            : 1-%ImageCount%
if /i "%ImageIndexNo%" neq "A" echo.    Image Index              : %ImageIndexNo%
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
echo.
echo.-------------------------------------------------------------------------------
echo.####Integrating Microsoft Edge Classic Browser#################################
echo.-------------------------------------------------------------------------------

for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" (
		echo.
		if not %%i gtr 9 echo.===========================[Install.wim, Index : %%i]============================
		if %%i gtr 9 echo.==========================[Install.wim, Index : %%i]============================
		echo.

		:: Getting Image Index Information
		call :GetImageIndexInfo "%InstallWim%", %%i >nul

		echo.-------------------------------------------------------------------------------
		echo.Integrating Microsoft Edge Classic Browser Base Package...
		echo.-------------------------------------------------------------------------------
		call :AddPackage "%InstallMount%\%%i", "%EdgeClassic%\Microsoft-Windows-Internet-Browser-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating Microsoft Edge Classic Browser [%ImageDefaultLanguage%] Language Package...
		echo.-------------------------------------------------------------------------------
		call :AddPackage "%InstallMount%\%%i", "%EdgeClassic%\Microsoft-Windows-Internet-Browser-Package~31bf3856ad364e35~%PackageArchitecture%~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab"

		:: Importing Registry Fix to Enable Integrating Windows 10 Cumulative Update.
		if "%ImageBuild%" lss "17763" (
			for %%j in (EnterpriseS, ServerStandard, ServerDatacenter) do (
				if "%ImageEdition%" equ "%%j" if exist "%InstallMount%\%%i\Windows\servicing\packages\Microsoft-Windows-Internet-Browser-Package~31bf3856ad364e35~*.mum" (
					call :MountImageRegistry "%InstallMount%\%%i"
					reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%" /v "InstallClient" /t REG_SZ /d "DISM Package Manager Provider" /f >nul
					reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%" /v "InstallName" /t REG_SZ /d "Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.mum" /f >nul
					reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%" /v "InstallLocation" /t REG_SZ /d "\\?\d:\rs.bin.%PackageArchitecture%fre.dep\mergedcomponents\images\client\packages\\" /f >nul
					reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%" /v "CurrentState" /t REG_DWORD /d "112" /f >nul
					reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%" /v "SelfUpdate" /t REG_DWORD /d "0" /f >nul
					reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%" /v "Visibility" /t REG_DWORD /d "1" /f >nul
					reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%" /v "InstallTimeHigh" /t REG_DWORD /d "30531506" /f >nul
					reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%" /v "InstallTimeLow" /t REG_DWORD /d "76431985" /f >nul
					reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%" /v "InstallUser" /t REG_SZ /d "S-1-5-18" /f >nul
					call :UnMountImageRegistry
				)
			)

			if "%ImageEdition%" equ "EnterpriseSN" if exist "%InstallMount%\%%i\Windows\servicing\packages\Microsoft-Windows-Internet-Browser-Package~31bf3856ad364e35~*.mum" (
				call :MountImageRegistry "%InstallMount%\%%i"
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseNEdition~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%" /v "InstallClient" /t REG_SZ /d "DISM Package Manager Provider" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseNEdition~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%" /v "InstallName" /t REG_SZ /d "Microsoft-Windows-EnterpriseNEdition~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.mum" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseNEdition~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%" /v "InstallLocation" /t REG_SZ /d "\\?\d:\rs.bin.%PackageArchitecture%fre.dep\mergedcomponents\images\client\packages\\" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseNEdition~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%" /v "CurrentState" /t REG_DWORD /d "112" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseNEdition~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%" /v "SelfUpdate" /t REG_DWORD /d "0" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseNEdition~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%" /v "Visibility" /t REG_DWORD /d "1" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseNEdition~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%" /v "InstallTimeHigh" /t REG_DWORD /d "30531506" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseNEdition~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%" /v "InstallTimeLow" /t REG_DWORD /d "76431985" /f >nul
				reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseNEdition~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%" /v "InstallUser" /t REG_SZ /d "S-1-5-18" /f >nul
				call :UnMountImageRegistry
			)
		)
	)
)

echo.-------------------------------------------------------------------------------
echo.####Finished Integrating Microsoft Edge Classic Browser########################
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set EdgeClassic=
set PackageServicePackBuild=
set PackageArchitecture=

endlocal

:: Returning to Integrate Features Menu
goto :IntFeaturesMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Integrate Microsoft Edge Chromium Browser
::-------------------------------------------------------------------------------------------
:IntEdgeChromium

setlocal

set "EdgeChrGPD=%EdgeChromium%\GroupPolicy"

cls
echo.===============================================================================
echo.          MSMG ToolKit - Integrate Microsoft Edge Chromium Browser
echo.===============================================================================
echo.

:: Getting Install Image Index Architecture
for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" call :GetImageArchitecture "%InstallWim%", %%i >nul
)

:: Setting Microsoft Edge Chromium Browser Pack Path
if "%SelectedSourceOS%" neq "w10" set "EdgeChromium=%EdgeChromium%\%SelectedSourceOS%"
if "%SelectedSourceOS%" equ "w10" (
	if "%ImageBuild%" leq "17763" set "EdgeChromium=%EdgeChromium%\%SelectedSourceOS%\10.0.%ImageBuild%"
	if "%ImageBuild%" geq "18362" if "%ImageBuild%" leq "18363" set "EdgeChromium=%EdgeChromium%\%SelectedSourceOS%\10.0.18362"
	if "%ImageBuild%" geq "19041" if "%ImageBuild%" leq "19042" set "EdgeChromium=%EdgeChromium%\%SelectedSourceOS%\10.0.19041"
)

:: Checking whether Microsoft Edge Chromium Browser Pack file exist
if not exist "%EdgeChromium%\Windows*-%ImageArchitecture%.cab" (
	echo.Microsoft Edge Chromium Browser Pack folder is empty...
	echo.
	echo.Please copy the file to ^<Packs\EdgeChromium\%SelectedSourceOS%^> folder...
	goto :Stop
)

if "%SelectedSourceOS%" equ "w7" if not exist "%EdgeChromium%\Windows6.1-KB4490628-%ImageArchitecture%.cab" (
	for %%i in (KB4490628,KB4474419,KB4550735) do (
		if not exist "%EdgeChromium%\Windows6.1-%%i-%ImageArchitecture%.cab" (
			echo.Microsoft Edge Chromium Browser Pack folder is missing the below file...
			echo.
			echo."Windows6.1-%%i-%ImageArchitecture%.cab"
			echo.
			echo.Please copy the above file to ^<Packs\EdgeChromium\%SelectedSourceOS%^> folder...
			goto :Stop
		)
	)
)

if not exist "%EdgeChrGPD%\EdgeChrGPD.tpk" (
	echo.Microsoft Edge Chromium Browser Pack folder is missing the below file...
	echo.
	echo.EdgeChrGPD.tpk
	echo.
	echo.Please copy the above file to ^<Packs\EdgeChromium\GroupPolicy^> folder...
	goto :Stop
)

for /d %%k in (cs-CZ,da-DK,de-DE,el-GR,en-US,es-ES,fi-FI,fr-FR,hu-HU,it-IT,ja-JP,ko-KR,nb-NO,nl-NL,pl-PL,pt-BR,pt-PT,ru-RU,sv-SE,tr-TR,zh-CN,zh-TW) do (
	if "%ImageDefaultLanguage%" equ "%%k" (
		if not exist "%EdgeChrGPD%\EdgeChrGPD_%%k.tpk" (
			echo.Microsoft Edge Chromium Browser Pack folder is missing the below file...
			echo.
			echo.EdgeChrGPD_%%k.tpk
			echo.
			echo.Please copy the above file to ^<Packs\EdgeChromium\GroupPolicy^> folder...
			goto :Stop
		)
	)
)

echo.-------------------------------------------------------------------------------
echo.####Starting Integrating Microsoft Edge Chromium Browser#######################
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    : Install.wim
if /i "%ImageIndexNo%" equ "A" echo.    Image Indexes            : 1-%ImageCount%
if /i "%ImageIndexNo%" neq "A" echo.    Image Index              : %ImageIndexNo%
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
echo.
echo.-------------------------------------------------------------------------------
echo.####Integrating Microsoft Edge Chromium Browser################################
echo.-------------------------------------------------------------------------------
echo.
for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" (
		if not %%i gtr 9 echo.===========================[Install.wim, Index : %%i]============================
		if %%i gtr 9 echo.==========================[Install.wim, Index : %%i]============================
		echo.

		:: Getting Image Index Information
		call :GetImageIndexInfo "%InstallWim%", %%i >nul

		if "%SelectedSourceOS%" equ "w7" (
			echo.-------------------------------------------------------------------------------
			echo.Integrating Windows Servicing Stack Update ^(SSU^) ^(KB4490628^) Package...
			echo.-------------------------------------------------------------------------------
			call :AddPackage "%InstallMount%\%%i", "%EdgeChromium%\Windows6.1-KB4490628-%ImageArchitecture%.cab"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Windows SHA-2 Code Update ^(KB4474419^) Package...
			echo.-------------------------------------------------------------------------------
			call :AddPackage "%InstallMount%\%%i", "%EdgeChromium%\Windows6.1-KB4474419-v3-%ImageArchitecture%.cab"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Windows Servicing Stack Update ^(SSU^) ^(KB4550735^) Package...
			echo.-------------------------------------------------------------------------------
			call :AddPackage "%InstallMount%\%%i", "%EdgeChromium%\Windows6.1-KB4550735-%ImageArchitecture%.cab"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Edge Chromium Browser Package...
			echo.-------------------------------------------------------------------------------
			call :AddPackage "%InstallMount%\%%i", "%EdgeChromium%\Windows6.1-KB4567409-%ImageArchitecture%.cab"
		)

		if "%SelectedSourceOS%" neq "w7" (
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Edge Chromium Browser Package...
			echo.-------------------------------------------------------------------------------
			for /f %%j IN ('"dir /b %EdgeChromium%\Windows*-%ImageArchitecture%.cab" 2^>nul') do (
				call :AddPackage "%InstallMount%\%%i", "%EdgeChromium%\%%j"
			)
		)

		echo.-------------------------------------------------------------------------------
		echo.Integrating Microsoft Edge Chromium Browser Group Policy Base Package...
		echo.-------------------------------------------------------------------------------
		call :ApplyImage "%EdgeChrGPD%\EdgeChrGPD.tpk", 1, "%InstallMount%\%%i"

		for /d %%k in (cs-CZ,da-DK,de-DE,el-GR,en-US,es-ES,fi-FI,fr-FR,hu-HU,it-IT,ja-JP,ko-KR,nb-NO,nl-NL,pl-PL,pt-BR,pt-PT,ru-RU,sv-SE,tr-TR,zh-CN,zh-TW) do (
			if "%ImageDefaultLanguage%" equ "%%k" (
				echo.-------------------------------------------------------------------------------
				echo.Integrating Microsoft Edge Chromium Browser Group Policy [%%k] Package...
				echo.-------------------------------------------------------------------------------
				call :ApplyImage "%EdgeChrGPD%\EdgeChrGPD_%%k.tpk", 1, "%InstallMount%\%%i"
			)
		)
	)
)

echo.-------------------------------------------------------------------------------
echo.####Finished Integrating Microsoft Edge Chromium Browser#######################
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set EdgeChrGPD=
set EdgeChromium=

endlocal

:: Returning to Integrate Features Menu
goto :IntFeaturesMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Integrate Windows Accessibility Braille
::-------------------------------------------------------------------------------------------
:IntBraille

setlocal

cls
echo.===============================================================================
echo.          MSMG ToolKit - Integrer le braille d'accessibilite Windows 
echo.===============================================================================
echo.

:: Getting Install Image Index Architecture
for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" call :GetImageArchitecture "%InstallWim%", %%i >nul
)

:: Setting Braille Pack Path
set "Braille=%Braille%\10.0.%ImageBuild%"

:: Setting Package Service Pack Build
if "%ImageBuild%" equ "15063" set "PackageServicePackBuild=0"
if "%ImageBuild%" equ "16299" set "PackageServicePackBuild=15"
if "%ImageBuild%" equ "17134" set "PackageServicePackBuild=1"
if "%ImageBuild%" equ "17763" set "PackageServicePackBuild=1"
if "%ImageBuild%" equ "18362" set "PackageServicePackBuild=1"
if "%ImageBuild%" equ "18363" set "PackageServicePackBuild=1"
if "%ImageBuild%" equ "19041" set "PackageServicePackBuild=1"
if "%ImageBuild%" equ "19042" set "PackageServicePackBuild=1"

:: Setting Package Architecture
if "%ImageArchitecture%" equ "x86" set "PackageArchitecture=x86"
if "%ImageArchitecture%" equ "x64" set "PackageArchitecture=amd64"
if "%ImageArchitecture%" equ "arm64" set "PackageArchitecture=arm64"

:: Checking whether Windows Accessibility Braille Pack file exist
if not exist "%Braille%\Microsoft-Windows-Accessibility-Braille-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab" (
	echo.Le dossier Windows Accessibility Braille Pack ne contient pas
	echo.le fichier ci-dessous.
	echo.
	echo."Microsoft-Windows-Accessibility-Braille-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab"
	echo.
	echo.Veuillez copier le fichier ci-dessus dans le dossier 
	echo.^<Packs\Braille\10.0.%ImageBuild%^>. 
	goto :Stop
)

call :RemoveFile "%Temp%\Microsoft-Windows-Accessibility-Braille-Package~31bf3856ad364e35~%PackageArchitecture%~~.cab"
if "%ImageBuild%" geq "17763" copy /y "%Braille%\Microsoft-Windows-Accessibility-Braille-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab" "%Temp%\Microsoft-Windows-Accessibility-Braille-Package~31bf3856ad364e35~%PackageArchitecture%~~.cab" >nul

echo.-------------------------------------------------------------------------------
echo.####Demarrage de l'integration du braille d'accessibilite Windows #############
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    : Install.wim
if /i "%ImageIndexNo%" equ "A" echo.    Image Indexes            : 1-%ImageCount%
if /i "%ImageIndexNo%" neq "A" echo.    Image Index              : %ImageIndexNo%
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
echo.
echo.-------------------------------------------------------------------------------
echo.####Integration du braille d'accessibilite Windows ############################
echo.-------------------------------------------------------------------------------

for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" (
		echo.
		if not %%i gtr 9 echo.===========================[Install.wim, Index : %%i]============================
		if %%i gtr 9 echo.==========================[Install.wim, Index : %%i]============================
		echo.

		:: Getting Image Index Information
		call :GetImageIndexInfo "%InstallWim%", %%i >nul

		if "%ImageBuild%" leq "17134" call :AddPackage "%InstallMount%\%%i", "%Braille%\Microsoft-Windows-Accessibility-Braille-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab"
		if "%ImageBuild%" geq "17763" call :AddPackage "%InstallMount%\%%i", "%Temp%\Microsoft-Windows-Accessibility-Braille-Package~31bf3856ad364e35~%PackageArchitecture%~~.cab"
	)
)

call :RemoveFile "%Temp%\Microsoft-Windows-Accessibility-Braille-Package~31bf3856ad364e35~%PackageArchitecture%~~.cab"

echo.-------------------------------------------------------------------------------
echo.####Fin de l'integration du braille d'accessibilite Windows#####################
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set Braille=
set PackageServicePackBuild=
set PackageArchitecture=

endlocal

:: Returning to Integrate Features Menu
goto :IntFeaturesMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Integrate Windows Multimedia Restricted Codecs
::-------------------------------------------------------------------------------------------
:IntMMRC

setlocal

cls
echo.===============================================================================
echo.       MSMG ToolKit - Integrate Windows Multimedia Restricted Codecs
echo.===============================================================================
echo.

:: Getting Install Image Index Architecture
for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" call :GetImageArchitecture "%InstallWim%", %%i >nul
)

:: Setting Multimedia Restricted Codecs Pack path
set "MMRC=%MMRC%\10.0.%ImageBuild%"

:: Setting Package Service Pack Build
if "%ImageBuild%" equ "14393" set "PackageServicePackBuild=0"
if "%ImageBuild%" equ "15063" set "PackageServicePackBuild=0"
if "%ImageBuild%" equ "16299" set "PackageServicePackBuild=15"
if "%ImageBuild%" equ "17134" set "PackageServicePackBuild=1"
if "%ImageBuild%" equ "17763" set "PackageServicePackBuild=1"
if "%ImageBuild%" equ "18362" set "PackageServicePackBuild=1"
if "%ImageBuild%" equ "18363" set "PackageServicePackBuild=1"
if "%ImageBuild%" equ "19041" set "PackageServicePackBuild=1"
if "%ImageBuild%" equ "19042" set "PackageServicePackBuild=1"

:: Checking whether Windows Multimedia Restricted Codecs Pack file exist
if not exist "%MMRC%\Multimedia-RestrictedCodecsExt-Package~31bf3856ad364e35~amd64~~%ImageVersion%.%PackageServicePackBuild%.cab" (
	echo.Windows Multimedia Restricted Codecs Pack folder is missing the below file...
	echo.
	echo."Multimedia-RestrictedCodecsExt-Package~31bf3856ad364e35~amd64~~%ImageVersion%.%PackageServicePackBuild%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\MultimediaRestrictedCodecs\10.0.%ImageBuild%^> folder...
	goto :Stop
)

:: Checking whether Windows Multimedia Restricted Codecs Pack file exist
if not exist "%MMRC%\Multimedia-RestrictedCodecsExt-Package~31bf3856ad364e35~amd64~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab" (
	echo.Windows Multimedia Restricted Codecs Pack folder is missing the below file...
	echo.
	echo."Multimedia-RestrictedCodecsExt-Package~31bf3856ad364e35~amd64~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\MultimediaRestrictedCodecs\10.0.%ImageBuild%^> folder...
	goto :Stop
)

:: Checking whether Windows Multimedia Restricted Codecs Pack file exist
if "%ImageBuild%" leq "17763" if "%ImageArchitecture%" equ "x64" if not exist "%MMRC%\Multimedia-RestrictedCodecsExt-WOW64-Package~31bf3856ad364e35~amd64~~%ImageVersion%.%PackageServicePackBuild%.cab" (
	echo.Windows Multimedia Restricted Codecs Pack folder is missing the below file...
	echo.
	echo."Multimedia-RestrictedCodecsExt-WOW64-Package~31bf3856ad364e35~amd64~~%ImageVersion%.%PackageServicePackBuild%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\MultimediaRestrictedCodecs\10.0.%ImageBuild%^> folder...
	goto :Stop
)

:: Checking whether Windows Multimedia Restricted Codecs Pack file exist
if "%ImageBuild%" leq "17763" if "%ImageArchitecture%" equ "x64" if not exist "%MMRC%\Multimedia-RestrictedCodecsExt-WOW64-Package~31bf3856ad364e35~amd64~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab" (
	echo.Windows Multimedia Restricted Codecs Pack folder is missing the below file...
	echo.
	echo."Multimedia-RestrictedCodecsExt-WOW64-Package~31bf3856ad364e35~amd64~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\MultimediaRestrictedCodecs\10.0.%ImageBuild%^> folder...
	goto :Stop
)

:: Checking whether Windows Multimedia Restricted Codecs Pack file exist
if "%ImageBuild%" geq "18362" if "%ImageArchitecture%" equ "x64" if not exist "%MMRC%\Multimedia-RestrictedCodecsExt-WOW64-Package~31bf3856ad364e35~wow64~~%ImageVersion%.%PackageServicePackBuild%.cab" (
	echo.Windows Multimedia Restricted Codecs Pack folder is missing the below file...
	echo.
	echo."Multimedia-RestrictedCodecsExt-WOW64-Package~31bf3856ad364e35~wow64~~%ImageVersion%.%PackageServicePackBuild%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\MultimediaRestrictedCodecs\10.0.%ImageBuild%^> folder...
	goto :Stop
)

:: Checking whether Windows Multimedia Restricted Codecs Pack file exist
if "%ImageBuild%" geq "18362" if "%ImageArchitecture%" equ "x64" if not exist "%MMRC%\Multimedia-RestrictedCodecsExt-WOW64-Package~31bf3856ad364e35~wow64~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab" (
	echo.Windows Multimedia Restricted Codecs Pack folder is missing the below file...
	echo.
	echo."Multimedia-RestrictedCodecsExt-WOW64-Package~31bf3856ad364e35~wow64~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\MultimediaRestrictedCodecs\10.0.%ImageBuild%^> folder...
	goto :Stop
)

echo.-------------------------------------------------------------------------------
echo.####Starting Integrating Windows Multimedia Restricted Codecs##################
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    : Install.wim
if /i "%ImageIndexNo%" equ "A" echo.    Image Indexes            : 1-%ImageCount%
if /i "%ImageIndexNo%" neq "A" echo.    Image Index              : %ImageIndexNo%
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
echo.
echo.-------------------------------------------------------------------------------
echo.####Integrating Windows Multimedia Restricted Codecs###########################
echo.-------------------------------------------------------------------------------

for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" (
		echo.
		if not %%i gtr 9 echo.===========================[Install.wim, Index : %%i]============================
		if %%i gtr 9 echo.==========================[Install.wim, Index : %%i]============================
		echo.

		:: Getting Image Index Information
		call :GetImageIndexInfo "%InstallWim%", %%i >nul

		echo.-------------------------------------------------------------------------------
		echo.Integrating Windows Multimedia Restricted Codecs Base Package...
		echo.-------------------------------------------------------------------------------
		call :AddPackage "%InstallMount%\%%i", "%MMRC%\Multimedia-RestrictedCodecsExt-Package~31bf3856ad364e35~amd64~~%ImageVersion%.%PackageServicePackBuild%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating Windows Multimedia Restricted Codecs [%ImageDefaultLanguage%] Language Package...
		echo.-------------------------------------------------------------------------------
		call :AddPackage "%InstallMount%\%%i", "%MMRC%\Multimedia-RestrictedCodecsExt-Package~31bf3856ad364e35~amd64~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab"
		echo.-------------------------------------------------------------------------------

		if "%ImageArchitecture%" equ "x64" (
			echo.Integrating Windows Multimedia Restricted Codecs WOW64 Base Package...
			echo.-------------------------------------------------------------------------------
			if "%ImageBuild%" leq "17763" call :AddPackage "%InstallMount%\%%i", "%MMRC%\Multimedia-RestrictedCodecsExt-WOW64-Package~31bf3856ad364e35~amd64~~%ImageVersion%.%PackageServicePackBuild%.cab"
			if "%ImageBuild%" geq "18362" call :AddPackage "%InstallMount%\%%i", "%MMRC%\Multimedia-RestrictedCodecsExt-WOW64-Package~31bf3856ad364e35~wow64~~%ImageVersion%.%PackageServicePackBuild%.cab"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Windows Multimedia Restricted Codecs WOW64 [%ImageDefaultLanguage%] Language Package...
			echo.-------------------------------------------------------------------------------
			if "%ImageBuild%" leq "17763" call :AddPackage "%InstallMount%\%%i", "%MMRC%\Multimedia-RestrictedCodecsExt-WOW64-Package~31bf3856ad364e35~amd64~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab"
			if "%ImageBuild%" geq "18362" call :AddPackage "%InstallMount%\%%i", "%MMRC%\Multimedia-RestrictedCodecsExt-WOW64-Package~31bf3856ad364e35~wow64~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab"
		)
	)
)

echo.-------------------------------------------------------------------------------
echo.####Finished Integrating Windows Multimedia Restricted Codecs##################
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set MMRC=
set PackageServicePackBuild=

endlocal

:: Returning to Integrate Features Menu
goto :IntFeaturesMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Integrate Windows Subsystem for Linux ^(WSL^)
::-------------------------------------------------------------------------------------------
:IntWSL

setlocal

cls
echo.===============================================================================
echo.        MSMG ToolKit - Integrate Windows Subsystem for Linux ^(WSL^)
echo.===============================================================================
echo.

:: Getting Install Image Index Architecture
for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" call :GetImageArchitecture "%InstallWim%", %%i >nul
)

:: Setting Windows Subsystem for Linux (WSL) Pack Path
set "WSL=%WSL%\10.0.%ImageBuild%"

:: Setting Package Service Pack Build
if "%ImageBuild%" equ "14393" set "PackageServicePackBuild=0"
if "%ImageBuild%" equ "15063" set "PackageServicePackBuild=0"
if "%ImageBuild%" equ "16299" set "PackageServicePackBuild=15"
if "%ImageBuild%" equ "17134" set "PackageServicePackBuild=1"
if "%ImageBuild%" equ "17763" set "PackageServicePackBuild=1"
if "%ImageBuild%" equ "18362" set "PackageServicePackBuild=1"
if "%ImageBuild%" equ "18363" set "PackageServicePackBuild=1"
if "%ImageBuild%" equ "19041" set "PackageServicePackBuild=1"
if "%ImageBuild%" equ "19042" set "PackageServicePackBuild=1"

:: Checking whether Windows Subsystem for Linux (WSL) Pack file exist
if not exist "%WSL%\Microsoft-Windows-Lxss-Optional-Package~31bf3856ad364e35~amd64~~%ImageVersion%.%PackageServicePackBuild%.cab" (
	echo.Windows Subsystem for Linux ^(WSL^) Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-Lxss-Optional-Package~31bf3856ad364e35~amd64~~%ImageVersion%.%PackageServicePackBuild%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\WSL\10.0.%ImageBuild%^> folder...
	goto :Stop
)

:: Checking whether Windows Subsystem for Linux (WSL) Pack file exist
if not exist "%WSL%\Microsoft-Windows-Lxss-Optional-Package~31bf3856ad364e35~amd64~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab" (
	echo.Windows Subsystem for Linux ^(WSL^) Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-Lxss-Optional-Package~31bf3856ad364e35~amd64~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\WSL\10.0.%ImageBuild%^> folder...
	goto :Stop
)

echo.-------------------------------------------------------------------------------
echo.####Starting Integrating Windows Subsystem for Linux ^(WSL^)#####################
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    : Install.wim
if /i "%ImageIndexNo%" equ "A" echo.    Image Indexes            : 1-%ImageCount%
if /i "%ImageIndexNo%" neq "A" echo.    Image Index              : %ImageIndexNo%
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
echo.
echo.-------------------------------------------------------------------------------
echo.####Integrating Windows Subsystem for Linux ^(WSL^)##############################
echo.-------------------------------------------------------------------------------

for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" (
		echo.
		if not %%i gtr 9 echo.===========================[Install.wim, Index : %%i]============================
		if %%i gtr 9 echo.==========================[Install.wim, Index : %%i]============================
		echo.

		:: Getting Image Index Information
		call :GetImageIndexInfo "%InstallWim%", %%i >nul

		echo.-------------------------------------------------------------------------------
		echo.Integrating Windows Subsystem for Linux ^(WSL^) Base Package...
		echo.-------------------------------------------------------------------------------
		call :AddPackage "%InstallMount%\%%i", "%WSL%\Microsoft-Windows-Lxss-Optional-Package~31bf3856ad364e35~amd64~~%ImageVersion%.%PackageServicePackBuild%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating Windows Subsystem for Linux ^(WSL^) [%ImageDefaultLanguage%] Language Package...
		echo.-------------------------------------------------------------------------------
		call :AddPackage "%InstallMount%\%%i", "%WSL%\Microsoft-Windows-Lxss-Optional-Package~31bf3856ad364e35~amd64~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab"
		echo.-------------------------------------------------------------------------------
		echo.Enabling Windows Subsystem for Linux ^(WSL^) Feature...
		echo.-------------------------------------------------------------------------------
		call :EnableFeature "%InstallMount%\%%i", "Microsoft-Windows-Subsystem-Linux /All"
	)
)

echo.-------------------------------------------------------------------------------
echo.####Finished Integrating Windows Subsystem for Linux ^(WSL^)#####################
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set PackageServicePackBuild=
set WSL=

endlocal

:: Returning to Integrate Features Menu
goto :IntFeaturesMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Integrate Open Secure Shell (SSH) Client & Server
::-------------------------------------------------------------------------------------------
:IntOpenSSH

setlocal

cls
echo.===============================================================================
echo.      MSMG ToolKit - Integrate Open Secure Shell ^(SSH^) Client ^& Server
echo.===============================================================================
echo.

:: Getting Install Image Index Architecture
for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" call :GetImageArchitecture "%InstallWim%", %%i >nul
)

:: Setting Open Secure Shell Pack Path
set "OpenSSH=%OpenSSH%\10.0.%ImageBuild%"

:: Setting Package Service Pack Build
if "%ImageBuild%" equ "16299" set "PackageServicePackBuild=15"
if "%ImageBuild%" equ "17134" set "PackageServicePackBuild=1"
if "%ImageBuild%" equ "17763" set "PackageServicePackBuild=1"
if "%ImageBuild%" equ "18362" set "PackageServicePackBuild=1"
if "%ImageBuild%" equ "18363" set "PackageServicePackBuild=1"
if "%ImageBuild%" equ "19041" set "PackageServicePackBuild=1"
if "%ImageBuild%" equ "19042" set "PackageServicePackBuild=1"

:: Setting Package Architecture
if "%ImageArchitecture%" equ "x86" set "PackageArchitecture=x86"
if "%ImageArchitecture%" equ "x64" set "PackageArchitecture=amd64"
if "%ImageArchitecture%" equ "arm64" set "PackageArchitecture=arm64"

:: Checking whether Open Secure Shell (SSH) Client Pack file exist
if not exist "%OpenSSH%\OpenSSH-Client-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab" (
	echo.OpenSSH Client ^& Server Pack folder is missing the below file...
	echo.
	echo."OpenSSH-Client-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\OpenSSH\10.0.%ImageBuild%^> folder...
	goto :Stop
)

:: Checking whether Open Secure Shell (SSH) Server Pack file exist
if not exist "%OpenSSH%\OpenSSH-Server-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab" (
	echo.OpenSSH Client ^& Server Pack folder is missing the below file...
	echo.
	echo."OpenSSH-Server-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\OpenSSH\10.0.%ImageBuild%^> folder...
	goto :Stop
)

call :RemoveFile "%Temp%\OpenSSH-Client-Package~31bf3856ad364e35~%PackageArchitecture%~~.cab"
call :RemoveFile "%Temp%\OpenSSH-Server-Package~31bf3856ad364e35~%PackageArchitecture%~~.cab"

if "%ImageBuild%" geq "17763" (
	copy /y "%OpenSSH%\OpenSSH-Client-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab" "%Temp%\OpenSSH-Client-Package~31bf3856ad364e35~%PackageArchitecture%~~.cab" >nul
	copy /y "%OpenSSH%\OpenSSH-Server-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab" "%Temp%\OpenSSH-Server-Package~31bf3856ad364e35~%PackageArchitecture%~~.cab" >nul
)

echo.-------------------------------------------------------------------------------
echo.####Starting Integrating Open Secure Shell ^(SSH^) Client ^& Server##############
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    : Install.wim
if /i "%ImageIndexNo%" equ "A" echo.    Image Indexes            : 1-%ImageCount%
if /i "%ImageIndexNo%" neq "A" echo.    Image Index              : %ImageIndexNo%
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
echo.
echo.-------------------------------------------------------------------------------
echo.####Integrating Open Secure Shell ^(SSH^) Client ^& Server#######################
echo.-------------------------------------------------------------------------------

for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" (
		echo.
		if not %%i gtr 9 echo.===========================[Install.wim, Index : %%i]============================
		if %%i gtr 9 echo.==========================[Install.wim, Index : %%i]============================
		echo.

		:: Getting Image Index Information
		call :GetImageIndexInfo "%InstallWim%", %%i >nul

		echo.-------------------------------------------------------------------------------
		echo.Integrating OpenSSH Client Package...
		echo.-------------------------------------------------------------------------------
		if "%ImageBuild%" leq "17134" call :AddPackage "%InstallMount%\%%i", "%OpenSSH%\OpenSSH-Client-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab"
		if "%ImageBuild%" geq "17763" call :AddPackage "%InstallMount%\%%i", "%Temp%\OpenSSH-Client-Package~31bf3856ad364e35~%PackageArchitecture%~~.cab"
		echo.-------------------------------------------------------------------------------
		echo.Integrating OpenSSH Server Package...
		echo.-------------------------------------------------------------------------------
		if "%ImageBuild%" leq "17134" call :AddPackage "%InstallMount%\%%i", "%OpenSSH%\OpenSSH-Server-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab"
		if "%ImageBuild%" geq "17763" call :AddPackage "%InstallMount%\%%i", "%Temp%\OpenSSH-Server-Package~31bf3856ad364e35~%PackageArchitecture%~~.cab"
	)
)

call :RemoveFile "%Temp%\OpenSSH-Server-Package~31bf3856ad364e35~%PackageArchitecture%~~.cab"
call :RemoveFile "%Temp%\OpenSSH-Server-Package~31bf3856ad364e35~%PackageArchitecture%~~.cab"

echo.-------------------------------------------------------------------------------
echo.####Finished Integrating Open Secure Shell ^(SSH^) Client ^& Server##############
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set OpenSSH=
set PackageServicePackBuild=
set PackageArchitecture=

endlocal

:: Returning to Integrate Features Menu
goto :IntFeaturesMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Integrate Windows Media Feature Pack
::-------------------------------------------------------------------------------------------
:IntMediaFeaturePack

setlocal

cls
echo.===============================================================================
echo.             MSMG ToolKit - Integrate Windows Media Feature Pack
echo.===============================================================================
echo.

:: Setting Windows Media Feature Pack folder path according to selected Source OS
if "%SelectedSourceOS%" neq "w10" set "MediaFeaturePack=%MediaFeaturePack%\%SelectedSourceOS%"
if "%SelectedSourceOS%" equ "w10" set "MediaFeaturePack=%MediaFeaturePack%\%SelectedSourceOS%\%ImageVersion%"

:: Getting Install Image Index Architecture
for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" call :GetImageArchitecture "%InstallWim%", %%i >nul
)

:: Setting Package Service Pack Build
if "%SelectedSourceOS%" equ "w10" (
	if "%ImageBuild%" equ "10240" set "PackageServicePackBuild=16384"
	if "%ImageBuild%" equ "10586" set "PackageServicePackBuild=0"
	if "%ImageBuild%" equ "14393" set "PackageServicePackBuild=0"
	if "%ImageBuild%" equ "15063" set "PackageServicePackBuild=0"
	if "%ImageBuild%" equ "16299" set "PackageServicePackBuild=15"
	if "%ImageBuild%" equ "17134" set "PackageServicePackBuild=1"
	if "%ImageBuild%" equ "17763" set "PackageServicePackBuild=1"
	if "%ImageBuild%" equ "18362" set "PackageServicePackBuild=1"
	if "%ImageBuild%" equ "18363" set "PackageServicePackBuild=1"
	if "%ImageBuild%" equ "19041" set "PackageServicePackBuild=1"
	if "%ImageBuild%" equ "19042" set "PackageServicePackBuild=1"
)

:: Setting Package Architecture
if "%ImageArchitecture%" equ "x86" set "PackageArchitecture=x86"
if "%ImageArchitecture%" equ "x64" set "PackageArchitecture=amd64"
if "%ImageArchitecture%" equ "arm64" set "PackageArchitecture=arm64"

:: Checking whether Windows Media Feature Pack file exist
if "%SelectedSourceOS%" equ "w7" if not exist "%MediaFeaturePack%\Microsoft-Windows-MediaFeaturePack-OOB-Package~31bf3856ad364e35~%PackageArchitecture%~~6.1.7600.16385.cab" (
	echo.Windows Media Feature Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-MediaFeaturePack-OOB-Package~31bf3856ad364e35~%PackageArchitecture%~~6.1.7600.16385.cab"
	echo.
	echo.Please copy the above file to ^<Packs\MediaFeaturePack\%SelectedSourceOS%^> folder...
	goto :Stop
)

:: Checking whether Windows Media Feature Pack file exist
if "%SelectedSourceOS%" equ "w7" if not exist "%MediaFeaturePack%\Microsoft-Windows-Media-Format-OOB-Package~31bf3856ad364e35~%PackageArchitecture%~~6.1.7600.16385.cab" (
	echo.Windows Media Feature Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-Media-Format-OOB-Package~31bf3856ad364e35~%PackageArchitecture%~~6.1.7600.16385.cab"
	echo.
	echo.Please copy the above file to ^<Packs\MediaFeaturePack\%SelectedSourceOS%^> folder...
	goto :Stop
)

:: Checking whether Windows Media Feature Pack file exist
if "%SelectedSourceOS%" equ "w81" if not exist "%MediaFeaturePack%\Microsoft-Windows-MediaFeaturePack-OOB-Package~31bf3856ad364e35~%PackageArchitecture%~~6.3.9600.16384.cab" (
	echo.Windows Media Feature Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-MediaFeaturePack-OOB-Package~31bf3856ad364e35~%PackageArchitecture%~~6.3.9600.16384.cab"
	echo.
	echo.Please copy the above file to ^<Packs\MediaFeaturePack\%SelectedSourceOS%^> folder...
	goto :Stop
)

:: Checking whether Windows Media Feature Pack file exist
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" leq "17763" if not exist "%MediaFeaturePack%\Microsoft-Windows-MediaFeaturePack-OOB-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab" (
	echo.Windows Media Feature Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-MediaFeaturePack-OOB-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\MediaFeaturePack\%SelectedSourceOS%\%ImageVersion%^> folder...
	goto :Stop
)

:: Checking whether Windows Media Feature Pack file exist
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" leq "17763" if not exist "%MediaFeaturePack%\Microsoft-Windows-MediaFeaturePack-OOB-Package~31bf3856ad364e35~%PackageArchitecture%~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab" (
	echo.Windows Media Feature Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-MediaFeaturePack-OOB-Package~31bf3856ad364e35~%PackageArchitecture%~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\MediaFeaturePack\%SelectedSourceOS%\%ImageVersion%^> folder...
	goto :Stop
)

:: Checking whether Windows Media Feature Pack file exist
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "18362" if not exist "%MediaFeaturePack%\Microsoft-Windows-Media-Features-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab" (
	echo.Windows Media Feature Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-Media-Features-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\MediaFeaturePack\%SelectedSourceOS%\%ImageVersion%^> folder...
	goto :Stop
)

:: Checking whether Windows Media Feature Pack file exist
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "18362" if not exist "%MediaFeaturePack%\Microsoft-Windows-Media-Features-Package~31bf3856ad364e35~%PackageArchitecture%~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab" (
	echo.Windows Media Feature Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-Media-Features-Package~31bf3856ad364e35~%PackageArchitecture%~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\MediaFeaturePack\%SelectedSourceOS%\%ImageVersion%^> folder...
	goto :Stop
)

:: Checking whether Windows Media Feature Pack file exist
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "18362" if "%ImageArchitecture%" equ "x64" if not exist "%MediaFeaturePack%\Microsoft-Windows-Media-Features-Package~31bf3856ad364e35~wow64~~%ImageVersion%.%PackageServicePackBuild%.cab" (
	echo.Windows Media Feature Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-Media-Features-Package~31bf3856ad364e35~wow64~~%ImageVersion%.%PackageServicePackBuild%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\MediaFeaturePack\%SelectedSourceOS%\%ImageVersion%^> folder...
	goto :Stop
)

:: Checking whether Windows Media Feature Pack file exist
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "18362" if "%ImageArchitecture%" equ "x64" if not exist "%MediaFeaturePack%\Microsoft-Windows-Media-Features-Package~31bf3856ad364e35~wow64~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab" (
	echo.Windows Media Feature Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-Media-Features-Package~31bf3856ad364e35~wow64~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\MediaFeaturePack\%SelectedSourceOS%\%ImageVersion%^> folder...
	goto :Stop
)

echo.-------------------------------------------------------------------------------
echo.####Starting Integrating Windows Media Feature Pack############################
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    : Install.wim
if /i "%ImageIndexNo%" equ "A" echo.    Image Indexes            : 1-%ImageCount%
if /i "%ImageIndexNo%" neq "A" echo.    Image Index              : %ImageIndexNo%
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
echo.
echo.-------------------------------------------------------------------------------
echo.####Integrating Windows Media Feature Pack#####################################
echo.-------------------------------------------------------------------------------

for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" (
		echo.
		if not %%i gtr 9 echo.===========================[Install.wim, Index : %%i]============================
		if %%i gtr 9 echo.==========================[Install.wim, Index : %%i]============================
		echo.

		:: Getting Image Index Information
		call :GetImageIndexInfo "%InstallWim%", %%i >nul

		for /d %%j in (StarterN, StarterKN, HomeBasicN, HomeBasicKN, CoreN, CloudN, ProessionalN, ProfessionalKN, ProfessionalEducationN, ProfessionalEducationKN, EnterpriseN, EnterpriseKN, EnterpriseSN, EnterpriseGN, UltimateN, UltimateKN, EducationN, EducationKN) do (
			if "%ImageEdition%" equ "%%j" (
				if "%SelectedSourceOS%" equ "w7" (
					echo.-------------------------------------------------------------------------------
					echo.Integrating Microsoft Windows Media Feature Pack OOB Package
					echo.-------------------------------------------------------------------------------
					call :AddPackage "%InstallMount%\%%i", "%MediaFeaturePack%\Microsoft-Windows-MediaFeaturePack-OOB-Package~31bf3856ad364e35~%PackageArchitecture%~~6.1.7600.16385.cab"
					echo.-------------------------------------------------------------------------------
					echo.Integrating Microsoft Windows Media Format OOB Package
					echo.-------------------------------------------------------------------------------
					call :AddPackage "%InstallMount%\%%i", "%MediaFeaturePack%\Microsoft-Windows-Media-Format-OOB-Package~31bf3856ad364e35~%PackageArchitecture%~~6.1.7600.16385.cab"
				)

				if "%SelectedSourceOS%" equ "w81" call :AddPackage "%InstallMount%\%%i", "%MediaFeaturePack%\Microsoft-Windows-MediaFeaturePack-OOB-Package~31bf3856ad364e35~%PackageArchitecture%~~6.3.9600.16384.cab"

				if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" leq "17763" (
					echo.-------------------------------------------------------------------------------
					echo.Integrating Microsoft Windows Media Feature Pack OOB Package
					echo.-------------------------------------------------------------------------------
					call :AddPackage "%InstallMount%\%%i", "%MediaFeaturePack%\Microsoft-Windows-MediaFeaturePack-OOB-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab"
					echo.-------------------------------------------------------------------------------
					echo.Integrating Microsoft Windows Media Feature Pack OOB [%ImageDefaultLanguage%] Package
					echo.-------------------------------------------------------------------------------
					call :AddPackage "%InstallMount%\%%i", "%MediaFeaturePack%\Microsoft-Windows-MediaFeaturePack-OOB-Package~31bf3856ad364e35~%PackageArchitecture%~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab"
				)

				if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "18362" (
					call :RemoveFolder "%Temp%\Updates\MediaFeaturePack"
					call :CreateFolder "%Temp%\Updates\MediaFeaturePack"
					expand -R "%MediaFeaturePack%\Microsoft-Windows-Media-Features-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab" -F:* "%Temp%\Updates\MediaFeaturePack" >nul

					echo.-------------------------------------------------------------------------------
					echo.Integrating Microsoft Windows Media Features Package
					echo.-------------------------------------------------------------------------------
					call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\MediaFeaturePack"
					echo.-------------------------------------------------------------------------------
					echo.Integrating Microsoft Windows Media Features [%ImageDefaultLanguage%] Package
					echo.-------------------------------------------------------------------------------
					call :AddPackage "%InstallMount%\%%i", "%MediaFeaturePack%\Microsoft-Windows-Media-Features-Package~31bf3856ad364e35~%PackageArchitecture%~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab"

					if "%ImageArchitecture%" equ "x64" (
						echo.-------------------------------------------------------------------------------
						echo.Integrating Microsoft Windows Media Features WOW64 Package...
						echo.-------------------------------------------------------------------------------
						call :AddPackage "%InstallMount%\%%i", "%MediaFeaturePack%\Microsoft-Windows-Media-Features-Package~31bf3856ad364e35~wow64~~%ImageVersion%.%PackageServicePackBuild%.cab"
						echo.-------------------------------------------------------------------------------
						echo.Integrating Microsoft Windows Media Features [%ImageDefaultLanguage%] WOW64 Package...
						echo.-------------------------------------------------------------------------------
						call :AddPackage "%InstallMount%\%%i", "%MediaFeaturePack%\Microsoft-Windows-Media-Features-Package~31bf3856ad364e35~wow64~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab"
					)

					call :RemoveFolder "%Temp%\Updates"
				)
			)
		)
	)
)

echo.-------------------------------------------------------------------------------
echo.####Finished Integrating Windows Media Feature Pack############################
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set MediaFeaturePack=
set PackageServicePackBuild=
set PackageArchitecture=

endlocal

:: Returning to Integrate Features Menu
goto :IntFeaturesMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Integrate Windows Mixed Reality
::-------------------------------------------------------------------------------------------
:IntWMR

setlocal

cls
echo.===============================================================================
echo.              MSMG ToolKit - Integrate Windows Mixed Reality
echo.===============================================================================
echo.

:: Setting Windows Mixed Reality folder path according to selected Source OS
set "WMR=%WMR%\%ImageVersion%"

:: Getting Install Image Index Architecture
for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" call :GetImageArchitecture "%InstallWim%", %%i >nul
)

:: Checking whether Windows Mixed Reality file exist
if not exist "%WMR%\Microsoft-Windows-Holographic-Desktop-FOD-Package~31bf3856ad364e35~amd64~~.cab" (
	echo.Windows Mixed Reality folder is missing the below file...
	echo.
	echo."Microsoft-Windows-Holographic-Desktop-FOD-Package~31bf3856ad364e35~amd64~~.cab"
	echo.
	echo.Please copy the above file to ^<Packs\WMR\%ImageVersion%^> folder...
	goto :Stop
)

echo.-------------------------------------------------------------------------------
echo.####Starting Integrating Windows Mixed Reality#################################
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    : Install.wim
if /i "%ImageIndexNo%" equ "A" echo.    Image Indexes            : 1-%ImageCount%
if /i "%ImageIndexNo%" neq "A" echo.    Image Index              : %ImageIndexNo%
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
echo.
echo.-------------------------------------------------------------------------------
echo.####Integrating Windows Mixed Reality##########################################
echo.-------------------------------------------------------------------------------

for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" (
		echo.
		if not %%i gtr 9 echo.===========================[Install.wim, Index : %%i]============================
		if %%i gtr 9 echo.==========================[Install.wim, Index : %%i]============================
		echo.

		:: Getting Image Index Information
		call :GetImageIndexInfo "%InstallWim%", %%i >nul

		call :AddPackage "%InstallMount%\%%i", "%WMR%\Microsoft-Windows-Holographic-Desktop-FOD-Package~31bf3856ad364e35~amd64~~.cab"
	)
)

echo.-------------------------------------------------------------------------------
echo.####Finished Integrating Windows Mixed Reality#################################
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set WMR=

endlocal

:: Returning to Integrate Features Menu
goto :IntFeaturesMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Integrate Windows Portable Devices
::-------------------------------------------------------------------------------------------
:IntPortableDevices

setlocal

cls
echo.===============================================================================
echo.             MSMG ToolKit - Integrate Windows Portable Devices
echo.===============================================================================
echo.

:: Getting Install Image Index Architecture
for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" call :GetImageArchitecture "%InstallWim%", %%i >nul
)

:: Setting Windows Portable Devices Pack Path
set "PortableDevices=%PortableDevices%\10.0.%ImageBuild%"

:: Setting Package Service Pack Build
if "%ImageBuild%" equ "10240" set "PackageServicePackBuild=16384"
if "%ImageBuild%" equ "14393" set "PackageServicePackBuild=0"
if "%ImageBuild%" equ "15063" set "PackageServicePackBuild=0"
if "%ImageBuild%" equ "16299" set "PackageServicePackBuild=15"
if "%ImageBuild%" equ "17134" set "PackageServicePackBuild=1"
if "%ImageBuild%" equ "17763" set "PackageServicePackBuild=1"
if "%ImageBuild%" equ "18362" set "PackageServicePackBuild=1"
if "%ImageBuild%" equ "18363" set "PackageServicePackBuild=1"
if "%ImageBuild%" equ "19041" set "PackageServicePackBuild=1"
if "%ImageBuild%" equ "19042" set "PackageServicePackBuild=1"

:: Setting Package Architecture
if "%ImageArchitecture%" equ "x86" set "PackageArchitecture=x86"
if "%ImageArchitecture%" equ "x64" set "PackageArchitecture=amd64"

:: Checking whether Windows Portable Devices Pack file exist
if not exist "%PortableDevices%\Microsoft-Windows-Portable-Devices-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab" (
	echo.Windows Portable Devices Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-Portable-Devices-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\PortableDevices\10.0.%ImageBuild%^> folder...
	goto :Stop
)

:: Checking whether Windows Portable Devices Pack file exist
if not exist "%PortableDevices%\Microsoft-Windows-Portable-Devices-Package~31bf3856ad364e35~%PackageArchitecture%~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab" (
	echo.Windows Portable Devices Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-Portable-Devices-Package~31bf3856ad364e35~%PackageArchitecture%~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\PortableDevices\10.0.%ImageBuild%^> folder...
	goto :Stop
)

:: Checking whether Windows Portable Devices Pack file exist
if "%ImageBuild%" leq "17763" if "%ImageArchitecture%" equ "x64" if not exist "%PortableDevices%\Microsoft-Windows-Portable-Devices-WOW64-Package~31bf3856ad364e35~amd64~~%ImageVersion%.%PackageServicePackBuild%.cab" (
	echo.Windows Portable Devices Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-Portable-Devices-WOW64-Package~31bf3856ad364e35~amd64~~%ImageVersion%.%PackageServicePackBuild%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\PortableDevices\10.0.%ImageBuild%^> folder...
	goto :Stop
)

:: Checking whether Windows Portable Devices Pack file exist
if "%ImageBuild%" leq "17763" if "%ImageArchitecture%" equ "x64" if not exist "%PortableDevices%\Microsoft-Windows-Portable-Devices-WOW64-Package~31bf3856ad364e35~amd64~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab" (
	echo.Windows Portable Devices Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-Portable-Devices-WOW64-Package~31bf3856ad364e35~amd64~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\PortableDevices\10.0.%ImageBuild%^> folder...
	goto :Stop
)

:: Checking whether Windows Portable Devices Pack file exist
if "%ImageBuild%" geq "18362" if "%ImageArchitecture%" equ "x64" if not exist "%PortableDevices%\Microsoft-Windows-Portable-Devices-WOW64-Package~31bf3856ad364e35~wow64~~%ImageVersion%.%PackageServicePackBuild%.cab" (
	echo.Windows Portable Devices Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-Portable-Devices-WOW64-Package~31bf3856ad364e35~wow64~~%ImageVersion%.%PackageServicePackBuild%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\PortableDevices\10.0.%ImageBuild%^> folder...
	goto :Stop
)

:: Checking whether Windows Portable Devices Pack file exist
if "%ImageBuild%" geq "18362" if "%ImageArchitecture%" equ "x64" if not exist "%PortableDevices%\Microsoft-Windows-Portable-Devices-WOW64-Package~31bf3856ad364e35~wow64~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab" (
	echo.Windows Portable Devices Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-Portable-Devices-WOW64-Package~31bf3856ad364e35~wow64~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\PortableDevices\10.0.%ImageBuild%^> folder...
	goto :Stop
)

echo.-------------------------------------------------------------------------------
echo.####Starting Integrating Windows Portable Devices##############################
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    : Install.wim
if /i "%ImageIndexNo%" equ "A" echo.    Image Indexes            : 1-%ImageCount%
if /i "%ImageIndexNo%" neq "A" echo.    Image Index              : %ImageIndexNo%
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
echo.
echo.-------------------------------------------------------------------------------
echo.####Integrating Windows Portable Devices#######################################
echo.-------------------------------------------------------------------------------

for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" (
		echo.
		if not %%i gtr 9 echo.===========================[Install.wim, Index : %%i]============================
		if %%i gtr 9 echo.==========================[Install.wim, Index : %%i]============================
		echo.

		:: Getting Image Index Information
		call :GetImageIndexInfo "%InstallWim%", %%i >nul

		for /d %%j in (StarterN,StarterKN,HomeBasicN,HomeBasicKN,CoreN,CloudN,ProfessionalN,ProfessionalKN,ProfessionalEducationN,ProfessionalEducationKN,EnterpriseN,EnterpriseKN,EnterpriseSN,EnterpriseGN,UltimateN,UltimateKN,EducationN,EducationKN) do (
			if "%ImageEdition%" equ "%%j" (
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows Portable Devices Package...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%PortableDevices%\Microsoft-Windows-Portable-Devices-Package~31bf3856ad364e35~%PackageArchitecture%~~%ImageVersion%.%PackageServicePackBuild%.cab"
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows Portable Devices [%ImageDefaultLanguage%] Language Package...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%PortableDevices%\Microsoft-Windows-Portable-Devices-Package~31bf3856ad364e35~%PackageArchitecture%~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab"

				if "%ImageArchitecture%" equ "x64" (
					echo.-------------------------------------------------------------------------------
					echo.Integrating Windows Portable Devices WOW64 Package...
					echo.-------------------------------------------------------------------------------
					if "%ImageBuild%" leq "17763" call :AddPackage "%InstallMount%\%%i", "%PortableDevices%\Microsoft-Windows-Portable-Devices-WOW64-Package~31bf3856ad364e35~amd64~~%ImageVersion%.%PackageServicePackBuild%.cab"
					if "%ImageBuild%" geq "18362" call :AddPackage "%InstallMount%\%%i", "%PortableDevices%\Microsoft-Windows-Portable-Devices-WOW64-Package~31bf3856ad364e35~wow64~~%ImageVersion%.%PackageServicePackBuild%.cab"
					echo.-------------------------------------------------------------------------------
					echo.Integrating Windows Portable Devices [%ImageDefaultLanguage%] Language WOW64 Package...
					echo.-------------------------------------------------------------------------------
					if "%ImageBuild%" leq "17763" call :AddPackage "%InstallMount%\%%i", "%PortableDevices%\Microsoft-Windows-Portable-Devices-WOW64-Package~31bf3856ad364e35~amd64~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab"
					if "%ImageBuild%" geq "18362" call :AddPackage "%InstallMount%\%%i", "%PortableDevices%\Microsoft-Windows-Portable-Devices-WOW64-Package~31bf3856ad364e35~wow64~%ImageDefaultLanguage%~%ImageVersion%.%PackageServicePackBuild%.cab"
				)
			)
		)
	)
)

echo.-------------------------------------------------------------------------------
echo.####Finished Integrating Windows Portable Devices##############################
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set PortableDevices=
set PackageServicePackBuild=
set PackageArchitecture=

endlocal

:: Returning to Integrate Features Menu
goto :IntFeaturesMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Integrate Windows PowerShell 7.1
::-------------------------------------------------------------------------------------------
:IntPowerShell7

setlocal

cls
echo.===============================================================================
echo.              MSMG ToolKit - Integrate Windows PowerShell 7.1
echo.===============================================================================
echo.

:: Getting Install Image Index Architecture
for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" call :GetImageArchitecture "%InstallWim%", %%i >nul
)

:: Checking whether Windows PowerShell 7.1 Pack file exist
if not exist "%PowerShell7%\PowerShell7_%SelectedSourceOS%.tpk" (
	echo.Windows PowerShell 7.1 Pack folder is missing the below file...
	echo.
	echo."PowerShell7_%SelectedSourceOS%.tpk"
	echo.
	echo.Please copy the above file to ^<Packs\PowerShell7^> folder...
	goto :Stop
)

:: Checking whether Windows PowerShell 7.1 Pack file exist
if not exist "%PowerShell7%\PowerShell7_%SelectedSourceOS%_%ImageArchitecture%.reg" (
	echo.Windows PowerShell 7.1 Pack folder is missing the below file...
	echo.
	echo."PowerShell7_%SelectedSourceOS%_%ImageArchitecture%.reg"
	echo.
	echo.Please copy the above file to ^<Packs\PowerShell7^> folder...
	goto :Stop
)

:: Checking whether Windows PowerShell 7.1 Pack file exist
if "%SelectedSourceOS%" equ "w7" if not exist "%PowerShell7%\Windows6.1-KB3118401-%ImageArchitecture%.cab" (
	echo.Windows PowerShell 7.1 Pack folder is missing the below file...
	echo.
	echo."Windows6.1-KB3118401-%ImageArchitecture%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\PowerShell7^> folder...
	goto :Stop
)

:: Checking whether Windows PowerShell 7.1 Pack file exist
if "%SelectedSourceOS%" equ "w81" if not exist "%PowerShell7%\Windows8.1-KB3118401-%ImageArchitecture%.cab" (
	echo.Windows PowerShell 7.1 Pack folder is missing the below file...
	echo.
	echo."Windows8.1-KB3118401-%ImageArchitecture%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\PowerShell7^> folder...
	goto :Stop
)

echo.-------------------------------------------------------------------------------
echo.####Starting Integrating Windows PowerShell 7.1################################
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    : Install.wim
if /i "%ImageIndexNo%" equ "A" echo.    Image Indexes            : 1-%ImageCount%
if /i "%ImageIndexNo%" neq "A" echo.    Image Index              : %ImageIndexNo%
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
echo.
echo.-------------------------------------------------------------------------------
echo.####Integrating Windows PowerShell 7.1#########################################
echo.-------------------------------------------------------------------------------

for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" (
		echo.
		if not %%i gtr 9 echo.===========================[Install.wim, Index : %%i]============================
		if %%i gtr 9 echo.==========================[Install.wim, Index : %%i]============================
		echo.

		:: Getting Image Index Information
		call :GetImageIndexInfo "%InstallWim%", %%i >nul

		if "%SelectedSourceOS%" neq "w10" (
			echo.-------------------------------------------------------------------------------
			echo.Integrating Windows Universal C Runtime ^(CRT^) Package...
			echo.-------------------------------------------------------------------------------
			if "%SelectedSourceOS%" equ "w7" call :AddPackage "%InstallMount%\%%i", "%PowerShell7%\Windows6.1-KB3118401-%ImageArchitecture%.cab"
			if "%SelectedSourceOS%" equ "w81" call :AddPackage "%InstallMount%\%%i", "%PowerShell7%\Windows8.1-KB3118401-%ImageArchitecture%.cab"
		)

		echo.-------------------------------------------------------------------------------
		echo.Integrating Windows PowerShell 7.1 Package...
		echo.-------------------------------------------------------------------------------
		if "%ImageArchitecture%" equ "x86" call :ApplyImage "%PowerShell7%\PowerShell7_%SelectedSourceOS%.tpk", 1, "%InstallMount%\%%i"
		if "%ImageArchitecture%" equ "x64" call :ApplyImage "%PowerShell7%\PowerShell7_%SelectedSourceOS%.tpk", 2, "%InstallMount%\%%i"
		echo.-------------------------------------------------------------------------------
		echo.Importing Windows PowerShell 7.1 Registry Settings...
		echo.-------------------------------------------------------------------------------
		echo.
		echo.Montage du registre d'images
		call :MountImageRegistry "%InstallMount%\%%i"
		echo.Importing Registry Settings to Image Registry...
		call :ImportRegistry2Image "%PowerShell7%\PowerShell7_%SelectedSourceOS%_%ImageArchitecture%.reg"
		echo.Demontage du registre d'images 
		call :UnMountImageRegistry
	)
)

echo.
echo.-------------------------------------------------------------------------------
echo.####Finished Integrating Windows PowerShell 7.1################################
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set PowerShell7=

endlocal

:: Returning to Integrate Features Menu
goto :IntFeaturesMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Integrate Windows Remote Server Administration Tool (RSAT)
::-------------------------------------------------------------------------------------------
:IntRSAT

setlocal

set RSATType=

if "%SelectedSourceOS%" equ "w10" (
	cls
	echo.===============================================================================
	echo.   MSMG ToolKit - Integrate Windows Remote Server Administration Tool ^(RSAT^)
	echo.===============================================================================
	echo.
	echo.  [1]  RSAT for Managing targets older than Windows Server, version 1709
	echo.
	echo.  [2]  RSAT for Managing Windows Server, version 1709
	echo.
	echo.  [3]  RSAT for Managing Windows Server, version 1803
	echo.
	echo.  [X]  Retour
	echo.
	echo.===============================================================================
	echo.
	choice /C:123X /N /M "Enter Your Choice : "
	if errorlevel 4 goto :IntegrateMenu
	if errorlevel 3 set RSATType=v1803
	if errorlevel 2 set RSATType=v1709
	if errorlevel 1 set RSATType=v1609
)

cls
echo.===============================================================================
echo.   MSMG ToolKit - Integrate Windows Remote Server Administration Tool ^(RSAT^)
echo.===============================================================================
echo.

:: Setting Windows Remote Server Administration Tool (RSAT) Pack folder path according to selected Source OS
set "RSAT=%RSAT%\%SelectedSourceOS%"

:: Getting Install Image Index Architecture
for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" call :GetImageArchitecture "%InstallWim%", %%i >nul
)

:: Setting Package Architecture
if "%ImageArchitecture%" equ "x86" set "PackageArchitecture=x86"
if "%ImageArchitecture%" equ "x64" set "PackageArchitecture=amd64"

:: Checking whether Windows Remote Server Administration Tool (RSAT) Pack file exist
if "%SelectedSourceOS%" equ "w7" if not exist "%RSAT%\Microsoft-Windows-RemoteServerAdministrationTools-Client-Package-TopLevel~31bf3856ad364e35~%PackageArchitecture%.cab" (
	echo.Remote Server Administration Tool Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-RemoteServerAdministrationTools-Client-Package-TopLevel~31bf3856ad364e35~%PackageArchitecture%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\RSAT\%SelectedSourceOS%^> folder...
	goto :Stop
)

:: Checking whether Windows Remote Server Administration Tool (RSAT) for Streaming Media Services Pack file exist
if "%SelectedSourceOS%" equ "w7" if not exist "%RSAT%\Microsoft-Windows-MediaServer-Admin-Package-TopLevel~31bf3856ad364e35~%PackageArchitecture%.cab" (
	echo.Remote Server Administration Tool Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-MediaServer-Admin-Package-TopLevel~31bf3856ad364e35~%PackageArchitecture%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\RSAT\%SelectedSourceOS%^> folder...
	goto :Stop
)

:: Checking whether Windows Remote Server Administration Tool (RSAT) Pack file exist
if "%SelectedSourceOS%" equ "w81" if not exist "%RSAT%\Microsoft-Windows-RemoteServerAdministrationTools-Client-Package-TopLevel~31bf3856ad364e35~%PackageArchitecture%.cab" (
	echo.Remote Server Administration Tool Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-RemoteServerAdministrationTools-Client-Package-TopLevel~31bf3856ad364e35~%PackageArchitecture%.cab"
	echo.
	echo.Please copy the above file to ^<Packs\RSAT\%SelectedSourceOS%^> folder...
	goto :Stop
)

:: Checking whether Windows Remote Server Administration Tool (RSAT) Pack file exist
if "%SelectedSourceOS%" equ "w10" if "%RSATType%" equ "v1609" if not exist "%RSAT%\10.0.14393\Microsoft-Windows-RemoteServerAdministrationTools-Client-Package-TopLevel~31bf3856ad364e35~%PackageArchitecture%~~10.0.14393.0.cab" (
	echo.Remote Server Administration Tool Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-RemoteServerAdministrationTools-Client-Package-TopLevel~31bf3856ad364e35~%PackageArchitecture%~~10.0.14393.0.cab"
	echo.
	echo.Please copy the above file to ^<Packs\RSAT\%SelectedSourceOS%\10.0.14393^> folder...
	goto :Stop
)

:: Checking whether Windows Remote Server Administration Tool (RSAT) Pack file exist
if "%SelectedSourceOS%" equ "w10" if "%RSATType%" equ "v1709" if not exist "%RSAT%\10.0.16299\Microsoft-Windows-RemoteServerAdministrationTools-Client-Package-TopLevel~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15.cab" (
	echo.Remote Server Administration Tool Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-RemoteServerAdministrationTools-Client-Package-TopLevel~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15.cab"
	echo.
	echo.Please copy the above file to ^<Packs\RSAT\%SelectedSourceOS%\10.0.16299^> folder...
	goto :Stop
)

:: Checking whether Windows Remote Server Administration Tool (RSAT) Pack file exist
if "%SelectedSourceOS%" equ "w10" if "%RSATType%" equ "v1803" if not exist "%RSAT%\10.0.17134\Microsoft-Windows-RemoteServerAdministrationTools-Client-Package-TopLevel~31bf3856ad364e35~%PackageArchitecture%~~10.0.17134.1.cab" (
	echo.Remote Server Administration Tool Pack folder is missing the below file...
	echo.
	echo."Microsoft-Windows-RemoteServerAdministrationTools-Client-Package-TopLevel~31bf3856ad364e35~%PackageArchitecture%~~10.0.17134.1.cab"
	echo.
	echo.Please copy the above file to ^<Packs\RSAT\%SelectedSourceOS%\10.0.17134^> folder...
	goto :Stop
)
echo.-------------------------------------------------------------------------------
echo.####Starting Integrating Windows Remote Server Administration Tool ^(RSAT^)######
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    : Install.wim
if /i "%ImageIndexNo%" equ "A" echo.    Image Indexes            : 1-%ImageCount%
if /i "%ImageIndexNo%" neq "A" echo.    Image Index              : %ImageIndexNo%
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
echo.
echo.-------------------------------------------------------------------------------
echo.####Integrating Windows Remote Server Administration Tool ^(RSAT^)###############
echo.-------------------------------------------------------------------------------

for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" (
		echo.
		if not %%i gtr 9 echo.===========================[Install.wim, Index : %%i]============================
		if %%i gtr 9 echo.==========================[Install.wim, Index : %%i]============================
		echo.

		:: Getting Image Index Information
		call :GetImageIndexInfo "%InstallWim%", %%i >nul
		
		:: Checking whether the selected Source OS is a valid editions
		if "%SelectedSourceOS%" equ "w7" (
			for /d %%j in (Professional,Ultimate) do (
				if "%ImageEdition%" equ "%%j" (
					echo.-------------------------------------------------------------------------------
					echo.Integrating Windows Remote Server Administration Tool ^(RSAT^) Package...
					echo.-------------------------------------------------------------------------------
					call :AddPackage "%InstallMount%\%%i", "%RSAT%\Microsoft-Windows-RemoteServerAdministrationTools-Client-Package-TopLevel~31bf3856ad364e35~%PackageArchitecture%.cab"
					echo.-------------------------------------------------------------------------------
					echo.Integrating Windows RSAT for Streaming Media Services Package...
					echo.-------------------------------------------------------------------------------
					call :AddPackage "%InstallMount%\%%i", "%RSAT%\Microsoft-Windows-MediaServer-Admin-Package-TopLevel~31bf3856ad364e35~%PackageArchitecture%.cab"
				)
			)
		)

		if "%SelectedSourceOS%" neq "w7" (
			for /d %%j in (Professional,Enterprise) do (
				if "%ImageEdition%" equ "%%j" (
					if "%SelectedSourceOS%" equ "w81" call :AddPackage "%InstallMount%\%%i", "%RSAT%\Microsoft-Windows-RemoteServerAdministrationTools-Client-Package-TopLevel~31bf3856ad364e35~%PackageArchitecture%.cab"

					if "%SelectedSourceOS%" equ "w10" (
						if "%RSATType%" equ "v1609" call :AddPackage "%InstallMount%\%%i", "%RSAT%\10.0.14393\Microsoft-Windows-RemoteServerAdministrationTools-Client-Package-TopLevel~31bf3856ad364e35~%PackageArchitecture%~~10.0.14393.0.cab"
						if "%RSATType%" equ "v1709" call :AddPackage "%InstallMount%\%%i", "%RSAT%\10.0.16299\Microsoft-Windows-RemoteServerAdministrationTools-Client-Package-TopLevel~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15.cab"
						if "%RSATType%" equ "v1803" call :AddPackage "%InstallMount%\%%i", "%RSAT%\10.0.17134\Microsoft-Windows-RemoteServerAdministrationTools-Client-Package-TopLevel~31bf3856ad364e35~%PackageArchitecture%~~10.0.17134.1.cab"
					)
				)
			)
		)
	)
)

echo.-------------------------------------------------------------------------------
echo.####Finished Integrating Windows Remote Server Administration Tool ^(RSAT^)######
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set RSAT=
set RSATType=
set PackageArchitecture=

endlocal

:: Returning to Integrate Features Menu
goto :IntFeaturesMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: MSMG ToolKit - Integrate Microsoft Default Inbox Apps
::-------------------------------------------------------------------------------------------
:IntInboxApps

setlocal

set InboxApp=

cls
echo.===============================================================================
echo.           MSMG ToolKit - Integrate Microsoft Default Inbox Apps
echo.===============================================================================
echo.

:: Integrate Windows 8.1 Default Inbox Apps Menu
if "%SelectedSourceOS%" equ "w81" (
	cls
	echo.===============================================================================
	echo.          MSMG ToolKit - Integrate Microsoft Default Inbox Apps Menu
	echo.===============================================================================
	echo.
	echo.  [01]   Alarms ^& Clock
	echo.  [02]   Calculator
	echo.  [03]   Calender, Mail ^& People
	echo.  [04]   Bing Finance
	echo.  [05]   Bing Food ^& Drink
	echo.  [06]   Bing Health ^& Fitness
	echo.  [07]   Bing Maps
	echo.  [08]   Bing News
	echo.  [09]   Bing Sports
	echo.  [10]   Bing Travel
	echo.  [11]   Bing Weather
	echo.  [12]   Help ^& Tips
	echo.  [13]   Office OneNote
	echo.  [14]   Reader
	echo.  [15]   Reading List
	echo.  [16]   Scan
	echo.  [17]   Skype
	echo.  [18]   Sound Recorder
	echo.  [19]   Xbox LIVE Games
	echo.  [20]   Zune Music
	echo.  [21]   Zune Video
	echo.  [22]   Help ^& Tips
	echo.
	echo.  [A]    All Inbox Apps
	echo.  [X]    Retour
	echo.
	echo.===============================================================================
	set /p MenuChoice=Enter Your Choice : 

	if "!MenuChoice!" equ "01" set "InboxApp=Alarms"
	if "!MenuChoice!" equ "02" set "InboxApp=Calculator"
	if "!MenuChoice!" equ "03" set "InboxApp=CommunicationsApps"
	if "!MenuChoice!" equ "04" set "InboxApp=BingFinance"
	if "!MenuChoice!" equ "05" set "InboxApp=BingFoodDrink"
	if "!MenuChoice!" equ "06" set "InboxApp=BingHealthFitness"
	if "!MenuChoice!" equ "07" set "InboxApp=BingMaps"
	if "!MenuChoice!" equ "08" set "InboxApp=BingNews"
	if "!MenuChoice!" equ "09" set "InboxApp=BingSports"
	if "!MenuChoice!" equ "10" set "InboxApp=BingTravel"
	if "!MenuChoice!" equ "11" set "InboxApp=BingWeather"
	if "!MenuChoice!" equ "12" set "InboxApp=HelpAndTips"
	if "!MenuChoice!" equ "13" set "InboxApp=OfficeOneNote"
	if "!MenuChoice!" equ "14" set "InboxApp=Reader"
	if "!MenuChoice!" equ "15" set "InboxApp=ReadingList"
	if "!MenuChoice!" equ "16" set "InboxApp=Scan"
	if "!MenuChoice!" equ "17" set "InboxApp=SkypeApp"
	if "!MenuChoice!" equ "18" set "InboxApp=SoundRecorder"
	if "!MenuChoice!" equ "19" set "InboxApp=XboxLiveGames"
	if "!MenuChoice!" equ "20" set "InboxApp=ZuneMusic"
	if "!MenuChoice!" equ "21" set "InboxApp=ZuneVideo"
	if /i "!MenuChoice!" equ "A" set "InboxApp=AllApps"
	if /i "!MenuChoice!" equ "X" goto :IntFeaturesMenu
)

:: Integrate Windows 10 v1809/V1903/v1909 Default Inbox Apps Menu
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "17763" if "%ImageBuild%" leq "18363" (
	cls
	echo.===============================================================================
	echo.          MSMG ToolKit - Integrate Microsoft Default Inbox Apps Menu
	echo.===============================================================================
	echo.
	echo.  [01]   3D Viewer
	echo.  [02]   Alarms ^& Clock
	echo.  [03]   AOMedia Video 1 ^(AV1^) Codec Plugin
	echo.  [04]   Calculator
	echo.  [05]   Camera
	echo.  [06]   Desktop App Installer
	echo.  [07]   Feedback Hub
	echo.  [08]   Films ^& TV
	echo.  [09]   Get Help
	echo.  [10]   Google's VP9 WebM Video Codec Plugin
	echo.  [11]   Groove Music
	echo.  [12]   High Efficiency Image File ^(HEIF^) Codec Plugin
	echo.  [13]   High Efficiency Video Coding ^(HEVC^) Codec Plugin
	echo.  [14]   Maps
	echo.  [15]   Messaging
	echo.  [16]   MPEG-2 Video Codec Plugin
	echo.  [17]   Microsoft Pay
	if "%ImageArchitecture%" equ "x64" echo.  [18]   Mixed Reality Portal
	echo.  [19]   Mobile Plans
	echo.  [20]   My Office
	echo.  [21]   News
	echo.  [22]   OneNote
	echo.  [23]   Paint 3D
	echo.  [24]   People
	echo.  [25]   Photos
	echo.  [26]   Print 3D
	echo.  [27]   Snip ^& Sketch
	echo.  [28]   Skype
	echo.  [29]   Solitaire Collection
	echo.  [30]   Sticky Notes
	echo.  [31]   Store Purchase App
	echo.  [32]   Tips
	echo.  [33]   Todos
	echo.  [34]   Voice Recorder
	echo.  [35]   Weather
	echo.  [36]   Web Media Codec Plugin
	echo.  [37]   WebP Image Codec Plugin
	echo.  [38]   Windows Mail
	echo.  [39]   Windows Store
	echo.  [40]   Xbox UI ^(Xbox TCUI^)
	echo.  [41]   Xbox Console Companion ^(Xbox App^)
	echo.  [42]   Xbox Game Bar Plugin ^(Xbox Game Overlay^)
	echo.  [43]   Xbox Game Bar ^(Xbox Gaming Overlay^)
	echo.  [44]   Xbox Identity Provider
	echo.  [45]   Xbox Live In-Game Experience ^(Xbox Speech To TextOverlay^)
	echo.  [46]   Your Phone
	echo.
	echo.  [A]    All Inbox Apps
	echo.  [X]    Retour
	echo.
	echo.===============================================================================
	set /p MenuChoice=Enter Your Choice : 

	if "!MenuChoice!" equ "01" set "InboxApp=MixedRealityViewer"
	if "!MenuChoice!" equ "02" set "InboxApp=Alarms"
	if "!MenuChoice!" equ "03" set "InboxApp=AV1VideoExtension"
	if "!MenuChoice!" equ "04" set "InboxApp=Calculator"
	if "!MenuChoice!" equ "05" set "InboxApp=Camera"
	if "!MenuChoice!" equ "06" set "InboxApp=DesktopAppInstaller"
	if "!MenuChoice!" equ "07" set "InboxApp=FeedbackHub"
	if "!MenuChoice!" equ "08" set "InboxApp=ZuneVideo"
	if "!MenuChoice!" equ "09" set "InboxApp=GetHelp"
	if "!MenuChoice!" equ "10" set "InboxApp=VP9Extensions"
	if "!MenuChoice!" equ "11" set "InboxApp=ZuneMusic"
	if "!MenuChoice!" equ "12" set "InboxApp=HEIFImageExtension"
	if "!MenuChoice!" equ "13" set "InboxApp=HEVCVideoExtension"
	if "!MenuChoice!" equ "14" set "InboxApp=Maps"
	if "!MenuChoice!" equ "15" set "InboxApp=Messaging"
	if "!MenuChoice!" equ "16" set "InboxApp=MPEG2VideoExtension"
	if "!MenuChoice!" equ "17" set "InboxApp=Wallet"
	if "!MenuChoice!" equ "18" if "%ImageArchitecture%" equ "x64" set "InboxApp=MixedRealityPortal"
	if "!MenuChoice!" equ "19" set "InboxApp=OneConnect"
	if "!MenuChoice!" equ "20" set "InboxApp=OfficeHub"
	if "!MenuChoice!" equ "21" set "InboxApp=BingNews"
	if "!MenuChoice!" equ "22" set "InboxApp=OneNote"
	if "!MenuChoice!" equ "23" set "InboxApp=Paint3D"
	if "!MenuChoice!" equ "24" set "InboxApp=People"
	if "!MenuChoice!" equ "25" set "InboxApp=Photos"
	if "!MenuChoice!" equ "26" set "InboxApp=Print3D"
	if "!MenuChoice!" equ "27" set "InboxApp=ScreenSketch"
	if "!MenuChoice!" equ "28" set "InboxApp=Skype"
	if "!MenuChoice!" equ "29" set "InboxApp=SolitaireCollection"
	if "!MenuChoice!" equ "30" set "InboxApp=StickyNotes"
	if "!MenuChoice!" equ "31" set "InboxApp=StorePurchaseApp"
	if "!MenuChoice!" equ "32" set "InboxApp=Getstarted"
	if "!MenuChoice!" equ "33" set "InboxApp=Todos"
	if "!MenuChoice!" equ "34" set "InboxApp=SoundRecorder"
	if "!MenuChoice!" equ "35" set "InboxApp=BingWeather"
	if "!MenuChoice!" equ "36" set "InboxApp=WebMediaExtensions"
	if "!MenuChoice!" equ "37" set "InboxApp=WebpImageExtension"
	if "!MenuChoice!" equ "38" set "InboxApp=CommunicationsApps"
	if "!MenuChoice!" equ "39" set "InboxApp=WindowsStore"
	if "!MenuChoice!" equ "40" set "InboxApp=XboxTCUI"
	if "!MenuChoice!" equ "41" set "InboxApp=XboxApp"
	if "!MenuChoice!" equ "42" set "InboxApp=XboxGameOverlay"
	if "!MenuChoice!" equ "43" set "InboxApp=XboxGamingOverlay"
	if "!MenuChoice!" equ "44" set "InboxApp=XboxIdentityProvider"
	if "!MenuChoice!" equ "45" set "InboxApp=XboxSpeechToTextOverlay"
	if "!MenuChoice!" equ "46" set "InboxApp=YourPhone"
	if /i "!MenuChoice!" equ "A" set "InboxApp=AllApps"
	if /i "!MenuChoice!" equ "X" goto :IntFeaturesMenu
)

:: Integrate Windows 10 v2004/v20H2 Default Inbox Apps Menu
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "19041" (
	cls
	echo.===============================================================================
	echo.          MSMG ToolKit - Integrate Microsoft Default Inbox Apps Menu
	echo.===============================================================================
	echo.  [01]   3D Viewer
	echo.  [02]   Alarms ^& Clock
	echo.  [03]   AOMedia Video 1 ^(AV1^) Codec Plugin
	echo.  [04]   Calculator
	echo.  [05]   Camera
	echo.  [06]   Cortana
	echo.  [07]   Desktop App Installer
	echo.  [08]   Feedback Hub
	echo.  [09]   Get Help
	echo.  [10]   Google's VP9 WebM Video Codec Plugin
	echo.  [11]   Groove Music
	echo.  [12]   High Efficiency Image File ^(HEIF^) Codec Plugin
	echo.  [13]   High Efficiency Video Coding ^(HEVC^) Codec Plugin
	echo.  [14]   Maps
	echo.  [15]   Messaging
	echo.  [16]   MPEG-2 Video Codec Plugin
	echo.  [17]   Microsoft Pay
	if "%ImageArchitecture%" equ "x64" echo.  [18]   Mixed Reality Portal
	echo.  [19]   Mobile Plans
	echo.  [20]   Movies ^& TV
	echo.  [21]   My Office
	echo.  [22]   News
	echo.  [23]   OneNote
	echo.  [24]   Paint 3D
	echo.  [25]   People
	echo.  [26]   Photos
	echo.  [27]   Print 3D
	echo.  [28]   Snip ^& Sketch
	echo.  [29]   Skype
	echo.  [30]   Solitaire Collection
	echo.  [31]   Sticky Notes
	echo.  [32]   Store Purchase App
	echo.  [33]   Tips
	echo.  [34]   Todos
	echo.  [35]   Voice Recorder
	echo.  [36]   Weather
	echo.  [37]   Web Media Codec Plugin
	echo.  [38]   WebP Image Codec Plugin
	echo.  [39]   Windows Mail
	echo.  [40]   Windows Store
	echo.  [41]   Xbox UI ^(Xbox TCUI^)
	echo.  [42]   Xbox Console Companion ^(Xbox App^)
	echo.  [43]   Xbox Game Bar Plugin ^(Xbox Game Overlay^)
	echo.  [44]   Xbox Game Bar ^(Xbox Gaming Overlay^)
	echo.  [45]   Xbox Identity Provider
	echo.  [46]   Xbox Live In-Game Experience ^(Xbox Speech To TextOverlay^)
	echo.  [47]   Your Phone
	echo.
	echo.  [A]    All Inbox Apps
	echo.  [X]    Retour
	echo.===============================================================================
	set /p MenuChoice=Enter Your Choice : 

	if "!MenuChoice!" equ "01" set "InboxApp=MixedRealityViewer"
	if "!MenuChoice!" equ "02" set "InboxApp=Alarms"
	if "!MenuChoice!" equ "03" set "InboxApp=AV1VideoExtension"
	if "!MenuChoice!" equ "04" set "InboxApp=Calculator"
	if "!MenuChoice!" equ "05" set "InboxApp=Camera"
	if "!MenuChoice!" equ "06" set "InboxApp=Cortana"
	if "!MenuChoice!" equ "07" set "InboxApp=DesktopAppInstaller"
	if "!MenuChoice!" equ "08" set "InboxApp=FeedbackHub"
	if "!MenuChoice!" equ "09" set "InboxApp=GetHelp"
	if "!MenuChoice!" equ "10" set "InboxApp=VP9Extensions"
	if "!MenuChoice!" equ "11" set "InboxApp=ZuneMusic"
	if "!MenuChoice!" equ "12" set "InboxApp=HEIFImageExtension"
	if "!MenuChoice!" equ "13" set "InboxApp=HEVCVideoExtension"
	if "!MenuChoice!" equ "14" set "InboxApp=Maps"
	if "!MenuChoice!" equ "15" set "InboxApp=Messaging"
	if "!MenuChoice!" equ "16" set "InboxApp=MPEG2VideoExtension"
	if "!MenuChoice!" equ "17" set "InboxApp=Wallet"
	if "!MenuChoice!" equ "18" if "%ImageArchitecture%" equ "x64" set "InboxApp=MixedRealityPortal"
	if "!MenuChoice!" equ "19" set "InboxApp=OneConnect"
	if "!MenuChoice!" equ "20" set "InboxApp=ZuneVideo"
	if "!MenuChoice!" equ "21" set "InboxApp=OfficeHub"
	if "!MenuChoice!" equ "22" set "InboxApp=BingNews"
	if "!MenuChoice!" equ "23" set "InboxApp=OneNote"
	if "!MenuChoice!" equ "24" set "InboxApp=Paint3D"
	if "!MenuChoice!" equ "25" set "InboxApp=People"
	if "!MenuChoice!" equ "26" set "InboxApp=Photos"
	if "!MenuChoice!" equ "27" set "InboxApp=Print3D"
	if "!MenuChoice!" equ "28" set "InboxApp=ScreenSketch"
	if "!MenuChoice!" equ "29" set "InboxApp=Skype"
	if "!MenuChoice!" equ "30" set "InboxApp=SolitaireCollection"
	if "!MenuChoice!" equ "31" set "InboxApp=StickyNotes"
	if "!MenuChoice!" equ "32" set "InboxApp=StorePurchaseApp"
	if "!MenuChoice!" equ "33" set "InboxApp=Getstarted"
	if "!MenuChoice!" equ "34" set "InboxApp=Todos"
	if "!MenuChoice!" equ "35" set "InboxApp=SoundRecorder"
	if "!MenuChoice!" equ "36" set "InboxApp=BingWeather"
	if "!MenuChoice!" equ "37" set "InboxApp=WebMediaExtensions"
	if "!MenuChoice!" equ "38" set "InboxApp=WebpImageExtension"
	if "!MenuChoice!" equ "39" set "InboxApp=CommunicationsApps"
	if "!MenuChoice!" equ "40" set "InboxApp=WindowsStore"
	if "!MenuChoice!" equ "41" set "InboxApp=XboxTCUI"
	if "!MenuChoice!" equ "42" set "InboxApp=XboxApp"
	if "!MenuChoice!" equ "43" set "InboxApp=XboxGameOverlay"
	if "!MenuChoice!" equ "44" set "InboxApp=XboxGamingOverlay"
	if "!MenuChoice!" equ "45" set "InboxApp=XboxIdentityProvider"
	if "!MenuChoice!" equ "46" set "InboxApp=XboxSpeechToTextOverlay"
	if "!MenuChoice!" equ "47" set "InboxApp=YourPhone"
	if /i "!MenuChoice!" equ "A" set "InboxApp=AllApps"
	if /i "!MenuChoice!" equ "X" goto :IntFeaturesMenu
)

:: Setting Default Inbox Apps Appx and License files path
set "Apps=%Apps%\%SelectedSourceOS%"

set Alarms_Appx=
set AV1VideoExtension_Appx=
set BingFinance_Appx=
set BingFoodDrink_Appx=
set BingHealthFitness_Appx=
set BingMaps_Appx=
set BingNews_Appx=
set BingSports_Appx=
set BingTravel_Appx=
set BingWeather_Appx=
set Calculator_Appx=
set Camera_Appx=
set CommunicationsApps_Appx=
set Cortana_Appx=
set DesktopAppInstaller_Appx=
set FeedbackHub_Appx=
set GetHelp_Appx=
set Getstarted_Appx=
set HEIFImageExtension_Appx=
set HEVCVideoExtension_Appx=
set HelpAndTips_Appx=
set Maps_Appx=
set Messaging_Appx=
set MixedRealityPortal_Appx=
set MixedRealityViewer_Appx=
set MPEG2VideoExtension_Appx=
set OfficeHub_Appx=
set OneNote_Appx=
set OneConnect_Appx=
set Paint3D_Appx=
set People_Appx=
set Photos_Appx=
set Print3D_Appx=
set Reader_Appx=
set ReadingList_Appx=
set Scan_Appx=
set ScreenSketch_Appx=
set Skype_Appx=
set SolitaireCollection_Appx=
set SoundRecorder_Appx=
set StickyNotes_Appx=
set StorePurchaseApp_Appx=
set Todos_Appx=
set VP9VideoExtensions_Appx=
set Wallet_Appx=
set WebMediaExtensions_Appx=
set WebpImageExtension_Appx=
set WindowsStore_Appx=
set Xbox_Appx=
set XboxGameOverlay_Appx=
set XboxGamingOverlay_Appx=
set XboxIdentityProvider_Appx=
set XboxLiveGames_Appx=
set XboxSpeechToTextOverlay_Appx=
set XboxTCUI_Appx=
set YourPhone_Appx=
set ZuneMusic_Appx=
set ZuneVideo_Appx=

set "Alarms_License=%Apps%\Microsoft.WindowsAlarms_8wekyb3d8bbwe.xml"
set "AV1VideoExtension_License=%Apps%\Microsoft.AV1VideoExtension_8wekyb3d8bbwe.%ImageArchitecture%.xml"
set "BingFinance_License=%Apps%\Microsoft.BingFinance_8wekyb3d8bbwe.xml"
set "BingFoodDrink_License=%Apps%\Microsoft.BingFoodAndDrink_8wekyb3d8bbwe.xml"
set "BingHealthFitness_License=%Apps%\Microsoft.BingHealthAndFitness_8wekyb3d8bbwe.xml"
set "BingMaps_License=%Apps%\Microsoft.BingMaps_8wekyb3d8bbwe.xml"
set "BingNews_License=%Apps%\Microsoft.BingNews_8wekyb3d8bbwe.xml"
set "BingSports_License=%Apps%\Microsoft.BingSports_8wekyb3d8bbwe.xml"
set "BingTravel_License=%Apps%\Microsoft.BingTravel_8wekyb3d8bbwe.xml"
set "BingWeather_License=%Apps%\Microsoft.BingWeather_8wekyb3d8bbwe.xml"
set "Calculator_License=%Apps%\Microsoft.WindowsCalculator_8wekyb3d8bbwe.xml"
set "Camera_License=%Apps%\Microsoft.WindowsCamera_8wekyb3d8bbwe.xml"
set "CommunicationsApps_License=%Apps%\Microsoft.WindowsCommunicationsApps_8wekyb3d8bbwe.xml"
set "Cortana_License=%Apps%\Microsoft.CortanaApp_8wekyb3d8bbwe.xml"
set "DesktopAppInstaller_License=%Apps%\Microsoft.DesktopAppInstaller_8wekyb3d8bbwe.xml"
set "FeedbackHub_License=%Apps%\Microsoft.WindowsFeedbackHub_8wekyb3d8bbwe.xml"
set "GetHelp_License=%Apps%\Microsoft.GetHelp_8wekyb3d8bbwe.xml"
set "Getstarted_License=%Apps%\Microsoft.Getstarted_8wekyb3d8bbwe.xml"
set "HEIFImageExtension_License=%Apps%\Microsoft.HEIFImageExtension_8wekyb3d8bbwe.%ImageArchitecture%.xml"
set "HEVCVideoExtension_License=%Apps%\Microsoft.HEVCVideoExtension_8wekyb3d8bbwe.%ImageArchitecture%.xml"
set "HelpAndTips_License=%Apps%\Microsoft.HelpAndTips_8wekyb3d8bbwe.xml"
set "Maps_License=%Apps%\Microsoft.WindowsMaps_8wekyb3d8bbwe.xml"
set "Messaging_License=%Apps%\Microsoft.Messaging_8wekyb3d8bbwe.xml"
set "MixedRealityPortal_License=%Apps%\Microsoft.MixedReality.Portal_8wekyb3d8bbwe.xml"
set "MixedRealityViewer_License=%Apps%\Microsoft.Microsoft3DViewer_8wekyb3d8bbwe.xml"
set "MPEG2VideoExtension_License=%Apps%\Microsoft.MPEG2VideoExtension_8wekyb3d8bbwe.%ImageArchitecture%.xml"
set "OfficeHub_License=%Apps%\Microsoft.MicrosoftOfficeHub_8wekyb3d8bbwe.xml"
set "OneNote_License=%Apps%\Microsoft.Office.OneNote_8wekyb3d8bbwe.xml"
set "OneConnect_License=%Apps%\Microsoft.OneConnect_8wekyb3d8bbwe.xml"
set "Paint3D_License=%Apps%\Microsoft.MSPaint_8wekyb3d8bbwe.xml"
set "People_License=%Apps%\Microsoft.People_8wekyb3d8bbwe.xml"
set "Photos_License=%Apps%\Microsoft.Windows.Photos_8wekyb3d8bbwe.xml"
set "Print3D_License=%Apps%\Microsoft.Print3D_8wekyb3d8bbwe.xml"
set "Reader_License=%Apps%\Microsoft.Reader_8wekyb3d8bbwe.xml"
set "ReadingList_License=%Apps%\Microsoft.WindowsReadingList_8wekyb3d8bbwe.xml"
set "Scan_License=%Apps%\Microsoft.WindowsScan_8wekyb3d8bbwe.xml"
set "ScreenSketch_License=%Apps%\Microsoft.ScreenSketch_8wekyb3d8bbwe.xml"
set "Skype_License=%Apps%\Microsoft.SkypeApp_kzf8qxf38zg5c.xml"
set "SolitaireCollection_License=%Apps%\Microsoft.MicrosoftSolitaireCollection_8wekyb3d8bbwe.xml"
set "SoundRecorder_License=%Apps%\Microsoft.WindowsSoundRecorder_8wekyb3d8bbwe.xml"
set "StickyNotes_License=%Apps%\Microsoft.MicrosoftStickyNotes_8wekyb3d8bbwe.xml"
set "StorePurchaseApp_License=%Apps%\Microsoft.StorePurchaseApp_8wekyb3d8bbwe.xml"
set "Todos_License=%Apps%\Microsoft.Todos_8wekyb3d8bbwe.xml"
set "VP9VideoExtensions_License=%Apps%\Microsoft.VP9VideoExtensions_8wekyb3d8bbwe.%ImageArchitecture%.xml"
set "Wallet_License=%Apps%\Microsoft.Wallet_8wekyb3d8bbwe.xml"
set "WebMediaExtensions_License=%Apps%\Microsoft.WebMediaExtensions_8wekyb3d8bbwe.xml"
set "WebpImageExtension_License=%Apps%\Microsoft.WebpImageExtension_8wekyb3d8bbwe.%ImageArchitecture%.xml"
set "WindowsStore_License=%Apps%\Microsoft.WindowsStore_8wekyb3d8bbwe.xml"
set "Xbox_License=%Apps%\Microsoft.XboxApp_8wekyb3d8bbwe.xml"
set "XboxGameOverlay_License=%Apps%\Microsoft.XboxGameOverlay_8wekyb3d8bbwe.xml"
set "XboxGamingOverlay_License=%Apps%\Microsoft.XboxGamingOverlay_8wekyb3d8bbwe.xml"
set "XboxIdentityProvider_License=%Apps%\Microsoft.XboxIdentityProvider_8wekyb3d8bbwe.xml"
set "XboxLiveGames_License=%Apps%\Microsoft.XboxLIVEGames_8wekyb3d8bbwe.xml"
set "XboxSpeechToTextOverlay_License=%Apps%\Microsoft.XboxSpeechToTextOverlay_8wekyb3d8bbwe.xml"
set "XboxTCUI_License=%Apps%\Microsoft.Xbox.TCUI_8wekyb3d8bbwe.xml"
set "YourPhone_License=%Apps%\Microsoft.YourPhone_8wekyb3d8bbwe.xml"
set "ZuneMusic_License=%Apps%\Microsoft.ZuneMusic_8wekyb3d8bbwe.xml"
set "ZuneVideo_License=%Apps%\Microsoft.ZuneVideo_8wekyb3d8bbwe.xml"

set AdvertisingXaml_Appx=
set MediaPlayReadyClient22_Appx=
set NETNativeFramework13_Appx=
set NETNativeFramework16_Appx=
set NETNativeFramework17_Appx=
set NETNativeFramework21_Appx=
set NETNativeFramework22_Appx=
set NETNativeRuntime13_Appx=
set NETNativeRuntime14_Appx=
set NETNativeRuntime16_Appx=
set NETNativeRuntime17_Appx=
set NETNativeRuntime21_Appx=
set NETNativeRuntime22_Appx=
set ServicesStoreEngagement_Appx=
set UIXaml20_Appx=
set UIXaml21_Appx=
set UIXaml22_Appx=
set UIXaml23_Appx=
set UIXaml24_Appx=
set VCLibs12_arm_Appx=
set VCLibs12_x86_Appx=
set VCLibs12_x64_Appx=
set VCLibsUWPDesktop14_Appx=
set VCLibs14_Appx=
set WinJS20_Appx=

:: Getting Install Image Index Architecture
for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" call :GetImageArchitecture "%InstallWim%", %%i >nul
)

:: Checking whether Microsoft Default Inbox Apps folder is empty
if not exist "%Apps%\*.appxbundle" (
	echo.Microsoft Default Inbox Apps .Appxbundle files are missing...
	echo.
	echo.Please copy the missing files to ^<Packs\Apps\%SelectedSourceOS%^> folder...
	echo.
	goto :Stop
)

if not exist "%Apps%\*.appx" (
	echo.Microsoft Default Inbox Apps .Appx files are missing...
	echo.
	echo.Please copy the missing files to ^<Packs\Apps\%SelectedSourceOS%^> folder...
	echo.
	goto :Stop
)

:: Getting Microsoft Default Inbox Apps files full pathnames
cd /d "%Apps%\"

for /f %%i IN ('"dir /b *Alarms*.appxbundle" 2^>nul') do if exist %%i set "Alarms_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *AV1VideoExtension*.appx" 2^>nul') do if exist %%i set "AV1VideoExtension_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *BingFinance*.appxbundle" 2^>nul') do if exist %%i set "BingFinance_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *BingFoodAndDrink*.appxbundle" 2^>nul') do if exist %%i set "BingFoodDrink_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *BingHealthAndFitness*.appxbundle" 2^>nul') do if exist %%i set "BingHealthFitness_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *BingMaps*.appxbundle" 2^>nul') do if exist %%i set "BingMaps_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *BingNews*.appxbundle" 2^>nul') do if exist %%i set "BingNews_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *BingSports*.appxbundle" 2^>nul') do if exist %%i set "BingSports_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *BingTravel*.appxbundle" 2^>nul') do if exist %%i set "BingTravel_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *BingWeather*.appxbundle" 2^>nul') do if exist %%i set "BingWeather_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *Calculator*.appxbundle" 2^>nul') do if exist %%i set "Calculator_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *Camera*.appxbundle" 2^>nul') do if exist %%i set "Camera_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *CommunicationsApps*.appxbundle" 2^>nul') do if exist %%i set "CommunicationsApps_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *CortanaApp*.appxbundle" 2^>nul') do if exist %%i set "Cortana_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *DesktopAppInstaller*.appxbundle" 2^>nul') do if exist %%i set "DesktopAppInstaller_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *FeedbackHub*.appxbundle" 2^>nul') do if exist %%i set "FeedbackHub_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *GetHelp*.appxbundle" 2^>nul') do if exist %%i set "GetHelp_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *Getstarted*.appxbundle" 2^>nul') do if exist %%i set "Getstarted_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *HEIFImageExtension*%ImageArchitecture%*.appx" 2^>nul') do if exist %%i set "HEIFImageExtension_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *HEVCVideoExtension*%ImageArchitecture%*.appx" 2^>nul') do if exist %%i set "HEVCVideoExtension_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *HelpAndTips*.appxbundle" 2^>nul') do if exist %%i set "HelpAndTips_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *Maps*.appxbundle" 2^>nul') do if exist %%i set "Maps_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *Messaging*.appxbundle" 2^>nul') do if exist %%i set "Messaging_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *MixedReality.Portal*.appxbundle" 2^>nul') do if exist %%i set "MixedRealityPortal_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *3DView*.appxbundle" 2^>nul') do if exist %%i set "MixedRealityViewer_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *MPEG2VideoExtension*%ImageArchitecture%*.appx" 2^>nul') do if exist %%i set "MPEG2VideoExtension_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *OfficeHub*.appxbundle" 2^>nul') do if exist %%i set "OfficeHub_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *OneNote*.appxbundle" 2^>nul') do if exist %%i set "OneNote_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *OneConnect*.appxbundle" 2^>nul') do if exist %%i set "OneConnect_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *Paint*.appxbundle" 2^>nul') do if exist %%i set "Paint3D_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *People*.appxbundle" 2^>nul') do if exist %%i set "People_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *Photos*.appxbundle" 2^>nul') do if exist %%i set "Photos_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *Print3D*.appxbundle" 2^>nul') do if exist %%i set "Print3D_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *Reader*.appxbundle" 2^>nul') do if exist %%i set "Reader_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *ReadingList*.appxbundle" 2^>nul') do if exist %%i set "ReadingList_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *Scan*.appxbundle" 2^>nul') do if exist %%i set "Scan_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *ScreenSketch*.appxbundle" 2^>nul') do if exist %%i set "ScreenSketch_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *Skype*.appxbundle" 2^>nul') do if exist %%i set "Skype_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *SolitaireCollection*.appxbundle" 2^>nul') do if exist %%i set "SolitaireCollection_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *SoundRecorder*.appxbundle" 2^>nul') do if exist %%i set "SoundRecorder_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *StickyNotes*.appxbundle" 2^>nul') do if exist %%i set "StickyNotes_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *StorePurchaseApp*.appxbundle" 2^>nul') do if exist %%i set "StorePurchaseApp_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *Todos*.appxbundle" 2^>nul') do if exist %%i set "Todos_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *VP9VideoExtensions*%ImageArchitecture%*.appx" 2^>nul') do if exist %%i set "VP9VideoExtensions_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *Wallet*.appxbundle" 2^>nul') do if exist %%i set "Wallet_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *WebMediaExtensions*.appxbundle" 2^>nul') do if exist %%i set "WebMediaExtensions_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *WebpImageExtension*%ImageArchitecture%*.appx" 2^>nul') do if exist %%i set "WebpImageExtension_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *WindowsStore*.appxbundle" 2^>nul') do if exist %%i set "WindowsStore_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *XboxApp*.appxbundle" 2^>nul') do if exist %%i set "Xbox_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *XboxGameOverlay*.appxbundle" 2^>nul') do if exist %%i set "XboxGameOverlay_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *XboxGamingOverlay*.appxbundle" 2^>nul') do if exist %%i set "XboxGamingOverlay_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *XboxIdentityProvider*.appxbundle" 2^>nul') do if exist %%i set "XboxIdentityProvider_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *XboxLIVEGames*.appxbundle" 2^>nul') do if exist %%i set "XboxLiveGames_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *XboxSpeechToTextOverlay*.appxbundle" 2^>nul') do if exist %%i set "XboxSpeechToTextOverlay_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *Xbox.TCUI*.appxbundle" 2^>nul') do if exist %%i set "XboxTCUI_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *YourPhone*.appxbundle" 2^>nul') do if exist %%i set "YourPhone_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *ZuneMusic*.appxbundle" 2^>nul') do if exist %%i set "ZuneMusic_Appx=%Apps%\%%i"
for /f %%i IN ('"dir /b *ZuneVideo*.appxbundle" 2^>nul') do if exist %%i set "ZuneVideo_Appx=%Apps%\%%i"

for /f %%i IN ('"dir /b Microsoft.Advertising.Xaml*_%ImageArchitecture%__8wekyb3d8bbwe.Appx" 2^>nul') do set "AdvertisingXaml_Appx=/DependencyPackagePath:%Apps%\%%i"
for /f %%i IN ('"dir /b *PlayReadyClient*%ImageArchitecture%.appx" 2^>nul') do set "MediaPlayReadyClient22_Appx=/DependencyPackagePath:%Apps%\%%i"
for /f %%i IN ('"dir /b Microsoft.NET.Native.Framework.1.3*_%ImageArchitecture%__8wekyb3d8bbwe.Appx" 2^>nul') do set "NETNativeFramework13_Appx=/DependencyPackagePath:%Apps%\%%i"
for /f %%i IN ('"dir /b Microsoft.NET.Native.Framework.1.6*_%ImageArchitecture%__8wekyb3d8bbwe.Appx" 2^>nul') do set "NETNativeFramework16_Appx=/DependencyPackagePath:%Apps%\%%i"
for /f %%i IN ('"dir /b Microsoft.NET.Native.Framework.1.7*_%ImageArchitecture%__8wekyb3d8bbwe.Appx" 2^>nul') do set "NETNativeFramework17_Appx=/DependencyPackagePath:%Apps%\%%i"
for /f %%i IN ('"dir /b Microsoft.NET.Native.Framework.2.1*_%ImageArchitecture%__8wekyb3d8bbwe.Appx" 2^>nul') do set "NETNativeFramework21_Appx=/DependencyPackagePath:%Apps%\%%i"
for /f %%i IN ('"dir /b Microsoft.NET.Native.Framework.2.2*_%ImageArchitecture%__8wekyb3d8bbwe.Appx" 2^>nul') do set "NETNativeFramework22_Appx=/DependencyPackagePath:%Apps%\%%i"
for /f %%i IN ('"dir /b Microsoft.NET.Native.Runtime.1.3*_%ImageArchitecture%__8wekyb3d8bbwe.Appx" 2^>nul') do set "NETNativeRuntime13_Appx=/DependencyPackagePath:%Apps%\%%i"
for /f %%i IN ('"dir /b Microsoft.NET.Native.Runtime.1.4*_%ImageArchitecture%__8wekyb3d8bbwe.Appx" 2^>nul') do set "NETNativeRuntime14_Appx=/DependencyPackagePath:%Apps%\%%i"
for /f %%i IN ('"dir /b Microsoft.NET.Native.Runtime.1.6*_%ImageArchitecture%__8wekyb3d8bbwe.Appx" 2^>nul') do set "NETNativeRuntime16_Appx=/DependencyPackagePath:%Apps%\%%i"
for /f %%i IN ('"dir /b Microsoft.NET.Native.Runtime.1.7*_%ImageArchitecture%__8wekyb3d8bbwe.Appx" 2^>nul') do set "NETNativeRuntime17_Appx=/DependencyPackagePath:%Apps%\%%i"
for /f %%i IN ('"dir /b Microsoft.NET.Native.Runtime.2.1*_%ImageArchitecture%__8wekyb3d8bbwe.Appx" 2^>nul') do set "NETNativeRuntime21_Appx=/DependencyPackagePath:%Apps%\%%i"
for /f %%i IN ('"dir /b Microsoft.NET.Native.Runtime.2.2*_%ImageArchitecture%__8wekyb3d8bbwe.Appx" 2^>nul') do set "NETNativeRuntime22_Appx=/DependencyPackagePath:%Apps%\%%i"
if "%ImageArchitecture%" equ "arm" for /f %%i IN ('"dir /b Microsoft.Services.Store.Engagement*_arm__8wekyb3d8bbwe.Appx" 2^>nul') do set "ServicesStoreEngagement_Appx=/DependencyPackagePath:%Apps%\%%i"
if "%ImageArchitecture%" equ "arm64" for /f %%i IN ('"dir /b Microsoft.Services.Store.Engagement*_arm64__8wekyb3d8bbwe.Appx" 2^>nul') do set "ServicesStoreEngagement_Appx=/DependencyPackagePath:%Apps%\%%i"
if "%ImageArchitecture%" equ "x86" for /f %%i IN ('"dir /b Microsoft.Services.Store.Engagement*_x86__8wekyb3d8bbwe.Appx" 2^>nul') do set "ServicesStoreEngagement_Appx=/DependencyPackagePath:%Apps%\%%i"
if "%ImageArchitecture%" equ "x64" for /f %%i IN ('"dir /b Microsoft.Services.Store.Engagement*_x64__8wekyb3d8bbwe.Appx" 2^>nul') do set "ServicesStoreEngagement_Appx=%ServicesStoreEngagement_Appx% /DependencyPackagePath:%Apps%\%%i"
for /f %%i IN ('"dir /b Microsoft.UI.Xaml.2.0*_%ImageArchitecture%__8wekyb3d8bbwe.Appx" 2^>nul') do set "UIXaml20_Appx=/DependencyPackagePath:%Apps%\%%i"
for /f %%i IN ('"dir /b Microsoft.UI.Xaml.2.1*_%ImageArchitecture%__8wekyb3d8bbwe.Appx" 2^>nul') do set "UIXaml21_Appx=/DependencyPackagePath:%Apps%\%%i"
for /f %%i IN ('"dir /b Microsoft.UI.Xaml.2.2*_%ImageArchitecture%__8wekyb3d8bbwe.Appx" 2^>nul') do set "UIXaml22_Appx=/DependencyPackagePath:%Apps%\%%i"
for /f %%i IN ('"dir /b Microsoft.UI.Xaml.2.3*_%ImageArchitecture%__8wekyb3d8bbwe.Appx" 2^>nul') do set "UIXaml23_Appx=/DependencyPackagePath:%Apps%\%%i"
for /f %%i IN ('"dir /b Microsoft.UI.Xaml.2.4*_%ImageArchitecture%__8wekyb3d8bbwe.Appx" 2^>nul') do set "UIXaml24_Appx=/DependencyPackagePath:%Apps%\%%i"
for /f %%i IN ('"dir /b Microsoft.VCLibs.120.00*_%ImageArchitecture%__8wekyb3d8bbwe.Appx" 2^>nul') do set "VCLibs12_Appx=/DependencyPackagePath:%Apps%\%%i"
for /f %%i IN ('"dir /b Microsoft.VCLibs.140.00.UWPDesktop*_%ImageArchitecture%__8wekyb3d8bbwe.Appx" 2^>nul') do set "VCLibsUWPDesktop14_Appx=/DependencyPackagePath:%Apps%\%%i"
for /f %%i IN ('"dir /b Microsoft.VCLibs.140.00*_%ImageArchitecture%__8wekyb3d8bbwe.Appx" 2^>nul') do set "VCLibs14_Appx=/DependencyPackagePath:%Apps%\%%i"
for /f %%i IN ('"dir /b Microsoft.WinJS*.appx" 2^>nul') do set "WinJS20_Appx=/DependencyPackagePath:%Apps%\%%i"

cd /d "%ROOT%\"

cls
echo.===============================================================================
echo. 	      MSMG ToolKit - Integrate Microsoft Default Inbox Apps
echo.===============================================================================
echo.
echo.-------------------------------------------------------------------------------
echo.####Starting Integrating Microsoft Default Inbox Apps##########################
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    : Install.wim
if /i "%ImageIndexNo%" equ "A" echo.    Image Indexes            : 1-%ImageCount%
if /i "%ImageIndexNo%" neq "A" echo.    Image Index              : %ImageIndexNo%
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
echo.
echo.-------------------------------------------------------------------------------
echo.####Integrating Microsoft Default Inbox Apps###################################
echo.-------------------------------------------------------------------------------

for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" (
		echo.
		if not %%i gtr 9 echo.===========================[Install.wim, Index : %%i]============================
		if %%i gtr 9 echo.==========================[Install.wim, Index : %%i]============================
		echo.

		:: Getting Image Index Information
		call :GetImageIndexInfo "%InstallWim%", %%i >nul

		:: Integraing Windows 8.1 Default Inbox Apps to Install Image File
		if "%SelectedSourceOS%" equ "w81" (
			if "%InboxApp%" equ "Alarms" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Alarms and Clock", "%Alarms_Appx%", "%VCLibs12_Appx%", "%Alarms_License%"
			if "%InboxApp%" equ "BingFinance" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Bing Finance", "%BingFinance_Appx%", "%VCLibs12_Appx%", "%WinJS20_Appx%", "%BingFinance_License%"
			if "%InboxApp%" equ "BingFoodDrink" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Bing Food and Drink", "%BingFoodDrink_Appx%", "%VCLibs12_Appx%", "%WinJS20_Appx%", "%BingFoodDrink_License%"
			if "%InboxApp%" equ "BingHealthFitness" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Bing Health and Fitness", "%BingHealthFitness%", "%VCLibs12_Appx%", "%WinJS20_Appx%", "%BingHealthFitness_License%"
			if "%InboxApp%" equ "BingMaps" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Bing Maps", "%BingMaps_Appx%", "%VCLibs12_Appx%", "%BingMaps_License%"
			if "%InboxApp%" equ "BingNews" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Bing News", "%BingNews_Appx%", "%VCLibs12_Appx%", "%WinJS20_Appx%", "%BingNews_License%"
			if "%InboxApp%" equ "BingSports" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Bing Sports", "%BingSports_Appx%", "%VCLibs12_Appx%", "%WinJS20_Appx%", "%BingSports_License%"
			if "%InboxApp%" equ "BingTravel" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Bing Travel", "%BingTravel_Appx%", "%VCLibs12_Appx%", "%WinJS20_Appx%", "%BingTravel_License%"
			if "%InboxApp%" equ "BingWeather" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Bing Weather", "%BingWeather_Appx%", "%VCLibs12_Appx%", "%WinJS20_Appx%", "%BingWeather_License%"
			if "%InboxApp%" equ "Calculator" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Calculator", "%Calculator_Appx%", "%VCLibs12_Appx%", "%Calculator_License%"
			if "%InboxApp%" equ "CommunicationsApps" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Calender, Mail and People", "%CommunicationsApps_Appx%", "%VCLibs12_Appx%", "%WinJS20_Appx%", "%CommunicationsApps_License%"
			if "%InboxApp%" equ "HelpAndTips" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Help and Tips", "%HelpAndTips_Appx%", "%VCLibs12_Appx%", "%HelpAndTips_License%"
			if "%InboxApp%" equ "OneNote" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Office OneNote", "%OneNote_Appx%", "%VCLibs12_Appx%", "%OneNote_License%"
			if "%InboxApp%" equ "Reader" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Reader", "%Reader_Appx%", "%VCLibs12_Appx%", "%Reader_License%"
			if "%InboxApp%" equ "ReadingList" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Reading List", "%ReadingList_Appx%", "%VCLibs12_Appx%", "%WinJS20_Appx%", "%ReadingList_License%"
			if "%InboxApp%" equ "Scan" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Scan", "%Scan_Appx%", "%VCLibs12_Appx%", "%Scan_License%"
			if "%InboxApp%" equ "SkypeApp" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Skype App", "%Skype_Appx%", "%VCLibs12_Appx%", "%WinJS20_Appx%", "%Skype_License%"
			if "%InboxApp%" equ "SoundRecorder" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Sound Recorder", "%SoundRecorder_Appx%", "%VCLibs12_Appx%", "%SoundRecorder_License%"
			if "%InboxApp%" equ "XboxLiveGames" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Xbox Live Games", "%XboxLiveGames_Appx%", "%VCLibs12_Appx%", "%WinJS20_Appx%", "%XboxLiveGames_License%"
			if "%InboxApp%" equ "ZuneMusic" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Zune Music", "%ZuneMusic_Appx%", "%MediaPlayReadyClient22_Appx%", "%VCLibs12_Appx%", "%WinJS20_Appx%", "%ZuneMusic_License%"
			if "%InboxApp%" equ "ZuneVideo" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Zune Video", "%ZuneVideo_Appx%", "%MediaPlayReadyClient22_Appx%", "%VCLibs12_Appx%", "%WinJS20_Appx%", "%ZuneVideo_License%"

			if "%InboxApp%" equ "AllApps" (
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Alarms and Clock", "%Alarms_Appx%", "%VCLibs12_Appx%", "%Alarms_License%"
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Bing Finance", "%BingFinance_Appx%", "%VCLibs12_Appx% %WinJS20_Appx%", "%BingFinance_License%"
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Bing Food and Drink", "%BingFoodDrink_Appx%", "%VCLibs12_Appx% %WinJS20_Appx%", "%BingFoodDrink_License%"
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Bing Health and Fitness", "%BingHealthFitness%", "%VCLibs12_Appx% %WinJS20_Appx%", "%BingHealthFitness_License%"
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Bing Maps", "%BingMaps_Appx%", "%VCLibs12_Appx%", "%BingMaps_License%"
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Bing News", "%BingNews_Appx%", "%VCLibs12_Appx%", "%WinJS20_Appx%", "%BingNews_License%"
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Bing Sports", "%BingSports_Appx%", "%VCLibs12_Appx% %WinJS20_Appx%", "%BingSports_License%"
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Bing Travel", "%BingTravel_Appx%", "%VCLibs12_Appx% %WinJS20_Appx%", "%BingTravel_License%"
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Bing Weather", "%BingWeather_Appx%", "%VCLibs12_Appx% %WinJS20_Appx%", "%BingWeather_License%"
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Calculator", "%Calculator_Appx%", "%VCLibs12_Appx%", "%Calculator_License%"
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Calender, Mail and People", "%CommunicationsApps_Appx%", "%VCLibs12_Appx% %WinJS20_Appx%", "%CommunicationsApps_License%"
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Help and Tips", "%HelpAndTips_Appx%", "%VCLibs12_Appx%", "%HelpAndTips_License%"
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Office OneNote", "%OneNote_Appx%", "%VCLibs12_Appx%", "%OneNote_License%"
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Reader", "%Reader_Appx%", "%VCLibs12_Appx%", "%Reader_License%"
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Reading List", "%ReadingList_Appx%", "%VCLibs12_Appx% %WinJS20_Appx%", "%ReadingList_License%"
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Scan", "%Scan_Appx%", "%VCLibs12_Appx%", "%Scan_License%"
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Skype App", "%Skype_Appx%", "%VCLibs12_Appx% %WinJS20_Appx%", "%Skype_License%"
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Sound Recorder", "%SoundRecorder_Appx%", "%VCLibs12_Appx%", "%SoundRecorder_License%"
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Xbox Live Games", "%XboxLiveGames_Appx%", "%VCLibs12_Appx% %WinJS20_Appx%", "%XboxLiveGames_License%"
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Zune Music", "%ZuneMusic_Appx%", "%MediaPlayReadyClient22_Appx%", "%VCLibs12_Appx% %WinJS20_Appx%", "%ZuneMusic_License%"
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Zune Video", "%ZuneVideo_Appx%", "%MediaPlayReadyClient22_Appx%", "%VCLibs12_Appx% %WinJS20_Appx%", "%ZuneVideo_License%"
			)
		)

		:: Integrating Windows 10 Default Inbox Apps to Install Image
		if "%SelectedSourceOS%" equ "w10" (
			if "%InboxApp%" equ "Alarms" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Alarms and Clock", "%Alarms_Appx%", "%NETNativeFramework22_Appx% %NETNativeRuntime22_Appx% %UIXaml24_Appx% %VCLibs14_Appx%", "%Alarms_License%"
			if "%InboxApp%" equ "AV1VideoExtension" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "AV1 Video Codec Plugin", "%AV1VideoExtension_Appx%", "%VCLibs14_Appx%", "%AV1VideoExtension_License%"
			if "%InboxApp%" equ "BingNews" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "News", "%BingNews_Appx%", "%NETNativeFramework22_Appx% %NETNativeRuntime22_Appx% %UIXaml21_Appx% %VCLibs14_Appx%", "%BingNews_License%"
			if "%InboxApp%" equ "BingWeather" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Weather", "%BingWeather_Appx%", "%NETNativeFramework22_Appx% %NETNativeRuntime22_Appx% %UIXaml21_Appx% %VCLibs14_Appx%", "%BingWeather_License%"
			if "%InboxApp%" equ "Calculator" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Calculator", "%Calculator_Appx%", "%UIXaml24_Appx% %VCLibs14_Appx%", "%Calculator_License%"
			if "%InboxApp%" equ "Camera" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Camera", "%Camera_Appx%", "%NETNativeFramework22_Appx% %NETNativeRuntime22_Appx% %VCLibs14_Appx%", "%Camera_License%"
			if "%InboxApp%" equ "CommunicationsApps" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Windows Mail", "%CommunicationsApps_Appx%", "%VCLibs14_Appx%", "%CommunicationsApps_License%"
			if "%InboxApp%" equ "Cortana" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Cortana", "%Cortana_Appx%", "%NETNativeFramework22_Appx% %NETNativeRuntime22_Appx% %UIXaml24_Appx% %VCLibsUWPDesktop14_Appx% %VCLibs14_Appx%", "%Cortana_License%"
			if "%InboxApp%" equ "DesktopAppInstaller" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "App Installer", "%DesktopAppInstaller_Appx%", "%VCLibsUWPDesktop14_Appx% %VCLibs14_Appx%", "%DesktopAppInstaller_License%"
			if "%InboxApp%" equ "FeedbackHub" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Feedback Hub", "%FeedbackHub_Appx%", "%NETNativeFramework22_Appx% %NETNativeRuntime22_Appx% %UIXaml24_Appx% %VCLibs14_Appx%", "%FeedbackHub_License%"
			if "%InboxApp%" equ "GetHelp" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Get Help", "%GetHelp_Appx%", "%NETNativeFramework22_Appx% %NETNativeRuntime22_Appx% %VCLibs14_Appx%", "%GetHelp_License%"
			if "%InboxApp%" equ "Getstarted" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Tips", "%Getstarted_Appx%", "%NETNativeFramework22_Appx% %NETNativeRuntime22_Appx% %VCLibs14_Appx%", "%Getstarted_License%"
			if "%InboxApp%" equ "HEIFImageExtension" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "HEIF Image Codec Plugin", "%HEIFImageExtension_Appx%", "%VCLibs14_Appx%", "%HEIFImageExtension_License%"
			if "%InboxApp%" equ "HEVCVideoExtension" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "HEVC Video Codec Plugin", "%HEVCVideoExtension_Appx%", "%VCLibs14_Appx%", "%HEVCVideoExtension_License%"
			if "%InboxApp%" equ "Maps" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Maps", "%Maps_Appx%", "%NETNativeFramework22_Appx% %NETNativeRuntime22_Appx% %UIXaml23_Appx% %VCLibs14_Appx%", "%Maps_License%"
			if "%InboxApp%" equ "Messaging" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Messaging", "%Messaging_Appx%", "%NETNativeFramework22_Appx% %NETNativeRuntime22_Appx% %UIXaml24_Appx% %VCLibs14_Appx%", "%Messaging_License%"
			if "%InboxApp%" equ "MixedRealityPortal" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Mixed Reality Portal", "%MixedRealityPortal_Appx%", "%VCLibs14_Appx%", "%MixedRealityPortal_License%"
			if "%InboxApp%" equ "MixedRealityViewer" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "3D Viewer", "%MixedRealityViewer_Appx%", "%NETNativeFramework22_Appx% %NETNativeRuntime22_Appx% %UIXaml21_Appx% %VCLibsUWPDesktop14_Appx% %VCLibs14_Appx%", "%MixedRealityViewer_License%"
			if "%InboxApp%" equ "MPEG2VideoExtension" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "MPEG-2 Video Codec Plugin", "%MPEG2VideoExtension_Appx%", "%VCLibs14_Appx%", "%MPEG2VideoExtension_License%"
			if "%InboxApp%" equ "OfficeHub" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "My Office", "%OfficeHub_Appx%", "%VCLibs14_Appx%", "%OfficeHub_License%"
			if "%InboxApp%" equ "OneNote" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Office OneNote", "%OneNote_Appx%", "%VCLibs14_Appx%", "%OneNote_License%"
			if "%InboxApp%" equ "OneConnect" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Mobile Plans", "%OneConnect_Appx%", "%NETNativeFramework22_Appx% %NETNativeRuntime22_Appx% %VCLibs14_Appx%", "%OneConnect_License%"
			if "%InboxApp%" equ "Paint3D" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Paint 3D", "%Paint3D_Appx%", "%UIXaml20_Appx% %VCLibs14_Appx%", "%Paint3D_License%"
			if "%InboxApp%" equ "People" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "People", "%People_Appx%", "%NETNativeFramework22_Appx% %NETNativeRuntime22_Appx% %VCLibs14_Appx%", "%People_License%"
			if "%InboxApp%" equ "Photos" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Photos", "%Photos_Appx%", "%NETNativeFramework22_Appx% %NETNativeRuntime22_Appx% %UIXaml24_Appx% %VCLibs14_Appx%", "%Photos_License%"
			if "%InboxApp%" equ "Print3D" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Print 3D", "%Print3D_Appx%", "%VCLibs14_Appx%", "%Print3D_License%"
			if "%InboxApp%" equ "ScreenSketch" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Snip and Sketch", "%ScreenSketch_Appx%", "%UIXaml24_Appx% %VCLibs14_Appx%", "%ScreenSketch_License%"
			if "%InboxApp%" equ "SkypeApp" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Skype", "%Skype_Appx%", "%NETNativeFramework22_Appx% %NETNativeRuntime22_Appx% %VCLibs14_Appx%", "%Skype_License%"
			if "%InboxApp%" equ "SolitaireCollection" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Solitaire Collection", "%SolitaireCollection_Appx%", "%NETNativeFramework22_Appx% %NETNativeRuntime22_Appx% %VCLibs14_Appx%", "%SolitaireCollection_License%"
			if "%InboxApp%" equ "SoundRecorder" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Voice Recorder", "%SoundRecorder_Appx%", "%UIXaml23_Appx% %VCLibs14_Appx%", "%SoundRecorder_License%"
			if "%InboxApp%" equ "StickyNotes" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Sticky Notes", "%StickyNotes_Appx%", "%NETNativeFramework22_Appx% %NETNativeRuntime22_Appx% %VCLibs14_Appx%", "%StickyNotes_License%"
			if "%InboxApp%" equ "StorePurchaseApp" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Store Purchase App", "%StorePurchaseApp_Appx%", "%NETNativeFramework22_Appx% %NETNativeRuntime22_Appx% %VCLibs14_Appx%", "%StorePurchaseApp_License%"
			if "%InboxApp%" equ "Todos" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Todos", "%Todos_Appx%", "%NETNativeFramework22_Appx% %NETNativeRuntime22_Appx% %UIXaml24_Appx% %VCLibs14_Appx%", "%Todos_License%"
			if "%InboxApp%" equ "VP9VideoExtensions" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Google's VP9 WebM Video Codec Plugin", "%VP9VideoExtensions_Appx%", "%VCLibs14_Appx%", "%VP9VideoExtensions_License%"
			if "%InboxApp%" equ "Wallet" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Microsoft Pay", "%Wallet_Appx%", "%NETNativeFramework17_Appx% %NETNativeRuntime17_Appx% %VCLibs14_Appx%", "%Wallet_License%"
			if "%InboxApp%" equ "WebMediaExtensions" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Web Media Codec Plugin", "%WebMediaExtensions_Appx%", "%VCLibs14_Appx%", "%WebMediaExtensions_License%"
			if "%InboxApp%" equ "WebpImageExtension" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "WebP Image Codec Plugin", "%WebpImageExtension_Appx%", "%VCLibs14_Appx%", "%WebpImageExtension_License%"
			if "%InboxApp%" equ "WindowsStore" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Windows Store", "%WindowsStore_Appx%", "%NETNativeFramework22_Appx% %NETNativeRuntime22_Appx% %VCLibs14_Appx%", "%WindowsStore_License%"
			if "%InboxApp%" equ "Xbox" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Xbox Console Companion", "%Xbox_Appx% %NETNativeFramework17_Appx%", "%NETNativeRuntime17_Appx% %VCLibsUWPDesktop14_Appx% %VCLibs14_Appx%", "%Xbox_License%"
			if "%InboxApp%" equ "XboxGameOverlay" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Xbox Game Bar Plugin", "%XboxGameOverlay_Appx%", "%VCLibs14_Appx%", "%XboxGameOverlay_License%"
			if "%InboxApp%" equ "XboxGamingOverlay" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Xbox Game Bar", "%XboxGamingOverlay_Appx%", "%VCLibsUWPDesktop14_Appx% %VCLibs14_Appx%", "%XboxGamingOverlay_License%"
			if "%InboxApp%" equ "XboxIdentityProvider" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Xbox Identity Provider", "%XboxIdentityProvider_Appx%", "%NETNativeFramework22_Appx% %NETNativeRuntime22_Appx% %VCLibs14_Appx%", "%XboxIdentityProvider_License%"
			if "%InboxApp%" equ "XboxSpeechToTextOverlay" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Xbox Live In-Game Experience", "%XboxSpeechToTextOverlay_Appx%", "%VCLibs14_Appx%", "%XboxSpeechToTextOverlay_License%"
			if "%InboxApp%" equ "XboxTCUI" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Xbox UI", "%XboxTCUI_Appx%", "%NETNativeFramework16_Appx% %NETNativeRuntime16_Appx% %VCLibs14_Appx%", "%XboxTCUI_License%"
			if "%InboxApp%" equ "YourPhone" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Your Phone", "%YourPhone_Appx%", "%NETNativeFramework22_Appx% %NETNativeRuntime22_Appx% %VCLibsUWPDesktop14_Appx% %VCLibs14_Appx%", "%YourPhone_License%"
			if "%InboxApp%" equ "ZuneMusic" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Groove Music", "%ZuneMusic_Appx%", "%UIXaml24_Appx% %VCLibs14_Appx%", "%ZuneVideo_License%"
			if "%InboxApp%" equ "ZuneVideo" if "%ImageBuild%" leq "18363" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Films and TV", "%ZuneVideo_Appx%", "%UIXaml24_Appx% %VCLibs14_Appx%", "%ZuneVideo_License%"
			if "%InboxApp%" equ "ZuneVideo" if "%ImageBuild%" geq "19041" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Movies and TV", "%ZuneVideo_Appx%", "%UIXaml24_Appx% %VCLibs14_Appx%", "%ZuneVideo_License%"

			if "%InboxApp%" equ "AllApps" (
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "3D Viewer", "%MixedRealityViewer_Appx%", "%NETNativeFramework22_Appx% %NETNativeRuntime22_Appx% %UIXaml21_Appx% %VCLibsUWPDesktop14_Appx% %VCLibs14_Appx%", "%MixedRealityViewer_License%"
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Alarms and Clock", "%Alarms_Appx%", "%NETNativeFramework22_Appx% %NETNativeRuntime22_Appx% %UIXaml24_Appx% %VCLibs14_Appx%", "%Alarms_License%"
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "App Installer", "%DesktopAppInstaller_Appx%", "%VCLibsUWPDesktop14_Appx% %VCLibs14_Appx%", "%DesktopAppInstaller_License%"
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "AV1 Video Codec Plugin", "%AV1VideoExtension_Appx%", "%VCLibs14_Appx%", "%AV1VideoExtension_License%"
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Calculator", "%Calculator_Appx%", "%UIXaml24_Appx% %VCLibs14_Appx%", "%Calculator_License%"
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Camera", "%Camera_Appx%", "%NETNativeFramework22_Appx% %NETNativeRuntime22_Appx% %VCLibs14_Appx%", "%Camera_License%"
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Cortana", "%Cortana_Appx%", "%NETNativeFramework22_Appx% %NETNativeRuntime22_Appx% %UIXaml24_Appx% %VCLibsUWPDesktop14_Appx% %VCLibs14_Appx%", "%Cortana_License%"
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Feedback Hub", "%FeedbackHub_Appx%", "%NETNativeFramework22_Appx% %NETNativeRuntime22_Appx% %UIXaml24_Appx% %VCLibs14_Appx%", "%FeedbackHub_License%"
				if "%ImageBuild%" leq "18363" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Films and TV", "%ZuneVideo_Appx%", "%UIXaml24_Appx% %VCLibs14_Appx%", "%ZuneVideo_License%"
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Get Help", "%GetHelp_Appx%", "%NETNativeFramework22_Appx% %NETNativeRuntime22_Appx% %VCLibs14_Appx%", "%GetHelp_License%"
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Google's VP9 WebM Video Codec Plugin", "%VP9VideoExtensions_Appx%", "%VCLibs14_Appx%", "%VP9VideoExtensions_License%"
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Groove Music", "%ZuneMusic_Appx%", "%UIXaml24_Appx% %VCLibs14_Appx%", "%ZuneVideo_License%"
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "HEIF Image Codec Plugin", "%HEIFImageExtension_Appx%", "%VCLibs14_Appx%", "%HEIFImageExtension_License%"
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "HEIF Video Codec Plugin", "%HEVCVideoExtension_Appx%", "%VCLibs14_Appx%", "%HEVCVideoExtension_License%"
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Maps", "%Maps_Appx%", "%NETNativeFramework22_Appx% %NETNativeRuntime22_Appx% %UIXaml23_Appx% %VCLibs14_Appx%", "%Maps_License%"
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Messaging", "%Messaging_Appx%", "%NETNativeFramework22_Appx% %NETNativeRuntime22_Appx% %UIXaml24_Appx% %VCLibs14_Appx%", "%Messaging_License%"
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "MPEG-2 Video Codec Plugin", "%MPEG2VideoExtension_Appx%", "%VCLibs14_Appx%", "%MPEG2VideoExtension_License%"
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Microsoft Pay", "%Wallet_Appx%", "%NETNativeFramework17_Appx% %NETNativeRuntime17_Appx% %VCLibs14_Appx%", "%Wallet_License%"
				if "%ImageArchitecture%" equ "x64" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Mixed Reality Portal", "%MixedRealityPortal_Appx%", "%VCLibs14_Appx%", "%MixedRealityPortal_License%"
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Mobile Plans", "%OneConnect_Appx%", "%NETNativeFramework22_Appx% %NETNativeRuntime22_Appx% %VCLibs14_Appx%", "%OneConnect_License%"
				if "%ImageBuild%" geq "19041" call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Movies and TV", "%ZuneVideo_Appx%", "%UIXaml24_Appx% %VCLibs14_Appx%", "%ZuneVideo_License%"
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "My Office", "%OfficeHub_Appx%", "%VCLibs14_Appx%", "%OfficeHub_License%"
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "News", "%BingNews_Appx%", "%NETNativeFramework22_Appx% %NETNativeRuntime22_Appx% %UIXaml21_Appx% %VCLibs14_Appx%", "%BingNews_License%"
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Office OneNote", "%OneNote_Appx%", "%VCLibs14_Appx%", "%OneNote_License%"
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Paint 3D", "%Paint3D_Appx%", "%UIXaml20_Appx% %VCLibs14_Appx%", "%Paint3D_License%"
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "People", "%People_Appx%", "%NETNativeFramework22_Appx% %NETNativeRuntime22_Appx% %VCLibs14_Appx%", "%People_License%"
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Photos", "%Photos_Appx%", "%NETNativeFramework22_Appx% %NETNativeRuntime22_Appx% %UIXaml24_Appx% %VCLibs14_Appx%", "%Photos_License%"
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Print 3D", "%Print3D_Appx%", "%VCLibs14_Appx%", "%Print3D_License%"
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Snip and Sketch", "%ScreenSketch_Appx%", "%UIXaml24_Appx% %VCLibs14_Appx%", "%ScreenSketch_License%"
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Skype", "%Skype_Appx%", "%NETNativeFramework22_Appx% %NETNativeRuntime22_Appx% %VCLibs14_Appx%", "%Skype_License%"
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Solitaire Collection", "%SolitaireCollection_Appx%", "%NETNativeFramework22_Appx% %NETNativeRuntime22_Appx% %VCLibs14_Appx%", "%SolitaireCollection_License%"
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Sticky Notes", "%StickyNotes_Appx%", "%NETNativeFramework22_Appx% %NETNativeRuntime22_Appx% %VCLibs14_Appx%", "%StickyNotes_License%"
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Store Purchase App", "%StorePurchaseApp_Appx%", "%NETNativeFramework22_Appx% %NETNativeRuntime22_Appx% %VCLibs14_Appx%", "%StorePurchaseApp_License%"
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Tips", "%Getstarted_Appx%", "%NETNativeFramework22_Appx% %NETNativeRuntime22_Appx% %VCLibs14_Appx%", "%Getstarted_License%"
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Todos", "%Todos_Appx%", "%NETNativeFramework22_Appx% %NETNativeRuntime22_Appx% %UIXaml24_Appx% %VCLibs14_Appx%", "%Todos_License%"
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Voice Recorder", "%SoundRecorder_Appx%", "%UIXaml23_Appx% %VCLibs14_Appx%", "%SoundRecorder_License%"
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Weather", "%BingWeather_Appx%", "%NETNativeFramework22_Appx% %NETNativeRuntime22_Appx% %UIXaml21_Appx% %VCLibs14_Appx%", "%BingWeather_License%"
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Web Media Codec Plugin", "%WebMediaExtensions_Appx%", "%VCLibs14_Appx%", "%WebMediaExtensions_License%"
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "WebP Image Codec Plugin", "%WebpImageExtension_Appx%", "%VCLibs14_Appx%", "%WebpImageExtension_License%"
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Windows Mail", "%CommunicationsApps_Appx%", "%VCLibs14_Appx%", "%CommunicationsApps_License%"
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Windows Store", "%WindowsStore_Appx%", "%NETNativeFramework22_Appx% %NETNativeRuntime22_Appx% %VCLibs14_Appx%", "%WindowsStore_License%"
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Xbox Console Companion", "%Xbox_Appx% %NETNativeFramework17_Appx%", "%NETNativeRuntime17_Appx% %VCLibsUWPDesktop14_Appx% %VCLibs14_Appx%", "%Xbox_License%"
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Xbox Game Bar Plugin", "%XboxGameOverlay_Appx%", "%VCLibs14_Appx%", "%XboxGameOverlay_License%"
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Xbox Game Bar", "%XboxGamingOverlay_Appx%", "%VCLibsUWPDesktop14_Appx% %VCLibs14_Appx%", "%XboxGamingOverlay_License%"
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Xbox Identity Provider", "%XboxIdentityProvider_Appx%", "%NETNativeFramework22_Appx% %NETNativeRuntime22_Appx% %VCLibs14_Appx%", "%XboxIdentityProvider_License%"
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Xbox Live In-Game Experience", "%XboxSpeechToTextOverlay_Appx%", "%VCLibs14_Appx%", "%XboxSpeechToTextOverlay_License%"
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Xbox UI", "%XboxTCUI_Appx%", "%NETNativeFramework16_Appx% %NETNativeRuntime16_Appx% %VCLibs14_Appx%", "%XboxTCUI_License%"
				call :AddProvisionedAppxPackage "%InstallMount%\%%i", "Your Phone", "%YourPhone_Appx%", "%NETNativeFramework22_Appx% %NETNativeRuntime22_Appx% %VCLibsUWPDesktop14_Appx% %VCLibs14_Appx%", "%YourPhone_License%"
			)

			echo.-------------------------------------------------------------------------------
			echo.Optimizing Microsoft Default Inbox Apps...
			echo.-------------------------------------------------------------------------------
			%DISM% /Image:"%InstallMount%\%%i" /Optimize-ProvisionedAppxPackages
			echo.
		)
	)
)

echo.-------------------------------------------------------------------------------
echo.####Finished Integrating Microsoft Default Inbox Apps##########################
echo.-------------------------------------------------------------------------------
echo.

:Stop
echo.===============================================================================
echo.
pause

set InboxApp=

set Apps=

set Alarms_Appx=
set BingFinance_Appx=
set BingFoodDrink_Appx=
set BingHealthFitness_Appx=
set BingMaps_Appx=
set BingNews_Appx=
set BingSports_Appx=
set BingTravel_Appx=
set BingWeather_Appx=
set Calculator_Appx=
set Camera_Appx=
set CommunicationsApps_Appx=
set Cortana_Appx=
set DesktopAppInstaller_Appx=
set FeedbackHub_Appx=
set GetHelp_Appx=
set Getstarted_Appx=
set HEIFImageExtension_Appx=
set HEVCVideoExtension_Appx=
set HelpAndTips_Appx=
set Maps_Appx=
set Messaging_Appx=
set MixedRealityPortal_Appx=
set MixedRealityViewer_Appx=
set MPEG2VideoExtension_Appx=
set OfficeHub_Appx=
set OneNote_Appx=
set OneConnect_Appx=
set Paint3D_Appx=
set People_Appx=
set Photos_Appx=
set Print3D_Appx=
set Reader_Appx=
set ReadingList_Appx=
set Scan_Appx=
set ScreenSketch_Appx=
set Skype_Appx=
set SolitaireCollection_Appx=
set SoundRecorder_Appx=
set StickyNotes_Appx=
set StorePurchaseApp_Appx=
set VP9VideoExtensions_Appx=
set Wallet_Appx=
set WebMediaExtensions_Appx=
set WebpImageExtension_Appx=
set WindowsStore_Appx=
set Xbox_Appx=
set XboxGameOverlay_Appx=
set XboxGamingOverlay_Appx=
set XboxIdentityProvider_Appx=
set XboxLiveGames_Appx=
set XboxSpeechToTextOverlay_Appx=
set XboxTCUI_Appx=
set YourPhone_Appx=
set ZuneMusic_Appx=
set ZuneVideo_Appx=

set AdvertisingXaml_Appx=
set MediaPlayReadyClient22_Appx=
set NETNativeFramework13_Appx=
set NETNativeFramework16_Appx=
set NETNativeFramework17_Appx=
set NETNativeFramework21_Appx=
set NETNativeFramework22_Appx=
set NETNativeRuntime13_Appx=
set NETNativeRuntime14_Appx=
set NETNativeRuntime16_Appx=
set NETNativeRuntime17_Appx=
set NETNativeRuntime21_Appx=
set NETNativeRuntime22_Appx=
set ServicesStoreEngagement_Appx=
set UIXaml20_Appx=
set UIXaml21_Appx=
set UIXaml22_Appx=
set UIXaml23_Appx=
set UIXaml24_Appx=
set VCLibs12_arm_Appx=
set VCLibs12_x86_Appx=
set VCLibs12_x64_Appx=
set VCLibsUWPDesktop14_Appx=
set VCLibs14_Appx=
set WinJS20_Appx=

endlocal

:: Returning to Integrate Microsoft Default Inbox Apps Menu
goto :IntInboxApps
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: MSMG ToolKit - Integrate Microsoft Office Desktop Universal Windows Platform (UWP) Apps
::-------------------------------------------------------------------------------------------
:IntOfficeUWPApps

setlocal

set OfficeUWPApp=
set OfficeDesktop_Appx=
set OfficeAccess_Appx=
set OfficeExcel_Appx=
set OfficeOutlook_Appx=
set OfficePowerPoint_Appx=
set OfficePublisher_Appx=
set OfficeWord_Appx=

set OfficeDesktop_License=
set OfficeAccess_License=
set OfficeExcel_License=
set OfficeOutlook_License=
set OfficePowerPoint_License=
set OfficePublisher_License=
set OfficeWord_License=

cls
echo.===============================================================================
echo.   MSMG ToolKit - Integrer les applications Microsoft Office Desktop ^(UWP^) 
echo.===============================================================================
echo.

:: Checking whether Microsoft Office Desktop (UWP) Apps folder is empty
if not exist "%OfficeUWP%\*.appxbundle" (
	echo.Microsoft Office Desktop ^(UWP^) Le dossier Apps Pack ^<Packs\%OfficeUWP%^> 
	echo.est vide.
	echo.
	echo.Veuillez copier les fichiers du pack d'applications Microsoft Office 
	echo. Desktop ^(UWP^) dans le dossier respectif. 
	echo.
	goto :Stop
)

if not exist "%OfficeUWP%\*.xml" (
	echo.Microsoft Office Desktop ^(UWP^) Le dossier Apps Pack ^<Packs\%OfficeUWP%^> 
	echo.est vide.
	echo.
	echo.Veuillez copier les fichiers du pack d'applications Microsoft Office 
	echo. Desktop ^(UWP^) dans le dossier respectif. 
	echo.
	goto :Stop
)

cls
echo.===============================================================================
echo.     MSMG ToolKit - Integrer le menu des applications de MO Desktop ^(UWP^) 
echo.===============================================================================
echo.
echo.  [1]  Microsoft Office Access 2016
echo.
echo.  [2]  Microsoft Office Excel 2016
echo.
echo.  [3]  Microsoft Office Outlook 2016
echo.
echo.  [4]  Microsoft Office PowerPoint 2016
echo.
echo.  [5]  Microsoft Office Publisher 2016
echo.
echo.  [6]  Microsoft Office Word 2016
echo.
echo.
echo.  [A]  All Apps
echo.
echo.  [X]  Retour
echo.
echo.===============================================================================
echo.
choice /C:123456AX /N /M "Entrer votre choix : "

if errorlevel 8 goto :IntFeaturesMenu
if errorlevel 7 set "OfficeUWPApp=AllOfficeApps"
if errorlevel 6 set "OfficeUWPApp=OfficeWord"
if errorlevel 5 set "OfficeUWPApp=OfficePublisher"
if errorlevel 4 set "OfficeUWPApp=OfficePowerPoint"
if errorlevel 3 set "OfficeUWPApp=OfficeOutlook"
if errorlevel 2 set "OfficeUWPApp=OfficeExcel"
if errorlevel 1 set "OfficeUWPApp=OfficeAccess"

:: Getting Install Image Index Architecture
for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" call :GetImageArchitecture "%InstallWim%", %%i >nul
)

:: Getting Microsoft Office Desktop (UWP) Apps files full pathnames
cd /d "%OfficeUWP%\"

for /f %%i IN ('"dir /b *Microsoft.Office.Desktop_*.appxbundle" 2^>nul') do if exist %%i set "OfficeDesktop_Appx=%OfficeUWP%\%%i"
for /f %%i IN ('"dir /b *Microsoft.Office.Desktop.Access_*.appxbundle" 2^>nul') do if exist %%i set "OfficeAccess_Appx=%OfficeUWP%\%%i"
for /f %%i IN ('"dir /b *Microsoft.Office.Desktop.Excel_*.appxbundle" 2^>nul') do if exist %%i set "OfficeExcel_Appx=%OfficeUWP%\%%i"
for /f %%i IN ('"dir /b *Microsoft.Office.Desktop.Outlook_*.appxbundle" 2^>nul') do if exist %%i set "OfficeOutlook_Appx=%OfficeUWP%\%%i"
for /f %%i IN ('"dir /b *Microsoft.Office.Desktop.PowerPoint*.appxbundle" 2^>nul') do if exist %%i set "OfficePowerPoint_Appx=%OfficeUWP%\%%i"
for /f %%i IN ('"dir /b *Microsoft.Office.Desktop.Publisher_*.appxbundle" 2^>nul') do if exist %%i set "OfficePublisher_Appx=%OfficeUWP%\%%i"
for /f %%i IN ('"dir /b *Microsoft.Office.Desktop.Word_*.appxbundle" 2^>nul') do if exist %%i set "OfficeWord_Appx=%OfficeUWP%\%%i"

for /f %%i IN ('"dir /b *Microsoft.Office.Desktop_*.xml" 2^>nul') do if exist %%i set "OfficeDesktop_License=%OfficeUWP%\%%i"
for /f %%i IN ('"dir /b *Microsoft.Office.Desktop.Access_*.xml" 2^>nul') do if exist %%i set "OfficeAccess_License=%OfficeUWP%\%%i"
for /f %%i IN ('"dir /b *Microsoft.Office.Desktop.Excel_*.xml" 2^>nul') do if exist %%i set "OfficeExcel_License=%OfficeUWP%\%%i"
for /f %%i IN ('"dir /b *Microsoft.Office.Desktop.Outlook_*.xml" 2^>nul') do if exist %%i set "OfficeOutlook_License=%OfficeUWP%\%%i"
for /f %%i IN ('"dir /b *Microsoft.Office.Desktop.PowerPoint_*.xml" 2^>nul') do if exist %%i set "OfficePowerPoint_License=%OfficeUWP%\%%i"
for /f %%i IN ('"dir /b *Microsoft.Office.Desktop.Publisher_*.xml" 2^>nul') do if exist %%i set "OfficePublisher_License=%OfficeUWP%\%%i"
for /f %%i IN ('"dir /b *Microsoft.Office.Desktop.Word_*.xml" 2^>nul') do if exist %%i set "OfficeWord_License=%OfficeUWP%\%%i"

cd /d "%ROOT%\"

cls
echo.===============================================================================
echo.   MSMG ToolKit - Integrer les applications Microsoft Office Desktop ^(UWP^) 
echo.===============================================================================
echo.
echo.-------------------------------------------------------------------------------
echo.####Demarrage de l'integration des applications MO Desktop ^(UWP^) ############
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    : Install.wim
if /i "%ImageIndexNo%" equ "A" echo.    Image Indexes            : 1-%ImageCount%
if /i "%ImageIndexNo%" neq "A" echo.    Image Index              : %ImageIndexNo%
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
echo.
echo.-------------------------------------------------------------------------------
if "%OfficeUWPApp%" equ "AllOfficeApps" echo.####Integrating Microsoft Office Desktop ^(UWP^) Apps############################
if "%OfficeUWPApp%" equ "OfficeAccess" echo.####Integrating Microsoft Office Desktop - Access ^(UWP^) Apps###################
if "%OfficeUWPApp%" equ "OfficeExcel" echo.####Integrating Microsoft Office Desktop - Excel ^(UWP^) Apps####################
if "%OfficeUWPApp%" equ "OfficeOutlook" echo.####Integrating Microsoft Office Desktop - Outlook ^(UWP^) Apps##################
if "%OfficeUWPApp%" equ "OfficePowerPoint" echo.####Integrating Microsoft Office Desktop - PowerPoint ^(UWP^) Apps###############
if "%OfficeUWPApp%" equ "OfficePublisher" echo.####Integrating Microsoft Office Desktop - Publisher ^(UWP^) Apps################
if "%OfficeUWPApp%" equ "OfficeWord" echo.####Integrating Microsoft Office Desktop - Word ^(UWP^) Apps#####################
echo.-------------------------------------------------------------------------------

for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" (
		echo.
		if not %%i gtr 9 echo.===========================[Install.wim, Index : %%i]============================
		if %%i gtr 9 echo.==========================[Install.wim, Index : %%i]============================
		echo.

		:: Getting Image Index Information
		call :GetImageIndexInfo "%InstallWim%", %%i >nul

		if "%OfficeUWPApp%" equ "OfficeAccess" %DISM% /Image:"%InstallMount%\%%i" /Add-ProvisionedAppxPackage /PackagePath:%OfficeDesktop_Appx% /OptionalPackagePath=%OfficeAccess_Appx% /LicensePath:%OfficeDesktop_License% /LicensePath:%OfficeAccess_License%
		if "%OfficeUWPApp%" equ "OfficeExcel" %DISM% /Image:"%InstallMount%\%%i" /Add-ProvisionedAppxPackage /PackagePath:%OfficeDesktop_Appx% /OptionalPackagePath=%OfficeExcel_Appx% /LicensePath:%OfficeDesktop_License% /LicensePath:%OfficeExcel_License%
		if "%OfficeUWPApp%" equ "OfficeOutlook" %DISM% /Image:"%InstallMount%\%%i" /Add-ProvisionedAppxPackage /PackagePath:%OfficeDesktop_Appx% /OptionalPackagePath=%OfficeOutlook_Appx% /LicensePath:%OfficeDesktop_License% /LicensePath:%OfficeOutlook_License%
		if "%OfficeUWPApp%" equ "OfficePowerPoint" %DISM% /Image:"%InstallMount%\%%i" /Add-ProvisionedAppxPackage /PackagePath:%OfficeDesktop_Appx% /OptionalPackagePath=%OfficePowerPoint_Appx% /LicensePath:%OfficeDesktop_License% /LicensePath:%OfficePowerPoint_License%
		if "%OfficeUWPApp%" equ "OfficePublisher" %DISM% /Image:"%InstallMount%\%%i" /Add-ProvisionedAppxPackage /PackagePath:%OfficeDesktop_Appx% /OptionalPackagePath=%OfficePublisher_Appx% /LicensePath:%OfficeDesktop_License% /LicensePath:%OfficePublisher_License%
		if "%OfficeUWPApp%" equ "OfficeWord" %DISM% /Image:"%InstallMount%\%%i" /Add-ProvisionedAppxPackage /PackagePath:%OfficeDesktop_Appx% /OptionalPackagePath=%OfficeWord_Appx% /LicensePath:%OfficeDesktop_License% /LicensePath:%OfficeWord_License%
		if "%OfficeUWPApp%" equ "AllOfficeApps" %DISM% /Image:"%InstallMount%\%%i" /Add-ProvisionedAppxPackage /PackagePath:%OfficeDesktop_Appx% /OptionalPackagePath=%OfficeAccess_Appx% /OptionalPackagePath=%OfficeExcel_Appx% /OptionalPackagePath=%OfficeOutlook_Appx% /OptionalPackagePath=%OfficePowerPoint_Appx% /OptionalPackagePath=%OfficePublisher_Appx% /OptionalPackagePath=%OfficeWord_Appx% /LicensePath:%OfficeDesktop_License% /LicensePath:%OfficeAccess_License% /LicensePath:%OfficeExcel_License% /LicensePath:%OfficeOutlook_License% /LicensePath:%OfficePowerPoint_License% /LicensePath:%OfficePublisher_License% /LicensePath:%OfficeWord_License%
	)
)

echo.
echo.-------------------------------------------------------------------------------
echo.####Fin de l'integration des applications MO Desktop ^(UWP^) ##################
echo.-------------------------------------------------------------------------------
echo.

:Stop
echo.===============================================================================
echo.
pause

set OfficeUWPApp=
set OfficeDesktop_Appx=
set OfficeAccess_Appx=
set OfficeExcel_Appx=
set OfficeOutlook_Appx=
set OfficePowerPoint_Appx=
set OfficePublisher_Appx=
set OfficeWord_Appx=

set OfficeDesktop_License=
set OfficeAccess_License=
set OfficeExcel_License=
set OfficeOutlook_License=
set OfficePowerPoint_License=
set OfficePublisher_License=
set OfficeWord_License=

endlocal

:: Returning to Integrate Features Menu
goto :IntFeaturesMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Integrate Windows Thin PC Add-on Features
::-------------------------------------------------------------------------------------------
:IntThinPcPkgs

if "%IsDialogsEnabled%" equ "Yes" (
	cls
	echo.===============================================================================
	echo.     MSMG ToolKit - Integrer les fonctionnalites complementaires Windows PC 
	echo.===============================================================================
	echo.
	echo.
	echo.
	echo.                              W A R N I N G
	echo.                              =============
	echo.
	echo. N'integrez aucune mise a jour avant d'integrer un pack de langue ou
	echo. toutes les fonctionnalites de Windows. Si vous integrez des mises a jour 
	echo. ^(Hotfix, General. Version de distribution [GDR], patch Zero-Day [ZDP] ou 
	echo. Service Pack [SP]^) qui contient des ressources dependant de la langue/des 
	echo. fonctionnalites avant l'integration toutes les mises a jour, les modifications 
	echo. specifiques a la langue/a la fonctionnalite contenues dans les mises a jour 
	echo. ne sont pas appliquees et vous devrez reintegrer les mises a jour. Integrez 
	echo. toujours les modules linguistiques/fonctionnalites Windows avant de
	echo. Installer les mises a jour. 
	echo.
	echo. Pour desactiver les boites de dialogue d'avertissement, choisissez Desactiver
	echo. les boites de dialogue dans Outils-^>Menu Options
	echo.
	echo.===============================================================================
	echo.
	choice /C:YN /N /M "Voulez-vous continuer ? ['Y'es/'N'o] : "
	if errorlevel 2 goto :IntegrateMenu
)

setlocal

set Feature=

cls
echo.===============================================================================
echo.     MSMG ToolKit - Integrer les fonctionnalites complementaires Windows PC 
echo.===============================================================================

:: Checking whether Multi-Index servicing mode is selected
if /i "%ImageIndexNo%" equ "A" (
	echo.Cette fonction n'est pas disponible lorsque le mode de maintenance 
	echo.multi-index est active. 
	echo.
	echo.Veuillez reselectionner la source avec un seul index
	goto :Stop
)

:: Checking whether the selected Source OS is a Windows Thin PC OS
if "%SelectedSourceOS%" equ "w7" if "%ImageInstallationType%" neq "Embedded" (
	echo.Le systeme d'exploitation source selectionne n'est pas un Windows Thin PC. 
	echo.
	echo.Veuillez utiliser le système d'exploitation Windows Thin PC Source. 
	goto :Stop
)

echo.  [A]  Microsoft .NET Framework 3.5 with Client Profile
echo.  [B]  Windows Backup ^& Restore
echo.  [C]  Windows Basic Help
echo.  [D]  Windows Defender
echo.  [E]  Windows DVD Maker
echo.  [F]  Windows Fax ^& Scan
echo.  [G]  Windows ISO Burner
echo.  [H]  Windows Media Center
echo.  [I]  Windows Media Player Premium Codecs
echo.  [J]  Windows Mobility Center
echo.  [K]  Windows Parental Control
echo.  [L]  Windows Photo Viewer
echo.  [M]  Windows Search
echo.  [N]  Windows Speech ^& Text with Speech US English Pack
echo.  [O]  Windows Tablet PC Support
echo.
echo.  [1]  All Features
echo.
echo.  [X]  Retour
echo.===============================================================================
choice /C:ABCDEFGHIJKLMNo1X /N /M "Enter your choice : "
if errorlevel 17 goto :IntegrateMenu
if errorlevel 16 set "Feature=All"
if errorlevel 15 set "Feature=TabletPC"
if errorlevel 14 set "Feature=SpeechText"
if errorlevel 13 set "Feature=Search"
if errorlevel 12 set "Feature=PhotoViewer"
if errorlevel 11 set "Feature=ParentalControl"
if errorlevel 10 set "Feature=MobilityCenter"
if errorlevel 9  set "Feature=PremiumCodecs"
if errorlevel 8  set "Feature=MediaCenter"
if errorlevel 7  set "Feature=ISOBurner"
if errorlevel 6  set "Feature=FaxScan"
if errorlevel 5  set "Feature=DVDMaker"
if errorlevel 4  set "Feature=Defender"
if errorlevel 3  set "Feature=BasicHelp"
if errorlevel 2  set "Feature=BackupRestore"
if errorlevel 1  set "Feature=NetFx35"

cls
echo.===============================================================================
if "%Feature%" equ "NetFx35" echo.     MSMG ToolKit - Integrate Microsoft .NET Framework 3.5 Add-on Feature
if "%Feature%" equ "BackupRestore" echo.       MSMG ToolKit - Integrate Windows Backup ^& Restore Add-on Feature
if "%Feature%" equ "BasicHelp" echo.         MSMG ToolKit - Integrate Windows Basic Help Add-on Feature
if "%Feature%" equ "Defender" echo.          MSMG ToolKit - Integrate Windows Defender Add-on Feature
if "%Feature%" equ "DVDMaker" echo.          MSMG ToolKit - Integrate Windows DVD Maker Add-on Feature
if "%Feature%" equ "FaxScan" echo.           MSMG ToolKit - Integrate Windows Fax ^& Scan Add-on Feature
if "%Feature%" equ "ISOBurner" echo.          MSMG ToolKit - Integrate Windows ISO Burner Add-on Feature
if "%Feature%" equ "MediaCenter" echo.        MSMG ToolKit - Integrate Windows Media Center Add-on Feature
if "%Feature%" equ "PremiumCodecs" echo.     MSMG ToolKit - Integrate Windows Media Player Premium Codecs Features
if "%Feature%" equ "MobilityCenter" echo.        MSMG ToolKit - Integrate Windows Mobility Center Add-on Feature
if "%Feature%" equ "ParentalControl" echo.       MSMG ToolKit - Integrate Windows Parental Control Add-on Feature
if "%Feature%" equ "PhotoViewer" echo.          MSMG ToolKit - Integrate Windows Photo Viewer Add-on Feature
if "%Feature%" equ "Search" echo.             MSMG ToolKit - Integrate Windows Search Add-on Feature
if "%Feature%" equ "SpeechText" echo.        MSMG ToolKit - Integrate Windows Speech ^& Text Add-on Feature
if "%Feature%" equ "TabletPC" echo.          MSMG ToolKit - Integrate Windows Tablet PC Add-on Feature
if "%Feature%" equ "All" echo.            MSMG ToolKit - Integrate Windows Thin PC Add-on Features
echo.===============================================================================
echo.

:: Getting Install Image Index Architecture
for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" call :GetImageArchitecture "%InstallWim%", %%i >nul
)

:: Checking whether Windows Thin PC Add-on Features folder is empty
if not exist "%ThinPC%\*.*" (
	echo.Windows Thin PC Add-on Features folder ^<Packs\ThinPC^> is empty...
	echo.
	echo.Please copy Windows Thin PC Add-on Features files to respective folder...
	goto :Stop
)

echo.-------------------------------------------------------------------------------
if "%Feature%" equ "NetFx35" echo.####Starting Integrating Microsoft .NET Framework 3.5 Add-on Feature###########
if "%Feature%" equ "BackupRestore" echo.####Starting Integrating Windows Backup ^& Restore Add-on Feature################
if "%Feature%" equ "BasicHelp" echo.####Starting Integrating Windows Basic Help Add-on Feature#####################
if "%Feature%" equ "Defender" echo.####Starting Integrating Windows Defender Add-on Feature#######################
if "%Feature%" equ "DVDMaker" echo.####Starting Integrating Windows DVD Maker Add-on Feature######################
if "%Feature%" equ "FaxScan" echo.####Starting Integrating Windows Fax ^& Scan Add-on Feature#####################
if "%Feature%" equ "ISOBurner" echo.####Starting Integrating Windows ISO Burner Add-on Feature#####################
if "%Feature%" equ "MediaCenter" echo.####Starting Integrating Windows Media Center Add-on Feature###################
if "%Feature%" equ "PremiumCodecs" echo.####Starting Integrating Windows Media Player Premium Codecs Features##########
if "%Feature%" equ "MobilityCenter" echo.####Starting Integrating Windows Mobility Center Add-on Feature################
if "%Feature%" equ "ParentalControl" echo.####Starting Integrating Windows Parental Control Add-on Feature###############
if "%Feature%" equ "PhotoViewer" echo.####Starting Integrating Windows Photo Viewer Add-on Feature###################
if "%Feature%" equ "Search" echo.####Starting Integrating Windows Search Add-on Feature#########################
if "%Feature%" equ "SpeechText" echo.####Starting Integrating Windows Speech ^& Text Add-on Feature##################
if "%Feature%" equ "TabletPC" echo.####Starting Integrating Windows Tablet PC Add-on Feature######################
if "%Feature%" equ "All" echo.####Starting Integrating Windows Thin PC Add-on Features#######################
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    : Install.wim
if /i "%ImageIndexNo%" equ "A" echo.    Image Indexes            : 1-%ImageCount%
if /i "%ImageIndexNo%" neq "A" echo.    Image Index              : %ImageIndexNo%
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
echo.
echo.-------------------------------------------------------------------------------
if "%Feature%" equ "NetFx35" echo.####Integrating Microsoft .NET Framework 3.5 Add-on Feature####################
if "%Feature%" equ "BackupRestore" echo.####Integrating Windows Backup ^& Restore Add-on Feature#######################
if "%Feature%" equ "BasicHelp" echo.####Integrating Windows Basic Help Add-on Feature##############################
if "%Feature%" equ "Defender" echo.####Integrating Windows Defender Add-on Feature################################
if "%Feature%" equ "DVDMaker" echo.####Integrating Windows DVD Maker Add-on Feature###############################
if "%Feature%" equ "FaxScan" echo.####Integrating Windows Fax ^& Scan Add-on Feature##############################
if "%Feature%" equ "ISOBurner" echo.####Integrating Windows ISO Burner Add-on Feature##############################
if "%Feature%" equ "MediaCenter" echo.####Integrating Windows Media Center Add-on Feature############################
if "%Feature%" equ "PremiumCodecs" echo.####Integrating Windows Media Player Premium Codecs Features###################
if "%Feature%" equ "MobilityCenter" echo.####Integrating Windows Mobility Center Add-on Feature#########################
if "%Feature%" equ "ParentalControl" echo.####Integrating Windows Parental Control Add-on Feature########################
if "%Feature%" equ "PhotoViewer" echo.####Integrating Windows Photo Viewer Add-on Feature############################
if "%Feature%" equ "Search" echo.####Integrating Windows Search Add-on Feature##################################
if "%Feature%" equ "SpeechText" echo.####Integrating Windows Speech ^& Text Add-on Feature###########################
if "%Feature%" equ "TabletPC" echo.####Integrating Windows Tablet PC Add-on Feature###############################
if "%Feature%" equ "All" echo.####Integrating Windows Thin PC Add-on Features################################
echo.-------------------------------------------------------------------------------

for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" (
		echo.
		if not %%i gtr 9 echo.===========================[Install.wim, Index : %%i]============================
		if %%i gtr 9 echo.==========================[Install.wim, Index : %%i]============================
		echo.

		:: Getting Image Index Information
		call :GetImageIndexInfo "%InstallWim%", %%i >nul

		if "%ImageEdition%" equ "Embedded" (
			if "%Feature%" equ "NetFx35" (
				echo.-------------------------------------------------------------------------------
				echo.Integrating Microsoft IIS Windows Process Activation Service Package...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%ThinPC%\WinEmb-IIS-WAS~31bf3856ad364e35~x86~~6.1.7601.17514.cab"
				echo.-------------------------------------------------------------------------------
				echo.Integrating Microsoft .NET Framework 3.0 Package...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%ThinPC%\WinEmb-NetFx30~31bf3856ad364e35~x86~~6.1.7601.17514.cab"
				echo.-------------------------------------------------------------------------------
				echo.Integrating Microsoft .NET Framework 3.0 Client Profile Package...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%ThinPC%\WinEmb-NetFx30Client~31bf3856ad364e35~x86~~6.1.7601.17514.cab"
				echo.-------------------------------------------------------------------------------
				echo.Integrating Microsoft .NET Framework 3.5 Package...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%ThinPC%\WinEmb-NetFx35~31bf3856ad364e35~x86~~6.1.7601.17514.cab"
				echo.-------------------------------------------------------------------------------
				echo.Integrating Microsoft .NET Framework 3.5 Client Profile Package...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%ThinPC%\WinEmb-NetFx35Client~31bf3856ad364e35~x86~~6.1.7601.17514.cab"
			)

			if "%Feature%" equ "BackupRestore" call :AddPackage "%InstallMount%\%%i", "%ThinPC%\WinEmb-BackupRestore~31bf3856ad364e35~x86~~6.1.7601.17514.cab"
			if "%Feature%" equ "BasicHelp" call :AddPackage "%InstallMount%\%%i", "%ThinPC%\WinEmb-HelpEngine~31bf3856ad364e35~x86~~6.1.7601.17514.cab"
			if "%Feature%" equ "Defender" call :AddPackage "%InstallMount%\%%i", "%ThinPC%\WinEmb-AntiMalware~31bf3856ad364e35~x86~~6.1.7601.17514.cab"

			if "%Feature%" equ "DVDMaker" (
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows DVD Maker Package...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%ThinPC%\WinEmb-DVDBurning~31bf3856ad364e35~x86~~6.1.7601.17514.cab"
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows ISO Burner Package...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%ThinPC%\WinEmb-IMAPIv2~31bf3856ad364e35~x86~~6.1.7601.17514.cab"
			)

			if "%Feature%" equ "FaxScan" call :AddPackage "%InstallMount%\%%i", "%ThinPC%\WinEmb-Fax-Scan~31bf3856ad364e35~x86~~6.1.7601.17514.cab"
			if "%Feature%" equ "ISOBurner" call :AddPackage "%InstallMount%\%%i", "%ThinPC%\WinEmb-IMAPIv2~31bf3856ad364e35~x86~~6.1.7601.17514.cab"
			if "%Feature%" equ "MediaCenter" call :AddPackage "%InstallMount%\%%i", "%ThinPC%\WinEmb-MediaCenter~31bf3856ad364e35~x86~~6.1.7601.17514.cab"

			if "%Feature%" equ "PremiumCodecs" (
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows Media Player DOLBY AC3 Audio Encoder Premium Codec Package
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%ThinPC%\WinEmb-PremiumCodecs-DOLBY-AC3-AudioEncoder~31bf3856ad364e35~x86~~6.1.7601.17514.cab"
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows Media Player MPEG2 Decoder Premium Codec Package...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%ThinPC%\WinEmb-PremiumCodecs-MPEG2-Decoder~31bf3856ad364e35~x86~~6.1.7600.16385.cab"
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows Media Player MPEG2 Encoder Premium Codec Package...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%ThinPC%\WinEmb-PremiumCodecs-MPEG2-Encoder~31bf3856ad364e35~x86~~6.1.7601.17514.cab"
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows Media Player MPEG2 ^& Dolby Decoder Premium Codec Package..
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%ThinPC%\WinEmb-PremiumCodecs-MPEG2andDolbyDecoder~31bf3856ad364e35~x86~~6.1.7600.16385.cab"
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows Media Player MPEG3 Premium Codec Package...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%ThinPC%\WinEmb-PremiumCodecs-MPEG3~31bf3856ad364e35~x86~~6.1.7600.16385.cab"
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows Media Player MPEG4 Premium Codec Package...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%ThinPC%\WinEmb-PremiumCodecs-MPEG4~31bf3856ad364e35~x86~~6.1.7600.16385.cab"
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows Media Player WMV Premium Codec Package...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%ThinPC%\WinEmb-PremiumCodecs-WMV~31bf3856ad364e35~x86~~6.1.7601.17514.cab"
			)

			if "%Feature%" equ "MobilityCenter" call :AddPackage "%InstallMount%\%%i", "%ThinPC%\WinEmb-MobilePC~31bf3856ad364e35~x86~~6.1.7601.17514.cab"
			if "%Feature%" equ "ParentalControl" call :AddPackage "%InstallMount%\%%i", "%ThinPC%\WinEmb-ParentalControl~31bf3856ad364e35~x86~~6.1.7601.17514.cab"
			if "%Feature%" equ "PhotoViewer" call :AddPackage "%InstallMount%\%%i", "%ThinPC%\WinEmb-Photos-Viewer~31bf3856ad364e35~x86~~6.1.7601.17514.cab"

			if "%Feature%" equ "Search" (
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows Natural Language Package...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%ThinPC%\WinEmb-Natural-Language~31bf3856ad364e35~x86~~6.1.7601.17514.cab"
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows Search Package...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%ThinPC%\WinEmb-Search~31bf3856ad364e35~x86~~6.1.7601.17514.cab"
			)
			
			if "%Feature%" equ "SpeechText" (
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows Speech ^& Text US English Language Pack Package...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%ThinPC%\WinEmb-Speech-LP-ENG~31bf3856ad364e35~x86~~6.1.7600.16385.cab"
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows Speech ^& Text Package...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%ThinPC%\WinEmb-Speech~31bf3856ad364e35~x86~~6.1.7601.17514.cab"
			)

			if "%Feature%" equ "TabletPC" call :AddPackage "%InstallMount%\%%i", "%ThinPC%\WinEmb-Tablet~31bf3856ad364e35~x86~~6.1.7601.17514.cab"

			if "%Feature%" equ "All" (
				echo.-------------------------------------------------------------------------------
				echo.Integrating Microsoft IIS Windows Process Activation Service Package...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%ThinPC%\WinEmb-IIS-WAS~31bf3856ad364e35~x86~~6.1.7601.17514.cab"
				echo.-------------------------------------------------------------------------------
				echo.Integrating Microsoft .NET Framework 3.0 Package...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%ThinPC%\WinEmb-NetFx30~31bf3856ad364e35~x86~~6.1.7601.17514.cab"
				echo.-------------------------------------------------------------------------------
				echo.Integrating Microsoft .NET Framework 3.0 Client Profile Package...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%ThinPC%\WinEmb-NetFx30Client~31bf3856ad364e35~x86~~6.1.7601.17514.cab"
				echo.-------------------------------------------------------------------------------
				echo.Integrating Microsoft .NET Framework 3.5 Package...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%ThinPC%\WinEmb-NetFx35~31bf3856ad364e35~x86~~6.1.7601.17514.cab"
				echo.-------------------------------------------------------------------------------
				echo.Integrating Microsoft .NET Framework 3.5 Client Profile Package...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%ThinPC%\WinEmb-NetFx35Client~31bf3856ad364e35~x86~~6.1.7601.17514.cab"
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows Backup ^& Restore Package...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%ThinPC%\WinEmb-BackupRestore~31bf3856ad364e35~x86~~6.1.7601.17514.cab"
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows Basic Help Package...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%ThinPC%\WinEmb-HelpEngine~31bf3856ad364e35~x86~~6.1.7601.17514.cab"
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows Defender Package...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%ThinPC%\WinEmb-AntiMalware~31bf3856ad364e35~x86~~6.1.7601.17514.cab"
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows DVD Maker Package...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%ThinPC%\WinEmb-DVDBurning~31bf3856ad364e35~x86~~6.1.7601.17514.cab"
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows Fax ^& Scan Feature...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%ThinPC%\WinEmb-Fax-Scan~31bf3856ad364e35~x86~~6.1.7601.17514.cab"
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows ISO Burner Package...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%ThinPC%\WinEmb-IMAPIv2~31bf3856ad364e35~x86~~6.1.7601.17514.cab"
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows Media Center Feature...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%ThinPC%\WinEmb-MediaCenter~31bf3856ad364e35~x86~~6.1.7601.17514.cab"
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows Media Player DOLBY AC3 Audio Encoder Premium Codec Package
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%ThinPC%\WinEmb-PremiumCodecs-DOLBY-AC3-AudioEncoder~31bf3856ad364e35~x86~~6.1.7601.17514.cab"
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows Media Player MPEG2 Decoder Premium Codec Package...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%ThinPC%\WinEmb-PremiumCodecs-MPEG2-Decoder~31bf3856ad364e35~x86~~6.1.7600.16385.cab"
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows Media Player MPEG2 Encoder Premium Codec Package...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%ThinPC%\WinEmb-PremiumCodecs-MPEG2-Encoder~31bf3856ad364e35~x86~~6.1.7601.17514.cab"
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows Media Player MPEG2 ^& Dolby Decoder Premium Codec Package..
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%ThinPC%\WinEmb-PremiumCodecs-MPEG2andDolbyDecoder~31bf3856ad364e35~x86~~6.1.7600.16385.cab"
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows Media Player MPEG3 Premium Codec Package...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%ThinPC%\WinEmb-PremiumCodecs-MPEG3~31bf3856ad364e35~x86~~6.1.7600.16385.cab"
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows Media Player MPEG4 Premium Codec Package...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%ThinPC%\WinEmb-PremiumCodecs-MPEG4~31bf3856ad364e35~x86~~6.1.7600.16385.cab"
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows Media Player WMV Premium Codec Package...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%ThinPC%\WinEmb-PremiumCodecs-WMV~31bf3856ad364e35~x86~~6.1.7601.17514.cab"
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows Mobility Center Feature...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%ThinPC%\WinEmb-MobilePC~31bf3856ad364e35~x86~~6.1.7601.17514.cab"
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows Parental Control Feature...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%ThinPC%\WinEmb-ParentalControl~31bf3856ad364e35~x86~~6.1.7601.17514.cab"
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows Photo Viewer Feature...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%ThinPC%\WinEmb-Photos-Viewer~31bf3856ad364e35~x86~~6.1.7601.17514.cab"
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows Natural Language Package...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%ThinPC%\WinEmb-Natural-Language~31bf3856ad364e35~x86~~6.1.7601.17514.cab"
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows Search Package...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%ThinPC%\WinEmb-Search~31bf3856ad364e35~x86~~6.1.7601.17514.cab"
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows Speech ^& Text US English Language Pack Package...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%ThinPC%\WinEmb-Speech-LP-ENG~31bf3856ad364e35~x86~~6.1.7600.16385.cab"
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows Speech ^& Text Package...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%ThinPC%\WinEmb-Speech~31bf3856ad364e35~x86~~6.1.7601.17514.cab"
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows Tablet PC Support Feature...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%ThinPC%\WinEmb-Tablet~31bf3856ad364e35~x86~~6.1.7601.17514.cab"
			)
		)

		if "%IsLogsEnabled%" equ "Yes" (
			echo.-------------------------------------------------------------------------------
			if "%Feature%" equ "NetFx35" echo.Generating Microsoft .NET Framework 3.5 Add-on Feature Integration Log...
			if "%Feature%" equ "BackupRestore" echo.Generating Windows Backup ^& Restore Add-on Feature Integration Log...
			if "%Feature%" equ "BasicHelp" echo.Generating Windows Basic Help Add-on Feature Integration Log...
			if "%Feature%" equ "Defender" echo.Generating Windows Defender Add-on Feature Integration Log...
			if "%Feature%" equ "DVDMaker" echo.Generating Windows DVD Maker Add-on Feature Integration Log...
			if "%Feature%" equ "FaxScan" echo.Generating Windows Fax ^& Scan Add-on Feature Integration Log...
			if "%Feature%" equ "ISOBurner" echo.Generating Windows ISO Burner Add-on Feature Integration Log...
			if "%Feature%" equ "MediaCenter" echo.Generating Windows Media Center Add-on Feature Integration Log...
			if "%Feature%" equ "PremiumCodecs" echo.Generating Windows Media Player Premium Codecs Features Integration Log...
			if "%Feature%" equ "MobilityCenter" echo.Generating Windows Mobility Center Add-on Feature Integration Log...
			if "%Feature%" equ "ParentalControl" echo.Generating Windows Parental Control Add-on Feature Integration Log...
			if "%Feature%" equ "PhotoViewer" echo.Generating Windows Photo Viewer Add-on Feature Integration Log...
			if "%Feature%" equ "Search" echo.Generating Windows Search Add-on Feature Integration Log...
			if "%Feature%" equ "SpeechText" echo.Generating Windows Speech ^& Text Add-on Feature Integration Log...
			if "%Feature%" equ "TabletPC" echo.Generating Windows Tablet PC Add-on Feature Integration Log...
			if "%Feature%" equ "All" echo.Generating Thin PC Add-on Features Integration Log...
			echo.-------------------------------------------------------------------------------
			echo.Writing Thin PC Add-on Features ^<Logs\ThinPC.txt^> Log file.
			call :GetPackages "%InstallMount%\%%i", "ThinPC.txt"
		)
	)
)

echo.
echo.-------------------------------------------------------------------------------
if "%Feature%" equ "NetFx35" echo.####Finished Integrating Microsoft .NET Framework 3.5 Add-on Feature###########
if "%Feature%" equ "BackupRestore" echo.####Finished Integrating Windows Backup ^& Restore Add-on Feature###############
if "%Feature%" equ "BasicHelp" echo.####Finished Integrating Windows Basic Help Add-on Feature#####################
if "%Feature%" equ "Defender" echo.####Finished Integrating Windows Defender Add-on Feature#######################
if "%Feature%" equ "DVDMaker" echo.####Finished Integrating Windows DVD Maker Add-on Feature######################
if "%Feature%" equ "FaxScan" echo.####Finished Integrating Windows Fax ^& Scan Add-on Feature#####################
if "%Feature%" equ "ISOBurner" echo.####Finished Integrating Windows ISO Burner Add-on Feature#####################
if "%Feature%" equ "MediaCenter" echo.####Finished Integrating Windows Media Center Add-on Feature###################
if "%Feature%" equ "PremiumCodecs" echo.####Finished Integrating Windows Media Player Premium Codecs Features##########
if "%Feature%" equ "MobilityCenter" echo.####Finished Integrating Windows Mobility Center Add-on Feature################
if "%Feature%" equ "ParentalControl" echo.####Finished Integrating Windows Parental Control Add-on Feature###############
if "%Feature%" equ "PhotoViewer" echo.####Finished Integrating Windows Photo Viewer Add-on Feature###################
if "%Feature%" equ "Search" echo.####Finished Integrating Windows Search Add-on Feature#########################
if "%Feature%" equ "SpeechText" echo.####Finished Integrating Windows Speech ^& Text Add-on Feature##################
if "%Feature%" equ "TabletPC" echo.####Finished Integrating Windows Tablet PC Add-on Feature######################
if "%Feature%" equ "All" echo.####Finished Integrating Windows Thin PC Add-on Features#######################
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set Feature=

endlocal

:: Returning to Integrate Windows Thin PC Add-on Features Menu
goto :IntThinPcPkgs
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Integrate Microsoft Diagnostics and Recovery Toolset ^(DaRT^) 7.0/8.1/10
::-------------------------------------------------------------------------------------------
:IntDaRT

setlocal

set DartType=
set PackageLanguage=
set DebugTools=

cls
echo.===============================================================================
if "%SelectedSourceOS%" equ "w7" echo.              MSMG ToolKit - Integrate Microsoft DaRT 7.0 Tools
if "%SelectedSourceOS%" equ "w81" echo.              MSMG ToolKit - Integrate Microsoft DaRT 8.1 Tools
if "%SelectedSourceOS%" equ "w10" echo.               MSMG ToolKit - Integrate Microsoft DaRT 10 Tools
echo.===============================================================================

if "%IsDialogsEnabled%" equ "Yes" (
	echo.
	echo.
	echo.
	echo.                              W A R N I N G
	echo.                              =============
	echo.
	echo. Microsoft DaRT 8.1/10 Tools includes functionality that lets an administrator
	echo. or a help desk worker run the DaRT tools remotely to resolve problems on an
	echo. end-user computer. In addition, you can save the International Organization
	echo. for Standardization ^(ISO^) image to a USB flash drive or put the ISO image on
	echo. a network to include its contents as a recovery partition on a computer's
	echo. hard disk. These capabilities provide flexibility, but also create potential
	echo. security risks that you should consider when configuring DaRT.
	echo.
	echo.
	echo.
	echo. To turn off Warning Dialogs, Choose Disable Dialogs in Tools-^>Options Menu
	echo.
	echo.===============================================================================
	echo.
	choice /C:YN /N /M "Do you want to Continue ? ['Y'es/'N'o] : "
	if errorlevel 2 goto :IntegrateMenu
)

cls
echo.===============================================================================
if "%SelectedSourceOS%" equ "w7" echo.              MSMG ToolKit - Integrate Microsoft DaRT 7.0 Tools
if "%SelectedSourceOS%" equ "w81" echo.              MSMG ToolKit - Integrate Microsoft DaRT 8.1 Tools
if "%SelectedSourceOS%" equ "w10" echo.               MSMG ToolKit - Integrate Microsoft DaRT 10 Tools
echo.===============================================================================
echo.
echo.  [1]  Integrate to Windows Setup Boot Image
echo.
if "%SelectedSourceOS%" neq "w7" (
	echo.  [2]  Integrate to Windows Recovery Image
	echo.
)
if "%SelectedSourceOS%" equ "w7" if "%ImageInstallationType%" neq "Embedded" (
	echo.  [2]  Integrate to Windows Recovery Image
	echo.
)
echo.
echo.
echo.
echo.
echo.
echo.
echo.
echo.
echo.
echo.
echo.
echo.  [X]  Retour
echo.
echo.===============================================================================
echo.
choice /C:12X /N /M "Enter Your Choice : "
if errorlevel 3 goto :IntegrateMenu
if errorlevel 2 set "DartType=Recovery"
if errorlevel 1 set "DartType=Boot"

cls
echo.===============================================================================
if "%SelectedSourceOS%" equ "w7" echo.              MSMG ToolKit - Integrate Microsoft DaRT 7.0 Tools
if "%SelectedSourceOS%" equ "w81" echo.              MSMG ToolKit - Integrate Microsoft DaRT 8.1 Tools
if "%SelectedSourceOS%" equ "w10" echo.               MSMG ToolKit - Integrate Microsoft DaRT 10 Tools
echo.===============================================================================
echo.

:: Checking whether the Source Boot Image is selected
if "%DartType%" equ "Boot" if "%IsBootImageSelected%" equ "No" (
	echo.Windows Setup Boot Image is not selected...
	echo.
	echo.Please choose Windows Setup Boot Image while selecting Source...
	goto :Stop
)

:: Checking whether the Source Recovery Image is selected
if "%DartType%" equ "Recovery" if "%IsRecoveryImageSelected%" equ "No" (
	echo.Windows Recovery Image Is not selected...
	echo.
	echo.Please choose Windows Recovery Image while selecting Source...
	goto :Stop
)

:: Setting Package Language
for /d %%i in (ar-SA,bg-BG,cs-CZ,da-DK,el-GR,en-GB,en-US,et-EE,fi-FI,he-IL,hr-HR,hu-HU,lt-LT,lv-LV,nb-NO,nl-NL,pl-PL,ro-RO,sk-SK,sl-SI,sr-Latn-CS,sr-Latn-RS,sv-SE,th-TH,tr-TR,uk-UA) do (
	if "%ImageDefaultLanguage%" equ "%%i" set "PackageLanguage=en-US"
)

for /d %%l in (de-DE,es-ES,fr-FR,it-IT,ja-JP,ko-KR,pt-BR,ru-RU,zh-CN,zh-TW) do (
   if "%ImageDefaultLanguage%" equ "%%l" set "PackageLanguage=%%l"
)

if "%ImageDefaultLanguage%" equ "es-MX" set "PackageLanguage=es-ES"
if "%ImageDefaultLanguage%" equ "fr-CA" set "PackageLanguage=fr-FR"
if "%ImageDefaultLanguage%" equ "pt-PT" set "PackageLanguage=pt-BR"
if "%ImageDefaultLanguage%" equ "zh-HK" set "PackageLanguage=zh-TW"

:: Setting Microsoft DaRT Tools Pack folder path
set "DaRT=%DaRT%\%SelectedSourceOS%"

:: Setting Microsoft DaRT Tools Debug Tools Package filename
if "%SelectedSourceOS%" equ "w10" (
	if "%ImageBuild%" leq "17763" set "DebugTools=DebugTools_%ImageVersion%.tpk"
	if "%ImageBuild%" geq "18362" if "%ImageBuild%" leq "18363" set "DebugTools=DebugTools_10.0.18362.tpk"
	if "%ImageBuild%" geq "19041" if "%ImageBuild%" leq "19042" set "DebugTools=DebugTools_10.0.19041.tpk"
)

:: Checking whether Microsoft DaRT 7/8.1/10 Tools Base Package file exist
if not exist "%DaRT%\DaRT.tpk" (
	if "%SelectedSourceOS%" equ "w7" echo.Microsoft DaRT 7 Tools Pack file "DaRT.tpk" not found...
	if "%SelectedSourceOS%" equ "w81" echo.Microsoft DaRT 8.1 Tools Pack file "DaRT.tpk" not found...
	if "%SelectedSourceOS%" equ "w10" echo.Microsoft DaRT 10 Tools Pack file "DaRT.tpk" not found...
	echo.
	echo.Please copy the above file to ^<Packs\DaRT\%SelectedSourceOS%^> folder...
	goto :Stop
)

:: Checking whether Microsoft DaRT 7/8.1/10 Tools Language Package file exist
if not exist "%DaRT%\DaRT_%PackageLanguage%.tpk" (
	if "%SelectedSourceOS%" equ "w7" echo.Microsoft DaRT 7 Tools Pack file "DaRT_%PackageLanguage%.tpk" not found...
	if "%SelectedSourceOS%" equ "w81" echo.Microsoft DaRT 8.1 Tools Pack file "DaRT_%PackageLanguage%.tpk" not found...
	if "%SelectedSourceOS%" equ "w10" echo.Microsoft DaRT 10 Tools Pack file "DaRT_%PackageLanguage%.tpk" not found...
	echo.
	echo.Please copy the above file to ^<Packs\DaRT\%SelectedSourceOS%^> folder...
	goto :Stop
)

:: Checking whether Microsoft DaRT 10 Debug Tools Package file exist
if "%SelectedSourceOS%" equ "w10" if not exist "%DaRT%\%DebugTools%" (
	echo.Microsoft DaRT 10 Tools Pack folder is missing the below file...
	echo.
	echo."%DebugTools%"
	echo.
	echo.Please copy the above file to ^<Packs\DaRT\%SelectedSourceOS%^> folder...
	goto :Stop
)

if "%DartType%" equ "Boot" (
	cls
	echo.===============================================================================
	if "%SelectedSourceOS%" equ "w7" echo.  MSMG ToolKit - Integrate Microsoft DaRT 7 Tools to Windows Setup Boot Image
	if "%SelectedSourceOS%" equ "w81" echo. MSMG ToolKit - Integrate Microsoft DaRT 8.1 Tools to Windows Setup Boot Image
	if "%SelectedSourceOS%" equ "w10" echo.  MSMG ToolKit - Integrate Microsoft DaRT 10 Tools to Windows Setup Boot Image
	echo.===============================================================================
	echo.

	:: Getting Boot Image Index Architecture
	call :GetImageArchitecture "%BootWim%", 2 >nul

	echo.-------------------------------------------------------------------------------
	if "%SelectedSourceOS%" equ "w7" echo.####Starting Integrating Microsoft DaRT 7 Tools to Windows Boot Image##########
	if "%SelectedSourceOS%" equ "w81" echo.####Starting Integrating Microsoft DaRT 8.1 Tools to Windows Boot Image########
	if "%SelectedSourceOS%" equ "w10" echo.####Starting Integrating Microsoft DaRT 10 Tools to Windows Boot Image#########
	echo.-------------------------------------------------------------------------------
	echo.
	echo.    Image                    : Boot.wim
	echo.    Image Index              : 2
	echo.    Image Architecture       : %ImageArchitecture%
	echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
	echo.
	echo.-------------------------------------------------------------------------------
	if "%SelectedSourceOS%" equ "w7" echo.####Integrating Microsoft DaRT 7 Tools to Windows Boot Image###################
	if "%SelectedSourceOS%" equ "w81" echo.####Integrating Microsoft DaRT 8.1 Tools to Windows Boot Image#################
	if "%SelectedSourceOS%" equ "w10" echo.####Integrating Microsoft DaRT 10 Tools to Windows Boot Image##################
	echo.-------------------------------------------------------------------------------
	echo.
	echo.-------------------------------------------------------------------------------
	if "%SelectedSourceOS%" equ "w7" echo.Integrating Microsoft DaRT 7 Tools Base Package...
	if "%SelectedSourceOS%" equ "w81" echo.Integrating Microsoft DaRT 8.1 Tools Base Package...
	if "%SelectedSourceOS%" equ "w10" echo.Integrating Microsoft DaRT 10 Tools Base Package...
	echo.-------------------------------------------------------------------------------
	if "%ImageArchitecture%" equ "x86" call :ApplyImage "%DaRT%\DaRT.tpk", 1, "%BootMount%\2"
	if "%ImageArchitecture%" equ "x64" call :ApplyImage "%DaRT%\DaRT.tpk", 2, "%BootMount%\2"

	if "%SelectedSourceOS%" equ "w10" if not exist "%BootMount%\2\Windows\System32\fmapi.dll" (
		if /i "%ImageIndexNo%" equ "A" copy /y "%InstallMount%\1\Windows\System32\fmapi.dll" "%BootMount%\2\Windows\System32" >nul
		if /i "%ImageIndexNo%" neq "A" if %ImageCount% equ 1 copy /y "%InstallMount%\1\Windows\System32\fmapi.dll" "%BootMount%\2\Windows\System32" >nul
		if /i "%ImageIndexNo%" neq "A" if %ImageCount% gtr 1 (
			for /l %%i in (1, 1, %ImageCount%) do (
				if exist "%WinReMount%\%%i" copy /y "%InstallMount%\%%i\Windows\System32\fmapi.dll" "%BootMount%\2\Windows\System32" >nul
			)
		)
	)

	call :RemoveFile "%BootMount%\2\Windows\System32\winpeshl.ini"
	echo.[LaunchApps]>>"%BootMount%\2\Windows\System32\winpeshl.ini"
	echo.%%windir%%\system32\wpeinit.exe>>"%BootMount%\2\Windows\System32\winpeshl.ini"
	echo.%%windir%%\system32\netstart.exe>>"%BootMount%\2\Windows\System32\winpeshl.ini"
	echo.%%systemdrive%%\setup.exe>>"%BootMount%\2\Windows\System32\winpeshl.ini"
	echo.-------------------------------------------------------------------------------
	if "%SelectedSourceOS%" equ "w7" echo.Integrating Microsoft DaRT 7 Tools [%PackageLanguage%] Language Package...
	if "%SelectedSourceOS%" equ "w81" echo.Integrating Microsoft DaRT 8.1 Tools [%PackageLanguage%] Language Package...
	if "%SelectedSourceOS%" equ "w10" echo.Integrating Microsoft DaRT 10 Tools [%PackageLanguage%] Language Package...
	echo.-------------------------------------------------------------------------------
	if "%ImageArchitecture%" equ "x86" call :ApplyImage "%DaRT%\DaRT_%PackageLanguage%.tpk", 1, "%BootMount%\2"
	if "%ImageArchitecture%" equ "x64" call :ApplyImage "%DaRT%\DaRT_%PackageLanguage%.tpk", 2, "%BootMount%\2"

	if "%SelectedSourceOS%" equ "w10" (
		echo.-------------------------------------------------------------------------------
		echo.Integrating Microsoft DaRT 10 Debug Tools Package...
		echo.-------------------------------------------------------------------------------
		if "%ImageArchitecture%" equ "x86" call :ApplyImage "%DaRT%\%DebugTools%", 1, "%BootMount%\2"
		if "%ImageArchitecture%" equ "x64" call :ApplyImage "%DaRT%\%DebugTools%", 2, "%BootMount%\2"
	)

	echo.-------------------------------------------------------------------------------
	if "%SelectedSourceOS%" equ "w7" echo.####Finished Integrating Microsoft DaRT 7 Tools to Windows Boot Image##########
	if "%SelectedSourceOS%" equ "w81" echo.####Finished Integrating Microsoft DaRT 8.1 Tools to Windows Boot Image########
	if "%SelectedSourceOS%" equ "w10" echo.####Finished Integrating Microsoft DaRT 10 Tools to Windows Boot Image#########
	echo.-------------------------------------------------------------------------------
)

if "%DartType%" equ "Recovery" (
	cls
	echo.===============================================================================
	if "%SelectedSourceOS%" equ "w7" echo.   MSMG ToolKit - Integrate Microsoft DaRT 7 Tools to Windows Recovery Image
	if "%SelectedSourceOS%" equ "w81" echo.  MSMG ToolKit - Integrate Microsoft DaRT 8.1 Tools to Windows Recovery Image
	if "%SelectedSourceOS%" equ "w10" echo.   MSMG ToolKit - Integrate Microsoft DaRT 10 Tools to Windows Recovery Image
	echo.===============================================================================
	echo.
	:: Getting Recovery Image Index Architecture
	if /i "%ImageIndexNo%" equ "A" call :GetImageArchitecture "%InstallMount%\1\%WinReWim%", 1 >nul
	if /i "%ImageIndexNo%" neq "A" if %ImageCount% equ 1 call :GetImageArchitecture "%InstallMount%\1\%WinReWim%", 1 >nul
	if /i "%ImageIndexNo%" neq "A" if %ImageCount% gtr 1 (
		for /l %%i in (1, 1, %ImageCount%) do (
			if exist "%WinReMount%\%%i" call :GetImageArchitecture "%WinReMount%\%%i\%WinReWim%", 1 >nul
		)
	)
	echo.-------------------------------------------------------------------------------
	if "%SelectedSourceOS%" equ "w7" echo.####Starting Integrating Microsoft DaRT 7 Tools to Windows Recovery Image######
	if "%SelectedSourceOS%" equ "w81" echo.####Starting Integrating Microsoft DaRT 8.1 Tools to Windows Recovery Image####
	if "%SelectedSourceOS%" equ "w10" echo.####Starting Integrating Microsoft DaRT 10 Tools to Windows Recovery Image#####
	echo.-------------------------------------------------------------------------------
	echo.
	echo.    Image                    : WinRE.wim
	echo.    Image Index              : 1
	echo.    Image Architecture       : %ImageArchitecture%
	echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
	echo.
	echo.-------------------------------------------------------------------------------
	if "%SelectedSourceOS%" equ "w7" echo.####Integrating Microsoft DaRT 7 Tools to Windows Recovery Image###############
	if "%SelectedSourceOS%" equ "w81" echo.####Integrating Microsoft DaRT 8.1 Tools to Windows Recovery Image#############
	if "%SelectedSourceOS%" equ "w10" echo.####Integrating Microsoft DaRT 10 Tools to Windows Recovery Image##############
	echo.-------------------------------------------------------------------------------
	echo.
	for /l %%i in (1, 1, %ImageCount%) do (
		if exist "%WinReMount%\%%i" (
			if not %%i gtr 9 echo.=====================[Install.wim, Index : %%i -^> WinRE.wim]=====================
			if %%i gtr 9 echo.=====================[Install.wim, Index : %%i -^> WinRE.wim]===================
			echo.
			echo.-------------------------------------------------------------------------------
			if "%SelectedSourceOS%" equ "w7" echo.Integrating Microsoft DaRT 7 Tools Base Package...
			if "%SelectedSourceOS%" equ "w81" echo.Integrating Microsoft DaRT 8.1 Tools Base Package...
			if "%SelectedSourceOS%" equ "w10" echo.Integrating Microsoft DaRT 10 Tools Base Package...
			echo.-------------------------------------------------------------------------------
			if "%ImageArchitecture%" equ "x86" call :ApplyImage "%DaRT%\DaRT.tpk", 1, "%WinReMount%\%%i"
			if "%ImageArchitecture%" equ "x64" call :ApplyImage "%DaRT%\DaRT.tpk", 2, "%WinReMount%\%%i"
			if "%SelectedSourceOS%" equ "w10" if not exist "%WinReMount%\%%i\Windows\System32\fmapi.dll" copy /y "%InstallMount%\%%i\Windows\System32\fmapi.dll" "%WinReMount%\%%i\Windows\System32" >nul

			call :RemoveFile "%WinReMount%\%%i\Windows\System32\winpeshl.ini"
			echo.[LaunchApps]>>"%WinReMount%\%%i\Windows\System32\winpeshl.ini"
			echo.%%windir%%\system32\wpeinit.exe>>"%WinReMount%\%%i\Windows\System32\winpeshl.ini"
			echo.%%windir%%\system32\netstart.exe>>"%WinReMount%\%%i\Windows\System32\winpeshl.ini"
			echo.%%systemdrive%%\sources\recovery\recenv.exe>>"%WinReMount%\%%i\Windows\System32\winpeshl.ini"

			echo.-------------------------------------------------------------------------------
			if "%SelectedSourceOS%" equ "w7" echo.Integrating Microsoft DaRT 7 Tools [%PackageLanguage%] Language Package...
			if "%SelectedSourceOS%" equ "w81" echo.Integrating Microsoft DaRT 8.1 Tools [%PackageLanguage%] Language Package...
			if "%SelectedSourceOS%" equ "w10" echo.Integrating Microsoft DaRT 10 Tools [%PackageLanguage%] Language Package...
			echo.-------------------------------------------------------------------------------
			if "%ImageArchitecture%" equ "x86" call :ApplyImage "%DaRT%\DaRT_%PackageLanguage%.tpk", 1, "%WinReMount%\%%i"
			if "%ImageArchitecture%" equ "x64" call :ApplyImage "%DaRT%\DaRT_%PackageLanguage%.tpk", 2, "%WinReMount%\%%i"

			if "%SelectedSourceOS%" equ "w10" (
				echo.-------------------------------------------------------------------------------
				echo.Integrating Microsoft DaRT 10 Debug Tools Package...
				echo.-------------------------------------------------------------------------------
				if "%ImageArchitecture%" equ "x86" call :ApplyImage "%DaRT%\%DebugTools%", 1, "%WinReMount%\%%i"
				if "%ImageArchitecture%" equ "x64" call :ApplyImage "%DaRT%\%DebugTools%", 2, "%WinReMount%\%%i"
			)
		)
	)

	echo.-------------------------------------------------------------------------------
	if "%SelectedSourceOS%" equ "w7" echo.####Finished Integrating Microsoft DaRT 7 Tools to Windows Recovery Image######
	if "%SelectedSourceOS%" equ "w81" echo.####Finished Integrating Microsoft DaRT 8.1 Tools to Windows Recovery Image####
	if "%SelectedSourceOS%" equ "w10" echo.####Finished Integrating Microsoft DaRT 10 Tools to Windows Recovery Image#####
	echo.-------------------------------------------------------------------------------
)

:Stop
echo.
echo.===============================================================================
echo.
pause

set DaRT=
set DartType=
set PackageLanguage=
set DebugTools=

endlocal

:: Returning to Integrate Features Menu
goto :IntFeaturesMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Integrate Microsoft DirectX 9.0c
::-------------------------------------------------------------------------------------------
:IntDirectX9c

setlocal

cls
echo.===============================================================================
echo.               MSMG ToolKit - Integrate Microsoft DirectX 9.0c
echo.===============================================================================
echo.

:: Getting Install Image Index Architecture
for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" call :GetImageArchitecture "%InstallWim%", %%i >nul
)

:: Checking whether Microsoft DirectX 9.0c Pack file exist
if not exist "%DirectX9c%\DirectX9c.tpk" (
	echo.Microsoft DirectX 9.0c Pack file "DirectX9c.tpk" not found...
	echo.
	echo.Please copy the above file to ^<Packs\DirectX9c^> folder...
	goto :Stop
)

:: Checking whether Microsoft DirectX 9.0c Pack file exist
if not exist "%DirectX9c%\DirectX9c_%ImageArchitecture%.reg" (
	echo.Microsoft DirectX 9.0c Pack file "DirectX9c_%ImageArchitecture%.reg" not found...
	echo.
	echo.Please copy the above file to ^<Packs\DirectX9c^> folder...
	goto :Stop
)

echo.-------------------------------------------------------------------------------
echo.####Starting Integrating Microsoft DirectX 9.0c################################
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    : Install.wim
if /i "%ImageIndexNo%" equ "A" echo.    Image Indexes            : 1-%ImageCount%
if /i "%ImageIndexNo%" neq "A" echo.    Image Index              : %ImageIndexNo%
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
echo.
echo.-------------------------------------------------------------------------------
echo.####Integrating Microsoft DirectX 9.0c#########################################
echo.-------------------------------------------------------------------------------

for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" (
		echo.
		if not %%i gtr 9 echo.===========================[Install.wim, Index : %%i]============================
		if %%i gtr 9 echo.==========================[Install.wim, Index : %%i]============================
		echo.

		:: Getting Image Index Information
		call :GetImageIndexInfo "%InstallWim%", %%i >nul

		echo.-------------------------------------------------------------------------------
		echo.Integrating Microsoft DirectX 9.0c Package...
		echo.-------------------------------------------------------------------------------
		if "%ImageArchitecture%" equ "x86" call :ApplyImage "%DirectX9c%\DirectX9c.tpk", 1, "%InstallMount%\%%i"
		if "%ImageArchitecture%" equ "x64" call :ApplyImage "%DirectX9c%\DirectX9c.tpk", 2, "%InstallMount%\%%i"
		echo.-------------------------------------------------------------------------------
		echo.Importing Microsoft DirectX 9.0c Registry Settings...
		echo.-------------------------------------------------------------------------------
		echo.
		echo.Montage du registre d'images
		call :MountImageRegistry "%InstallMount%\%%i"
		echo.Importing Registry Settings to Image Registry...
		call :ImportRegistry2Image "%DirectX9c%\DirectX9c_%ImageArchitecture%.reg"
		echo.Demontage du registre d'images 
		call :UnMountImageRegistry
	)
)

echo.
echo.-------------------------------------------------------------------------------
echo.####Finished Integrating Microsoft DirectX 9.0c################################
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

endlocal

:: Returning to Integrate Features Menu
goto :IntFeaturesMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Integrate Microsoft Games
::-------------------------------------------------------------------------------------------
:IntGames

setlocal

set Game=
set PackageLanguage=

cls
echo.===============================================================================
echo.                   MSMG ToolKit - Integrate Microsoft Games
echo.===============================================================================

:: Getting Install Image Index Architecture
for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" call :GetImageArchitecture "%InstallWim%", %%i >nul
)

:: Checking whether the selected Source OS is a Windows 7 Client Edition
if "%SelectedSourceOS%" equ "w7" if "%ImageInstallationType%" equ "Client" if "%ImageEdition%" neq "HomePremium" if "%ImageEdition%" neq "HomePremiumN" if "%ImageEdition%" neq "Professional" if "%ImageEdition%" neq "ProfessionalN" if "%ImageEdition%" neq "Enterprise" if "%ImageEdition%" neq "EnterpriseN" if "%ImageEdition%" neq "Ultimate" if "%ImageEdition%" neq "UltimateN" (
	cls
	echo.===============================================================================
	echo.                MSMG ToolKit - Integrate Microsoft Games Menu
	echo.===============================================================================
	echo.
	echo.  [1]  Chess Titans
	echo.
	echo.  [2]  Mahjong Titans
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.  [A]  All Games
	echo.
	echo.  [X]  Retour
	echo.
	echo.===============================================================================
	echo.
	choice /C:12AX /N /M "Enter your choice : "
	if errorlevel 4 goto :IntFeaturesMenu
	if errorlevel 3 set "Game=W7Games"
	if errorlevel 2 set "Game=MahjongTitans"
	if errorlevel 1 set "Game=ChessTitans"
)

:: Checking whether the selected Source OS is not a Windows 7 Client Edition
if "%SelectedSourceOS%" equ "w7" if "%ImageInstallationType%" neq "Client" (
	cls
	echo.===============================================================================
	echo.                MSMG ToolKit - Integrate Microsoft Games Menu
	echo.===============================================================================
	echo.
	echo.  [1]  Chess Titans
	echo.  [2]  FreeCell
	echo.  [3]  Hearts
	echo.  [4]  Mahjong Titans
	echo.  [5]  Minesweeper
	echo.  [6]  Purble Place
	echo.  [7]  Solitaire
	echo.  [8]  Spider Solitaire
	echo.
	echo.
	echo.
	echo.
	echo.  [A]  All Games
	echo.
	echo.  [X]  Retour
	echo.
	echo.===============================================================================
	echo.
	choice /C:12345678AX /N /M "Enter your choice : "
	if errorlevel 10 goto :IntFeaturesMenu
	if errorlevel 9 set "Game=W7Games"
	if errorlevel 8 set "Game=SpiderSolitaire"
	if errorlevel 7 set "Game=Solitaire"
	if errorlevel 6 set "Game=PurblePlace"
	if errorlevel 5 set "Game=Minesweeper"
	if errorlevel 4 set "Game=MahjongTitans"
	if errorlevel 3 set "Game=Hearts"
	if errorlevel 2 set "Game=FreeCell"
	if errorlevel 1 set "Game=ChessTitans"
)

:: Checking whether the selected Source OS is not Windows 7
if "%SelectedSourceOS%" neq "w7" (
	cls
	echo.===============================================================================
	echo.                MSMG ToolKit - Integrate Microsoft Games Menu
	echo.===============================================================================
	echo.
	echo.  [1]  Chess Titans
	echo.  [2]  FreeCell
	echo.  [3]  Hearts
	echo.  [4]  Mahjong Titans
	echo.  [5]  Minesweeper
	echo.  [6]  Purble Place
	echo.  [7]  Solitaire
	echo.  [8]  Spider Solitaire
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.  [A]  All Games
	echo.
	echo.  [X]  Retour
	echo.
	echo.===============================================================================
	echo.
	choice /C:12345678AX /N /M "Enter your choice : "
	if errorlevel 10 goto :IntFeaturesMenu
	if errorlevel 9 set "Game=W7Games"
	if errorlevel 8 set "Game=SpiderSolitaire"
	if errorlevel 7 set "Game=Solitaire"
	if errorlevel 6 set "Game=PurblePlace"
	if errorlevel 5 set "Game=Minesweeper"
	if errorlevel 4 set "Game=MahjongTitans"
	if errorlevel 3 set "Game=Hearts"
	if errorlevel 2 set "Game=FreeCell"
	if errorlevel 1 set "Game=ChessTitans"
)

cls
echo.===============================================================================
echo.                   MSMG ToolKit - Integrate Microsoft Games
echo.===============================================================================
echo.

:: Checking whether Microsoft Games Pack file exist
if not exist "%Games%\Games_%ImageArchitecture%.tpk" (
	echo.Microsoft Games Pack file "Games_%ImageArchitecture%.tpk" not found...
	echo.
	echo.Please copy the above file to ^<Packs\Games^> folder...
	goto :Stop
)

:: Checking whether Microsoft Games Pack file exist
if not exist "%Games%\Games_%ImageArchitecture%_%ImageDefaultLanguage%.tpk" (
	echo.Microsoft Games Pack file "Games_%ImageArchitecture%_%ImageDefaultLanguage%.tpk" not found...
	echo.
	echo.Please copy the above file to ^<Packs\Games^> folder...
	goto :Stop
)

:: Checking whether Microsoft Games Pack file exist
for %%j in (W7Games,ChessTitans,FreeCell,Hearts,MahjongTitans,Minesweeper,PurblePlace,Solitaire,SpiderSolitaire) do (
	if "%Game%" equ "%%j" if not exist "%Games%\%Game%.reg" (
		echo.Microsoft Games Pack file "%Game%.reg" not found...
		echo.
		echo.Please copy the above file to ^<Packs\Games^> folder...
		goto :Stop
	)
)

echo.-------------------------------------------------------------------------------
echo.####Starting Integrating Microsoft Games#######################################
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    : Install.wim
if /i "%ImageIndexNo%" equ "A" echo.    Image Indexes            : 1-%ImageCount%
if /i "%ImageIndexNo%" neq "A" echo.    Image Index              : %ImageIndexNo%
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
echo.
echo.-------------------------------------------------------------------------------
echo.####Integrating Microsoft Games################################################
echo.-------------------------------------------------------------------------------

for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" (
		echo.
		if not %%i gtr 9 echo.===========================[Install.wim, Index : %%i]============================
		if %%i gtr 9 echo.==========================[Install.wim, Index : %%i]============================
		echo.

		:: Getting Image Index Information
		call :GetImageIndexInfo "%InstallWim%", %%i >nul

		echo.-------------------------------------------------------------------------------
		echo.Integrating Microsoft Games Base Package...
		echo.-------------------------------------------------------------------------------
		call :ApplyImage "%Games%\Games_%ImageArchitecture%.tpk", 1, "%InstallMount%\%%i"
		echo.-------------------------------------------------------------------------------
		echo.Integrating Microsoft Games Base [%ImageDefaultLanguage%] Language Package...
		echo.-------------------------------------------------------------------------------
		call :ApplyImage "%Games%\Games_%ImageArchitecture%_%ImageDefaultLanguage%.tpk", 1, "%InstallMount%\%%i"

		if "%Game%" equ "ChessTitans" (
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Chess Titans Game Base Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%.tpk", 2, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Chess Titans Game [%ImageDefaultLanguage%] Language Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%_%ImageDefaultLanguage%.tpk", 2, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
		)

		if "%Game%" equ "FreeCell" (
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft FreeCell Game Base Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%.tpk", 3, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft FreeCell Game [%ImageDefaultLanguage%] Language Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%_%ImageDefaultLanguage%.tpk", 3, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
		)

		if "%Game%" equ "Hearts" (
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Hearts Game Base Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%.tpk", 4, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Hearts Game [%ImageDefaultLanguage%] Language Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%_%ImageDefaultLanguage%.tpk", 4, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
		)

		if "%Game%" equ "MahjongTitans" (
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Mahjong Titans Game Base Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%.tpk", 5, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Mahjong Titans Game [%ImageDefaultLanguage%] Language Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%_%ImageDefaultLanguage%.tpk", 5, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
		)

		if "%Game%" equ "Minesweeper" (
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Minesweeper Game Base Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%.tpk", 6, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Minesweeper Game [%ImageDefaultLanguage%] Language Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%_%ImageDefaultLanguage%.tpk", 6, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
		)

		if "%Game%" equ "PurblePlace" (
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Purble Place Game Base Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%.tpk", 7, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Purble Place Game [%ImageDefaultLanguage%] Language Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%_%ImageDefaultLanguage%.tpk", 7, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
		)

		if "%Game%" equ "Solitaire" (
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Solitaire Game Base Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%.tpk", 8, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Solitaire Game [%ImageDefaultLanguage%] Language Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%_%ImageDefaultLanguage%.tpk", 8, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
		)

		if "%Game%" equ "SpiderSolitaire" (
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Spider Solitaire Game Base Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%.tpk", 9, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Spider Solitaire Game [%ImageDefaultLanguage%] Language Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%_%ImageDefaultLanguage%.tpk", 9, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
		)

		if "%Game%" equ "W7Games" if "%SelectedSourceOS%" equ "w7" if "%ImageInstallationType%" equ "Client" if "%ImageEdition%" neq "HomePremium" if "%ImageEdition%" neq "HomePremiumN" if "%ImageEdition%" neq "Professional" if "%ImageEdition%" neq "ProfessionalN" if "%ImageEdition%" neq "Enterprise" if "%ImageEdition%" neq "EnterpriseN" if "%ImageEdition%" neq "Ultimate" if "%ImageEdition%" neq "UltimateN" (
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Chess Titans Game Base Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%.tpk", 2, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Chess Titans Game [%ImageDefaultLanguage%] Language Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%_%ImageDefaultLanguage%.tpk", 2, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Mahjong Titans Game Base Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%.tpk", 5, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Mahjong Titans Game [%ImageDefaultLanguage%] Language Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%_%ImageDefaultLanguage%.tpk", 5, "%InstallMount%\%%i"
		)

		if "%Game%" equ "W7Games" if "%SelectedSourceOS%" equ "w7" if "%ImageInstallationType%" neq "Client" (
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Chess Titans Game Base Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%.tpk", 2, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Chess Titans Game [%ImageDefaultLanguage%] Language Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%_%ImageDefaultLanguage%.tpk", 2, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft FreeCell Game Base Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%.tpk", 3, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft FreeCell Game [%ImageDefaultLanguage%] Language Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%_%ImageDefaultLanguage%.tpk", 3, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Hearts Game Base Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%.tpk", 4, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Hearts Game [%ImageDefaultLanguage%] Language Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%_%ImageDefaultLanguage%.tpk", 4, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Mahjong Titans Game Base Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%.tpk", 5, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Mahjong Titans Game [%ImageDefaultLanguage%] Language Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%_%ImageDefaultLanguage%.tpk", 5, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Minesweeper Game Base Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%.tpk", 6, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Minesweeper Game [%ImageDefaultLanguage%] Language Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%_%ImageDefaultLanguage%.tpk", 6, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Purble Place Game Base Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%.tpk", 7, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Purble Place Game [%ImageDefaultLanguage%] Language Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%_%ImageDefaultLanguage%.tpk", 7, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Solitaire Game Base Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%.tpk", 8, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Solitaire Game [%ImageDefaultLanguage%] Language Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%_%ImageDefaultLanguage%.tpk", 8, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Spider Solitaire Game Base Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%.tpk", 9, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Spider Solitaire Game [%ImageDefaultLanguage%] Language Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%_%ImageDefaultLanguage%.tpk", 9, "%InstallMount%\%%i"
		)

		if "%Game%" equ "W7Games" if "%SelectedSourceOS%" neq "w7" (
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Chess Titans Game Base Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%.tpk", 2, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Chess Titans Game [%ImageDefaultLanguage%] Language Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%_%ImageDefaultLanguage%.tpk", 2, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft FreeCell Game Base Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%.tpk", 3, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft FreeCell Game [%ImageDefaultLanguage%] Language Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%_%ImageDefaultLanguage%.tpk", 3, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Hearts Game Base Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%.tpk", 4, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Hearts Game [%ImageDefaultLanguage%] Language Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%_%ImageDefaultLanguage%.tpk", 4, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Mahjong Titans Game Base Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%.tpk", 5, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Mahjong Titans Game [%ImageDefaultLanguage%] Language Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%_%ImageDefaultLanguage%.tpk", 5, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Minesweeper Game Base Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%.tpk", 6, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Minesweeper Game [%ImageDefaultLanguage%] Language Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%_%ImageDefaultLanguage%.tpk", 6, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Purble Place Game Base Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%.tpk", 7, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Purble Place Game [%ImageDefaultLanguage%] Language Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%_%ImageDefaultLanguage%.tpk", 7, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Solitaire Game Base Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%.tpk", 8, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Solitaire Game [%ImageDefaultLanguage%] Language Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%_%ImageDefaultLanguage%.tpk", 8, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Spider Solitaire Game Base Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%.tpk", 9, "%InstallMount%\%%i"
			echo.-------------------------------------------------------------------------------
			echo.Integrating Microsoft Spider Solitaire Game [%ImageDefaultLanguage%] Language Package...
			echo.-------------------------------------------------------------------------------
			call :ApplyImage "%Games%\Games_%ImageArchitecture%_%ImageDefaultLanguage%.tpk", 9, "%InstallMount%\%%i"
		)

		echo.-------------------------------------------------------------------------------
		echo.Importing Microsoft Games Registry Settings...
		echo.-------------------------------------------------------------------------------
		echo.
		echo.Montage du registre d'images
		call :MountImageRegistry "%InstallMount%\%%i"

		echo.Importing Registry Settings to Image Registry...
		if "%Game%" equ "ChessTitans" call :ImportRegistry2Image "%Games%\ChessTitans.reg"
		if "%Game%" equ "FreeCell" call :ImportRegistry2Image "%Games%\FreeCell.reg"
		if "%Game%" equ "Hearts" call :ImportRegistry2Image "%Games%\Hearts.reg"
		if "%Game%" equ "MahjongTitans" call :ImportRegistry2Image "%Games%\MahjongTitans.reg"
		if "%Game%" equ "Minesweeper" call :ImportRegistry2Image "%Games%\Minesweeper.reg"
		if "%Game%" equ "PurblePlace" call :ImportRegistry2Image "%Games%\PurblePlace.reg"
		if "%Game%" equ "Solitaire" call :ImportRegistry2Image "%Games%\Solitaire.reg"
		if "%Game%" equ "SpiderSolitaire" call :ImportRegistry2Image "%Games%\SpiderSolitaire.reg"
		if "%Game%" equ "W7Games" call :ImportRegistry2Image "%Games%\W7Games.reg"

		echo.Demontage du registre d'images 
		call :UnMountImageRegistry

		:: Deleting Non-Windows Media Center Related Games Shortcuts
		if /i not exist "%InstallMount%\%%i\Windows\ehome" (
			for %%z in (Chess, FreeCell, Hearts, Mahjong, Minesweeper, Purble Place, Solitaire, SpiderSolitaire) do (
				if /i exist "%InstallMount%\%%i\Program Files\Microsoft Games\%%z" (
					cd "%InstallMount%\%%i\Program Files\Microsoft Games\%%z" >nul
					if /i exist desktop.ini (
						attrib -h -s -a desktop.ini
						del /f /q desktop.ini >nul
					)
					cd "%ROOT%" >nul
					call :RemoveFile "%InstallMount%\%%i\Program Files\Microsoft Games\%%z\*MCE.*"
				)
			)
		)
	)
)

echo.
echo.-------------------------------------------------------------------------------
echo.####Finished Integrating Microsoft Games#######################################
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set Game=

endlocal

:: Returning to Integrate Microsoft Games Menu
goto :IntGames
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Integrate Windows Sidebar
::-------------------------------------------------------------------------------------------
:IntSidebar

setlocal

set PackageIndex=

cls
echo.===============================================================================
echo.                   MSMG ToolKit - Integrate Windows Sidebar
echo.===============================================================================
echo.

:: Getting Install Image Index Architecture
for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" call :GetImageArchitecture "%InstallWim%", %%i >nul
)

:: Setting Package Index
if "%ImageArchitecture%" equ "x86" set "PackageIndex=1"
if "%ImageArchitecture%" equ "x64" set "PackageIndex=2"

:: Checking whether Windows Sidebar Pack file exist
if not exist "%Sidebar%\Sidebar.tpk" (
	echo.Windows Sidebar Pack file "Sidebar.tpk" not found...
	echo.
	echo.Please copy the above file to ^<Packs\Sidebar^> folder...
	goto :Stop
)

:: Checking whether Windows Sidebar Pack file exist
if not exist "%Sidebar%\Sidebar_%ImageDefaultLanguage%.tpk" (
	echo.Windows Sidebar Pack file "Sidebar_%ImageDefaultLanguage%.tpk" not found...
	echo.
	echo.Please copy the above file to ^<Packs\Sidebar^> folder...
	goto :Stop
)

:: Checking whether Windows Sidebar Pack file exist
if not exist "%Sidebar%\Sidebar_%ImageArchitecture%.reg" (
	echo.Windows Sidebar Pack file "Sidebar_%ImageArchitecture%.reg" not found...
	echo.
	echo.Please copy the above file to ^<Packs\Sidebar^> folder...
	goto :Stop
)

echo.-------------------------------------------------------------------------------
echo.####Starting Integrating Windows Sidebar#######################################
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    : Install.wim
if /i "%ImageIndexNo%" equ "A" echo.    Image Indexes            : 1-%ImageCount%
if /i "%ImageIndexNo%" neq "A" echo.    Image Index              : %ImageIndexNo%
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
echo.
echo.-------------------------------------------------------------------------------
echo.####Integrating Windows Sidebar################################################
echo.-------------------------------------------------------------------------------

for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" (
		echo.
		if not %%i gtr 9 echo.===========================[Install.wim, Index : %%i]============================
		if %%i gtr 9 echo.==========================[Install.wim, Index : %%i]============================
		echo.

		:: Getting Image Index Information
		call :GetImageIndexInfo "%InstallWim%", %%i >nul

		echo.-------------------------------------------------------------------------------
		echo.Integrating Windows Sidebar Base Package...
		echo.-------------------------------------------------------------------------------
		call :ApplyImage "%Sidebar%\Sidebar.tpk", %PackageIndex%, "%InstallMount%\%%i"
		echo.-------------------------------------------------------------------------------
		echo.Integrating Windows Sidebar [%ImageDefaultLanguage%] Language Package...
		echo.-------------------------------------------------------------------------------
		call :ApplyImage "%Sidebar%\Sidebar_%ImageDefaultLanguage%.tpk", %PackageIndex%, "%InstallMount%\%%i"
		echo.-------------------------------------------------------------------------------
		echo.Importing Windows Sidebar Registry Settings...
		echo.-------------------------------------------------------------------------------
		echo.
		echo.Montage du registre d'images
		call :MountImageRegistry "%InstallMount%\%%i"
		echo.Taking Image Registry Ownership...
		echo.Importing Registry Settings to Image Registry...
		call :ImportRegistry2Image "%Sidebar%\Sidebar_%ImageArchitecture%.reg"
		call :ImportRegistry2Image "%Sidebar%\3rdPartyGadgets_%ImageArchitecture%.reg"
		echo.Demontage du registre d'images 
		call :UnMountImageRegistry
		echo.

		:: Deleting Microsoft Sidebar Media Center files if the Source Edition is not MediaCenter
		if /i not exist "%InstallMount%\%%i\Windows\ehome" call :RemoveFolder "%InstallMount%\%%i\Program Files\Windows Sidebar\Gadgets\MediaCenter.Gadget"
	)
)

echo.
echo.-------------------------------------------------------------------------------
echo.####Finished Integrating Windows Sidebar#######################################
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set PackageIndex=

endlocal

:: Returning to Integrate Features Menu
goto :IntFeaturesMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Integrate Microsoft Visual C++ Runtime
::-------------------------------------------------------------------------------------------
:IntVCRuntime

setlocal

set PackageIndex=

cls
echo.===============================================================================
echo.            MSMG ToolKit - Integrer Microsoft Visual C++ Runtime 
echo.===============================================================================
echo.

:: Setting Microsoft Visual C++ Runtime Pack folder path
set "VCRuntime=%VCRuntime%\%SelectedSourceOS%"

:: Getting Install Image Index Architecture
for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" call :GetImageArchitecture "%InstallWim%", %%i >nul
)

:: Setting Package Index
if "%ImageArchitecture%" equ "x86" set "PackageIndex=1"
if "%ImageArchitecture%" equ "x64" set "PackageIndex=2"

:: Checking whether Microsoft Visual C++ Runtime Pack file exist
if not exist "%VCRuntime%\VC.tpk" (
	echo.Le fichier Microsoft Visual C++ Runtime Pack "VC.tpk" est introuvable.
	echo.
	echo.Veuillez copier le fichier ci-dessus dans le dossier ^<Packs\VCRuntime\%SelectedSourceOS%^>.
	goto :Stop
)

if "%SelectedSourceOS%" equ "w7" if not exist "%VCRuntime%\Windows6.1-KB3118401-%ImageArchitecture%.cab" (
	echo.Le fichier Microsoft Visual C++ Runtime Pack "Windows6.1-KB3118401-%ImageArchitecture%.cab" 
	echo.est introuvable.
	echo.
	echo.Veuillez copier le fichier ci-dessus dans le dossier ^<Packs\VCRuntime\%SelectedSourceOS%^>...
	goto :Stop
)

if "%SelectedSourceOS%" equ "w81" if not exist "%VCRuntime%\Windows8.1-KB3118401-%ImageArchitecture%.cab" (
	echo.Le fichier Microsoft Visual C++ Runtime Pack "Windows8.1-KB3118401-%ImageArchitecture%.cab" 
	echo.est introuvable.
	echo.
	echo.Veuillez copier le fichier ci-dessus dans le dossier ^<Packs\VCRuntime\%SelectedSourceOS%^>...
	goto :Stop
)

for %%i in (Certificates, VC_2005, VC_2008, VC_2010, VC_2012, VC_2013, VC_2019, VC_Legacy) do (
	if not exist "%VCRuntime%\%%i_%ImageArchitecture%.reg" (
		echo.Le fichier Microsoft Visual C++ Runtime Pack 
		echo."%%i_%ImageArchitecture%.reg" est introuvable.
		echo.
		echo.Veuillez copier le fichier ci-dessus dans le dossier 
		echo.^<Packs\VCRuntime\%SelectedSourceOS%^>... 
		goto :Stop
	)
)

echo.-------------------------------------------------------------------------------
echo.####Demarrage de l'integration de Microsoft Visual C++ Runtime  ###############
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    : Install.wim
if /i "%ImageIndexNo%" equ "A" echo.    Image Indexes            : 1-%ImageCount%
if /i "%ImageIndexNo%" neq "A" echo.    Image Index              : %ImageIndexNo%
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
echo.
echo.-------------------------------------------------------------------------------
echo.####Integration de Microsoft Visual C++ Runtime  ##############################
echo.-------------------------------------------------------------------------------

for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" (
		echo.
		if not %%i gtr 9 echo.===========================[Install.wim, Index : %%i]============================
		if %%i gtr 9 echo.==========================[Install.wim, Index : %%i]============================
		echo.

		:: Getting Image Index Information
		call :GetImageIndexInfo "%InstallWim%", %%i >nul

		if "%SelectedSourceOS%" neq "w10" (
			echo.-------------------------------------------------------------------------------
			echo.Integration du package de mise a jour des prerequis Microsoft Visual C++ ... 
			echo.-------------------------------------------------------------------------------
			if "%SelectedSourceOS%" equ "w7" call :AddPackage "%InstallMount%\%%i", "%VCRuntime%\Windows6.1-KB3118401-%ImageArchitecture%.cab"
			if "%SelectedSourceOS%" equ "w81" call :AddPackage "%InstallMount%\%%i", "%VCRuntime%\Windows8.1-KB3118401-%ImageArchitecture%.cab"
		)

		echo.-------------------------------------------------------------------------------
		echo.Integration de Microsoft Visual C++ Runtime Package...
		echo.-------------------------------------------------------------------------------
		call :ApplyImage "%VCRuntime%\VC.tpk", %PackageIndex%, "%InstallMount%\%%i"
		echo.-------------------------------------------------------------------------------
		echo.Importation des parametres du registre d'execution Microsoft Visual C++ ... 
		echo.-------------------------------------------------------------------------------
		echo.
		echo.Montage du registre d'images... 
		call :MountImageRegistry "%InstallMount%\%%i"
		echo.Importation des parametres de registre dans le registre d'images... 

		for %%i in (Certificates, VC_2005, VC_2008, VC_2010, VC_2012, VC_2013, VC_2019, VC_Legacy) do (
			call :ImportRegistry2Image "%VCRuntime%\%%i_%ImageArchitecture%.reg"
		)

		echo.Demontage du registre d'images...
		call :UnMountImageRegistry
	)
)

echo.
echo.-------------------------------------------------------------------------------
echo.####Finished Integrating Microsoft Visual C++ Runtime##########################
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set VCRuntime=
set PackageIndex=

endlocal

:: Returning to Integrate Features Menu
goto :IntFeaturesMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Integrate Windows Updates Menu
::-------------------------------------------------------------------------------------------
:IntUpdatesMenu

if "%IsDialogsEnabled%" equ "Yes" (
	cls
	echo.===============================================================================
	echo.               MSMG ToolKit - Integrer les mises a jour Windows 
	echo.===============================================================================
	echo.
	echo.
	echo.
	echo.                             A T T E N T I O N
	echo.                             =================
	echo.
	echo.  N'integrez aucune mise a jour avant d'integrer un module linguistique ou des 
	echo.  fonctionnalites Windows. Si vous integrez des mises a jour ^(Hotfix, 
	echo.  General Distribution Release [GDR], Zero-Day Patch [ZDP] ou Service Pack
	echo.  [SP]^) qui contient des ressources dependant de la langue/des fonctionnalites 
	echo.  avant d'integrer des mises a jour, la langue/fonctionnalite/les modifications 
	echo.  specifiques contenues dans les mises a jour ne sont pas appliquees et vous 
	echo.  devrez reintegrer les mises a jour. Integrer toujours les modules 
	echo.  linguistiques/fonctionnalites Windows avant d'installer les mises a jour.
	echo.
	echo.
	echo.  Pour desactiver les boites de dialogue d'avertissement, choisissez Desactiver
	echo.  les boites de dialogue dans Outils-^>Menu Options 
	echo.
	echo.===============================================================================
	echo.
	choice /C:YN /N /M "Voulez-vous continuer ? ['Y'es/'N'o] : "
	if errorlevel 2 goto :IntegrateMenu
)

cls
echo.===============================================================================
echo.               MSMG ToolKit - Integrer les mises a jour Windows
echo.===============================================================================
echo.
echo.  [1]   Integrer les mises a jour Windows
echo.
echo.  [2]   Integrer le pack de mise à jour WHD 
echo.
echo.
echo.
echo.
echo.
echo.
echo.
echo.
echo.
echo.
echo.
echo.
echo.  [X]   Retour
echo.
echo.===============================================================================
echo.

choice /C:12X /N /M "Entrer votre choix : "
if errorlevel 3 goto :IntegrateMenu
if errorlevel 2 goto :IntWHDUpdatesMenu
if errorlevel 1 call :IntUpdates WUpdates

:IntWHDUpdatesMenu
cls
echo.===============================================================================
echo.          MSMG ToolKit - Integrer le menu du pack de mise a jour WHD 
echo.===============================================================================
echo.
if "%SelectedSourceOS%" equ "w7" (
	echo.  [1]   Integrez WHD Update Pack au Service Pack 2
	echo.
	echo.  [2]   Integrer le pack de mise a jour WHD sans Service Pack 2
	echo.
	echo.  [3]   Integrer les mises a jour du support d'installation de Windows 
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.  [X]   Retour
	echo.
	echo.===============================================================================
	echo.
)

if "%SelectedSourceOS%" equ "w81" (
	echo.  [1]   Integrer les mises a jour de reference WHD
	echo.
	echo.  [2]   Integrer les mises a jour generales WHD
	echo.
	echo.  [3]   Integrer les mises a jour du correctif WHD
	echo.
	echo.  [4]   Integrer les mises a jour de securite WHD
	echo.
	echo.  [5]   Integrer les mises a jour supplementaires de WHD
	echo.
	echo.  [6]   Integrer les mises a jour du support d'installation de Windows 
	echo.
	echo.
	echo.
	echo.
	echo.  [X]   Retour
	echo.
	echo.===============================================================================
	echo.
)

if "%SelectedSourceOS%" equ "w10" (
	echo.  [1]   Integrer les mises a jour generales WHD
	echo.
	echo.  [2]   Integrer les mises a jour du support d'installation de Windows 
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.  [X]   Retour
	echo.
	echo.===============================================================================
	echo.
)

if "%SelectedSourceOS%" equ "w7" (
	choice /C:123X /N /M "Entrer votre choix : "
	if errorlevel 4 goto :IntegrateMenu
	if errorlevel 3 goto :IntWindowsSetupMediaUpdates
	if errorlevel 2 (
		set IsW7SP1CRUSelected=0
		goto :IntW7WHDUpdatesMenu
	)
	if errorlevel 1 (
		set IsW7SP1CRUSelected=1
		goto :IntW7WHDUpdatesMenu
	)
)

if "%SelectedSourceOS%" equ "w81" (
	choice /C:123456X /N /M "Entrer votre choix : "
	if errorlevel 7 goto :IntegrateMenu
	if errorlevel 6 goto :IntWindowsSetupMediaUpdates
	if errorlevel 5 goto :IntWHDAdditionalMenu
	if errorlevel 4 call :IntUpdates Security
	if errorlevel 3 call :IntUpdates Hotfix
	if errorlevel 2 call :IntUpdates General
	if errorlevel 1 goto :IntWHDBaselineMenu
)

if "%SelectedSourceOS%" equ "w10" (
	choice /C:12X /N /M "Entrer votre choix : "
	if errorlevel 3 goto :IntegrateMenu
	if errorlevel 2 goto :IntWindowsSetupMediaUpdates
	if errorlevel 1 goto :IntWHDBaselineMenu
)

:IntW7WHDUpdatesMenu
if "%IsDialogsEnabled%" equ "Yes" if "%IsW7SP1CRUSelected%" equ "1" (
	cls
	echo.===============================================================================
	echo.      MSMG ToolKit - Integrer les mises a jour WHD avec le Service Pack 2
	echo.===============================================================================
	echo.## Convenience Rollup Update for Windows 7 SP1 aka Service Pack 2 ##
	echo.
	echo.KB3125574 is a comprehensive rollup update that contains almost all fixes
	echo.released after Windows 7 SP1's release, up through April 2016.
	echo.
	echo.If you intend to integrate any of the following feature packages, integrate
	echo.them *first* ^(before KB3125574^) so the rollup can integrate their updated
	echo.components afterwards:
	echo.
	echo.DCA2.0, AD LDS, VirtualPC, WorkFolders, Server Essentials Connector found
	echo.in WHD Additional and Extra Updates section.
	echo.
	echo.This update aims to simplify the updating process for Windows 7, but it's
	echo.completely optional, and for due diligence purposes, be aware that it does
	echo.contain some telemetry updates components ^(3068708, 3075249^).
	echo.So if you do not want this, you should choose Integrate WHD Updates without
	echo.Service Pack 2 option from Integrate WHD Updates Menu.
	echo.
	echo.You could also block these telemetry effects while having the rollup integrated
	echo.refer to this topic for details: http://forums.mydigitallife.info/threads/68131
	echo.===============================================================================
	pause
)
cls
echo.===============================================================================
echo.                 MSMG ToolKit - Integrer les mises a jour WHD 
echo.===============================================================================
echo.
if "%SelectedSourceOS%" equ "w7" (
	echo.  [1]   Integrer les mises a jour supplementaires de WHD
	echo.
	echo.  [2]   Integrer les mises a jour supplémentaires WHD
	echo.
	echo.  [3]   Integrer les mises a jour générales WHD
	echo.
	echo.  [4]   Integrer les mises a jour du correctif WHD
	echo.
	echo.  [5]   Integrer les mises a jour de sécurité WHD
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.  [X]   Retour
	echo.
	echo.===============================================================================
	echo.
)

if "%SelectedSourceOS%" equ "w7" (
	choice /C:12345X /N /M "Entrer votre choix : "
	if errorlevel 6 goto :IntegrateMenu
	if errorlevel 5 call :IntUpdates "Security"
	if errorlevel 4 call :IntUpdates "Hotfix"
	if errorlevel 3 call :IntUpdates "General"
	if errorlevel 2 goto :IntWHDExtraMenu
	if errorlevel 1 goto :IntWHDAdditionalMenu
)

:IntWHDBaselineMenu
cls

echo.===============================================================================
if "%SelectedSourceOS%" equ "w81" echo.               MSMG ToolKit - Integrer le menu des mises a jour de la ligne de base WHD 
if "%SelectedSourceOS%" equ "w10" echo.              MSMG ToolKit - Integrer le menu des mises a jour generales de WHD
echo.===============================================================================
echo.
echo.  [1]   Integration a l'image de demarrage de l'installation de Windows
echo.
echo.  [2]   Integration a l'image d'installation de l'installation de Windows
echo.
echo.  [3]   Integrer a l'installation de Windows Installer ^& l'image de recuperation
echo.
echo.  [4]   Integration a l'image de demarrage, d'installation et de recuperation de l'installation de Windows 
echo.
echo.
echo.
echo.
echo.
echo.
echo.
echo.
echo.  [X]   Retour
echo.
echo.===============================================================================
echo.
choice /C:1234X /N /M "Entrer votre choix : "
if errorlevel 5 goto :IntUpdatesMenu
if errorlevel 4 call :IntWHDBaseLine BootInstallRecovery
if errorlevel 3 call :IntWHDBaseLine InstallRecovery
if errorlevel 2 call :IntWHDBaseLine Install
if errorlevel 1 call :IntWHDBaseLine Boot

:IntWHDAdditionalMenu
cls

echo.===============================================================================
echo.         MSMG ToolKit - Integrer les Mises a jour supplementaires WHD 
echo.===============================================================================
echo.
if "%SelectedSourceOS%" equ "w7" (
	echo.  [1]   Integrer les technologies d'activation Windows ^(WAT^)
	echo.
	echo.  [2]   Integrer les conditions prealables a la mise à niveau vers Windows 10 
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
)

if "%SelectedSourceOS%" equ "w81" (
	echo.  [1]  Integrer les mises a jour de Microsoft .NET Framework 3.5
	echo.
	echo.  [2]  Integrer les conditions préalables a la mise à niveau vers Windows 10
	echo.
	echo.  [3]  Integrer les mises a jour de Windows PE
	echo.
	echo.  [4]  Integrer les mises a jour de satisfaction de Windows Update 
	echo.
	echo.
	echo.
	echo.
)

echo.
echo.
echo.
echo.
echo.  [X]   Retour
echo.
echo.===============================================================================
echo.
if "%SelectedSourceOS%" equ "w7" (
	choice /C:12X /N /M "Entrer votre choix : "
	if errorlevel 3 goto :IntW7WHDUpdatesMenu
	if errorlevel 2 call :IntUpdates "Windows10"
	if errorlevel 1 call :IntUpdates "WAT"
)

if "%SelectedSourceOS%" equ "w81" (
	choice /C:1234X /N /M "Entrer votre choix : "
	if errorlevel 5 goto :IntWHDUpdatesMenu
	if errorlevel 4 call :IntUpdates "WUSatisfy"
	if errorlevel 3 call :IntUpdates "WinPE"
	if errorlevel 2 call :IntUpdates "Windows10"
	if errorlevel 1 call :IntUpdates "NET35"
)

:IntWHDExtraMenu
cls

echo.===============================================================================
echo.                MSMG ToolKit - Integrate WHD Extra Updates Menu
echo.===============================================================================

if "%SelectedSourceOS%" equ "w7" if "%IsW7SP1CRUSelected%" equ "0" (
	echo.  [1]   Active Directory Lightweight Directory Services ^(ADLDS^)
	echo.
	echo.  [2]   File Management API
	echo.
	echo.  [3]   Microsoft Virtual PC
	echo.
	echo.  [4]   Windows Features Updates
	echo.
	echo.  [5]   Sync Agent for Domain Environmernts ^(Work Folders^)
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.  [X]   Retour
	echo.===============================================================================
	echo.
)

if "%SelectedSourceOS%" equ "w7" if "%IsW7SP1CRUSelected%" equ "1" (
	echo.
	echo.  [1]   Active Directory Lightweight Directory Services ^(ADLDS^)
	echo.
	echo.  [2]   File Management API
	echo.
	echo.  [3]   Microsoft Virtual PC
	echo.
	echo.  [4]   Sync Agent for Domain Environmernts ^(Work Folders^)
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.  [X]   Retour
	echo.
	echo.===============================================================================
	echo.
)

if "%SelectedSourceOS%" equ "w7" if "%IsW7SP1CRUSelected%" equ "0" (
	choice /C:12345X /N /M "Entrer votre choix : "
	if errorlevel 6 goto :IntW7WHDUpdatesMenu
	if errorlevel 5 call :IntUpdates "WorkFolders"
	if errorlevel 4 call :IntUpdates "Features"
	if errorlevel 3 call :IntUpdates "VirtualPC"
	if errorlevel 2 call :IntUpdates "FMApi"
	if errorlevel 1 call :IntUpdates "ADLDS"
)

if "%SelectedSourceOS%" equ "w7" if "%IsW7SP1CRUSelected%" equ "1" (
	choice /C:1234X /N /M "Entrer votre choix : "
	if errorlevel 5 goto :IntW7WHDUpdatesMenu
	if errorlevel 4 call :IntUpdates "WorkFolders"
	if errorlevel 3 call :IntUpdates "VirtualPC"
	if errorlevel 2 call :IntUpdates "FMApi"
	if errorlevel 1 call :IntUpdates "ADLDS"
)

::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Integrate WHD Baseline/General Updates to Windows Setup Boot, Install & Recovery Image
::-------------------------------------------------------------------------------------------
:IntWHDBaseline

setlocal

:: Setting WHD Updates Type
set "UpdateType=%~1"

cls
echo.===============================================================================
if "%UpdateType%" equ "Boot" (
    if "%SelectedSourceOS%" equ "w81" echo.   MSMG ToolKit - Integrate WHD Baseline Updates to Windows Setup Boot Image
    if "%SelectedSourceOS%" equ "w10" echo.    MSMG ToolKit - Integrate WHD General Updates to Windows Setup Boot Image
)

if "%UpdateType%" equ "Install" (
    if "%SelectedSourceOS%" equ "w81" echo. MSMG ToolKit - Integrate WHD Baseline Updates to Windows Setup Install Image
    if "%SelectedSourceOS%" equ "w10" echo.  MSMG ToolKit - Integrate WHD General Updates to Windows Setup Install Image
)

if "%UpdateType%" equ "InstallRecovery" (
    if "%SelectedSourceOS%" equ "w81" echo.                  MSMG ToolKit - Integrate WHD Baseline Updates
    if "%SelectedSourceOS%" equ "w10" echo.                   MSMG ToolKit - Integrate WHD General Updates
    echo.                    to Windows Setup Install ^& Recovery Images
)

if "%UpdateType%" equ "BootInstallRecovery" (
    if "%SelectedSourceOS%" equ "w81" echo.                  MSMG ToolKit - Integrate WHD Baseline Updates
    if "%SelectedSourceOS%" equ "w10" echo.                   MSMG ToolKit - Integrate WHD General Updates
    echo.                to Windows Setup Boot, Install ^& Recovery Images
)
echo.===============================================================================
echo.

if "%UpdateType%" neq "Install" if "%UpdateType%" neq "InstallRecovery" if "%IsBootImageSelected%" equ "No" (
	echo.Windows Setup Boot Image is not selected...
	echo.
	echo.Please choose Windows Setup Boot Image while selecting Source...
	goto :Stop
)

if "%UpdateType%" neq "Boot" if "%UpdateType%" neq "Install" if "%IsRecoveryImageSelected%" equ "No" (
    echo.Windows Recovery Image is not selected...
    echo.
    echo.Please choose Windows Recovery Image while selecting Source...
    goto :Stop
)

:: Getting Install Image Index Architecture
for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" call :GetImageArchitecture "%InstallWim%", %%i >nul
)

:: Setting Package Architecture
if "%ImageArchitecture%" equ "x86" set "PackageArchitecture=x86"
if "%ImageArchitecture%" equ "x64" set "PackageArchitecture=amd64"
if "%ImageArchitecture%" equ "arm64" set "PackageArchitecture=arm64"

:: Settings WHD Baseline Updates folder path
if "%SelectedSourceOS%" equ "w81" set "Updates=%WHD%\%SelectedSourceOS%\%ImageArchitecture%\Baseline"
if "%SelectedSourceOS%" equ "w10" (
	if "%ImageBuild%" leq "17763" set "Updates=%WHD%\%SelectedSourceOS%\%ImageArchitecture%\10.0.%ImageBuild%"
	if "%ImageBuild%" geq "18362" if "%ImageBuild%" leq "18363" set "Updates=%WHD%\%SelectedSourceOS%\%ImageArchitecture%\10.0.18362"
	if "%ImageBuild%" geq "19041" if "%ImageBuild%" leq "19042" set "Updates=%WHD%\%SelectedSourceOS%\%ImageArchitecture%\10.0.19041"
)

:: Checking whether WHD Baseline Updates folder is empty
if "%SelectedSourceOS%" equ "w81" (
	:: Windows 8.1 RTM (Build : 6.3.9600.16384)
	if %ImageServicePackBuild% equ 16384 if not exist "%Updates%\RTM\*.msu" if not exist "%Updates%\RTM\*.cab" (
		echo.WHD Baseline Updates folder ^<WHD\%SelectedSourceOS%\%ImageArchitecture%\Baseline\RTM^> is empty...
		echo.
		echo.Please copy WHD Baseline Updates to respective folder...
		goto :Stop
	)

	:: Windows 8.1 all Builds include Post-RTM
	if "%ImageServicePackBuild%" neq "16384" if not exist "%Updates%\*.msu" if not exist "%Updates%\*.cab" (
       echo.WHD Baseline Updates folder ^<WHD\%SelectedSourceOS%\%ImageArchitecture%\Baseline^> is empty...
       echo.
       echo.Please copy WHD Baseline Updates to respective folder...
       goto :Stop
	)
)

:: Windows 10
if "%SelectedSourceOS%" equ "w10" if not exist "%Updates%\*.msu" if not exist "%Updates%\*.cab" (
	if "%ImageBuild%" leq "17763" echo.WHD General Updates folder ^<WHD\w10\%ImageArchitecture%\10.0.%ImageBuild%^> is empty...
	if "%ImageBuild%" geq "18362" if "%ImageBuild%" leq "18363" echo.WHD General Updates folder ^<WHD\w10\%ImageArchitecture%\10.0.18362^> is empty...
	if "%ImageBuild%" geq "19041" if "%ImageBuild%" leq "19042" echo.WHD General Updates folder ^<WHD\w10\%ImageArchitecture%\10.0.19041^> is empty...
	echo.
	echo.Please copy WHD General Updates to respective folder...
	goto :Stop
)

echo.-------------------------------------------------------------------------------
if "%SelectedSourceOS%" equ "w81" echo.##################Starting Integrating WHD Baseline Updates####################
if "%SelectedSourceOS%" equ "w10" echo.##################Starting Integrating WHD General Updates#####################
if "%UpdateType%" equ "Boot" echo.########################to Windows Setup Boot Image############################
if "%UpdateType%" equ "Install" echo.######################to Windows Setup Install Image###########################
if "%UpdateType%" equ "InstallRecovery" echo.#################to Windows Setup Install ^& Recovery Images#####################
if "%UpdateType%" equ "BootInstallRecovery" echo.##############to Windows Setup Boot, Install ^& Recovery Images#################
echo.-------------------------------------------------------------------------------
echo.
if "%UpdateType%" equ "Boot" (
	echo.    Image                    : Boot.wim
	echo.    Image Index              : 1, 2
)

if "%UpdateType%" equ "Install" (
	echo.    Image                    : Install.wim	
	if /i "%ImageIndexNo%" equ "A" echo.    Image Indexes            : 1-%ImageCount%
	if /i "%ImageIndexNo%" neq "A" echo.    Image Index              : %ImageIndexNo%
)

if "%UpdateType%" equ "InstallRecovery" (
	echo.    Image                    : Install.wim        ^|  WinRE.wim
	if /i "%ImageIndexNo%" equ "A" echo.    Image Indexes            : 1-%ImageCount%                  ^|      1
	if /i "%ImageIndexNo%" neq "A" echo.    Image Index              : %ImageIndexNo%                  ^|      1
)

if "%UpdateType%" equ "BootInstallRecovery" (
	echo.    Image                    : Boot.wim         ^|  Install.wim   ^|  WinRE.wim
	if /i "%ImageIndexNo%" equ "A" echo.    Image Indexes            : 1, 2             ^|      1-%ImageCount%              ^|      1
	if /i "%ImageIndexNo%" neq "A" echo.    Image Index              : 1, 2             ^|      %ImageIndexNo%         ^|      1
)

echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
echo.
echo.-------------------------------------------------------------------------------
if "%SelectedSourceOS%" equ "w81" echo.####Processing WHD Baseline Updates Packages###################################
if "%SelectedSourceOS%" equ "w10" echo.####Processing WHD General Updates Packages####################################
echo.-------------------------------------------------------------------------------
echo.
:: Creating WHD Baseline Updates Temporary folder
if "%SelectedSourceOS%" equ "w81" echo.Creating WHD Baseline Updates Temporary folder...
if "%SelectedSourceOS%" equ "w10" echo.Creating WHD General Updates Temporary folder...
call :RemoveFolder "%Temp%\Updates"
call :CreateFolder "%Temp%\Updates"
echo.

:: Extracting .CAB files From .MSU Package files to CAB Temporary folder
echo.Extracting .CAB Package files to Temporary folder...

:: Windows 8.1 RTM (Build : 6.3.9600.16384)
if "%SelectedSourceOS%" equ "w81" if %ImageServicePackBuild% equ 16384 (
	if exist "%Updates%\Windows8.1-KB3021910-%ImageArchitecture%*.msu" expand "%Updates%\Windows8.1-KB3021910-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul
	if exist "%Updates%\RTM\Windows8.1-KB2919355-%ImageArchitecture%*.msu" expand "%Updates%\RTM\Windows8.1-KB2919355-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB3000850-%ImageArchitecture%*.msu" expand "%Updates%\Windows8.1-KB3000850-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul
	if exist "%Updates%\RTM\Windows8.1-KB2932046-%ImageArchitecture%*.msu" expand "%Updates%\RTM\Windows8.1-KB2932046-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB2934018-%ImageArchitecture%*.msu" expand "%Updates%\Windows8.1-KB2934018-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul
	if exist "%Updates%\RTM\Windows8.1-KB2937592-%ImageArchitecture%*.msu" expand "%Updates%\RTM\Windows8.1-KB2937592-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul
	if exist "%Updates%\RTM\Windows8.1-KB2938439-%ImageArchitecture%*.msu" expand "%Updates%\RTM\Windows8.1-KB2938439-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul
	if exist "%Updates%\RTM\Windows8.1-KB2938772-%ImageArchitecture%*.msu" expand "%Updates%\RTM\Windows8.1-KB2938772-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB3003057-%ImageArchitecture%*.msu" expand "%Updates%\Windows8.1-KB3003057-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB4566425-%ImageArchitecture%*.msu" expand "%Updates%\Windows8.1-KB4566425-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul

	:: Copy .CAB files from .MSU package files to CAB Temporary folder
	if exist "%Updates%\Windows8.1-KB3021910-%ImageArchitecture%*.cab" %XCopy% "%Updates%\Windows8.1-KB3021910-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
	if exist "%Updates%\RTM\Windows8.1-KB2919355-%ImageArchitecture%*.cab" %XCopy% "%Updates%\RTM\Windows8.1-KB2919355-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB3000850-%ImageArchitecture%*.cab" %XCopy% "%Updates%\Windows8.1-KB3000850-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
	if exist "%Updates%\RTM\Windows8.1-KB2932046-%ImageArchitecture%*.cab" %XCopy% "%Updates%\RTM\Windows8.1-KB2932046-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB2934018-%ImageArchitecture%*.cab" %XCopy% "%Updates%\Windows8.1-KB2934018-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
	if exist "%Updates%\RTM\Windows8.1-KB2937592-%ImageArchitecture%*.cab" %XCopy% "%Updates%\RTM\Windows8.1-KB2937592-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
	if exist "%Updates%\RTM\Windows8.1-KB2938439-%ImageArchitecture%*.cab" %XCopy% "%Updates%\RTM\Windows8.1-KB2938439-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
	if exist "%Updates%\RTM\Windows8.1-KB2938772-%ImageArchitecture%*.cab" %XCopy% "%Updates%\RTM\Windows8.1-KB2938772-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB3003057-%ImageArchitecture%*.cab" %XCopy% "%Updates%\Windows8.1-KB3003057-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB4566425-%ImageArchitecture%*.cab" %XCopy% "%Updates%\Windows8.1-KB4566425-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
)

:: Windows 8.1 with Update (IR3 Build : 6.3.9600.17031)
if "%SelectedSourceOS%" equ "w81" if "%ImageServicePackBuild%" equ "17031" (
	if exist "%Updates%\Windows8.1-KB3021910-%ImageArchitecture%*.msu" expand "%Updates%\Windows8.1-KB3021910-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB4566425-%ImageArchitecture%*.msu" expand "%Updates%\Windows8.1-KB4566425-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB3000850-%ImageArchitecture%*.msu" expand "%Updates%\Windows8.1-KB3000850-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB2934018-%ImageArchitecture%*.msu" expand "%Updates%\Windows8.1-KB2934018-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB3003057-%ImageArchitecture%*.msu" expand "%Updates%\Windows8.1-KB3003057-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul

	:: Copy .CAB files from .MSU package files to CAB Temporary folder
	if exist "%Updates%\Windows8.1-KB3021910-%ImageArchitecture%*.cab" %XCopy% "%Updates%\Windows8.1-KB3021910-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB4566425-%ImageArchitecture%*.cab" %XCopy% "%Updates%\Windows8.1-KB4566425-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB3000850-%ImageArchitecture%*.cab" %XCopy% "%Updates%\Windows8.1-KB3000850-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB2934018-%ImageArchitecture%*.cab" %XCopy% "%Updates%\Windows8.1-KB2934018-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB3003057-%ImageArchitecture%*.cab" %XCopy% "%Updates%\Windows8.1-KB3003057-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
)

:: Windows 8.1 with Update Refresh (IR4 Build : 6.3.9600.17056)
if "%SelectedSourceOS%" equ "w81" if "%ImageServicePackBuild%" equ "17056" (
	if exist "%Updates%\Windows8.1-KB3021910-%ImageArchitecture%*.msu" expand "%Updates%\Windows8.1-KB3021910-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB4566425-%ImageArchitecture%*.msu" expand "%Updates%\Windows8.1-KB4566425-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB3000850-%ImageArchitecture%*.msu" expand "%Updates%\Windows8.1-KB3000850-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB3003057-%ImageArchitecture%*.msu" expand "%Updates%\Windows8.1-KB3003057-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul

	:: Copy .CAB files from .MSU package files to CAB Temporary folder
	if exist "%Updates%\Windows8.1-KB3021910-%ImageArchitecture%*.cab" %XCopy% "%Updates%\Windows8.1-KB3021910-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB4566425-%ImageArchitecture%*.cab" %XCopy% "%Updates%\Windows8.1-KB4566425-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB3000850-%ImageArchitecture%*.cab" %XCopy% "%Updates%\Windows8.1-KB3000850-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB3003057-%ImageArchitecture%*.cab" %XCopy% "%Updates%\Windows8.1-KB3003057-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
)

:: Windows 8.1 with Update Refresh (IR5 Build : 6.3.9600.17415)
if "%SelectedSourceOS%" equ "w81" if "%ImageServicePackBuild%" equ "17415" (
	if exist "%Updates%\Windows8.1-KB3021910-%ImageArchitecture%*.msu" expand "%Updates%\Windows8.1-KB3021910-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB4566425-%ImageArchitecture%*.msu" expand "%Updates%\Windows8.1-KB4566425-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates" >nul

	:: Copy .CAB files from .MSU package files to CAB Temporary folder
	if exist "%Updates%\Windows8.1-KB3021910-%ImageArchitecture%*.cab" %XCopy% "%Updates%\Windows8.1-KB3021910-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
	if exist "%Updates%\Windows8.1-KB4566425-%ImageArchitecture%*.cab" %XCopy% "%Updates%\Windows8.1-KB4566425-%ImageArchitecture%*.cab" "%Temp%\Updates" >nul
)

:: Windows 10
if "%SelectedSourceOS%" equ "w10" (
	call :CreateFolder "%Temp%\Updates"

	if exist "%Updates%\*.msu" (
		expand -R "%Updates%\*.msu" -F:Win*.cab "%Temp%\Updates" >nul
    	for /f %%i in ('"dir /b %Temp%\Updates\*.cab" 2^>nul') do (
        	set Update=%%i
        	set Update=!Update:~0,-4!
			call :CreateFolder "%Temp%\Updates\!Update!"
			expand -R "%Temp%\Updates\%%i" -F:* "%Temp%\Updates\!Update!" >nul
			if exist "%Temp%\Updates\!Update!\Cab_*.cab" expand -R "%Temp%\Updates\!Update!\Cab_*.cab" -F:* "%Temp%\Updates\!Update!" >nul
			call :RemoveFile "%Temp%\Updates\!Update!\Cab_*.cab"
		)

		call :RemoveFile "%Temp%\Updates\*.cab" >nul
	)

	if exist "%Updates%\*.cab" (
    	for /f %%i in ('"dir /b %Updates%\*.cab" 2^>nul') do (
        	set Update=%%i
        	set Update=!Update:~0,-4!
			call :CreateFolder "%Temp%\Updates\!Update!"
			expand -R "%Updates%\%%i" -F:* "%Temp%\Updates\!Update!" >nul
			if exist "%Temp%\Updates\!Update!\Cab_*.cab" expand -R "%Temp%\Updates\!Update!\Cab_*.cab" -F:* "%Temp%\Updates\!Update!" >nul
			call :RemoveFile "%Temp%\Updates\!Update!\Cab_*.cab"
		)
	)

	if exist "%Updates%\defender-update-kit-%ImageArchitecture%.zip" (
		%Zip% x -y "%Updates%\defender-update-kit-%ImageArchitecture%.zip" -o"%Temp%\Updates\Defender" >nul
		expand -R "%Temp%\Updates\Defender\defender-dism-%ImageArchitecture%.cab" -F:* "%Temp%\Updates\Defender" >nul
		call :RemoveFile "%Temp%\Updates\Defender\defender-dism-%ImageArchitecture%.cab"
		call :RemoveFile "%Temp%\Updates\Defender\DefenderUpdateWinImage.ps1"
		call :RemoveFile "%Temp%\Updates\Defender\license.txt"
	)

	:: Renaming Windows Updates folder names matching to their respective update type
	cd /d "%Temp%\Updates\"

	for /f %%i in ('"dir /b *.*" 2^>nul') do (
    	if exist "%%i\update.mum" (
        	findstr /c:"Package_for_RollupFix" "%%i\update.mum" >nul
	    	if not errorlevel 1 ren "%%i" "Cumulative" >nul
    	)

    	if exist "%%i\update.mum" (
        	findstr /c:"Package_for_DotNetRollup" "%%i\update.mum" >nul
			if not errorlevel 1 ren "%%i" "NetCumulative" >nul
    	)

    	if exist "%%i\update.mum" (
        	findstr /c:"Update for Removal of Adobe Flash Player" "%%i\update.mum" >nul
			if not errorlevel 1 ren "%%i" "RemoveFlashPlayer" >nul
    	)

    	if exist "%%i\%PackageArchitecture%_microsoft-windows-m..update-genuineintel_*.manifest" ren "%%i" "CPUMicroCode" >nul
    	if exist "%%i\package-defender.xml" ren "%%i" "Defender" >nul
    	if exist "%%i\setuphost.exe" ren "%%i" "DVDMedia" >nul
    	if exist "%%i\%PackageArchitecture%_microsoft-windows-19h2enablement_*.manifest" ren "%%i" "Enablement" >nul
		if not exist "%%i\%PackageArchitecture%_microsoft-windows-20h2enablement_*.manifest" if exist "%%i\%PackageArchitecture%_microsoft-windows-e..-firsttimeinstaller_*.manifest" ren "%%i" "EdgeChromium" >nul
    	if exist "%%i\%PackageArchitecture%_microsoft-windows-20h2enablement_*.manifest" ren "%%i" "Enablement" >nul
    	if exist "%%i\%PackageArchitecture%_adobe-flash-for-*.manifest" ren "%%i" "FlashPlayer" >nul
    	if exist "%%i\Microsoft-Windows-NetFx3-OnDemand-Package~31bf3856ad364e35~%PackageArchitecture%~~10.0.*.mum" ren "%%i" "NET35" >nul
    	if exist "%%i\Microsoft-Windows-NetFx3-OnDemand-Package~31bf3856ad364e35~%PackageArchitecture%~%ImageDefaultLanguage%~10.0.*.mum" ren "%%i" "NET35LP" >nul
    	if exist "%%i\%PackageArchitecture%_netfx4clientcorecomp_31bf3856ad364e35_*.manifest" ren "%%i" "NET45" >nul
    	if exist "%%i\%PackageArchitecture%_netfx4clientcorecomp.resources_*%ImageDefaultLanguage%*.manifest" ren "%%i" "NET45LP" >nul
    	if exist "%%i\%PackageArchitecture%_microsoft-windows-s..boot-firmwareupdate_*.manifest" ren "%%i" "SecureBoot" >nul
    	if exist "%%i\%PackageArchitecture%_microsoft-windows-servicingstack_*.manifest" ren "%%i" "ServicingStack" >nul
    	if exist "%%i\%PackageArchitecture%_microsoft-windows-userexperience-desktop_*.manifest" ren "%%i" "WindowsExperienceFeature" >nul
    	if exist "%%i\%PackageArchitecture%_microsoft-windows-sysreset_*.manifest" ren "%%i" "WinPE" >nul
	)

	cd /d "%ROOT%\"
)

echo.
echo.Finished Extracting .CAB Package files to Temporary folder...
echo.
if "%UpdateType%" neq "Boot" if "%ImageBuild%" geq "19041" if "%ImageBuild%" leq "19042" if exist "%Temp%\Updates\Enablement\Update.mum" (
	choice /C:YN /N /M "Do you want to skip integrating Microsoft Edge Chromium ? ['Y'es/'N'o] : "
	if !errorlevel! equ 1 (
		del /f /q "%Temp%\Updates\Enablement\Update.mum" >nul
		del /f /q "%Temp%\Updates\Enablement\Update.cat" >nul

		if "%ImageArchitecture%" equ "x86" (
			rd /q /s "%Temp%\Updates\Enablement\x86_microsoft-windows-e..-firsttimeinstaller_31bf3856ad364e35_10.0.19041.681_none_d4e678d60dbf374c" >nul
			move /y "%Temp%\Updates\Enablement\microsoft-windows-20h2enablement-package~31bf3856ad364e35~x86~~10.0.19041.681.cat" "%Temp%\Updates\Enablement\Update.cat" >nul
			move /y "%Temp%\Updates\Enablement\microsoft-windows-20h2enablement-package~31bf3856ad364e35~x86~~10.0.19041.681.mum" "%Temp%\Updates\Enablement\Update.mum" >nul
			del /f /q "%Temp%\Updates\Enablement\x86_88ed58c8b45ef5b335c7e00f1d272a1c_31bf3856ad364e35_*.manifest" >nul
			del /f /q "%Temp%\Updates\Enablement\x86_microsoft-windows-e..-firsttimeinstaller_31bf3856ad364e35_*.manifest" >nul
			del /f /q "%Temp%\Updates\Enablement\package_1_for_kb4562830~31bf3856ad364e35~x86~~*.mum" >nul
			del /f /q "%Temp%\Updates\Enablement\package_1_for_kb4562830~31bf3856ad364e35~x86~~*.cat" >nul
		)

		if "%ImageArchitecture%" equ "x64" (
			rd /q /s "%Temp%\Updates\Enablement\amd64_microsoft-windows-e..-firsttimeinstaller_31bf3856ad364e35_10.0.19041.681_none_31051459c61ca882" >nul
			del /f /q "%Temp%\Updates\Enablement\package_1_for_kb4562830~31bf3856ad364e35~amd64~~*.mum" >nul
			del /f /q "%Temp%\Updates\Enablement\package_1_for_kb4562830~31bf3856ad364e35~amd64~~*.cat" >nul
			del /f /q "%Temp%\Updates\Enablement\amd64_84b67765c88012e177d65b696e48302e_31bf3856ad364e35_*.manifest" >nul
			del /f /q "%Temp%\Updates\Enablement\amd64_microsoft-windows-e..-firsttimeinstaller_31bf3856ad364e35_*.manifest" >nul
			move /y "%Temp%\Updates\Enablement\microsoft-windows-20h2enablement-package~31bf3856ad364e35~amd64~~10.0.19041.681.cat" "%Temp%\Updates\Enablement\Update.cat" >nul
			move /y "%Temp%\Updates\Enablement\microsoft-windows-20h2enablement-package~31bf3856ad364e35~amd64~~10.0.19041.681.mum" "%Temp%\Updates\Enablement\Update.mum" >nul
		)

		if "%ImageArchitecture%" equ "arm64" (
			rd /q /s "%Temp%\Updates\Enablement\arm64_microsoft-windows-e..-firsttimeinstaller_31bf3856ad364e35_10.0.19041.681_none_31051c93c61c9d1e" >nul
			del /f /q "%Temp%\Updates\Enablement\package_1_for_kb4562830~31bf3856ad364e35~arm64~~*.mum" >nul
			del /f /q "%Temp%\Updates\Enablement\package_1_for_kb4562830~31bf3856ad364e35~arm64~~*.cat" >nul
			del /f /q "%Temp%\Updates\Enablement\arm64_d29030e5eb1fbfc0c65c0cd08e617938_31bf3856ad364e35_*.manifest" >nul
			del /f /q "%Temp%\Updates\Enablement\arm64_microsoft-windows-e..-firsttimeinstaller_31bf3856ad364e35_*.manifest" >nul
			move /y "%Temp%\Updates\Enablement\microsoft-windows-20h2enablement-package~31bf3856ad364e35~arm64~~10.0.19041.681.cat" "%Temp%\Updates\Enablement\Update.cat" >nul
			move /y "%Temp%\Updates\Enablement\microsoft-windows-20h2enablement-package~31bf3856ad364e35~arm64~~10.0.19041.681.mum" "%Temp%\Updates\Enablement\Update.mum" >nul
		)
	)
	echo.
)

if "%UpdateType%" neq "Install" if "%UpdateType%" neq "InstallRecovery" (
    echo.-------------------------------------------------------------------------------
    if "%SelectedSourceOS%" equ "w81" echo.####Integrating WHD Baseline Updates to Windows Setup Boot Image###############
    if "%SelectedSourceOS%" equ "w10" echo.####Integrating WHD General Updates to Windows Setup Boot Image################
    echo.-------------------------------------------------------------------------------
	echo.

    for /l %%i in (1, 1, 2) do (
	    echo.=============================[Boot.wim, Index : %%i]=============================
	    echo.
	    :: Windows 8.1 RTM (Build : 6.3.9600.16384)
	    if "%SelectedSourceOS%" equ "w81" if %ImageServicePackBuild% equ 16384 (
		    echo.-------------------------------------------------------------------------------
		    echo.Integrating WHD Baseline Prerequisite Update ^(KB3021910^)...
		    echo.-------------------------------------------------------------------------------
		    call :AddPackage "%BootMount%\%%i", "%Temp%\Updates\Windows8.1-KB3021910-%ImageArchitecture%.cab"
		    echo.-------------------------------------------------------------------------------
		    echo.Integrating WHD Baseline Update ^(KB2919355^)...
		    echo.-------------------------------------------------------------------------------
		    call :AddPackage "%BootMount%\%%i", "%Temp%\Updates\Windows8.1-KB2919355-%ImageArchitecture%.cab"
		    echo.-------------------------------------------------------------------------------
		    echo.Integrating WHD Baseline Feature Pack Update ^(KB3000850^)...
		    echo.-------------------------------------------------------------------------------
		    call :AddPackage "%BootMount%\%%i", "%Temp%\Updates\Windows8.1-KB3000850-%ImageArchitecture%.cab"
		    echo.-------------------------------------------------------------------------------
		    echo.Integrating WHD Baseline Feature Pack Update ^(KB2932046^)...
		    echo.-------------------------------------------------------------------------------
		    call :AddPackage "%BootMount%\%%i", "%Temp%\Updates\Windows8.1-KB2932046-%ImageArchitecture%.cab"
		    echo.-------------------------------------------------------------------------------
		    echo.Integrating WHD Baseline Feature Pack Update ^(KB2934018^)...
		    echo.-------------------------------------------------------------------------------
		    call :AddPackage "%BootMount%\%%i", "%Temp%\Updates\Windows8.1-KB2934018-%ImageArchitecture%.cab"
		    echo.-------------------------------------------------------------------------------
		    echo.Integrating WHD Baseline Feature Pack Update ^(KB2937592^)...
		    echo.-------------------------------------------------------------------------------
		    call :AddPackage "%BootMount%\%%i", "%Temp%\Updates\Windows8.1-KB2937592-%ImageArchitecture%.cab"
		    echo.-------------------------------------------------------------------------------
		    echo.Integrating WHD Baseline Feature Pack Update ^(KB2938439^)...
		    echo.-------------------------------------------------------------------------------
		    call :AddPackage "%BootMount%\%%i", "%Temp%\Updates\Windows8.1-KB2938439-%ImageArchitecture%.cab"
		    echo.-------------------------------------------------------------------------------
		    echo.Integrating WHD Baseline Feature Pack Update ^(KB2938772^)...
		    echo.-------------------------------------------------------------------------------
		    call :AddPackage "%BootMount%\%%i", "%Temp%\Updates\Windows8.1-KB2938772-%ImageArchitecture%.cab"
		    echo.-------------------------------------------------------------------------------
		    echo.Integrating WHD Baseline Feature Pack Update ^(KB3003057^)...
		    echo.-------------------------------------------------------------------------------
		    call :AddPackage "%BootMount%\%%i", "%Temp%\Updates\Windows8.1-KB3003057-%ImageArchitecture%.cab"
		    echo.-------------------------------------------------------------------------------
		    echo.Integrating WHD Baseline Feature Pack Update ^(KB4566425^)...
		    echo.-------------------------------------------------------------------------------
		    call :AddPackage "%BootMount%\%%i", "%Temp%\Updates\Windows8.1-KB4566425-%ImageArchitecture%.cab"
	    )

		:: Windows 8.1 with Update (IR3 Build : 6.3.9600.17031)
		if "%SelectedSourceOS%" equ "w81" if "%ImageServicePackBuild%" equ "17031" (
			echo.-------------------------------------------------------------------------------
			echo.Integrating WHD Baseline Feature Pack Update ^(KB3021910^)...
			echo.-------------------------------------------------------------------------------
			call :AddPackage "%BootMount%\%%i", "%Temp%\Updates\Windows8.1-KB3021910-%ImageArchitecture%.cab"
			echo.-------------------------------------------------------------------------------
			echo.Integrating WHD Baseline Feature Pack Update ^(KB4566425^)...
			echo.-------------------------------------------------------------------------------
			call :AddPackage "%BootMount%\%%i", "%Temp%\Updates\Windows8.1-KB4566425-%ImageArchitecture%.cab"
			echo.-------------------------------------------------------------------------------
			echo.Integrating WHD Baseline Feature Pack Update ^(KB3000850^)...
			echo.-------------------------------------------------------------------------------
			call :AddPackage "%BootMount%\%%i", "%Temp%\Updates\Windows8.1-KB3000850-%ImageArchitecture%.cab"
			echo.-------------------------------------------------------------------------------
			echo.Integrating WHD Baseline Feature Pack Update ^(KB2934018^)...
			echo.-------------------------------------------------------------------------------
			call :AddPackage "%BootMount%\%%i", "%Temp%\Updates\Windows8.1-KB2934018-%ImageArchitecture%.cab"
			echo.-------------------------------------------------------------------------------
			echo.Integrating WHD Baseline Feature Pack Update ^(KB3003057^)...
			echo.-------------------------------------------------------------------------------
			call :AddPackage "%BootMount%\%%i", "%Temp%\Updates\Windows8.1-KB3003057-%ImageArchitecture%.cab"
	    )

	    :: Windows 8.1 with Update (IR4 Build : 6.3.9600.17056)
	    if "%SelectedSourceOS%" equ "w81" if "%ImageServicePackBuild%" equ "17056" (
			echo.-------------------------------------------------------------------------------
			echo.Integrating WHD Baseline Feature Pack Update ^(KB3021910^)...
			echo.-------------------------------------------------------------------------------
			call :AddPackage "%BootMount%\%%i", "%Temp%\Updates\Windows8.1-KB3021910-%ImageArchitecture%.cab"
			echo.-------------------------------------------------------------------------------
			echo.Integrating WHD Baseline Feature Pack Update ^(KB4566425^)...
			echo.-------------------------------------------------------------------------------
			call :AddPackage "%BootMount%\%%i", "%Temp%\Updates\Windows8.1-KB4566425-%ImageArchitecture%.cab"
			echo.-------------------------------------------------------------------------------
			echo.Integrating WHD Baseline Feature Pack Update ^(KB3000850^)...
			echo.-------------------------------------------------------------------------------
			call :AddPackage "%BootMount%\%%i", "%Temp%\Updates\Windows8.1-KB3000850-%ImageArchitecture%.cab"
			echo.-------------------------------------------------------------------------------
			echo.Integrating WHD Baseline Feature Pack Update ^(KB3003057^)...
			echo.-------------------------------------------------------------------------------
			call :AddPackage "%BootMount%\%%i", "%Temp%\Updates\Windows8.1-KB3003057-%ImageArchitecture%.cab"
	    )

	    :: Windows 8.1 with Update Refresh (IR5 Build : 6.3.9600.17415)
	    if "%SelectedSourceOS%" equ "w81" if "%ImageServicePackBuild%" equ "17415" (
			if exist "%Temp%\Updates\Windows8.1-KB3021910-%ImageArchitecture%.cab" (
				echo.-------------------------------------------------------------------------------
				echo.Integrating WHD Baseline Feature Pack Update ^(KB3021910^)...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%BootMount%\%%i", "%Temp%\Updates\Windows8.1-KB3021910-%ImageArchitecture%.cab"
			)

			echo.-------------------------------------------------------------------------------
			echo.Integrating WHD Baseline Feature Pack Update ^(KB4566425^)...
			echo.-------------------------------------------------------------------------------
			call :AddPackage "%BootMount%\%%i", "%Temp%\Updates\Windows8.1-KB4566425-%ImageArchitecture%.cab"
	    )

        :: Windows 10
        if "%SelectedSourceOS%" equ "w10" (
			if exist "%Temp%\Updates\ServicingStack\Update.mum" (
				if "%ImageBuild%" equ "10240" if "%ImageServicePackBuild%" equ "16384" (
					echo.-------------------------------------------------------------------------------
					echo.Applying Windows 10 v1507 Cumulative Update Integration Fix...
					echo.-------------------------------------------------------------------------------
					if "%ImageArchitecture%" equ "x86" call :ApplyImage "%W10CUFix%\TH1CUFix.tpk", 1, "%BootMount%\%%i"
					if "%ImageArchitecture%" equ "x64" call :ApplyImage "%W10CUFix%\TH1CUFix.tpk", 2, "%BootMount%\%%i"
    				call :MountImageRegistry "%BootMount%\%%i"
	    			call :ImportRegistry2Image "%W10CUFix%\TH1CUFix_%ImageArchitecture%.reg" 2>nul
		    		call :UnMountImageRegistry
    			)

	    		if "%ImageArchitecture%" equ "x86" if "%ImageBuild%" equ "14393" if "%ImageServicePackBuild%" equ "0" (
		    		echo.-------------------------------------------------------------------------------
			    	echo.Applying Windows 10 v1607 Cumulative Update Integration Fix...
    				echo.-------------------------------------------------------------------------------
	    			call :ApplyImage "%W10CUFix%\RS1CUFix.tpk", 1, "%BootMount%\%%i"
		    		call :MountImageRegistry "%BootMount%\%%i"
			    	call :ImportRegistry2Image "%W10CUFix%\RS1CUFix.reg" 2>nul
			    	call :UnMountImageRegistry
			    )

			    echo.-------------------------------------------------------------------------------
			    echo.Integrating Windows 10 Servicing Stack Update...
			    echo.-------------------------------------------------------------------------------
			    call :AddPackage "%BootMount%\%%i", "%Temp%\Updates\ServicingStack"
		    )

		    if exist "%Temp%\Updates\Enablement\Update.mum" (
			    echo.-------------------------------------------------------------------------------
				if "%ImageBuild%" geq "18362" if "%ImageBuild%" leq "18363" echo.Integrating Windows 10 v1909 Feature Enablement Update Package...
				if "%ImageBuild%" geq "19041" if "%ImageBuild%" leq "19042" echo.Integrating Windows 10 v20H2 Feature Enablement Update Package...
				echo.-------------------------------------------------------------------------------
			    call :AddPackage "%BootMount%\%%i", "%Temp%\Updates\Enablement"
		    )

		    if exist "%Temp%\Updates\Cumulative\Update.mum" (
			    echo.-------------------------------------------------------------------------------
			    echo.Integrating Windows 10 Cumulative Update...
			    echo.-------------------------------------------------------------------------------
			    call :AddPackage "%BootMount%\%%i", "%Temp%\Updates\Cumulative"
		    )
	    )
	)

	:: Windows 8.1
	if "%SelectedSourceOS%" equ "w81" if exist "%Temp%\Updates\WinPE\*.cab" (
	    echo.-------------------------------------------------------------------------------
	    echo.Integrating Windows 10 WinPE Updates...
	    echo.-------------------------------------------------------------------------------
	    call :AddPackage "%BootMount%\2", "%Temp%\Updates\WinPE"
	)

	:: Windows 10
	if "%SelectedSourceOS%" equ "w10" (
		if exist "%Temp%\Updates\WinPE\Update.mum" (
		   	echo.-------------------------------------------------------------------------------
		   	echo.Integrating Windows 10 Win PE Update to Image...
		   	echo.-------------------------------------------------------------------------------
		   	call :AddPackage "%BootMount%\2", "%Temp%\Updates\WinPE"
		)

		if exist "%Temp%\Updates\DVDMedia\*.exe" if exist "%Temp%\Updates\DVDMedia\*.dll" (
			echo.-------------------------------------------------------------------------------
			echo.Integrating Windows 10 Setup Media Update...
			echo.-------------------------------------------------------------------------------
			echo.
			echo.Copying Windows 10 Setup Media Update to ^<DVD^> folder.
			%XCopy% "%Temp%\Updates\DVDMedia\*.*" "%DVD%\sources" >nul
			cd /d "%DVD%\sources\" >nul
			
			for /d %%i in (ar-SA,bg-BG,cs-CZ,da-DK,de-DE,el-GR,en-GB,en-US,es-ES,es-MX,et-EE,fi-FI,fr-CA,fr-FR,he-IL,hr-HR,hu-HU,it-IT,ja-JP,ko-KR,lt-LT,lv-LV,nb-NO,nl-NL,pl-PL,pt-BR,pt-PT,ro-RO,ru-RU,sk-SK,sl-SI,sr-Latn-RS,sv-SE,th-TH,tr-TR,uk-UA,zh-CN,zh-HK,zh-TW) do (
				if "%ImageDefaultLanguage%" neq "%%i" rd /q /s "%DVD%\sources\%%i" >nul 2>&1
			)

			cd /d "%ROOT%\" >nul
			echo.
		)
	)
)

if "%UpdateType%" neq "Boot" (
    echo.-------------------------------------------------------------------------------
    if "%SelectedSourceOS%" equ "w81" echo.####Integrating WHD Baseline Updates to Windows Setup Install Image############
    if "%SelectedSourceOS%" equ "w10" echo.####Integrating WHD General Updates to Windows Setup Install Image#############
    echo.-------------------------------------------------------------------------------

    for /l %%i in (1, 1, %ImageCount%) do (
	    if exist "%InstallMount%\%%i" (
		    echo.
		    if not %%i gtr 9 echo.===========================[Install.wim, Index : %%i]============================
		    if %%i gtr 9 echo.==========================[Install.wim, Index : %%i]============================
		    echo.

		    :: Windows 8.1 RTM (Build : 6.3.9600.16384)
		    if "%SelectedSourceOS%" equ "w81" if %ImageServicePackBuild% equ 16384 (
			    echo.-------------------------------------------------------------------------------
			    echo.Integrating WHD Baseline Prerequisite Update ^(KB3021910^)...
			    echo.-------------------------------------------------------------------------------
			    call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Windows8.1-KB3021910-%ImageArchitecture%.cab"
			    echo.-------------------------------------------------------------------------------
			    echo.Integrating WHD Baseline Update ^(KB2919355^)...
			    echo.-------------------------------------------------------------------------------
			    call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Windows8.1-KB2919355-%ImageArchitecture%.cab"
			    echo.-------------------------------------------------------------------------------
			    echo.Integrating WHD Baseline Feature Pack Update ^(KB3000850^)...
			    echo.-------------------------------------------------------------------------------
			    call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Windows8.1-KB3000850-%ImageArchitecture%.cab"
			    echo.-------------------------------------------------------------------------------
			    echo.Integrating WHD Baseline Feature Pack Update ^(KB2932046^)...
			    echo.-------------------------------------------------------------------------------
			    call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Windows8.1-KB2932046-%ImageArchitecture%.cab"
			    echo.-------------------------------------------------------------------------------
			    echo.Integrating WHD Baseline Feature Pack Update ^(KB2934018^)...
			    echo.-------------------------------------------------------------------------------
			    call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Windows8.1-KB2934018-%ImageArchitecture%.cab"
			    echo.-------------------------------------------------------------------------------
			    echo.Integrating WHD Baseline Feature Pack Update ^(KB2937592^)...
			    echo.-------------------------------------------------------------------------------
			    call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Windows8.1-KB2937592-%ImageArchitecture%.cab"
			    echo.-------------------------------------------------------------------------------
			    echo.Integrating WHD Baseline Feature Pack Update ^(KB2938439^)...
			    echo.-------------------------------------------------------------------------------
			    call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Windows8.1-KB2938439-%ImageArchitecture%.cab"
			    echo.-------------------------------------------------------------------------------
			    echo.Integrating WHD Baseline Feature Pack Update ^(KB2938772^)...
			    echo.-------------------------------------------------------------------------------
			    call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Windows8.1-KB2938772-%ImageArchitecture%.cab"
			    echo.-------------------------------------------------------------------------------
			    echo.Integrating WHD Baseline Feature Pack Update ^(KB3003057^)...
			    echo.-------------------------------------------------------------------------------
			    call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Windows8.1-KB3003057-%ImageArchitecture%.cab"
			    echo.-------------------------------------------------------------------------------
			    echo.Integrating WHD Baseline Feature Pack Update ^(KB3014442^)...
			    echo.-------------------------------------------------------------------------------
			    call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Windows8.1-KB3014442-%ImageArchitecture%.cab"
			    echo.-------------------------------------------------------------------------------
			    echo.Integrating WHD Baseline Feature Pack Update ^(KB4566425^)...
			    echo.-------------------------------------------------------------------------------
			    call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Windows8.1-KB4566425-%ImageArchitecture%.cab"
		    )

		    :: Windows 8.1 with Update (IR3 Build : 6.3.9600.17031)
		    if "%SelectedSourceOS%" equ "w81" if "%ImageServicePackBuild%" equ "17031" (
			    echo.-------------------------------------------------------------------------------
			    echo.Integrating WHD Baseline Feature Pack Update ^(KB3021910^)...
			    echo.-------------------------------------------------------------------------------
			    call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Windows8.1-KB3021910-%ImageArchitecture%.cab"
			    echo.-------------------------------------------------------------------------------
			    echo.Integrating WHD Baseline Feature Pack Update ^(KB4566425^)...
			    echo.-------------------------------------------------------------------------------
			    call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Windows8.1-KB4566425-%ImageArchitecture%.cab"
			    echo.-------------------------------------------------------------------------------
			    echo.Integrating WHD Baseline Feature Pack Update ^(KB3000850^)...
			    echo.-------------------------------------------------------------------------------
			    call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Windows8.1-KB3000850-%ImageArchitecture%.cab"
			    echo.-------------------------------------------------------------------------------
			    echo.Integrating WHD Baseline Feature Pack Update ^(KB2934018^)...
			    echo.-------------------------------------------------------------------------------
			    call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Windows8.1-KB2934018-%ImageArchitecture%.cab"
			    echo.-------------------------------------------------------------------------------
			    echo.Integrating WHD Baseline Feature Pack Update ^(KB3003057^)...
			    echo.-------------------------------------------------------------------------------
			    call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Windows8.1-KB3003057-%ImageArchitecture%.cab"
			    echo.-------------------------------------------------------------------------------
			    echo.Integrating WHD Baseline Feature Pack Update ^(KB3014442^)...
			    echo.-------------------------------------------------------------------------------
			    call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Windows8.1-KB3014442-%ImageArchitecture%.cab"
		    )

		    :: Windows 8.1 with Update (IR4 Build : 6.3.9600.17056)
		    if "%SelectedSourceOS%" equ "w81" if "%ImageServicePackBuild%" equ "17056" (
			    echo.-------------------------------------------------------------------------------
			    echo.Integrating WHD Baseline Feature Pack Update ^(KB3021910^)...
			    echo.-------------------------------------------------------------------------------
			    call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Windows8.1-KB3021910-%ImageArchitecture%.cab"
			    echo.-------------------------------------------------------------------------------
			    echo.Integrating WHD Baseline Feature Pack Update ^(KB4566425^)...
			    echo.-------------------------------------------------------------------------------
			    call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Windows8.1-KB4566425-%ImageArchitecture%.cab"
			    echo.-------------------------------------------------------------------------------
			    echo.Integrating WHD Baseline Feature Pack Update ^(KB3000850^)...
			    echo.-------------------------------------------------------------------------------
			    call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Windows8.1-KB3000850-%ImageArchitecture%.cab"
			    echo.-------------------------------------------------------------------------------
			    echo.Integrating WHD Baseline Feature Pack Update ^(KB3003057^)...
			    echo.-------------------------------------------------------------------------------
			    call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Windows8.1-KB3003057-%ImageArchitecture%.cab"
			    echo.-------------------------------------------------------------------------------
			    echo.Integrating WHD Baseline Feature Pack Update ^(KB3014442^)...
			    echo.-------------------------------------------------------------------------------
			    call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Windows8.1-KB3014442-%ImageArchitecture%.cab"
		    )

		    :: Windows 8.1 with Update Refresh (IR5 Build : 6.3.9600.17415)
		    if "%SelectedSourceOS%" equ "w81" if "%ImageServicePackBuild%" equ "17415" (
			    if exist "%Temp%\Updates\Windows8.1-KB3021910-%ImageArchitecture%.cab" (
			    	echo.-------------------------------------------------------------------------------
			    	echo.Integrating WHD Baseline Feature Pack Update ^(KB3021910^)...
			    	echo.-------------------------------------------------------------------------------
			    	call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Windows8.1-KB3021910-%ImageArchitecture%.cab"
			    )

			    echo.-------------------------------------------------------------------------------
			    echo.Integrating WHD Baseline Feature Pack Update ^(KB4566425^)...
			    echo.-------------------------------------------------------------------------------
			    call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Windows8.1-KB4566425-%ImageArchitecture%.cab"
		    )

		    :: Windows 10
		    if "%SelectedSourceOS%" equ "w10" (
			    :: Importing registry fix to enable integrating Windows 10 updates to EOL editions.
			    if "%ImageBuild%" equ "10240" (
					call :GetImageEdition "%InstallWim%", %%i >nul

                    for %%j in (Core, CoreSingleLanguage, Professional, Education, Enterprise, ProfessionalEducation, ProfessionalWorkstation) do (
						if "%ImageEdition" equ "%%j" (
							call :MountImageRegistry "%InstallMount%\%%i"
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseSEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10240.16384" /v "InstallClient" /t REG_SZ /d "DISM Package Manager Provider" /f >nul
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseSEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10240.16384" /v "InstallName" /t REG_SZ /d "Microsoft-Windows-EnterpriseSEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10240.16384.mum" /f >nul
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseSEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10240.16384" /v "InstallLocation" /t REG_SZ /d "\\?\d:\th1.bin.%PackageArchitecture%fre\csi\pkgs\\" /f >nul
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseSEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10240.16384" /v "CurrentState" /t REG_DWORD /d "112" /f >nul
			    		    reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseSEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10240.16384" /v "SelfUpdate" /t REG_DWORD /d "0" /f >nul
			    		    reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseSEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10240.16384" /v "Visibility" /t REG_DWORD /d "1" /f >nul
				    	    reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseSEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10240.16384" /v "InstallTimeHigh" /t REG_DWORD /d "30649479" /f >nul
				    	    reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseSEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10240.16384" /v "InstallTimeLow" /t REG_DWORD /d "1431244152" /f >nul
				    	    reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseSEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10240.16384" /v "InstallUser" /t REG_SZ /d "S-1-5-18" /f >nul
				    	    call :UnMountImageRegistry
						)
                    )

                    for %%j in (CoreN, ProfessionalN, EducationN, EnterpriseN, ProfessionalEducationN, ProfessionalWorkstationN) do (
						if "%ImageEdition" equ "%%j" (
							call :MountImageRegistry "%InstallMount%\%%i"
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseSNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10240.16384" /v "InstallClient" /t REG_SZ /d "DISM Package Manager Provider" /f >nul
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseSNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10240.16384" /v "InstallName" /t REG_SZ /d "Microsoft-Windows-EnterpriseSNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10240.16384.mum" /f >nul
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseSNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10240.16384" /v "InstallLocation" /t REG_SZ /d "\\?\d:\th1.bin.%PackageArchitecture%fre\csi\pkgs\\" /f >nul
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseSNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10240.16384" /v "CurrentState" /t REG_DWORD /d "112" /f >nul
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseSNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10240.16384" /v "SelfUpdate" /t REG_DWORD /d "0" /f >nul
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseSNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10240.16384" /v "Visibility" /t REG_DWORD /d "1" /f >nul
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseSNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10240.16384" /v "InstallTimeHigh" /t REG_DWORD /d "30649479" /f >nul
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseSNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10240.16384" /v "InstallTimeLow" /t REG_DWORD /d "1431244152" /f >nul
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseSNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10240.16384" /v "InstallUser" /t REG_SZ /d "S-1-5-18" /f >nul
				    	    call :UnMountImageRegistry
						)
                    )
				)

			    if "%ImageBuild%" equ "10586" (
					call :GetImageEdition "%InstallWim%", %%i >nul

                    for %%j in (Core, CoreSingleLanguage, Professional, Education, ProfessionalEducation, ProfessionalWorkstation) do (
						if "%ImageEdition" equ "%%j" (
							call :MountImageRegistry "%InstallMount%\%%i"
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10586.0" /v "InstallClient" /t REG_SZ /d "DISM Package Manager Provider" /f >nul
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10586.0" /v "InstallName" /t REG_SZ /d "Microsoft-Windows-EnterpriseSEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10586.1.mum" /f >nul
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10586.0" /v "InstallLocation" /t REG_SZ /d "\\?\d:\th2.bin.%PackageArchitecture%fre\csi\pkgs\\" /f >nul
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10586.0" /v "CurrentState" /t REG_DWORD /d "112" /f >nul
			    		    reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10586.0" /v "SelfUpdate" /t REG_DWORD /d "0" /f >nul
			    		    reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10586.0" /v "Visibility" /t REG_DWORD /d "1" /f >nul
				    	    reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10586.0" /v "InstallTimeHigh" /t REG_DWORD /d "30649479" /f >nul
				    	    reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10586.0" /v "InstallTimeLow" /t REG_DWORD /d "1431244152" /f >nul
				    	    reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10586.0" /v "InstallUser" /t REG_SZ /d "S-1-5-18" /f >nul
				    	    call :UnMountImageRegistry
						)
                    )

                    for %%j in (CoreN, ProfessionalN, EducationN, ProfessionalEducationN, ProfessionalWorkstationN) do (
						if "%ImageEdition" equ "%%j" (
							call :MountImageRegistry "%InstallMount%\%%i"
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10586.0" /v "InstallClient" /t REG_SZ /d "DISM Package Manager Provider" /f >nul
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10586.0" /v "InstallName" /t REG_SZ /d "Microsoft-Windows-EnterpriseSNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10586.1.mum" /f >nul
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10586.0" /v "InstallLocation" /t REG_SZ /d "\\?\d:\th2.bin.%PackageArchitecture%fre\csi\pkgs\\" /f >nul
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10586.0" /v "CurrentState" /t REG_DWORD /d "112" /f >nul
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10586.0" /v "SelfUpdate" /t REG_DWORD /d "0" /f >nul
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10586.0" /v "Visibility" /t REG_DWORD /d "1" /f >nul
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10586.0" /v "InstallTimeHigh" /t REG_DWORD /d "30649479" /f >nul
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10586.0" /v "InstallTimeLow" /t REG_DWORD /d "1431244152" /f >nul
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.10586.0" /v "InstallUser" /t REG_SZ /d "S-1-5-18" /f >nul
				    	    call :UnMountImageRegistry
						)
                    )
				)

			    if "%ImageBuild%" equ "14393" (
					call :GetImageEdition "%InstallWim%", %%i >nul

                    for %%j in (Core, CoreSingleLanguage, Professional, Education, Enterprise, ProfessionalEducation, ProfessionalWorkstation) do (
						if "%ImageEdition" equ "%%j" (
							call :MountImageRegistry "%InstallMount%\%%i"
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseSEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.14393.0" /v "InstallClient" /t REG_SZ /d "DISM Package Manager Provider" /f >nul
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseSEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.14393.0" /v "InstallName" /t REG_SZ /d "Microsoft-Windows-EnterpriseSEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.14393.0.mum" /f >nul
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseSEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.14393.0" /v "InstallLocation" /t REG_SZ /d "\\?\d:\rs1.bin.%PackageArchitecture%fre\csi\pkgs\\" /f >nul
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseSEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.14393.0" /v "CurrentState" /t REG_DWORD /d "112" /f >nul
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseSEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.14393.0" /v "SelfUpdate" /t REG_DWORD /d "0" /f >nul
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseSEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.14393.0" /v "Visibility" /t REG_DWORD /d "1" /f >nul
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseSEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.14393.0" /v "InstallTimeHigh" /t REG_DWORD /d "30649479" /f >nul
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseSEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.14393.0" /v "InstallTimeLow" /t REG_DWORD /d "1431244152" /f >nul
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseSEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.14393.0" /v "InstallUser" /t REG_SZ /d "S-1-5-18" /f >nul
				    	    call :UnMountImageRegistry
						)
                    )

                    for %%j in (CoreN, ProfessionalN, EducationN, EnterpriseN, ProfessionalEducationN, ProfessionalWorkstationN) do (
						if "%ImageEdition" equ "%%j" (
							call :MountImageRegistry "%InstallMount%\%%i"
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseSNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.14393.0" /v "InstallClient" /t REG_SZ /d "DISM Package Manager Provider" /f >nul
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseSNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.14393.0" /v "InstallName" /t REG_SZ /d "Microsoft-Windows-EnterpriseSNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.14393.0.mum" /f >nul
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseSNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.14393.0" /v "InstallLocation" /t REG_SZ /d "\\?\d:\rs1.bin.%PackageArchitecture%fre\csi\pkgs\\" /f >nul
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseSNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.14393.0" /v "CurrentState" /t REG_DWORD /d "112" /f >nul
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseSNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.14393.0" /v "SelfUpdate" /t REG_DWORD /d "0" /f >nul
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseSNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.14393.0" /v "Visibility" /t REG_DWORD /d "1" /f >nul
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseSNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.14393.0" /v "InstallTimeHigh" /t REG_DWORD /d "30649479" /f >nul
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseSNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.14393.0" /v "InstallTimeLow" /t REG_DWORD /d "1431244152" /f >nul
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseSNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.14393.0" /v "InstallUser" /t REG_SZ /d "S-1-5-18" /f >nul
				    	    call :UnMountImageRegistry
						)
                    )
				)

			    if "%ImageBuild%" equ "15063" (
					call :GetImageEdition "%InstallWim%", %%i >nul

                    for %%j in (Core, CoreSingleLanguage, Professional, Education, ProfessionalEducation, ProfessionalWorkstation) do (
						if "%ImageEdition" equ "%%j" (
							call :MountImageRegistry "%InstallMount%\%%i"
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.15063.0" /v "InstallClient" /t REG_SZ /d "DISM Package Manager Provider" /f >nul
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.15063.0" /v "InstallName" /t REG_SZ /d "Microsoft-Windows-EnterpriseSEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.15063.1.mum" /f >nul
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.15063.0" /v "InstallLocation" /t REG_SZ /d "\\?\d:\rs2.bin.%PackageArchitecture%fre\csi\pkgs\\" /f >nul
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.15063.0" /v "CurrentState" /t REG_DWORD /d "112" /f >nul
			    		    reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.15063.0" /v "SelfUpdate" /t REG_DWORD /d "0" /f >nul
			    		    reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.15063.0" /v "Visibility" /t REG_DWORD /d "1" /f >nul
				    	    reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.15063.0" /v "InstallTimeHigh" /t REG_DWORD /d "30649479" /f >nul
				    	    reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.15063.0" /v "InstallTimeLow" /t REG_DWORD /d "1431244152" /f >nul
				    	    reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.15063.0" /v "InstallUser" /t REG_SZ /d "S-1-5-18" /f >nul
				    	    call :UnMountImageRegistry
						)
                    )

                    for %%j in (CoreN, ProfessionalN, EducationN, ProfessionalEducationN, ProfessionalWorkstationN) do (
						if "%ImageEdition" equ "%%j" (
							call :MountImageRegistry "%InstallMount%\%%i"
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.15063.0" /v "InstallClient" /t REG_SZ /d "DISM Package Manager Provider" /f >nul
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.15063.0" /v "InstallName" /t REG_SZ /d "Microsoft-Windows-EnterpriseSNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.15063.1.mum" /f >nul
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.15063.0" /v "InstallLocation" /t REG_SZ /d "\\?\d:\rs2.bin.%PackageArchitecture%fre\csi\pkgs\\" /f >nul
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.15063.0" /v "CurrentState" /t REG_DWORD /d "112" /f >nul
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.15063.0" /v "SelfUpdate" /t REG_DWORD /d "0" /f >nul
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.15063.0" /v "Visibility" /t REG_DWORD /d "1" /f >nul
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.15063.0" /v "InstallTimeHigh" /t REG_DWORD /d "30649479" /f >nul
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.15063.0" /v "InstallTimeLow" /t REG_DWORD /d "1431244152" /f >nul
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.15063.0" /v "InstallUser" /t REG_SZ /d "S-1-5-18" /f >nul
				    	    call :UnMountImageRegistry
						)
                    )
				)

			    if "%ImageBuild%" equ "16299" (
					call :GetImageEdition "%InstallWim%", %%i >nul

                    for %%j in (Core, CoreSingleLanguage, Professional, Education, ProfessionalEducation, ProfessionalWorkstation) do (
						if "%ImageEdition" equ "%%j" (
							call :MountImageRegistry "%InstallMount%\%%i"
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "InstallClient" /t REG_SZ /d "DISM Package Manager Provider" /f >nul
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "InstallName" /t REG_SZ /d "Microsoft-Windows-EnterpriseSEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.1.mum" /f >nul
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "InstallLocation" /t REG_SZ /d "\\?\d:\rs3.bin.%PackageArchitecture%fre\csi\pkgs\\" /f >nul
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "CurrentState" /t REG_DWORD /d "112" /f >nul
			    		    reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "SelfUpdate" /t REG_DWORD /d "0" /f >nul
			    		    reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "Visibility" /t REG_DWORD /d "1" /f >nul
				    	    reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "InstallTimeHigh" /t REG_DWORD /d "30649479" /f >nul
				    	    reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "InstallTimeLow" /t REG_DWORD /d "1431244152" /f >nul
				    	    reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "InstallUser" /t REG_SZ /d "S-1-5-18" /f >nul
				    	    call :UnMountImageRegistry
						)
                    )

                    for %%j in (CoreN, ProfessionalN, EducationN, ProfessionalEducationN, ProfessionalWorkstationN) do (
						if "%ImageEdition" equ "%%j" (
							call :MountImageRegistry "%InstallMount%\%%i"
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "InstallClient" /t REG_SZ /d "DISM Package Manager Provider" /f >nul
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "InstallName" /t REG_SZ /d "Microsoft-Windows-EnterpriseSNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.1.mum" /f >nul
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "InstallLocation" /t REG_SZ /d "\\?\d:\rs3.bin.%PackageArchitecture%fre\csi\pkgs\\" /f >nul
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "CurrentState" /t REG_DWORD /d "112" /f >nul
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "SelfUpdate" /t REG_DWORD /d "0" /f >nul
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "Visibility" /t REG_DWORD /d "1" /f >nul
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "InstallTimeHigh" /t REG_DWORD /d "30649479" /f >nul
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "InstallTimeLow" /t REG_DWORD /d "1431244152" /f >nul
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.16299.15" /v "InstallUser" /t REG_SZ /d "S-1-5-18" /f >nul
				    	    call :UnMountImageRegistry
						)
                    )
				)

			    if "%ImageBuild%" equ "17134" (
					call :GetImageEdition "%InstallWim%", %%i >nul

                    for %%j in (Core, CoreSingleLanguage, Professional, Education, Enterprise, ProfessionalEducation, ProfessionalWorkstation) do (
						if "%ImageEdition" equ "%%j" (
							call :MountImageRegistry "%InstallMount%\%%i"
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.17134.1" /v "InstallClient" /t REG_SZ /d "DISM Package Manager Provider" /f >nul
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.17134.1" /v "InstallName" /t REG_SZ /d "Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.17134.1.mum" /f >nul
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.17134.1" /v "InstallLocation" /t REG_SZ /d "\\?\d:\rs4.bin.%PackageArchitecture%fre\csi\pkgs\\" /f >nul
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.17134.1" /v "CurrentState" /t REG_DWORD /d "112" /f >nul
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.17134.1" /v "SelfUpdate" /t REG_DWORD /d "0" /f >nul
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.17134.1" /v "Visibility" /t REG_DWORD /d "1" /f >nul
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.17134.1" /v "InstallTimeHigh" /t REG_DWORD /d "30649479" /f >nul
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.17134.1" /v "InstallTimeLow" /t REG_DWORD /d "1431244152" /f >nul
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.17134.1" /v "InstallUser" /t REG_SZ /d "S-1-5-18" /f >nul
				    	    call :UnMountImageRegistry
						)
                    )

                    for %%j in (CoreN, ProfessionalN, EducationN, EnterpriseN, ProfessionalEducationN, ProfessionalWorkstationN) do (
						if "%ImageEdition" equ "%%j" (
							call :MountImageRegistry "%InstallMount%\%%i"
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.17134.1" /v "InstallClient" /t REG_SZ /d "DISM Package Manager Provider" /f >nul
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.17134.1" /v "InstallName" /t REG_SZ /d "Microsoft-Windows-EnterpriseNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.17134.1.mum" /f >nul
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.17134.1" /v "InstallLocation" /t REG_SZ /d "\\?\d:\rs4.bin.%PackageArchitecture%fre\csi\pkgs\\" /f >nul
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.17134.1" /v "CurrentState" /t REG_DWORD /d "112" /f >nul
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.17134.1" /v "SelfUpdate" /t REG_DWORD /d "0" /f >nul
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.17134.1" /v "Visibility" /t REG_DWORD /d "1" /f >nul
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.17134.1" /v "InstallTimeHigh" /t REG_DWORD /d "30649479" /f >nul
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.17134.1" /v "InstallTimeLow" /t REG_DWORD /d "1431244152" /f >nul
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.17134.1" /v "InstallUser" /t REG_SZ /d "S-1-5-18" /f >nul
				    	    call :UnMountImageRegistry
						)
                    )
				)

			    if "%ImageBuild%" equ "17763" (
					call :GetImageEdition "%InstallWim%", %%i >nul

                    for %%j in (Core, CoreSingleLanguage, Professional, Education, Enterprise, ProfessionalEducation, ProfessionalWorkstation) do (
						if "%ImageEdition" equ "%%j" (
							call :MountImageRegistry "%InstallMount%\%%i"
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseSEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.17763.1" /v "InstallClient" /t REG_SZ /d "DISM Package Manager Provider" /f >nul
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseSEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.17763.1" /v "InstallName" /t REG_SZ /d "Microsoft-Windows-EnterpriseSEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.17763.1.mum" /f >nul
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseSEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.17763.1" /v "InstallLocation" /t REG_SZ /d "\\?\d:\rs5.bin.%PackageArchitecture%fre\csi\pkgs\\" /f >nul
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseSEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.17763.1" /v "CurrentState" /t REG_DWORD /d "112" /f >nul
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseSEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.17763.1" /v "SelfUpdate" /t REG_DWORD /d "0" /f >nul
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseSEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.17763.1" /v "Visibility" /t REG_DWORD /d "1" /f >nul
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseSEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.17763.1" /v "InstallTimeHigh" /t REG_DWORD /d "30649479" /f >nul
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseSEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.17763.1" /v "InstallTimeLow" /t REG_DWORD /d "1431244152" /f >nul
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseSEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.17763.1" /v "InstallUser" /t REG_SZ /d "S-1-5-18" /f >nul
				    	    call :UnMountImageRegistry
						)
                    )

                    for %%j in (CoreN, ProfessionalN, EducationN, EnterpriseN, ProfessionalEducationN, ProfessionalWorkstationN) do (
						if "%ImageEdition" equ "%%j" (
							call :MountImageRegistry "%InstallMount%\%%i"
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseSNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.17763.1" /v "InstallClient" /t REG_SZ /d "DISM Package Manager Provider" /f >nul
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseSNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.17763.1" /v "InstallName" /t REG_SZ /d "Microsoft-Windows-EnterpriseSNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.17763.1.mum" /f >nul
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseSNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.17763.1" /v "InstallLocation" /t REG_SZ /d "\\?\d:\rs5.bin.%PackageArchitecture%fre\csi\pkgs\\" /f >nul
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseSNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.17763.1" /v "CurrentState" /t REG_DWORD /d "112" /f >nul
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseSNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.17763.1" /v "SelfUpdate" /t REG_DWORD /d "0" /f >nul
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseSNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.17763.1" /v "Visibility" /t REG_DWORD /d "1" /f >nul
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseSNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.17763.1" /v "InstallTimeHigh" /t REG_DWORD /d "30649479" /f >nul
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseSNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.17763.1" /v "InstallTimeLow" /t REG_DWORD /d "1431244152" /f >nul
			    	    	reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages\Microsoft-Windows-EnterpriseSNEdition~31bf3856ad364e35~%PackageArchitecture%~~10.0.17763.1" /v "InstallUser" /t REG_SZ /d "S-1-5-18" /f >nul
				    	    call :UnMountImageRegistry
						)
                    )
				)

			    if exist "%Temp%\Updates\ServicingStack\Update.mum" (
			    	if "%ImageBuild%" equ "10240" if "%ImageServicePackBuild%" equ "16384" (
			    		echo.-------------------------------------------------------------------------------
			    		echo.Applying Windows 10 v1507 Cumulative Update Integration Fix...
			    		echo.-------------------------------------------------------------------------------
			    		if "%ImageArchitecture%" equ "x86" call :ApplyImage "%W10CUFix%\TH1CUFix.tpk", 1, "%InstallMount%\%%i"
			    		if "%ImageArchitecture%" equ "x64" call :ApplyImage "%W10CUFix%\TH1CUFix.tpk", 2, "%InstallMount%\%%i"
			    		call :MountImageRegistry "%InstallMount%\%%i"
			    		call :ImportRegistry2Image "%W10CUFix%\TH1CUFix_%ImageArchitecture%.reg" 2>nul
			    		call :UnMountImageRegistry
			    	)

			    	if "%ImageArchitecture%" equ "x86" if "%ImageBuild%" equ "14393" if "%ImageServicePackBuild%" equ "0" (
			    		echo.-------------------------------------------------------------------------------
			    		echo.Applying Windows 10 v1607 Cumulative Update Integration Fix...
			    		echo.-------------------------------------------------------------------------------
			    		call :ApplyImage "%W10CUFix%\RS1CUFix.tpk", 1, "%InstallMount%\%%i"
			    		call :MountImageRegistry "%InstallMount%\%%i"
			    		call :ImportRegistry2Image "%W10CUFix%\RS1CUFix.reg" 2>nul
			    		call :UnMountImageRegistry
			    	)

			    	echo.-------------------------------------------------------------------------------
			    	echo.Integrating Windows 10 Servicing Stack Update Package...
			    	echo.-------------------------------------------------------------------------------
			    	call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\ServicingStack"
			    )

			    if "%ImageBuild%" geq "18362" if "%ImageBuild%" leq "18363" if exist "%Temp%\Updates\Enablement\Update.mum" (
				    echo.-------------------------------------------------------------------------------
				    echo.Integrating Windows 10 v1909 Feature Enablement Update Package...
				    echo.-------------------------------------------------------------------------------
				    call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Enablement"
			    )

			    if exist "%Temp%\Updates\WindowsExperienceFeature\Update.mum" (
				    echo.-------------------------------------------------------------------------------
				    echo.Integrating Windows Experience Feature Pack Update Package...
				    echo.-------------------------------------------------------------------------------
				    call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\WindowsExperienceFeature"
			    )

			    if exist "%Temp%\Updates\CPUMicroCode\Update.mum" (
				    echo.-------------------------------------------------------------------------------
				    echo.Integrating Intel CPU Microcode Dynamic Update Package...
				    echo.-------------------------------------------------------------------------------
				    call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\CPUMicroCode"
			    )

			    if exist "%Temp%\Updates\SecureBoot\Update.mum" (
				    echo.-------------------------------------------------------------------------------
				    echo.Integrating Windows Secure Boot Dynamic Update Package...
				    echo.-------------------------------------------------------------------------------
				    call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\SecureBoot"
			    )

			    if exist "%Temp%\Updates\FlashPlayer\Update.mum" (
				    echo.-------------------------------------------------------------------------------
				    echo.Integrating Adobe Flash Player Security Update Package...
				    echo.-------------------------------------------------------------------------------
				    call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\FlashPlayer"
			    )

			    if exist "%Temp%\Updates\RemoveFlashPlayer\Update.mum" (
				    echo.-------------------------------------------------------------------------------
				    echo.Integrating Remove Adobe Flash Player Update Package...
				    echo.-------------------------------------------------------------------------------
				    call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\RemoveFlashPlayer"
			    )

			    if exist "%Temp%\Updates\NET45\Update.mum" (
				    echo.-------------------------------------------------------------------------------
				    echo.Integrating Microsoft .NET Framework 4.5 Package...
				    echo.-------------------------------------------------------------------------------
				    call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\NET45"
			    )

			    if exist "%Temp%\Updates\NET45LP\Update.mum" (
				    echo.-------------------------------------------------------------------------------
				    echo.Integrating Microsoft .NET Framework 4.5 [%ImageDefaultLanguage%] Package...
				    echo.-------------------------------------------------------------------------------
				    call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\NET45LP"
			    )

			    if exist "%Temp%\Updates\Cumulative\Update.mum" (
				    echo.-------------------------------------------------------------------------------
				    echo.Integrating Windows 10 Cumulative Update Package...
				    echo.-------------------------------------------------------------------------------
				    call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Cumulative"
			    )

			    if exist "%Temp%\Updates\NET35\Update.mum" (
				    if "%ImageBuild%" lss "19041" if not exist "%InstallMount%\%%i\Windows\WinSxS\pending.xml" (
						echo.-------------------------------------------------------------------------------
						echo.Performing [Install.wim, Index : %%i] Image Cleanup...
						echo.-------------------------------------------------------------------------------
						call :CleanupImage "%InstallMount%\%%i", "ComponentCleanupResetBase"
					)
					echo.-------------------------------------------------------------------------------
				    echo.Integrating Microsoft .NET Framework 3.5 Package...
				    echo.-------------------------------------------------------------------------------
				    call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\NET35"
			    )

			    if exist "%Temp%\Updates\NET35LP\Update.mum" (
				    echo.-------------------------------------------------------------------------------
				    echo.Integrating Microsoft .NET Framework 3.5 [%ImageDefaultLanguage%] Package...
				    echo.-------------------------------------------------------------------------------
				    call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\NET35LP"
			    )

			    if exist "%Temp%\Updates\NetCumulative\Update.mum" (
				    echo.-------------------------------------------------------------------------------
				    echo.Integrating Microsoft .NET 3.5/4.x Cumulative Update Package...
				    echo.-------------------------------------------------------------------------------
				    call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\NetCumulative"
			    )

			    if exist "%Temp%\Updates\EdgeChromium\Update.mum" (
				    echo.-------------------------------------------------------------------------------
				    echo.Integrating Microsoft Edge Chromium Browser Package...
				    echo.-------------------------------------------------------------------------------
				    call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\EdgeChromium"
			    )

			    if "%ImageBuild%" geq "19041" if "%ImageBuild%" leq "19042" if exist "%Temp%\Updates\Enablement\Update.mum" (
				    echo.-------------------------------------------------------------------------------
				    echo.Integrating Windows 10 v20H2 Feature Enablement Update Package...
				    echo.-------------------------------------------------------------------------------
				    call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Enablement"
			    )

			    if exist "%Temp%\Updates\Cumulative\Update.mum" (
				    echo.-------------------------------------------------------------------------------
				    echo.Re-Integrating Windows 10 Cumulative Update Package...
				    echo.-------------------------------------------------------------------------------
				    call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\Cumulative"
			    )

			    if exist "%Temp%\Updates\Defender\package-defender.xml" (
				    echo.-------------------------------------------------------------------------------
				    echo.Integrating Windows Defender Definition Update Package...
				    echo.-------------------------------------------------------------------------------
				    echo.
				    for /f %%x IN ('"dir /b %Temp%\Updates\Defender\Platform" 2^>nul') do (set "DefenderVersion=%%x")

				    echo.Copying Windows Defender Definition Updates ^(v!DefenderVersion!^).
				    %XCopy% "%Temp%\Updates\Defender\Definition Updates\Updates" "%InstallMount%\%%i\ProgramData\Microsoft\Windows Defender\Definition Updates\Updates" >nul

				    echo.Copying Windows Defender Platform Updates.
				    %XCopy% /s "%Temp%\Updates\Defender\Platform" "%InstallMount%\%%i\ProgramData\Microsoft\Windows Defender\Platform" >nul

				    echo.Copying MpAsDesc.dll file.
				    Copy "%InstallMount%\%%i\Program Files\Windows Defender\MpAsDesc.dll" "%InstallMount%\%%i\ProgramData\Microsoft\Windows Defender\Platform\!DefenderVersion!" >nul
				    if "%ImageArchitecture%" equ "x64" Copy "%InstallMount%\%%i\Program Files (x86)\Windows Defender\MpAsDesc.dll" "%InstallMount%\%%i\ProgramData\Microsoft\Windows Defender\Platform\!DefenderVersion!\x86" >nul

				    echo.Copying MpAsDesc.dll.mui file.
				    for /d %%y in (ar-SA,bg-BG,cs-CZ,da-DK,de-DE,el-GR,en-GB,en-US,es-ES,es-MX,et-EE,fi-FI,fr-CA,fr-FR,he-IL,hr-HR,hu-HU,it-IT,ja-JP,ko-KR,lt-LT,lv-LV,nb-NO,nl-NL,pl-PL,pt-BR,pt-PT,ro-RO,ru-RU,sk-SK,sl-SI,sr-Latn-RS,sv-SE,th-TH,tr-TR,uk-UA,zh-CN,zh-HK,zh-TW) do (
					    if exist "%InstallMount%\%%i\Program Files\Windows Defender\%%y" (
						    call :CreateFolder "%InstallMount%\%%i\ProgramData\Microsoft\Windows Defender\Platform\!DefenderVersion!\%%y"
						    Copy "%InstallMount%\%%i\Program Files\Windows Defender\%%y\mpasdesc.dll.mui" "%InstallMount%\%%i\ProgramData\Microsoft\Windows Defender\Platform\!DefenderVersion!\%%y\mpasdesc.dll.mui" >nul

						    if "%ImageArchitecture%" equ "x64" (
							    call :CreateFolder "%InstallMount%\%%i\ProgramData\Microsoft\Windows Defender\Platform\!DefenderVersion!\x86\%%y"
							    Copy "%InstallMount%\%%i\Program Files (x86)\Windows Defender\%%y\mpasdesc.dll.mui" "%InstallMount%\%%i\ProgramData\Microsoft\Windows Defender\Platform\!DefenderVersion!\x86\%%y\mpasdesc.dll.mui" >nul
						    )
					    )
				    )

				    echo.Copying Package-defender.xml to Windows Temp folder.
				    Copy "%Temp%\Updates\Defender\package-defender.xml" "%InstallMount%\%%i\Windows\Temp" >nul
				    echo.
			    )
		    )
	    )
    )
)

if "%UpdateType%" neq "Boot" if "%UpdateType%" neq "Install" (
    echo.-------------------------------------------------------------------------------
    if "%SelectedSourceOS%" equ "w81" echo.####Integrating WHD Baseline Updates to Windows Setup Recovery Image###########
    if "%SelectedSourceOS%" equ "w10" echo.####Integrating WHD General Updates to Windows Setup Recovery Image############
    echo.-------------------------------------------------------------------------------

    for /l %%i in (1, 1, %ImageCount%) do (
	    if exist "%WinReMount%\%%i" (
		    echo.
		    if not %%i gtr 9 echo.=====================[Install.wim, Index : %%i -^> WinRE.wim]=====================
		    if %%i gtr 9 echo.=====================[Install.wim, Index : %%i -^> WinRE.wim]===================
		    echo.
		
		    :: Windows 8.1 RTM (Build : 6.3.9600.16384)
		    if "%SelectedSourceOS%" equ "w81" if %ImageServicePackBuild% equ 16384 (
			    echo.-------------------------------------------------------------------------------
			    echo.Integrating WHD Baseline Prerequisite Update ^(KB3021910^)...
			    echo.-------------------------------------------------------------------------------
			    call :AddPackage "%WinReMount%\%%i", "%Temp%\Updates\Windows8.1-KB3021910-%ImageArchitecture%.cab"
			    echo.-------------------------------------------------------------------------------
			    echo.Integrating WHD Baseline Update ^(KB2919355^)...
			    echo.-------------------------------------------------------------------------------
			    call :AddPackage "%WinReMount%\%%i", "%Temp%\Updates\Windows8.1-KB2919355-%ImageArchitecture%.cab"
			    echo.-------------------------------------------------------------------------------
			    echo.Integrating WHD Baseline Feature Pack Update ^(KB3000850^)...
			    echo.-------------------------------------------------------------------------------
			    call :AddPackage "%WinReMount%\%%i", "%Temp%\Updates\Windows8.1-KB3000850-%ImageArchitecture%.cab"
			    echo.-------------------------------------------------------------------------------
			    echo.Integrating WHD Baseline Feature Pack Update ^(KB2932046^)...
			    echo.-------------------------------------------------------------------------------
			    call :AddPackage "%WinReMount%\%%i", "%Temp%\Updates\Windows8.1-KB2932046-%ImageArchitecture%.cab"
			    echo.-------------------------------------------------------------------------------
			    echo.Integrating WHD Baseline Feature Pack Update ^(KB2934018^)...
			    echo.-------------------------------------------------------------------------------
			    call :AddPackage "%WinReMount%\%%i", "%Temp%\Updates\Windows8.1-KB2934018-%ImageArchitecture%.cab"
			    echo.-------------------------------------------------------------------------------
			    echo.Integrating WHD Baseline Feature Pack Update ^(KB2937592^)...
			    echo.-------------------------------------------------------------------------------
			    call :AddPackage "%WinReMount%\%%i", "%Temp%\Updates\Windows8.1-KB2937592-%ImageArchitecture%.cab"
			    echo.-------------------------------------------------------------------------------
			    echo.Integrating WHD Baseline Feature Pack Update ^(KB2938439^)...
			    echo.-------------------------------------------------------------------------------
			    call :AddPackage "%WinReMount%\%%i", "%Temp%\Updates\Windows8.1-KB2938439-%ImageArchitecture%.cab"
			    echo.-------------------------------------------------------------------------------
			    echo.Integrating WHD Baseline Feature Pack Update ^(KB2938772^)...
			    echo.-------------------------------------------------------------------------------
			    call :AddPackage "%WinReMount%\%%i", "%Temp%\Updates\Windows8.1-KB2938772-%ImageArchitecture%.cab"
			    echo.-------------------------------------------------------------------------------
			    echo.Integrating WHD Baseline Feature Pack Update ^(KB3003057^)...
			    echo.-------------------------------------------------------------------------------
			    call :AddPackage "%WinReMount%\%%i", "%Temp%\Updates\Windows8.1-KB3003057-%ImageArchitecture%.cab"
			    echo.-------------------------------------------------------------------------------
			    echo.Integrating WHD Baseline Feature Pack Update ^(KB4566425^)...
			    echo.-------------------------------------------------------------------------------
			    call :AddPackage "%WinReMount%\%%i", "%Temp%\Updates\Windows8.1-KB4566425-%ImageArchitecture%.cab"
		    )

		    :: Windows 8.1 with Update (IR3 Build : 6.3.9600.17031)
		    if "%SelectedSourceOS%" equ "w81" if "%ImageServicePackBuild%" equ "17031" (
			    echo.-------------------------------------------------------------------------------
			    echo.Integrating WHD Baseline Feature Pack Update ^(KB3021910^)...
			    echo.-------------------------------------------------------------------------------
			    call :AddPackage "%WinReMount%\%%i", "%Temp%\Updates\Windows8.1-KB3021910-%ImageArchitecture%.cab"
			    echo.-------------------------------------------------------------------------------
			    echo.Integrating WHD Baseline Feature Pack Update ^(KB4566425^)...
			    echo.-------------------------------------------------------------------------------
			    call :AddPackage "%WinReMount%\%%i", "%Temp%\Updates\Windows8.1-KB4566425-%ImageArchitecture%.cab"
			    echo.-------------------------------------------------------------------------------
			    echo.Integrating WHD Baseline Feature Pack Update ^(KB3000850^)...
			    echo.-------------------------------------------------------------------------------
			    call :AddPackage "%WinReMount%\%%i", "%Temp%\Updates\Windows8.1-KB3000850-%ImageArchitecture%.cab"
			    echo.-------------------------------------------------------------------------------
			    echo.Integrating WHD Baseline Feature Pack Update ^(KB2934018^)...
			    echo.-------------------------------------------------------------------------------
			    call :AddPackage "%WinReMount%\%%i", "%Temp%\Updates\Windows8.1-KB2934018-%ImageArchitecture%.cab"
			    echo.-------------------------------------------------------------------------------
			    echo.Integrating WHD Baseline Feature Pack Update ^(KB3003057^)...
			    echo.-------------------------------------------------------------------------------
			    call :AddPackage "%WinReMount%\%%i", "%Temp%\Updates\Windows8.1-KB3003057-%ImageArchitecture%.cab"
		    )

		    :: Windows 8.1 with Update Refresh (IR4 Build : 6.3.9600.17056)
		    if "%SelectedSourceOS%" equ "w81" if "%ImageServicePackBuild%" equ "17056" (
			    echo.-------------------------------------------------------------------------------
			    echo.Integrating WHD Baseline Feature Pack Update ^(KB3021910^)...
			    echo.-------------------------------------------------------------------------------
			    call :AddPackage "%WinReMount%\%%i", "%Temp%\Updates\Windows8.1-KB3021910-%ImageArchitecture%.cab"
			    echo.-------------------------------------------------------------------------------
			    echo.Integrating WHD Baseline Feature Pack Update ^(KB4566425^)...
			    echo.-------------------------------------------------------------------------------
			    call :AddPackage "%WinReMount%\%%i", "%Temp%\Updates\Windows8.1-KB4566425-%ImageArchitecture%.cab"
			    echo.-------------------------------------------------------------------------------
			    echo.Integrating WHD Baseline Feature Pack Update ^(KB3000850^)...
			    echo.-------------------------------------------------------------------------------
			    call :AddPackage "%WinReMount%\%%i", "%Temp%\Updates\Windows8.1-KB3000850-%ImageArchitecture%.cab"
			    echo.-------------------------------------------------------------------------------
			    echo.Integrating WHD Baseline Feature Pack Update ^(KB3003057^)...
			    echo.-------------------------------------------------------------------------------
			    call :AddPackage "%WinReMount%\%%i", "%Temp%\Updates\Windows8.1-KB3003057-%ImageArchitecture%.cab"
		    )

		    :: Windows 8.1 with Update Refresh (IR5 Build : 6.3.9600.17415)
		    if "%SelectedSourceOS%" equ "w81" if "%ImageServicePackBuild%" equ "17415" (
			    if exist "%Temp%\Updates\Windows8.1-KB3021910-%ImageArchitecture%.cab" (
			    	echo.-------------------------------------------------------------------------------
			    	echo.Integrating WHD Baseline Feature Pack Update ^(KB3021910^)...
			    	echo.-------------------------------------------------------------------------------
			    	call :AddPackage "%WinReMount%\%%i", "%Temp%\Updates\Windows8.1-KB3021910-%ImageArchitecture%.cab"
			    )

			    echo.-------------------------------------------------------------------------------
			    echo.Integrating WHD Baseline Feature Pack Update ^(KB4566425^)...
			    echo.-------------------------------------------------------------------------------
			    call :AddPackage "%WinReMount%\%%i", "%Temp%\Updates\Windows8.1-KB4566425-%ImageArchitecture%.cab"
    		)

	    	:: Windows 8.1
			if "%SelectedSourceOS%" equ "w81" if exist "%Temp%\Updates\WinPE\*.cab" (
		    	echo.-------------------------------------------------------------------------------
		    	echo.Integrating Windows 10 WinPE Updates...
		    	echo.-------------------------------------------------------------------------------
		    	call :AddPackage "%WinReMount%\%%i", "%Temp%\Updates\WinPE"
	    	)

		    :: Windows 10
		    if "%SelectedSourceOS%" equ "w10" (
			    if exist "%Temp%\Updates\ServicingStack\Update.mum" (
			    	if "%ImageBuild%" equ "10240" if "%ImageServicePackBuild%" equ "16384" (
			    		echo.-------------------------------------------------------------------------------
			    		echo.Applying Windows 10 v1507 Cumulative Update Integration Fix...
			    		echo.-------------------------------------------------------------------------------
			    		if "%ImageArchitecture%" equ "x86" call :ApplyImage "%W10CUFix%\TH1CUFix.tpk", 1, "%WinReMount%\%%i"
			    		if "%ImageArchitecture%" equ "x64" call :ApplyImage "%W10CUFix%\TH1CUFix.tpk", 2, "%WinReMount%\%%i"
			    		call :MountImageRegistry "%WinReMount%\%%i"
			    		call :ImportRegistry2Image "%W10CUFix%\TH1CUFix_%ImageArchitecture%.reg" 2>nul
			    		call :UnMountImageRegistry
			    	)
			    	
			    	if "%ImageArchitecture%" equ "x86" if "%ImageBuild%" equ "14393" if "%ImageServicePackBuild%" equ "0" (
			    		echo.-------------------------------------------------------------------------------
			    		echo.Applying Windows 10 v1607 Cumulative Update Integration Fix...
			    		echo.-------------------------------------------------------------------------------
			    		call :ApplyImage "%W10CUFix%\RS1CUFix.tpk", 1, "%WinReMount%\%%i"
			    		call :MountImageRegistry "%WinReMount%\%%i"
			    		call :ImportRegistry2Image "%W10CUFix%\RS1CUFix.reg" 2>nul
			    		call :UnMountImageRegistry
			    	)
		
			    	echo.-------------------------------------------------------------------------------
			    	echo.Integrating Windows 10 Servicing Stack Update Package...
			    	echo.-------------------------------------------------------------------------------
			    	call :AddPackage "%WinReMount%\%%i", "%Temp%\Updates\ServicingStack"
			    )

			    if exist "%Temp%\Updates\SecureBoot\Update.mum" (
				    echo.-------------------------------------------------------------------------------
				    echo.Integrating Windows Secure Boot WinPE Update Package...
				    echo.-------------------------------------------------------------------------------
				    call :AddPackage "%WinReMount%\%%i", "%Temp%\Updates\SecureBoot"
			    )

			    if exist "%Temp%\Updates\WinPE\Update.mum" (
			    	echo.-------------------------------------------------------------------------------
			    	echo.Integrating Windows 10 WinPE Update Package...
			    	echo.-------------------------------------------------------------------------------
			    	call :AddPackage "%WinReMount%\%%i", "%Temp%\Updates\WinPE"
			    )

			    if exist "%Temp%\Updates\Enablement\Update.mum" (
			    	echo.-------------------------------------------------------------------------------
			    	if "%ImageBuild%" geq "18362" if "%ImageBuild%" leq "18363" echo.Integrating Windows 10 v1909 Feature Enablement Update Package...
			    	if "%ImageBuild%" geq "19041" if "%ImageBuild%" leq "19042" echo.Integrating Windows 10 v20H2 Feature Enablement Update Package...
			    	echo.-------------------------------------------------------------------------------
			    	call :AddPackage "%WinReMount%\%%i", "%Temp%\Updates\Enablement"
			    )

			    if exist "%Temp%\Updates\Cumulative\Update.mum" (
			    	echo.-------------------------------------------------------------------------------
			    	echo.Integrating Windows 10 Cumulative Update Package...
			    	echo.-------------------------------------------------------------------------------
			    	call :AddPackage "%WinReMount%\%%i", "%Temp%\Updates\Cumulative"
			    )
		    )
	    )
    )
)

if "%IsLogsEnabled%" equ "Yes" (
	echo.-------------------------------------------------------------------------------
	if "%SelectedSourceOS%" equ "w81" echo.Generating WHD Baseline Updates Integration Log File...
	if "%SelectedSourceOS%" equ "w10" echo.Generating WHD General Updates Integration Log File...
	echo.-------------------------------------------------------------------------------
	echo.
	if "%SelectedSourceOS%" equ "w81" echo.Writing WHD Baseline Updates Integration Log.
	if "%SelectedSourceOS%" equ "w10" echo.Writing WHD General Updates Integration Log.
	echo.

	if "%UpdateType%" neq "Install" if "%UpdateType%" neq "InstallRecovery" (
		for /l %%k in (1, 1, 2) do (
			call :GetPackages "%BootMount%\%%k", "Boot-%%k.txt"
		)
	)

	if "%UpdateType%" neq "Boot" (
	    for /l %%i in (1, 1, %ImageCount%) do (
			if exist "%InstallMount%\%%i" (
    	    	call :GetPackages "%InstallMount%\%%i", "Install-%%i.txt"
    		)
		)
	)

	if "%UpdateType%" neq "Boot" if "%UpdateType%" neq "Install" (
    	for /l %%i in (1, 1, %ImageCount%) do (
	    	if exist "%WinReMount%\%%i" (
				call :GetPackages "%WinReMount%\%%i", "Install_WinRE-%%i.txt"
    		)
		)
	)
)

echo.-------------------------------------------------------------------------------
echo.####Cleaning Up Temporary files ^& Folders######################################
echo.-------------------------------------------------------------------------------
echo.
if "%SelectedSourceOS%" equ "w81" echo.Cleaning Up WHD Baseline Updates Temporary folder.
if "%SelectedSourceOS%" equ "w10" echo.Cleaning Up WHD General Updates Temporary folder.
call :RemoveFolder "%Temp%\Updates"
echo.
echo.-------------------------------------------------------------------------------
if "%SelectedSourceOS%" equ "w81" echo.##################Finished Integrating WHD Baseline Updates####################
if "%SelectedSourceOS%" equ "w10" echo.##################Finished Integrating WHD General Updates#####################
if "%UpdateType%" equ "Boot" echo.########################to Windows Setup Boot Image############################
if "%UpdateType%" equ "Install" echo.######################to Windows Setup Install Image###########################
if "%UpdateType%" equ "InstallRecovery" echo.#################to Windows Setup Install ^& Recovery Images#####################
if "%UpdateType%" equ "BootInstallRecovery" echo.##############to Windows Setup Boot, Install ^& Recovery Images#################
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set UpdateType=
set PackageArchitecture=
set Updates=

endlocal

:: Reading Updated Image Information
if "%SelectedSourceOS%" equ "w10" (
	for /l %%i in (1, 1, %ImageCount%) do (
		if exist "%InstallMount%\%%i" (
			call :MountImageRegistry "%InstallMount%\%%i"
			for /f "tokens=3 delims= " %%x in ('reg query "HKLM\TK_SOFTWARE\Microsoft\Windows NT\CurrentVersion" /v "CurrentBuild" ^| find "REG_SZ"') do (set /a ImageBuild=%%x)
			set "ImageVersion=10.0.!ImageBuild!"
			for /f "tokens=3 delims= " %%y in ('reg query "HKLM\TK_SOFTWARE\Microsoft\Windows NT\CurrentVersion" /v "UBR" ^| find "REG_DWORD"') do (set /a ImageServicePackBuild=%%y)
			call :UnMountImageRegistry
		)
	)
)

:: Returning to Integrate Menu
goto :IntegrateMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Integrate Updates
:: Input Parameters [%~1 : UpdateType ]
::-------------------------------------------------------------------------------------------
:IntUpdates

setlocal

:: Setting WHD Updates Type
set "UpdateType=%~1"

cls
echo.===============================================================================
if "%UpdateType%" equ "WUpdates" echo.                   MSMG ToolKit - Integrate Windows Updates
if "%UpdateType%" equ "General" echo.                 MSMG ToolKit - Integrate WHD General Updates
if "%UpdateType%" equ "Hotfix" echo.                 MSMG ToolKit - Integrate WHD Hotfix Updates
if "%UpdateType%" equ "Security" echo.               MSMG ToolKit - Integrate WHD Security Updates
if "%UpdateType%" equ "NET35" echo.        MSMG ToolKit - Integrate Microsoft .NET Framework 3.5 Updates
if "%UpdateType%" equ "WAT" echo.        MSMG ToolKit - Integrate Windows Activation Technologies ^(WAT^)
if "%UpdateType%" equ "Windows10" echo.        MSMG ToolKit - Integrate Windows 10 Upgrade Preparation Updates
if "%UpdateType%" equ "WinPE" echo.                MSMG ToolKit - Integrate Windows PE Updates
if "%UpdateType%" equ "WUSatisfy" echo.           MSMG ToolKit - Integrate Windows Update Satisfy Updates
if "%UpdateType%" equ "ADLDS" echo.   MSMG ToolKit - Integrate Active Directory Lightweight Directory Services
if "%UpdateType%" equ "FMApi" echo.                    MSMG ToolKit - Integrate File Management API
if "%UpdateType%" equ "Features" echo.                   MSMG ToolKit - Integrate Windows Features
if "%UpdateType%" equ "VirtualPC" echo.             MSMG ToolKit - Integrate Microsoft Virtual PC Feature
if "%UpdateType%" equ "WorkFolders" echo.  MSMG ToolKit - Integrate Sync Agent for Domain Environmernts ^(Work Folders^)
echo.===============================================================================
echo.

:: Getting Install Image Index Architecture
for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" call :GetImageArchitecture "%InstallWim%", %%i >nul
)

:: Settings Windows/WHD Updates Menu folder path
if "%UpdateType%" equ "WUpdates" set "Updates=%Updates%\%SelectedSourceOS%\%ImageArchitecture%"
if "%UpdateType%" neq "WUpdates" set "Updates=%WHD%\%SelectedSourceOS%\%ImageArchitecture%"

:: Checking Windows/WHD Updates folder is empty
if "%UpdateType%" equ "WUpdates" if not exist "%Updates%\*.msu" if not exist "%Updates%\*.cab" (
	echo.Windows Updates folder ^<Updates\%SelectedSourceOS%\%ImageArchitecture%^> is empty...
	echo.
	echo.Please copy Windows Updates files to respective folder...
	goto :Stop
)

if "%UpdateType%" equ "General" (
	if "%SelectedSourceOS%" equ "w7" if "%IsW7SP1CRUSelected%" equ "0" if not exist "%Updates%\Extra\WithoutKB3125574\#General\*.msu" if not exist "%Updates%\Extra\WithoutKB3125574\#General\*.cab" (
		echo.WHD General Updates Folder ^<WHD\%SelectedSourceOS%\%ImageArchitecture%\Extra\WithoutKB3125574\#General^> is empty...
		echo.
		echo.Please copy WHD General Updates files to respective folder...
		goto :Stop
	)

	if "%SelectedSourceOS%" equ "w7" if "%IsW7SP1CRUSelected%" equ "1" if not exist "%Updates%\General\*.msu" if not exist "%Updates%\General\*.cab" (
		echo.WHD General Updates Folder ^<WHD\%SelectedSourceOS%\%ImageArchitecture%\General^> is empty...
		echo.
		echo.Please copy WHD General Updates files to respective folder...
		goto :Stop
	)

	if "%SelectedSourceOS%" equ "w81" if not exist "%Updates%\General\*.msu" if not exist "%Updates%\General\*.cab" (
		echo.WHD General Updates Folder ^<WHD\%SelectedSourceOS%\%ImageArchitecture%\General^> is empty...
		echo.
		echo.Please copy WHD General Updates files to respective folder...
		goto :Stop
	)
)

if "%UpdateType%" equ "Hotfix" (
	if "%SelectedSourceOS%" equ "w7" if "%IsW7SP1CRUSelected%" equ "0" if not exist "%Updates%\Extra\WithoutKB3125574\#Hotfix\*.msu" if not exist "%Updates%\Extra\WithoutKB3125574\#Hotfix\*.cab" (
		echo.WHD Hotfix Updates Folder ^<WHD\%SelectedSourceOS%\%ImageArchitecture%\Extra\WithoutKB3125574\#Hotfix^> is empty...
		echo.
		echo.Please copy WHD Hotfix Updates files to respective folder...
		goto :Stop
	)

	if "%SelectedSourceOS%" equ "w7" if "%IsW7SP1CRUSelected%" equ "1" if not exist "%Updates%\Hotfix\*.msu" if not exist "%Updates%\Hotfix\*.cab" (
		echo.WHD Hotfix Updates Folder ^<WHD\%SelectedSourceOS%\%ImageArchitecture%\Hotfix^> is empty...
		echo.
		echo.Please copy WHD Hotfix Updates files to respective folder...
		goto :Stop
	)

	if "%SelectedSourceOS%" equ "w81" if not exist "%Updates%\Hotfix\*.msu" if not exist "%Updates%\Hotfix\*.cab" (
		echo.WHD Hotfix Updates Folder ^<WHD\%SelectedSourceOS%\%ImageArchitecture%\Hotfix^> is empty...
		echo.
		echo.Please copy WHD Hotfix Updates files to respective folder...
		goto :Stop
	)
)

if "%UpdateType%" equ "Security" (
	if "%SelectedSourceOS%" equ "w7" if "%IsW7SP1CRUSelected%" equ "0" if not exist "%Updates%\Extra\WithoutKB3125574\#Security\*.msu" if not exist "%Updates%\Extra\WithoutKB3125574\#Security\*.cab" (
		echo.WHD Security Updates Folder ^<WHD\%SelectedSourceOS%\%ImageArchitecture%\Extra\WithoutKB3125574\#Security^> is empty...
		echo.
		echo.Please copy WHD Security Updates files to respective folder...
		goto :Stop
	)

	if "%SelectedSourceOS%" equ "w7" if "%IsW7SP1CRUSelected%" equ "1" if not exist "%Updates%\Security\WithoutESU\*.msu" if not exist "%Updates%\Security\WithoutESU\*.cab" (
		echo.WHD Security Updates Folder ^<WHD\%SelectedSourceOS%\%ImageArchitecture%\Security\WithoutESU^> is empty...
		echo.
		echo.Please copy WHD Security Updates files to respective folder...
		goto :Stop
	)

	if "%SelectedSourceOS%" equ "w7" if "%IsW7SP1CRUSelected%" equ "1" if not exist "%Updates%\Security\*.msu" if not exist "%Updates%\Security\*.cab" (
		echo.WHD Security Updates Folder ^<WHD\%SelectedSourceOS%\%ImageArchitecture%\Security^> is empty...
		echo.
		echo.Please copy WHD Security Updates files to respective folder...
		goto :Stop
	)
	
	if "%SelectedSourceOS%" equ "w81" if not exist "%Updates%\Security\*.msu" if not exist "%Updates%\Security\*.cab" (
		echo.WHD Security Updates Folder ^<WHD\%SelectedSourceOS%\%ImageArchitecture%\Security^> is empty...
		echo.
		echo.Please copy WHD Security Updates files to respective folder...
		goto :Stop
	)
)

if "%UpdateType%" equ "NET35" if not exist "%Updates%\Additional\NET35\*.msu" if not exist "%Updates%\Additional\NET35\*.cab" (
	echo.	         Microsoft .NET Framework 3.5 Updates Folder
	echo.	       ^<WHD\%SelectedSourceOS%\%ImageArchitecture%\Additional\NET35^> is empty...
	echo.
	echo. Please Copy Microsoft .NET Framework 3.5 Updates files to respective folder...
	goto :Stop
)

if "%UpdateType%" equ "WAT" (
	if not exist "%Updates%\Additional\WAT\*.msu" if not exist "%Updates%\Additional\WAT\*.cab" (
		echo.                    Windows Activation Technologies Folder
		echo.                 ^<WHD\%SelectedSourceOS%\%ImageArchitecture%\Additional\WAT^> is empty...
		echo.
		echo.    Please Copy Windows Activation Technologies files to respective folder...
		goto :Stop
	)

	if "%ImageEdition%" equ "Embedded" (
		echo.Windows Activation Technologies Requires Client/Server Editions...
		goto :Stop
	)
)

if "%UpdateType%" equ "Windows10" (
	if not exist "%Updates%\Additional\Windows10\*.msu" if not exist "%Updates%\Additional\Windows10\*.cab" (
		echo.                  Windows 10 Upgrade Preparation Updates Folder
		echo.               ^<WHD\%SelectedSourceOS%\%ImageArchitecture%\Additional\Windows10^> is empty...
		echo.
		echo.Please copy Windows 10 Upgrade Preparation Updates files to Respective Folder..
		goto :Stop
	)

	if "%IsW7SP1CRUSelected%" equ "0" if not exist "%Updates%\Extra\WithoutKB3125574\_Windows10\*.msu" if not exist "%Updates%\Extra\WithoutKB3125574\_Windows10\*.cab" (
		echo.               Windows 10 Upgrade Preparation Updates Folder
		echo.       ^<WHD\%SelectedSourceOS%\%ImageArchitecture%\Extra\WithoutKB3125574\_Windows10^> is empty...
		echo.
		echo.Please copy Windows 10 Upgrade Preparation Updates files to Respective Folder..
		goto :Stop
	)

	if "%ImageEdition%" equ "Embedded" (
		echo.Windows 10 Upgrade Preparation Updates Requires Client Editions...
		goto :Stop
	)
)

if "%UpdateType%" equ "WinPE" if not exist "%Updates%\Additional\WinPE\*.msu" if not exist "%Updates%\Additional\WinPE\*.cab" (
	echo.Windows PE Updates Folder ^<WHD\%SelectedSourceOS%\%ImageArchitecture%\Additional\WinPE^> is empty...
	echo.
	echo.Please copy Windows PE Updates files to respective folder...
	goto :Stop
)

if "%UpdateType%" equ "WUSatisfy" if not exist "%Updates%\Additional\WU.Satisfy\*.msu" if not exist "%Updates%\Additional\WU.Satisfy\*.cab" (
	echo.                    Windows Update Satisfy Updates Folder
	echo.              ^<WHD\%SelectedSourceOS%\%ImageArchitecture%\Additional\WU.Satisfy^> is empty...
	echo.
	echo.    Please Copy Windows Update Satisfy Updates files to respective folder...
	goto :Stop
)

if "%UpdateType%" equ "ADLDS" (
	if not exist "%Updates%\Extra\AD_LDS\*.msu" if not exist "%Updates%\Extra\AD_LDS\*.cab" (
		echo.        Active Directory Lightweight Directory Services Feature Folder
		echo.                 ^<WHD\%SelectedSourceOS%\%ImageArchitecture%\Extra\AD_LDS^> is empty...
		echo.
		echo.           Please Copy ADLDS Feature files to respective folder...
		goto :Stop
	)

	if not exist "%Updates%\Extra\AD_LDS\Updates\*.msu" if not exist "%Updates%\Extra\AD_LDS\Updates\*.cab" (
		echo.     Active Directory Lightweight Directory Services Feature Updates Folder
		echo.           ^<WHD\%SelectedSourceOS%\%ImageArchitecture%\Extra\AD_LDS\Updates^> is empty...
		echo.
		echo.        Please Copy ADLDS Feature Updates files to respective folder...
		goto :Stop
	)

	if "%IsW7SP1CRUSelected%" equ "0" if not exist "%Updates%\Extra\WithoutKB3125574\AD_LDS\*.msu" if not exist "%Updates%\Extra\WithoutKB3125574\AD_LDS\*.cab" (
		echo.     Active Directory Lightweight Directory Services Feature Updates Folder
		echo.         ^<WHD\%SelectedSourceOS%\%ImageArchitecture%\Extra\WithoutKB3125574\AD_LDS^> is empty...
		echo.
		echo.        Please Copy ADLDS Feature Updates files to respective folder...
		goto :Stop
	)

	if "%ImageEdition%" neq "Professional" if "%ImageEdition%" neq "Enterprise" if "%ImageEdition%" neq "Ultimate" (
		echo.           Active Directory Lightweight Directory Services Feature
		echo.             Requires Professional/Enterprise/Ultimate Editions...
		goto :Stop
	) else (
		goto :Continue
	)
)

if "%UpdateType%" equ "FMApi" if not exist "%Updates%\Extra\Addons\FM.Api\*.msu" if not exist "%Updates%\Extra\Addons\FM.Api\*.cab" (
	echo.                        File Management API Folder
	echo.        ^<WHD\%SelectedSourceOS%\%ImageArchitecture%\Extra\Addons\FM.Api^> is empty...
	echo.
	echo.           Please Copy File Management API files to respective folder...
	goto :Stop
)

if "%UpdateType%" equ "Features" if not exist "%Updates%\Extra\WithoutKB3125574\_Features\*.msu" if not exist "%Updates%\Extra\WithoutKB3125574\_Features\*.cab" (
	echo.                           Windows Features Folder
	echo.        ^<WHD\%SelectedSourceOS%\%ImageArchitecture%\Extra\WithoutKB3125574\_Features^> is empty...
	echo.
	echo.           Please Copy Windows Features files to respective folder...
	goto :Stop
)

if "%UpdateType%" equ "VirtualPC" (
	if not exist "%Updates%\Extra\VirtualPC\*.msu" if not exist "%Updates%\Extra\VirtualPC\*.cab" (
		echo.                     Microsoft Virtual PC Feature Folder
		echo.                ^<WHD\%SelectedSourceOS%\%ImageArchitecture%\Extra\VirtualPC^> is empty...
		echo.
		echo.    Please Copy Microsoft Virtual PC Feature files to respective folder...
		goto :Stop
	)

	if "%IsW7SP1CRUSelected%" equ "0" if not exist "%Updates%\Extra\WithoutKB3125574\VirtualPC\*.msu" if not exist "%Updates%\Extra\WithoutKB3125574\VirtualPC\*.cab" (
		echo.                Microsoft Virtual PC Feature Updates Folder
		echo.       ^<WHD\%SelectedSourceOS%\%ImageArchitecture%\Extra\WithoutKB3125574\VirtualPC^> is empty...
		echo.
		echo.Please copy Microsoft Virtual PC Feature Updates files to respective folder...
		goto :Stop
	)
)

if "%UpdateType%" equ "WorkFolders" (
	if not exist "%Updates%\Extra\Addons\WorkFolders\*.msu" if not exist "%Updates%\Extra\Addons\WorkFolders\*.cab" (
		echo.       Sync Agent for Domain Environmernts ^(Work Folders^) Feature Folder
		echo.           ^<WHD\%SelectedSourceOS%\%ImageArchitecture%\Extra\Addons\WorkFolders^> is empty...
		echo.
		echo.         Please Copy Sync Agent for Domain Environmernts ^(Work Folders^)
		echo.                   Feature files to respective folder...
		goto :Stop
	)

	if "%IsW7SP1CRUSelected%" equ "0" if not exist "%Updates%\Extra\WithoutKB3125574\WorkFolders\*.msu" if not exist "%Updates%\Extra\WithoutKB3125574\WorkFolders\*.cab" (
		echo.   Sync Agent for Domain Environmernts ^(Work Folders^) Feature Updates Folder
		echo.      ^<WHD\%SelectedSourceOS%\%ImageArchitecture%\Extra\WithoutKB3125574\WorkFolders^> is empty...
		echo.
		echo.        Please Copy Sync Agent for Domain Environmernts ^(Work Folders^)
		echo.                Feature Updates files to respective folder...
		goto :Stop
	)

	if "%ImageEdition%" neq "Professional" if "%ImageEdition%" neq "Enterprise" if "%ImageEdition%" neq "Ultimate" (
		echo.           Sync Agent for Domain Environmernts ^(Work Folders^) Feature
		echo.             Requires Professional/Enterprise/Ultimate Editions...
		goto :Stop
	) else (
		goto :Continue
	)
)

:Continue
echo.-------------------------------------------------------------------------------
if "%UpdateType%" equ "WUpdates" echo.####Starting Integrating Windows Updates#######################################
if "%UpdateType%" equ "General" echo.####Starting Integrating WHD General Updates###################################
if "%UpdateType%" equ "Hotfix" echo.####Starting Integrating WHD Hotfix Updates####################################
if "%UpdateType%" equ "Security" echo.####Starting Integrating WHD Security Updates##################################
if "%UpdateType%" equ "NET35" echo.####Starting Integrating Microsoft .NET Framework 3.5 Updates##################
if "%UpdateType%" equ "WAT" echo.####Starting Integrating Windows Activation Technologies ^(WAT^)#################
if "%UpdateType%" equ "Windows10" echo.####Starting Integrating Windows 10 Upgrade Preparation Updates################
if "%UpdateType%" equ "WinPE" echo.####Starting Integrating Windows PE Updates####################################
if "%UpdateType%" equ "WUSatisfy" echo.####Starting Integrating Windows Update Satisfy Updates########################
if "%UpdateType%" equ "ADLDS" echo.####Starting Integrating Active Directory Lightweight Directory Services#######
if "%UpdateType%" equ "FMApi" echo.####Starting Integrating File Management API###################################
if "%UpdateType%" equ "Features" echo.####Starting Integrating Windows Features######################################
if "%UpdateType%" equ "VirtualPC" echo.####Starting Integrating Microsoft Virtual PC Feature##########################
if "%UpdateType%" equ "WorkFolders" echo.####Starting Integrating Sync Agent for Domain Environmernts ^(Work Folders^)####
echo.-------------------------------------------------------------------------------
echo.
if "%UpdateType%" neq "WinPE" (
	echo.    Image                    : Install.wim
	if /i "%ImageIndexNo%" equ "A" echo.    Image Indexes            : 1-%ImageCount%
	if /i "%ImageIndexNo%" neq "A" echo.    Image Index              : %ImageIndexNo%
) else (
	echo.    Image                    : Boot.wim         ^|  WinRE.wim
	if /i "%ImageIndexNo%" neq "A" echo.    Image Indexes            :    2             ^|    1
	if /i "%ImageIndexNo%" equ "A" echo.    Image Indexes            :    2             ^|    1
)
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
echo.
echo.-------------------------------------------------------------------------------
if "%UpdateType%" equ "WUpdates" echo.####Processing Windows Updates Packages########################################
if "%UpdateType%" equ "General" echo.####Processing WHD General Updates Packages####################################
if "%UpdateType%" equ "Hotfix" echo.####Processing WHD Hotfix Updates Packages#####################################
if "%UpdateType%" equ "Security" echo.####Processing WHD Security Updates Packages###################################
if "%UpdateType%" equ "NET35" echo.####Processing Microsoft .NET Framework 3.5 Updates Packages###################
if "%UpdateType%" equ "WAT" echo.####Processing Windows Activation Technologies ^(WAT^) Packages##################
if "%UpdateType%" equ "Windows10" echo.####Processing Windows 10 Upgrade Preparation Updates Packages#################
if "%UpdateType%" equ "WinPE" echo.####Processing Windows PE Updates Packages#####################################
if "%UpdateType%" equ "WUSatisfy" echo.####Processing Windows Update Satisfy Updates Packages#########################
if "%UpdateType%" equ "ADLDS" echo.####Processing Active Directory Lightweight Directory Services Packages########
if "%UpdateType%" equ "FMApi" echo.####Processing File Management API Packages####################################
if "%UpdateType%" equ "Features" echo.####Processing Windows Features Packages#######################################
if "%UpdateType%" equ "VirtualPC" echo.####Processing Microsoft Virtual PC Feature Packages###########################
if "%UpdateType%" equ "WorkFolders" echo.####Processing Sync Agent for Domain Environmernts ^(Work Folders^) Packages#####
echo.-------------------------------------------------------------------------------
echo.
:: Creating Windows/WHD Updates Temporary Folder
if "%UpdateType%" equ "WUpdates" echo.Creating Windows Updates Packages Temporary folder...
if "%UpdateType%" equ "General" echo.Creating WHD General Updates Packages Temporary folder...
if "%UpdateType%" equ "Hotfix" echo.Creating WHD Hotfix Updates Packages Temporary folder...
if "%UpdateType%" equ "Security" echo.Creating WHD Security Updates Packages Temporary folder...
if "%UpdateType%" equ "NET35" echo.Creating Microsoft .NET Framework 3.5 Updates Packages Temporary folder...
if "%UpdateType%" equ "WAT" echo.Creating Windows Activation Technologies Packages Temporary folder...
if "%UpdateType%" equ "Windows10" echo.Creating Windows 10 Upgrade Preparation Updates Packages Temporary folder...
if "%UpdateType%" equ "WinPE" echo.Creating Windows PE Updates Packages Temporary folder...
if "%UpdateType%" equ "WUSatisfy" echo.Creating Windows Update Satisfy Updates Packages Temporary folder...
if "%UpdateType%" equ "ADLDS" echo.Creating ADLDS Packages Temporary folder...
if "%UpdateType%" equ "FMApi" echo.Creating File Management API Packages Temporary folder...
if "%UpdateType%" equ "Features" echo.Creating Windows Features Packages Temporary folder...
if "%UpdateType%" equ "VirtualPC" echo.Creating Microsoft Virtual PC Feature Packages Temporary folder...
if "%UpdateType%" equ "WorkFolders" echo.Creating Sync Agent for Domain Environmernts Packages Temporary folder...
echo.

call :RemoveFolder "%Temp%\Updates"
call :CreateFolder "%Temp%\Updates"

if "%UpdateType%" equ "General" call :CreateFolder "%Temp%\Updates\%UpdateType%"
if "%UpdateType%" equ "Hotfix" call :CreateFolder "%Temp%\Updates\%UpdateType%"

if "%UpdateType%" equ "Security" (
	call :CreateFolder "%Temp%\Updates\%UpdateType%" >nul
	if "%SelectedSourceOS%" equ "w81" call :CreateFolder "%Temp%\Updates\%UpdateType%\ProWMC"
)

if "%UpdateType%" equ "NET35" call :CreateFolder "%Temp%\Updates\%UpdateType%"
if "%UpdateType%" equ "WAT" call :CreateFolder "%Temp%\Updates\%UpdateType%"
if "%UpdateType%" equ "Windows10" call :CreateFolder "%Temp%\Updates\%UpdateType%"
if "%UpdateType%" equ "WinPE" call :CreateFolder "%Temp%\Updates\%UpdateType%"
if "%UpdateType%" equ "WUSatisfy" call :CreateFolder "%Temp%\Updates\%UpdateType%\ProfessionalWMC"
if "%UpdateType%" equ "ADLDS" call :CreateFolder "%Temp%\Updates\%UpdateType%\Updates"
if "%UpdateType%" equ "FMApi" call :CreateFolder "%Temp%\Updates\%UpdateType%\Updates"
if "%UpdateType%" equ "Features" call :CreateFolder "%Temp%\Updates\%UpdateType%"

if "%UpdateType%" equ "VirtualPC" (
	if "%IsW7SP1CRUSelected%" equ "1" call :CreateFolder "%Temp%\Updates\%UpdateType%"
	if "%IsW7SP1CRUSelected%" equ "0" call :CreateFolder "%Temp%\Updates\%UpdateType%\Updates"
)

if "%UpdateType%" equ "WorkFolders" (
	if "%IsW7SP1CRUSelected%" equ "1" call :CreateFolder "%Temp%\Updates\%UpdateType%"
	if "%IsW7SP1CRUSelected%" equ "0" call :CreateFolder "%Temp%\Updates\%UpdateType%\Updates"
)

echo.Extracting .CAB Package files to Temporary folder...
echo.

:: Extracting/Copying Windows/WHD Updates .CAB files to Temporary Folder
if "%UpdateType%" equ "WUpdates" (
	if exist "%Updates%\*%ImageArchitecture%*.msu" expand "%Updates%\*.msu" -F:Win*.cab "%Temp%\Updates" >nul
	if exist "%Updates%\*%ImageArchitecture%*.cab" %XCopy% "%Updates%\*.cab" "%Temp%\Updates" >nul
)

if "%UpdateType%" equ "General" (
	if "%SelectedSourceOS%" equ "w7" if "%IsW7SP1CRUSelected%" equ "0" (
		if exist "%Updates%\Extra\WithoutKB3125574\#General\*%ImageArchitecture%*.msu" expand "%Updates%\Extra\WithoutKB3125574\#General\*.msu" -F:Win*.cab "%Temp%\Updates\%UpdateType%" >nul
		if exist "%Updates%\Extra\WithoutKB3125574\#General\*%ImageArchitecture%*.cab" %XCopy% "%Updates%\Extra\WithoutKB3125574\#General\*.cab" "%Temp%\Updates\%UpdateType%" >nul

		if exist "%Temp%\Updates\%UpdateType%\WUClient*.cab" (
			call :CreateFolder "%Temp%\Updates\%UpdateType%\WUClient"
			move /y "%Temp%\Updates\%UpdateType%\WUClient*.cab" "%Temp%\Updates\%UpdateType%\WUClient" >nul
		)
	)

	if "%SelectedSourceOS%" equ "w7" if "%IsW7SP1CRUSelected%" equ "1" (
		if exist "%Updates%\%UpdateType%\*%ImageArchitecture%*.msu" expand "%Updates%\%UpdateType%\*.msu" -F:Win*.cab "%Temp%\Updates\%UpdateType%" >nul
		if exist "%Updates%\%UpdateType%\*%ImageArchitecture%*.cab" %XCopy% "%Updates%\%UpdateType%\*.cab" "%Temp%\Updates\%UpdateType%" >nul

		call :CreateFolder "%Temp%\Updates\%UpdateType%\SP2"
		move /y "%Temp%\Updates\%UpdateType%\Windows6.1-KB4490628-%ImageArchitecture%.cab" "%Temp%\Updates\%UpdateType%\SP2" >nul
		move /y "%Temp%\Updates\%UpdateType%\Windows6.1-KB2670838-%ImageArchitecture%.cab" "%Temp%\Updates\%UpdateType%\SP2" >nul
		move /y "%Temp%\Updates\%UpdateType%\Windows6.1-KB3125574-v4-%ImageArchitecture%.cab" "%Temp%\Updates\%UpdateType%\SP2" >nul
		move /y "%Temp%\Updates\%UpdateType%\Windows6.1-KB3172605-%ImageArchitecture%.cab" "%Temp%\Updates\%UpdateType%\SP2" >nul

		call :CreateFolder "%Temp%\Updates\%UpdateType%\Client"
		if exist "%Temp%\Updates\%UpdateType%\Windows6.1-KB917607-%ImageArchitecture%.cab" del /f /q "%Temp%\Updates\%UpdateType%\Windows6.1-KB917607-%ImageArchitecture%.cab" >nul
	)

	if "%SelectedSourceOS%" equ "w81" (
		if exist "%Updates%\%UpdateType%\*%ImageArchitecture%*.msu" expand "%Updates%\%UpdateType%\*.msu" -F:Win*.cab "%Temp%\Updates\%UpdateType%" >nul
		if exist "%Updates%\%UpdateType%\*%ImageArchitecture%*.cab" %XCopy% "%Updates%\%UpdateType%\*.cab" "%Temp%\Updates\%UpdateType%" >nul

		if exist "%Temp%\Updates\%UpdateType%\Windows8.1-KB3140185-%ImageArchitecture%.cab" (
			call :CreateFolder "%Temp%\Updates\%UpdateType%\Upgrade"
			move /y "%Temp%\Updates\%UpdateType%\Windows8.1-KB3140185-%ImageArchitecture%.cab" "%Temp%\Updates\%UpdateType%\Upgrade" >nul
		)

		if exist "%Temp%\Updates\%UpdateType%\Windows8.1-KB917607-%ImageArchitecture%.cab" del /f /q "%Temp%\Updates\%UpdateType%\Windows8.1-KB917607-%ImageArchitecture%.cab" >nul
		if exist "%Temp%\Updates\%UpdateType%\Windows8.1-KB4486105-%ImageArchitecture%.cab" del /f /q "%Temp%\Updates\%UpdateType%\Windows8.1-KB4486105-%ImageArchitecture%.cab" >nul
	)
)

if "%UpdateType%" equ "Hotfix" (
	if "%SelectedSourceOS%" equ "w7" if "%IsW7SP1CRUSelected%" equ "0" (
		if exist "%Updates%\Extra\WithoutKB3125574\#Hotfix\*%ImageArchitecture%*.msu" expand "%Updates%\Extra\WithoutKB3125574\#Hotfix\*.msu" -F:Win*.cab "%Temp%\Updates\%UpdateType%" >nul
		if exist "%Updates%\Extra\WithoutKB3125574\#Hotfix\*%ImageArchitecture%*.cab" %XCopy% "%Updates%\Extra\WithoutKB3125574\#Hotfix\*.cab" "%Temp%\Updates\%UpdateType%" >nul

		if exist "%Temp%\Updates\%UpdateType%\Windows6.1-KB2780124-%ImageArchitecture%*.cab" (
			call :CreateFolder "%Temp%\Updates\%UpdateType%\Ent_Ultimate"
			move /y "%Temp%\Updates\%UpdateType%\Windows6.1-KB2780124-%ImageArchitecture%*.cab" "%Temp%\Updates\%UpdateType%\Ent_Ultimate" >nul
		)
	)

	if "%SelectedSourceOS%" equ "w7" if "%IsW7SP1CRUSelected%" equ "1" (
		if exist "%Updates%\%UpdateType%\*%ImageArchitecture%*.msu" expand "%Updates%\%UpdateType%\*.msu" -F:Win*.cab "%Temp%\Updates\%UpdateType%" >nul
		if exist "%Updates%\%UpdateType%\*%ImageArchitecture%*.cab" %XCopy% "%Updates%\%UpdateType%\*.cab" "%Temp%\Updates\%UpdateType%" >nul

		call :CreateFolder "%Temp%\Updates\%UpdateType%\Client"
		if exist "%Temp%\Updates\%UpdateType%\Windows6.1-KB2727994-v3-%ImageArchitecture%.cab" move /y "%Temp%\Updates\%UpdateType%\Windows6.1-KB2727994-v3-%ImageArchitecture%.cab" "%Temp%\Updates\%UpdateType%\Client" >nul
	)

	if "%SelectedSourceOS%" equ "w81" (
		if exist "%Updates%\%UpdateType%\*%ImageArchitecture%*.msu" expand "%Updates%\%UpdateType%\*.msu" -F:Win*.cab "%Temp%\Updates\%UpdateType%" >nul
		if exist "%Updates%\%UpdateType%\*%ImageArchitecture%*.cab" %XCopy% "%Updates%\%UpdateType%\*.cab" "%Temp%\Updates\%UpdateType%" >nul
	)
)

if "%UpdateType%" equ "Security" (
	if "%SelectedSourceOS%" equ "w7" if "%IsW7SP1CRUSelected%" equ "0" (
		if exist "%Updates%\Extra\WithoutKB3125574\#Security\*%ImageArchitecture%*.msu" expand "%Updates%\Extra\WithoutKB3125574\#Security\*.msu" -F:Win*.cab "%Temp%\Updates\%UpdateType%" >nul
		if exist "%Updates%\Extra\WithoutKB3125574\#Security\*%ImageArchitecture%*.cab" %XCopy% "%Updates%\Extra\WithoutKB3125574\#Security\*.cab" "%Temp%\Updates\%UpdateType%" >nul

		if exist "%Updates%\%UpdateType%\Windows6.1-KB4490628-%ImageArchitecture%*.msu" expand "%Updates%\%UpdateType%\Windows6.1-KB4490628-%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates\%UpdateType%" >nul
		if exist "%Updates%\%UpdateType%\Windows6.1-KB4490628-%ImageArchitecture%*.cab" %XCopy% "%Updates%\%UpdateType%\Windows6.1-KB4490628-%ImageArchitecture%*.cab" "%Temp%\Updates\%UpdateType%" >nul
	)

	if "%SelectedSourceOS%" equ "w7" if "%IsW7SP1CRUSelected%" equ "1" (
		if exist "%Updates%\%UpdateType%\WithoutESU\*%ImageArchitecture%*.msu" expand "%Updates%\%UpdateType%\WithoutESU\*.msu" -F:Win*.cab "%Temp%\Updates\%UpdateType%" >nul
		if exist "%Updates%\%UpdateType%\WithoutESU\*%ImageArchitecture%*.cab" %XCopy% "%Updates%\%UpdateType%\WithoutESU\*.cab" "%Temp%\Updates\%UpdateType%" >nul
		if exist "%Updates%\%UpdateType%\*%ImageArchitecture%*.msu" expand "%Updates%\%UpdateType%\*.msu" -F:Win*.cab "%Temp%\Updates\%UpdateType%" >nul
		if exist "%Updates%\%UpdateType%\*%ImageArchitecture%*.cab" %XCopy% "%Updates%\%UpdateType%\*.cab" "%Temp%\Updates\%UpdateType%" >nul
	)

	if "%SelectedSourceOS%" equ "w81" (
		if exist "%Updates%\%UpdateType%\*%ImageArchitecture%*.msu" expand "%Updates%\%UpdateType%\*.msu" -F:Win*.cab "%Temp%\Updates\%UpdateType%" >nul
		if exist "%Updates%\%UpdateType%\*%ImageArchitecture%*.cab" %XCopy% "%Updates%\%UpdateType%\*.cab" "%Temp%\Updates\%UpdateType%" >nul
		if exist "%Updates%\%UpdateType%\NET452\*%ImageArchitecture%*.msu" expand "%Updates%\%UpdateType%\NET452\*.msu" -F:Win*.cab "%Temp%\Updates\%UpdateType%" >nul
		if exist "%Updates%\%UpdateType%\NET452\*%ImageArchitecture%*.cab" %XCopy% "%Updates%\%UpdateType%\NET452\*.cab" "%Temp%\Updates\%UpdateType%" >nul
	)
)

if "%UpdateType%" equ "NET35" (
	if exist "%Updates%\Additional\NET35\*%ImageArchitecture%*.msu" expand "%Updates%\Additional\NET35\*.msu" -F:Win*.cab "%Temp%\Updates\%UpdateType%" >nul
	if exist "%Updates%\Additional\NET35\*%ImageArchitecture%*.cab" %XCopy% "%Updates%\Additional\NET35\*.cab" "%Temp%\Updates\%UpdateType%" >nul
)

if "%UpdateType%" equ "WAT" (
	if exist "%Updates%\Additional\WAT\*%ImageArchitecture%*.msu" expand "%Updates%\Additional\WAT\*.msu" -F:Win*.cab "%Temp%\Updates\%UpdateType%" >nul
	if exist "%Updates%\Additional\WAT\*%ImageArchitecture%*.cab" %XCopy% "%Updates%\Additional\WAT\*.cab" "%Temp%\Updates\%UpdateType%" >nul
)

if "%UpdateType%" equ "Windows10" (
	if exist "%Updates%\Additional\Windows10\*%ImageArchitecture%*.msu" expand "%Updates%\Additional\Windows10\*.msu" -F:Win*.cab "%Temp%\Updates\%UpdateType%" >nul
	if exist "%Updates%\Additional\Windows10\*%ImageArchitecture%*.cab" %XCopy% "%Updates%\Additional\Windows10\*.cab" "%Temp%\Updates\%UpdateType%" >nul

	if "%IsW7SP1CRUSelected%" equ "0" (
		if exist "%Updates%\Extra\WithoutKB3125574\_Windows10\*%ImageArchitecture%*.msu" expand "%Updates%\Extra\WithoutKB3125574\_Windows10\*.msu" -F:Win*.cab "%Temp%\Updates\%UpdateType%" >nul
		if exist "%Updates%\Extra\WithoutKB3125574\_Windows10\*%ImageArchitecture%*.cab" %XCopy% "%Updates%\Extra\WithoutKB3125574\_Windows10\*.cab" "%Temp%\Updates\%UpdateType%" >nul
	)
)

if "%UpdateType%" equ "WinPE" (
	if exist "%Updates%\Additional\WinPE\*%ImageArchitecture%*.msu" expand "%Updates%\Additional\WinPE\*.msu" -F:Win*.cab "%Temp%\Updates\%UpdateType%" >nul
	if exist "%Updates%\Additional\WinPE\*%ImageArchitecture%*.cab" %XCopy% "%Updates%\Additional\WinPE\*.cab" "%Temp%\Updates\%UpdateType%" >nul

	if exist "%Updates%\General\Windows8.1-KB3084905*%ImageArchitecture%*.msu" expand "%Updates%\General\Windows8.1-KB3084905*%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates\%UpdateType%" >nul
	if exist "%Updates%\General\Windows8.1-KB3084905*%ImageArchitecture%*.cab" %XCopy% "%Updates%\General\Windows8.1-KB3084905*%ImageArchitecture%*.cab" "%Temp%\Updates\%UpdateType%" >nul
	if exist "%Updates%\General\Windows8.1-KB3115224*%ImageArchitecture%*.msu" expand "%Updates%\General\Windows8.1-KB3115224*%ImageArchitecture%*.msu" -F:Win*.cab "%Temp%\Updates\%UpdateType%" >nul
	if exist "%Updates%\General\Windows8.1-KB3115224*%ImageArchitecture%*.cab" %XCopy% "%Updates%\General\Windows8.1-KB3115224*%ImageArchitecture%*.cab" "%Temp%\Updates\%UpdateType%" >nul
)

if "%UpdateType%" equ "WUSatisfy" (
	if exist "%Updates%\Additional\WU.Satisfy\*%ImageArchitecture%*.msu" expand "%Updates%\Additional\WU.Satisfy\*.msu" -F:Win*.cab "%Temp%\Updates\%UpdateType%" >nul
	if exist "%Updates%\Additional\WU.Satisfy\*%ImageArchitecture%*.cab" %XCopy% "%Updates%\Additional\WU.Satisfy\*.cab" "%Temp%\Updates\%UpdateType%" >nul
	if exist "%Updates%\Additional\WU.Satisfy\ProfessionalWMC\*%ImageArchitecture%*.msu" expand "%Updates%\Additional\WU.Satisfy\ProfessionalWMC\*.msu" -F:Win*.cab "%Temp%\Updates\%UpdateType%\ProfessionalWMC" >nul
	if exist "%Updates%\Additional\WU.Satisfy\ProfessionalWMC\*%ImageArchitecture%*.cab" %XCopy% "%Updates%\Additional\WU.Satisfy\ProfessionalWMC\*.cab" "%Temp%\Updates\%UpdateType%\ProfessionalWMC" >nul
)

if "%UpdateType%" equ "ADLDS" (
	if exist "%Updates%\Extra\AD_LDS\*%ImageArchitecture%*.msu" expand "%Updates%\Extra\AD_LDS\*.msu" -F:Win*.cab "%Temp%\Updates\%UpdateType%" >nul
	if exist "%Updates%\Extra\AD_LDS\*%ImageArchitecture%*.cab" %XCopy% "%Updates%\Extra\AD_LDS\*.cab" "%Temp%\Updates\%UpdateType%" >nul

	if exist "%Updates%\Extra\AD_LDS\Updates\*%ImageArchitecture%*.msu" expand "%Updates%\Extra\AD_LDS\Updates\*.msu" -F:Win*.cab "%Temp%\Updates\%UpdateType%\Updates" >nul
	if exist "%Updates%\Extra\AD_LDS\Updates\*%ImageArchitecture%*.cab" %XCopy% "%Updates%\Extra\AD_LDS\Updates\*.cab" "%Temp%\Updates\%UpdateType%\Updates" >nul

	if "%IsW7SP1CRUSelected%" equ "0" (
		if exist "%Updates%\Extra\WithoutKB3125574\AD_LDS\*%ImageArchitecture%*.msu" expand "%Updates%\Extra\WithoutKB3125574\AD_LDS\*.msu" -F:Win*.cab "%Temp%\Updates\%UpdateType%\Updates" >nul
		if exist "%Updates%\Extra\WithoutKB3125574\AD_LDS\*%ImageArchitecture%*.cab" %XCopy% "%Updates%\Extra\WithoutKB3125574\AD_LDS\*.cab" "%Temp%\Updates\%UpdateType%\Updates" >nul
	)
)

if "%UpdateType%" equ "FMApi" (
	if exist "%Updates%\Extra\Addons\FM.Api\*%ImageArchitecture%*.msu" expand "%Updates%\Extra\Addons\FM.Api\*.msu" -F:Win*.cab "%Temp%\Updates\%UpdateType%" >nul
	if exist "%Updates%\Extra\Addons\FM.Api\*%ImageArchitecture%*.cab" %XCopy% "%Updates%\Extra\Addons\FM.Api\*.cab" "%Temp%\Updates\%UpdateType%" >nul
)

if "%UpdateType%" equ "Features" (
	if exist "%Updates%\Extra\WithoutKB3125574\_Features\*%ImageArchitecture%*.msu" expand "%Updates%\Extra\WithoutKB3125574\_Features\*.msu" -F:Win*.cab "%Temp%\Updates\%UpdateType%" >nul
	if exist "%Updates%\Extra\WithoutKB3125574\_Features\*%ImageArchitecture%*.cab" %XCopy% "%Updates%\Extra\WithoutKB3125574\_Features\*.cab" "%Temp%\Updates\%UpdateType%" >nul
)

if "%UpdateType%" equ "VirtualPC" (
	if exist "%Updates%\Extra\VirtualPC\*%ImageArchitecture%*.msu" expand "%Updates%\Extra\VirtualPC\*.msu" -F:Win*.cab "%Temp%\Updates\%UpdateType%" >nul
	if exist "%Updates%\Extra\VirtualPC\*%ImageArchitecture%*.cab" %XCopy% "%Updates%\Extra\VirtualPC\*.cab" "%Temp%\Updates\%UpdateType%" >nul

	if "%IsW7SP1CRUSelected%" equ "0" (
		if exist "%Updates%\Extra\WithoutKB3125574\VirtualPC\*%ImageArchitecture%*.msu" expand "%Updates%\Extra\WithoutKB3125574\VirtualPC\*.msu" -F:Win*.cab "%Temp%\Updates\%UpdateType%\Updates" >nul
		if exist "%Updates%\Extra\WithoutKB3125574\VirtualPC\*%ImageArchitecture%*.cab" %XCopy% "%Updates%\Extra\WithoutKB3125574\VirtualPC\*.cab" "%Temp%\Updates\%UpdateType%\Updates" >nul
	)
)

if "%UpdateType%" equ "WorkFolders" (
	if exist "%Updates%\Extra\Addons\WorkFolders\*%ImageArchitecture%*.msu" expand "%Updates%\Extra\Addons\WorkFolders\*.msu" -F:Win*.cab "%Temp%\Updates\%UpdateType%" >nul
	if exist "%Updates%\Extra\Addons\WorkFolders\*%ImageArchitecture%*.cab" %XCopy% "%Updates%\Extra\Addons\WorkFolders\*.cab" "%Temp%\Updates\%UpdateType%" >nul

	if "%IsW7SP1CRUSelected%" equ "0" (
		if exist "%Updates%\Extra\WithoutKB3125574\WorkFolders\*%ImageArchitecture%*.msu" expand "%Updates%\Extra\WithoutKB3125574\WorkFolders\*.msu" -F:Win*.cab "%Temp%\Updates\%UpdateType%\Updates" >nul
		if exist "%Updates%\Extra\WithoutKB3125574\WorkFolders\*%ImageArchitecture%*.cab" %XCopy% "%Updates%\Extra\WithoutKB3125574\WorkFolders\*.cab" "%Temp%\Updates\%UpdateType%\Updates" >nul
	)
)

echo.Finished Extracting .CAB Package files to Temporary folder...
echo.
echo.-------------------------------------------------------------------------------
:: Integrating Windows/WHD Updates Packages to WIM Image
if "%UpdateType%" equ "WUpdates" echo.####Integrating Windows Updates################################################
if "%UpdateType%" equ "General" echo.####Integrating WHD General Updates############################################
if "%UpdateType%" equ "Hotfix" echo.####Integrating WHD Hotfix Updates#############################################
if "%UpdateType%" equ "Security" echo.####Integrating WHD Security Updates###########################################
if "%UpdateType%" equ "NET35" echo.####Integrating Microsoft .NET Framework 3.5 Updates###########################
if "%UpdateType%" equ "WAT" echo.####Integrating Windows Activation Technologies ^(WAT^) #########################
if "%UpdateType%" equ "Windows10" echo.####Integrating Windows 10 Upgrade Preparation Updates#########################
if "%UpdateType%" equ "WinPE" echo.####Integrating Windows PE Updates#############################################
if "%UpdateType%" equ "WUSatisfy" echo.####Integrating Windows Update Satisfy Updates#################################
if "%UpdateType%" equ "ADLDS" echo.####Integrating Active Directory Lightweight Directory Services Feature########
if "%UpdateType%" equ "FMApi" echo.####Integrating File Management API Feature####################################
if "%UpdateType%" equ "Features" echo.####Integrating Windows Features Updates#######################################
if "%UpdateType%" equ "VirtualPC" echo.####Integrating Microsoft Virtual PC Feature###################################
if "%UpdateType%" equ "WorkFolders" echo.####Integrating Sync Agent for Domain Environmernts ^(Work Folders^)#############
echo.-------------------------------------------------------------------------------

for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" (
		echo.
		if not %%i gtr 9 echo.===========================[Install.wim, Index : %%i]============================
		if %%i gtr 9 echo.==========================[Install.wim, Index : %%i]============================

		if "%UpdateType%" equ "WUpdates" call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates"

		if "%UpdateType%" equ "General" (
			call :GetImageEdition "%InstallWim%", %%i

			if "%SelectedSourceOS%" equ "w7" if "%IsW7SP1CRUSelected%" equ "0" (
				call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\%UpdateType%"

				if exist "%Temp%\Updates\%UpdateType%\WUClient\WUClient*.cab" (
					echo.-------------------------------------------------------------------------------
					echo.Integrating Windows 7 - Windows Update Client Updates Packages...
					echo.-------------------------------------------------------------------------------
					call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\%UpdateType%\WUClient\WUClient-SelfUpdate-Core-%ImageArchitecture%-7.6.7600.320.cab"
					echo.-------------------------------------------------------------------------------
					call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\%UpdateType%\WUClient\WUClient-SelfUpdate-Aux-%ImageArchitecture%-7.6.7600.320.cab"
					echo.-------------------------------------------------------------------------------
					call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\%UpdateType%\WUClient\WUClient-SelfUpdate-ActiveX-%ImageArchitecture%-7.6.7600.320.cab"
				)
			)

			if "%SelectedSourceOS%" equ "w7" if "%IsW7SP1CRUSelected%" equ "1" (
				echo.
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows 7 SP1 Convenience Rollup Prerequisite Update Package...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\%UpdateType%\SP2\Windows6.1-KB4490628-%ImageArchitecture%.cab"
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows 7 SP1 Convenience Rollup Platform Update Package...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\%UpdateType%\SP2\Windows6.1-KB2670838-%ImageArchitecture%.cab"
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows 7 SP1 Convenience Rollup Update Package...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\%UpdateType%\SP2\Windows6.1-KB3125574-v4-%ImageArchitecture%.cab"
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows 7 SP1 July 2016 Rollup Update Package...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\%UpdateType%\SP2\Windows6.1-KB3172605-%ImageArchitecture%.cab"
				echo.-------------------------------------------------------------------------------
				echo.Integrating WHD General Updates Packages...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\%UpdateType%"

				if "%ImageInstallationType%" neq "Embedded" if exist "%Temp%\Updates\%UpdateType%\Client\*.cab" (
					echo.-------------------------------------------------------------------------------
					echo.Integrating Windows 7 Client Updates Packages...
					echo.-------------------------------------------------------------------------------
					call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\%UpdateType%\Client"
				)
			)

			if "%SelectedSourceOS%" equ "w81" (
				call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\%UpdateType%"

				if exist "%Temp%\Updates\%UpdateType%\Upgrade\*.cab" (
					if "%ImageEdition%" equ "Core" (
						echo.-------------------------------------------------------------------------------
						echo.Integrating Windows 8.1 Upgradeable Editions Updates Packages...
						echo.-------------------------------------------------------------------------------
						call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\%UpdateType%\Upgrade"
					)

					if "%ImageEdition%" equ "CoreSingleLanguage" (
						echo.-------------------------------------------------------------------------------
						echo.Integrating Windows 8.1 Upgradeable Editions Updates Packages...
						echo.-------------------------------------------------------------------------------
						call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\%UpdateType%\Upgrade"
					)

					if "%ImageEdition%" equ "CoreCountrySpecific" (
						echo.-------------------------------------------------------------------------------
						echo.Integrating Windows 8.1 Upgradeable Editions Updates Packages...
						echo.-------------------------------------------------------------------------------
						call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\%UpdateType%\Upgrade"
					)

					if "%ImageEdition%" equ "Professional" if not exist "%InstallMount%\%%i\Windows\Servicing\Packages\Microsoft-Windows-Security-SPP-Component-SKU-Professional-GVLK-Package*.mum" (
						echo.-------------------------------------------------------------------------------
						echo.Integrating Windows 8.1 Upgradeable Editions Updates Packages...
						echo.-------------------------------------------------------------------------------
						call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\%UpdateType%\Upgrade"
					)
				)
			)
		)

		if "%UpdateType%" equ "Hotfix" (
			call :GetImageEdition "%InstallWim%", %%i

			call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\%UpdateType%"

			if "%SelectedSourceOS%" equ "w7" if "%IsW7SP1CRUSelected%" equ "0" if exist "%Temp%\Updates\%UpdateType%\Ent_Ultimate\*.cab" (
				if "%ImageEdition%" equ "Enterprise" (
					echo.-------------------------------------------------------------------------------
					echo.Integrating Windows 7 Enterprise Edition Updates Packages...
					echo.-------------------------------------------------------------------------------
					call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\%UpdateType%\Ent_Ultimate"
				)

				if "%ImageEdition%" equ "Ultimate"  (
					echo.-------------------------------------------------------------------------------
					echo.Integrating Windows 7 Ultimate Edition Updates Packages...
					echo.-------------------------------------------------------------------------------
					call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\%UpdateType%\Ent_Ultimate"
				)
			)

			if "%SelectedSourceOS%" equ "w7" if "%IsW7SP1CRUSelected%" equ "1" if "%ImageInstallationType%" neq "Embedded" if exist "%Temp%\Updates\%UpdateType%\Client\*.cab" (
				echo.-------------------------------------------------------------------------------
				echo.Integrating Windows 7 Client Updates Packages...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\%UpdateType%\Client"
			)
		)

		if "%UpdateType%" equ "Security" (
			call :GetImageEdition "%InstallWim%", %%i >nul
			call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\%UpdateType%"

			:: Applying Anti Microsoft Telemetry Client Patches
			call :MountImageRegistry "%InstallMount%\%%i"
			Reg add "HKLM\TK_SYSTEM\ControlSet001\Services\DiagTrack" /v "Start" /t REG_DWORD /d "4" /f >nul
			Reg delete "HKLM\TK_SYSTEM\ControlSet001\Control\WMI\AutoLogger\AutoLogger-Diagtrack-Listener" /f >nul 2>&1
			Reg delete "HKLM\TK_SYSTEM\ControlSet001\Control\WMI\AutoLogger\SQMLogger" /f >nul 2>&1
			Reg delete "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Diagnostics\DiagTrack" /f >nul 2>&1
			call :UnMountImageRegistry
		)

		if "%UpdateType%" equ "NET35" call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\%UpdateType%"
		if "%UpdateType%" equ "WAT" call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\%UpdateType%"
		if "%UpdateType%" equ "Windows10" call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\%UpdateType%"

		if "%UpdateType%" equ "WinPE" (
			if "%IsBootImageSelected%" equ "Yes" (
				echo.-------------------------------------------------------------------------------
				echo.             Integrating Windows PE Updates to Boot.wim Image...
				echo.---------------------------------[Index : 2]-----------------------------------
				call :AddPackage "%BootMount%\2", "%Temp%\Updates\%UpdateType%"
			)

			if "%IsRecoveryImageSelected%" equ "Yes" (
				echo.-------------------------------------------------------------------------------
				echo.             Integrating Windows PE Updates to WinRE.wim Image...
				echo.---------------------------------[Index : 1]-----------------------------------
				call :AddPackage "%WinReMount%\%%i", "%Temp%\Updates\%UpdateType%"
			)
		)

		if "%UpdateType%" equ "WUSatisfy" (
			call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\%UpdateType%"

			if exist "%Temp%\Updates\%UpdateType%\ProfessionalWMC\*.cab" (
				call :GetImageEdition "%InstallWim%", %%i >nul

				if "%ImageEdition%" equ "ProfessionalWMC" (
					echo.-------------------------------------------------------------------------------
					echo.Integrating Windows 8.1 Pro WMC Edition - Windows Update Satisfy Updates...
					echo.-------------------------------------------------------------------------------
					call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\%UpdateType%\ProfessionalWMC"
				)
			)
		)

		if "%UpdateType%" equ "ADLDS" (
			call :GetImageEdition "%InstallWim%", %%i

			for /d %%j in (Professional, Enterprise, Ultimate) do (
				if "%ImageEdition%" equ "%%j" (
					call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\%UpdateType%"

					echo.-------------------------------------------------------------------------------
					echo.Integrating Active Directory Lightweight Directory Services Updates Packages...
					echo.-------------------------------------------------------------------------------
					call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\%UpdateType%\Updates"
				)
			)
		)

		if "%UpdateType%" equ "FMApi" call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\%UpdateType%"
		if "%UpdateType%" equ "Features" call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\%UpdateType%"

		if "%UpdateType%" equ "VirtualPC" (
			call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\%UpdateType%"

			if "%IsW7SP1CRUSelected%" equ "0"  if exist "%Temp%\Updates\%UpdateType%\Updates\*.cab" (
				echo.-------------------------------------------------------------------------------
				echo.Integrating Microsoft Virtual PC Feature Updates...
				echo.-------------------------------------------------------------------------------
				call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\%UpdateType%\Updates"
			)
		)

		if "%UpdateType%" equ "WorkFolders" (
			call :GetImageEdition "%InstallWim%", %%i

			for /d %%j in (Professional, Enterprise, Ultimate) do (
				if "%ImageEdition%" equ "%%j" (
					call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\%UpdateType%"

					if "%IsW7SP1CRUSelected%" equ "0" if exist "%Temp%\Updates\%UpdateType%\Updates\*.cab" (
						echo.-------------------------------------------------------------------------------
						echo.Integrating Microsoft Work Folders Feature Updates...
						echo.-------------------------------------------------------------------------------
						call :AddPackage "%InstallMount%\%%i", "%Temp%\Updates\%UpdateType%\Updates"
					)
				)
			)
		)
	)
)

if "%IsLogsEnabled%" equ "Yes" (
	echo.-------------------------------------------------------------------------------
	if "%UpdateType%" equ "WUpdates" echo.Generating Windows Updates Integration LOG File...
	if "%UpdateType%" equ "General" echo.Generating WHD General Updates Integration LOG File...
	if "%UpdateType%" equ "Hotfix" echo.Generating WHD Hotfix Updates Integration LOG File...
	if "%UpdateType%" equ "Security" echo.Generating WHD Security Updates Integration LOG File...
	if "%UpdateType%" equ "NET35" echo.Generating Microsoft .NET Framework 3.5 Updates Integration LOG File...
	if "%UpdateType%" equ "WAT" echo.Generating Windows Activation Technologies Integration ^(WAT^) LOG File...
	if "%UpdateType%" equ "Windows10" echo.Generating Windows 10 Upgrade Preparation Updates Integration LOG File...
	if "%UpdateType%" equ "WinPE" echo.Generating Windows PE Updates Integration LOG File...
	if "%UpdateType%" equ "WUSatisfy" echo.Generating Windows Update Satisfy Updates Integration LOG File...
	if "%UpdateType%" equ "ADLDS" echo.Generating Active Directory Lightweight Directory Services Integration LOG File...
	if "%UpdateType%" equ "FMApi" echo.Generating File Management API Integration LOG File...
	if "%UpdateType%" equ "Features" echo.Generating Windows Features Packages Integration LOG File...
	if "%UpdateType%" equ "VirtualPC" echo.Generating Microsoft Virtual PC Feature Integration LOG File...
	if "%UpdateType%" equ "WorkFolders" echo.Generating Work Folders Integration LOG File...
	echo.-------------------------------------------------------------------------------
	echo.
	if "%UpdateType%" equ "WUpdates" echo.Writing Windows Updates Integration Log file.
	if "%UpdateType%" equ "General" echo.Writing WHD General Updates Integration Log file.
	if "%UpdateType%" equ "Hotfix" echo.Writing WHD Hotfix Updates Integration Log file.
	if "%UpdateType%" equ "Security" echo.Writing WHD Security Updates Integration Log file.
	if "%UpdateType%" equ "NET35" echo.Writing Microsoft .NET Framework 3.5 Updates Integration Log file.
	if "%UpdateType%" equ "WAT" echo.Writing Windows Activation Technologies Integration Log file.
	if "%UpdateType%" equ "Windows10" echo.Writing Windows 10 Upgrade Preparation Updates Integration Log file.
	if "%UpdateType%" equ "WinPE" echo.Writing Windows PE Updates Integration Log file.
	if "%UpdateType%" equ "WUSatisfy" echo.Writing Windows Update Satisfy Updates Integration Log file.
	if "%UpdateType%" equ "ADLDS" echo.Writing Active Directory Lightweight Directory Services Integration Log file.
	if "%UpdateType%" equ "FMApi" echo.Writing File Management API Integration Log file.
	if "%UpdateType%" equ "Features" echo.Writing Windows Features Packages Integration Log file.
	if "%UpdateType%" equ "VirtualPC" echo.Writing Microsoft Virtual PC Feature Integration Log file.
	if "%UpdateType%" equ "WorkFolders" echo.Writing Work Folders Integration Log file.

	for /l %%i in (1, 1, %ImageCount%) do (
		if exist "%InstallMount%\%%i" call :GetPackages "%InstallMount%\%%i", "Updates-%%i.txt"
	)
)

echo.
echo.-------------------------------------------------------------------------------
echo.Cleaning Up Temporary Files ^& Folders...
echo.-------------------------------------------------------------------------------
echo.
:: Cleaning Up Windows/WHD Updates Temporary folder...
if "%UpdateType%" equ "WUpdates" echo.Cleaning Up Windows Updates Temporary folder.
if "%UpdateType%" equ "General" echo.Cleaning Up WHD General Updates Temporary folder.
if "%UpdateType%" equ "Hotfix" echo.Cleaning Up WHD Hotfix Updates Temporary folder.
if "%UpdateType%" equ "Security" echo.Cleaning Up WHD Security Updates Temporary folder.
if "%UpdateType%" equ "NET35" echo.Cleaning Up Microsoft .NET Framework 3.5 Updates Temporary folder.
if "%UpdateType%" equ "WAT" echo.Cleaning Up Windows Activation Technologies Temporary folder.
if "%UpdateType%" equ "Windows10" echo.Cleaning Up Windows 10 Upgrade Preparation Updates Temporary folder.
if "%UpdateType%" equ "WinPE" echo.Cleaning Up Windows PE Updates Temporary folder.
if "%UpdateType%" equ "WUSatisfy" echo.Cleaning Up Windows Update Satisfy Updates Temporary folder.
if "%UpdateType%" equ "ADLDS" echo.Cleaning Up Active Directory Lightweight Directory Services Temporary folder.
if "%UpdateType%" equ "FMApi" echo.Cleaning Up File Management API Temporary folder.
if "%UpdateType%" equ "Features" echo.Cleaning Up Windows Features Updates Temporary folder.
if "%UpdateType%" equ "VirtualPC" echo.Cleaning Up Microsoft Virtual PC Feature Temporary folder.
if "%UpdateType%" equ "WorkFolders" echo.Cleaning Up Sync Agent for Domain Environmernts Temporary folder.

call :RemoveFolder "%Temp%\Updates"
echo.
echo.-------------------------------------------------------------------------------
if "%UpdateType%" equ "WUpdates" echo.####Finished Integrating Windows Updates#######################################
if "%UpdateType%" equ "General" echo.####Finished Integrating WHD General Updates###################################
if "%UpdateType%" equ "Hotfix" echo.####Finished Integrating WHD Hotfix Updates####################################
if "%UpdateType%" equ "Security" echo.####Finished Integrating WHD Security Updates##################################
if "%UpdateType%" equ "NET35" echo.####Finished Integrating Microsoft .NET Framework 3.5 Updates##################
if "%UpdateType%" equ "WAT" echo.####Finished Integrating Windows Activation Technologies ^(WAT^) ################
if "%UpdateType%" equ "Windows10" echo.####Finished Windows 10 Upgrade Preparation Updates############################
if "%UpdateType%" equ "WinPE" echo.####Finished Integrating Windows PE Updates####################################
if "%UpdateType%" equ "WUSatisfy" echo.####Finished Integrating Windows Update Satisfy Updates########################
if "%UpdateType%" equ "ADLDS" echo.####Finished Integrating Active Directory Lightweight Directory Service Feature
if "%UpdateType%" equ "FMApi" echo.####Finished Integrating File Management API Feature###########################
if "%UpdateType%" equ "Features" echo.####Finished Integrating Windows Features Updates##############################
if "%UpdateType%" equ "VirtualPC" echo.####Finished Integrating Microsoft Virtual PC Feature##########################
if "%UpdateType%" equ "WorkFolders" echo.####Finished Integrating Sync Agent for Domain Environmernts ^(Work Folders^)####
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set Updates=
set UpdateType=
set IsW7SP1CRUSelected=

endlocal

:: Reading Updated Image Information
if "%SelectedSourceOS%" equ "w10" (
	for /l %%i in (1, 1, %ImageCount%) do (
		if exist "%InstallMount%\%%i" (
			call :MountImageRegistry "%InstallMount%\%%i"
			for /f "tokens=3 delims= " %%x in ('reg query "HKLM\TK_SOFTWARE\Microsoft\Windows NT\CurrentVersion" /v "CurrentBuild" ^| find "REG_SZ"') do (set /a ImageBuild=%%x)
			set "ImageVersion=10.0.!ImageBuild!"
			for /f "tokens=3 delims= " %%y in ('reg query "HKLM\TK_SOFTWARE\Microsoft\Windows NT\CurrentVersion" /v "UBR" ^| find "REG_DWORD"') do (set /a ImageServicePackBuild=%%y)
			call :UnMountImageRegistry
		)
	)
)

:: Returning to Integrate Menu
goto :IntegrateMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Integrate Windows Setup Media Updates
::-------------------------------------------------------------------------------------------
:IntWindowsSetupMediaUpdates

setlocal

cls
echo.===============================================================================
echo.                  MSMG ToolKit - Update Windows Setup Media
echo.===============================================================================
echo.

If /i "%ImageIndexNo%" equ "A" (
	echo.This feature doens't work when multiple indexes are selected...
	pause
	goto :IntegrateMenu
)

echo.-------------------------------------------------------------------------------
echo.####Starting Updating Windows Setup Media######################################
echo.-------------------------------------------------------------------------------
echo.
echo.Getting Windows Setup Media Language Settings...
echo.
for /f "tokens=* delims=" %%a in ('%DISM% /Get-WimInfo /WimFile:%BootWim% /Index:1 ^| findstr /i Default') do ( set ImageDefaultLanguage=%%a )
set ImageDefaultLanguage=%ImageDefaultLanguage:~1,-11%
echo.Found Windows Setup Media Language : [%ImageDefaultLanguage%]
echo.
echo.Copying Windows Setup Media Update files to ^<DVD^> folder...

:: Creating Directory Structures
call :CreateFolder "%DVD%"
call :CreateFolder "%DVD%\boot"
call :CreateFolder "%DVD%\efi"
call :CreateFolder "%DVD%\sources"
call :CreateFolder "%DVD%\boot\%ImageDefaultLanguage%"
call :CreateFolder "%DVD%\boot\fonts"
call :CreateFolder "%DVD%\boot\resources"
call :CreateFolder "%DVD%\efi\boot"
call :CreateFolder "%DVD%\efi\microsoft"
call :CreateFolder "%DVD%\efi\microsoft\boot"
call :CreateFolder "%DVD%\efi\microsoft\boot\fonts"
call :CreateFolder "%DVD%\efi\microsoft\boot\resources"
call :CreateFolder "%DVD%\sources\%ImageDefaultLanguage%"
call :CreateFolder "%DVD%\sources\inf"

Copy /Y "%BootMount%\2\Windows\Boot\PCAT\bootmgr" "%DVD%\bootmgr" >nul
Copy /Y "%BootMount%\2\Windows\Boot\EFI\bootmgr.efi" "%DVD%\bootmgr.efi" >nul
Copy /Y "%BootMount%\2\setup.exe" "%DVD%\setup.exe" >nul
Copy /Y "%BootMount%\2\Windows\Boot\DVD\PCAT\bcd" "%DVD%\boot\bcd" >nul
Copy /Y "%BootMount%\2\Windows\Boot\DVD\PCAT\boot.sdi" "%DVD%\boot\boot.sdi" >nul
Copy /Y "%BootMount%\2\Windows\Boot\DVD\PCAT\%ImageDefaultLanguage%\bootfix.bin" "%DVD%\boot\bootfix.bin" >nul
Copy /Y "%BootMount%\2\Windows\System32\bootsect.exe" "%DVD%\boot\bootsect.exe" >nul
Copy /Y "%BootMount%\2\Windows\Boot\DVD\PCAT\etfsboot.com" "%DVD%\boot\etfsboot.com" >nul
Copy /Y "%BootMount%\2\Windows\Boot\PCAT\memtest.exe" "%DVD%\boot\memtest.exe" >nul
Copy /Y "%BootMount%\2\Windows\System32\%ImageDefaultLanguage%\bootsect.exe.mui" "%DVD%\boot\%ImageDefaultLanguage%\bootsect.exe.mui" >nul
Copy /Y "%InstallMount%\%ImageIndexNo%\Windows\Boot\Fonts\chs_boot.ttf" "%DVD%\boot\fonts\chs_boot.ttf" >nul
Copy /Y "%InstallMount%\%ImageIndexNo%\Windows\Boot\Fonts\cht_boot.ttf" "%DVD%\boot\fonts\cht_boot.ttf" >nul
Copy /Y "%InstallMount%\%ImageIndexNo%\Windows\Boot\Fonts\jpn_boot.ttf" "%DVD%\boot\fonts\jpn_boot.ttf" >nul
Copy /Y "%InstallMount%\%ImageIndexNo%\Windows\Boot\Fonts\kor_boot.ttf" "%DVD%\boot\fonts\kor_boot.ttf" >nul
Copy /Y "%InstallMount%\%ImageIndexNo%\Windows\Boot\Fonts\malgunn_boot.ttf" "%DVD%\boot\fonts\malgunn_boot.ttf" >nul
Copy /Y "%InstallMount%\%ImageIndexNo%\Windows\Boot\Fonts\malgun_boot.ttf" "%DVD%\boot\fonts\malgun_boot.ttf" >nul
Copy /Y "%InstallMount%\%ImageIndexNo%\Windows\Boot\Fonts\meiryon_boot.ttf" "%DVD%\boot\fonts\meiryon_boot.ttf" >nul
Copy /Y "%InstallMount%\%ImageIndexNo%\Windows\Boot\Fonts\meiryo_boot.ttf" "%DVD%\boot\fonts\meiryo_boot.ttf" >nul
Copy /Y "%InstallMount%\%ImageIndexNo%\Windows\Boot\Fonts\msjhn_boot.ttf" "%DVD%\boot\fonts\msjhn_boot.ttf" >nul
Copy /Y "%InstallMount%\%ImageIndexNo%\Windows\Boot\Fonts\msjh_boot.ttf" "%DVD%\boot\fonts\msjh_boot.ttf" >nul
Copy /Y "%InstallMount%\%ImageIndexNo%\Windows\Boot\Fonts\msyhn_boot.ttf" "%DVD%\boot\fonts\msyhn_boot.ttf" >nul
Copy /Y "%InstallMount%\%ImageIndexNo%\Windows\Boot\Fonts\msyh_boot.ttf" "%DVD%\boot\fonts\msyh_boot.ttf" >nul
Copy /Y "%InstallMount%\%ImageIndexNo%\Windows\Boot\Fonts\segmono_boot.ttf" "%DVD%\boot\fonts\segmono_boot.ttf" >nul
Copy /Y "%InstallMount%\%ImageIndexNo%\Windows\Boot\Fonts\segoen_slboot.ttf" "%DVD%\boot\fonts\segoen_slboot.ttf" >nul
Copy /Y "%InstallMount%\%ImageIndexNo%\Windows\Boot\Fonts\segoe_slboot.ttf" "%DVD%\boot\fonts\segoe_slboot.ttf" >nul
Copy /Y "%InstallMount%\%ImageIndexNo%\Windows\Boot\Fonts\wgl4_boot.ttf" "%DVD%\boot\fonts\wgl4_boot.ttf" >nul
Copy /Y "%BootMount%\2\Windows\Boot\Resources\bootres.dll" "%DVD%\boot\resources\bootres.dll" >nul
rem "%DVD%\efi\boot\bootia32.efi" >nul
rem "%DVD%\efi\microsoft\boot\cdboot.efi" >nul
rem "%DVD%\efi\microsoft\boot\cdboot_noprompt.efi" >nul
Copy /Y "%BootMount%\2\Windows\Boot\DVD\EFI\%ImageDefaultLanguage%\efisys.bin" "%DVD%\efi\microsoft\boot\efisys.bin" >nul
Copy /Y "%BootMount%\2\Windows\Boot\DVD\EFI\%ImageDefaultLanguage%\efisys_noprompt.bin" "%DVD%\efi\microsoft\boot\efisys_noprompt.bin" >nul
Copy /Y "%BootMount%\2\Windows\Boot\EFI\memtest.efi" "%DVD%\efi\microsoft\boot\memtest.efi" >nul
Copy /Y "%InstallMount%\%ImageIndexNo%\Windows\Boot\Fonts\chs_boot.ttf" "%DVD%\efi\microsoft\boot\fonts\chs_boot.ttf" >nul
Copy /Y "%InstallMount%\%ImageIndexNo%\Windows\Boot\Fonts\cht_boot.ttf" "%DVD%\efi\microsoft\boot\fonts\cht_boot.ttf" >nul
Copy /Y "%InstallMount%\%ImageIndexNo%\Windows\Boot\Fonts\jpn_boot.ttf" "%DVD%\efi\microsoft\boot\fonts\jpn_boot.ttf" >nul
Copy /Y "%InstallMount%\%ImageIndexNo%\Windows\Boot\Fonts\kor_boot.ttf" "%DVD%\efi\microsoft\boot\fonts\kor_boot.ttf" >nul
Copy /Y "%InstallMount%\%ImageIndexNo%\Windows\Boot\Fonts\malgunn_boot.ttf" "%DVD%\efi\microsoft\boot\fonts\malgunn_boot.ttf" >nul
Copy /Y "%InstallMount%\%ImageIndexNo%\Windows\Boot\Fonts\malgun_boot.ttf" "%DVD%\efi\microsoft\boot\fonts\malgun_boot.ttf" >nul
Copy /Y "%InstallMount%\%ImageIndexNo%\Windows\Boot\Fonts\meiryon_boot.ttf" "%DVD%\efi\microsoft\boot\fonts\meiryon_boot.ttf" >nul
Copy /Y "%InstallMount%\%ImageIndexNo%\Windows\Boot\Fonts\meiryo_boot.ttf" "%DVD%\efi\microsoft\boot\fonts\meiryo_boot.ttf" >nul
Copy /Y "%InstallMount%\%ImageIndexNo%\Windows\Boot\Fonts\msjhn_boot.ttf" "%DVD%\efi\microsoft\boot\fonts\msjhn_boot.ttf" >nul
Copy /Y "%InstallMount%\%ImageIndexNo%\Windows\Boot\Fonts\msjh_boot.ttf" "%DVD%\efi\microsoft\boot\fonts\msjh_boot.ttf" >nul
Copy /Y "%InstallMount%\%ImageIndexNo%\Windows\Boot\Fonts\msyhn_boot.ttf" "%DVD%\efi\microsoft\boot\fonts\msyhn_boot.ttf" >nul
Copy /Y "%InstallMount%\%ImageIndexNo%\Windows\Boot\Fonts\msyh_boot.ttf" "%DVD%\efi\microsoft\boot\fonts\msyh_boot.ttf" >nul
Copy /Y "%InstallMount%\%ImageIndexNo%\Windows\Boot\Fonts\segmono_boot.ttf" "%DVD%\efi\microsoft\boot\fonts\segmono_boot.ttf" >nul
Copy /Y "%InstallMount%\%ImageIndexNo%\Windows\Boot\Fonts\segoen_slboot.ttf" "%DVD%\efi\microsoft\boot\fonts\segoen_slboot.ttf" >nul
Copy /Y "%InstallMount%\%ImageIndexNo%\Windows\Boot\Fonts\segoe_slboot.ttf" "%DVD%\efi\microsoft\boot\fonts\segoe_slboot.ttf" >nul
Copy /Y "%InstallMount%\%ImageIndexNo%\Windows\Boot\Fonts\wgl4_boot.ttf" "%DVD%\efi\microsoft\boot\fonts\wgl4_boot.ttf" >nul
rem "%DVD%\efi\microsoft\boot\resources\bootres.dll" >nul
Copy /Y "%InstallMount%\%ImageIndexNo%\Windows\apppatch\acres.dll" "%DVD%\sources\acres.dll" >nul
Copy /Y "%InstallMount%\%ImageIndexNo%\Windows\System32\actionqueue.dll" "%DVD%\sources\actionqueue.dll" >nul
rem "%DVD%\sources\adfscomp.dll" >nul
rem "%DVD%\sources\admtv3check.dll" >nul
Copy /Y "%InstallMount%\%ImageIndexNo%\Windows\System32\aeinv.dll" "%DVD%\sources\aeinv.dll" >nul
rem "%DVD%\sources\alert.gif" >nul
Copy /Y "%BootMount%\2\sources\api-ms-win-downlevel-advapi32-l1-1-0.dll" "%DVD%\sources\api-ms-win-downlevel-advapi32-l1-1-0.dll" >nul
Copy /Y "%BootMount%\2\sources\api-ms-win-downlevel-advapi32-l1-1-1.dll" "%DVD%\sources\api-ms-win-downlevel-advapi32-l1-1-1.dll" >nul
Copy /Y "%BootMount%\2\sources\api-ms-win-downlevel-advapi32-l2-1-0.dll" "%DVD%\sources\api-ms-win-downlevel-advapi32-l2-1-0.dll" >nul
Copy /Y "%BootMount%\2\sources\api-ms-win-downlevel-advapi32-l2-1-1.dll" "%DVD%\sources\api-ms-win-downlevel-advapi32-l2-1-1.dll" >nul
Copy /Y "%BootMount%\2\sources\api-ms-win-downlevel-advapi32-l3-1-0.dll" "%DVD%\sources\api-ms-win-downlevel-advapi32-l3-1-0.dll" >nul
Copy /Y "%BootMount%\2\sources\api-ms-win-downlevel-advapi32-l4-1-0.dll" "%DVD%\sources\api-ms-win-downlevel-advapi32-l4-1-0.dll" >nul
Copy /Y "%BootMount%\2\sources\api-ms-win-downlevel-kernel32-l1-1-0.dll" "%DVD%\sources\api-ms-win-downlevel-kernel32-l1-1-0.dll" >nul
Copy /Y "%BootMount%\2\sources\api-ms-win-downlevel-kernel32-l2-1-0.dll" "%DVD%\sources\api-ms-win-downlevel-kernel32-l2-1-0.dll" >nul
Copy /Y "%BootMount%\2\sources\api-ms-win-downlevel-ole32-l1-1-0.dll" "%DVD%\sources\api-ms-win-downlevel-ole32-l1-1-0.dll" >nul
Copy /Y "%BootMount%\2\sources\api-ms-win-downlevel-ole32-l1-1-1.dll" "%DVD%\sources\api-ms-win-downlevel-ole32-l1-1-1.dll" >nul
Copy /Y "%BootMount%\2\sources\api-ms-win-downlevel-shlwapi-l1-1-0.dll" "%DVD%\sources\api-ms-win-downlevel-shlwapi-l1-1-0.dll" >nul
Copy /Y "%BootMount%\2\sources\api-ms-win-downlevel-shlwapi-l1-1-1.dll" "%DVD%\sources\api-ms-win-downlevel-shlwapi-l1-1-1.dll" >nul
Copy /Y "%BootMount%\2\sources\api-ms-win-downlevel-user32-l1-1-0.dll" "%DVD%\sources\api-ms-win-downlevel-user32-l1-1-0.dll" >nul
Copy /Y "%BootMount%\2\sources\api-ms-win-downlevel-user32-l1-1-1.dll" "%DVD%\sources\api-ms-win-downlevel-user32-l1-1-1.dll" >nul
Copy /Y "%BootMount%\2\sources\api-ms-win-downlevel-version-l1-1-0.dll" "%DVD%\sources\api-ms-win-downlevel-version-l1-1-0.dll" >nul
Copy /Y "%BootMount%\2\sources\appcompat.xsl" "%DVD%\sources\appcompat.xsl" >nul
Copy /Y "%BootMount%\2\sources\appcompat_bidi.xsl" "%DVD%\sources\appcompat_bidi.xsl" >nul
rem "%DVD%\sources\appcompat_detailed.xsl" >nul
rem "%DVD%\sources\appcompat_detailed_bidi.xsl" >nul
Copy /Y "%BootMount%\2\sources\appcompat_detailed_bidi_txt.xsl" "%DVD%\sources\appcompat_detailed_bidi_txt.xsl" >nul
Copy /Y "%BootMount%\2\sources\appcompat_detailed_txt.xsl" "%DVD%\sources\appcompat_detailed_txt.xsl" >nul
Copy /Y "%BootMount%\2\sources\arunimg.dll" "%DVD%\sources\arunimg.dll" >nul
Copy /Y "%BootMount%\2\sources\arunres.dll" "%DVD%\sources\arunres.dll" >nul
Copy /Y "%BootMount%\2\sources\autorun.dll" "%DVD%\sources\autorun.dll" >nul
rem "%DVD%\sources\background_cli.bmp" >nul
rem "%DVD%\sources\cdplib.mof" >nul
rem "%DVD%\sources\cdplibuninstall.mof" >nul
rem "%DVD%\sources\clustercompliance.dll" >nul
Copy /Y "%InstallMount%\%ImageIndexNo%\Windows\System32\migwiz\cmi2migxml.dll" "%DVD%\sources\cmi2migxml.dll" >nul
Copy /Y "%InstallMount%\%ImageIndexNo%\Windows\System32\cmifw.dll" "%DVD%\sources\cmifw.dll" >nul
Copy /Y "%BootMount%\2\sources\cmisetup.dll" "%DVD%\sources\cmisetup.dll" >nul
Copy /Y "%InstallMount%\%ImageIndexNo%\Windows\System32\CompatTel\compatctrl.dll" "%DVD%\sources\compatctrl.dll" >nul
Copy /Y "%BootMount%\2\sources\compatprovider.dll" "%DVD%\sources\compatprovider.dll" >nul
Copy /Y "%InstallMount%\%ImageIndexNo%\Windows\System32\CompatTel\compatresources.dll" "%DVD%\sources\compatresources.dll" >nul
Copy /Y "%BootMount%\2\sources\compliance.ini" "%DVD%\sources\compliance.ini" >nul
rem "%DVD%\sources\compres.dll" >nul
Copy /Y "%BootMount%\2\sources\cryptosetup.dll" "%DVD%\sources\cryptosetup.dll" >nul
Copy /Y "%InstallMount%\%ImageIndexNo%\Windows\System32\migwiz\csiagent.dll" "%DVD%\sources\csiagent.dll" >nul
rem "%DVD%\sources\cversion.ini" >nul
rem "%DVD%\sources\db_msftproductionwindowssigningca.cer" >nul
Copy /Y "%InstallMount%\%ImageIndexNo%\Windows\System32\devinv.dll" "%DVD%\sources\devinv.dll" >nul
Copy /Y "%BootMount%\2\sources\diager.dll" "%DVD%\sources\diager.dll" >nul
Copy /Y "%BootMount%\2\sources\diagnostic.dll" "%DVD%\sources\diagnostic.dll" >nul
Copy /Y "%BootMount%\2\sources\dism.exe" "%DVD%\sources\dism.exe" >nul
Copy /Y "%BootMount%\2\Windows\System32\dismapi.dll" "%DVD%\sources\dismapi.dll" >nul
Copy /Y "%BootMount%\2\sources\dismcore.dll" "%DVD%\sources\dismcore.dll" >nul
Copy /Y "%BootMount%\2\sources\dismcoreps.dll" "%DVD%\sources\dismcoreps.dll" >nul
Copy /Y "%BootMount%\2\sources\dismprov.dll" "%DVD%\sources\dismprov.dll" >nul
Copy /Y "%InstallMount%\%ImageIndexNo%\Windows\apppatch\drvmain.sdb" "%DVD%\sources\drvmain.sdb" >nul
Copy /Y "%InstallMount%\%ImageIndexNo%\Windows\System32\CompatTel\drvmain32.sdb" "%DVD%\sources\drvmain32.sdb" >nul
Copy /Y "%InstallMount%\%ImageIndexNo%\Windows\System32\CompatTel\drvmain64.sdb" "%DVD%\sources\drvmain64.sdb" >nul
rem "%DVD%\sources\drvmainarm.sdb" >nul
Copy /Y "%BootMount%\2\sources\drvmgrtn.dll" "%DVD%\sources\drvmgrtn.dll" >nul
Copy /Y "%BootMount%\2\sources\du.dll" "%DVD%\sources\du.dll" >nul
Copy /Y "%InstallMount%\%ImageIndexNo%\Windows\WinSxS\x86_microsoft-windows-servicingstack-net_31bf3856ad364e35_6.3.9600.17031_none_d358249e46914d92\firewallofflineapi.dll" "%DVD%\sources\firewallofflineapi.dll" >nul
Copy /Y "%BootMount%\2\sources\folderprovider.dll" "%DVD%\sources\folderprovider.dll" >nul
rem "%DVD%\sources\fveupg.dll" >nul
Copy /Y "%BootMount%\2\sources\hwcompat.dll" "%DVD%\sources\hwcompat.dll" >nul
Copy /Y "%BootMount%\2\sources\hwcompat.txt" "%DVD%\sources\hwcompat.txt" >nul
rem "%DVD%\sources\hwcompatPE.txt" >nul
Copy /Y "%BootMount%\2\sources\hwexclude.txt" "%DVD%\sources\hwexclude.txt" >nul
rem "%DVD%\sources\hwexcludePE.txt" >nul
rem "%DVD%\sources\hypervcomplcheck.dll" >nul
Copy /Y "%BootMount%\2\sources\idwbinfo.txt" "%DVD%\sources\idwbinfo.txt" >nul
rem "%DVD%\sources\iiscomp.dll" >nul
Copy /Y "%BootMount%\2\sources\imagingprovider.dll" "%DVD%\sources\imagingprovider.dll" >nul
Copy /Y "%BootMount%\2\sources\input.dll" "%DVD%\sources\input.dll" >nul
rem "%DVD%\sources\install.exe" >nul
Copy /Y "%InstallMount%\%ImageIndexNo%\Windows\System32\oobe\installeventres.dll" "%DVD%\sources\installeventres.dll" >nul
rem "%DVD%\sources\installprep.exe" >nul
rem "%DVD%\sources\itgtupg.dll" >nul
Copy /Y "%BootMount%\2\sources\lang.ini" "%DVD%\sources\lang.ini" >nul
Copy /Y "%BootMount%\2\sources\locale.nls" "%DVD%\sources\locale.nls" >nul
Copy /Y "%BootMount%\2\sources\logprovider.dll" "%DVD%\sources\logprovider.dll" >nul
Copy /Y "%InstallMount%\%ImageIndexNo%\Windows\System32\luainstall.dll" "%DVD%\sources\luainstall.dll" >nul
Copy /Y "%InstallMount%\%ImageIndexNo%\Windows\System32\migwiz\migapp.xml" "%DVD%\sources\migapp.xml" >nul
Copy /Y "%InstallMount%\%ImageIndexNo%\Windows\System32\migwiz\migcore.dll" "%DVD%\sources\migcore.dll" >nul
Copy /Y "%InstallMount%\%ImageIndexNo%\Windows\System32\migwiz\mighost.exe" "%DVD%\sources\mighost.exe" >nul
Copy /Y "%InstallMount%\%ImageIndexNo%\Windows\System32\migisol.dll" "%DVD%\sources\migisol.dll" >nul
Copy /Y "%InstallMount%\%ImageIndexNo%\Windows\System32\migwiz\migres.dll" "%DVD%\sources\migres.dll" >nul
Copy /Y "%InstallMount%\%ImageIndexNo%\Windows\System32\migwiz\migstore.dll" "%DVD%\sources\migstore.dll" >nul
Copy /Y "%InstallMount%\%ImageIndexNo%\Windows\System32\migwiz\migsys.dll" "%DVD%\sources\migsys.dll" >nul
rem "%DVD%\sources\migtestplugin.dll" >nul
Copy /Y "%BootMount%\2\sources\msxml6.dll" "%DVD%\sources\msxml6.dll" >nul
Copy /Y "%BootMount%\2\sources\msxml6r.dll" "%DVD%\sources\msxml6r.dll" >nul
Copy /Y "%InstallMount%\%ImageIndexNo%\Windows\System32\migwiz\mxeagent.dll" "%DVD%\sources\mxeagent.dll" >nul
Copy /Y "%BootMount%\2\sources\ndiscompl.dll" "%DVD%\sources\ndiscompl.dll" >nul
Copy /Y "%BootMount%\2\sources\nlsbres.dll" "%DVD%\sources\nlsbres.dll" >nul
Copy /Y "%BootMount%\2\sources\ntdsupg.dll" "%DVD%\sources\ntdsupg.dll" >nul
rem "%DVD%\sources\ntfrsupg.dll" >nul
rem "%DVD%\sources\nxquery.cat" >nul
rem "%DVD%\sources\nxquery.inf" >nul
rem "%DVD%\sources\nxquery.sys" >nul
Copy /Y "%BootMount%\2\sources\offline.xml" "%DVD%\sources\offline.xml" >nul
rem "%DVD%\sources\oscomps.woa.xml" >nul
rem "%DVD%\sources\oscomps.xml" >nul
rem "%DVD%\sources\osfilter.inf" >nul
rem "%DVD%\sources\outofbox_windows_db.bin" >nul
Copy /Y "%BootMount%\2\sources\pnpibs.dll" "%DVD%\sources\pnpibs.dll" >nul
rem "%DVD%\sources\postrollback.exe" >nul
Copy /Y "%InstallMount%\%ImageIndexNo%\Windows\System32\CompatTel\queryappblock.exe" "%DVD%\sources\queryappblock.exe" >nul
rem "%DVD%\sources\quirks.ait" >nul
rem "%DVD%\sources\rdsupgcheck.dll" >nul
Copy /Y "%InstallMount%\%ImageIndexNo%\Windows\PolicyDefinitions\reagent.admx" "%DVD%\sources\reagent.admx" >nul
Copy /Y "%BootMount%\2\sources\reagent.dll" "%DVD%\sources\reagent.dll" >nul
Copy /Y "%InstallMount%\%ImageIndexNo%\Windows\System32\Recovery\reagent.xml" "%DVD%\sources\reagent.xml" >nul
rem "%DVD%\sources\reportgen.dll" >nul
rem "%DVD%\sources\rmsupg.dll" >nul
Copy /Y "%BootMount%\2\sources\rollback.exe" "%DVD%\sources\rollback.exe" >nul
Copy /Y "%BootMount%\2\sources\schema.dat" "%DVD%\sources\schema.dat" >nul
Copy /Y "%BootMount%\2\sources\sdbapiu.dll" "%DVD%\sources\sdbapiu.dll" >nul
Copy /Y "%BootMount%\2\sources\segoeui.ttf" "%DVD%\sources\segoeui.ttf" >nul
Copy /Y "%BootMount%\2\sources\setup.exe" "%DVD%\sources\setup.exe" >nul
Copy /Y "%InstallMount%\%ImageIndexNo%\Windows\System32\CompatTel\setupcompat.dll" "%DVD%\sources\setupcompat.dll" >nul
rem "%DVD%\sources\setuperror.exe" >nul
Copy /Y "%BootMount%\2\sources\setupplatform.cfg" "%DVD%\sources\setupplatform.cfg" >nul
Copy /Y "%BootMount%\2\sources\setupplatform.dll" "%DVD%\sources\setupplatform.dll" >nul
Copy /Y "%BootMount%\2\sources\setupplatform.exe" "%DVD%\sources\setupplatform.exe" >nul
rem "%DVD%\sources\setupresume.exe" >nul
Copy /Y "%InstallMount%\%ImageIndexNo%\Windows\System32\migwiz\sfcn.dat" "%DVD%\sources\sfcn.dat" >nul
Copy /Y "%InstallMount%\%ImageIndexNo%\Windows\System32\migwiz\sflcid.dat" "%DVD%\sources\sflcid.dat" >nul
Copy /Y "%InstallMount%\%ImageIndexNo%\Windows\System32\migwiz\sflistw7.dat" "%DVD%\sources\sflistw7.dat" >nul
Copy /Y "%InstallMount%\%ImageIndexNo%\Windows\System32\migwiz\sflistw8.dat" "%DVD%\sources\sflistw8.dat" >nul
Copy /Y "%InstallMount%\%ImageIndexNo%\Windows\System32\migwiz\sflistw8.woa.dat" "%DVD%\sources\sflistw8.woa.dat" >nul
Copy /Y "%InstallMount%\%ImageIndexNo%\Windows\System32\migwiz\sflistwb.dat" "%DVD%\sources\sflistwb.dat" >nul
Copy /Y "%InstallMount%\%ImageIndexNo%\Windows\System32\migwiz\sflistwb.woa.dat" "%DVD%\sources\sflistwb.woa.dat" >nul
Copy /Y "%InstallMount%\%ImageIndexNo%\Windows\System32\migwiz\sfpat.inf" "%DVD%\sources\sfpat.inf" >nul
rem "%DVD%\sources\sfpatpg.inf" >nul
Copy /Y "%InstallMount%\%ImageIndexNo%\Windows\System32\migwiz\sfpatw7.inf" "%DVD%\sources\sfpatw7.inf" >nul
Copy /Y "%InstallMount%\%ImageIndexNo%\Windows\System32\migwiz\sfpatw8.inf" "%DVD%\sources\sfpatw8.inf" >nul
Copy /Y "%InstallMount%\%ImageIndexNo%\Windows\System32\migwiz\sfpatwb.inf" "%DVD%\sources\sfpatwb.inf" >nul
Copy /Y "%BootMount%\2\sources\smiengine.dll" "%DVD%\sources\smiengine.dll" >nul
Copy /Y "%BootMount%\2\sources\spflvrnt.dll" "%DVD%\sources\spflvrnt.dll" >nul
Copy /Y "%BootMount%\2\sources\spprgrss.dll" "%DVD%\sources\spprgrss.dll" >nul
Copy /Y "%BootMount%\2\sources\spwizeng.dll" "%DVD%\sources\spwizeng.dll" >nul
Copy /Y "%BootMount%\2\sources\spwizimg.dll" "%DVD%\sources\spwizimg.dll" >nul
Copy /Y "%BootMount%\2\sources\spwizres.dll" "%DVD%\sources\spwizres.dll" >nul
Copy /Y "%BootMount%\2\sources\sqmapi.dll" "%DVD%\sources\sqmapi.dll" >nul
Copy /Y "%BootMount%\2\sources\ssshim.dll" "%DVD%\sources\ssshim.dll" >nul
Copy /Y "%InstallMount%\%ImageIndexNo%\Windows\apppatch\sysmain.sdb" "%DVD%\sources\sysmain.sdb" >nul
Copy /Y "%InstallMount%\%ImageIndexNo%\Windows\System32\CompatTel\sysmain32.sdb" "%DVD%\sources\sysmain32.sdb" >nul
Copy /Y "%InstallMount%\%ImageIndexNo%\Windows\System32\CompatTel\sysmain64.sdb" "%DVD%\sources\sysmain64.sdb" >nul
rem "%DVD%\sources\telemetry.xsd" >nul
rem "%DVD%\sources\uddicomp.dll" >nul
Copy /Y "%BootMount%\2\sources\unattend.dll" "%DVD%\sources\unattend.dll" >nul
Copy /Y "%BootMount%\2\sources\unbcl.dll" "%DVD%\sources\unbcl.dll" >nul
rem "%DVD%\sources\upgcompat.inf" >nul" >nul
rem "%DVD%\sources\upgdriver.dll" >nul" >nul
Copy /Y "%BootMount%\2\sources\upgloader.dll" "%DVD%\sources\upgloader.dll" >nul
rem "%DVD%\sources\upgradeagent.dll" >nul
rem "%DVD%\sources\upgradeagent.xml" >nul
rem "%DVD%\sources\upgrade_bulk.xml" >nul
rem "%DVD%\sources\upgrade_data.xml" >nul
Copy /Y "%BootMount%\2\sources\upgrade_frmwrk.xml" "%DVD%\sources\upgrade_frmwrk.xml" >nul
Copy /Y "%BootMount%\2\sources\upgreport.dll" "%DVD%\sources\upgreport.dll" >nul
rem "%DVD%\sources\upgwow_bulk.xml" >nul
Copy /Y "%BootMount%\2\sources\uxlib.dll" "%DVD%\sources\uxlib.dll" >nul
Copy /Y "%BootMount%\2\sources\uxlibres.dll" "%DVD%\sources\uxlibres.dll" >nul
Copy /Y "%BootMount%\2\sources\vhdprovider.dll" "%DVD%\sources\vhdprovider.dll" >nul
Copy /Y "%BootMount%\2\sources\w32uiimg.dll" "%DVD%\sources\w32uiimg.dll" >nul
Copy /Y "%BootMount%\2\sources\w32uires.dll" "%DVD%\sources\w32uires.dll" >nul
Copy /Y "%BootMount%\2\sources\warning.gif" "%DVD%\sources\warning.gif" >nul
Copy /Y "%BootMount%\2\sources\wdsclient.dll" "%DVD%\sources\wdsclient.dll" >nul
Copy /Y "%BootMount%\2\sources\wdsclientapi.dll" "%DVD%\sources\wdsclientapi.dll" >nul
Copy /Y "%BootMount%\2\sources\wdscore.dll" "%DVD%\sources\wdscore.dll" >nul
Copy /Y "%BootMount%\2\sources\wdscsl.dll" "%DVD%\sources\wdscsl.dll" >nul
Copy /Y "%BootMount%\2\sources\wdsimage.dll" "%DVD%\sources\wdsimage.dll" >nul
Copy /Y "%BootMount%\2\sources\wdstptc.dll" "%DVD%\sources\wdstptc.dll" >nul
rem "%DVD%\sources\wdsupgcompl.dll" >nul
Copy /Y "%BootMount%\2\sources\wdsutil.dll" "%DVD%\sources\wdsutil.dll" >nul
Copy /Y "%InstallMount%\%ImageIndexNo%\Windows\System32\CompatTel\wica.dll" "%DVD%\sources\wica.dll" >nul
Copy /Y "%InstallMount%\%ImageIndexNo%\Windows\System32\CompatTel\wica.ini" "%DVD%\sources\wica.ini" >nul
rem "%DVD%\sources\wicadevicefilters.xml" >nul
Copy /Y "%InstallMount%\%ImageIndexNo%\Windows\System32\CompatTel\wicainventory.exe" "%DVD%\sources\wicainventory.exe" >nul
rem "%DVD%\sources\wicatel.dll" >nul
Copy /Y "%BootMount%\2\sources\wimprovider.dll" "%DVD%\sources\wimprovider.dll" >nul
Copy /Y "%BootMount%\2\sources\win32ui.dll" "%DVD%\sources\win32ui.dll" >nul
Copy /Y "%BootMount%\2\sources\winsetup.dll" "%DVD%\sources\winsetup.dll" >nul
Copy /Y "%InstallMount%\%ImageIndexNo%\Windows\apppatch\%ImageDefaultLanguage%\acres.dll.mui" "%DVD%\sources\%ImageDefaultLanguage%\acres.dll.mui" >nul
Copy /Y "%InstallMount%\%ImageIndexNo%\Windows\System32\%ImageDefaultLanguage%\actionqueue.dll.mui" "%DVD%\sources\%ImageDefaultLanguage%\actionqueue.dll.mui" >nul
Copy /Y "%BootMount%\2\sources\%ImageDefaultLanguage%\arunres.dll.mui" "%DVD%\sources\%ImageDefaultLanguage%\arunres.dll.mui" >nul
Copy /Y "%BootMount%\2\sources\%ImageDefaultLanguage%\cmisetup.dll.mui" "%DVD%\sources\%ImageDefaultLanguage%\cmisetup.dll.mui" >nul
rem "%DVD%\sources\%ImageDefaultLanguage%\compatctrl.dll.mui" >nul
Copy /Y "%BootMount%\2\sources\%ImageDefaultLanguage%\compatprovider.dll.mui" "%DVD%\sources\%ImageDefaultLanguage%\compatprovider.dll.mui" >nul
rem "%DVD%\sources\%ImageDefaultLanguage%\compatresources.dll.mui" >nul
rem "%DVD%\sources\%ImageDefaultLanguage%\compres.dll.mui" >nul
Copy /Y "%InstallMount%\%ImageIndexNo%\Windows\Help\%ImageDefaultLanguage%\credits.rtf" "%DVD%\sources\%ImageDefaultLanguage%\credits.rtf" >nul
Copy /Y "%BootMount%\2\sources\%ImageDefaultLanguage%\dism.exe.mui" "%DVD%\sources\%ImageDefaultLanguage%\dism.exe.mui" >nul
Copy /Y "%InstallMount%\%ImageIndexNo%\Windows\System32\%ImageDefaultLanguage%\dismapi.dll.mui" "%DVD%\sources\%ImageDefaultLanguage%\dismapi.dll.mui" >nul
Copy /Y "%BootMount%\2\sources\%ImageDefaultLanguage%\dismcore.dll.mui" "%DVD%\sources\%ImageDefaultLanguage%\dismcore.dll.mui" >nul
Copy /Y "%BootMount%\2\sources\%ImageDefaultLanguage%\dismprov.dll.mui" "%DVD%\sources\%ImageDefaultLanguage%\dismprov.dll.mui" >nul
Copy /Y "%InstallMount%\%ImageIndexNo%\Windows\System32\%ImageDefaultLanguage%\erofflps.txt" "%DVD%\sources\%ImageDefaultLanguage%\erofflps.txt" >nul
Copy /Y "%BootMount%\2\sources\%ImageDefaultLanguage%\folderprovider.dll.mui" "%DVD%\sources\%ImageDefaultLanguage%\folderprovider.dll.mui" >nul
Copy /Y "%BootMount%\2\sources\%ImageDefaultLanguage%\imagingprovider.dll.mui" "%DVD%\sources\%ImageDefaultLanguage%\imagingprovider.dll.mui" >nul
Copy /Y "%BootMount%\2\sources\%ImageDefaultLanguage%\input.dll.mui" "%DVD%\sources\%ImageDefaultLanguage%\input.dll.mui" >nul
rem "%DVD%\sources\%ImageDefaultLanguage%\install.exe.mui" >nul
Copy /Y "%InstallMount%\%ImageIndexNo%\Windows\System32\oobe\%ImageDefaultLanguage%\installeventres.dll.mui" "%DVD%\sources\%ImageDefaultLanguage%\installeventres.dll.mui" >nul
rem "%DVD%\sources\%ImageDefaultLanguage%\installprep.exe.mui" >nul
Copy /Y "%BootMount%\2\sources\%ImageDefaultLanguage%\logprovider.dll.mui" "%DVD%\sources\%ImageDefaultLanguage%\logprovider.dll.mui" >nul
Copy /Y "%InstallMount%\%ImageIndexNo%\Windows\System32\migwiz\%ImageDefaultLanguage%\migcore.dll.mui" "%DVD%\sources\%ImageDefaultLanguage%\migcore.dll.mui" >nul
Copy /Y "%InstallMount%\%ImageIndexNo%\Windows\System32\migwiz\%ImageDefaultLanguage%\migres.dll.mui" "%DVD%\sources\%ImageDefaultLanguage%\migres.dll.mui" >nul
Copy /Y "%BootMount%\2\sources\%ImageDefaultLanguage%\msxml6r.dll.mui" "%DVD%\sources\%ImageDefaultLanguage%\msxml6r.dll.mui" >nul
Copy /Y "%BootMount%\2\sources\%ImageDefaultLanguage%\nlsbres.dll.mui" "%DVD%\sources\%ImageDefaultLanguage%\nlsbres.dll.mui" >nul
Copy /Y "%InstallMount%\%ImageIndexNo%\Windows\System32\oobe\%ImageDefaultLanguage%\oobe_help_opt_in_details.rtf" "%DVD%\sources\%ImageDefaultLanguage%\oobe_help_opt_in_details.rtf" >nul
Copy /Y "%BootMount%\2\sources\%ImageDefaultLanguage%\pnpibs.dll.mui" "%DVD%\sources\%ImageDefaultLanguage%\pnpibs.dll.mui" >nul
rem "%DVD%\sources\%ImageDefaultLanguage%\postrollback.exe.mui" >nul
Copy /Y "%InstallMount%\%ImageIndexNo%\Windows\System32\oobe\%ImageDefaultLanguage%\privacy.rtf" "%DVD%\sources\%ImageDefaultLanguage%\privacy.rtf" >nul
Copy /Y "%InstallMount%\%ImageIndexNo%\Windows\PolicyDefinitions\%ImageDefaultLanguage%\reagent.adml" "%DVD%\sources\%ImageDefaultLanguage%\reagent.adml" >nul
Copy /Y "%InstallMount%\%ImageIndexNo%\Windows\System32\%ImageDefaultLanguage%\reagent.dll.mui" "%DVD%\sources\%ImageDefaultLanguage%\reagent.dll.mui" >nul
Copy /Y "%BootMount%\2\sources\%ImageDefaultLanguage%\rollback.exe.mui" "%DVD%\sources\%ImageDefaultLanguage%\rollback.exe.mui" >nul
Copy /Y "%BootMount%\2\sources\%ImageDefaultLanguage%\setup.exe.mui" "%DVD%\sources\%ImageDefaultLanguage%\setup.exe.mui" >nul
rem "%DVD%\sources\%ImageDefaultLanguage%\setupcompat.dll.mui" >nul
rem "%DVD%\sources\%ImageDefaultLanguage%\setuperror.exe.mui" >nul
rem "%DVD%\sources\%ImageDefaultLanguage%\setupplatform.exe.mui" >nul
rem "%DVD%\sources\%ImageDefaultLanguage%\setupresume.exe.mui" >nul
Copy /Y "%BootMount%\2\sources\%ImageDefaultLanguage%\setup_help_upgrade_or_custom.rtf" "%DVD%\sources\%ImageDefaultLanguage%\setup_help_upgrade_or_custom.rtf" >nul
rem "%DVD%\sources\%ImageDefaultLanguage%\setup_help_whattokeep.rtf" >nul
Copy /Y "%BootMount%\2\sources\%ImageDefaultLanguage%\smiengine.dll.mui" "%DVD%\sources\%ImageDefaultLanguage%\smiengine.dll.mui" >nul
Copy /Y "%BootMount%\2\sources\%ImageDefaultLanguage%\spwizres.dll.mui" "%DVD%\sources\%ImageDefaultLanguage%\spwizres.dll.mui" >nul
rem "%DVD%\sources\%ImageDefaultLanguage%\upgdriver.dll.mui" >nul
Copy /Y "%BootMount%\2\sources\%ImageDefaultLanguage%\upgloader.dll.mui" "%DVD%\sources\%ImageDefaultLanguage%\upgloader.dll.mui" >nul
rem "%DVD%\sources\%ImageDefaultLanguage%\upgreport.dll.mui" >nul
Copy /Y "%BootMount%\2\sources\%ImageDefaultLanguage%\uxlibres.dll.mui" "%DVD%\sources\%ImageDefaultLanguage%\uxlibres.dll.mui" >nul
Copy /Y "%BootMount%\2\sources\%ImageDefaultLanguage%\vhdprovider.dll.mui" "%DVD%\sources\%ImageDefaultLanguage%\vhdprovider.dll.mui" >nul
Copy /Y "%BootMount%\2\sources\%ImageDefaultLanguage%\vofflps.rtf" "%DVD%\sources\%ImageDefaultLanguage%\vofflps.rtf" >nul
Copy /Y "%BootMount%\2\sources\%ImageDefaultLanguage%\w32uires.dll.mui" "%DVD%\sources\%ImageDefaultLanguage%\w32uires.dll.mui" >nul
Copy /Y "%BootMount%\2\sources\%ImageDefaultLanguage%\wdsclient.dll.mui" "%DVD%\sources\%ImageDefaultLanguage%\wdsclient.dll.mui" >nul
Copy /Y "%BootMount%\2\sources\%ImageDefaultLanguage%\wdsimage.dll.mui" "%DVD%\sources\%ImageDefaultLanguage%\wdsimage.dll.mui" >nul
Copy /Y "%BootMount%\2\sources\%ImageDefaultLanguage%\wimprovider.dll.mui" "%DVD%\sources\%ImageDefaultLanguage%\wimprovider.dll.mui" >nul
Copy /Y "%BootMount%\2\sources\%ImageDefaultLanguage%\winsetup.dll.mui" "%DVD%\sources\%ImageDefaultLanguage%\winsetup.dll.mui" >nul
Copy /Y "%BootMount%\2\sources\inf\setup.cfg" "%DVD%\sources\inf\setup.cfg" >nul
echo.
echo.-------------------------------------------------------------------------------
echo.####Finished Updating Windows Setup Media######################################
echo.-------------------------------------------------------------------------------
echo.
echo.===============================================================================
echo.
pause

endlocal

:: Returning to Integrate Menu
goto :IntegrateMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Integrate Windows 8.1 Media Center Generic Activation Tokens to Install Image
::-------------------------------------------------------------------------------------------
:IntWMCGActTokens

if "%IsDialogsEnabled%" equ "Yes" (
	cls
	echo.===============================================================================
	echo. MSMG ToolKit - Integrate Windows 8.1 Media Center Generic Activation Tokens
	echo.===============================================================================
	echo.
	echo.
	echo.                            I N F O R M A T I O N
	echo.                            =====================
	echo.
	echo.  Windows 8.1 Media Center Generic Activation Tokens are Generic Tokens data
	echo.  files that have been extracted from an Un-Activated Windows 8.0 Pro WMC
	echo.  OS upgraded to Windows 8.1 Pro WMC OS through Windows Store upgrade method.
	echo.
	echo.  Since Windows 8.1 Pro OS doesn't accepts Windows 8.0 Pro WMC or WMC Add-on
	echo.  Keys to install the OS, These Generic Tokens helps to make Windows Setup to
	echo.  accept and install Windows 8.0 Pro WMC or WMC Add-on Keys for installation.
	echo.
	echo.  Later the installed OS can be directly activated through Online or Phone
	echo.  activation method.
	echo.
	echo.
	echo.  To turn off Warning Dialogs, Choose Disable Dialogs in Tools-^>Options Menu
	echo.
	echo.===============================================================================
	echo.
	choice /C:YN /N /M "Do you want to continue ? ['Y'es/'N'o] : "
	if errorlevel 2 goto :IntCustomFeaturesMenu
)

setlocal

cls
echo.===============================================================================
echo.  MSMG ToolKit - Integrate Windows 8.1 Media Center Generic Activation Tokens
echo.===============================================================================
echo.

:: Getting Install Image Index Architecture
for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" call :GetImageArchitecture "%InstallWim%", %%i >nul
)

echo.-------------------------------------------------------------------------------
echo.####Starting Integrating Windows 8.1 Media Center Generic Activation Tokens####
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    : Install.wim
if /i "%ImageIndexNo%" equ "A" echo.    Image Indexes            : 1-%ImageCount%
if /i "%ImageIndexNo%" neq "A" echo.    Image Index              : %ImageIndexNo%
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
echo.
echo.-------------------------------------------------------------------------------
echo.####Integrating Windows 8.1 Media Center Generic Activation Tokens#############
echo.-------------------------------------------------------------------------------
echo.

for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" (
		if "%ImageEdition%" equ "ProfessionalWMC" call :ApplyImage "%WMCGActTokens%", 1, "%InstallMount%\%%i"
	)
)

echo.-------------------------------------------------------------------------------
echo.####Finished Integrating Windows 8.1 Media Center Generic Activation Tokens####
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

endlocal

:: Returning to Integrate Custom Features Menu
goto :IntCustomFeaturesMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Integrate Windows Pre-Activation Data
::-------------------------------------------------------------------------------------------
:IntPreActTokens

if "%IsDialogsEnabled%" equ "Yes" (
	cls
	echo.===============================================================================
	echo.          MSMG ToolKit - Integrate Windows 8.1 Pre-Activation Data
	echo.===============================================================================
	echo.
	echo. MSMG ToolKit will allow you to integrate your system activation details to
	echo. Windows Installation Disc Image to perform auto activation of system without
	echo. any need to activate online or through phone activation.
	echo.
	echo. Note: When you make any changes to your System Hardware, then the activation
	echo. status will be Lost.
	echo.
	echo. Requirements:
	echo. -------------
	echo. 1^) Windows Product Key
	echo.
	echo. 2^) Latest Pre-Activated Tokens files from Windows Activated System Drive
	echo.
	echo.    - "data.dat" from "<%SytemDrive%\Windows\System32\spp\store>" folder
	echo.    - "tokens.dat" from "<%SytemDrive%\Windows\System32\spp\store>" folder
	echo.    - "cache.dat" from "<%SytemDrive%\Windows\System32\spp\store>" folder
	echo.
	echo.===============================================================================
	echo.
	choice /C:YN /N /M "Do you want to Continue ? ['Y'es/'N'o] : "
	if errorlevel 2 goto :IntCustomFeaturesMenu
)

setlocal

cls
echo.===============================================================================
echo.           MSMG ToolKit - Integrate Windows 8.1 Pre-Activation Data
echo.===============================================================================
echo.

:: Getting Install Image Index Architecture
for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" call :GetImageArchitecture "%InstallWim%", %%i >nul
)

:: Settings Windows Pre-Activation Details folder path
set "PreActTokens=%PreActTokens%\%SelectedSourceOS%\%ImageArchitecture%"

:: Checking whether Windows Pre-Activation Token data files exist
if not exist "%PreActTokens%\data.dat" if not exist "%PreActTokens%\cache.dat" if not exist "%PreActTokens%\tokens.dat" (
	echo.Windows Pre-Activation Token files folder ^<Packs\PreActTokens\%SelectedSourceOS%\%ImageArchitecture%^> is empty
	echo.
	choice /C:YN /N /M "Do you want to copy Activation files from System Folder? ['Y'es/'N'o] : "
	if errorlevel 2 (
		echo.
		echo.Please copy Pre-Activation Token files to respective folder...
		goto :Stop
	)
	if errorlevel 1 (
		echo.
		echo.Copying Pre-Activation Token files from ^<System32\Spp\store\2.0^>
		Xcopy /O /H /R /K /Y "%SystemRoot%\System32\spp\store\2.0\data.dat" %PreActTokens% >nul
		Xcopy /O /H /R /K /Y "%SystemRoot%\System32\spp\store\2.0\tokens.dat" %PreActTokens% >nul
		Xcopy /O /H /R /K /Y "%SystemRoot%\System32\spp\store\2.0\cache\cache.dat" %PreActTokens% >nul
	)
)

cls
echo.===============================================================================
echo.           MSMG ToolKit - Integrate Windows 8.1 Pre-Activation Data
echo.===============================================================================
echo.
echo.-------------------------------------------------------------------------------
echo.####Starting Integrating Windows 8.1 Pre-Activation Data#######################
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    : Install.wim
if /i "%ImageIndexNo%" equ "A" echo.    Image Indexes            : 1-%ImageCount%
if /i "%ImageIndexNo%" neq "A" echo.    Image Index              : %ImageIndexNo%
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
echo.
echo.-------------------------------------------------------------------------------
echo.####Getting Windows 8.1 Activation Product Key Details#########################
echo.-------------------------------------------------------------------------------
echo.
set /p ProductKey=Enter the Product Key with the '-'s : 
echo.
echo.-------------------------------------------------------------------------------
echo.####Integrating Windows 8.1 Pre-Activation Data################################
echo.-------------------------------------------------------------------------------

for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" (
		echo.
		echo.-------------------------------------------------------------------------------
		echo.Integrating Windows 8.1 Product Key [%ProductKey%]...
		echo.-------------------------------------------------------------------------------
		%DISM% /Image:"%InstallMount%\%%i" /Set-ProductKey:%ProductKey%
		echo.
		echo.-------------------------------------------------------------------------------
		echo.Integrating Windows 8.1 Pre-Activated Token files...
		echo.-------------------------------------------------------------------------------
		echo.
		echo.Copying Windows 8.1 Pre-Activated Token files...
		Xcopy /O /H /R /K /Y %PreActTokens%\tokens.dat "%InstallMount%\%%i\Windows\System32\spp\store\2.0"
		Xcopy /O /H /R /K /Y %PreActTokens%\data.dat "%InstallMount%\%%i\Windows\System32\spp\store\2.0"
		Xcopy /O /H /R /K /Y %PreActTokens%\cache.dat "%InstallMount%\%%i\Windows\System32\spp\store\2.0\cache"
	)
)

echo.
echo.-------------------------------------------------------------------------------
echo.####Finished Integrating Windows 8.1 Pre-Activation Data#######################
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set PreActTokens=
set ProductKey=

endlocal

:: Returning to Integrate Custom Features Menu
goto :IntCustomFeaturesMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Integrate Terminal Server Patch
::-------------------------------------------------------------------------------------------
:IntCustomTerminalServer

setlocal

cls
echo.===============================================================================
echo.        MSMG ToolKit - Integrer le correctif Microsoft Terminal Server 
echo.===============================================================================
echo.

:: Getting Install Image Index Architecture
for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" call :GetImageArchitecture "%InstallWim%", %%i >nul
)

:: Setting Terminal Server path according to selected Source OS
set "CustomTerminalServer=%CustomTerminalServer%\%SelectedSourceOS%\%ImageArchitecture%"

:: Checking whether Microsoft Terminal Server Patch Pack file exist
if not exist "%CustomTerminalServer%\termsrv.dll" (
	echo.Fichier de correctif Microsoft Terminal Server "termsrv.dll" introuvable.
	echo.
	echo.Veuillez copier le fichier ci-dessus dans le dossier ^<Custom\TerminalServer\%SelectedSourceOS%\%ImageArchitecture%^>
	goto :Stop
)

echo.-------------------------------------------------------------------------------
echo.####Demarrage de l'integration du correctif Microsoft Terminal Server  ########
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    : Install.wim
if /i "%ImageIndexNo%" equ "A" echo.    Image Indexes            : 1-%ImageCount%
if /i "%ImageIndexNo%" neq "A" echo.    Image Index              : %ImageIndexNo%
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
echo.
echo.-------------------------------------------------------------------------------
echo.####Integration du correctif Microsoft Terminal Server  #######################
echo.-------------------------------------------------------------------------------

for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" (
		echo.
		if not %%i gtr 9 echo.===========================[Install.wim, Index : %%i]============================
		if %%i gtr 9 echo.==========================[Install.wim, Index : %%i]============================
		echo.
		echo.-------------------------------------------------------------------------------
		echo.Copie du fichier [termsrv.dll] de Microsoft Terminal Server corrige
		echo.-------------------------------------------------------------------------------
		echo.
		%XCopy% %CustomTerminalServer%\*.* "%InstallMount%\%%i\Windows\System32"
		echo.
		echo.-------------------------------------------------------------------------------
		echo.Importation des parametres du registre des correctifs de Terminal Server
		echo.-------------------------------------------------------------------------------
		echo.
		echo.Montage du registre d'images
		call :MountImageRegistry "%InstallMount%\%%i"
		echo.Importing Registry Settings to Image Registry...
		Reg add "HKLM\TK_SYSTEM\ControlSet001\Control\Terminal Server" /v "fDenyTSConnections" /t REG_DWORD /d "0" /f >nul
		Reg add "HKLM\TK_SYSTEM\ControlSet001\Control\Terminal Server" /v "fSingleSessionPerUser" /t REG_DWORD /d "0" /f >nul
		echo.Demontage du registre d'images. 
		call :UnMountImageRegistry
		echo.
	)
)

echo.-------------------------------------------------------------------------------
echo.####Integration du correctif Microsoft Terminal Server terminee  ##############
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set CustomTerminalServer=

endlocal

:: Returning to Integrate Custom Features Menu
goto :IntCustomFeaturesMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Integrate Custom UxTheme Patch
::-------------------------------------------------------------------------------------------
:IntCustomUxTheme

setlocal

cls
echo.===============================================================================
echo.                MSMG ToolKit - Integrate Custom UxTheme Patch
echo.===============================================================================
echo.

:: Getting Install Image Index Architecture
for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" call :GetImageArchitecture "%InstallWim%", %%i >nul
)

:: Setting Custom UxTheme Patch Pack files path according to selected Source OS
set "CustomUxTheme=%CustomUxTheme%\%SelectedSourceOS%\%ImageArchitecture%"

:: Checking whether Custom UxTheme Patch Pack file exist
if "%SelectedSourceOS%" equ "w7" (
	for %%i in (themeservice.dll, themeui.dll, uxtheme.dll) do (
		if not exist "%CustomUxTheme%\%%i" (
			echo.Custom UxTheme Patch file "%%i" not found...
			echo.
			echo.Please copy the above file to ^<Custom\UxTheme\%SelectedSourceOS%\%ImageArchitecture%^> folder...
			goto :Stop
		)
	)
)

:: Checking whether Custom UxTheme Patch Pack file exist
if "%SelectedSourceOS%" neq "w7" (
	for %%i in (themeui.dll, UXInit.dll, uxtheme.dll) do (
		if not exist "%CustomUxTheme%\%%i" (
			echo.Custom UxTheme Patch file "%%i" not found...
			echo.
			echo.Please copy the above file to ^<Custom\UxTheme\%SelectedSourceOS%\%ImageArchitecture%^> folder...
			goto :Stop
		)
	)
)
echo.-------------------------------------------------------------------------------
echo.####Starting Integrating Custom UxTheme Patch##################################
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    : Install.wim
if /i "%ImageIndexNo%" equ "A" echo.    Image Indexes            : 1-%ImageCount%
if /i "%ImageIndexNo%" neq "A" echo.    Image Index              : %ImageIndexNo%
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
echo.
echo.-------------------------------------------------------------------------------
echo.####Integrating Custom UxTheme Patch###########################################
echo.-------------------------------------------------------------------------------

for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" (
		echo.
		if not %%i gtr 9 echo.===========================[Install.wim, Index : %%i]============================
		if %%i gtr 9 echo.==========================[Install.wim, Index : %%i]============================
		echo.
		echo.Copying Custom UxTheme Patch files...
		echo.
		%XCopy% %CustomUxTheme%\*.* "%InstallMount%\%%i\Windows\System32"
	)
)

echo.
echo.-------------------------------------------------------------------------------
echo.####Finished Integrating Custom UxTheme Patch##################################
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set CustomUxTheme=

endlocal

:: Returning to Integrate Custom Features Menu
goto :IntCustomFeaturesMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Integrate Custom Windows Recovery Image
::-------------------------------------------------------------------------------------------
:IntCustomRecoveryImage

setlocal

cls
echo.===============================================================================
echo.          MSMG ToolKit - Integrate Custom Windows Recovery Image
echo.===============================================================================
echo.

:: Checking whether Source Windows Recovery Image is selected
if "%IsRecoveryImageSelected%" equ "Yes" (
	echo.Windows Recovery Image is selected...
	echo.
	echo.Please skip Windows Recovery Image while selecting Source...
	goto :Stop
)

:: Getting Install Image Index Architecture
for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" call :GetImageArchitecture "%InstallWim%", %%i >nul
)

:: Setting Custom Windows Recovery Image file path according to selected Source OS
set "RecoveryImage=%CustomRecoveryImage%\%SelectedSourceOS%\%ImageArchitecture%\winre.wim"

:: Checking whether Custom Windows Recovery Image file exist
if not exist "%RecoveryImage%" (
	echo.Custom Windows Recovery Image file "winre.wim" not found...
	echo.
	echo.Please copy the above file to ^<Custom\RecoveryImage\%SelectedSourceOS%\%ImageArchitecture%^> folder...
	goto :Stop
)
echo.-------------------------------------------------------------------------------
echo.####Starting Integrating Custom Windows Recovery Image#########################
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    : Install.wim
if /i "%ImageIndexNo%" equ "A" echo.    Image Indexes            : 1-%ImageCount%
if /i "%ImageIndexNo%" neq "A" echo.    Image Index              : %ImageIndexNo%
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
echo.
echo.-------------------------------------------------------------------------------
echo.####Integrating Custom Windows Recovery Image##################################
echo.-------------------------------------------------------------------------------

for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" (
		echo.
		if not %%i gtr 9 echo.=====================[Install.wim, Index : %%i -^> WinRE.wim]====================
		if %%i gtr 9 echo.=====================[Install.wim, Index : %%i -^> WinRE.wim]===================
		echo.
		echo.Copying Custom Windows Recovery Environment ^(WinRE^) Image...
		copy /y "%RecoveryImage%" "%InstallMount%\%%i\Windows\System32\Recovery" >nul
	)
)

echo.
echo.-------------------------------------------------------------------------------
echo.####Finished Integrating Custom Windows Recovery Image#########################
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set RecoveryImage=

endlocal

:: Returning to Integrate Custom Features Menu
goto :IntCustomFeaturesMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Integrate Custom Default User Account Pictures
::-------------------------------------------------------------------------------------------
:IntUAP

setlocal

cls
echo.===============================================================================
echo.        MSMG ToolKit - Integrate Custom Default User Account Pictures
echo.===============================================================================
echo.

:: Setting Custom User Account Pictures path according to selected Source OS
set "UAP=%UAP%\%SelectedSourceOS%"

:: Checking whether Custom Default User Account Pictures Pack file exist
if "%SelectedSourceOS%" equ "w7" if "%ImageInstallationType%" neq "Server" (
	if not exist "%UAP%\user.bmp" (
		echo.Custom Default User Account Pictures Pack file "user.bmp" not found...
		echo.
		echo.Please copy the above file to ^<Packs\UAP\%SelectedSourceOS%^> folder...
		goto :Stop
	)
)

:: Checking whether Custom Default User Account Pictures Pack file exist
if "%SelectedSourceOS%" equ "w7" if "%ImageInstallationType%" equ "Server" (
	if not exist "%UAP%\user.bmp" (
		echo.Custom Default User Account Pictures Pack file "user.bmp" not found...
		echo.
		echo.Please copy the above file to ^<Packs\UAP\%SelectedSourceOS%^> folder...
		goto :Stop
	)
)

:: Checking whether Custom Default User Account Pictures Pack file exist
if "%SelectedSourceOS%" equ "w81" (
	for %%i in (guest.bmp, guest.png, user.bmp, user.png, user-40.png, user-200.png) do (
		if not exist "%UAP%\%%i" (
			echo.Custom Default User Account Pictures Pack file "%%i" not found...
			echo.
			echo.Please copy the above file to ^<Packs\UAP\%SelectedSourceOS%^> folder...
			goto :Stop
		)
	)
)

:: Checking whether Custom Default User Account Pictures Pack file exist
if "%SelectedSourceOS%" equ "w10" (
	for %%i in (guest.bmp, guest.png, user.bmp, user.png, user-32.png, user-40.png, user-48.png, user-192.png, user-200.png) do (
		if not exist "%UAP%\%%i" (
			echo.Custom Default User Account Pictures Pack file "%%i" not found...
			echo.
			echo.Please copy the above file to ^<Packs\UAP\%SelectedSourceOS%^> folder...
			goto :Stop
		)
	)
)

echo.-------------------------------------------------------------------------------
echo.####Starting Integrating Custom Default User Account Pictures##################
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    : Install.wim
if /i "%ImageIndexNo%" equ "A" echo.    Image Indexes            : 1-%ImageCount%
if /i "%ImageIndexNo%" neq "A" echo.    Image Index              : %ImageIndexNo%
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
echo.
echo.-------------------------------------------------------------------------------
echo.####Integrating Custom Default User Account Pictures###########################
echo.-------------------------------------------------------------------------------

for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" (
		echo.
		if not %%i gtr 9 echo.===========================[Install.wim, Index : %%i]============================
		if %%i gtr 9 echo.==========================[Install.wim, Index : %%i]============================
		echo.
		echo.Copying Custom Default User Account Pictures files...
		echo.

		if "%SelectedSourceOS%" equ "w7" if "%ImageInstallationType%" neq "Server Core" (
			if "%ImageInstallationType%" neq "Server" %XCopy% %UAP%\*.* "%InstallMount%\%%i\ProgramData\Microsoft\User Account Pictures"
			if "%ImageInstallationType%" equ "Server" %XCopy% %UAP%\user.bmp "%InstallMount%\%%i\ProgramData\Microsoft\User Account Pictures"
		)

		if "%SelectedSourceOS%" neq "w7" %XCopy% %UAP%\*.* "%InstallMount%\%%i\ProgramData\Microsoft\User Account Pictures"
	)
)

echo.
echo.-------------------------------------------------------------------------------
echo.####Finished Integrating Custom Default User Account Pictures##################
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set UAP=

endlocal

:: Returning to Integrate Custom Features Menu
goto :IntCustomFeaturesMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Integrate Custom System Files
::-------------------------------------------------------------------------------------------
:IntCustomFiles

setlocal

cls
echo.===============================================================================
echo.                MSMG ToolKit - Integrate Custom System Files
echo.===============================================================================
echo.

:: Getting Install Image Index Architecture
for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" call :GetImageArchitecture "%InstallWim%", %%i >nul
)

:: Setting Custom System files path according to selected Source OS
set "CustomFiles=%CustomFiles%\%SelectedSourceOS%\%ImageArchitecture%"

:: Checking whether Custom System files Pack file exist
for /f %%i in ('dir /b /s /a:-d "%CustomFiles%\*.*" 2^>nul ^| find /v /c ""') do (
	if "%%i" equ "0" (
		echo.Custom System files Pack folder is empty...
		echo.
		echo.Please copy the custom files to ^<Custom\Files\%SelectedSourceOS%\%ImageArchitecture%^> folder...
		goto :Stop
	)
)

echo.-------------------------------------------------------------------------------
echo.####Starting Integrating Custom System Files###################################
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    : Install.wim
if /i "%ImageIndexNo%" equ "A" echo.    Image Indexes            : 1-%ImageCount%
if /i "%ImageIndexNo%" neq "A" echo.    Image Index              : %ImageIndexNo%
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
echo.
echo.-------------------------------------------------------------------------------
echo.####Integrating Custom System Files############################################
echo.-------------------------------------------------------------------------------

for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" (
		echo.
		if not %%i gtr 9 echo.===========================[Install.wim, Index : %%i]============================
		if %%i gtr 9 echo.==========================[Install.wim, Index : %%i]============================
		echo.
		echo.Copying Custom System files...
		echo.
		%XCopy% %CustomFiles%\*.* "%InstallMount%\%%i"
	)
)

echo.
echo.-------------------------------------------------------------------------------
echo.####Finished Integrating Custom System Files###################################
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set CustomFiles=

endlocal

:: Returning to Integrate Custom Features Menu
goto :IntCustomFeaturesMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Integrate Custom Fonts
::-------------------------------------------------------------------------------------------
:IntCustomFonts

cls
echo.===============================================================================
echo.                   MSMG ToolKit - Integrate Custom Fonts
echo.===============================================================================
echo.

:: Checking whether Custom Fonts Pack file exist
for /f %%i in ('dir /b /s /a:-d "%CustomFonts%\*.ttf" 2^>nul ^| find /v /c ""') do (
	if "%%i" equ "0" (
		echo.Custom Fonts Pack folder is empty...
		echo.
		echo.Please copy the font files to ^<Custom\Fonts^> folder...
		goto :Stop
	)
)

echo.-------------------------------------------------------------------------------
echo.####Starting Integrating Custom Fonts##########################################
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    : Install.wim
if /i "%ImageIndexNo%" equ "A" echo.    Image Indexes            : 1-%ImageCount%
if /i "%ImageIndexNo%" neq "A" echo.    Image Index              : %ImageIndexNo%
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
echo.
echo.-------------------------------------------------------------------------------
echo.####Integrating Custom Fonts###################################################
echo.-------------------------------------------------------------------------------

for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" (
		echo.
		if not %%i gtr 9 echo.===========================[Install.wim, Index : %%i]============================
		if %%i gtr 9 echo.==========================[Install.wim, Index : %%i]============================
		echo.
		call :MountImageRegistry "%InstallMount%\%%i"
        PowerShell -Executionpolicy Bypass -File "%Bin%\AddFonts.ps1" -mountPath "%InstallMount%\%%i\Windows\Fonts" -fontsPath "%CustomFonts%"
		call :UnMountImageRegistry
		echo.
	)
)

echo.-------------------------------------------------------------------------------
echo.####Finished Integrating Custom Fonts##########################################
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

:: Returning to Integrate Custom Features Menu
goto :IntCustomFeaturesMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Integrate Microsoft Win32Calc Metro Skin
::-------------------------------------------------------------------------------------------
:IntWin32CalcMetroSkin

setlocal

cls
echo.===============================================================================
echo.          MSMG ToolKit - Integrate Microsoft Win32Calc Metro Skin
echo.===============================================================================
echo.

:: Getting Install Image Index Architecture
for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" call :GetImageArchitecture "%InstallWim%", %%i >nul
)

set "Skins=%Skins%\Win32Calc"

:: Checking whether Microsoft Win32Calc Metro Skin Pack file exist
if not exist "%Skins%\Win32Calc.exe.res" (
	echo.Microsoft Win32Calc Metro Skin Pack file "Win32Calc.exe.res" not found...
	echo.
	echo.Please copy the above file to ^<Packs\Skins\Win32Calc^> folder...
	goto :Stop
)

echo.-------------------------------------------------------------------------------
echo.####Starting Integrating Microsoft Win32Calc Metro Skin########################
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    : Install.wim
if /i "%ImageIndexNo%" equ "A" echo.    Image Indexes            : 1-%ImageCount%
if /i "%ImageIndexNo%" neq "A" echo.    Image Index              : %ImageIndexNo%
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
echo.
echo.-------------------------------------------------------------------------------
echo.####Integrating Microsoft Win32Calc Metro Skin#################################
echo.-------------------------------------------------------------------------------

copy /y %ResourceHacker% %Temp% >nul

for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" (
		echo.
		if not %%i gtr 9 echo.===========================[Install.wim, Index : %%i]============================
		if %%i gtr 9 echo.==========================[Install.wim, Index : %%i]============================
		echo.
		echo.Copying Microsoft Win32Calc files to Temporary Folder...
		if "%ImageArchitecture%" equ "x86" copy "%InstallMount%\%%i\Windows\System32\Win32Calc.exe" "%Temp%\Win32Calc_x.exe" >nul

		if "%ImageArchitecture%" equ "x64" (
			copy "%InstallMount%\%%i\Windows\System32\Win32Calc.exe" "%Temp%\Win32Calc64_x.exe" >nul
			copy "%InstallMount%\%%i\Windows\SysWOW64\Win32Calc.exe" "%Temp%\Win32Calc32_x.exe" >nul
		)

		echo.
		echo.Applying Microsoft Win32Calc Metro Skin to [Win32Calc.exe] file...
		if "%ImageArchitecture%" equ "x86" (
			"%Temp%\ResourceHacker.exe" -addoverwrite "%Temp%\Win32Calc_x.exe", "%Temp%\Win32Calc.exe", "%Skins%\Win32Calc.exe.res" ,,,
			call :RemoveFile "%Temp%\Win32Calc_x.exe"
		)

		if "%ImageArchitecture%" equ "x64" (
			"%Temp%\ResourceHacker.exe" -addoverwrite "%Temp%\Win32Calc32_x.exe", "%Temp%\Win32Calc32.exe", "%Skins%\Win32Calc.exe.res" ,,,
			call :RemoveFile "%Temp%\Win32Calc32_x.exe"
			"%Temp%\ResourceHacker.exe" -addoverwrite "%Temp%\Win32Calc64_x.exe", "%Temp%\Win32Calc64.exe", "%Skins%\Win32Calc.exe.res" ,,,
			call :RemoveFile "%Temp%\Win32Calc64_x.exe"
		)

		echo.
		echo.Copying Patched Microsoft Win32Calc files...
		if "%ImageArchitecture%" equ "x86" move /y "%Temp%\Win32Calc.exe" "%InstallMount%\%%i\Windows\System32\Win32Calc.exe" >nul

		if "%ImageArchitecture%" equ "x64" (
			move /y "%Temp%\Win32Calc64.exe" "%InstallMount%\%%i\Windows\System32\Win32Calc.exe" >nul
			move /y "%Temp%\Win32Calc32.exe" "%InstallMount%\%%i\Windows\SysWOW64\Win32Calc.exe" >nul
		)
	)
)

call :RemoveFile "%Temp%\ResourceHacker.exe"
call :RemoveFile "%Temp%\ResourceHacker.ini"
call :RemoveFile "%Temp%\ResourceHacker.log"
echo.
echo.-------------------------------------------------------------------------------
echo.####Finished Integrating Microsoft Win32Calc Metro Skin########################
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set Skins=

endlocal

:: Returning to Integrate Custom Features Menu
goto :IntCustomFeaturesMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Integrate Windows Photo Viewer Metro Skin
::-------------------------------------------------------------------------------------------
:IntWPVMetroSkin

setlocal

cls
echo.===============================================================================
echo.          MSMG ToolKit - Integrate Windows Photo Viewer Metro Skin
echo.===============================================================================
echo.

:: Getting Install Image Index Architecture
for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" call :GetImageArchitecture "%InstallWim%", %%i >nul
)

set "Skins=%Skins%\PhotoViewer"

:: Checking whether Windows Photo Viewer Metro Skin Pack file exist
for %%i in (PhotoViewer.dll.res, photowiz.dll.res) do (
	if not exist "%Skins%\%%i" (
		echo.Windows Photo Viewer Metro Skin Pack file "%%i" not found...
		echo.
		echo.Please copy the above file to ^<Packs\Skins\PhotoViewer^> folder...
		goto :Stop
	)
)

echo.-------------------------------------------------------------------------------
echo.####Starting Integrating Windows Photo Viewer Metro Skin#######################
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    : Install.wim
if /i "%ImageIndexNo%" equ "A" echo.    Image Indexes            : 1-%ImageCount%
if /i "%ImageIndexNo%" neq "A" echo.    Image Index              : %ImageIndexNo%
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
echo.
echo.-------------------------------------------------------------------------------
echo.####Integrating Windows Photo Viewer Metro Skin################################
echo.-------------------------------------------------------------------------------

copy /y %ResourceHacker% %Temp% >nul

for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" (
		echo.
		if not %%i gtr 9 echo.===========================[Install.wim, Index : %%i]============================
		if %%i gtr 9 echo.==========================[Install.wim, Index : %%i]============================
		echo.
		echo.Copying Windows Photo Viewer files to Temporary Folder...
		if "%ImageArchitecture%" equ "x86" (
			copy "%InstallMount%\%%i\Program Files\Windows Photo Viewer\PhotoViewer.dll" "%Temp%\PhotoViewer_x.dll" >nul
			copy "%InstallMount%\%%i\Windows\System32\photowiz.dll" "%Temp%\photowiz_x.dll" >nul
		)

		if "%ImageArchitecture%" equ "x64" (
			copy "%InstallMount%\%%i\Program Files\Windows Photo Viewer\PhotoViewer.dll" "%Temp%\PhotoViewer64_x.dll" >nul
			copy "%InstallMount%\%%i\Program Files (x86)\Windows Photo Viewer\PhotoViewer.dll" "%Temp%\PhotoViewer32_x.dll" >nul
			copy "%InstallMount%\%%i\Windows\System32\photowiz.dll" "%Temp%\photowiz64_x.dll" >nul
			copy "%InstallMount%\%%i\Windows\SysWOW64\photowiz.dll" "%Temp%\photowiz32_x.dll" >nul
		)

		echo.
		if "%ImageArchitecture%" equ "x86" (
			echo.Applying Windows Photo Viewer Metro Skin to [PhotoViewer.dll] file...
			"%Temp%\ResourceHacker.exe" -addoverwrite "%Temp%\PhotoViewer_x.dll", "%Temp%\PhotoViewer.dll", "%Skins%\PhotoViewer.dll.res" ,,,
			call :RemoveFile "%Temp%\PhotoViewer_x.dll"
			echo.
			echo.Applying Windows Photo Viewer Metro Skin to [photowiz.dll] file...
			"%Temp%\ResourceHacker.exe" -addoverwrite "%Temp%\photowiz_x.dll", "%Temp%\photowiz.dll", "%Skins%\photowiz.dll.res" ,,,
			call :RemoveFile "%Temp%\photowiz_x.dll"
		)

		if "%ImageArchitecture%" equ "x64" (
			echo.Applying Windows Photo Viewer Metro Skin to [PhotoViewer.dll] file...
			"%Temp%\ResourceHacker.exe" -addoverwrite "%Temp%\PhotoViewer32_x.dll", "%Temp%\PhotoViewer32.dll", "%Skins%\PhotoViewer.dll.res" ,,,
			call :RemoveFile "%Temp%\PhotoViewer32_x.dll"
			"%Temp%\ResourceHacker.exe" -addoverwrite "%Temp%\PhotoViewer64_x.dll", "%Temp%\PhotoViewer64.dll", "%Skins%\PhotoViewer.dll.res" ,,,
			call :RemoveFile "%Temp%\PhotoViewer64_x.dll"
			echo.
			echo.Applying Windows Photo Viewer Metro Skin to [photowiz.dll] file...
			"%Temp%\ResourceHacker.exe" -addoverwrite "%Temp%\photowiz32_x.dll", "%Temp%\photowiz32.dll", "%Skins%\photowiz.dll.res" ,,,
			call :RemoveFile "%Temp%\photowiz32_x.dll"
			"%Temp%\ResourceHacker.exe" -addoverwrite "%Temp%\photowiz64_x.dll", "%Temp%\photowiz64.dll", "%Skins%\photowiz.dll.res" ,,,
			call :RemoveFile "%Temp%\photowiz64_x.dll"
		)

		echo.
		echo.Copying Patched Windows Photo Viewer files...
		if "%ImageArchitecture%" equ "x86" (
			move /y "%Temp%\PhotoViewer.dll" "%InstallMount%\%%i\Program Files\Windows Photo Viewer\PhotoViewer.dll" >nul
			move /y "%Temp%\photowiz.dll" "%InstallMount%\%%i\Windows\System32\photowiz.dll" >nul
		)

		if "%ImageArchitecture%" equ "x64" (
			move /y "%Temp%\PhotoViewer64.dll" "%InstallMount%\%%i\Program Files\Windows Photo Viewer\PhotoViewer.dll" >nul
			move /y "%Temp%\PhotoViewer32.dll" "%InstallMount%\%%i\Program Files (x86)\Windows Photo Viewer\PhotoViewer.dll" >nul
			move /y "%Temp%\photowiz64.dll" "%InstallMount%\%%i\Windows\System32\photowiz.dll" >nul
			move /y "%Temp%\photowiz32.dll" "%InstallMount%\%%i\Windows\SysWOW64\photowiz.dll" >nul
		)
	)
)

call :RemoveFile "%Temp%\ResourceHacker.exe"
call :RemoveFile "%Temp%\ResourceHacker.ini"
call :RemoveFile "%Temp%\ResourceHacker.log"

echo.
echo.-------------------------------------------------------------------------------
echo.####Finished Integrating Windows Photo Viewer Metro Skin#######################
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set Skins=

endlocal

:: Returning to Integrate Custom Features Menu
goto :IntCustomFeaturesMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Integrate Windows Media Player Metro Skin
::-------------------------------------------------------------------------------------------
:IntWMPMetroSkin

setlocal

cls
echo.===============================================================================
echo.         MSMG ToolKit - Integrer le skin Metro de Windows Media Player 
echo.===============================================================================
echo.

:: Getting Install Image Index Architecture
for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" call :GetImageArchitecture "%InstallWim%", %%i >nul
)

set "Skins=%Skins%\MediaPlayer"

:: Checking whether Windows Media Player Metro Skin Pack file exist
for %%i in (setup_wm.exe.res, wmpconfig.exe.res, wmplayer.exe.res, wmploc.dll.res, wmpshare.exe.res, WMPSideShowGadget.exe.res) do (
	if not exist "%Skins%\%%i" (
		echo.Fichier Windows Media Player Metro Skin Pack "%%i" introuvable.
		echo.
		echo.Veuillez copier le fichier ci-dessus dans le dossier 
		echo.^<Packs\Skins\MediaPlayer^>. 
		goto :Stop
	)
)

echo.-------------------------------------------------------------------------------
echo.####Demarrage de l'integration du skin Metro de Windows Media Player ##########
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    : Install.wim
if /i "%ImageIndexNo%" equ "A" echo.    Image Indexes            : 1-%ImageCount%
if /i "%ImageIndexNo%" neq "A" echo.    Image Index              : %ImageIndexNo%
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
echo.
echo.-------------------------------------------------------------------------------
echo.####Integration du skin Metro de Windows Media Player #########################
echo.-------------------------------------------------------------------------------

copy /y %ResourceHacker% %Temp% >nul

for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" (
		echo.
		if not %%i gtr 9 echo.===========================[Install.wim, Index : %%i]============================
		if %%i gtr 9 echo.==========================[Install.wim, Index : %%i]============================
		echo.
		echo.Copying Windows Media Player files to Temporary Folder...
		if "%ImageArchitecture%" equ "x86" (
			copy "%InstallMount%\%%i\Program Files\Windows Media Player\setup_wm.exe" "%Temp%\setup_wm_x.exe" >nul
			copy "%InstallMount%\%%i\Program Files\Windows Media Player\wmpconfig.exe" "%Temp%\wmpconfig_x.exe" >nul
			copy "%InstallMount%\%%i\Program Files\Windows Media Player\wmplayer.exe" "%Temp%\wmplayer_x.exe" >nul
			copy "%InstallMount%\%%i\Program Files\Windows Media Player\wmpshare.exe" "%Temp%\wmpshare_x.exe" >nul
			if exist "%InstallMount%\%%i\Program Files\Windows Media Player\WMPSideShowGadget.exe" copy "%InstallMount%\%%i\Program Files\Windows Media Player\WMPSideShowGadget.exe" "%Temp%\WMPSideShowGadget_x.exe" >nul
			copy "%InstallMount%\%%i\Windows\System32\wmploc.dll" "%Temp%\wmploc_x.dll" >nul
		)

		if "%ImageArchitecture%" equ "x64" (
			copy "%InstallMount%\%%i\Program Files\Windows Media Player\setup_wm.exe" "%Temp%\setup_wm_x.exe" >nul
			copy "%InstallMount%\%%i\Program Files\Windows Media Player\wmpconfig.exe" "%Temp%\wmpconfig_x.exe" >nul
			copy "%InstallMount%\%%i\Program Files\Windows Media Player\wmplayer.exe" "%Temp%\wmplayer_x.exe" >nul
			copy "%InstallMount%\%%i\Program Files\Windows Media Player\wmpshare.exe" "%Temp%\wmpshare_x.exe" >nul
			if exist "%InstallMount%\%%i\Program Files\Windows Media Player\WMPSideShowGadget.exe" copy "%InstallMount%\%%i\Program Files\Windows Media Player\WMPSideShowGadget.exe" "%Temp%\WMPSideShowGadget_x.exe" >nul
			copy "%InstallMount%\%%i\Windows\System32\wmploc.dll" "%Temp%\wmploc64_x.dll" >nul
			copy "%InstallMount%\%%i\Windows\SysWOW64\wmploc.dll" "%Temp%\wmploc32_x.dll" >nul
		)

		echo.
		echo.Applying Windows Media Player Metro Skin to [setup_wm.exe] file...
		"%Temp%\ResourceHacker.exe" -addoverwrite "%Temp%\setup_wm_x.exe", "%Temp%\setup_wm.exe", "%Skins%\setup_wm.exe.res" ,,,
		call :RemoveFile "%Temp%\setup_wm_x.exe"
		echo.Applying Windows Media Player Metro Skin to [wmpconfig.exe] file...
		"%Temp%\ResourceHacker.exe" -addoverwrite "%Temp%\wmpconfig_x.exe", "%Temp%\wmpconfig.exe", "%Skins%\wmpconfig.exe.res" ,,,
		call :RemoveFile "%Temp%\wmpconfig_x.exe"
		echo.Applying Windows Media Player Metro Skin to [wmplayer.exe] file...
		"%Temp%\ResourceHacker.exe" -addoverwrite "%Temp%\wmplayer_x.exe", "%Temp%\wmplayer.exe", "%Skins%\wmplayer.exe.res" ,,,
		call :RemoveFile "%Temp%\wmplayer_x.exe"
		echo.Applying Windows Media Player Metro Skin to [wmpshare.exe] file...
		"%Temp%\ResourceHacker.exe" -addoverwrite "%Temp%\wmpshare_x.exe", "%Temp%\wmpshare.exe", "%Skins%\wmpshare.exe.res" ,,,
		call :RemoveFile "%Temp%\wmpshare_x.exe"

		if exist "%Temp%\WMPSideShowGadget_x.exe" (
			echo.Applying Windows Media Player Metro Skin to [WMPSideShowGadget.exe] file...
			"%Temp%\ResourceHacker.exe" -addoverwrite "%Temp%\WMPSideShowGadget_x.exe", "%Temp%\WMPSideShowGadget.exe", "%Skins%\WMPSideShowGadget.exe.res" ,,,
			call :RemoveFile "%Temp%\WMPSideShowGadget_x.exe"
		)

		if "%ImageArchitecture%" equ "x86" (
			echo.Applying Windows Media Player Metro Skin to [wmploc.dll] file...
			"%Temp%\ResourceHacker.exe" -addoverwrite "%Temp%\wmploc_x.dll", "%Temp%\wmploc.dll", "%Skins%\wmploc.dll.res" ,,,
			call :RemoveFile "%Temp%\wmploc_x.dll"
		)

		if "%ImageArchitecture%" equ "x64" (
			echo.Applying Windows Media Player Metro Skin to [wmploc.dll] file...
			"%Temp%\ResourceHacker.exe" -addoverwrite "%Temp%\wmploc32_x.dll", "%Temp%\wmploc32.dll", "%Skins%\wmploc.dll.res" ,,,
			call :RemoveFile "%Temp%\wmploc32_x.dll"
			"%Temp%\ResourceHacker.exe" -addoverwrite "%Temp%\wmploc64_x.dll", "%Temp%\wmploc64.dll", "%Skins%\wmploc.dll.res" ,,,
			call :RemoveFile "%Temp%\wmploc64_x.dll"
		)

		echo.
		echo.Copying Patched Windows Media Player files...
		move /y "%Temp%\setup_wm.exe" "%InstallMount%\%%i\Program Files\Windows Media Player\setup_wm.exe" >nul
		move /y "%Temp%\wmpconfig.exe" "%InstallMount%\%%i\Program Files\Windows Media Player\wmpconfig.exe" >nul
		move /y "%Temp%\wmplayer.exe" "%InstallMount%\%%i\Program Files\Windows Media Player\wmplayer.exe" >nul
		move /y "%Temp%\wmpshare.exe" "%InstallMount%\%%i\Program Files\Windows Media Player\wmpshare.exe" >nul
		if exist "%Temp%\WMPSideShowGadget.exe" move /y "%Temp%\WMPSideShowGadget.exe" "%InstallMount%\%%i\Program Files\Windows Media Player\WMPSideShowGadget.exe" >nul
		if "%ImageArchitecture%" equ "x86" move /y "%Temp%\wmploc.dll" "%InstallMount%\%%i\Windows\System32\wmploc.dll" >nul
		if "%ImageArchitecture%" equ "x64" move /y "%Temp%\wmploc64.dll" "%InstallMount%\%%i\Windows\System32\wmploc.dll" >nul
		if "%ImageArchitecture%" equ "x64" move /y "%Temp%\wmploc32.dll" "%InstallMount%\%%i\Windows\SysWOW64\wmploc.dll" >nul
	)
)

call :RemoveFile "%Temp%\ResourceHacker.exe"
call :RemoveFile "%Temp%\ResourceHacker.ini"
call :RemoveFile "%Temp%\ResourceHacker.log"

echo.
echo.-------------------------------------------------------------------------------
echo.####Fin de l'integration du skin Metro du lecteur Windows Media Player #####
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set Skins=

endlocal

:: Returning to Integrate Custom Features Menu
goto :IntCustomFeaturesMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Remove Windows Components Menu
::-------------------------------------------------------------------------------------------
:RemoveWindowsComponentsMenu

:: Remove Windows 10 v1809/v1903/v1909/v2004/v20H2 Client Edition
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "17763" if "%ImageBuild%" leq "19042" (
	cls
	echo.===============================================================================
	echo.               MSMG ToolKit - Supprimer les composants Windows
	echo.===============================================================================
	echo.
	echo.  [1]   Selectionner les composants Windows 
	echo.
	echo.  [2]   Supprimer les composants Windows
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.  [X]   Retour
	echo.
	echo.===============================================================================
	echo.
	choice /C:12X /N /M "Entrer votre choix : "
	if errorlevel 3 goto :RemoveMenu
	if errorlevel 2 goto :RemoveWindowsComponents
	if errorlevel 1 goto :SelectWindowsComponentsMenu
)

:SelectWindowsComponentsMenu
:: Remove Windows 10 v1809/v1903/v1909/v2004/v20H2 Client Edition
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "17763" if "%ImageBuild%" leq "19042" (
	cls
	echo.===============================================================================
	echo.              MSMG ToolKit - Supprimer les composants Windows 
	echo.===============================================================================
	echo.
	echo.  [1]   Internet
	echo.
	echo.  [2]   Multimedia
	echo.
	echo.  [3]   Confidentialite
	echo.
	echo.  [4]   Bureau a distance
	echo.
	echo.  [5]   Systeme
	echo.
	echo.  [6]   Applications Systeme 
	echo.
	echo.  [7]   Applications Windows
	echo.
	echo.
	echo.  [X]   Retour
	echo.
	echo.===============================================================================
	echo.
	choice /C:1234567X /N /M "Entrer votre choix : "
	if errorlevel 8 goto :RemoveWindowsComponentsMenu
	if errorlevel 7 goto :RemoveWindowsAppsMenu
	if errorlevel 6 goto :RemoveSystemAppsMenu
	if errorlevel 5 goto :RemoveSystemMenu
	if errorlevel 4 goto :RemoveRemotingMenu
	if errorlevel 3 goto :RemovePrivacyMenu
	if errorlevel 2 goto :RemoveMultimediaMenu
	if errorlevel 1 goto :RemoveInternetMenu
)

:RemoveInternetMenu
:: Remove Windows 10 v1809/v1903/v1909/v2004/v20H2 Client Internet Menu
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "17763" if "%ImageBuild%" leq "19042" (
	cls
	echo.===============================================================================
	echo.              MSMG ToolKit - Supprimer les composants Internet 
	echo.===============================================================================
	echo.
	echo.  [1] %C_AdobeFlashForWindows% Adobe Flash pour Windows
	echo.
	if "%ImageBuild%" leq "19041" (
		echo.  [2] %C_InternetExplorer% Internet Explorer
		echo.
		echo.
	)
	if "%ImageBuild%" equ "19042" (
		echo.  [2] %C_EdgeChromium% Edge Chromium Browser
		echo.
		echo.  [3] %C_InternetExplorer% Internet Explorer
	)
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.  [A]   Tous les composants Internet 
	echo.
	echo.  [X]   Retour
	echo.
	echo.===============================================================================
	echo.
	choice /C:123AX /N /M "Entrer votre choix : "
	if errorlevel 5 goto :SelectWindowsComponentsMenu
	if errorlevel 4 (
		set "C_AdobeFlashForWindows=-"
		if "%ImageBuild%" equ "19042" set "C_EdgeChromium=-"
		set "C_InternetExplorer=-"
	)
	if errorlevel 3 if "%ImageBuild%" equ "19042" (	if "%C_InternetExplorer%" equ "+" ( set "C_InternetExplorer=-" ) else ( set "C_InternetExplorer=+" ) )
	if errorlevel 2 if "%ImageBuild%" leq "19041" ( if "%C_InternetExplorer%" equ "+" ( set "C_InternetExplorer=-" ) else ( set "C_InternetExplorer=+" ) )
	if errorlevel 2 if "%ImageBuild%" equ "19042" ( if "%C_EdgeChromium%" equ "+" ( set "C_EdgeChromium=-" ) else ( set "C_EdgeChromium=+" ) )
	if errorlevel 1 ( if "%C_AdobeFlashForWindows%" equ "+" ( set "C_AdobeFlashForWindows=-" ) else ( set "C_AdobeFlashForWindows=+" ) )

	goto :RemoveInternetMenu
)

:RemoveMultimediaMenu
:: Remove Windows 10 v1809/v1903/v1909/v2004/v20H2 Client Multimedia Menu
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "17763" if "%ImageBuild%" leq "19042" (
	cls
	echo.===============================================================================
	echo.             MSMG ToolKit - Supprimer les composants multimedias 
	echo.===============================================================================
	echo.
	echo.  [1] %C_FirstLogonAnimation% Premiere animation de connexion 
	echo.  [2] %C_GameExplorer% Game Explorer ^| Necessaire pour les jeux Microsoft 
	echo.  [3] %C_SnippingTool% Outils de capture 
	echo.  [4] %C_SpeechRecognition% Reconnaissance vocale ^| Necessaire pour Cortana
	echo.  [5] %C_WindowsMediaPlayer% Lecteur Windows Media 
	echo.  [6] %C_WindowsPhotoViewer% Visionneuse de photos Windows 
	echo.  [7] %C_WinSAT% Outil d'evaluation du systeme Windows 
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.  [A]   Tous les composants Multimedia
	echo.
	echo.  [X]   Retour
	echo.
	echo.===============================================================================
	echo.
	choice /C:1234567AX /N /M "Entrer votre choix : "
	if errorlevel 9 goto :SelectWindowsComponentsMenu
	if errorlevel 8 (
		set "C_Cortana=-"
		set "C_FirstLogonAnimation=-"
		set "C_GameExplorer=-"
		set "C_SnippingTool=-"
		set "C_SpeechRecognition=-"
		set "C_WindowsMediaPlayer=-"
		set "C_WindowsPhotoViewer=-"
		set "C_WinSAT=-"
	)
	if errorlevel 7 ( if "%C_WinSAT%" equ "+" ( set "C_WinSAT=-" ) else ( set "C_WinSAT=+" ) )
	if errorlevel 6 ( if "%C_WindowsPhotoViewer%" equ "+" ( set "C_WindowsPhotoViewer=-" ) else ( set "C_WindowsPhotoViewer=+" ) )
	if errorlevel 5 ( if "%C_WindowsMediaPlayer%" equ "+" ( set "C_WindowsMediaPlayer=-" ) else ( set "C_WindowsMediaPlayer=+" ) )
	if errorlevel 4 ( 
		if "%C_SpeechRecognition%" equ "+" ( 
			set "C_Cortana=-"
			set "C_SpeechRecognition=-"
		) else ( 
			set "C_SpeechRecognition=+"
		)
	)
	if errorlevel 3 ( if "%C_SnippingTool%" equ "+" ( set "C_SnippingTool=-" ) else ( set "C_SnippingTool=+" ) )
	if errorlevel 2 ( if "%C_GameExplorer%" equ "+" ( set "C_GameExplorer=-" ) else  ( set "C_GameExplorer=+" ) )
	if errorlevel 1 ( if "%C_FirstLogonAnimation%" equ "+" ( set "C_FirstLogonAnimation=-" ) else  ( set "C_FirstLogonAnimation=+" ) )

	goto :RemoveMultimediaMenu
)

:RemovePrivacyMenu
:: Remove Windows 10 v1809/v1903/v1909/v2004/v20H2 Client Privacy Menu
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "17763" if "%ImageBuild%" leq "19042" (
	cls
	echo.===============================================================================
	echo.         MSMG ToolKit - Supprimer les composants de confidentialite 
	echo.===============================================================================
	echo.
	echo.  [A] %C_AssignedAccess% Acces attribue
	echo.  [B] %C_CEIP% Programme d'amelioration de l'experience client ^(CEIP^)
	echo.  [C] %C_FaceRecognition% Reconnaissance faciale
	echo.  [D] %C_KernelDebugging% Debogage du noyau ^| Depend de Rapport d'erreurs Windows
	echo.  [E] %C_LocationService% Service de localisation
	echo.  [F] %C_PicturePassword% Mot de passe d'image
	echo.  [G] %C_PinEnrollment% Prise en charge de la connexion par code PIN
	echo.  [H] %C_UnifiedTelemetryClient% Client de telemetrie unifiee ^(Asimov^) ^| Depend du Rapport d'erreurs
	echo.  [I] %C_WiFiNetworkManager% Gestionnaire de reseau WiFi ^(WiFi Sense^)
	if "%ImageBuild%" equ "17763" echo.  [J] %C_WindowsErrorReporting% Rapport d'erreurs Windows 
	if "%ImageBuild%" geq "18362" if "%ImageBuild%" leq "18363" echo.  [J] %C_WindowsErrorReporting% Rapport d'erreurs Windows  ^| Necessaire pour une experience hors boite 
	if "%ImageBuild%" geq "19041" if "%ImageBuild%" leq "19042" echo.  [J] %C_WindowsErrorReporting% Rapport d'erreurs Windows 
	echo.  [K] %C_WindowsInsiderHub% Windows Insider Hub
	echo.
	echo.
	echo.  [1]   Tous les composants de confidentialite
	echo.  [X]   Retour
	echo.
	echo.===============================================================================
	echo.
	choice /C:ABCDEFGHIJK1X /N /M "Entrer votre choix : "
	if errorlevel 13 goto :SelectWindowsComponentsMenu
	if errorlevel 12 (
		set "C_AssignedAccess=-"
		set "C_AssignedAccessLockApp=-"
		set "C_CEIP=-"
		set "C_FaceRecognition=-"
		set "C_KernelDebugging=-"
		set "C_LocationService=-"
		set "C_PicturePassword=-"
		set "C_PinEnrollment=-"
		set "C_UnifiedTelemetryClient=-"
		set "C_WiFiNetworkManager=-"
		set "C_WindowsErrorReporting=-"
		set "C_WindowsInsiderHub=-"
	)
	if errorlevel 11 ( if "%C_WindowsInsiderHub%" equ "+" ( set "C_WindowsInsiderHub=-" ) else ( set "C_WindowsInsiderHub=+" ) )
	if errorlevel 10 ( 
		if "%C_WindowsErrorReporting%" equ "+" ( 
			set "C_KernelDebugging=-"
			set "C_UnifiedTelemetryClient=-"
			set "C_WindowsErrorReporting=-"
		) else ( 
			set "C_WindowsErrorReporting=+"
		)
	)
	if errorlevel 9  ( if "%C_WiFiNetworkManager%" equ "+" ( set "C_WiFiNetworkManager=-" ) else ( set "C_WiFiNetworkManager=+" ) )
	if errorlevel 8 ( 
		if "%C_UnifiedTelemetryClient%" equ "+" ( 
			set "C_UnifiedTelemetryClient=-"
		) else ( 
			set "C_UnifiedTelemetryClient=+"
			set "C_WindowsErrorReporting=+"
		)
	)
	if errorlevel 7  ( if "%C_PinEnrollment%" equ "+" ( set "C_PinEnrollment=-" ) else ( set "C_PinEnrollment=+" ) )
	if errorlevel 6  ( if "%C_PicturePassword%" equ "+" ( set "C_PicturePassword=-" ) else ( set "C_PicturePassword=+" ) )
	if errorlevel 5  ( if "%C_LocationService%" equ "+" ( set "C_LocationService=-" ) else ( set "C_LocationService=+" ) )
	if errorlevel 4 ( 
		if "%C_KernelDebugging%" equ "+" ( 
			set "C_KernelDebugging=-"
		) else ( 
			set "C_KernelDebugging=+"
			set "C_WindowsErrorReporting=+"
		)
	)
	if errorlevel 3  ( if "%C_FaceRecognition%" equ "+" ( set "C_FaceRecognition=-" ) else ( set "C_FaceRecognition=+" ) )
	if errorlevel 2  ( if "%C_CEIP%" equ "+" ( set "C_CEIP=-" ) else ( set "C_CEIP=+" ) )
	if errorlevel 1 ( 
		if "%C_AssignedAccess%" equ "+" ( 
			set "C_AssignedAccess=-"
			set "C_AssignedAccessLockApp=-"
		) else ( 
			set "C_AssignedAccess=+"
		)
	)

	goto :RemovePrivacyMenu
)

:RemoveRemotingMenu
:: Remove Windows 10 v1809/v1903/v1909/v2004/v20H2 Client Remoting Menu
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "17763" if "%ImageBuild%" leq "19042" (
	cls
	echo.===============================================================================
	echo.          MSMG ToolKit - Supprimer le menu des composants a distance  
	echo.===============================================================================
	echo.
	echo.  [1] %C_HomeGroup% Groupe d'accueil 
	echo.
	echo.  [2] %C_MultiPointConnector% Connecteur MultiPoint 
	echo.
	echo.  [3] %C_RemoteAssistance% Assistance a distance
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.  [A]   Tous les composants a distance 
	echo.
	echo.  [X]   Retour
	echo.
	echo.===============================================================================
	echo.
	choice /C:123AX /N /M "Entrer votre choix : "
	if errorlevel 5 goto :SelectWindowsComponentsMenu
	if errorlevel 4 (
		set "C_HomeGroup=-"
		set "C_MultiPointConnector=-"
		set "C_RemoteAssistance=-"
	)
	if errorlevel 3 ( if "%C_RemoteAssistance%" equ "+" ( set "C_RemoteAssistance=-" ) else ( set "C_RemoteAssistance=+" ) )
	if errorlevel 2 ( if "%C_MultiPointConnector%" equ "+" ( set "C_MultiPointConnector=-" ) else ( set "C_MultiPointConnector=+" ) )
	if errorlevel 1 ( if "%C_HomeGroup%" equ "+" ( set "C_HomeGroup=-" ) else ( set "C_HomeGroup=+" ) )

	goto :RemoveRemotingMenu
)

:RemoveSystemMenu
:: Remove Windows 10 v1809/v1903/v1909/v2004/v20H2 Client System Menu
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "17763" if "%ImageBuild%" leq "19042" (
	cls
	echo.===============================================================================
	echo.              MSMG ToolKit - Supprimer les composants du systeme 
	echo.===============================================================================
	echo.  [A] %C_DeviceLockdown% Verrouillage de l'appareil ^(Experience integree ^)
	echo.  [B] %C_EaseOfAccessThemes% Facilite d'acces aux themes 
	echo.  [C] %C_EasyTransfer% Transfert facile 
	echo.  [D] %C_FileHistory% Historique du fichier
	echo.  [E] %C_ManualSetup% Configuration manuelle ^(Mise a niveau InPlace^)
	echo.  [F] %C_Paint% Paint
	echo.  [G] %C_SecurityCenter% Centre de securite ^| Depend de Windows Defender 
	echo.  [H] %C_StepsRecorder% Enregistreur d'etapes 
	echo.  [I] %C_SystemRestore% Restauration du systeme ^| Depend de la Sauvegarde Windows 
	echo.  [J] %C_WindowsBackup% Sauvegarde Windows 
	echo.  [K] %C_WindowsFirewall% Pare-feu Windows 
	echo.  [L] %C_WindowsSubsystemForLinux% Sous-systeme Windows pour Linux 
	echo.  [M] %C_WindowsToGo% Windows To Go
	echo.  [N] %C_Wordpad% Wordpad
	echo.
	echo.  [1]   Tous les composants du systeme 
	echo.
	echo.  [X]   Retour
	echo.===============================================================================
	echo.
	choice /C:ABCDEFGHIJKLMN1X /N /M "Entrer votre choix : "
	if errorlevel 16 goto :SelectWindowsComponentsMenu
	if errorlevel 15 (
		set "C_DeviceLockdown=-"
		set "C_EaseOfAccessThemes=-"
		set "C_EasyTransfer=-"
		set "C_FileHistory=-"
		set "C_ManualSetup=-"
		set "C_Paint=-"
		set "C_SecurityCenter=-"
		set "C_StepsRecorder=-"
		set "C_SystemRestore=-"
		set "C_WindowsBackup=-"
		set "C_WindowsFirewall=-"
		set "C_WindowsSubsystemForLinux=-"
		set "C_WindowsToGo=-"
		set "C_Wordpad=-"
	)
	if errorlevel 14 ( if "%C_Wordpad%" equ "+" ( set "C_Wordpad=-" ) else ( set "C_Wordpad=+" ) )
	if errorlevel 13 ( if "%C_WindowsToGo%" equ "+" ( set "C_WindowsToGo=-" ) else ( set "C_WindowsToGo=+" ) )
	if errorlevel 12 ( if "%C_WindowsSubsystemForLinux%" equ "+" ( set "C_WindowsSubsystemForLinux=-" ) else ( set "C_WindowsSubsystemForLinux=+" ) )
	if errorlevel 11 ( if "%C_WindowsFirewall%" equ "+" ( set "C_WindowsFirewall=-" ) else ( set "C_WindowsFirewall=+" ) )
	if errorlevel 10 ( 
		if "%C_WindowsBackup%" equ "+" ( 
			set "C_SystemRestore=-"
			set "C_WindowsBackup=-"
		) else ( 
			set "C_WindowsBackup=+"
		)
	)
	if errorlevel 9 ( 
		if "%C_SystemRestore%" equ "+" ( 
			set "C_SystemRestore=-"
		) else ( 
			set "C_SystemRestore=+"
			set "C_WindowsBackup=+"
		)
	)
	if errorlevel 8 ( if "%C_StepsRecorder%" equ "+" ( set "C_StepsRecorder=-" ) else ( set "C_StepsRecorder=+" ) )
	if errorlevel 7 (
		if "%C_SecurityCenter%" equ "+" ( 
			set "C_SecurityCenter=-"
		) else ( 
			set "C_SecurityCenter=+"
			set "C_WindowsDefender=+"
		)
	)
	if errorlevel 6 ( if "%C_Paint%" equ "+" ( set "C_Paint=-" ) else ( set "C_Paint=+" ) )
	if errorlevel 5 ( if "%C_ManualSetup%" equ "+" ( set "C_ManualSetup=-" ) else ( set "C_ManualSetup=+" ) )
	if errorlevel 4 ( if "%C_FileHistory%" equ "+" ( set "C_FileHistory=-" ) else ( set "C_FileHistory=+" ) )
	if errorlevel 3 ( if "%C_EasyTransfer%" equ "+" ( set "C_EasyTransfer=-" ) else ( set "C_EasyTransfer=+" ) )
	if errorlevel 2 ( if "%C_EaseOfAccessThemes%" equ "+" ( set "C_EaseOfAccessThemes=-" ) else ( set "C_EaseOfAccessThemes=+" ) )
	if errorlevel 1 ( if "%C_DeviceLockdown%" equ "+" ( set "C_DeviceLockdown=-" ) else ( set "C_DeviceLockdown=+" ) )

	goto :RemoveSystemMenu
)

:RemoveSystemAppsMenu
:: Remove Windows 10 v1809 Client Enterprise LTSC 2019 Client System Apps Menu
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "17763" if "%ImageFlag%" equ "EnterpriseS" (
	cls
	echo.===============================================================================
	echo.              MSMG ToolKit - Supprimer les applications systeme 
	echo.===============================================================================
	echo.  [01] %C_AssignedAccessLockApp% Application de verrouillage d'acces affecte
	echo.  [02] %C_AADBrokerPlugin% Plug-in Azure Active Directory Broker
	echo.  [03] %C_BioEnrollment% Application d'inscription bio
	echo.  [04] %C_CBSPreview% Scanner de codes barres de l'appareil photo
	echo.  [05] %C_ContentDeliveryManager% Gestionnaire de diffusion de contenu 
	echo.  [06] %C_Cortana% Cortana, Menu Demarrer ^& Parametres Recherche ^| Depend de la reconnaissance vocale
	echo.  [07] %C_EdgeDevToolsClient% Client des outils de developpement Edge
	echo.  [08] %C_ECApp% Application de controle oculaire
	echo.  [09] %C_FileExplorer% Application Explorateur de fichiers
	echo.  [10] %C_LockApp% Application de verrouillage
	echo.  [11] %C_MapControl% Contrôle de carte
	echo.  [12] %C_NarratorQuickStart% Demarrage rapide du narrateur
	echo.  [13] %C_ParentalControls% Controle parental
	echo.  [14] %C_PeopleExperienceHost% Barre de contacts
	echo.  [15] %C_QuickAssist% Application d'assistance rapide
	echo.  [16] %C_RetailDemoContent% Contenu de la demonstration au detail
	echo.  [17] %C_SettingSync% Réglage de la synchronisation
	echo.  [18] %C_SkypeORTC% Skype ORTC
	echo.  [19] %C_SmartScreen% Ecran intelligent ^| Depend de Windows Defender
	echo.  [20] %C_Win32WebViewHost% Win32 Web View Host
	echo.  [21] %C_WindowsDefender% Application Windows Defender
	echo.  [22] %C_WindowsMixedReality% Windows Mixed Reality
	echo.  [23] %C_WindowsReaderPDF% Lecteur Windows ^(PDF^)
	echo.  [24] %C_XboxGameCallableUI% Interface utilisateur appelable du jeu Xbox 
	echo.
	echo.  [A]    Toutes les applications systeme
	echo.  [X]    Retour
	echo.===============================================================================
	set /p MenuChoice=Entrer votre choix : 

	if /i "!MenuChoice!" equ "X" goto :SelectWindowsComponentsMenu
	if /i "!MenuChoice!" equ "A" (
		set "C_AADBrokerPlugin=-"
		set "C_AssignedAccessLockApp=-"
		set "C_BioEnrollment=-"
		set "C_CBSPreview=-"
		set "C_ContentDeliveryManager=-"
		set "C_Cortana=-"
		set "C_ECApp=-"
		set "C_EdgeDevToolsClient=-"
		set "C_FileExplorer=-"
		set "C_LockApp=-"
		set "C_MapControl=-"
		set "C_NarratorQuickStart=-"
		set "C_ParentalControls=-"
		set "C_PeopleExperienceHost=-"
		set "C_QuickAssist=-"
		set "C_RetailDemoContent=-"
		set "C_SecurityCenter=-"
		set "C_SettingSync=-"
		set "C_SkypeORTC=-"
		set "C_SmartScreen=-"
		set "C_Win32WebViewHost=-"
		set "C_WindowsDefender=-"
		set "C_WindowsMixedReality=-"
		set "C_WindowsReaderPDF=-"
		set "C_XboxGameCallableUI=-"
	)
	if "!MenuChoice!" equ "24" ( if "%C_XboxGameCallableUI%" equ "+" ( set "C_XboxGameCallableUI=-" ) else ( set "C_XboxGameCallableUI=+" ) )
	if "!MenuChoice!" equ "23" ( if "%C_WindowsReaderPDF%" equ "+" ( set "C_WindowsReaderPDF=-" ) else ( set "C_WindowsReaderPDF=+" ) )
	if "!MenuChoice!" equ "22" ( if "%C_WindowsMixedReality%" equ "+" ( set "C_WindowsMixedReality=-" ) else ( set "C_WindowsMixedReality=+" ) )
	if "!MenuChoice!" equ "21" (
		if "%C_WindowsDefender%" equ "+" ( 
			set "C_SecurityCenter=-"
			set "C_SmartScreen=-"
			set "C_WindowsDefender=-"
		) else ( 
			set "C_WindowsDefender=+"
		)
	)
	if "!MenuChoice!" equ "20" ( if "%C_Win32WebViewHost%" equ "+" ( set "C_Win32WebViewHost=-" ) else ( set "C_Win32WebViewHost=+" ) )
	if "!MenuChoice!" equ "19" (
		if "%C_SmartScreen%" equ "+" ( 
			set "C_SmartScreen=-"
		) else ( 
			set "C_SmartScreen=+"
			set "C_WindowsDefender=+"
		)
	)
	if "!MenuChoice!" equ "18" ( if "%C_SkypeORTC%" equ "+" ( set "C_SkypeORTC=-" ) else ( set "C_SkypeORTC=+" ) )
	if "!MenuChoice!" equ "17" ( if "%C_SettingSync%" equ "+" ( set "C_SettingSync=-" ) else ( set "C_SettingSync=+" ) )
	if "!MenuChoice!" equ "16" ( if "%C_RetailDemoContent%" equ "+" ( set "C_RetailDemoContent=-" ) else ( set "C_RetailDemoContent=+" ) )
	if "!MenuChoice!" equ "15" ( if "%C_QuickAssist%" equ "+" ( set "C_QuickAssist=-" ) else ( set "C_QuickAssist=+" ) )
	if "!MenuChoice!" equ "14" ( if "%C_PeopleExperienceHost%" equ "+" ( set "C_PeopleExperienceHost=-" ) else ( set "C_PeopleExperienceHost=+" ) )
	if "!MenuChoice!" equ "13" ( if "%C_ParentalControls%" equ "+" ( set "C_ParentalControls=-" ) else ( set "C_ParentalControls=+" ) )
	if "!MenuChoice!" equ "12" ( if "%C_NarratorQuickStart%" equ "+" ( set "C_NarratorQuickStart=-" ) else ( set "C_NarratorQuickStart=+" ) )
	if "!MenuChoice!" equ "11" ( if "%C_MapControl%" equ "+" ( set "C_MapControl=-" ) else ( set "C_MapControl=+" ) )
	if "!MenuChoice!" equ "10" ( if "%C_LockApp%" equ "+" ( set "C_LockApp=-" ) else ( set "C_LockApp=+" ) )
	if "!MenuChoice!" equ "09" ( if "%C_FileExplorer%" equ "+" ( set "C_FileExplorer=-" ) else ( set "C_FileExplorer=+" ) )
	if "!MenuChoice!" equ "08" ( if "%C_ECApp%" equ "+" ( set "C_ECApp=-" ) else ( set "C_ECApp=+" ) )
	if "!MenuChoice!" equ "07" ( if "%C_EdgeDevToolsClient%" equ "+" ( set "C_EdgeDevToolsClient=-" ) else ( set "C_EdgeDevToolsClient=+" ) )
	if "!MenuChoice!" equ "06" (
		if "%C_Cortana%" equ "+" ( 
			set "C_Cortana=-"
		) else ( 
			set "C_Cortana=+"
			set "C_SpeechRecognition=+"
		)
	)
	if "!MenuChoice!" equ "05" ( if "%C_ContentDeliveryManager%" equ "+" ( set "C_ContentDeliveryManager=-" ) else ( set "C_ContentDeliveryManager=+" ) )
	if "!MenuChoice!" equ "04" ( if "%C_CBSPreview%" equ "+" ( set "C_CBSPreview=-" ) else ( set "C_CBSPreview=+" ) )
	if "!MenuChoice!" equ "03" ( if "%C_BioEnrollment%" equ "+" ( set "C_BioEnrollment=-" ) else ( set "C_BioEnrollment=+" ) )
	if "!MenuChoice!" equ "02" ( if "%C_AADBrokerPlugin%" equ "+" ( set "C_AADBrokerPlugin=-" ) else ( set "C_AADBrokerPlugin=+" ) )
	if "!MenuChoice!" equ "01" (
		if "%C_AssignedAccessLockApp%" equ "+" ( 
			set "C_AssignedAccessLockApp=-"
		) else ( 
			set "C_AssignedAccess=+"
			set "C_AssignedAccessLockApp=+"
		)
	)
)

:: Remove Windows 10 v1809 Client Enterprise N LTSC 2019 Client System Apps Menu
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "17763" if "%ImageFlag%" equ "EnterpriseSN" (
	cls
	echo.===============================================================================
	echo.               MSMG ToolKit - Supprimer les applications systeme 
	echo.===============================================================================
	echo.  [01] %C_AssignedAccessLockApp% Application de verrouillage d'acces affecte
	echo.  [02] %C_AADBrokerPlugin% Plug-in Azure Active Directory Broker
	echo.  [03] %C_BioEnrollment% Application d'inscription biometrique
	echo.  [04] %C_CBSPreview% Scanner de codes barres de l'appareil photo
	echo.  [05] %C_ContentDeliveryManager% Gestionnaire de diffusion de contenu 
	echo.  [06] %C_Cortana% Cortana, Menu Demarrer ^& Parametres Recherche ^| Depend de la reconnaissance vocale
	echo.  [07] %C_EdgeDevToolsClient% Client des outils de developpement Edge
	echo.  [08] %C_ECApp% Application de controle oculaire
	echo.  [09] %C_FileExplorer% Application Explorateur de fichiers
	echo.  [10] %C_LockApp% Application de verrouillage
	echo.  [11] %C_MapControl% Contrôle de carte
	echo.  [12] %C_NarratorQuickStart% Demarrage rapide du narrateur
	echo.  [13] %C_ParentalControls% Controle parental
	echo.  [14] %C_PeopleExperienceHost% Barre de contacts
	echo.  [15] %C_QuickAssist% Application d'assistance rapide
	echo.  [16] %C_RetailDemoContent% Contenu de la demonstration au detail
	echo.  [17] %C_SettingSync% Réglage de la synchronisation
	echo.  [18] %C_SkypeORTC% Skype ORTC
	echo.  [19] %C_SmartScreen% Ecran intelligent ^| Depend de Windows Defender
	echo.  [20] %C_Win32WebViewHost% Win32 Web View Host
	echo.  [21] %C_WindowsDefender% Application Windows Defender
	echo.  [22] %C_WindowsMixedReality% Windows Mixed Reality
	echo.  [23] %C_WindowsReaderPDF% Lecteur Windows ^(PDF^)
	echo.  [24] %C_XboxGameCallableUI% Interface utilisateur appelable du jeu Xbox 
	echo.
	echo.  [A]    Toutes les applications systeme 
	echo.  [X]    Retour
	echo.===============================================================================
	set /p MenuChoice=Entrer votre choix : 

	if /i "!MenuChoice!" equ "X" goto :SelectWindowsComponentsMenu
	if /i "!MenuChoice!" equ "A" (
		set "C_AADBrokerPlugin=-"
		set "C_AssignedAccessLockApp=-"
		set "C_BioEnrollment=-"
		set "C_CBSPreview=-"
		set "C_ContentDeliveryManager=-"
		set "C_Cortana=-"
		set "C_ECApp=-"
		set "C_EdgeDevToolsClient=-"
		set "C_FileExplorer=-"
		set "C_LockApp=-"
		set "C_MapControl=-"
		set "C_NarratorQuickStart=-"
		set "C_ParentalControls=-"
		set "C_PeopleExperienceHost=-"
		set "C_QuickAssist=-"
		set "C_RetailDemoContent=-"
		set "C_SecurityCenter=-"
		set "C_SettingSync=-"
		set "C_SkypeORTC=-"
		set "C_SmartScreen=-"
		set "C_Win32WebViewHost=-"
		set "C_WindowsDefender=-"
		set "C_WindowsMixedReality=-"
		set "C_WindowsReaderPDF=-"
		set "C_XboxGameCallableUI=-"
	)
	if "!MenuChoice!" equ "24" ( if "%C_XboxGameCallableUI%" equ "+" ( set "C_XboxGameCallableUI=-" ) else ( set "C_XboxGameCallableUI=+" ) )
	if "!MenuChoice!" equ "23" ( if "%C_WindowsReaderPDF%" equ "+" ( set "C_WindowsReaderPDF=-" ) else ( set "C_WindowsReaderPDF=+" ) )
	if "!MenuChoice!" equ "22" ( if "%C_WindowsMixedReality%" equ "+" ( set "C_WindowsMixedReality=-" ) else ( set "C_WindowsMixedReality=+" ) )
	if "!MenuChoice!" equ "21" (
		if "%C_WindowsDefender%" equ "+" ( 
			set "C_SecurityCenter=-"
			set "C_SmartScreen=-"
			set "C_WindowsDefender=-"
		) else ( 
			set "C_WindowsDefender=+"
		)
	)
	if "!MenuChoice!" equ "20" ( if "%C_Win32WebViewHost%" equ "+" ( set "C_Win32WebViewHost=-" ) else ( set "C_Win32WebViewHost=+" ) )
	if "!MenuChoice!" equ "19" (
		if "%C_SmartScreen%" equ "+" ( 
			set "C_SmartScreen=-"
		) else ( 
			set "C_SmartScreen=+"
			set "C_WindowsDefender=+"
		)
	)
	if "!MenuChoice!" equ "18" ( if "%C_SkypeORTC%" equ "+" ( set "C_SkypeORTC=-" ) else ( set "C_SkypeORTC=+" ) )
	if "!MenuChoice!" equ "17" ( if "%C_SettingSync%" equ "+" ( set "C_SettingSync=-" ) else ( set "C_SettingSync=+" ) )
	if "!MenuChoice!" equ "16" ( if "%C_RetailDemoContent%" equ "+" ( set "C_RetailDemoContent=-" ) else ( set "C_RetailDemoContent=+" ) )
	if "!MenuChoice!" equ "15" ( if "%C_QuickAssist%" equ "+" ( set "C_QuickAssist=-" ) else ( set "C_QuickAssist=+" ) )
	if "!MenuChoice!" equ "14" ( if "%C_PeopleExperienceHost%" equ "+" ( set "C_PeopleExperienceHost=-" ) else ( set "C_PeopleExperienceHost=+" ) )
	if "!MenuChoice!" equ "13" ( if "%C_ParentalControls%" equ "+" ( set "C_ParentalControls=-" ) else ( set "C_ParentalControls=+" ) )
	if "!MenuChoice!" equ "12" ( if "%C_NarratorQuickStart%" equ "+" ( set "C_NarratorQuickStart=-" ) else ( set "C_NarratorQuickStart=+" ) )
	if "!MenuChoice!" equ "11" ( if "%C_MapControl%" equ "+" ( set "C_MapControl=-" ) else ( set "C_MapControl=+" ) )
	if "!MenuChoice!" equ "10" ( if "%C_LockApp%" equ "+" ( set "C_LockApp=-" ) else ( set "C_LockApp=+" ) )
	if "!MenuChoice!" equ "09" ( if "%C_FileExplorer%" equ "+" ( set "C_FileExplorer=-" ) else ( set "C_FileExplorer=+" ) )
	if "!MenuChoice!" equ "08" ( if "%C_ECApp%" equ "+" ( set "C_ECApp=-" ) else ( set "C_ECApp=+" ) )
	if "!MenuChoice!" equ "07" ( if "%C_EdgeDevToolsClient%" equ "+" ( set "C_EdgeDevToolsClient=-" ) else ( set "C_EdgeDevToolsClient=+" ) )
	if "!MenuChoice!" equ "06" (
		if "%C_Cortana%" equ "+" ( 
			set "C_Cortana=-"
		) else ( 
			set "C_Cortana=+"
			set "C_SpeechRecognition=+"
		)
	)
	if "!MenuChoice!" equ "05" ( if "%C_ContentDeliveryManager%" equ "+" ( set "C_ContentDeliveryManager=-" ) else ( set "C_ContentDeliveryManager=+" ) )
	if "!MenuChoice!" equ "04" ( if "%C_CBSPreview%" equ "+" ( set "C_CBSPreview=-" ) else ( set "C_CBSPreview=+" ) )
	if "!MenuChoice!" equ "03" ( if "%C_BioEnrollment%" equ "+" ( set "C_BioEnrollment=-" ) else ( set "C_BioEnrollment=+" ) )
	if "!MenuChoice!" equ "02" ( if "%C_AADBrokerPlugin%" equ "+" ( set "C_AADBrokerPlugin=-" ) else ( set "C_AADBrokerPlugin=+" ) )
	if "!MenuChoice!" equ "01" (
		if "%C_AssignedAccessLockApp%" equ "+" ( 
			set "C_AssignedAccessLockApp=-"
		) else ( 
			set "C_AssignedAccess=+"
			set "C_AssignedAccessLockApp=+"
		)
	)
)

:: Remove Windows 10 v1809 Client Edition System Apps Menu
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "17763" if "%ImageFlag%" neq "EnterpriseS" if "%ImageFlag%" neq "EnterpriseSN" (
	cls
	echo.===============================================================================
	echo.               MSMG ToolKit - Supprimer les applications systeme 
	echo.===============================================================================
	echo.  [01] %C_AssignedAccessLockApp% Application de verrouillage d'acces affecte ^| Depend de Acces attribue
	echo.  [02] %C_AADBrokerPlugin% Plug-in Azure Active Directory AppX Broker
	echo.  [03] %C_BioEnrollment% Application d'inscription biometrique
	echo.  [04] %C_CBSPreview% Scanner de codes-barres de l'appareil photo
	echo.  [05] %C_PPIProjection% Connecter l'application 
	echo.  [06] %C_ContentDeliveryManager% Content Delivery Manager ^| Necessaire pour une experience hors boite
	echo.  [07] %C_Cortana% Application Cortana ^| Depend de Reconnaissance faciale
	echo.  [08] %C_Edge% Navigateur classique Edge 
	echo.  [09] %C_EdgeDevToolsClient% Client des outils de developpement Edge ^| Depend de Edge Classic
	echo.  [10] %C_ECApp% Application de contrôle oculaire
	echo.  [11] %C_FileExplorer% Application Explorateur de fichiers
	echo.  [12] %C_LockApp% Application ecran verrouille
	echo.  [13] %C_MapControl% Controle de carte
	echo.  [14] %C_NarratorQuickStart% Demarrage rapide du narrateur
	echo.  [15] %C_OneDrive% Client de bureau OneDrive
	echo.  [16] %C_ParentalControls% Controle parental
	echo.  [17] %C_PeopleExperienceHost% Barre de contacts
	echo.  [18] %C_QuickAssist% Application d'assistance rapide
	echo.  [19] %C_RetailDemoContent% Contenu de la demonstration au detail
	echo.  [20] %C_SettingSync% Definition de la synchronisation
	echo.  [21] %C_SkypeORTC% Skype ORTC
	echo.  [22] %C_SmartScreen% Ecran intelligent ^| Depend de Windows Defender
	echo.  [23] %C_SecureAssessmentBrowser% Passer une application de test 
	echo.  [24] %C_Win32WebViewHost% Win32 Web View Host
	echo.  [25] %C_WindowsDefender% Application Windows Defender
	echo.  [26] %C_WindowsMixedReality% Windows Mixed Reality
	echo.  [27] %C_WindowsReaderPDF% Lecteur Windows ^(PDF^) ^| Depend de Edge Classic
	echo.  [28] %C_XboxGameCallableUI% Interface utilisateur appelable du jeu Xbox 
	echo.
	echo.  [A]    Toutes les applications systeme 
	echo.  [X]    Retour
	echo.===============================================================================
	set /p MenuChoice=Entrer votre choix : 

	if /i "!MenuChoice!" equ "X" goto :SelectWindowsComponentsMenu
	if /i "!MenuChoice!" equ "A" (
		set "C_3DViewer=-"
		set "C_AADBrokerPlugin=-"
		set "C_AssignedAccessLockApp=-"
		set "C_BioEnrollment=-"
		set "C_CBSPreview=-"
		set "C_ContentDeliveryManager=-"
		set "C_Cortana=-"
		set "C_ECApp=-"
		set "C_Edge=-"
		set "C_EdgeDevToolsClient=-"
		set "C_FileExplorer=-"
		set "C_LockApp=-"
		set "C_MapControl=-"
		set "C_Maps=-"
		if "%ImageArchitecture%" equ "x64" set "C_MixedRealityPortal=-"
		set "C_NarratorQuickStart=-"
		set "C_OneDrive=-"
		set "C_ParentalControls=-"
		set "C_People=-"
		set "C_PeopleExperienceHost=-"
		set "C_PPIProjection=-"
		set "C_QuickAssist=-"
		set "C_RetailDemoContent=-"
		set "C_SecureAssessmentBrowser=-"
		set "C_SecurityCenter=-"
		set "C_SettingSync=-"
		set "C_SkypeORTC=-"
		set "C_SolitaireCollection=-"
		set "C_SmartScreen=-"
		set "C_Win32WebViewHost=-"
		set "C_WindowsDefender=-"
		set "C_WindowsMixedReality=-"
		set "C_WindowsStore=-"
		set "C_WindowsReaderPDF=-"
		set "C_XboxGameCallableUI=-"
	)
	if "!MenuChoice!" equ "28" (
		if "%C_XboxGameCallableUI%" equ "+" ( 
			set "C_SolitaireCollection=-"
			set "C_XboxGameCallableUI=-"
		) else (
			set "C_XboxGameCallableUI=+"
		)
	)
	if "!MenuChoice!" equ "27" (
		if "%C_WindowsReaderPDF%" equ "+" ( 
			set "C_WindowsReaderPDF=-"
		) else (
			set "C_Edge=+"
			set "C_WindowsReaderPDF=+"
		)
	)
	if "!MenuChoice!" equ "26" (
		if "%C_WindowsMixedReality%" equ "+" ( 
			set "C_3DViewer=-"
			if "%ImageArchitecture%" equ "x64" set "C_MixedRealityPortal=-"
			set "C_WindowsMixedReality=-"
		) else ( 
			set "C_WindowsMixedReality=+"
		)
	)
	if "!MenuChoice!" equ "25" (
		if "%C_WindowsDefender%" equ "+" ( 
			set "C_SecurityCenter=-"
			set "C_SmartScreen=-"
            set "C_WindowsStore=-"
			set "C_WindowsDefender=-"
		) else ( 
			set "C_WindowsDefender=+"
		)
	)
	if "!MenuChoice!" equ "24" ( if "%C_Win32WebViewHost%" equ "+" ( set "C_Win32WebViewHost=-" ) else ( set "C_Win32WebViewHost=+" ) )
	if "!MenuChoice!" equ "23" ( if "%C_SecureAssessmentBrowser%" equ "+" ( set "C_SecureAssessmentBrowser=-" ) else ( set "C_SecureAssessmentBrowser=+" ) )
	if "!MenuChoice!" equ "22" (
		if "%C_SmartScreen%" equ "+" ( 
			set "C_SmartScreen=-"
			set "C_WindowsStore=-"
		) else ( 
			set "C_SmartScreen=+"
			set "C_WindowsDefender=+"
		)
	)
	if "!MenuChoice!" equ "21" ( if "%C_SkypeORTC%" equ "+" ( set "C_SkypeORTC=-" ) else ( set "C_SkypeORTC=+" ) )
	if "!MenuChoice!" equ "20" ( if "%C_SettingSync%" equ "+" ( set "C_SettingSync=-" ) else ( set "C_SettingSync=+" ) )
	if "!MenuChoice!" equ "19" ( if "%C_RetailDemoContent%" equ "+" ( set "C_RetailDemoContent=-" ) else ( set "C_RetailDemoContent=+" ) )
	if "!MenuChoice!" equ "18" ( if "%C_QuickAssist%" equ "+" ( set "C_QuickAssist=-" ) else ( set "C_QuickAssist=+" ) )
	if "!MenuChoice!" equ "17" (
		if "%C_PeopleExperienceHost%" equ "+" ( 
			set "C_People=-"
			set "C_PeopleExperienceHost=-"
		) else (
			set "C_PeopleExperienceHost=+"
		)
	)
	if "!MenuChoice!" equ "16" ( if "%C_ParentalControls%" equ "+" ( set "C_ParentalControls=-" ) else ( set "C_ParentalControls=+" ) )
	if "!MenuChoice!" equ "15" ( if "%C_OneDrive%" equ "+" ( set "C_OneDrive=-" ) else ( set "C_OneDrive=+" ) )
	if "!MenuChoice!" equ "14" ( if "%C_NarratorQuickStart%" equ "+" ( set "C_NarratorQuickStart=-" ) else ( set "C_NarratorQuickStart=+" ) )
	if "!MenuChoice!" equ "13" (
		if "%C_MapControl%" equ "+" ( 
			set "C_MapControl=-"
			set "C_Maps=-"
		) else (
			set "C_MapControl=+"
		)
	)
	if "!MenuChoice!" equ "12" ( if "%C_LockApp%" equ "+" ( set "C_LockApp=-" ) else ( set "C_LockApp=+" ) )
	if "!MenuChoice!" equ "11" ( if "%C_FileExplorer%" equ "+" ( set "C_FileExplorer=-" ) else ( set "C_FileExplorer=+" ) )
	if "!MenuChoice!" equ "10" ( if "%C_ECApp%" equ "+" ( set "C_ECApp=-" ) else ( set "C_ECApp=+" ) )
	if "!MenuChoice!" equ "09" (
		if "%C_EdgeDevToolsClient%" equ "+" ( 
			set "C_EdgeDevToolsClient=-"
		) else (
			set "C_Edge=+"
			set "C_EdgeDevToolsClient=+"
		)
	)
	if "!MenuChoice!" equ "08" (
		if "%C_Edge%" equ "+" ( 
			set "C_Edge=-"
			set "C_EdgeDevToolsClient=-"
			set "C_WindowsReaderPDF=-"
		) else (
			set "C_Edge=+"
		)
	)
	if "!MenuChoice!" equ "07" (
		if "%C_Cortana%" equ "+" ( 
			set "C_Cortana=-"
		) else ( 
			set "C_Cortana=+"
			set "C_SpeechRecognition=+"
		)
	)
	if "!MenuChoice!" equ "06" ( if "%C_ContentDeliveryManager%" equ "+" ( set "C_ContentDeliveryManager=-" ) else ( set "C_ContentDeliveryManager=+" ) )
	if "!MenuChoice!" equ "05" ( if "%C_PPIProjection%" equ "+" ( set "C_PPIProjection=-" ) else ( set "C_PPIProjection=+" ) )
	if "!MenuChoice!" equ "04" ( if "%C_CBSPreview%" equ "+" ( set "C_CBSPreview=-" ) else ( set "C_CBSPreview=+" ) )
	if "!MenuChoice!" equ "03" ( if "%C_BioEnrollment%" equ "+" ( set "C_BioEnrollment=-" ) else ( set "C_BioEnrollment=+" ) )
	if "!MenuChoice!" equ "02" ( if "%C_AADBrokerPlugin%" equ "+" ( set "C_AADBrokerPlugin=-" ) else ( set "C_AADBrokerPlugin=+" ) )
	if "!MenuChoice!" equ "01" (
		if "%C_AssignedAccessLockApp%" equ "+" ( 
			set "C_AssignedAccessLockApp=-"
		) else ( 
			set "C_AssignedAccess=+"
			set "C_AssignedAccessLockApp=+"
		)
	)
)

:: Remove Windows 10 v1903/v1909 Client Edition System Apps Menu
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "18362" if "%ImageBuild%" leq "18363" (
	cls
	echo.===============================================================================
	echo.               MSMG ToolKit - Supprimer les applications systeme 
	echo.===============================================================================
	echo.  [01] %C_AssignedAccessLockApp% Application de verrouillage d'acces affecte ^| Depend de Acces attribue
	echo.  [02] %C_AADBrokerPlugin% Plug-in Azure Active Directory AppX Broker
	echo.  [03] %C_BioEnrollment% Application d'inscription biometrique
	echo.  [04] %C_CallingShellApp% Appel de l'application Shell
	echo.  [05] %C_CBSPreview% Scanner de codes-barres de l'appareil photo
	echo.  [06] %C_PPIProjection% Connecter l'application 
	echo.  [07] %C_ContentDeliveryManager% Content Delivery Manager ^| Necessaire pour une experience hors boite
	echo.  [08] %C_Cortana% Application Cortana ^| Depend de Reconnaissance faciale
	echo.  [09] %C_Edge% Navigateur classique Edge 
	echo.  [10] %C_EdgeDevToolsClient% Client des outils de developpement Edge ^| Depend de Edge Classic
	echo.  [11] %C_ECApp% Application de contrôle oculaire
	echo.  [12] %C_FileExplorer% Application Explorateur de fichiers
	echo.  [13] %C_LockApp% Application ecran verrouille
	echo.  [14] %C_MapControl% Controle de carte
	echo.  [15] %C_NarratorQuickStart% Demarrage rapide du narrateur
	echo.  [16] %C_OneDrive% Client de bureau OneDrive
	echo.  [17] %C_ParentalControls% Controle parental
	echo.  [18] %C_PeopleExperienceHost% Barre de contacts
	echo.  [19] %C_QuickAssist% Application d'assistance rapide
	echo.  [20] %C_RetailDemoContent% Contenu de la demonstration au detail
	echo.  [21] %C_SettingSync% Definition de la synchronisation
	echo.  [22] %C_SkypeORTC% Skype ORTC
	echo.  [23] %C_SmartScreen% Ecran intelligent ^| Depend de Windows Defender
	echo.  [24] %C_SecureAssessmentBrowser% Passer une application de test 
	echo.  [25] %C_Win32WebViewHost% Win32 Web View Host
	echo.  [26] %C_WindowsDefender% Application Windows Defender
	echo.  [27] %C_WindowsMixedReality% Windows Mixed Reality
	echo.  [28] %C_WindowsReaderPDF% Lecteur Windows ^(PDF^) ^| Depend de Edge Classic
	echo.  [29] %C_XboxGameCallableUI% Interface utilisateur appelable du jeu Xbox 
	echo.
	echo.  [A]    Toutes les applications systeme 
	echo.  [X]    Retour
	echo.===============================================================================
	set /p MenuChoice=Entrer votre choix : 

	if /i "!MenuChoice!" equ "X" goto :SelectWindowsComponentsMenu
	if /i "!MenuChoice!" equ "A" (
		set "C_AADBrokerPlugin=-"
		set "C_AssignedAccessLockApp=-"
		set "C_BioEnrollment=-"
		set "C_CallingShellApp=-"
		set "C_CBSPreview=-"
		set "C_ContentDeliveryManager=-"
		set "C_Cortana=-"
		set "C_ECApp=-"
		set "C_Edge=-"
		set "C_EdgeDevToolsClient=-"
		set "C_FileExplorer=-"
		set "C_LockApp=-"
		set "C_MapControl=-"
		set "C_NarratorQuickStart=-"
		set "C_OneDrive=-"
		set "C_ParentalControls=-"
		set "C_PeopleExperienceHost=-"
		set "C_PPIProjection=-"
		set "C_QuickAssist=-"
		set "C_RetailDemoContent=-"
		set "C_SecureAssessmentBrowser=-"
		set "C_SecurityCenter=-"
		set "C_SettingSync=-"
		set "C_SkypeORTC=-"
		set "C_SmartScreen=-"
		set "C_Win32WebViewHost=-"
		set "C_WindowsDefender=-"
		set "C_WindowsMixedReality=-"
		set "C_WindowsReaderPDF=-"
		set "C_XboxGameCallableUI=-"
	)

	if "!MenuChoice!" equ "29" ( if "%C_XboxGameCallableUI%" equ "+" ( set "C_XboxGameCallableUI=-" ) else ( set "C_XboxGameCallableUI=+" ) )
	if "!MenuChoice!" equ "28" ( if "%C_WindowsReaderPDF%" equ "+" ( set "C_WindowsReaderPDF=-" ) else ( set "C_WindowsReaderPDF=+" ) )
	if "!MenuChoice!" equ "27" ( if "%C_WindowsMixedReality%" equ "+" ( set "C_WindowsMixedReality=-" ) else ( set "C_WindowsMixedReality=+" ) )
	if "!MenuChoice!" equ "26" ( if "%C_WindowsDefender%" equ "+" ( set "C_WindowsDefender=-" ) else ( set "C_WindowsDefender=+" ) )
	if "!MenuChoice!" equ "25" ( if "%C_Win32WebViewHost%" equ "+" ( set "C_Win32WebViewHost=-" ) else ( set "C_Win32WebViewHost=+" ) )
	if "!MenuChoice!" equ "24" ( if "%C_SecureAssessmentBrowser%" equ "+" ( set "C_SecureAssessmentBrowser=-" ) else ( set "C_SecureAssessmentBrowser=+" ) )
	if "!MenuChoice!" equ "23" ( if "%C_SmartScreen%" equ "+" ( set "C_SmartScreen=-" ) else ( set "C_SmartScreen=+" ) )
	if "!MenuChoice!" equ "22" ( if "%C_SkypeORTC%" equ "+" ( set "C_SkypeORTC=-" ) else ( set "C_SkypeORTC=+" ) )
	if "!MenuChoice!" equ "21" ( if "%C_SettingSync%" equ "+" ( set "C_SettingSync=-" ) else ( set "C_SettingSync=+" ) )
	if "!MenuChoice!" equ "20" ( if "%C_RetailDemoContent%" equ "+" ( set "C_RetailDemoContent=-" ) else ( set "C_RetailDemoContent=+" ) )
	if "!MenuChoice!" equ "19" ( if "%C_QuickAssist%" equ "+" ( set "C_QuickAssist=-" ) else ( set "C_QuickAssist=+" ) )
	if "!MenuChoice!" equ "18" ( if "%C_PeopleExperienceHost%" equ "+" ( set "C_PeopleExperienceHost=-" ) else ( set "C_PeopleExperienceHost=+" ) )
	if "!MenuChoice!" equ "17" ( if "%C_ParentalControls%" equ "+" ( set "C_ParentalControls=-" ) else ( set "C_ParentalControls=+" ) )
	if "!MenuChoice!" equ "16" ( if "%C_OneDrive%" equ "+" ( set "C_OneDrive=-" ) else ( set "C_OneDrive=+" ) )
	if "!MenuChoice!" equ "15" ( if "%C_NarratorQuickStart%" equ "+" ( set "C_NarratorQuickStart=-" ) else ( set "C_NarratorQuickStart=+" ) )
	if "!MenuChoice!" equ "14" ( if "%C_MapControl%" equ "+" ( set "C_MapControl=-" ) else ( set "C_MapControl=+" ) )
	if "!MenuChoice!" equ "13" ( if "%C_LockApp%" equ "+" ( set "C_LockApp=-" ) else ( set "C_LockApp=+" ) )
	if "!MenuChoice!" equ "12" ( if "%C_FileExplorer%" equ "+" ( set "C_FileExplorer=-" ) else ( set "C_FileExplorer=+" ) )
	if "!MenuChoice!" equ "11" ( if "%C_ECApp%" equ "+" ( set "C_ECApp=-" ) else ( set "C_ECApp=+" ) )
	if "!MenuChoice!" equ "10" ( if "%C_EdgeDevToolsClient%" equ "+" ( set "C_EdgeDevToolsClient=-" ) else ( set "C_EdgeDevToolsClient=+" ) )
	if "!MenuChoice!" equ "09" ( if "%C_Edge%" equ "+" ( set "C_Edge=-" ) else ( set "C_Edge=+" ) )
	if "!MenuChoice!" equ "08" ( if "%C_Cortana%" equ "+" ( set "C_Cortana=-" ) else ( set "C_Cortana=+" ) )
	if "!MenuChoice!" equ "07" ( if "%C_ContentDeliveryManager%" equ "+" ( set "C_ContentDeliveryManager=-" ) else ( set "C_ContentDeliveryManager=+" ) )
	if "!MenuChoice!" equ "06" ( if "%C_PPIProjection%" equ "+" ( set "C_PPIProjection=-" ) else ( set "C_PPIProjection=+" ) )
	if "!MenuChoice!" equ "05" ( if "%C_CBSPreview%" equ "+" ( set "C_CBSPreview=-" ) else ( set "C_CBSPreview=+" ) )
	if "!MenuChoice!" equ "04" ( if "%C_CallingShellApp%" equ "+" ( set "CallingShellApp=-" ) else ( set "CallingShellApp=+" ) )
	if "!MenuChoice!" equ "03" ( if "%C_BioEnrollment%" equ "+" ( set "C_BioEnrollment=-" ) else ( set "C_BioEnrollment=+" ) )
	if "!MenuChoice!" equ "02" ( if "%C_AADBrokerPlugin%" equ "+" ( set "C_AADBrokerPlugin=-" ) else ( set "C_AADBrokerPlugin=+" ) )
	if "!MenuChoice!" equ "01" ( if "%C_AssignedAccessLockApp%" equ "+" ( set "C_AssignedAccessLockApp=-" ) else ( set "C_AssignedAccessLockApp=+" ) )
)

:: Remove Windows 10 v2004/v20H2 Client Edition System Apps Menu
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "19041" if "%ImageBuild%" leq "19042" (
	cls
	echo.===============================================================================
	echo.               MSMG ToolKit - Supprimer les applications systeme
	echo.===============================================================================
	echo.  [01] %C_AssignedAccessLockApp% Application de verrouillage d'acces affecte ^| Depend de Acces attribue
	echo.  [02] %C_AADBrokerPlugin% Plug-in Azure Active Directory AppX Broker
	echo.  [03] %C_BioEnrollment% Application d'inscription biometrique
	echo.  [04] %C_CallingShellApp% Appel de l'application Shell
	echo.  [05] %C_CBSPreview% Scanner de codes-barres de l'appareil photo
	echo.  [06] %C_ContentDeliveryManager% Content Delivery Manager ^| Necessaire pour une experience hors boite
	echo.  [07] %C_Edge% Navigateur classique Edge 
	echo.  [08] %C_EdgeDevToolsClient% Client des outils de developpement Edge ^| Depend de Edge Classic
	echo.  [09] %C_ECApp% Application de contrôle oculaire
	echo.  [10] %C_FileExplorer% Application Explorateur de fichiers
	echo.  [11] %C_LockApp% Application ecran verrouille
	echo.  [12] %C_MapControl% Controle de carte
	echo.  [13] %C_NarratorQuickStart% Demarrage rapide du narrateur
	echo.  [14] %C_OneDrive% Client de bureau OneDrive
	echo.  [15] %C_ParentalControls% Controle parental
	echo.  [16] %C_PeopleExperienceHost% Barre de contacts
	echo.  [17] %C_QuickAssist% Application d'assistance rapide
	echo.  [18] %C_RetailDemoContent% Contenu de la demonstration au detail
	echo.  [19] %C_SettingSync% Definition de la synchronisation
	echo.  [20] %C_SkypeORTC% Skype ORTC
	echo.  [21] %C_SmartScreen% Ecran intelligent ^| Depend de Windows Defender
	echo.  [22] %C_SecureAssessmentBrowser% Passer une application de test 
	echo.  [23] %C_Win32WebViewHost% Win32 Web View Host
	echo.  [24] %C_WindowsDefender% Application Windows Defender
	echo.  [25] %C_WindowsMixedReality% Windows Mixed Reality
	echo.  [26] %C_WindowsReaderPDF% Lecteur Windows ^(PDF^) ^| Depend de Edge Classic
	echo.  [27] %C_XboxGameCallableUI% Interface utilisateur appelable du jeu Xbox 
	echo.
	echo.  [A]    Toutes les applications systeme 
	echo.  [X]    Retour
	echo.===============================================================================
	set /p MenuChoice=Entrer votre choix : 

	if /i "!MenuChoice!" equ "X" goto :SelectWindowsComponentsMenu
	if /i "!MenuChoice!" equ "A" (
		set "C_3DViewer=-"
		set "C_AADBrokerPlugin=-"
		set "C_AssignedAccessLockApp=-"
		set "C_BioEnrollment=-"
		set "C_CallingShellApp=-"
		set "C_CBSPreview=-"
		set "C_ContentDeliveryManager=-"
		set "C_ECApp=-"
		set "C_Edge=-"
		set "C_EdgeDevToolsClient=-"
		set "C_FileExplorer=-"
		set "C_LockApp=-"
		set "C_MapControl=-"
		set "C_Maps=-"
		if "%ImageArchitecture%" equ "x64" set "C_MixedRealityPortal=-"
		set "C_NarratorQuickStart=-"
		set "C_OneDrive=-"
		set "C_ParentalControls=-"
		set "C_People=-"
		set "C_PeopleExperienceHost=-"
		set "C_QuickAssist=-"
		set "C_RetailDemoContent=-"
		set "C_SecureAssessmentBrowser=-"
		set "C_SecurityCenter=-"
		set "C_SettingSync=-"
		set "C_StickyNotes=-"
		set "C_SkypeORTC=-"
		set "C_SolitaireCollection=-"
		set "C_SmartScreen=-"
		set "C_Win32WebViewHost=-"
		set "C_WindowsDefender=-"
		set "C_WindowsMixedReality=-"
		set "C_WindowsStore=-"
		set "C_WindowsReaderPDF=-"
		set "C_XboxGameCallableUI=-"
	)

	if "!MenuChoice!" equ "27" (
		if "%C_XboxGameCallableUI%" equ "+" ( 
			set "C_SolitaireCollection=-"
			set "C_XboxGameCallableUI=-"
		) else (
			set "C_XboxGameCallableUI=+"
		)
	)
	if "!MenuChoice!" equ "26" (
		if "%C_WindowsReaderPDF%" equ "+" ( 
			set "C_WindowsReaderPDF=-"
		) else (
			set "C_Edge=+"
			set "C_WindowsReaderPDF=+"
		)
	)
	if "!MenuChoice!" equ "25" (
		if "%C_WindowsMixedReality%" equ "+" ( 
			set "C_3DViewer=-"
			if "%ImageArchitecture%" equ "x64" set "C_MixedRealityPortal=-"
			set "C_WindowsMixedReality=-"
		) else ( 
			set "C_WindowsMixedReality=+"
		)
	)
	if "!MenuChoice!" equ "24" (
		if "%C_WindowsDefender%" equ "+" ( 
			set "C_SecurityCenter=-"
			set "C_SmartScreen=-"
			set "C_StickyNotes=-"
            set "C_WindowsStore=-"
			set "C_WindowsDefender=-"
		) else ( 
			set "C_WindowsDefender=+"
		)
	)
	if "!MenuChoice!" equ "23" ( if "%C_Win32WebViewHost%" equ "+" ( set "C_Win32WebViewHost=-" ) else ( set "C_Win32WebViewHost=+" ) )
	if "!MenuChoice!" equ "22" ( if "%C_SecureAssessmentBrowser%" equ "+" ( set "C_SecureAssessmentBrowser=-" ) else ( set "C_SecureAssessmentBrowser=+" ) )
	if "!MenuChoice!" equ "21" (
		if "%C_SmartScreen%" equ "+" ( 
			set "C_SmartScreen=-"
			set "C_WindowsStore=-"
		) else ( 
			set "C_SmartScreen=+"
			set "C_WindowsDefender=+"
		)
	)
	if "!MenuChoice!" equ "20" ( if "%C_SkypeORTC%" equ "+" ( set "C_SkypeORTC=-" ) else ( set "C_SkypeORTC=+" ) )
	if "!MenuChoice!" equ "19" ( if "%C_SettingSync%" equ "+" ( set "C_SettingSync=-" ) else ( set "C_SettingSync=+" ) )
	if "!MenuChoice!" equ "18" ( if "%C_RetailDemoContent%" equ "+" ( set "C_RetailDemoContent=-" ) else ( set "C_RetailDemoContent=+" ) )
	if "!MenuChoice!" equ "17" ( if "%C_QuickAssist%" equ "+" ( set "C_QuickAssist=-" ) else ( set "C_QuickAssist=+" ) )
	if "!MenuChoice!" equ "16" (
		if "%C_PeopleExperienceHost%" equ "+" ( 
			set "C_People=-"
			set "C_PeopleExperienceHost=-"
		) else (
			set "C_PeopleExperienceHost=+"
		)
	)
	if "!MenuChoice!" equ "15" ( if "%C_ParentalControls%" equ "+" ( set "C_ParentalControls=-" ) else ( set "C_ParentalControls=+" ) )
	if "!MenuChoice!" equ "14" ( if "%C_OneDrive%" equ "+" ( set "C_OneDrive=-" ) else ( set "C_OneDrive=+" ) )
	if "!MenuChoice!" equ "13" ( if "%C_NarratorQuickStart%" equ "+" ( set "C_NarratorQuickStart=-" ) else ( set "C_NarratorQuickStart=+" ) )
	if "!MenuChoice!" equ "12" (
		if "%C_MapControl%" equ "+" ( 
			set "C_MapControl=-"
			set "C_Maps=-"
		) else (
			set "C_MapControl=+"
		)
	)
	if "!MenuChoice!" equ "11" ( if "%C_LockApp%" equ "+" ( set "C_LockApp=-" ) else ( set "C_LockApp=+" ) )
	if "!MenuChoice!" equ "10" ( if "%C_FileExplorer%" equ "+" ( set "C_FileExplorer=-" ) else ( set "C_FileExplorer=+" ) )
	if "!MenuChoice!" equ "09" ( if "%C_ECApp%" equ "+" ( set "C_ECApp=-" ) else ( set "C_ECApp=+" ) )
	if "!MenuChoice!" equ "08" (
		if "%C_EdgeDevToolsClient%" equ "+" ( 
			set "C_EdgeDevToolsClient=-"
		) else (
			set "C_Edge=+"
			set "C_EdgeDevToolsClient=+"
		)
	)
	if "!MenuChoice!" equ "07" (
		if "%C_Edge%" equ "+" ( 
			set "C_Edge=-"
			set "C_EdgeDevToolsClient=-"
			set "C_WindowsReaderPDF=-"
		) else (
			set "C_Edge=+"
		)
	)
	if "!MenuChoice!" equ "06" ( if "%C_ContentDeliveryManager%" equ "+" ( set "C_ContentDeliveryManager=-" ) else ( set "C_ContentDeliveryManager=+" ) )
	if "!MenuChoice!" equ "05" ( if "%C_CBSPreview%" equ "+" ( set "C_CBSPreview=-" ) else ( set "C_CBSPreview=+" ) )
	if "!MenuChoice!" equ "04" ( if "%C_CallingShellApp%" equ "+" ( set "CallingShellApp=-" ) else ( set "CallingShellApp=+" ) )
	if "!MenuChoice!" equ "03" ( if "%C_BioEnrollment%" equ "+" ( set "C_BioEnrollment=-" ) else ( set "C_BioEnrollment=+" ) )
	if "!MenuChoice!" equ "02" ( if "%C_AADBrokerPlugin%" equ "+" ( set "C_AADBrokerPlugin=-" ) else ( set "C_AADBrokerPlugin=+" ) )
	if "!MenuChoice!" equ "01" (
		if "%C_AssignedAccessLockApp%" equ "+" ( 
			set "C_AssignedAccessLockApp=-"
		) else ( 
			set "C_AssignedAccess=+"
			set "C_AssignedAccessLockApp=+"
		)
	)
)

:: Returing to Remove System Apps Menu
goto :RemoveSystemAppsMenu

:RemoveWindowsAppsMenu
:: Remove Windows 10 v1809 Client Enterprise LTSC 2019 Client System Apps Menu
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "17763" if "%ImageFlag%" equ "EnterpriseS" (
	cls
	echo.===============================================================================
	echo.               MSMG ToolKit - Supprimer les applications systeme
	echo.===============================================================================
	echo.
	echo.  [1] %C_WindowsStore% Back-end du Windows Store 
	echo.
	echo.  [2] %C_XboxApp% Back-end de l'application Xbox 
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.  [X]   Retour
	echo.
	echo.===============================================================================
	echo.
	choice /C:12X /N /M "Entrer votre choix : "
	if errorlevel 3 goto :SelectWindowsComponentsMenu
	if errorlevel 2 ( if "%C_XboxApp%" equ "+" ( set "C_XboxApp=-" ) else ( set "C_XboxApp=+" ) )
	if errorlevel 1 ( if "%C_WindowsStore%" equ "+" ( set "C_WindowsStore=-" ) else ( set "C_WindowsStore=+" ) )
)

:: Remove Windows 10 v1809 Client Enterprise N LTSC 2019 Client System Apps Menu
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "17763" if "%ImageFlag%" equ "EnterpriseSN" (
	cls
	echo.===============================================================================
	echo.               MSMG ToolKit - Supprimer les applications systeme
	echo.===============================================================================
	echo.
	echo.  [1] %C_WindowsStore% Back-end du Windows Store 
	echo.
	echo.  [2] %C_XboxApp% Back-end de l'application Xbox 
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.  [X]   Retour
	echo.
	echo.===============================================================================
	echo.
	choice /C:12X /N /M "Entrer votre choix : "
	if errorlevel 3 goto :SelectWindowsComponentsMenu
	if errorlevel 2 ( if "%C_XboxApp%" equ "+" ( set "C_XboxApp=-" ) else ( set "C_XboxApp=+" ) )
	if errorlevel 1 ( if "%C_WindowsStore%" equ "+" ( set "C_WindowsStore=-" ) else ( set "C_WindowsStore=+" ) )
)

:: Remove Windows 10 v1809/v1903/v1909 Client 32-Bit Client Windows Apps Menu
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "17763" if "%ImageBuild%" leq "18363" if "%ImageArchitecture%" equ "x86" if "%ImageFlag%" neq "EnterpriseS" if "%ImageFlag%" neq "EnterpriseSN" (
	cls
	echo.===============================================================================
	echo.               MSMG ToolKit - Supprimer les applications Windows 
	echo.===============================================================================
	echo.  [01] %C_AdvertisingXaml% Xaml publicitaire
	echo.  [02] %C_Alarms% Alarmes ^& application Horloge
	echo.  [03] %C_Calculator% Application Calculatrice
	echo.  [04] %C_Camera% Application pour appareil photo
	echo.  [05] %C_DesktopAppInstaller% Programme d'installation de l'application de bureau
	echo.  [06] %C_FeedbackHub% Application Hub Feedback
	echo.  [07] %C_ZuneVideo% Films et application TV
	echo.  [08] %C_GetHelp% Obtenir l'application d'aide
	echo.  [09] %C_VP9VideoExtensions% Plugin de codec vidéo VP9 WebM de Google
	echo.  [10] %C_ZuneMusic% Application Groove Music
	echo.  [11] %C_HEIFImageExtension% Plugin de codec High Efficiency Image File ^(HEIF^)
	echo.  [12] %C_Maps% Application Maps ^| Depends de Controle de la carte
	echo.  [13] %C_Messaging% Application Messagerie
	echo.  [14] %C_WalletService% Application Microsoft Pay
	echo.  [15] %C_3DViewer% Application de visionneuse de realite ^| Depend de Windows Mixed Reality
	echo.  [16] %C_OneConnect% Application pour les forfaits mobiles
	echo.  [17] %C_OfficeHub% Mon application Office
	echo.  [18] %C_OfficeOneNote% Application OneNote
	echo.  [19] %C_Paint3D% Application Paint 3D
	echo.  [20] %C_People% Application Contacts ^| Depend de Barre de contacts
	echo.  [21] %C_Photos% Application Photos
	echo.  [22] %C_Print3D% Application d'impression 3D
	echo.  [23] %C_ScreenSketch% Application de croquis d'ecran
	echo.  [24] %C_SkypeApp% Application Skype
	echo.  [25] %C_SolitaireCollection% Application solitaire ^| Depend de Xbox Game
	if "%ImageBuild%" equ "17763" echo.  [26] %C_StickyNotes% Application Notes autocollantes
	if "%ImageBuild%" neq "17763" echo.  [26] %C_StickyNotes% Application Notes autocollantes ^| Depend de Windows Store
	echo.  [27] %C_Getstarted% Application Tips 
	echo.  [28] %C_SoundRecorder% Application Enregistreur vocal
	echo.  [29] %C_BingWeather% Application Meteo ^| Depend de Publicite Xaml
	echo.  [30] %C_WebMediaExtensions% Web Media Codec Plugin
	echo.  [31] %C_WebpImageExtensions% WebP Image Codec Plugin
	echo.  [32] %C_CommunicationsApps% Application Windows Mail ^| Depend de Publicite Xaml
	echo.  [33] %C_WindowsStore% Windows Store ^| Depends de Ecran intelligent
	echo.  [34] %C_XboxApp% Application Xbox 
	echo.  [35] %C_XboxIdentityProvider% Fournisseur d'identite Xbox
	echo.  [36] %C_YourPhone% Votre application telephonique 
	echo.
	echo.  [A]    Toutes les applications Windows 
	echo.  [X]    Retour
	echo.===============================================================================
	set /p MenuChoice=Entrer votre choix : 

	if /i "!MenuChoice!" equ "X" goto :SelectWindowsComponentsMenu
	if /i "!MenuChoice!" equ "A" (
		set "C_3DViewer=-"
		set "C_AdvertisingXaml=-"
		set "C_Alarms=-"
		set "C_BingWeather=-"
		set "C_Calculator=-"
		set "C_Camera=-"
		set "C_CommunicationsApps=-"
		set "C_DesktopAppInstaller=-"
		set "C_FeedbackHub=-"
		set "C_GetHelp=-"
		set "C_Getstarted=-"
		set "C_HEIFImageExtension=-"
		set "C_Maps=-"
		set "C_Messaging=-"
		set "C_OfficeHub=-"
		set "C_OfficeOneNote=-"
		set "C_OneConnect=-"
		set "C_Paint3D=-"
		set "C_People=-"
		set "C_Photos=-"
		set "C_Print3D=-"
		set "C_ScreenSketch=-"
		set "C_SkypeApp=-"
		set "C_SolitaireCollection=-"
		set "C_SoundRecorder=-"
		set "C_StickyNotes=-"
		set "C_VP9VideoExtensions=-"
		set "C_WalletService=-"
		set "C_WebMediaExtensions=-"
		set "C_WebpImageExtensions=-"
		set "C_WindowsStore=-"
		set "C_XboxApp=-"
		set "C_XboxIdentityProvider=-"
		set "C_YourPhone=-"
		set "C_ZuneMusic=-"
		set "C_ZuneVideo=-"
	)
	if "!MenuChoice!" equ "36" ( if "%C_YourPhone%" equ "+" ( set "C_YourPhone=-" ) else ( set "C_YourPhone=+" ) )
	if "!MenuChoice!" equ "35" ( if "%C_XboxIdentityProvider%" equ "+" ( set "C_XboxIdentityProvider=-" ) else ( set "C_XboxIdentityProvider=+" ) )
	if "!MenuChoice!" equ "34" ( if "%C_XboxApp%" equ "+" ( set "C_XboxApp=-" ) else ( set "C_XboxApp=+" ) )
	if "!MenuChoice!" equ "33" (
		if "%C_WindowsStore%" equ "+" ( 
            set "C_StickyNotes=-"
			set "C_WindowsStore=-"
		) else ( 
			set "C_SmartScreen=+"
			set "C_WindowsStore=+"
			set "C_WindowsDefender=+"
		)
	)
	if "!MenuChoice!" equ "32" (
		if "%C_CommunicationsApps%" equ "+" ( 
			set "C_CommunicationsApps=-"
		) else (
			set "C_AdvertisingXaml=+"
			set "C_CommunicationsApps=+"
		)
	)
	if "!MenuChoice!" equ "31" ( if "%C_WebpImageExtensions%" equ "+" ( set "C_WebpImageExtensions=-" ) else ( set "C_WebpImageExtensions=+" ) )
	if "!MenuChoice!" equ "30" ( if "%C_WebMediaExtensions%" equ "+" ( set "C_WebMediaExtensions=-" ) else ( set "C_WebMediaExtensions=+" ) )
	if "!MenuChoice!" equ "29" (
		if "%C_BingWeather%" equ "+" ( 
			set "C_BingWeather=-"
		) else (
			set "C_AdvertisingXaml=+"
			set "C_BingWeather=+"
		)
	)
	if "!MenuChoice!" equ "28" ( if "%C_SoundRecorder%" equ "+" ( set "C_SoundRecorder=-" ) else ( set "C_SoundRecorder=+" ) )
	if "!MenuChoice!" equ "27" ( if "%C_Getstarted%" equ "+" ( set "C_Getstarted=-" ) else ( set "C_Getstarted=+" ) )
	if "!MenuChoice!" equ "26" (
		if "%C_StickyNotes%" equ "+" ( 
			set "C_StickyNotes=-"
		) else (
			set "C_StickyNotes=+"
			set "C_WindowsDefender=+"
			set "C_WindowsStore=+"
		)
	)
	if "!MenuChoice!" equ "25" (
		if "%C_SolitaireCollection%" equ "+" ( 
			set "C_SolitaireCollection=-"
		) else (
			set "C_SolitaireCollection=+"
			set "C_XboxGameCallableUI=+"
		)
	)
	if "!MenuChoice!" equ "24" ( if "%C_SkypeApp%" equ "+" ( set "C_SkypeApp=-" ) else ( set "C_SkypeApp=+" ) )
	if "!MenuChoice!" equ "23" ( if "%C_ScreenSketch%" equ "+" ( set "C_ScreenSketch=-" ) else ( set "C_ScreenSketch=+" ) )
	if "!MenuChoice!" equ "22" ( if "%C_Print3D%" equ "+" ( set "C_Print3D=-" ) else ( set "C_Print3D=+" ) )
	if "!MenuChoice!" equ "21" ( if "%C_Photos%" equ "+" ( set "C_Photos=-" ) else ( set "C_Photos=+" ) )
	if "!MenuChoice!" equ "20" (
		if "%C_People%" equ "+" ( 
			set "C_People=-"
		) else ( 
			set "C_People=+"
			set "C_PeopleExperienceHost=+"
		)
	)
	if "!MenuChoice!" equ "19" ( if "%C_Paint3D%" equ "+" ( set "C_Paint3D=-" ) else ( set "C_Paint3D=+" ) )
	if "!MenuChoice!" equ "18" ( if "%C_OfficeOneNote%" equ "+" ( set "C_OfficeOneNote=-" ) else ( set "C_OfficeOneNote=+" ) )
	if "!MenuChoice!" equ "17" ( if "%C_OfficeHub%" equ "+" ( set "C_OfficeHub=-" ) else ( set "C_OfficeHub=+" ) )
	if "!MenuChoice!" equ "16" ( if "%C_OneConnect%" equ "+" ( set "C_OneConnect=-" ) else ( set "C_OneConnect=+" ) )
	if "!MenuChoice!" equ "15" (
		if "%C_3DViewer%" equ "+" ( 
			set "C_3DViewer=-"
		) else ( 
			set "C_3DViewer=+"
			set "C_WindowsMixedReality=+"
		)
	)
	if "!MenuChoice!" equ "14" ( if "%C_WalletService%" equ "+" ( set "C_WalletService=-" ) else ( set "C_WalletService=+" ) )
	if "!MenuChoice!" equ "13" ( if "%C_Messaging%" equ "+" ( set "C_Messaging=-" ) else ( set "C_Messaging=+" ) )
	if "!MenuChoice!" equ "12" (
		if "%C_Maps%" equ "+" ( 
			set "C_Maps=-"
		) else (
			set "C_MapControl=+"
			set "C_Maps=+"
		)
	)
	if "!MenuChoice!" equ "11" ( if "%C_HEIFImageExtension%" equ "+" ( set "C_HEIFImageExtension=-" ) else ( set "C_HEIFImageExtension=+" ) )
	if "!MenuChoice!" equ "10" ( if "%C_ZuneMusic%" equ "+" ( set "C_ZuneMusic=-" ) else ( set "C_ZuneMusic=+" ) )
	if "!MenuChoice!" equ "09" ( if "%C_VP9VideoExtensions%" equ "+" ( set "C_VP9VideoExtensions=-" ) else ( set "C_VP9VideoExtensions=+" ) )
	if "!MenuChoice!" equ "08" ( if "%C_GetHelp%" equ "+" ( set "C_GetHelp=-" ) else ( set "C_GetHelp=+" ) )
	if "!MenuChoice!" equ "07" ( if "%C_ZuneVideo%" equ "+" ( set "C_ZuneVideo=-" ) else ( set "C_ZuneVideo=+" ) )
	if "!MenuChoice!" equ "06" ( if "%C_FeedbackHub%" equ "+" ( set "C_FeedbackHub=-" ) else ( set "C_FeedbackHub=+" ) )
	if "!MenuChoice!" equ "05" ( if "%C_DesktopAppInstaller%" equ "+" ( set "C_DesktopAppInstaller=-" ) else ( set "C_DesktopAppInstaller=+" ) )
	if "!MenuChoice!" equ "04" ( if "%C_Camera%" equ "+" ( set "C_Camera=-" ) else ( set "C_Camera=+" ) )
	if "!MenuChoice!" equ "03" ( if "%C_Calculator%" equ "+" ( set "C_Calculator=-" ) else ( set "C_Calculator=+" ) )
	if "!MenuChoice!" equ "02" ( if "%C_Alarms%" equ "+" ( set "C_Alarms=-" ) else ( set "C_Alarms=+" ) )
	if "!MenuChoice!" equ "01" (
		if "%C_AdvertisingXaml%" equ "+" ( 
			set "C_AdvertisingXaml=-"
			set "C_BingWeather=-"
			set "C_CommunicationsApps=-"
		) else (
			set "C_AdvertisingXaml=+"
		)
	)
)

:: Remove Windows 10 v1809/v1903/v1909 Client Non Enterprise (N) LTSC 2019 64-Bit Client Windows Apps Menu
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "17763" if "%ImageBuild%" leq "18363" if "%ImageArchitecture%" equ "x64" if "%ImageFlag%" neq "EnterpriseS" if "%ImageFlag%" neq "EnterpriseSN" (
	cls
	echo.===============================================================================
	echo.               MSMG ToolKit - Supprimer les applications Windows 
	echo.===============================================================================
	echo.  [01] %C_AdvertisingXaml% Xaml publicitaire
	echo.  [02] %C_Alarms% Alarmes ^& application Horloge
	echo.  [03] %C_Calculator% Application Calculatrice
	echo.  [04] %C_Camera% Application pour appareil photo
	echo.  [05] %C_DesktopAppInstaller% Programme d'installation de l'application de bureau
	echo.  [06] %C_FeedbackHub% Application Hub Feedback
	echo.  [07] %C_ZuneVideo% Films et application TV
	echo.  [08] %C_GetHelp% Obtenir l'application d'aide
	echo.  [09] %C_VP9VideoExtensions% Plugin de codec vidéo VP9 WebM de Google
	echo.  [10] %C_ZuneMusic% Application Groove Music
	echo.  [11] %C_HEIFImageExtension% Plugin de codec High Efficiency Image File ^(HEIF^)
	echo.  [12] %C_Maps% Application Maps ^| Depends de Controle de la carte
	echo.  [13] %C_Messaging% Application Messagerie
	echo.  [14] %C_WalletService% Application Microsoft Pay
	echo.  [15] %C_MixedRealityPortal% Application de portail de realite mixte ^| Depend de Windows Mixed Reality 
	echo.  [16] %C_3DViewer% Application de visionneuse de realite ^| Depend de Windows Mixed Reality
	echo.  [17] %C_OneConnect% Application pour les forfaits mobiles
	echo.  [18] %C_OfficeHub% Mon application Office
	echo.  [19] %C_OfficeOneNote% Application OneNote
	echo.  [20] %C_Paint3D% Application Paint 3D
	echo.  [21] %C_People% Application Contacts ^| Depend de Barre de contacts
	echo.  [22] %C_Photos% Application Photos
	echo.  [23] %C_Print3D% Application d'impression 3D
	echo.  [24] %C_ScreenSketch% Application de croquis d'ecran
	echo.  [25] %C_SkypeApp% Application Skype
	echo.  [26] %C_SolitaireCollection% Application solitaire ^| Depend de Xbox Game
	if "%ImageBuild%" equ "17763" echo.  [27] %C_StickyNotes% Application Notes autocollantes
	if "%ImageBuild%" neq "17763" echo.  [27] %C_StickyNotes% Application Notes autocollantes ^| Depend de Windows Store
	echo.  [28] %C_Getstarted% Application Tips 
	echo.  [29] %C_SoundRecorder% Application Enregistreur vocal
	echo.  [30] %C_BingWeather% Application Meteo ^| Depend de Publicite Xaml
	echo.  [31] %C_WebMediaExtensions% Web Media Codec Plugin
	echo.  [32] %C_WebpImageExtensions% WebP Image Codec Plugin
	echo.  [33] %C_CommunicationsApps% Application Windows Mail ^| Depend de Publicite Xaml
	echo.  [34] %C_WindowsStore% Windows Store ^| Depends de Ecran intelligent
	echo.  [35] %C_XboxApp% Application Xbox 
	echo.  [36] %C_XboxIdentityProvider% Fournisseur d'identite Xbox
	echo.  [37] %C_YourPhone% Votre application telephonique 
	echo.
	echo.  [A]    Toutes les applications Windows 
	echo.  [X]    Retour
	echo.===============================================================================
	set /p MenuChoice=Entrer votre choix : 

	if /i "!MenuChoice!" equ "X" goto :SelectWindowsComponentsMenu
	if /i "!MenuChoice!" equ "A" (
		set "C_3DViewer=-"
		set "C_AdvertisingXaml=-"
		set "C_Alarms=-"
		set "C_BingWeather=-"
		set "C_Calculator=-"
		set "C_Camera=-"
		set "C_CommunicationsApps=-"
		set "C_DesktopAppInstaller=-"
		set "C_FeedbackHub=-"
		set "C_GetHelp=-"
		set "C_Getstarted=-"
		set "C_HEIFImageExtension=-"
		set "C_Maps=-"
		set "C_Messaging=-"
		set "C_MixedRealityPortal=-"
		set "C_OfficeHub=-"
		set "C_OfficeOneNote=-"
		set "C_OneConnect=-"
		set "C_Paint3D=-"
		set "C_People=-"
		set "C_Photos=-"
		set "C_Print3D=-"
		set "C_ScreenSketch=-"
		set "C_SkypeApp=-"
		set "C_SolitaireCollection=-"
		set "C_SoundRecorder=-"
		set "C_StickyNotes=-"
		set "C_VP9VideoExtensions=-"
		set "C_WalletService=-"
		set "C_WebMediaExtensions=-"
		set "C_WebpImageExtensions=-"
		set "C_WindowsStore=-"
		set "C_XboxApp=-"
		set "C_XboxIdentityProvider=-"
		set "C_YourPhone=-"
		set "C_ZuneMusic=-"
		set "C_ZuneVideo=-"
	)
	if "!MenuChoice!" equ "37" ( if "%C_YourPhone%" equ "+" ( set "C_YourPhone=-" ) else ( set "C_YourPhone=+" ) )
	if "!MenuChoice!" equ "36" ( if "%C_XboxIdentityProvider%" equ "+" ( set "C_XboxIdentityProvider=-" ) else ( set "C_XboxIdentityProvider=+" ) )
	if "!MenuChoice!" equ "35" ( if "%C_XboxApp%" equ "+" ( set "C_XboxApp=-" ) else ( set "C_XboxApp=+" ) )
	if "!MenuChoice!" equ "34" (
		if "%C_WindowsStore%" equ "+" ( 
            set "C_StickyNotes=-"
			set "C_WindowsStore=-"
		) else ( 
			set "C_SmartScreen=+"
			set "C_WindowsStore=+"
			set "C_WindowsDefender=+"
		)
	)
	if "!MenuChoice!" equ "33" (
		if "%C_CommunicationsApps%" equ "+" ( 
			set "C_CommunicationsApps=-"
		) else (
			set "C_AdvertisingXaml=+"
			set "C_CommunicationsApps=+"
		)
	)
	if "!MenuChoice!" equ "32" ( if "%C_WebpImageExtensions%" equ "+" ( set "C_WebpImageExtensions=-" ) else ( set "C_WebpImageExtensions=+" ) )
	if "!MenuChoice!" equ "31" ( if "%C_WebMediaExtensions%" equ "+" ( set "C_WebMediaExtensions=-" ) else ( set "C_WebMediaExtensions=+" ) )
	if "!MenuChoice!" equ "30" (
		if "%C_BingWeather%" equ "+" ( 
			set "C_BingWeather=-"
		) else (
			set "C_AdvertisingXaml=+"
			set "C_BingWeather=+"
		)
	)
	if "!MenuChoice!" equ "29" ( if "%C_SoundRecorder%" equ "+" ( set "C_SoundRecorder=-" ) else ( set "C_SoundRecorder=+" ) )
	if "!MenuChoice!" equ "28" ( if "%C_Getstarted%" equ "+" ( set "C_Getstarted=-" ) else ( set "C_Getstarted=+" ) )
	if "!MenuChoice!" equ "27" (
		if "%C_StickyNotes%" equ "+" ( 
			set "C_StickyNotes=-"
		) else (
			set "C_StickyNotes=+"
			set "C_WindowsDefender=+"
			set "C_WindowsStore=+"
		)
	)
	if "!MenuChoice!" equ "26" (
		if "%C_SolitaireCollection%" equ "+" ( 
			set "C_SolitaireCollection=-"
		) else (
			set "C_SolitaireCollection=+"
			set "C_XboxGameCallableUI=+"
		)
	)
	if "!MenuChoice!" equ "25" ( if "%C_SkypeApp%" equ "+" ( set "C_SkypeApp=-" ) else ( set "C_SkypeApp=+" ) )
	if "!MenuChoice!" equ "24" ( if "%C_ScreenSketch%" equ "+" ( set "C_ScreenSketch=-" ) else ( set "C_ScreenSketch=+" ) )
	if "!MenuChoice!" equ "23" ( if "%C_Print3D%" equ "+" ( set "C_Print3D=-" ) else ( set "C_Print3D=+" ) )
	if "!MenuChoice!" equ "22" ( if "%C_Photos%" equ "+" ( set "C_Photos=-" ) else ( set "C_Photos=+" ) )
	if "!MenuChoice!" equ "21" (
		if "%C_People%" equ "+" ( 
			set "C_People=-"
		) else ( 
			set "C_People=+"
			set "C_PeopleExperienceHost=+"
		)
	)
	if "!MenuChoice!" equ "20" ( if "%C_Paint3D%" equ "+" ( set "C_Paint3D=-" ) else ( set "C_Paint3D=+" ) )
	if "!MenuChoice!" equ "19" ( if "%C_OfficeOneNote%" equ "+" ( set "C_OfficeOneNote=-" ) else ( set "C_OfficeOneNote=+" ) )
	if "!MenuChoice!" equ "18" ( if "%C_OfficeHub%" equ "+" ( set "C_OfficeHub=-" ) else ( set "C_OfficeHub=+" ) )
	if "!MenuChoice!" equ "17" ( if "%C_OneConnect%" equ "+" ( set "C_OneConnect=-" ) else ( set "C_OneConnect=+" ) )
	if "!MenuChoice!" equ "16" (
		if "%C_3DViewer%" equ "+" ( 
			set "C_3DViewer=-"
		) else ( 
			set "C_3DViewer=+"
			set "C_WindowsMixedReality=+"
		)
	)
	if "!MenuChoice!" equ "15" (
		if "%C_MixedRealityPortal%" equ "+" ( 
			set "C_MixedRealityPortal=-"
		) else ( 
			set "C_MixedRealityPortal=+"
			set "C_WindowsMixedReality=+"
		)
	)
	if "!MenuChoice!" equ "14" ( if "%C_WalletService%" equ "+" ( set "C_WalletService=-" ) else ( set "C_WalletService=+" ) )
	if "!MenuChoice!" equ "13" ( if "%C_Messaging%" equ "+" ( set "C_Messaging=-" ) else ( set "C_Messaging=+" ) )
	if "!MenuChoice!" equ "12" (
		if "%C_Maps%" equ "+" ( 
			set "C_Maps=-"
		) else (
			set "C_MapControl=+"
			set "C_Maps=+"
		)
	)
	if "!MenuChoice!" equ "11" ( if "%C_HEIFImageExtension%" equ "+" ( set "C_HEIFImageExtension=-" ) else ( set "C_HEIFImageExtension=+" ) )
	if "!MenuChoice!" equ "10" ( if "%C_ZuneMusic%" equ "+" ( set "C_ZuneMusic=-" ) else ( set "C_ZuneMusic=+" ) )
	if "!MenuChoice!" equ "09" ( if "%C_VP9VideoExtensions%" equ "+" ( set "C_VP9VideoExtensions=-" ) else ( set "C_VP9VideoExtensions=+" ) )
	if "!MenuChoice!" equ "08" ( if "%C_GetHelp%" equ "+" ( set "C_GetHelp=-" ) else ( set "C_GetHelp=+" ) )
	if "!MenuChoice!" equ "07" ( if "%C_ZuneVideo%" equ "+" ( set "C_ZuneVideo=-" ) else ( set "C_ZuneVideo=+" ) )
	if "!MenuChoice!" equ "06" ( if "%C_FeedbackHub%" equ "+" ( set "C_FeedbackHub=-" ) else ( set "C_FeedbackHub=+" ) )
	if "!MenuChoice!" equ "05" ( if "%C_DesktopAppInstaller%" equ "+" ( set "C_DesktopAppInstaller=-" ) else ( set "C_DesktopAppInstaller=+" ) )
	if "!MenuChoice!" equ "04" ( if "%C_Camera%" equ "+" ( set "C_Camera=-" ) else ( set "C_Camera=+" ) )
	if "!MenuChoice!" equ "03" ( if "%C_Calculator%" equ "+" ( set "C_Calculator=-" ) else ( set "C_Calculator=+" ) )
	if "!MenuChoice!" equ "02" ( if "%C_Alarms%" equ "+" ( set "C_Alarms=-" ) else ( set "C_Alarms=+" ) )
	if "!MenuChoice!" equ "01" (
		if "%C_AdvertisingXaml%" equ "+" ( 
			set "C_AdvertisingXaml=-"
			set "C_BingWeather=-"
			set "C_CommunicationsApps=-"
		) else (
			set "C_AdvertisingXaml=+"
		)
	)
)

:: Remove Windows 10 v2004/v20H2 32-Bit Client Windows Apps Menu
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "19041" if "%ImageBuild%" leq "19042" if "%ImageArchitecture%" equ "x86" (
	cls
	echo.===============================================================================
	echo.               MSMG ToolKit - Supprimer les applications Windows 
	echo.===============================================================================
	echo.  [01] %C_AdvertisingXaml% Xaml publicitaire
	echo.  [02] %C_Alarms% Alarmes ^& application Horloge
	echo.  [03] %C_Calculator% Application Calculatrice
	echo.  [04] %C_Camera% Application pour appareil photo
	echo.  [05] %C_DesktopAppInstaller% Programme d'installation de l'application de bureau
	echo.  [06] %C_FeedbackHub% Application Hub Feedback
	echo.  [07] %C_ZuneVideo% Films et application TV
	echo.  [08] %C_GetHelp% Obtenir l'application d'aide
	echo.  [09] %C_VP9VideoExtensions% Plugin de codec vidéo VP9 WebM de Google
	echo.  [10] %C_ZuneMusic% Application Groove Music
	echo.  [11] %C_HEIFImageExtension% Plugin de codec High Efficiency Image File ^(HEIF^)
	echo.  [12] %C_Maps% Application Maps ^| Depends de Controle de la carte
	echo.  [13] %C_WalletService% Application Microsoft Pay
	echo.  [14] %C_3DViewer% Application de visionneuse de realite ^| Depend de Windows Mixed Reality
	echo.  [15] %C_OneConnect% Application pour les forfaits mobiles
	echo.  [16] %C_OfficeHub% Mon application Office
	echo.  [17] %C_OfficeOneNote% Application OneNote
	echo.  [18] %C_Paint3D% Application Paint 3D
	echo.  [19] %C_People% Application Contacts ^| Depend de Barre de contacts
	echo.  [20] %C_Photos% Application Photos
	echo.  [21] %C_Print3D% Application d'impression 3D
	echo.  [22] %C_ScreenSketch% Application de croquis d'ecran
	echo.  [23] %C_SkypeApp% Application Skype
	echo.  [24] %C_SolitaireCollection% Application solitaire ^| Depend de Xbox Game
	echo.  [25] %C_Getstarted% Application Tips 
	echo.  [26] %C_SoundRecorder% Application Enregistreur vocal
	echo.  [27] %C_BingWeather% Application Meteo ^| Depend de Publicite Xaml
	echo.  [28] %C_WebMediaExtensions% Web Media Codec Plugin
	echo.  [29] %C_WebpImageExtensions% WebP Image Codec Plugin
	echo.  [30] %C_CommunicationsApps% Application Windows Mail ^| Depend de Publicite Xaml
	echo.  [31] %C_WindowsStore% Windows Store ^| Depends de Ecran intelligent
	echo.  [32] %C_XboxApp% Application Xbox 
	echo.  [33] %C_XboxIdentityProvider% Fournisseur d'identite Xbox
	echo.  [34] %C_YourPhone% Votre application telephonique 
	echo.
	echo.  [A]    Toutes les applications Windows 
	echo.  [X]    Retour
	echo.===============================================================================
	set /p MenuChoice=Entrer votre choix : 

	if /i "!MenuChoice!" equ "X" goto :SelectWindowsComponentsMenu
	if /i "!MenuChoice!" equ "A" (
		set "C_3DViewer=-"
		set "C_AdvertisingXaml=-"
		set "C_Alarms=-"
		set "C_BingWeather=-"
		set "C_Calculator=-"
		set "C_Camera=-"
		set "C_CommunicationsApps=-"
		set "C_Cortana=-"
		set "C_DesktopAppInstaller=-"
		set "C_FeedbackHub=-"
		set "C_GetHelp=-"
		set "C_Getstarted=-"
		set "C_HEIFImageExtension=-"
		set "C_Maps=-"
		set "C_OfficeHub=-"
		set "C_OfficeOneNote=-"
		set "C_Paint3D=-"
		set "C_People=-"
		set "C_Photos=-"
		set "C_ScreenSketch=-"
		set "C_SkypeApp=-"
		set "C_SolitaireCollection=-"
		set "C_SoundRecorder=-"
		set "C_StickyNotes=-"
		set "C_VP9VideoExtensions=-"
		set "C_WalletService=-"
		set "C_WebMediaExtensions=-"
		set "C_WebpImageExtensions=-"
		set "C_WindowsStore=-"
		set "C_XboxApp=-"
		set "C_XboxIdentityProvider=-"
		set "C_YourPhone=-"
		set "C_ZuneMusic=-"
		set "C_ZuneVideo=-"
	)
	if "!MenuChoice!" equ "34" ( if "%C_YourPhone%" equ "+" ( set "C_YourPhone=-" ) else ( set "C_YourPhone=+" ) )
	if "!MenuChoice!" equ "33" ( if "%C_XboxIdentityProvider%" equ "+" ( set "C_XboxIdentityProvider=-" ) else ( set "C_XboxIdentityProvider=+" ) )
	if "!MenuChoice!" equ "32" ( if "%C_XboxApp%" equ "+" ( set "C_XboxApp=-" ) else ( set "C_XboxApp=+" ) )
	if "!MenuChoice!" equ "31" (
		if "%C_WindowsStore%" equ "+" ( 
            set "C_StickyNotes=-"
			set "C_WindowsStore=-"
		) else ( 
			set "C_SmartScreen=+"
			set "C_WindowsStore=+"
			set "C_WindowsDefender=+"
		)
	)
	if "!MenuChoice!" equ "30" (
		if "%C_CommunicationsApps%" equ "+" ( 
			set "C_CommunicationsApps=-"
		) else (
			set "C_AdvertisingXaml=+"
			set "C_CommunicationsApps=+"
		)
	)
	if "!MenuChoice!" equ "29" ( if "%C_WebpImageExtensions%" equ "+" ( set "C_WebpImageExtensions=-" ) else ( set "C_WebpImageExtensions=+" ) )
	if "!MenuChoice!" equ "28" ( if "%C_WebMediaExtensions%" equ "+" ( set "C_WebMediaExtensions=-" ) else ( set "C_WebMediaExtensions=+" ) )
	if "!MenuChoice!" equ "27" (
		if "%C_BingWeather%" equ "+" ( 
			set "C_BingWeather=-"
		) else (
			set "C_AdvertisingXaml=+"
			set "C_BingWeather=+"
		)
	)
	if "!MenuChoice!" equ "26" ( if "%C_SoundRecorder%" equ "+" ( set "C_SoundRecorder=-" ) else ( set "C_SoundRecorder=+" ) )
	if "!MenuChoice!" equ "25" ( if "%C_Getstarted%" equ "+" ( set "C_Getstarted=-" ) else ( set "C_Getstarted=+" ) )
	if "!MenuChoice!" equ "24" (
		if "%C_StickyNotes%" equ "+" ( 
			set "C_StickyNotes=-"
		) else (
			set "C_StickyNotes=+"
			set "C_WindowsDefender=+"
			set "C_WindowsStore=+"
		)
	)
	if "!MenuChoice!" equ "23" (
		if "%C_SolitaireCollection%" equ "+" ( 
			set "C_SolitaireCollection=-"
		) else (
			set "C_SolitaireCollection=+"
			set "C_XboxGameCallableUI=+"
		)
	)
	if "!MenuChoice!" equ "22" ( if "%C_SkypeApp%" equ "+" ( set "C_SkypeApp=-" ) else ( set "C_SkypeApp=+" ) )
	if "!MenuChoice!" equ "21" ( if "%C_ScreenSketch%" equ "+" ( set "C_ScreenSketch=-" ) else ( set "C_ScreenSketch=+" ) )
	if "!MenuChoice!" equ "20" ( if "%C_Photos%" equ "+" ( set "C_Photos=-" ) else ( set "C_Photos=+" ) )
	if "!MenuChoice!" equ "19" (
		if "%C_People%" equ "+" ( 
			set "C_People=-"
		) else ( 
			set "C_People=+"
			set "C_PeopleExperienceHost=+"
		)
	)
	if "!MenuChoice!" equ "18" ( if "%C_Paint3D%" equ "+" ( set "C_Paint3D=-" ) else ( set "C_Paint3D=+" ) )
	if "!MenuChoice!" equ "17" ( if "%C_OfficeOneNote%" equ "+" ( set "C_OfficeOneNote=-" ) else ( set "C_OfficeOneNote=+" ) )
	if "!MenuChoice!" equ "16" ( if "%C_OfficeHub%" equ "+" ( set "C_OfficeHub=-" ) else ( set "C_OfficeHub=+" ) )
	if "!MenuChoice!" equ "15" ( if "%C_ZuneVideo%" equ "+" ( set "C_ZuneVideo=-" ) else ( set "C_ZuneVideo=+" ) )
	if "!MenuChoice!" equ "14" (
		if "%C_3DViewer%" equ "+" ( 
			set "C_3DViewer=-"
		) else ( 
			set "C_3DViewer=+"
			set "C_WindowsMixedReality=+"
		)
	)
	if "!MenuChoice!" equ "13" ( if "%C_WalletService%" equ "+" ( set "C_WalletService=-" ) else ( set "C_WalletService=+" ) )
	if "!MenuChoice!" equ "12" (
		if "%C_Maps%" equ "+" ( 
			set "C_Maps=-"
		) else (
			set "C_MapControl=+"
			set "C_Maps=+"
		)
	)
	if "!MenuChoice!" equ "11" ( if "%C_HEIFImageExtension%" equ "+" ( set "C_HEIFImageExtension=-" ) else ( set "C_HEIFImageExtension=+" ) )
	if "!MenuChoice!" equ "10" ( if "%C_ZuneMusic%" equ "+" ( set "C_ZuneMusic=-" ) else ( set "C_ZuneMusic=+" ) )
	if "!MenuChoice!" equ "09" ( if "%C_VP9VideoExtensions%" equ "+" ( set "C_VP9VideoExtensions=-" ) else ( set "C_VP9VideoExtensions=+" ) )
	if "!MenuChoice!" equ "08" ( if "%C_GetHelp%" equ "+" ( set "C_GetHelp=-" ) else ( set "C_GetHelp=+" ) )
	if "!MenuChoice!" equ "07" ( if "%C_FeedbackHub%" equ "+" ( set "C_FeedbackHub=-" ) else ( set "C_FeedbackHub=+" ) )
	if "!MenuChoice!" equ "06" ( if "%C_DesktopAppInstaller%" equ "+" ( set "C_DesktopAppInstaller=-" ) else ( set "C_DesktopAppInstaller=+" ) )
	if "!MenuChoice!" equ "05" (
		if "%C_Cortana%" equ "+" ( 
			set "C_Cortana=-"
		) else (
			set "C_Cortana=+"
			set "C_SpeechRecognition=+"
		)
	)
	if "!MenuChoice!" equ "04" ( if "%C_Camera%" equ "+" ( set "C_Camera=-" ) else ( set "C_Camera=+" ) )
	if "!MenuChoice!" equ "03" ( if "%C_Calculator%" equ "+" ( set "C_Calculator=-" ) else ( set "C_Calculator=+" ) )
	if "!MenuChoice!" equ "02" ( if "%C_Alarms%" equ "+" ( set "C_Alarms=-" ) else ( set "C_Alarms=+" ) )
	if "!MenuChoice!" equ "01" (
		if "%C_AdvertisingXaml%" equ "+" ( 
			set "C_AdvertisingXaml=-"
			set "C_BingWeather=-"
			set "C_CommunicationsApps=-"
		) else (
			set "C_AdvertisingXaml=+"
		)
	)
)

:: Remove Windows 10 v2004/v20H2 64-Bit Client Windows Apps Menu
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" geq "19041" if "%ImageBuild%" leq "19042" if "%ImageArchitecture%" equ "x64" (
	cls
	echo.===============================================================================
	echo.               MSMG ToolKit - Supprimer les applications Windows 
	echo.===============================================================================
	echo.  [01] %C_AdvertisingXaml% Xaml publicitaire
	echo.  [02] %C_Alarms% Alarmes ^& application Horloge
	echo.  [03] %C_Calculator% Application Calculatrice
	echo.  [04] %C_Camera% Application pour appareil photo
	echo.  [05] %C_Cortana% Application Cortana ^| Depend de Reconnaissance faciale
	echo.  [06] %C_DesktopAppInstaller% Programme d'installation de l'application de bureau
	echo.  [07] %C_FeedbackHub% Application Hub Feedback
	echo.  [08] %C_GetHelp% Obtenir l'application d'aide
	echo.  [09] %C_VP9VideoExtensions% Plugin de codec vidéo VP9 WebM de Google
	echo.  [10] %C_ZuneMusic% Application Groove Music
	echo.  [11] %C_HEIFImageExtension% Plugin de codec High Efficiency Image File ^(HEIF^)
	echo.  [12] %C_Maps% Application Maps ^| Depends de Controle de la carte
	echo.  [13] %C_WalletService% Application Microsoft Pay
	echo.  [14] %C_3DViewer% Application de visionneuse de realite mixte ^| Depend de Windows Mixed Reality
	echo.  [15] %C_ZuneVideo% Films et application TV
	echo.  [16] %C_OfficeHub% Mon application Office
	echo.  [17] %C_OfficeOneNote% Application OneNote
	echo.  [18] %C_Paint3D% Application Paint 3D
	echo.  [19] %C_People% Application Contacts ^| Depend de Barre de contacts
	echo.  [20] %C_Photos% Application Photos
	echo.  [21] %C_Print3D% Application d'impression 3D
	echo.  [22] %C_ScreenSketch% Application de croquis d'ecran
	echo.  [23] %C_SkypeApp% Application Skype
	echo.  [24] %C_SolitaireCollection% Application solitaire ^| Depend de Xbox Game
	echo.  [25] %C_StickyNotes% Application Notes autocollantes ^| Depend de Windows Store
	echo.  [26] %C_Getstarted% Application Tips 
	echo.  [27] %C_SoundRecorder% Application Enregistreur vocal
	echo.  [28] %C_BingWeather% Application Meteo ^| Depend de Publicite Xaml
	echo.  [29] %C_WebMediaExtensions% Web Media Codec Plugin
	echo.  [30] %C_WebpImageExtensions% WebP Image Codec Plugin
	echo.  [31] %C_CommunicationsApps% Application Windows Mail ^| Depend de Publicite Xaml
	echo.  [32] %C_WindowsStore% Windows Store ^| Depends de Ecran intelligent
	echo.  [33] %C_XboxApp% Application Xbox 
	echo.  [34] %C_XboxIdentityProvider% Fournisseur d'identite Xbox
	echo.  [35] %C_YourPhone% Votre application telephonique
	echo.
	echo.  [A]    Toutes les applications Windows 
	echo.  [X]    Retour
	echo.===============================================================================
	set /p MenuChoice=Entrer votre choix : 

	if /i "!MenuChoice!" equ "X" goto :SelectWindowsComponentsMenu
	if /i "!MenuChoice!" equ "A" (
		set "C_3DViewer=-"
		set "C_AdvertisingXaml=-"
		set "C_Alarms=-"
		set "C_BingWeather=-"
		set "C_Calculator=-"
		set "C_Camera=-"
		set "C_CommunicationsApps=-"
		set "C_Cortana=-"
		set "C_DesktopAppInstaller=-"
		set "C_FeedbackHub=-"
		set "C_GetHelp=-"
		set "C_Getstarted=-"
		set "C_HEIFImageExtension=-"
		set "C_Maps=-"
		set "C_MixedRealityPortal=-"
		set "C_OfficeHub=-"
		set "C_OfficeOneNote=-"
		set "C_Paint3D=-"
		set "C_People=-"
		set "C_Photos=-"
		set "C_ScreenSketch=-"
		set "C_SkypeApp=-"
		set "C_SolitaireCollection=-"
		set "C_SoundRecorder=-"
		set "C_StickyNotes=-"
		set "C_VP9VideoExtensions=-"
		set "C_WalletService=-"
		set "C_WebMediaExtensions=-"
		set "C_WebpImageExtensions=-"
		set "C_WindowsStore=-"
		set "C_XboxApp=-"
		set "C_XboxIdentityProvider=-"
		set "C_YourPhone=-"
		set "C_ZuneMusic=-"
		set "C_ZuneVideo=-"
	)
	if "!MenuChoice!" equ "35" ( if "%C_YourPhone%" equ "+" ( set "C_YourPhone=-" ) else ( set "C_YourPhone=+" ) )
	if "!MenuChoice!" equ "34" ( if "%C_XboxIdentityProvider%" equ "+" ( set "C_XboxIdentityProvider=-" ) else ( set "C_XboxIdentityProvider=+" ) )
	if "!MenuChoice!" equ "33" ( if "%C_XboxApp%" equ "+" ( set "C_XboxApp=-" ) else ( set "C_XboxApp=+" ) )
	if "!MenuChoice!" equ "32" (
		if "%C_WindowsStore%" equ "+" ( 
            set "C_StickyNotes=-"
			set "C_WindowsStore=-"
		) else ( 
			set "C_SmartScreen=+"
			set "C_WindowsStore=+"
			set "C_WindowsDefender=+"
		)
	)
	if "!MenuChoice!" equ "31" (
		if "%C_CommunicationsApps%" equ "+" ( 
			set "C_CommunicationsApps=-"
		) else (
			set "C_AdvertisingXaml=+"
			set "C_CommunicationsApps=+"
		)
	)
	if "!MenuChoice!" equ "30" ( if "%C_WebpImageExtensions%" equ "+" ( set "C_WebpImageExtensions=-" ) else ( set "C_WebpImageExtensions=+" ) )
	if "!MenuChoice!" equ "29" ( if "%C_WebMediaExtensions%" equ "+" ( set "C_WebMediaExtensions=-" ) else ( set "C_WebMediaExtensions=+" ) )
	if "!MenuChoice!" equ "28" (
		if "%C_BingWeather%" equ "+" ( 
			set "C_BingWeather=-"
		) else (
			set "C_AdvertisingXaml=+"
			set "C_BingWeather=+"
		)
	)
	if "!MenuChoice!" equ "27" ( if "%C_SoundRecorder%" equ "+" ( set "C_SoundRecorder=-" ) else ( set "C_SoundRecorder=+" ) )
	if "!MenuChoice!" equ "26" ( if "%C_Getstarted%" equ "+" ( set "C_Getstarted=-" ) else ( set "C_Getstarted=+" ) )
	if "!MenuChoice!" equ "25" (
		if "%C_StickyNotes%" equ "+" ( 
			set "C_StickyNotes=-"
		) else (
			set "C_StickyNotes=+"
			set "C_WindowsDefender=+"
			set "C_WindowsStore=+"
		)
	)
	if "!MenuChoice!" equ "24" (
		if "%C_SolitaireCollection%" equ "+" ( 
			set "C_SolitaireCollection=-"
		) else (
			set "C_SolitaireCollection=+"
			set "C_XboxGameCallableUI=+"
		)
	)
	if "!MenuChoice!" equ "23" ( if "%C_SkypeApp%" equ "+" ( set "C_SkypeApp=-" ) else ( set "C_SkypeApp=+" ) )
	if "!MenuChoice!" equ "22" ( if "%C_ScreenSketch%" equ "+" ( set "C_ScreenSketch=-" ) else ( set "C_ScreenSketch=+" ) )
	if "!MenuChoice!" equ "21" ( if "%C_Photos%" equ "+" ( set "C_Photos=-" ) else ( set "C_Photos=+" ) )
	if "!MenuChoice!" equ "20" (
		if "%C_People%" equ "+" ( 
			set "C_People=-"
		) else ( 
			set "C_People=+"
			set "C_PeopleExperienceHost=+"
		)
	)
	if "!MenuChoice!" equ "19" ( if "%C_Paint3D%" equ "+" ( set "C_Paint3D=-" ) else ( set "C_Paint3D=+" ) )
	if "!MenuChoice!" equ "18" ( if "%C_OfficeOneNote%" equ "+" ( set "C_OfficeOneNote=-" ) else ( set "C_OfficeOneNote=+" ) )
	if "!MenuChoice!" equ "17" ( if "%C_OfficeHub%" equ "+" ( set "C_OfficeHub=-" ) else ( set "C_OfficeHub=+" ) )
	if "!MenuChoice!" equ "16" ( if "%C_ZuneVideo%" equ "+" ( set "C_ZuneVideo=-" ) else ( set "C_ZuneVideo=+" ) )
	if "!MenuChoice!" equ "15" (
		if "%C_3DViewer%" equ "+" ( 
			set "C_3DViewer=-"
		) else ( 
			set "C_3DViewer=+"
			set "C_WindowsMixedReality=+"
		)
	)
	if "!MenuChoice!" equ "14" ( if "%C_MixedRealityPortal%" equ "+" ( set "C_MixedRealityPortal=-" ) else ( set "C_MixedRealityPortal=+" ) )
	if "!MenuChoice!" equ "13" ( if "%C_WalletService%" equ "+" ( set "C_WalletService=-" ) else ( set "C_WalletService=+" ) )
	if "!MenuChoice!" equ "12" (
		if "%C_Maps%" equ "+" ( 
			set "C_Maps=-"
		) else (
			set "C_MapControl=+"
			set "C_Maps=+"
		)
	)
	if "!MenuChoice!" equ "11" ( if "%C_HEIFImageExtension%" equ "+" ( set "C_HEIFImageExtension=-" ) else ( set "C_HEIFImageExtension=+" ) )
	if "!MenuChoice!" equ "10" ( if "%C_ZuneMusic%" equ "+" ( set "C_ZuneMusic=-" ) else ( set "C_ZuneMusic=+" ) )
	if "!MenuChoice!" equ "09" ( if "%C_VP9VideoExtensions%" equ "+" ( set "C_VP9VideoExtensions=-" ) else ( set "C_VP9VideoExtensions=+" ) )
	if "!MenuChoice!" equ "08" ( if "%C_GetHelp%" equ "+" ( set "C_GetHelp=-" ) else ( set "C_GetHelp=+" ) )
	if "!MenuChoice!" equ "07" ( if "%C_FeedbackHub%" equ "+" ( set "C_FeedbackHub=-" ) else ( set "C_FeedbackHub=+" ) )
	if "!MenuChoice!" equ "06" ( if "%C_DesktopAppInstaller%" equ "+" ( set "C_DesktopAppInstaller=-" ) else ( set "C_DesktopAppInstaller=+" ) )
	if "!MenuChoice!" equ "05" (
		if "%C_Cortana%" equ "+" ( 
			set "C_Cortana=-"
		) else (
			set "C_Cortana=+"
			set "C_SpeechRecognition=+"
		)
	)
	if "!MenuChoice!" equ "04" ( if "%C_Camera%" equ "+" ( set "C_Camera=-" ) else ( set "C_Camera=+" ) )
	if "!MenuChoice!" equ "03" ( if "%C_Calculator%" equ "+" ( set "C_Calculator=-" ) else ( set "C_Calculator=+" ) )
	if "!MenuChoice!" equ "02" ( if "%C_Alarms%" equ "+" ( set "C_Alarms=-" ) else ( set "C_Alarms=+" ) )
	if "!MenuChoice!" equ "01" (
		if "%C_AdvertisingXaml%" equ "+" ( 
			set "C_AdvertisingXaml=-"
			set "C_BingWeather=-"
			set "C_CommunicationsApps=-"
		) else (
			set "C_AdvertisingXaml=+"
		)
	)
)

:: Returning to Remove Windows Apps Menu.
goto :RemoveWindowsAppsMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Remove Windows Components
::-------------------------------------------------------------------------------------------
:RemoveWindowsComponents

setlocal

set Components=

cls
echo.===============================================================================
echo.                MSMG ToolKit - Suppression de composants Windows 
echo.===============================================================================
echo.

:: Getting Install Image Index Architecture
for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" call :GetImageArchitecture "%InstallWim%", %%i >nul
)

:: Set Package Architecture
if "%ImageArchitecture%" equ "x86" set "PackageArchitecture=x86"
if "%ImageArchitecture%" equ "x64" set "PackageArchitecture=amd64"
if "%ImageArchitecture%" equ "arm64" set "PackageArchitecture=arm64"

for %%i in (C_AdobeFlashForWindows,C_EdgeChromium,C_InternetExplorer,C_FirstLogonAnimation,C_GameExplorer,C_SnippingTool,C_SpeechRecognition,C_WindowsMediaPlayer,C_WindowsPhotoViewer,C_WinSAT,C_AssignedAccess,C_CEIP,C_FaceRecognition,C_KernelDebugging,C_LocationService,C_PicturePassword,C_PinEnrollment,C_UnifiedTelemetryClient,C_WiFiNetworkManager,C_WindowsErrorReporting,C_WindowsInsiderHub,C_HomeGroup,C_MultiPointConnector,C_RemoteAssistance,C_DeviceLockdown,C_EaseOfAccessThemes,C_EasyTransfer,C_FileHistory,C_Paint,C_SecurityCenter,C_StepsRecorder,C_SystemRestore,C_WindowsBackup,C_WindowsFirewall,C_WindowsSubsystemForLinux,C_WindowsToGo,C_Wordpad,C_AADBrokerPlugin,C_AssignedAccessLockApp,C_BioEnrollment,C_CallingShellApp,C_CBSPreview,C_ContentDeliveryManager,C_Cortana,C_ECApp,C_EdgeDevToolsClient,C_Edge,C_FileExplorer,C_LockApp,C_MapControl,C_NarratorQuickStart,C_OneDrive,C_ParentalControls,C_PeopleExperienceHost,C_PPIProjection,C_QuickAssist,C_RetailDemoContent,C_SecureAssessmentBrowser,C_SettingSync,C_SkypeORTC,C_SmartScreen,C_Win32WebViewHost,C_WindowsDefender,C_WindowsMixedReality,C_WindowsReaderPDF,C_XboxGameCallableUI,C_3DViewer,C_AdvertisingXaml,C_Alarms,C_BingWeather,C_Calculator,C_Camera,C_CommunicationsApps,C_DesktopAppInstaller,C_FeedbackHub,C_GetHelp,C_Getstarted,C_HEIFImageExtension,C_Maps,C_Messaging,C_MixedRealityPortal,C_OfficeHub,C_OfficeOneNote,C_OneConnect,C_Paint3D,C_People,C_Photos,C_Print3D,C_ScreenSketch,C_SkypeApp,C_SolitaireCollection,C_SoundRecorder,C_StickyNotes,C_VP9VideoExtensions,C_WalletService,C_WebMediaExtensions,C_WebpImageExtensions,C_WindowsStore,C_XboxApp,C_XboxIdentityProvider,C_YourPhone,C_ZuneMusic,C_ZuneVideo) do (
	if "!%%i!" equ "-" (
		for /f "tokens=2 delims=_" %%j in ("%%i") do ( set "Components=!Components!%%j;" )
	)
)

if "%Components%" equ "" (
	echo.Aucun composant Windows n'a ete selectionne pour la suppression.
	goto :Stop
)

echo.-------------------------------------------------------------------------------
echo.####Demarrage de la suppression des composants Windows ########################
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    : Install.wim
if /i "%ImageIndexNo%" equ "A" echo.    Image Indexes            : 1-%ImageCount%
if /i "%ImageIndexNo%" neq "A" echo.    Image Index              : %ImageIndexNo%
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
echo.
echo.-------------------------------------------------------------------------------
echo.####Suppression de composants Windows #########################################
echo.-------------------------------------------------------------------------------

for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" (
		echo.
		if not %%i gtr 9 echo.===========================[Install.wim, Index : %%i]============================
		if %%i gtr 9 echo.==========================[Install.wim, Index : %%i]============================

		:: Removing Windows Components
		%ToolKitHelper% "%InstallMount%\%%i" "%Components%"
	)
)

if "%C_ManualSetup%" equ "-" call :RemoveWindowsManualSetup

echo.-------------------------------------------------------------------------------
echo.####Fin de la suppression des composants Windows ##############################
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set Components=

endlocal

:: Resetting Components status flags
for %%i in (C_AdobeFlashForWindows,C_EdgeChromium,C_InternetExplorer,C_FirstLogonAnimation,C_GameExplorer,C_SnippingTool,C_SpeechRecognition,C_WindowsMediaPlayer,C_WindowsPhotoViewer,C_WinSAT,C_AssignedAccess,C_CEIP,C_FaceRecognition,C_KernelDebugging,C_LocationService,C_PicturePassword,C_PinEnrollment,C_UnifiedTelemetryClient,C_WiFiNetworkManager,C_WindowsErrorReporting,C_WindowsInsiderHub,C_HomeGroup,C_MultiPointConnector,C_RemoteAssistance,C_DeviceLockdown,C_EaseOfAccessThemes,C_EasyTransfer,C_FileHistory,C_ManualSetup,C_Paint,C_SecurityCenter,C_StepsRecorder,C_SystemRestore,C_WindowsBackup,C_WindowsFirewall,C_WindowsSubsystemForLinux,C_WindowsToGo,C_Wordpad,C_AADBrokerPlugin,C_AssignedAccessLockApp,C_BioEnrollment,C_CallingShellApp,C_CBSPreview,C_ContentDeliveryManager,C_Cortana,C_ECApp,C_EdgeDevToolsClient,C_Edge,C_FileExplorer,C_LockApp,C_MapControl,C_NarratorQuickStart,C_OneDrive,C_ParentalControls,C_PeopleExperienceHost,C_PPIProjection,C_QuickAssist,C_RetailDemoContent,C_SecureAssessmentBrowser,C_SettingSync,C_SkypeORTC,C_SmartScreen,C_Win32WebViewHost,C_WindowsDefender,C_WindowsMixedReality,C_WindowsReaderPDF,C_XboxGameCallableUI,C_3DViewer,C_AdvertisingXaml,C_Alarms,C_BingWeather,C_Calculator,C_Camera,C_CommunicationsApps,C_DesktopAppInstaller,C_FeedbackHub,C_GetHelp,C_Getstarted,C_HEIFImageExtension,C_Maps,C_Messaging,C_MixedRealityPortal,C_OfficeHub,C_OfficeOneNote,C_OneConnect,C_Paint3D,C_People,C_Photos,C_Print3D,C_ScreenSketch,C_SkypeApp,C_SolitaireCollection,C_SoundRecorder,C_StickyNotes,C_VP9VideoExtensions,C_WalletService,C_WebMediaExtensions,C_WebpImageExtensions,C_WindowsStore,C_XboxApp,C_XboxIdentityProvider,C_YourPhone,C_ZuneMusic,C_ZuneVideo) do (
	set "%%i=+"
)

:: Returning to Remove Windows Components Menu.
goto :RemoveWindowsComponentsMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Remove Windows Manual Setup Feature
::-------------------------------------------------------------------------------------------
:RemoveWindowsManualSetup

echo.-------------------------------------------------------------------------------
echo.Suppression de la fonction de configuration manuelle de Windows 
echo.-------------------------------------------------------------------------------
echo.

:: Removing Windows Manual Setup Feature files and folders
echo.Veuillez patienter, suppression des fichiers et dossiers d'installation manuelle

call :RemoveFile "%DVD%\autorun.inf"
call :RemoveFile "%DVD%\setup.exe"
call :RemoveFile "%DVD%\*.dll"
call :RemoveFolder "%DVD%\ca"
call :RemoveFolder "%DVD%\NanoServer"
call :RemoveFolder "%DVD%\support"
call :RemoveFolder "%DVD%\upgrade"
call :RemoveFolder "%DVD%\sources\dlmanifests"
call :RemoveFolder "%DVD%\sources\etwproviders"
call :RemoveFolder "%DVD%\sources\inf"
call :RemoveFolder "%DVD%\sources\hwcompat"
call :RemoveFolder "%DVD%\sources\migration"
call :RemoveFolder "%DVD%\sources\replacementmanifests"
call :RemoveFolder "%DVD%\sources\servicing"
call :RemoveFolder "%DVD%\sources\servicingstackmisc"
call :RemoveFolder "%DVD%\sources\sxs"
call :RemoveFolder "%DVD%\sources\uup"
call :RemoveFolder "%DVD%\sources\vista"
call :RemoveFolder "%DVD%\sources\xp"

if exist "%DVD%\sources\%ImageDefaultLanguage%\setup.exe.mui" move /y "%DVD%\sources\%ImageDefaultLanguage%\setup.exe.mui" "%DVD%" >nul
if exist "%DVD%\sources\EI.CFG" move /y "%DVD%\sources\EI.CFG" "%DVD%" >nul
if exist "%DVD%\sources\*.clg" move /y "%DVD%\sources\*.clg" "%DVD%" >nul
if exist "%DVD%\sources\gatherosstate.exe" move /y "%DVD%\sources\gatherosstate.exe" "%DVD%" >nul
if exist "%DVD%\sources\setup.exe" move /y "%DVD%\sources\setup.exe" "%DVD%" >nul
if exist "%DVD%\sources\lang.ini" move /y "%DVD%\sources\lang.ini" "%DVD%" >nul
if exist "%DVD%\sources\pid.txt" move /y "%DVD%\sources\pid.txt" "%DVD%" >nul

call :RemoveFile "%DVD%\sources\%ImageDefaultLanguage%\*.adml"
call :RemoveFile "%DVD%\sources\%ImageDefaultLanguage%\*.mui"
call :RemoveFile "%DVD%\sources\%ImageDefaultLanguage%\*.rtf"
call :RemoveFile "%DVD%\sources\%ImageDefaultLanguage%\*.txt"
call :RemoveFile "%DVD%\sources\*.dll"
call :RemoveFile "%DVD%\sources\*.gif"
call :RemoveFile "%DVD%\sources\*.xsl"
call :RemoveFile "%DVD%\sources\*.bmp"
call :RemoveFile "%DVD%\sources\*.hiv"
call :RemoveFile "%DVD%\sources\*.mof"
call :RemoveFile "%DVD%\sources\*.ini"
call :RemoveFile "%DVD%\sources\*.cer"
call :RemoveFile "%DVD%\sources\*.exe"
call :RemoveFile "%DVD%\sources\*.sdb"
call :RemoveFile "%DVD%\sources\*.txt"
call :RemoveFile "%DVD%\sources\*.nls"
call :RemoveFile "%DVD%\sources\*.xml"
call :RemoveFile "%DVD%\sources\*.cat"
call :RemoveFile "%DVD%\sources\*.inf"
call :RemoveFile "%DVD%\sources\*.sys"
call :RemoveFile "%DVD%\sources\*.bin"
call :RemoveFile "%DVD%\sources\*.ait"
call :RemoveFile "%DVD%\sources\*.admx"
call :RemoveFile "%DVD%\sources\*.dat"
call :RemoveFile "%DVD%\sources\*.ttf"
call :RemoveFile "%DVD%\sources\*.cfg"
call :RemoveFile "%DVD%\sources\*.xsd"
call :RemoveFile "%DVD%\sources\*.rtf"
call :RemoveFile "%DVD%\sources\*.xrm-ms"

if exist "%DVD%\setup.exe.mui" move /y "%DVD%\setup.exe.mui" "%DVD%\sources\%ImageDefaultLanguage%" >nul
if exist "%DVD%\EI.CFG" move /y "%DVD%\EI.CFG" "%DVD%\sources" >nul
if exist "%DVD%\*.clg" move /y "%DVD%\*.clg" "%DVD%\sources" >nul
if exist "%DVD%\gatherosstate.exe" move /y "%DVD%\gatherosstate.exe" "%DVD%\sources" >nul
if exist "%DVD%\setup.exe" move /y "%DVD%\setup.exe" "%DVD%\sources" >nul
if exist "%DVD%\lang.ini" move /y "%DVD%\lang.ini" "%DVD%\sources" >nul
if exist "%DVD%\pid.txt" move /y "%DVD%\pid.txt" "%DVD%\sources" >nul
echo.
echo.Suppression terminee, fichiers et dossiers d'installation manuelle de Windows. 
echo.

goto :eof
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Remove Windows Apps Using Apps List
::-------------------------------------------------------------------------------------------
:RemoveWindowsAppsList

setlocal

set "RemoveAppsList=%Lists%\RemoveAppsList.txt"

cls
echo.===============================================================================
echo.        MSMG ToolKit - Supprimer les applications Windows via la liste 
echo.===============================================================================
echo.

:: Getting Install Image Index Architecture
for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" call :GetImageArchitecture "%InstallWim%", %%i >nul
)

echo.-------------------------------------------------------------------------------
echo.####Demarrage de la suppression des applications Windows via la liste #########
echo.-------------------------------------------------------------------------------
echo.
echo.
echo.    Image                    : Install.wim
if /i "%ImageIndexNo%" equ "A" echo.    Image Indexes            : 1-%ImageCount%
if /i "%ImageIndexNo%" neq "A" echo.    Image Index              : %ImageIndexNo%
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
echo.
echo.-------------------------------------------------------------------------------
echo.####Suppression des applications Windows via la liste #########################
echo.-------------------------------------------------------------------------------

for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" (
		echo.
		if not %%i gtr 9 echo.===========================[Install.wim, Index : %%i]============================
		if %%i gtr 9 echo.==========================[Install.wim, Index : %%i]============================
		echo.

		for /f %%z IN ('"type %RemoveAppsList%" 2^>nul') do (
			call :RemoveProvisionedAppxPackage "%InstallMount%\%%i", %%z, %%z

			if "%%z" equ "Microsoft.3DBuilder" (
				:: Mounting Image Registry
				call :MountImageRegistry "%InstallMount%\%%i"

				:: Removing 3D Print with 3D Builder option from right click context menu
				Reg delete "HKLM\TK_SOFTWARE\Classes\SystemFileAssociations\.bmp\Shell\T3D Print" /f >nul 2>&1
				Reg delete "HKLM\TK_SOFTWARE\Classes\SystemFileAssociations\.jpg\Shell\T3D Print" /f >nul 2>&1
				Reg delete "HKLM\TK_SOFTWARE\Classes\SystemFileAssociations\.png\Shell\T3D Print" /f >nul 2>&1

				:: Un-Mounting Image Registry
				call :UnMountImageRegistry
			)

			if "%%z" equ "Microsoft.MSPaint" (
				:: Mounting Image Registry
				call :MountImageRegistry "%InstallMount%\%%i"

				:: Removing Edit with Paint 3D Option from right click context menu
				Reg delete "HKLM\TK_SOFTWARE\Classes\SystemFileAssociations\.3mf\Shell\3D Edit" /f >nul 2>&1
				Reg delete "HKLM\TK_SOFTWARE\Classes\SystemFileAssociations\.bmp\Shell\3D Edit" /f >nul 2>&1
				Reg delete "HKLM\TK_SOFTWARE\Classes\SystemFileAssociations\.fbx\Shell\3D Edit" /f >nul 2>&1
				Reg delete "HKLM\TK_SOFTWARE\Classes\SystemFileAssociations\.gif\Shell\3D Edit" /f >nul 2>&1
				Reg delete "HKLM\TK_SOFTWARE\Classes\SystemFileAssociations\.jfif\Shell\3D Edit" /f >nul 2>&1
				Reg delete "HKLM\TK_SOFTWARE\Classes\SystemFileAssociations\.jpe\Shell\3D Edit" /f >nul 2>&1
				Reg delete "HKLM\TK_SOFTWARE\Classes\SystemFileAssociations\.jpeg\Shell\3D Edit" /f >nul 2>&1
				Reg delete "HKLM\TK_SOFTWARE\Classes\SystemFileAssociations\.jpg\Shell\3D Edit" /f >nul 2>&1
				Reg delete "HKLM\TK_SOFTWARE\Classes\SystemFileAssociations\.png\Shell\3D Edit" /f >nul 2>&1
				Reg delete "HKLM\TK_SOFTWARE\Classes\SystemFileAssociations\.tif\Shell\3D Edit" /f >nul 2>&1
				Reg delete "HKLM\TK_SOFTWARE\Classes\SystemFileAssociations\.tiff\Shell\3D Edit" /f >nul 2>&1

				:: Un-Mounting Image Registry
				call :UnMountImageRegistry
			)

			if "%%z" equ "Microsoft.Print3D" if "%ImageBuild%" geq "16299"  (
				:: Mounting Image Registry
				call :MountImageRegistry "%InstallMount%\%%i"

				:: Removing 3D Objects Section from Windows Explorer Navigation Pane
				Reg delete "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Explorer\MyComputer\NameSpace\{0DB7E03F-FC29-4DC6-9020-FF41B59E513A}" /f >nul 2>&1
				if "%ImageArchitecture%" equ "x64" Reg delete "HKLM\TK_SOFTWARE\Wow6432Node\Microsoft\Windows\CurrentVersion\Explorer\MyComputer\NameSpace\{0DB7E03F-FC29-4DC6-9020-FF41B59E513A}" /f >nul 2>&1

				:: Un-Mounting Image Registry
				call :UnMountImageRegistry
			)

			if "%%z" equ "Microsoft.Microsoft3DViewer" if "%ImageBuild%" geq "16299"  (
				:: Mounting Image Registry
				call :MountImageRegistry "%InstallMount%\%%i"

				:: Removing 3D Objects Section from Windows Explorer Navigation Pane
				Reg delete "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Explorer\MyComputer\NameSpace\{0DB7E03F-FC29-4DC6-9020-FF41B59E513A}" /f >nul 2>&1
				if "%ImageArchitecture%" equ "x64" Reg delete "HKLM\TK_SOFTWARE\Wow6432Node\Microsoft\Windows\CurrentVersion\Explorer\MyComputer\NameSpace\{0DB7E03F-FC29-4DC6-9020-FF41B59E513A}" /f >nul 2>&1

				:: Un-Mounting Image Registry
				call :UnMountImageRegistry
			)
		)
	)
)

echo.-------------------------------------------------------------------------------
echo.####Fin de la suppression des applications Windows via la liste ################
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set RemoveAppsList=

endlocal

:: Returning to Remove Menu.
goto :RemoveMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Remove Windows Components Using Package List
::-------------------------------------------------------------------------------------------
:RemoveWindowsComponentsList

if "%IsDialogsEnabled%" equ "Yes" (
	cls
	echo.===============================================================================
	echo. MSMG ToolKit - Supprimer les composants Windows via la liste des packages 
	echo.===============================================================================
	echo.
	echo.
	echo.
	echo.                              A T T E N T I O N
	echo.                              =================
	echo.
	echo.   La suppression des packages sans tests appropries peut endommager le systeme 
	echo.   d'exploitation et/ou les fonctionalites.
	echo.
	echo.   Lors de l'ajout de packages a RemovePkgsList.txt, ajouter uniquement les noms 
	echo.   de package parent a l'exclusion de ses packages de langue ou sous-packages.
	echo.
	if "%SelectedSourceOS%" neq "w10" echo.
	if "%SelectedSourceOS%" equ "w10"  if "%ImageBuild%" lss "17763" echo.
	if "%SelectedSourceOS%" equ "w10"  if "%ImageBuild%" geq "17763" if "%ImageBuild%" leq "19042" echo.   E.g: WindowsDefender ^(ToolKitHelper.exe Method^)
	echo.   E.g: Windows-Defender-Client-Package ^(DISM Method^)
	echo.
	echo.   Pour desactiver les boites de dialogue d'avertissement, choisissez 
	echo.   Desactiver les boites de dialogue dans Outils-^>Menu Options 
	echo.
	echo.===============================================================================
	echo.
	choice /C:YN /N /M "Voulez-vous continuer ? ['Y'es/'N'o] : "
	if errorlevel 2 goto :RemoveMenu
)

setlocal

set "RemovePkgsList=%Lists%\RemovePkgsList.txt"
set RemovalMethod=

if "%SelectedSourceOS%" neq "w10" set "RemovalMethod=DISM"
if "%SelectedSourceOS%" equ "w10"  if "%ImageBuild%" lss "17763" set "RemovalMethod=DISM"

if "%SelectedSourceOS%" equ "w10"  if "%ImageBuild%" geq "17763" if "%ImageBuild%" leq "19042" (
	cls
	echo.===============================================================================
	echo. MSMG ToolKit - Supprimer des composants Windows via le menu Liste des packages 
	echo.===============================================================================
	echo.
	echo.  [1]   Supprimer des composants Windows via la liste des packages 
	echo.        ^(Methode DISM^) 
	echo.
	echo.  [2]   Supprimer des composants Windows via la liste des packages
	echo.        ^(Methode ToolKitHelper^) 
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.  	Remarque : utiliser une seule des methodes ci-dessus 
	echo.
	echo.
	echo.  [X]   Retour
	echo.
	echo.===============================================================================
	echo.
	choice /C:12X /N /M "Entrer votre choix : "
	if errorlevel 3 goto :RemoveMenu
	if errorlevel 2 set "RemovalMethod=ToolKitHelper"
	if errorlevel 1 set "RemovalMethod=DISM"
)

cls
echo.===============================================================================
echo.   MSMG ToolKit - Supprimer les composants Windows via la liste des packages 
echo.===============================================================================
echo.

:: Getting Install Image Index Architecture
for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" call :GetImageArchitecture "%InstallWim%", %%i >nul
)

echo.-------------------------------------------------------------------------------
echo.####Demarrage de la suppression des composants via la liste des packages ######
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    : Install.wim
if /i "%ImageIndexNo%" equ "A" echo.    Image Indexes            : 1-%ImageCount%
if /i "%ImageIndexNo%" neq "A" echo.    Image Index              : %ImageIndexNo%
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
echo.
echo.-------------------------------------------------------------------------------
echo.####Suppression de composants Windows via la liste des packages ###############
echo.-------------------------------------------------------------------------------

for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" (
		echo.
		if not %%i gtr 9 echo.===========================[Install.wim, Index : %%i]============================
		if %%i gtr 9 echo.==========================[Install.wim, Index : %%i]============================

		if "%RemovalMethod%" == "DISM" (
			for /f %%z IN ('"type %RemovePkgsList%" 2^>nul') do (
				call :RemoveLockedPackage "%InstallMount%\%%i", %%z, %%z
			)
		)

		if "%RemovalMethod%" == "ToolKitHelper" (
			%ToolKitHelper% "%InstallMount%\%%i" "%RemovePkgsList%"
			echo.
		)
	)
)

echo.-------------------------------------------------------------------------------
echo.####Fin de la suppression des composants Windows via la liste des packages ####
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set RemovePkgsList=
set RemovalMethod=

endlocal

:: Returning to Remove Menu.
goto :RemoveMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Enable Windows Features Using Features List
::-------------------------------------------------------------------------------------------
:EnableFeatures

setlocal

set "FeaturesList=%Lists%\EnableFeaturesList.txt"

cls
echo.===============================================================================
echo.        MSMG ToolKit - Activer les fonctionnalites Windows via la liste
echo.===============================================================================
echo.

:: Getting Install Image Index Architecture
for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" call :GetImageArchitecture "%InstallWim%", %%i >nul
)

echo.-------------------------------------------------------------------------------
echo.####Demarrage de l'activation des fonctionnalites Windows via la liste ########
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    : Install.wim
if /i "%ImageIndexNo%" equ "A" echo.    Image Indexes            : 1-%ImageCount%
if /i "%ImageIndexNo%" neq "A" echo.    Image Index              : %ImageIndexNo%
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
echo.
echo.-------------------------------------------------------------------------------
echo.####Activation des fonctionnalites Windows via la liste #######################
echo.-------------------------------------------------------------------------------

for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" (
		echo.
		if not %%i gtr 9 echo.===========================[Install.wim, Index : %%i]============================
		if %%i gtr 9 echo.==========================[Install.wim, Index : %%i]============================
		echo.

		for /f %%z IN ('"type %FeaturesList%" 2^>nul') do (
			echo.-------------------------------------------------------------------------------
			echo.Enabling Windows Feature - [%%z]...
			echo.-------------------------------------------------------------------------------
			call :EnableFeature "%InstallMount%\%%i" %%z
		)
	)
)

echo.-------------------------------------------------------------------------------
echo.####Activation des fonctionnalites Windows via la liste terminee ##############
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set FeaturesList=

endlocal

:: Returning to Customize Menu
goto :CustomizeMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Disable Windows Features Using Features List
::-------------------------------------------------------------------------------------------
:DisableFeatures

setlocal

set "FeaturesList=%Lists%\DisableFeaturesList.txt"

cls
echo.===============================================================================
echo.       MSMG ToolKit - Desactiver les fonctionnalites Windows via la liste 
echo.===============================================================================
echo.

:: Getting Install Image Index Architecture
for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" call :GetImageArchitecture "%InstallWim%", %%i >nul
)

echo.-------------------------------------------------------------------------------
echo.####Demarrage de la desactivation des fonctionnalites Windows via la liste ####
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    : Install.wim
if /i "%ImageIndexNo%" equ "A" echo.    Image Indexes            : 1-%ImageCount%
if /i "%ImageIndexNo%" neq "A" echo.    Image Index              : %ImageIndexNo%
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
echo.
echo.-------------------------------------------------------------------------------
echo.####Desactivation des fonctionnalites Windows via la liste ####################
echo.-------------------------------------------------------------------------------

for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" (
		echo.
		if not %%i gtr 9 echo.===========================[Install.wim, Index : %%i]============================
		if %%i gtr 9 echo.==========================[Install.wim, Index : %%i]============================
		echo.

		for /f %%z IN ('"type %FeaturesList%" 2^>nul') do (
			echo.-------------------------------------------------------------------------------
			echo.Désactivation de la fonctionnalite Windows  - [%%z]...
			echo.-------------------------------------------------------------------------------
			call :DisableFeature "%InstallMount%\%%i" %%z
		)
	)
)

echo.-------------------------------------------------------------------------------
echo.####Fin de la desactivation des fonctionnalites Windows via la liste ##########
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set FeaturesList=

endlocal

:: Returning to Customize Menu
goto :CustomizeMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Import Custom Default Inbox Apps Associations from XML File
::-------------------------------------------------------------------------------------------
:ImportMetroAppsAssociation

setlocal

set "CustomAppsAssociationXML=%XMLs%\%SelectedSourceOS%_CustomAppsAssociation.xml"

cls
echo.===============================================================================
echo.  MSMG ToolKit - Importer des associations d'applications de boite de reception 
echo.  par defaut personnalisees a partir d'un fichier XML 
echo.===============================================================================
echo.

:: Getting Install Image Index Architecture
for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" call :GetImageArchitecture "%InstallWim%", %%i >nul
)

echo.-------------------------------------------------------------------------------
echo.####Demarrage de l'importation d'associations d'applications de boite de 
echo.reception par defaut personnalisees a partir d'un fichier XML #################
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    : Install.wim
if /i "%ImageIndexNo%" equ "A" echo.    Image Indexes            : 1-%ImageCount%
if /i "%ImageIndexNo%" neq "A" echo.    Image Index              : %ImageIndexNo%
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
echo.
echo.-------------------------------------------------------------------------------
echo.####Importation d'associations d'applications de boite de reception par defaut
echo.personnalisees a partir d'un fichier XML ######################################
echo.-------------------------------------------------------------------------------

for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" (
		echo.
		if not %%i gtr 9 echo.===========================[Install.wim, Index : %%i]============================
		if %%i gtr 9 echo.==========================[Install.wim, Index : %%i]============================
		echo.

		call :ImportDefaultAppAssociations "%InstallMount%\%%i", "%CustomAppsAssociationXML%"
	)
)

echo.
echo.-------------------------------------------------------------------------------
echo.####Fin de l'importation des associations d'applications de boite de reception 
echo.par defaut personnalisees a partir d'un fichier XML ###########################
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set CustomAppsAssociationXML=

endlocal

:: Returning to Customize Menu
goto :CustomizeMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Export Default Inbox Apps Associations to XML File
::-------------------------------------------------------------------------------------------
:ExportMetroAppsAssociation

setlocal

set "DefaultMetroAppsAssociationXML=%XMLs%\%SelectedSourceOS%_DefaultAppsAssociation.xml"

cls
echo.===============================================================================
echo.      MSMG ToolKit - Exporter les associations d'applications de la boite 
echo.      de reception vers un fichier XML 
echo.===============================================================================
echo.

:: Getting Install Image Index Architecture
for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" call :GetImageArchitecture "%InstallWim%", %%i >nul
)

echo.-------------------------------------------------------------------------------
echo.####Demarrage de l'exportation des associations d'applications de la boite 
echo.de reception par defaut vers un fichier XML ###################################
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    : Install.wim
if /i "%ImageIndexNo%" equ "A" echo.    Image Indexes            : 1-%ImageCount%
if /i "%ImageIndexNo%" neq "A" echo.    Image Index              : %ImageIndexNo%
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
echo.
echo.-------------------------------------------------------------------------------
echo.####Verification de l'association des applications de la boite de reception 
echo.par defaut ####################################################################
echo.-------------------------------------------------------------------------------

for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" (
		echo.
		%DISM% /Image:"%InstallMount%\%%i" /Get-DefaultAppAssociations | findstr /c:"file could not be" >nul
		if errorlevel 1 (
			echo.Fichier XML de l'association des applications de la boite de reception par 
			echo.defaut trouve. 
			echo.
			echo.-------------------------------------------------------------------------------
			echo.Exportation des associations d'applications de la boite de réception par defaut echo.vers un fichier XML. .
			echo.-------------------------------------------------------------------------------
			echo.
			call :RemoveFile "%DefaultMetroAppsAssociationXML%"
			%DISM% /Image:"%InstallMount%\%%i" /Get-DefaultAppAssociations | findstr "<" >> "%DefaultMetroAppsAssociationXML%"
			echo.
			echo.-------------------------------------------------------------------------------
			echo.####Fin de l'exportation des associations d'applications de la boite de echo.reception par defaut vers un fichier XML ######################################
			echo.-------------------------------------------------------------------------------
			goto :Stop
		)
		if not errorlevel 1 (
			echo.L'association par defaut des applications de la boite de reception est vide. 
			echo.
			echo.-------------------------------------------------------------------------------
			echo.####Arrete d'exporter les associations d'applications de la boite de reception echo.par defaut vers un fichier XML ################################################
			echo.-------------------------------------------------------------------------------
			goto :Stop
		)
	)
)

:Stop
echo.
echo.===============================================================================
echo.
pause

set DefaultMetroAppsAssociationXML=

endlocal

:: Returning to Customize Menu
goto :CustomizeMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Remove Default Inbox Apps Association
::-------------------------------------------------------------------------------------------
:RemoveMetroAppsAssociation

setlocal

cls
echo.===============================================================================
echo.  MSMG ToolKit - Supprimer l'association des applis de la boite de reception 
echo.===============================================================================
echo.

:: Getting Install Image Index Architecture
for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" call :GetImageArchitecture "%InstallWim%", %%i >nul
)

echo.-------------------------------------------------------------------------------
echo.####Demarrage de la suppression de l'association d'applications de la boite 
echo.de reception par defaut #######################################################
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    : Install.wim
if /i "%ImageIndexNo%" equ "A" echo.    Image Indexes            : 1-%ImageCount%
if /i "%ImageIndexNo%" neq "A" echo.    Image Index              : %ImageIndexNo%
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
echo.
echo.-------------------------------------------------------------------------------

for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" (
		echo.
		if not %%i gtr 9 echo.===========================[Install.wim, Index : %%i]============================
		if %%i gtr 9 echo.==========================[Install.wim, Index : %%i]============================
		echo.
		echo.-------------------------------------------------------------------------------
		echo.Verification de l'association des applis de la boite de reception par defaut 
		echo.-------------------------------------------------------------------------------
		echo.
		%DISM% /Image:"%InstallMount%\%%i" /Get-DefaultAppAssociations | findstr /c:"file could not be" >nul
		if errorlevel 1 (
			echo.Le fichier XML de l'association des applications de la boite de reception
			echo.par defaut trouve. 
			echo.
			echo.-------------------------------------------------------------------------------
			echo.Suppression de l'association des applications de la boite de reception 
			echo.par defaut. 
			echo.-------------------------------------------------------------------------------
			call :RemoveDefaultAppAssociations "%InstallMount%\%%i"
			echo.
			if "%%i" equ "%ImageCount%" (
				echo.-------------------------------------------------------------------------------
				echo.####Fin de la suppression de l'association des applications de la boite de reception par defaut ###########################
				echo.-------------------------------------------------------------------------------
				echo.
			)
		) else (
			echo.L'association d'applications par defaut de la boite de reception a deja ete
			echo.supprimee. 
			echo.
			echo.Ignorer la suppression de l'association des applications de la boite de
			echo.reception par defaut. 
			echo.
			if "%%i" equ "%ImageCount%" (
				echo.-------------------------------------------------------------------------------
				echo.####Arret de la suppression de l'association des applications de la boite
				echo.de reception par defaut ############################
				echo.-------------------------------------------------------------------------------
				echo.
			)
		)
	)
)

:Stop
echo.===============================================================================
echo.
pause

endlocal

:: Returning to Customize Menu
goto :CustomizeMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Import Custom StartMenu Layout from XML File
::-------------------------------------------------------------------------------------------
:ImportStartMenuLayout

setlocal

set "CustomStartMenuLayoutXML=%XMLs%\%SelectedSourceOS%_CustomStartMenuLayout.xml"

cls
echo.===============================================================================
echo. MSMG ToolKit - Importer la disposition personnalisee du menu Demarrer via XML 
echo.===============================================================================
echo.

:: Getting Install Image Index Architecture
for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" call :GetImageArchitecture "%InstallWim%", %%i >nul
)

echo.-------------------------------------------------------------------------------
echo.####Demarrage de l'importation d'une mise en page de menu de demarrage 
echo.personnalisee via un fichier XML ##############################################
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    : Install.wim
if /i "%ImageIndexNo%" equ "A" echo.    Image Indexes            : 1-%ImageCount%
if /i "%ImageIndexNo%" neq "A" echo.    Image Index              : %ImageIndexNo%
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
echo.
echo.-------------------------------------------------------------------------------
echo.####Importation d'une disposition de menu de demarrage personnalisee 
echo.via un fichier XML ############################################################
echo.-------------------------------------------------------------------------------

for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" (
		echo.
		if not %%i gtr 9 echo.===========================[Install.wim, Index : %%i]============================
		if %%i gtr 9 echo.==========================[Install.wim, Index : %%i]============================
		echo.
		echo.Copie de la disposition du menu Demarrer personnalisee.
		copy %CustomStartMenuLayoutXML% "%InstallMount%\%%i\Users\Default\AppData\Local\Microsoft\Windows\Shell\LayoutModification.xml" >nul
		call :RemoveFolder "%InstallMount%\%%i\Users\Default\AppData\Local\TileDataLayer"
	)
)

echo.
echo.-------------------------------------------------------------------------------
echo.####Fin de l'importation de la disposition du menu Demarrer personnalisee 
echo.via un fichier XML ############################################################
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set CustomStartMenuLayoutXML=

endlocal

:: Returning to Customize Menu
goto :CustomizeMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Import Custom Registry Settings from Registry File
::-------------------------------------------------------------------------------------------
:ImportCustomRegistry

setlocal

cls
echo.===============================================================================
echo. MSMG ToolKit - Importer les parametres de registre via le fichier de registre 
echo.===============================================================================
echo.

:: Getting Install Image Index Architecture
for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" call :GetImageArchitecture "%InstallWim%", %%i >nul
)

set "CustomRegistry=%CustomRegistry%\%SelectedSourceOS%\%ImageArchitecture%"

:: Checking whether Custom Registry Settings Pack folder is empty
for /f %%i in ('dir /b /a:-d "%CustomRegistry%\*.reg" 2^>nul ^| find /v /c ""') do (
	if "%%i" equ "0" (
		echo.Le dossier Parametres de registre personnalises est vide.
		echo.
		echo.Veuillez copier les fichiers de registre dans le dossier
		echo.^<Custom\Registry\%SelectedSourceOS%\%ImageArchitecture%^>.
		goto :Stop
	)
)

echo.-------------------------------------------------------------------------------
echo.####Demarrage de l'importation des parametres de registre via le fichier ######
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    : Install.wim
if /i "%ImageIndexNo%" equ "A" echo.    Image Indexes            : 1-%ImageCount%
if /i "%ImageIndexNo%" neq "A" echo.    Image Index              : %ImageIndexNo%
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
echo.
echo.-------------------------------------------------------------------------------
echo.####Traitement des fichiers de parametres de registre personnalises  ##########
echo.-------------------------------------------------------------------------------
echo.
echo.Making Custom Registry compatible with ToolKit's Image Registry...
call :RemoveFolder "%Temp%\CustomRegistry"
call :CreateFolder "%Temp%\CustomRegistry"
PowerShell -Executionpolicy Bypass -File "%Bin%\ConvertReg.ps1" "%CustomRegistry%" "%Temp%\CustomRegistry"
echo.
echo.-------------------------------------------------------------------------------
echo.####Importation de parametres de registre via un fichier de registre  #########
echo.-------------------------------------------------------------------------------

for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" (
		echo.
		if not %%i gtr 9 echo.===========================[Install.wim, Index : %%i]============================
		if %%i gtr 9 echo.==========================[Install.wim, Index : %%i]============================
		echo.
		echo.Montage du registre d'images
		call :MountImageRegistry "%InstallMount%\%%i"
		echo.

		for /f "tokens=*" %%z in ('"dir /b "%Temp%\CustomRegistry\*.reg"" 2^>nul') do (
			echo.Importing [%%z] to Image Registry...
			call :ImportRegistry2Image "%Temp%\CustomRegistry\%%z"
		)

		echo.
		echo.Demontage du registre d'images 
		call :UnMountImageRegistry
	)
)

call :RemoveFolder "%Temp%\CustomRegistry"
echo.
echo.-------------------------------------------------------------------------------
echo.####Importation des parametres de registre via le fichier de registre termine #
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set CustomRegistry=

endlocal

:: Returning to Customize Menu
goto :CustomizeMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Apply Tweaks Menu
::-------------------------------------------------------------------------------------------
:ApplyTweaksMenu

setlocal

set Tweak=

cls
echo.===============================================================================
echo.                 MSMG ToolKit - Menu Appliquer les ajustements 
echo.===============================================================================
echo.

if "%SelectedSourceOS%" equ "w81" (
	echo.  [A]   Desactiver les mises a jour automatiques des pilotes via Windows Update
	echo.  [B]   Desactiver le telechargement automatique et l'installation des applis 
	echo.  [C]   Desactiver Windows Defender
	echo.  [D]   Desactiver Windows SmartScreen
	echo.  [E]   Desactiver la mise a niveau automatique de Windows
	echo.  [F]   Desactiver Windows Update
	echo.  [G]   Forcer les programmes .NET a utiliser le plus recent Framework .NET
	echo.  [H]   Activer la visionneuse de photos Windows
	echo.  [I]   Activer le codec professionnel MP3 Fraunhofer 
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.
	echo.  [X]   Retour
	echo.
	echo.===============================================================================
	echo.
	choice /C:ABCDEFGHIX /N /M "Entrer votre choix : "
	if errorlevel 10 goto :CustomizeMenu
	if errorlevel 9  set "Tweak=EnableFMP3ProCodec"
	if errorlevel 8  set "Tweak=EnablePhotoViewer"
	if errorlevel 7  set "Tweak=ForceLatestNetFramework"
	if errorlevel 6  set "Tweak=DisableWindowsUpdate"
	if errorlevel 5  set "Tweak=DisableWindowsUpgrade"
	if errorlevel 4  set "Tweak=DisableWindowsSmartScreen"
	if errorlevel 3  set "Tweak=DisableWindowsDefender"
	if errorlevel 2  set "Tweak=Disable3RDPartyApps"
	if errorlevel 1  set "Tweak=DisableDriversUpdates"
)

if "%SelectedSourceOS%" equ "w10" (
	echo.  [A]   Desactiver l'application Cortana
	echo.  [B]   Masquer l'icone TaskView de la barre des taches
	echo.  [C]   Desactiver les mises a jour automatiques des pilotes via Windows Update
	echo.  [D]   Desactiver le telechargement automatique et l'installation des applis
	echo.  [E]   Desactiver Windows Defender
	echo.  [F]   Desactiver Windows SmartScreen
	echo.  [G]   Desactiver la mise a niveau automatique de Windows
	echo.  [H]   Desactiver Windows Update
	echo.  [I]   Desactiver l'espace de stockage reserve pour les mises a jour Windows
	echo.  [J]   Forcer les programmes .NET a utiliser le plus recent Framework .NET
	echo.  [K]   Activer la visionneuse de photos Windows
	echo.  [L]   Activer le codec professionnel MP3 Fraunhofer
	echo.  [M]   Activer le nettoyage d'image DISM avec une reinitialisation complete 
	echo.
	echo.
	echo.  [X]   Retour
	echo.
	echo.===============================================================================
	echo.
	choice /C:ABCDEFGHIJKLMX /N /M "Entrer votre choix : "
	if errorlevel 14 goto :CustomizeMenu
	if errorlevel 13 set "Tweak=EnableFullResetBase"
	if errorlevel 12 set "Tweak=EnableFMP3ProCodec"
	if errorlevel 11 set "Tweak=EnablePhotoViewer"
	if errorlevel 10 set "Tweak=ForceLatestNetFramework"
	if errorlevel 9  set "Tweak=DisableReservedStorage"
	if errorlevel 8  set "Tweak=DisableWindowsUpdate"
	if errorlevel 7  set "Tweak=DisableWindowsUpgrade"
	if errorlevel 6  set "Tweak=DisableWindowsSmartScreen"
	if errorlevel 5  set "Tweak=DisableWindowsDefender"
	if errorlevel 4  set "Tweak=Disable3RDPartyApps"
	if errorlevel 3  set "Tweak=DisableDriversUpdates"
	if errorlevel 2  set "Tweak=HideTaskViewIcon"
	if errorlevel 1  set "Tweak=DisableCortanaApp"
)

cls
echo.===============================================================================
echo.                    MSMG ToolKit - Appliquer des ajustements 
echo.===============================================================================
echo.
:: Getting Install Image Index Architecture
if /i "%ImageIndexNo%" equ "A" call :GetImageArchitecture "%InstallWim%", 1 >nul
if /i "%ImageIndexNo%" neq "A" call :GetImageArchitecture "%InstallWim%", %ImageIndexNo% >nul

echo.-------------------------------------------------------------------------------
echo.####Commencer a appliquer des ajustements  ####################################
echo.-------------------------------------------------------------------------------
echo.
echo.    Image                    : Install.wim
if /i "%ImageIndexNo%" equ "A" echo.    Image Indexes            : 1-%ImageCount%
if /i "%ImageIndexNo%" neq "A" echo.    Image Index              : %ImageIndexNo%
echo.    Image Architecture       : %ImageArchitecture%
echo.    Image Version            : %ImageVersion%.%ImageServicePackBuild%.%ImageServicePackLevel%
echo.
echo.-------------------------------------------------------------------------------
if "%Tweak%" equ "Disable3RDPartyApps" echo.####Applying Disable Downloading and Installing 3rd Party Apps Tweak###########
if "%Tweak%" equ "DisableCortanaApp" echo.####Applying Disable Cortana App Tweak#########################################
if "%Tweak%" equ "DisableDriversUpdates" echo.####Applying Disable Automatic Driver Updates through Windows Update Tweak#####
if "%Tweak%" equ "DisableReservedStorage" echo.####Applying Disable Microsoft Reserved Storage Space for Windows Updates######
if "%Tweak%" equ "DisableWindowsDefender" echo.####Applying Disable Windows Defender Tweak####################################
if "%Tweak%" equ "DisableWindowsUpdate" echo.####Applying Disable Windows Update Tweak######################################
if "%Tweak%" equ "DisableWindowsUpgrade" echo.####Applying Disable Automatic Windows OS Upgrade Tweak########################
if "%Tweak%" equ "EnableFMP3ProCodec" echo.####Applying Enable Fraunhofer MP3 Professional Codec Tweak####################
if "%Tweak%" equ "EnableFullResetBase" echo.####Applying Enable DISM Image Cleanup with Full ResetBase Tweak###############
if "%Tweak%" equ "EnablePhotoViewer" echo.####Applying Enable Windows Photo Viewer Tweak#################################
if "%Tweak%" equ "ForceLatestNetFramework" echo.####Applying Force .NET Programs to Use Newest .NET Framework Tweak############
if "%Tweak%" equ "HideTaskViewIcon" echo.####Applying Hide Taskbar TaskView Icon Tweak##################################
echo.-------------------------------------------------------------------------------

for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" (
		echo.
		if not %%i gtr 9 echo.===========================[Install.wim, Index : %%i]============================
		if %%i gtr 9 echo.==========================[Install.wim, Index : %%i]============================
		echo.
		echo.Montage du registre d'images.
		call :MountImageRegistry "%InstallMount%\%%i"
		echo.Importing Registry Settings to Image Registry...

        if "%Tweak%" equ "DisableCortanaApp" (
	    	Reg add "HKLM\TK_DEFAULT\SOFTWARE\Microsoft\InputPersonalization\TrainedDataStore" /v "HarvestContacts" /t REG_DWORD /d "0" /f >nul 2>&1
	    	Reg add "HKLM\TK_DEFAULT\SOFTWARE\Microsoft\Windows\CurrentVersion\Search" /v "DeviceHistoryEnabled" /t REG_DWORD /d "0" /f >nul 2>&1
	    	Reg add "HKLM\TK_DEFAULT\SOFTWARE\Microsoft\Windows\CurrentVersion\Search" /v "HistoryViewEnabled" /t REG_DWORD /d "0" /f >nul 2>&1
	    	Reg add "HKLM\TK_DEFAULT\SOFTWARE\Microsoft\Windows\CurrentVersion\Windows Search" /v "CortanaConsent" /t REG_DWORD /d "0" /f >nul 2>&1
	    	Reg add "HKLM\TK_DEFAULT\SOFTWARE\Microsoft\Windows\CurrentVersion\Windows Search" /v "CortanaIsReplaceable" /t REG_DWORD /d "1" /f >nul 2>&1
	    	Reg add "HKLM\TK_DEFAULT\SOFTWARE\Microsoft\Windows\CurrentVersion\Windows Search" /v "CortanaIsReplaced" /t REG_DWORD /d "1" /f >nul 2>&1
	    	Reg add "HKLM\TK_DEFAULT\SOFTWARE\Microsoft\Windows\CurrentVersion\Windows Search" /v "SearchboxTaskbarMode" /t REG_DWORD /d "0" /f >nul 2>&1
	    	Reg add "HKLM\TK_DEFAULT\SOFTWARE\Policies\Microsoft\InputPersonalization" /v "RestrictImplicitInkCollection" /t REG_DWORD /d "1" /f >nul 2>&1
	    	Reg add "HKLM\TK_DEFAULT\SOFTWARE\Policies\Microsoft\InputPersonalization" /v "RestrictImplicitTextCollection" /t REG_DWORD /d "1" /f >nul 2>&1
	    	Reg add "HKLM\TK_NTUSER\SOFTWARE\Classes\Local Settings\Software\Microsoft\Windows\CurrentVersion\AppContainer\Storage\microsoft.microsoftedge_8wekyb3d8bbwe\MicrosoftEdge\ServiceUI" /v "EnableCortana" /t REG_DWORD /d "0" /f >nul 2>&1
	    	Reg add "HKLM\TK_NTUSER\SOFTWARE\Microsoft\InputPersonalization" /v "RestrictImplicitInkCollection" /t REG_DWORD /d "1" /f >nul 2>&1
	    	Reg add "HKLM\TK_NTUSER\SOFTWARE\Microsoft\InputPersonalization" /v "RestrictImplicitTextCollection" /t REG_DWORD /d "1" /f >nul 2>&1
	    	Reg add "HKLM\TK_NTUSER\SOFTWARE\Microsoft\InputPersonalization\TrainedDataStore" /v "HarvestContacts" /t REG_DWORD /d "0" /f >nul 2>&1
	    	Reg add "HKLM\TK_NTUSER\SOFTWARE\Microsoft\Personalization\Settings" /v "AcceptedPrivacyPolicy" /t REG_DWORD /d "0" /f >nul 2>&1
	    	Reg add "HKLM\TK_NTUSER\SOFTWARE\Microsoft\Windows\CurrentVersion\Search" /v "DeviceHistoryEnabled" /t REG_DWORD /d "0" /f >nul 2>&1
	    	Reg add "HKLM\TK_NTUSER\SOFTWARE\Microsoft\Windows\CurrentVersion\Search" /v "HistoryViewEnabled" /t REG_DWORD /d "0" /f >nul 2>&1
	    	Reg add "HKLM\TK_NTUSER\SOFTWARE\Microsoft\Windows\CurrentVersion\Windows Search" /v "CortanaConsent" /t REG_DWORD /d "0" /f >nul 2>&1
	    	Reg add "HKLM\TK_NTUSER\SOFTWARE\Microsoft\Windows\CurrentVersion\Windows Search" /v "CortanaIsReplaceable" /t REG_DWORD /d "1" /f >nul 2>&1
	    	Reg add "HKLM\TK_NTUSER\SOFTWARE\Microsoft\Windows\CurrentVersion\Windows Search" /v "CortanaIsReplaced" /t REG_DWORD /d "1" /f >nul 2>&1
	    	Reg add "HKLM\TK_NTUSER\SOFTWARE\Microsoft\Windows\CurrentVersion\Windows Search" /v "SearchboxTaskbarMode" /t REG_DWORD /d "0" /f >nul 2>&1
	    	Reg add "HKLM\TK_SOFTWARE\Microsoft\PolicyManager\current\device\AboveLock" /v "AllowCortanaAboveLock" /t REG_DWORD /d "0" /f >nul 2>&1
	    	Reg add "HKLM\TK_SOFTWARE\Microsoft\PolicyManager\current\device\Experience" /v "AllowCortana" /t REG_DWORD /d "0" /f >nul 2>&1
	    	Reg add "HKLM\TK_SOFTWARE\Microsoft\Speech_OneCore\Preferences" /v "ModelDownloadAllowed" /t REG_DWORD /d "0" /f >nul 2>&1
	    	Reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Search" /v "SearchboxTaskbarMode" /t REG_DWORD /d "1" /f >nul 2>&1
	    	Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\InputPersonalization" /v "AllowInputPersonalization" /t REG_DWORD /d "0" /f >nul 2>&1
	    	Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\Windows\Windows Search" /v "AllowCloudSearch" /t REG_DWORD /d "0" /f >nul 2>&1
	    	Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\Windows\Windows Search" /v "AllowCortana" /t REG_DWORD /d "0" /f >nul 2>&1
	    	Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\Windows\Windows Search" /v "AllowCortanaAboveLock" /t REG_DWORD /d "0" /f >nul 2>&1
	    	Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\Windows\Windows Search" /v "AllowSearchToUseLocation" /t REG_DWORD /d "0" /f >nul 2>&1
	    	Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\Windows\Windows Search" /v "ConnectedSearchPrivacy" /t REG_DWORD /d "3" /f >nul 2>&1
	    	Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\Windows\Windows Search" /v "ConnectedSearchSafeSearch" /t REG_DWORD /d "3" /f >nul 2>&1
	    	Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\Windows\Windows Search" /v "ConnectedSearchUseWeb" /t REG_DWORD /d "0" /f >nul 2>&1
	    	Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\Windows\Windows Search" /v "ConnectedSearchUseWebOverMeteredConnections" /t REG_DWORD /d "0" /f >nul 2>&1
	    	Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\Windows\Windows Search" /v "DisableWebSearch" /t REG_DWORD /d "1" /f >nul 2>&1
	    	Reg add "HKLM\TK_SOFTWARE\Policies\Wow6432Node\Microsoft\Windows\Windows Search" /v "AllowCortana" /t REG_DWORD /d "0" /f >nul 2>&1
	    	Reg add "HKLM\TK_SOFTWARE\Policies\Wow6432Node\Microsoft\Windows\Windows Search" /v "AllowCortanaAboveLock" /t REG_DWORD /d "0" /f >nul 2>&1
	    	Reg add "HKLM\TK_SYSTEM\ControlSet001\Services\SharedAccess\Parameters\FirewallPolicy\FirewallRules" /v "Block Cortana ActionUriServer.exe" /t REG_SZ /d "v2.26|Action=Block|Active=TRUE|Dir=Out|RA42=IntErnet|RA62=IntErnet|App=C:\Windows\SystemApps\Microsoft.Windows.Cortana_cw5n1h2txyewy\ActionUriServer.exe|Name=Block Cortana ActionUriServer.exe|Desc=Block Cortana Outbound UDP/TCP Traffic|" /f >nul 2>&1
	    	Reg add "HKLM\TK_SYSTEM\ControlSet001\Services\SharedAccess\Parameters\FirewallPolicy\FirewallRules" /v "Block Cortana Package" /t REG_SZ /d "v2.26|Action=Block|Active=TRUE|Dir=Out|RA42=IntErnet|RA62=IntErnet|Name=Block Cortana Package|Desc=Block Cortana Outbound UDP/TCP Traffic|AppPkgId=S-1-15-2-1861897761-1695161497-2927542615-642690995-327840285-2659745135-2630312742|Platform=2:6:2|Platform2=GTEQ|" /f >nul 2>&1
	    	Reg add "HKLM\TK_SYSTEM\ControlSet001\Services\SharedAccess\Parameters\FirewallPolicy\FirewallRules" /v "Block Cortana PlacesServer.exe" /t REG_SZ /d "v2.26|Action=Block|Active=TRUE|Dir=Out|RA42=IntErnet|RA62=IntErnet|App=C:\Windows\SystemApps\Microsoft.Windows.Cortana_cw5n1h2txyewy\PlacesServer.exe|Name=Block Cortana PlacesServer.exe|Desc=Block Cortana Outbound UDP/TCP Traffic|" /f >nul 2>&1
	    	Reg add "HKLM\TK_SYSTEM\ControlSet001\Services\SharedAccess\Parameters\FirewallPolicy\FirewallRules" /v "Block Cortana RemindersServer.exe" /t REG_SZ /d "v2.26|Action=Block|Active=TRUE|Dir=Out|RA42=IntErnet|RA62=IntErnet|App=C:\Windows\SystemApps\Microsoft.Windows.Cortana_cw5n1h2txyewy\RemindersServer.exe|Name=Block Cortana RemindersServer.exe|Desc=Block Cortana Outbound UDP/TCP Traffic|" /f >nul 2>&1
	    	Reg add "HKLM\TK_SYSTEM\ControlSet001\Services\SharedAccess\Parameters\FirewallPolicy\FirewallRules" /v "Block Cortana RemindersShareTargetApp.exe" /t REG_SZ /d "v2.26|Action=Block|Active=TRUE|Dir=Out|RA42=IntErnet|RA62=IntErnet|App=C:\Windows\SystemApps\Microsoft.Windows.Cortana_cw5n1h2txyewy\RemindersShareTargetApp.exe|Name=Block Cortana RemindersShareTargetApp.exe|Desc=Block Cortana Outbound UDP/TCP Traffic|" /f >nul 2>&1
	    	Reg add "HKLM\TK_SYSTEM\ControlSet001\Services\SharedAccess\Parameters\FirewallPolicy\FirewallRules" /v "Block Cortana SearchUI.exe" /t REG_SZ /d "v2.26|Action=Block|Active=TRUE|Dir=Out|RA42=IntErnet|RA62=IntErnet|App=C:\Windows\SystemApps\Microsoft.Windows.Cortana_cw5n1h2txyewy\SearchUI.exe|Name=Block Cortana SearchUI.exe|Desc=Block Cortana Outbound UDP/TCP Traffic|" /f >nul 2>&1
        )

        if "%Tweak%" equ "HideTaskViewIcon" Reg add "HKLM\TK_NTUSER\SOFTWARE\Microsoft\Windows\CurrentVersion\Explorer\Advanced" /v "ShowTaskViewButton" /t REG_DWORD /d "0" /f >nul

        if "%Tweak%" equ "DisableDriversUpdates" (
	    	Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\Windows\Device Metadata" /v "PreventDeviceMetadataFromNetwork" /t REG_DWORD /d "1" /f >nul
	    	Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\Windows\DriverSearching" /v "DontPromptForWindowsUpdate" /t REG_DWORD /d "1" /f >nul
	    	Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\Windows\DriverSearching" /v "DontSearchWindowsUpdate" /t REG_DWORD /d "1" /f >nul
	    	Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\Windows\DriverSearching" /v "DriverUpdateWizardWuSearchEnabled" /t REG_DWORD /d "0" /f >nul
	    	Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\Windows\DriverSearching" /v "SearchOrderConfig" /t REG_DWORD /d "1" /f >nul
	    	Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\Windows\WindowsUpdate" /v "ExcludeWUDriversInQualityUpdate" /t REG_DWORD /d "1" /f >nul
        )

        if "%Tweak%" equ "Disable3RDPartyApps" (
	    	Reg add "HKLM\TK_NTUSER\SOFTWARE\Microsoft\Windows\CurrentVersion\ContentDeliveryManager" /v "OemPreInstalledAppsEnabled" /t REG_DWORD /d "0" /f >nul
	    	Reg add "HKLM\TK_NTUSER\SOFTWARE\Microsoft\Windows\CurrentVersion\ContentDeliveryManager" /v "PreInstalledAppsEnabled" /t REG_DWORD /d "0" /f >nul
	    	Reg add "HKLM\TK_NTUSER\SOFTWARE\Microsoft\Windows\CurrentVersion\ContentDeliveryManager" /v "SilentInstalledAppsEnabled" /t REG_DWORD /d "0" /f >nul
	    	Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\Windows\CloudContent" /v "DisableWindowsConsumerFeatures" /t REG_DWORD /d "1" /f >nul
        )

        if "%Tweak%" equ "DisableWindowsDefender" (
	    	Reg add "HKLM\TK_DEFAULT\SOFTWARE\Microsoft\Windows Security Health\State" /v "AccountProtection_MicrosoftAccount_Disconnected" /t REG_DWORD /d "0" /f >nul 2>&1
	    	Reg add "HKLM\TK_NTUSER\SOFTWARE\Microsoft\Windows Security Health\State" /v "AccountProtection_MicrosoftAccount_Disconnected" /t REG_DWORD /d "0" /f >nul 2>&1
	    	Reg add "HKLM\TK_SOFTWARE\Microsoft\Windows Defender Security Center\Notifications" /v "DisableNotifications" /t REG_DWORD /d "1" /f >nul 2>&1
	    	Reg add "HKLM\TK_SOFTWARE\Microsoft\Windows Defender Security Center\Notifications" /v "DisableEnhancedNotifications" /t REG_DWORD /d "1" /f >nul 2>&1
	    	Reg add "HKLM\TK_SOFTWARE\Microsoft\Windows Defender\Features" /v "TamperProtection" /t REG_DWORD /d "0" /f >nul 2>&1
	    	Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\MRT" /v "DontOfferThroughWUAU" /t REG_DWORD /d "1" /f >nul 2>&1
	    	Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\MRT" /v "DontReportInfectionInformation" /t REG_DWORD /d "1" /f >nul 2>&1
	    	Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\Windows Defender" /v "DisableAntiSpyware" /t REG_DWORD /d "1" /f >nul 2>&1
	    	Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\Windows Defender\Spynet" /v "SpyNetReporting" /t REG_DWORD /d "0" /f >nul 2>&1
	    	Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\Windows Defender\Spynet" /v "SubmitSamplesConsent" /t REG_DWORD /d "2" /f >nul 2>&1
	    	Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\Windows Defender Security Center\Systray" /v "HideSystray" /t REG_DWORD /d "1" /f >nul 2>&1
        )

        if "%Tweak%" equ "DisableWindowsSmartScreen" Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\Windows\System" /v "EnableSmartScreen" /t REG_DWORD /d "0" /f >nul 2>&1

        if "%Tweak%" equ "DisableWindowsUpgrade" (
	        if "%SelectedSourceOS%" neq "w10" (
		    	Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\Windows\Gwx" /v "DisableGwx" /t REG_DWORD /d "1" /f >nul
		    	Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\Windows\WindowsUpdate" /v "DisableOSUpgrade" /t REG_DWORD /d "1" /f >nul
	        )

    	    if "%SelectedSourceOS%" equ "w10" (
		    	Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\Windows\WindowsUpdate\AU" /v "AUOptions" /t REG_DWORD /d "2" /f >nul
		    	Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\Windows\WindowsUpdate\AU" /v "NoAutoUpdate" /t REG_DWORD /d "1" /f >nul
		    	Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\Windows\WindowsUpdate" /v "DeferUpdatePeriod" /t REG_DWORD /d "0" /f >nul 2>&1
		    	Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\Windows\WindowsUpdate" /v "DeferUpgrade" /t REG_DWORD /d "1" /f >nul 2>&1
		    	Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\Windows\WindowsUpdate" /v "DeferUpgradePeriod" /t REG_DWORD /d "1" /f >nul 2>&1
		    	Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\Windows\WindowsUpdate" /v "TargetReleaseVersion" /t REG_DWORD /d "1" >nul 2>&1
		    	if "%ImageBuild%" equ "17134" Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\Windows\WindowsUpdate" /v "TargetReleaseVersionInfo" /t REG_SZ /d "1803" >nul 2>&1
		    	if "%ImageBuild%" equ "17763" Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\Windows\WindowsUpdate" /v "TargetReleaseVersionInfo" /t REG_SZ /d "1809" >nul 2>&1
		    	if "%ImageBuild%" equ "18362" Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\Windows\WindowsUpdate" /v "TargetReleaseVersionInfo" /t REG_SZ /d "1903" >nul 2>&1
		    	if "%ImageBuild%" equ "18363" Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\Windows\WindowsUpdate" /v "TargetReleaseVersionInfo" /t REG_SZ /d "1909" >nul 2>&1
		    	if "%ImageBuild%" equ "19041" Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\Windows\WindowsUpdate" /v "TargetReleaseVersionInfo" /t REG_SZ /d "2004" >nul 2>&1
		    	if "%ImageBuild%" equ "19042" Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\Windows\WindowsUpdate" /v "TargetReleaseVersionInfo" /t REG_SZ /d "20H2" >nul 2>&1
	        )
        )

        if "%Tweak%" equ "DisableWindowsUpdate" (
	    	Reg add "HKLM\TK_DEFAULT\SOFTWARE\Microsoft\Windows\CurrentVersion\ContentDeliveryManager" /v "SubscribedContent-310093Enabled" /t REG_DWORD /d "0" /f >nul 2>&1
	    	Reg add "HKLM\TK_NTUSER\SOFTWARE\Microsoft\Windows\CurrentVersion\ContentDeliveryManager" /v "SubscribedContent-310093Enabled" /t REG_DWORD /d "0" /f >nul 2>&1
	    	Reg add "HKLM\TK_NTUSER\SOFTWARE\Microsoft\Windows\CurrentVersion\DeliveryOptimization" /v "SystemSettingsDownloadMode" /t REG_DWORD /d "0" /f >nul 2>&1
	    	Reg add "HKLM\TK_SOFTWARE\Microsoft\Speech_OneCore\Preferences" /v "ModelDownloadAllowed" /t REG_DWORD /d "0" /f >nul 2>&1
	    	Reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\DeliveryOptimization" /v "OptInOOBE" /t REG_DWORD /d "0" /f >nul 2>&1
	    	Reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\DeliveryOptimization\Config" /v "DODownloadMode" /t REG_DWORD /d "0" /f >nul 2>&1
	    	Reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\WindowsStore\WindowsUpdate" /v "AutoDownload" /t REG_DWORD /d "2" /f >nul 2>&1
	    	Reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\WindowsUpdate\Services\7971f918-a847-4430-9279-4a52d1efe18d" /v "registeredWithAU" /t REG_DWORD /d "0" /f >nul 2>&1
	    	Reg add "HKLM\TK_SOFTWARE\Microsoft\WindowsUpdate\UX\Settings" /v "HideMCTLink" /t REG_DWORD /d "1" /f >nul 2>&1
	    	Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\Speech" /v "AllowSpeechModelUpdate" /t REG_DWORD /d "0" /f >nul 2>&1
	    	Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\Windows\DeliveryOptimization" /v "DODownloadMode" /t REG_DWORD /d "0" /f >nul 2>&1
	    	Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\Windows\WindowsUpdate\AU" /v "AUOptions" /t REG_DWORD /d "2" /f >nul 2>&1
	    	Reg add "HKLM\TK_SOFTWARE\Policies\Microsoft\Windows\WindowsUpdate\AU" /v "NoAutoUpdate" /t REG_DWORD /d "1" /f >nul 2>&1
	    	Reg add "HKLM\TK_SYSTEM\ControlSet001\Services\wuauserv" /v "Start" /t REG_DWORD /d "4" /f >nul 2>&1
        )

        if "%Tweak%" equ "DisableReservedStorage" Reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\ReserveManager" /v "ShippedWithReserves" /t REG_DWORD /d "0" /f >nul
        if "%Tweak%" equ "ForceLatestNetFramework" Reg add "HKLM\TK_SOFTWARE\Microsoft\.NETFramework" /v "OnlyUseLatestCLR" /t REG_DWORD /d "1" /f >nul

        if "%Tweak%" equ "EnablePhotoViewer" (
	    	Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\ApplicationAssociationToasts" /v "emffile_.emf" /t REG_DWORD /d "0" /f >nul
	    	Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\ApplicationAssociationToasts" /v "rlefile_.rle" /t REG_DWORD /d "0" /f >nul
	    	Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\ApplicationAssociationToasts" /v "wmffile_.wmf" /t REG_DWORD /d "0" /f >nul
	    	Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer" /v "GlobalAssocChangedCounter" /t REG_DWORD /d "13" /f >nul
	    	Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.bmp\OpenWithList" /v "a" /t REG_SZ /d "PhotoViewer.dll" /f >nul
	    	Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.bmp\OpenWithList" /v "MRUList" /t REG_SZ /d "a" /f >nul
	    	Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.bmp\UserChoice" /v "Hash" /t REG_SZ /d "TDU75KWAGi4=" /f >nul
	    	Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.bmp\UserChoice" /v "ProgId" /t REG_SZ /d "PhotoViewer.FileAssoc.Bitmap" /f >nul
	    	Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.dib\OpenWithList" /v "a" /t REG_SZ /d "PhotoViewer.dll" /f >nul
	    	Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.dib\OpenWithList" /v "MRUList" /t REG_SZ /d "a" /f >nul
	    	Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.dib\UserChoice" /v "Hash" /t REG_SZ /d "hAQpLYJfRYE=" /f >nul
	    	Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.dib\UserChoice" /v "ProgId" /t REG_SZ /d "PhotoViewer.FileAssoc.Bitmap" /f >nul
	    	Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.gif\OpenWithList" /v "a" /t REG_SZ /d "PhotoViewer.dll" /f >nul
	    	Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.gif\OpenWithList" /v "MRUList" /t REG_SZ /d "a" /f >nul
	    	Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.gif\UserChoice" /v "Hash" /t REG_SZ /d "1in4hcmDrB4=" /f >nul
	    	Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.gif\UserChoice" /v "ProgId" /t REG_SZ /d "PhotoViewer.FileAssoc.Gif" /f >nul
	    	Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.jfif\OpenWithList" /v "a" /t REG_SZ /d "PhotoViewer.dll" /f >nul
	    	Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.jfif\OpenWithList" /v "MRUList" /t REG_SZ /d "a" /f >nul
	    	Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.jfif\UserChoice" /v "Hash" /t REG_SZ /d "Y5upkzp3g5E=" /f >nul
	    	Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.jfif\UserChoice" /v "ProgId" /t REG_SZ /d "PhotoViewer.FileAssoc.JFIF" /f >nul
	    	Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.jpe\OpenWithList" /v "a" /t REG_SZ /d "PhotoViewer.dll" /f >nul
	    	Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.jpe\OpenWithList" /v "MRUList" /t REG_SZ /d "a" /f >nul
	    	Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.jpe\UserChoice" /v "Hash" /t REG_SZ /d "ZIeqfdrNtFk=" /f >nul
	    	Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.jpe\UserChoice" /v "ProgId" /t REG_SZ /d "PhotoViewer.FileAssoc.Jpeg" /f >nul
	    	Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.jpeg\OpenWithList" /v "a" /t REG_SZ /d "PhotoViewer.dll" /f >nul
	    	Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.jpeg\OpenWithList" /v "MRUList" /t REG_SZ /d "a" /f >nul
	    	Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.jpeg\UserChoice" /v "Hash" /t REG_SZ /d "iVWM3EAePKw=" /f >nul
	    	Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.jpeg\UserChoice" /v "ProgId" /t REG_SZ /d "PhotoViewer.FileAssoc.Jpeg" /f >nul
	    	Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.jpg\OpenWithList" /v "a" /t REG_SZ /d "PhotoViewer.dll" /f >nul
	    	Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.jpg\OpenWithList" /v "MRUList" /t REG_SZ /d "a" /f >nul
	    	Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.jpg\UserChoice" /v "Hash" /t REG_SZ /d "Xq9gH4jXoFM=" /f >nul
	    	Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.jpg\UserChoice" /v "ProgId" /t REG_SZ /d "PhotoViewer.FileAssoc.Jpeg" /f >nul
	    	Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.jxr\OpenWithList" /v "a" /t REG_SZ /d "PhotoViewer.dll" /f >nul
	    	Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.jxr\OpenWithList" /v "MRUList" /t REG_SZ /d "a" /f >nul
	    	Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.jxr\UserChoice" /v "Hash" /t REG_SZ /d "ahz7f/Yl09M=" /f >nul
	    	Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.jxr\UserChoice" /v "ProgId" /t REG_SZ /d "PhotoViewer.FileAssoc.Wdp" /f >nul
	    	Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.png\OpenWithList" /v "a" /t REG_SZ /d "PhotoViewer.dll" /f >nul
	    	Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.png\OpenWithList" /v "MRUList" /t REG_SZ /d "a" /f >nul
	    	Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.png\UserChoice" /v "Hash" /t REG_SZ /d "Evm7jp++AWA=" /f >nul
	    	Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.png\UserChoice" /v "ProgId" /t REG_SZ /d "PhotoViewer.FileAssoc.Png" /f >nul
	    	Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.tif\OpenWithList" /v "a" /t REG_SZ /d "PhotoViewer.dll" /f >nul
	    	Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.tif\OpenWithList" /v "MRUList" /t REG_SZ /d "a" /f >nul
	    	Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.tif\UserChoice" /v "Hash" /t REG_SZ /d "wEj9gLqtYH4=" /f >nul
	    	Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.tif\UserChoice" /v "ProgId" /t REG_SZ /d "TIFImage.Document" /f >nul
	    	Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.tiff\OpenWithList" /v "a" /t REG_SZ /d "PhotoViewer.dll" /f >nul
	    	Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.tiff\OpenWithList" /v "MRUList" /t REG_SZ /d "a" /f >nul
	    	Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.tiff\UserChoice" /v "Hash" /t REG_SZ /d "/r2V12Yryig=" /f >nul
	    	Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.tiff\UserChoice" /v "ProgId" /t REG_SZ /d "TIFImage.Document" /f >nul
	    	Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.wdp\OpenWithList" /v "a" /t REG_SZ /d "PhotoViewer.dll" /f >nul
	    	Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.wdp\OpenWithList" /v "MRUList" /t REG_SZ /d "a" /f >nul
	    	Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.wdp\UserChoice" /v "Hash" /t REG_SZ /d "/qcrPB0bhuI=" /f >nul
	    	Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\CurrentVersion\Explorer\FileExts\.wdp\UserChoice" /v "ProgId" /t REG_SZ /d "PhotoViewer.FileAssoc.Wdp" /f >nul
	    	Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\Roaming\OpenWith\FileExts\.bmp\UserChoice" /v "Hash" /t REG_SZ /d "rEigxhAPyos=" /f >nul
	    	Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\Roaming\OpenWith\FileExts\.bmp\UserChoice" /v "ProgId" /t REG_SZ /d "PhotoViewer.FileAssoc.Bitmap" /f >nul
	    	Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\Roaming\OpenWith\FileExts\.dib\UserChoice" /v "Hash" /t REG_SZ /d "R60f5QZs3Hg=" /f >nul
	    	Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\Roaming\OpenWith\FileExts\.dib\UserChoice" /v "ProgId" /t REG_SZ /d "PhotoViewer.FileAssoc.Bitmap" /f >nul
	    	Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\Roaming\OpenWith\FileExts\.gif\UserChoice" /v "Hash" /t REG_SZ /d "YcQO9pssSPU=" /f >nul
	    	Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\Roaming\OpenWith\FileExts\.gif\UserChoice" /v "ProgId" /t REG_SZ /d "PhotoViewer.FileAssoc.Gif" /f >nul
	    	Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\Roaming\OpenWith\FileExts\.jfif\UserChoice" /v "Hash" /t REG_SZ /d "5yjvWKb+Jns=" /f >nul
	    	Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\Roaming\OpenWith\FileExts\.jfif\UserChoice" /v "ProgId" /t REG_SZ /d "PhotoViewer.FileAssoc.JFIF" /f >nul
	    	Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\Roaming\OpenWith\FileExts\.jpe\UserChoice" /v "Hash" /t REG_SZ /d "TujD2rCi+po=" /f >nul
	    	Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\Roaming\OpenWith\FileExts\.jpe\UserChoice" /v "ProgId" /t REG_SZ /d "PhotoViewer.FileAssoc.Jpeg" /f >nul
	    	Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\Roaming\OpenWith\FileExts\.jpeg\UserChoice" /v "Hash" /t REG_SZ /d "wdZ9wQI4vW8=" /f >nul
	    	Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\Roaming\OpenWith\FileExts\.jpeg\UserChoice" /v "ProgId" /t REG_SZ /d "PhotoViewer.FileAssoc.Jpeg" /f >nul
	    	Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\Roaming\OpenWith\FileExts\.jpg\UserChoice" /v "Hash" /t REG_SZ /d "3xY0V0JOiFc=" /f >nul
	    	Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\Roaming\OpenWith\FileExts\.jpg\UserChoice" /v "ProgId" /t REG_SZ /d "PhotoViewer.FileAssoc.Jpeg" /f >nul
	    	Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\Roaming\OpenWith\FileExts\.jxr\UserChoice" /v "Hash" /t REG_SZ /d "ENXEd5Uzg84=" /f >nul
	    	Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\Roaming\OpenWith\FileExts\.jxr\UserChoice" /v "ProgId" /t REG_SZ /d "PhotoViewer.FileAssoc.Wdp" /f >nul
	    	Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\Roaming\OpenWith\FileExts\.png\UserChoice" /v "Hash" /t REG_SZ /d "SPesrUKrIFE=" /f >nul
	    	Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\Roaming\OpenWith\FileExts\.png\UserChoice" /v "ProgId" /t REG_SZ /d "PhotoViewer.FileAssoc.Png" /f >nul
	    	Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\Roaming\OpenWith\FileExts\.tif\UserChoice" /v "Hash" /t REG_SZ /d "bCXQRSAHD/I=" /f >nul
	    	Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\Roaming\OpenWith\FileExts\.tif\UserChoice" /v "ProgId" /t REG_SZ /d "TIFImage.Document" /f >nul
	    	Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\Roaming\OpenWith\FileExts\.tiff\UserChoice" /v "Hash" /t REG_SZ /d "7F/LfjhVnes=" /f >nul
	    	Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\Roaming\OpenWith\FileExts\.tiff\UserChoice" /v "ProgId" /t REG_SZ /d "TIFImage.Document" /f >nul
	    	Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\Roaming\OpenWith\FileExts\.wdp\UserChoice" /v "Hash" /t REG_SZ /d "tu0JqOen+Es=" /f >nul
	    	Reg add "HKLM\TK_NTUSER\Software\Microsoft\Windows\Roaming\OpenWith\FileExts\.wdp\UserChoice" /v "ProgId" /t REG_SZ /d "PhotoViewer.FileAssoc.Wdp" /f >nul
	    	Reg add "HKLM\TK_SOFTWARE\Classes\Applications\photoviewer.dll\shell\open" /v "MuiVerb" /t REG_SZ /d "@photoviewer.dll,-3043" /f >nul
	    	Reg add "HKLM\TK_SOFTWARE\Classes\Applications\photoviewer.dll\shell\open\command" /ve /t REG_EXPAND_SZ /d "%%SystemRoot%%\System32\rundll32.exe \"%%ProgramFiles%%\Windows Photo Viewer\PhotoViewer.dll\", ImageView_Fullscreen %%1" /f >nul
	    	Reg add "HKLM\TK_SOFTWARE\Classes\Applications\photoviewer.dll\shell\open\DropTarget" /v "Clsid" /t REG_SZ /d "{FFE2A43C-56B9-4bf5-9A79-CC6D4285608A}" /f >nul
	    	Reg add "HKLM\TK_SOFTWARE\Classes\Applications\photoviewer.dll\shell\print\command" /ve /t REG_EXPAND_SZ /d "%%SystemRoot%%\System32\rundll32.exe \"%%ProgramFiles%%\Windows Photo Viewer\PhotoViewer.dll\", ImageView_Fullscreen %%1" /f >nul
	    	Reg add "HKLM\TK_SOFTWARE\Classes\Applications\photoviewer.dll\shell\print\DropTarget" /v "Clsid" /t REG_SZ /d "{60fd46de-f830-4894-a628-6fa81bc0190d}" /f >nul
	    	Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Bitmap" /v "FriendlyTypeName" /t REG_EXPAND_SZ /d "@%%ProgramFiles%%\Windows Photo Viewer\PhotoViewer.dll,-3056" /f >nul
	    	Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Bitmap" /v "ImageOptionFlags" /t REG_DWORD /d "1" /f >nul
	    	Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Bitmap\DefaultIcon" /ve /t REG_SZ /d "%%SystemRoot%%\System32\imageres.dll,-70" /f >nul
	    	Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Bitmap\shell\open\command" /ve /t REG_EXPAND_SZ /d "%%SystemRoot%%\System32\rundll32.exe \"%%ProgramFiles%%\Windows Photo Viewer\PhotoViewer.dll\", ImageView_Fullscreen %%1" /f >nul
	    	Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Bitmap\shell\open\DropTarget" /v "Clsid" /t REG_SZ /d "{FFE2A43C-56B9-4bf5-9A79-CC6D4285608A}" /f >nul
	    	Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Gif" /v "FriendlyTypeName" /t REG_EXPAND_SZ /d "@%%ProgramFiles%%\Windows Photo Viewer\PhotoViewer.dll,-3057" /f >nul
	    	Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Gif" /v "ImageOptionFlags" /t REG_DWORD /d "1" /f >nul
	    	Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Gif\DefaultIcon" /ve /t REG_SZ /d "%%SystemRoot%%\System32\imageres.dll,-83" /f >nul
	    	Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Gif\shell\open\command" /ve /t REG_EXPAND_SZ /d "%%SystemRoot%%\System32\rundll32.exe \"%%ProgramFiles%%\Windows Photo Viewer\PhotoViewer.dll\", ImageView_Fullscreen %%1" /f >nul
	    	Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Gif\shell\open\DropTarget" /v "Clsid" /t REG_SZ /d "{FFE2A43C-56B9-4bf5-9A79-CC6D4285608A}" /f >nul
	    	Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.JFIF" /v "EditFlags" /t REG_DWORD /d "65536" /f >nul
	    	Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.JFIF" /v "FriendlyTypeName" /t REG_EXPAND_SZ /d "@%%ProgramFiles%%\Windows Photo Viewer\PhotoViewer.dll,-3055" /f >nul
	    	Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.JFIF" /v "ImageOptionFlags" /t REG_DWORD /d "1" /f >nul
	    	Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.JFIF\DefaultIcon" /ve /t REG_SZ /d "%%SystemRoot%%\System32\imageres.dll,-72" /f >nul
	    	Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.JFIF\shell\open" /v "MuiVerb" /t REG_EXPAND_SZ /d "@%%ProgramFiles%%\Windows Photo Viewer\photoviewer.dll,-3043" /f >nul
	    	Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.JFIF\shell\open\command" /ve /t REG_EXPAND_SZ /d "%%SystemRoot%%\System32\rundll32.exe \"%%ProgramFiles%%\Windows Photo Viewer\PhotoViewer.dll\", ImageView_Fullscreen %%1" /f >nul
	    	Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.JFIF\shell\open\DropTarget" /v "Clsid" /t REG_SZ /d "{FFE2A43C-56B9-4bf5-9A79-CC6D4285608A}" /f >nul
	    	Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Jpeg" /v "EditFlags" /t REG_DWORD /d "65536" /f >nul
	    	Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Jpeg" /v "FriendlyTypeName" /t REG_EXPAND_SZ /d "@%%ProgramFiles%%\Windows Photo Viewer\PhotoViewer.dll,-3055" /f >nul
	    	Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Jpeg" /v "ImageOptionFlags" /t REG_DWORD /d "1" /f >nul
	    	Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Jpeg\DefaultIcon" /ve /t REG_SZ /d "%%SystemRoot%%\System32\imageres.dll,-72" /f >nul
	    	Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Jpeg\shell\open" /v "MuiVerb" /t REG_EXPAND_SZ /d "@%%ProgramFiles%%\Windows Photo Viewer\photoviewer.dll,-3043" /f >nul
	    	Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Jpeg\shell\open\command" /ve /t REG_EXPAND_SZ /d "%%SystemRoot%%\System32\rundll32.exe \"%%ProgramFiles%%\Windows Photo Viewer\PhotoViewer.dll\", ImageView_Fullscreen %%1" /f >nul
	    	Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Jpeg\shell\open\DropTarget" /v "Clsid" /t REG_SZ /d "{FFE2A43C-56B9-4bf5-9A79-CC6D4285608A}" /f >nul
	    	Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Png" /v "FriendlyTypeName" /t REG_EXPAND_SZ /d "@%%ProgramFiles%%\Windows Photo Viewer\PhotoViewer.dll,-3057" /f >nul
	    	Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Png" /v "ImageOptionFlags" /t REG_DWORD /d "1" /f >nul
	    	Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Png\DefaultIcon" /ve /t REG_SZ /d "%%SystemRoot%%\System32\imageres.dll,-71" /f >nul
	    	Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Png\shell\open\command" /ve /t REG_EXPAND_SZ /d "%%SystemRoot%%\System32\rundll32.exe \"%%ProgramFiles%%\Windows Photo Viewer\PhotoViewer.dll\", ImageView_Fullscreen %%1" /f >nul
	    	Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Png\shell\open\DropTarget" /v "Clsid" /t REG_SZ /d "{FFE2A43C-56B9-4bf5-9A79-CC6D4285608A}" /f >nul
	    	Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Tiff" /v "FriendlyTypeName" /t REG_EXPAND_SZ /d "@%%ProgramFiles%%\Windows Photo Viewer\PhotoViewer.dll,-3058" /f >nul
	    	Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Tiff" /v "ImageOptionFlags" /t REG_DWORD /d "1" /f >nul
	    	Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Tiff\DefaultIcon" /ve /t REG_SZ /d "%%SystemRoot%%\System32\imageres.dll,-122" /f >nul
	    	Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Tiff\shell\open" /v "MuiVerb" /t REG_EXPAND_SZ /d "@%%ProgramFiles%%\Windows Photo Viewer\photoviewer.dll,-3043" /f >nul
	    	Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Tiff\shell\open\command" /ve /t REG_EXPAND_SZ /d "%%SystemRoot%%\System32\rundll32.exe \"%%ProgramFiles%%\Windows Photo Viewer\PhotoViewer.dll\", ImageView_Fullscreen %%1" /f >nul
	    	Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Tiff\shell\open\DropTarget" /v "Clsid" /t REG_SZ /d "{FFE2A43C-56B9-4bf5-9A79-CC6D4285608A}" /f >nul
	    	Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Wdp" /v "EditFlags" /t REG_DWORD /d "65536" /f >nul
	    	Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Wdp" /v "ImageOptionFlags" /t REG_DWORD /d "1" /f >nul
	    	Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Wdp\DefaultIcon" /ve /t REG_SZ /d "%%SystemRoot%%\System32\wmphoto.dll,-400" /f >nul
	    	Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Wdp\shell\open" /v "MuiVerb" /t REG_EXPAND_SZ /d "@%%ProgramFiles%%\Windows Photo Viewer\photoviewer.dll,-3043" /f >nul
	    	Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Wdp\shell\open\command" /ve /t REG_EXPAND_SZ /d "%%SystemRoot%%\System32\rundll32.exe \"%%ProgramFiles%%\Windows Photo Viewer\PhotoViewer.dll\", ImageView_Fullscreen %%1" /f >nul
	    	Reg add "HKLM\TK_SOFTWARE\Classes\PhotoViewer.FileAssoc.Wdp\shell\open\DropTarget" /v "Clsid" /t REG_SZ /d "{FFE2A43C-56B9-4bf5-9A79-CC6D4285608A}" /f >nul
	    	Reg add "HKLM\TK_SOFTWARE\Microsoft\Windows Photo Viewer\Capabilities" /v "ApplicationDescription" /t REG_SZ /d "@%%ProgramFiles%%\Windows Photo Viewer\photoviewer.dll,-3069" /f >nul
	    	Reg add "HKLM\TK_SOFTWARE\Microsoft\Windows Photo Viewer\Capabilities" /v "ApplicationName" /t REG_SZ /d "@%%ProgramFiles%%\Windows Photo Viewer\photoviewer.dll,-3009" /f >nul
	    	Reg add "HKLM\TK_SOFTWARE\Microsoft\Windows Photo Viewer\Capabilities\FileAssociations" /v ".bmp" /t REG_SZ /d "PhotoViewer.FileAssoc.Bitmap" /f >nul
	    	Reg add "HKLM\TK_SOFTWARE\Microsoft\Windows Photo Viewer\Capabilities\FileAssociations" /v ".dib" /t REG_SZ /d "PhotoViewer.FileAssoc.Bitmap" /f >nul
	    	Reg add "HKLM\TK_SOFTWARE\Microsoft\Windows Photo Viewer\Capabilities\FileAssociations" /v ".gif" /t REG_SZ /d "PhotoViewer.FileAssoc.Gif" /f >nul
	    	Reg add "HKLM\TK_SOFTWARE\Microsoft\Windows Photo Viewer\Capabilities\FileAssociations" /v ".jfif" /t REG_SZ /d "PhotoViewer.FileAssoc.JFIF" /f >nul
	    	Reg add "HKLM\TK_SOFTWARE\Microsoft\Windows Photo Viewer\Capabilities\FileAssociations" /v ".jpe" /t REG_SZ /d "PhotoViewer.FileAssoc.Jpeg" /f >nul
	    	Reg add "HKLM\TK_SOFTWARE\Microsoft\Windows Photo Viewer\Capabilities\FileAssociations" /v ".jpeg" /t REG_SZ /d "PhotoViewer.FileAssoc.Jpeg" /f >nul
	    	Reg add "HKLM\TK_SOFTWARE\Microsoft\Windows Photo Viewer\Capabilities\FileAssociations" /v ".jpg" /t REG_SZ /d "PhotoViewer.FileAssoc.Jpeg" /f >nul
	    	Reg add "HKLM\TK_SOFTWARE\Microsoft\Windows Photo Viewer\Capabilities\FileAssociations" /v ".jxr" /t REG_SZ /d "PhotoViewer.FileAssoc.Wdp" /f >nul
	    	Reg add "HKLM\TK_SOFTWARE\Microsoft\Windows Photo Viewer\Capabilities\FileAssociations" /v ".png" /t REG_SZ /d "PhotoViewer.FileAssoc.Png" /f >nul
	    	Reg add "HKLM\TK_SOFTWARE\Microsoft\Windows Photo Viewer\Capabilities\FileAssociations" /v ".tif" /t REG_SZ /d "PhotoViewer.FileAssoc.Tiff" /f >nul
	    	Reg add "HKLM\TK_SOFTWARE\Microsoft\Windows Photo Viewer\Capabilities\FileAssociations" /v ".tiff" /t REG_SZ /d "PhotoViewer.FileAssoc.Tiff" /f >nul
	    	Reg add "HKLM\TK_SOFTWARE\Microsoft\Windows Photo Viewer\Capabilities\FileAssociations" /v ".wdp" /t REG_SZ /d "PhotoViewer.FileAssoc.Wdp" /f >nul
        )

        if "%Tweak%" equ "EnableFMP3ProCodec" (
	        if "%ImageArchitecture%" equ "x86" (
		    	Reg add "HKLM\TK_SOFTWARE\Microsoft\Windows NT\CurrentVersion\drivers.desc" /v "%%SystemRoot%%\System32\l3codecp.acm" /t REG_SZ /d "Fraunhofer IIS MPEG Layer-3 Codec (Professional)" /f >nul
		    	Reg add "HKLM\TK_SOFTWARE\Microsoft\Windows NT\CurrentVersion\Drivers32" /v "msacm.l3acm" /t REG_EXPAND_SZ /d "%%SystemRoot%%\System32\l3codecp.acm" /f >nul
		    	Reg delete "HKLM\TK_SOFTWARE\Microsoft\Windows NT\CurrentVersion\drivers.desc" /f >nul 2>&1
	        )

	        if "%ImageArchitecture%" equ "x64" (
		    	Reg add "HKLM\TK_SOFTWARE\Microsoft\Windows NT\CurrentVersion\drivers.desc" /v "%%SystemRoot%%\System32\l3codecp.acm" /t REG_SZ /d "Fraunhofer IIS MPEG Layer-3 Codec (Professional)" /f >nul
		    	Reg add "HKLM\TK_SOFTWARE\Microsoft\Windows NT\CurrentVersion\Drivers32" /v "msacm.l3acm" /t REG_EXPAND_SZ /d "%%SystemRoot%%\System32\l3codecp.acm" /f >nul
		    	Reg add "HKLM\TK_SOFTWARE\Wow6432Node\Microsoft\Windows NT\CurrentVersion\drivers.desc" /v "%%SystemRoot%%\SysWOW64\l3codecp.acm" /t REG_SZ /d "Fraunhofer IIS MPEG Layer-3 Codec (Professional)" /f >nul
		    	Reg add "HKLM\TK_SOFTWARE\Wow6432Node\Microsoft\Windows NT\CurrentVersion\Drivers32" /v "msacm.l3acm" /t REG_EXPAND_SZ /d "%%SystemRoot%%\SysWOW64\l3codecp.acm" /f >nul
		    	Reg delete "HKLM\TK_SOFTWARE\Microsoft\Windows NT\CurrentVersion\drivers.desc" /f >nul 2>&1
		    	Reg delete "HKLM\TK_SOFTWARE\Wow6432Node\Microsoft\Windows NT\CurrentVersion\drivers.desc" /f >nul 2>&1
	        )
        )

        if "%Tweak%" equ "EnableFullResetBase" Reg add "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\SideBySide\Configuration" /v "DisableResetbase" /t REG_DWORD /d "0" /f >nul

		echo.Demontage du registre d'images. 
		call :UnMountImageRegistry
	)
)

echo.
echo.-------------------------------------------------------------------------------
echo.####Terminer l'application des ajustements  ###################################
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set Tweaks=

endlocal

:: Returning to Apply Tweaks Menu
goto :ApplyTweaksMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Cleanup Source Images
::-------------------------------------------------------------------------------------------
:CleanupSource

cls
echo.===============================================================================
echo.  MSMG ToolKit - Nettoyer les images sources des composants et du ResetBase 
echo.===============================================================================
echo.
:: Unmount Image Registry if Mounted
call :UnMountImageRegistry
echo.-------------------------------------------------------------------------------
echo.####Demarrage du nettoyage des images sources des composants et du ResetBase ## 
echo.-------------------------------------------------------------------------------
echo.
if "%IsBootImageSelected%" equ "Yes" (
	:: Performing [Boot.wim, Index : 1 and 2] Image Component Cleanup with ResetBase Option
	for /l %%i in (1, 1, 2) do (
		echo.-------------------------------------------------------------------------------
		echo.Nettoyage du composant d'image [Boot.wim, Index : %%i]
		echo.-------------------------------------------------------------------------------
		call :CleanupImage "%BootMount%\%%i", "ComponentCleanupResetBase"
	)
)

for /l %%i in (1, 1, %ImageCount%) do (
	if exist "%InstallMount%\%%i" (
		:: Performing [Install.wim] Image Component Clean-Up with ResetBase Option
		echo.-------------------------------------------------------------------------------
		echo.Nettoyage du composant d'image [Install.wim, Index : %%i]
		echo.-------------------------------------------------------------------------------
		if exist "%InstallMount%\%%i\Windows\WinSxS\pending.xml" (
			echo.
			echo.Impossible d'effectuer le nettoyage du composant lorsque Pending.xml est present
			echo.
		) else (
			call :CleanupImage "%InstallMount%\%%i", "ComponentCleanupResetBase"
		)

		if "%IsRecoveryImageSelected%" equ "Yes" (
			:: Performing [WinRE.wim] Image Component Cleanup with ResetBase Option
			echo.-------------------------------------------------------------------------------
			echo.Execution de [Install.wim, Index: %%i-^>WinRE.wim] Nettoyage du composant d'image
			echo.-------------------------------------------------------------------------------
			call :CleanupImage "%WinReMount%\%%i", "ComponentCleanupResetBase"
		)
	)
)

echo.-------------------------------------------------------------------------------
echo.####Nettoyage des images source termine des composants et du ResetBase ########
echo.-------------------------------------------------------------------------------
echo.

:Stop
echo.===============================================================================
echo.
pause

:: Returning to Apply Menu
goto :ApplyMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Apply, Save and Optimize Changes to the Source Images
::-------------------------------------------------------------------------------------------
:SaveSource

setlocal

set "TrimEditions=No"

cls
echo.===============================================================================
echo.  MSMG ToolKit - Appliquer et enregistrer les modifications aux images source 
echo.===============================================================================
echo.
:: Unmount Image Registry if Mounted
call :UnMountImageRegistry
echo.-------------------------------------------------------------------------------
echo.####Demarrage de l'application et de l'enregistrement des modifications 
echo.aux images source #############################################################
echo.-------------------------------------------------------------------------------
echo.
if /i "%ImageIndexNo%" neq "A" if %ImageCount% neq 1 (
	choice /C:NY /N /M "Voulez-vous reduire les editions d'image non sélectionnees ? ['Y'es/'N'o] : "
	if errorlevel 2 set "TrimEditions=Yes"
	echo.
)

choice /C:YN /N /M "Voulez-vous nettoyer le dossier Image ? ['Y'es/'N'o] : "
echo.
if %errorlevel% equ 1 (
	echo.-------------------------------------------------------------------------------
	echo.Nettoyage du dossier Image
	echo.-------------------------------------------------------------------------------
	echo.
	echo.Nettoyage des fichiers ou dossiers temporaires et journaux d'image.
	:: Performing [Boot.wim, Index : 1 and 2] Image Windows folder cleanup
	if "%IsBootImageSelected%" equ "Yes" (
		for /l %%i in (1, 1, 2) do (
			if exist "%BootMount%\%%i\Users\Default\*.LOG1" del /f /q "%BootMount%\%%i\Users\Default\*.LOG1" >nul 2>&1
			if exist "%BootMount%\%%i\Users\Default\*.LOG2" del /f /q "%BootMount%\%%i\Users\Default\*.LOG2" >nul 2>&1
			if exist "%BootMount%\%%i\Users\Default\*.TM.blf" del /f /q "%BootMount%\%%i\Users\Default\*.TM.blf" >nul 2>&1
			if exist "%BootMount%\%%i\Users\Default\*.regtrans-ms" del /f /q "%BootMount%\%%i\Users\Default\*.regtrans-ms" >nul 2>&1
			if exist "%BootMount%\%%i\Windows\inf\*.log" del /f /q "%BootMount%\%%i\Windows\inf\*.log" >nul 2>&1

			if exist "%BootMount%\%%i\Windows\CbsTemp\*" (
				for /f %%i in ('"dir /s /b /ad "%BootMount%\%%i\Windows\CbsTemp\*"" 2^>nul') do (rd /q /s %%i >nul 2>&1)
				del /s /f /q "%BootMount%\%%i\Windows\CbsTemp\*" >nul 2>&1
			)

			if exist "%BootMount%\%%i\Windows\System32\config\*.LOG1" del /f /q "%BootMount%\%%i\Windows\System32\config\*.LOG1" >nul 2>&1
			if exist "%BootMount%\%%i\Windows\System32\config\*.LOG2" del /f /q "%BootMount%\%%i\Windows\System32\config\*.LOG2" >nul 2>&1
			if exist "%BootMount%\%%i\Windows\System32\config\*.TM.blf" del /f /q "%BootMount%\%%i\Windows\System32\config\*.TM.blf" >nul 2>&1
			if exist "%BootMount%\%%i\Windows\System32\config\*.regtrans-ms" del /f /q "%BootMount%\%%i\Windows\System32\config\*.regtrans-ms" >nul 2>&1
			if exist "%BootMount%\%%i\Windows\System32\SMI\Store\Machine\*.LOG1" del /f /q "%BootMount%\%%i\Windows\System32\SMI\Store\Machine\*.LOG1" >nul 2>&1
			if exist "%BootMount%\%%i\Windows\System32\SMI\Store\Machine\*.LOG2" del /f /q "%BootMount%\%%i\Windows\System32\SMI\Store\Machine\*.LOG2" >nul 2>&1
			if exist "%BootMount%\%%i\Windows\System32\SMI\Store\Machine\*.TM.blf" del /f /q "%BootMount%\%%i\Windows\System32\SMI\Store\Machine\*.TM.blf" >nul 2>&1
			if exist "%BootMount%\%%i\Windows\System32\SMI\Store\Machine\*.regtrans-ms" del /f /q "%BootMount%\%%i\Windows\System32\SMI\Store\Machine\*.regtrans-ms" >nul 2>&1
			if exist "%BootMount%\%%i\Windows\WinSxS\Backup\*.*" del /f /q "%BootMount%\Windows\WinSxS\Backup\*.*" >nul 2>&1
			if exist "%BootMount%\%%i\Windows\WinSxS\ManifestCache\*.bin" del /f /q "%BootMount%\%%i\Windows\WinSxS\ManifestCache\*.bin" >nul 2>&1
			if exist "%BootMount%\%%i\Windows\WinSxS\Temp\PendingDeletes\*" del /f /q "%BootMount%\%%i\Windows\WinSxS\Temp\PendingDeletes\*" >nul 2>&1
			if exist "%BootMount%\%%i\Windows\WinSxS\Temp\TransformerRollbackData\*" del /s /f /q "%BootMount%\%%i\Windows\WinSxS\Temp\TransformerRollbackData\*" >nul 2>&1
		)
	)

	for /l %%i in (1, 1, %ImageCount%) do (
		:: Performing [Install.wim] Image Windows folder cleanup
		if exist "%InstallMount%\%%i" (
			if exist "%InstallMount%\%%i\$Recycle.Bin" rd /q /s "%InstallMount%\%%i\$Recycle.Bin" >nul 2>&1
			if exist "%InstallMount%\%%i\PerfLogs" rd /q /s "%InstallMount%\%%i\PerfLogs" >nul 2>&1
			if exist "%InstallMount%\%%i\Users\Default\*.LOG1" del /f /q "%InstallMount%\%%i\Users\Default\*.LOG1" >nul 2>&1
			if exist "%InstallMount%\%%i\Users\Default\*.LOG2" del /f /q "%InstallMount%\%%i\Users\Default\*.LOG2" >nul 2>&1
			if exist "%InstallMount%\%%i\Users\Default\*.TM.blf" del /f /q "%InstallMount%\%%i\Users\Default\*.TM.blf" >nul 2>&1
			if exist "%InstallMount%\%%i\Users\Default\*.regtrans-ms" del /f /q "%InstallMount%\%%i\Users\Default\*.regtrans-ms" >nul 2>&1
			if exist "%InstallMount%\%%i\Windows\inf\*.log" del /f /q "%InstallMount%\%%i\Windows\inf\*.log" >nul 2>&1

			if exist "%InstallMount%\%%i\Windows\CbsTemp\*" (
				for /f %%i in ('"dir /s /b /ad "%InstallMount%\%%i\Windows\CbsTemp\*"" 2^>nul') do (rd /q /s %%i >nul 2>&1)
				del /s /f /q "%InstallMount%\%%i\Windows\CbsTemp\*" >nul 2>&1
			)

			if exist "%InstallMount%\%%i\Windows\System32\config\*.LOG1" del /f /q "%InstallMount%\%%i\Windows\System32\config\*.LOG1" >nul 2>&1
			if exist "%InstallMount%\%%i\Windows\System32\config\*.LOG2" del /f /q "%InstallMount%\%%i\Windows\System32\config\*.LOG2" >nul 2>&1
			if exist "%InstallMount%\%%i\Windows\System32\config\*.TM.blf" del /f /q "%InstallMount%\%%i\Windows\System32\config\*.TM.blf" >nul 2>&1
			if exist "%InstallMount%\%%i\Windows\System32\config\*.regtrans-ms" del /f /q "%InstallMount%\%%i\Windows\System32\config\*.regtrans-ms" >nul 2>&1
			if exist "%InstallMount%\%%i\Windows\System32\SMI\Store\Machine\*.LOG1" del /f /q "%InstallMount%\%%i\Windows\System32\SMI\Store\Machine\*.LOG1" >nul 2>&1
			if exist "%InstallMount%\%%i\Windows\System32\SMI\Store\Machine\*.LOG2" del /f /q "%InstallMount%\%%i\Windows\System32\SMI\Store\Machine\*.LOG2" >nul 2>&1
			if exist "%InstallMount%\%%i\Windows\System32\SMI\Store\Machine\*.TM.blf" del /f /q "%InstallMount%\%%i\Windows\System32\SMI\Store\Machine\*.TM.blf" >nul 2>&1
			if exist "%InstallMount%\%%i\Windows\System32\SMI\Store\Machine\*.regtrans-ms" del /f /q "%InstallMount%\%%i\Windows\System32\SMI\Store\Machine\*.regtrans-ms" >nul 2>&1
			if exist "%InstallMount%\%%i\Windows\WinSxS\Backup\*.*" del /f /q "%InstallMount%\%%i\Windows\WinSxS\Backup\*.*" >nul 2>&1
			if exist "%InstallMount%\%%i\Windows\WinSxS\ManifestCache\*.bin" del /f /q "%InstallMount%\%%i\Windows\WinSxS\ManifestCache\*.bin" >nul 2>&1
			if exist "%InstallMount%\%%i\Windows\WinSxS\Temp\PendingDeletes\*" del /f /q "%InstallMount%\%%i\Windows\WinSxS\Temp\PendingDeletes\*" >nul 2>&1
			if exist "%InstallMount%\%%i\Windows\WinSxS\Temp\TransformerRollbackData\*" del /f /q "%InstallMount%\%%i\Windows\WinSxS\Temp\TransformerRollbackData\*" >nul 2>&1

			:: Performing [WinRE.wim, Index : 1] Image Windows folder cleanup
			if "%IsRecoveryImageSelected%" equ "Yes" (
				if exist "%WinReMount%\%%i\Users\Default\*.LOG1" del /f /q "%WinReMount%\%%i\Users\Default\*.LOG1" >nul 2>&1
				if exist "%WinReMount%\%%i\Users\Default\*.LOG2" del /f /q "%WinReMount%\%%i\Users\Default\*.LOG2" >nul 2>&1
				if exist "%WinReMount%\%%i\Users\Default\*.TM.blf" del /f /q "%WinReMount%\%%i\Users\Default\*.TM.blf" >nul 2>&1
				if exist "%WinReMount%\%%i\Users\Default\*.regtrans-ms" del /f /q "%WinReMount%\%%i\Users\Default\*.regtrans-ms" >nul 2>&1
				if exist "%WinReMount%\%%i\Windows\inf\*.log" del /f /q "%WinReMount%\%%i\Windows\inf\*.log" >nul 2>&1

				if exist "%WinReMount%\%%i\Windows\CbsTemp\*" (
					for /f %%j in ('"dir /s /b /ad "%WinReMount%\%%i\Windows\CbsTemp\*"" 2^>nul') do (rd /q /s %%j >nul 2>&1)
					del /s /f /q "%WinReMount%\%%i\Windows\CbsTemp\*" >nul 2>&1
				)

				if exist "%WinReMount%\%%i\Windows\System32\config\*.LOG1" del /f /q "%WinReMount%\%%i\Windows\System32\config\*.LOG1" >nul 2>&1
				if exist "%WinReMount%\%%i\Windows\System32\config\*.LOG2" del /f /q "%WinReMount%\%%i\Windows\System32\config\*.LOG2" >nul 2>&1
				if exist "%WinReMount%\%%i\Windows\System32\config\*.TM.blf" del /f /q "%WinReMount%\%%i\Windows\System32\config\*.TM.blf" >nul 2>&1
				if exist "%WinReMount%\%%i\Windows\System32\config\*.regtrans-ms" del /f /q "%WinReMount%\%%i\Windows\System32\config\*.regtrans-ms" >nul 2>&1
				if exist "%WinReMount%\%%i\Windows\System32\SMI\Store\Machine\*.LOG1" del /f /q "%WinReMount%\%%i\Windows\System32\SMI\Store\Machine\*.LOG1" >nul 2>&1
				if exist "%WinReMount%\%%i\Windows\System32\SMI\Store\Machine\*.LOG2" del /f /q "%WinReMount%\%%i\Windows\System32\SMI\Store\Machine\*.LOG2" >nul 2>&1
				if exist "%WinReMount%\%%i\Windows\System32\SMI\Store\Machine\*.TM.blf" del /f /q "%WinReMount%\%%i\Windows\System32\SMI\Store\Machine\*.TM.blf" >nul 2>&1
				if exist "%WinReMount%\%%i\Windows\System32\SMI\Store\Machine\*.regtrans-ms" del /f /q "%WinReMount%\%%i\Windows\System32\SMI\Store\Machine\*.regtrans-ms" >nul 2>&1
				if exist "%WinReMount%\%%i\Windows\WinSxS\Backup\*.*" del /f /q "%WinReMount%\%%i\Windows\WinSxS\Backup\*.*" >nul 2>&1
				if exist "%WinReMount%\%%i\Windows\WinSxS\ManifestCache\*.bin" del /f /q "%WinReMount%\%%i\Windows\WinSxS\ManifestCache\*.bin" >nul 2>&1
				if exist "%WinReMount%\%%i\Windows\WinSxS\Temp\PendingDeletes\*" del /f /q "%WinReMount%\%%i\Windows\WinSxS\Temp\PendingDeletes\*" >nul 2>&1
				if exist "%WinReMount%\%%i\Windows\WinSxS\Temp\TransformerRollbackData\*" del /s /f /q "%WinReMount%\%%i\Windows\WinSxS\Temp\TransformerRollbackData\*" >nul 2>&1
			)
		)
	)
	echo.
)

:: Saving & Un-Mounting Source Boot Images
if "%IsBootImageSelected%" equ "Yes" (
	for /l %%i in (1, 1, 2) do (
		echo.-------------------------------------------------------------------------------
		echo.Application des modifications et demontage de l'image [Boot.wim, Index : %%i]. 
		echo.-------------------------------------------------------------------------------
		call :UnMountImage "%BootMount%\%%i", "Commit"
		call :RemoveFolder "%BootMount%\%%i"
	)
)

:: Re-Building Source Boot Image with Maximum Compression.
echo.-------------------------------------------------------------------------------
echo.Optimizing Source [Boot.wim] Image with Maximum Compression...
echo.-------------------------------------------------------------------------------
call :ExportImage "%BootWim%", "%Temp%\rebuild.wim", "WIM", "No"
move /y "%Temp%\rebuild.wim" "%BootWim%" >nul

:: Saving & Un-Mounting Source Install & Recovery Images
for /l %%i in (1, 1, %ImageCount%) do (
   if exist "%InstallMount%\%%i" (
		if "%IsRecoveryImageSelected%" equ "Yes" (
			echo.-------------------------------------------------------------------------------
			echo.Application des modifications et Demontage [Install.wim, Index : %%i-^>
			echo.WinRE.wim] Image 
			echo.-------------------------------------------------------------------------------
			call :UnMountImage "%WinReMount%\%%i", "Commit"
			call :RemoveFolder "%WinReMount%\%%i"

			:: Re-Building Source Recovery Image with Maximum Compression.
			echo.-------------------------------------------------------------------------------
			echo.Optimisation de l'image source [Install.wim, Index : %%i-^>WinRE.wim]. 
			echo.-------------------------------------------------------------------------------
			call :ExportImage "%InstallMount%\%%i\%WinReWim%", "%Temp%\rebuild.wim", "WIM", "No"
			move /y "%Temp%\rebuild.wim" "%InstallMount%\%%i\%WinReWim%" >nul
		)

		echo.-------------------------------------------------------------------------------
		echo.Application des modifications et Demontage [Install.wim, Index : %%i] Image. 
		echo.-------------------------------------------------------------------------------
		call :UnMountImage "%InstallMount%\%%i", "Commit"
		call :RemoveFolder "%InstallMount%\%%i"
	)
)

:: Re-Building Source Install Image with Maximum Compression.
echo.-------------------------------------------------------------------------------
echo.Optimisation de l'image source [Install.wim] avec une compression maximale.
echo.-------------------------------------------------------------------------------

if "%TrimEditions%" equ "Yes" (
	for %%i in (%ImageIndexNo%) do (
		call :ExportImageIndex "%InstallWim%", %%i, "%Temp%\rebuild.wim", "WIM", "No"
	)
)

if "%TrimEditions%" equ "No" (
	call :ExportImage "%InstallWim%", "%Temp%\rebuild.wim", "WIM", "No"
)

move /y "%Temp%\rebuild.wim" "%InstallWim%" >nul
echo.-------------------------------------------------------------------------------
echo.####L'application et l'enregistrement des modifications aux images source 
echo.sont termines #################################################################
echo.-------------------------------------------------------------------------------
echo.

:Stop
echo.===============================================================================
echo.
pause

set TrimEditions=

endlocal

set IsSourceSelected=No
set IsBootImageSelected=No
set IsRecoveryImageSelected=No
set SelectedSourceOS=

goto :MainMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Discard Changes & Unmount Source Images
::-------------------------------------------------------------------------------------------
:DiscardSource

cls
echo.===============================================================================
echo.            MSMG ToolKit - Discard Changes ^& Unmount Source Images
echo.===============================================================================
echo.
:: Unmount Image Registry if Mounted
call :UnMountImageRegistry
echo.-------------------------------------------------------------------------------
echo.####Starting Discarding Changes ^& Un-Mounting Source Images####################
echo.-------------------------------------------------------------------------------
echo.
:: Discarding ^& Un-Mounting Source Boot Images
if "%IsBootImageSelected%" equ "Yes" (
	for /l %%i in (1, 1, 2) do (
		echo.-------------------------------------------------------------------------------
		echo.Un-Mounting [Boot.wim, Index : %%i] Image...
		echo.-------------------------------------------------------------------------------
		call :UnMountImage "%BootMount%\%%i", "Discard"
		call :RemoveFolder "%BootMount%\%%i"
	)
)

:: Discarding ^& Un-Mounting Source Install & Recovery Images
for /l %%i in (1, 1, %ImageCount%) do (
   if exist "%InstallMount%\%%i" (
		if "%IsRecoveryImageSelected%" equ "Yes" (
			echo.-------------------------------------------------------------------------------
			echo.Un-Mounting [Install.wim, Index : %%i -^> WinRE.wim] Image...
			echo.-------------------------------------------------------------------------------
			call :UnMountImage "%WinReMount%\%%i", "Discard"
			call :RemoveFolder "%WinReMount%\%%i"
		)

		echo.-------------------------------------------------------------------------------
		echo.Un-Mounting [Install.wim, Index : %%i] Image...
		echo.-------------------------------------------------------------------------------
		call :UnMountImage "%InstallMount%\%%i", "Discard"
		call :RemoveFolder "%InstallMount%\%%i"
	)
)
echo.-------------------------------------------------------------------------------
echo.####Finished Discarding Changes ^& Un-Mounting Source Images####################
echo.-------------------------------------------------------------------------------
echo.

set IsSourceSelected=No
set IsBootImageSelected=No
set IsRecoveryImageSelected=No
set SelectedSourceOS=

:Stop
echo.===============================================================================
echo.
pause

goto :MainMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Make a DVD ISO Image for Burning to DVD Disc
::-------------------------------------------------------------------------------------------
:MakeISO

setlocal

set "BIOSBoot=%DVD%\boot\etfsboot.com"
set "UEFIBoot=%DVD%\efi\microsoft\boot\efisys.bin"
set ISOLabel=
set ISOFileName=

cls
echo.===============================================================================
echo.                     MSMG ToolKit - Make a DVD ISO Image
echo.===============================================================================
echo.

:: Checking whether Source is Applied
if "%IsSourceSelected%" equ "Yes" (
	echo.Can't use this feature when the Source OS is selected...
	goto :Stop
)

:: Checking whether Windows Source DVD folder is empty
if not exist "%BIOSBoot%" (
	echo.Windows Installation Source folder ^<DVD^> is empty...
	echo.
	echo.Please copy Installation Source files to ^<DVD^> folder...
	goto :Stop
)

:: Checking whether Windows Source DVD folder is empty
if not exist "%BootWim%" (
	echo.Windows Installation Source folder ^<DVD^> is empty...
	echo.
	echo.Please copy Installation Source files to ^<DVD^> folder...
	goto :Stop
)

:: Checking whether Windows Source DVD folder is empty
if not exist "%InstallWim%" if not exist "%InstallEsd%" if not exist "%DVD%\sources\*.swm" (
	echo.Windows Installation Source folder ^<DVD^> is empty...
	echo.
	echo.Please copy Installation Source files to ^<DVD^> folder...
	goto :Stop
)

call :CreateFolder "%ISO%"

echo.-------------------------------------------------------------------------------
echo.####Starting Building a DVD ISO Image##########################################
echo.-------------------------------------------------------------------------------
echo.
echo.-------------------------------------------------------------------------------
echo.####Getting DVD ISO Image Details##############################################
echo.-------------------------------------------------------------------------------
echo.
:: Getting ISO Label Name
set /p ISOLabel=Enter the ISO Volume Label : 
echo.

:: Getting ISO File Name
set /p ISOFileName=Enter the ISO File Name : 
echo.

:: Building a DVD ISO Image for Booting with BIOS/UEFI Systems.
echo.-------------------------------------------------------------------------------
echo.####Building a DVD ISO Image###################################################
echo.-------------------------------------------------------------------------------
if "%ISOLabel%" equ "" (
	if exist "%UEFIBoot%" "%Oscdimg%" -bootdata:2#p0,e,b"%BIOSBoot%"#pEF,e,b"%UEFIBoot%" -o -h -m -u2 -udfver102 "%DVD%" "%ISO%\%ISOFileName%.iso"
	if not exist "%UEFIBoot%" "%Oscdimg%" -bootdata:1#p0,e,b"%BIOSBoot%" -o -h -m -u2 -udfver102 "%DVD%" "%ISO%\%ISOFileName%.iso"
)

if "%ISOLabel%" neq "" (
	if exist "%UEFIBoot%" "%Oscdimg%" -bootdata:2#p0,e,b"%BIOSBoot%"#pEF,e,b"%UEFIBoot%" -o -h -m -u2 -udfver102 -l"%ISOLabel%" "%DVD%" "%ISO%\%ISOFileName%.iso"
	if not exist "%UEFIBoot%" "%Oscdimg%" -bootdata:1#p0,e,b"%BIOSBoot%" -o -h -m -u2 -udfver102 -l"%ISOLabel%" "%DVD%" "%ISO%\%ISOFileName%.iso"
)
echo.
echo.-------------------------------------------------------------------------------
echo.####Finished Building a DVD ISO Image##########################################
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set BIOSBoot=
set UEFIBoot=
set ISOLabel=
set ISOFileName=

endlocal

:: Returning to Main Menu
goto :MainMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Burn a DVD ISO Image to DVD Disc
::-------------------------------------------------------------------------------------------
:BurnISO

setlocal

set DvdDrive=
set ISOFileName=

cls
echo.===============================================================================
echo.             MSMG ToolKit - Burn a DVD ISO Image to a DVD Disc
echo.===============================================================================
echo.

:: Checking whether ISO folder is empty
if not exist "%ISO%\*.iso" (
	echo.ISO Image folder ^<ISO^> is empty...
	echo.
	echo.Please copy ISO Images to ^<ISO^> folder...
	goto :Stop
)

echo.-------------------------------------------------------------------------------
echo.####Starting Burning a DVD ISO Image to a DVD Disc#############################
echo.-------------------------------------------------------------------------------
echo.
echo.-------------------------------------------------------------------------------
echo.####Getting DVD Drive ^& DVD ISO Image Details##################################
echo.-------------------------------------------------------------------------------
echo.
:: Getting ISO File Name
set /p ISOFileName=Enter the ISO File Name : 
echo.
:: Getting DVD Drive Letter
set /p DvdDrive=Enter the DVD Drive Letter : 
echo.
echo.-------------------------------------------------------------------------------
echo.####Burning a DVD ISO Image to DVD Disc########################################
echo.-------------------------------------------------------------------------------
echo.
echo.Burning ISO Image file [%ISOFileName%.iso] to DVD Drive [%DvdDrive%:]...
echo.
%DvdBurn% "%DvdDrive%:" "%ISO%\%ISOFileName%.iso"
echo.
echo.-------------------------------------------------------------------------------
echo.####Finished Burning a DVD ISO Image to a DVD Disc#############################
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set DvdDrive=
set ISOFileName=

endlocal

:: Returning to Main Menu
goto :MainMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Copy Source Folder to USB Flash Drive
::-------------------------------------------------------------------------------------------
:CopyUSB

setlocal

set USBDriveLetter=
set USBDriveLabel=

cls
echo.===============================================================================
echo.             MSMG ToolKit - Copy Source Folder to USB Flash Drive
echo.===============================================================================
echo.

:: Checking whether Source is Applied
if "%IsSourceSelected%" equ "Yes" (
	echo.Can't use this feature when the Source OS is selected...
	goto :Stop
)

:: Checking whether Windows Source DVD folder is empty
if not exist "%BootWim%" (
	echo.Windows Installation Source folder ^<DVD^> is empty...
	echo.
	echo.Please copy Installation Source files to ^<DVD^> folder...
	goto :Stop
)

:: Checking whether Windows Source DVD folder is empty
if not exist "%InstallWim%" if not exist "%InstallEsd%" (
	echo.Windows Installation Source folder ^<DVD^> is empty...
	echo.
	echo.Please copy Installation Source files to ^<DVD^> folder...
	goto :Stop
)

echo.-------------------------------------------------------------------------------
echo.####Starting Copying Source Folder to USB Flash Drive##########################
echo.-------------------------------------------------------------------------------
echo.
echo.-------------------------------------------------------------------------------
echo.####Getting USB Flash Drive Options############################################
echo.-------------------------------------------------------------------------------
echo.
:: Show Available USB Flash Drivers.
echo.Listing Available USB Flash Drives...
call :ListDisks

:: Getting USB Flash Drive Letter
set /p USBDriveLetter=Enter USB Flash Drive Letter : 

:: Setting USB Flash Drive Letter
set "USBDriveLetter=%USBDriveLetter%:"
echo.
echo.-------------------------------------------------------------------------------
echo.####Copying Source Folder to USB Flash Drive###################################
echo.-------------------------------------------------------------------------------
echo.
echo.-------------------------------------------------------------------------------
echo.Copying Source files and folders, Please Wait...
echo.-------------------------------------------------------------------------------
echo.
echo.Source Drive : "%DVD%"
echo.Target Drive : %USBDriveLetter%
echo.
%XCopy% "%DVD%" %USBDriveLetter% >nul
echo.-------------------------------------------------------------------------------
echo.####Finished Copying Source Folder to USB Flash Drive##########################
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set USBDriveLetter=
set USBDriveLabel=

endlocal

:: Returning to Main Menu
goto :MainMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Sync Source Boot and Install Images to USB Flash Drive
::-------------------------------------------------------------------------------------------
:SyncUSB

setlocal

set USBDriveLetter=
set USBDriveLabel=

cls
echo.===============================================================================
echo.     MSMG ToolKit - Sync Source Boot ^& Install Images to USB Flash Drive
echo.===============================================================================
echo.

:: Checking whether Source is Applied
if "%IsSourceSelected%" equ "Yes" (
	echo.Can't use this feature when the Source OS is selected...
	goto :Stop
)

:: Checking whether Windows Source DVD folder is empty
if not exist "%BootWim%" (
	echo.Windows Installation Source folder ^<DVD^> is empty...
	echo.
	echo.Please copy Installation Source files to ^<DVD^> folder...
	goto :Stop
)

:: Checking whether Windows Source DVD folder is empty
if not exist "%InstallWim%" if not exist "%InstallEsd%" (
	echo.Windows Installation Source folder ^<DVD^> is empty...
	echo.
	echo.Please copy Installation Source files to ^<DVD^> folder...
	goto :Stop
)

echo.-------------------------------------------------------------------------------
echo.####Starting Syncing Source Boot ^& Install Images to USB Flash Drive###########
echo.-------------------------------------------------------------------------------
echo.
echo.-------------------------------------------------------------------------------
echo.####Getting USB Flash Drive Options############################################
echo.-------------------------------------------------------------------------------
echo.
:: Show Available USB Flash Drivers.
echo.Listing Available USB Flash Drives...
call :ListDisks

:: Getting USB Flash Drive Letter
set /p USBDriveLetter=Enter USB Flash Drive Letter : 

:: Setting USB Flash Drive Letter
set "USBDriveLetter=%USBDriveLetter%:"
echo.
echo.-------------------------------------------------------------------------------
echo.####Syncing Source Boot ^& Install Images to USB Flash Drive####################
echo.-------------------------------------------------------------------------------
echo.
echo.-------------------------------------------------------------------------------
echo.Copying Source Boot ^& Install Image files, Please Wait...
echo.-------------------------------------------------------------------------------
echo.
echo.Source : ^<\DVD\Sources\Boot.wim^>
if exist "%DVD%\Sources\install.wim" echo.         ^<\DVD\Sources\Install.wim^>
if exist "%DVD%\Sources\install.esd" echo.         ^<\DVD\Sources\Install.esd^>
echo.Target : ^<%USBDriveLetter%\Sources^>
echo.
call :RemoveFile %USBDriveLetter%\Sources\Boot.wim
call :RemoveFile %USBDriveLetter%\Sources\Install.wim
call :RemoveFile %USBDriveLetter%\Sources\Install.esd

%XCopy% "%DVD%\Sources\boot.wim" %USBDriveLetter%\Sources
if exist "%DVD%\Sources\install.wim" %XCopy% "%DVD%\Sources\install.wim" %USBDriveLetter%\Sources
if exist "%DVD%\Sources\install.esd" %XCopy% "%DVD%\Sources\install.esd" %USBDriveLetter%\Sources
echo.
echo.-------------------------------------------------------------------------------
echo.####Finished Syncing Source Boot ^& Install Images to USB Flash Drive###########
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set USBDriveLetter=
set USBDriveLabel=

endlocal

:: Returning to Main Menu
goto :MainMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Burn a ISO Image to USB Flash Drive
::-------------------------------------------------------------------------------------------
:BurnUSB

setlocal

set ISOFileName=
set USBDriveLetter=

cls
echo.===============================================================================
echo.                MSMG ToolKit - Burn a ISO Image to USB Flash Drive
echo.===============================================================================
echo.

:: Checking whether ISO folder is empty
if not exist "%ISO%\*.iso" (
	echo.ISO Image folder ^<ISO^> is empty...
	echo.
	echo.Please copy ISO Images to ^<ISO^> folder...
	goto :Stop
)

echo.-------------------------------------------------------------------------------
echo.####Starting Burning a ISO Image to USB Flash Drive############################
echo.-------------------------------------------------------------------------------
echo.
echo.-------------------------------------------------------------------------------
echo.####Getting ISO Image Options##################################################
echo.-------------------------------------------------------------------------------
echo.
:: Getting ISO File Name
set /p ISOFileName=Enter the ISO File Name : 

:: Setting ISO File Name
set "ISOFileName=%ISOFileName%.iso"
echo.
echo.-------------------------------------------------------------------------------
echo.####Getting USB Flash Drive Options############################################
echo.-------------------------------------------------------------------------------
echo.
:: Show Available USB Flash Drivers.
echo.Listing Available USB Flash Drives...
call :ListDisks

:: Getting USB Flash Drive Letter
set /p USBDriveLetter=Enter USB Flash Drive Letter : 

:: Setting USB Flash Drive Letter
set "USBDriveLetter=%USBDriveLetter%:"

echo.
echo.-------------------------------------------------------------------------------
echo.####Burning ISO Image to USB Flash Drive#######################################
echo.-------------------------------------------------------------------------------
echo.
echo.-------------------------------------------------------------------------------
echo.Copying ISO Image file Contents to USB Flash Drive, Please Wait...
echo.-------------------------------------------------------------------------------
echo.
echo.Source ISO        : %ISOFileName%
echo.Target Drive      : %USBDriveLetter%
echo.
%Zip% x -y "%ISO%\%ISOFileName%" -o"%USBDriveLetter%"
echo.
echo.-------------------------------------------------------------------------------
echo.####Finished Burning a ISO Image to USB Flash Drive############################
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set ISOFileName=
set USBDriveLetter=

endlocal

:: Returning to Main Menu
goto :MainMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Format a USB Flash Drive
::-------------------------------------------------------------------------------------------
:FormatUSB

setlocal

set USBDriveLetter=
set USBDriveLabel=

cls
echo.===============================================================================
echo.                     MSMG ToolKit - Formater la cle USB 
echo.===============================================================================
echo.
echo.-------------------------------------------------------------------------------
echo.####Demarrage du formatage du lecteur flash USB ###############################
echo.-------------------------------------------------------------------------------
echo.
echo.-------------------------------------------------------------------------------
echo.####Obtention des options de lecteur flash USB ################################
echo.-------------------------------------------------------------------------------
echo.
:: Show Available USB Flash Drivers.
echo.Liste des lecteurs flash USB disponibles ... 
call :ListDisks

:: Getting USB Flash Drive Letter
set /p USBDriveLetter=Entrer la lettre du lecteur flash USB :
echo.

:: Setting USB Flash Drive Letter
set "USBDriveLetter=%USBDriveLetter%:"

:: Checking whether the Specified USB Flash Drive exist
cd /d %USBDriveLetter% 2>nul
if errorlevel 1 (
	echo.Cle USB non valide specifiee, veuillez reessayer... 
	goto :Stop
)

:: Getting USB Flash Drive Volume Label.
set /p USBDriveLabel=Entrer l'etiquette de volume du lecteur flash USB : 
echo.

:: Getting USB Boot Type (UEFI/BIOS/ALL).
choice /C:12 /N /M "Enter USB Flash Drive Boot Type [1=BIOS,2=BIOS/UEFI] : "
if errorlevel 2 goto :BIOS_UEFI
if errorlevel 1 goto :BIOS

:: Formatting USB Flash Drive in NTFS Format for BIOS Booting Systems.
:BIOS
	echo.
	choice /C:YN /N /M "Etes-vous sur de vouloir formater [%USBDriveLetter%]? ['Y'es/'N'o] : "
	if errorlevel 2 (
		echo.
		echo.Formatage du lecteur flash USB [%USBDriveLetter%] annule...
		echo.
		echo.-------------------------------------------------------------------------------
		echo.####Arret du formatage du lecteur flash USB ##############################
		echo.-------------------------------------------------------------------------------
		goto :Stop
	)
	if errorlevel 1 (
		call :FormatDisk %USBDriveLetter%, NTFS, %USBDriveLabel%
		echo.
		echo.-------------------------------------------------------------------------------
		echo.####Fin du formatage de la cle USB #######################################
		echo.-------------------------------------------------------------------------------
		goto :Stop
	)

:: Formatting USB Flash Drive in FAT32 Format for BIOS and or UEFI Booting Systems.
:BIOS_UEFI
	echo.
	choice /C:YN /N /M "Etes-vous sur de vouloir formater [%USBDriveLetter%]? ['Y'es/'N'o] : "
	if errorlevel 2 (
		echo.
		echo.Formatage de la cle USB Flash [%USBDriveLetter%] annule. 
		echo.
		echo.-------------------------------------------------------------------------------
		echo.####Arret du formatage du lecteur flash USB###############################
		echo.-------------------------------------------------------------------------------
		goto :Stop
	)
	if errorlevel 1 (
		call :FormatDisk %USBDriveLetter%, FAT32, %USBDriveLabel%
		echo.
		echo.-------------------------------------------------------------------------------
		echo.####Fin du formatage de la cle USB #######################################
		echo.-------------------------------------------------------------------------------
		goto :Stop
	)

:Stop
echo.
echo.===============================================================================
echo.
pause

set USBDriveLetter=
set USBDriveLabel=

endlocal

:: Returning to Main Menu
goto :MainMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to List All the Disks and Volumes
::-------------------------------------------------------------------------------------------
:ListDisks

call :RemoveFile "%Temp%\DiskList.txt"
call :RemoveFile "%Temp%\DiskList1.txt"

echo.list volume>> "%Temp%\DiskList.txt"
diskpart /s "%Temp%\DiskList.txt" >> "%Temp%\DiskList1.txt"
call :RemoveFile "%Temp%\DiskList.txt"
echo.>> "%Temp%\DiskList.txt"

echo.===============================================================================>> "%Temp%\DiskList.txt"
if "%HostLanguage%" equ "en-US" echo.  Volume #  Letter Label      file Sys Type         Size    Status     Info>> "%Temp%\DiskList.txt"
if "%HostLanguage%" equ "fr-FR" echo.  N# volume   Ltr  Nom          Fs     Type        Taille   Statut     Info>> "%Temp%\DiskList.txt"
echo.------------------------------------------------------------------------------->> "%Temp%\DiskList.txt"
if "%HostLanguage%" equ "en-US" findstr "Removable" "%Temp%\DiskList1.txt" >> "%Temp%\DiskList.txt"
if "%HostLanguage%" equ "fr-FR" findstr "Amovible" "%Temp%\DiskList1.txt" >> "%Temp%\DiskList.txt"
echo.===============================================================================>> "%Temp%\DiskList.txt"

type "%Temp%\DiskList.txt"
call :RemoveFile "%Temp%\DiskList.txt"
call :RemoveFile "%Temp%\DiskList1.txt"
echo.

goto :eof
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Format a Disk/Volume
:: Input Parameters [ %~1 : USB Drive Letter, %~2 : Format Type, %~3 : Drive Label]
::-------------------------------------------------------------------------------------------
:FormatDisk

:: Writing DiskPart.txt Script File.
call :RemoveFile "%Temp%\DiskPart.txt"
echo.select volume ^%~1>> "%Temp%\DiskPart.txt"
echo.clean>> "%Temp%\DiskPart.txt"
echo.create partition primary>> "%Temp%\DiskPart.txt"
echo.select partition ^1>> "%Temp%\DiskPart.txt"
echo.active>> "%Temp%\DiskPart.txt"
echo.format fs=%~2 quick label=%~3>> "%Temp%\DiskPart.txt"
echo.exit>> "%Temp%\DiskPart.txt"
echo.exit>> "%Temp%\DiskPart.txt"
echo.
echo.-------------------------------------------------------------------------------
echo.####Formatting USB Flash Drive#################################################
echo.-------------------------------------------------------------------------------
echo.
:: Executing DiskPart.txt Script file With Diskpart.
echo.Formatting USB Flash Drive [%~1] in %~2 Format, Please wait...
start /B /wait diskpart /s "%Temp%\DiskPart.txt" >nul
echo.
echo.Formatting USB Flash Drive [%~1] in %~2 Format, complete...
call :RemoveFile "%Temp%\DiskPart.txt"

goto :eof
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: MSMG ToolKit - WIM Manager
::-------------------------------------------------------------------------------------------
:WIMManager

cls
echo.===============================================================================
echo.                          MSMG ToolKit - WIM Manager
echo.===============================================================================
echo.

:: Checking whether Source is Applied.
if "%IsSourceSelected%" equ "Yes" (
	echo.Impossible d'utiliser cette fonction lorsque le système d'exploitation 
	echo.source est sélectionné. 
	echo.
	echo.===============================================================================
	echo.
	pause
	goto :ToolsMenu
)

echo.  [A]   Afficher
echo.  [B]   Renommer
echo.  [C]   Effacer
echo.  [D]   Exporter
echo.  [E]   Convertir
echo.  [F]   Couper
echo.  [G]   Fusionner
echo.  [H]   Mise a jour
echo.  [I]   Capturer
echo.  [J]   Appliquer
echo.  [K]   Nettoyer
echo.
echo.
echo.
echo.
echo.  [X]   Retour
echo.
echo.===============================================================================
echo.
choice /C:ABCDEFGHIJKX /N /M "Entrer votre choix : "
if errorlevel 12 goto :ToolsMenu
if errorlevel 11 goto :WIMCleanUp
if errorlevel 10 goto :WIMApply
if errorlevel 9  goto :WIMCapture
if errorlevel 8  goto :WIMUpgrade
if errorlevel 7  goto :WIMMerge
if errorlevel 6  goto :WIMSplit
if errorlevel 5  goto :WIMConvert
if errorlevel 4  goto :WIMExport
if errorlevel 3  goto :WIMDelete
if errorlevel 2  goto :WIMRename
if errorlevel 1  goto :WIMDisplay

::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Display WIM Image Information
::-------------------------------------------------------------------------------------------
:WIMDisplay

cls
echo.===============================================================================
echo.               MSMG ToolKit - Display WIM Image Information
echo.===============================================================================

:: Checking whether Windows Source Install Image file exist
if not exist "%InstallWim%" (
	echo.Cannot find Windows Setup Install Image ^<DVD\Sources\install.wim^> file...
	echo.
	echo.Please copy Windows Setup "Install.wim" Image to respective folder...
	echo.
	echo.===============================================================================
	echo.
	goto :Stop
)

:: Display Image Index Information
call :ShowImageInfo

:Stop

pause

:: Returning to WIM Manager Menu
goto :WIMManager
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Rename WIM Index
::-------------------------------------------------------------------------------------------
:WIMRename

setlocal

set NewImageName=
set NewImageDescription=

cls
echo.===============================================================================
echo.                MSMG ToolKit - Renommer l'index des images WIM 
echo.===============================================================================
echo.

:: Checking whether Windows Source Install Image file exist
if not exist "%InstallWim%" (
	echo.Impossible de trouver le fichier Image d'installation 
	echo.^<DVD\Sources\install.wim^> du programme d'installation de Windows.
	echo.
	echo.Veuillez copier le fichier image d'installation de l'installation 
	echo.de Windows dans le dossier respectif. 
	goto :Stop
)

echo.-------------------------------------------------------------------------------
echo.####Demarrage du changement de nom de l'index d'image WIM source ##############
echo.-------------------------------------------------------------------------------

:: Display Image Index Information
call :ShowImageInfo

:: Getting Image Index No to Rename
set /p ImageIndexNo=Entrer le numero d'index d'image WIM ['Q'uit] : 

:: Checking for Image Index Validation
if not defined ImageIndexNo (
	echo.
	echo.Numero d'index saisi, invalide.
	echo.
	pause
	goto :WIMRename
)

if /i "%ImageIndexNo%" equ "Q" goto :WIMManager

echo.
set /p NewImageName=Entrer le nom de l'index WIM : 
echo.
set /p NewImageDescription=Entrer la description de l'index WIM : 

echo.
echo.-------------------------------------------------------------------------------
echo.Renommer l'image WIM source [Install.wim, Index:%ImageIndexNo%] Informations. 
echo.-------------------------------------------------------------------------------
echo.
%WimLibImagex% info "%InstallWim%" %ImageIndexNo% "%NewImageName%" "%NewImageDescription%" --image-property DISPLAYNAME="%NewImageName%" --image-property DISPLAYDESCRIPTION="%NewImageDescription%"
echo.
echo.-------------------------------------------------------------------------------
echo.####Renommer l'index des images WIM source ####################################
echo.-------------------------------------------------------------------------------
:Stop
echo.
echo.===============================================================================
echo.
pause

set NewImageName=
set NewImageDescription=
set ImageIndexNo=

endlocal

:: Returning to WIM Manager Menu
goto :WIMManager
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Delete WIM Index
::-------------------------------------------------------------------------------------------
:WIMDelete

cls
echo.===============================================================================
echo.                     MSMG ToolKit - Supprimer l'index WIM
echo.===============================================================================
echo.

:: Checking whether Windows Source Install Image file exist
if not exist "%InstallWim%" (
	echo.Impossible de trouver le fichier Image d'installation 
	echo.^<DVD\Sources\install.wim^> de l'installation de Windows ...
	echo.
	echo.Veuillez copier le fichier image d'installation de Windows dans 
	echo.le dossier respectif. 
	goto :Stop
)

:: Finding total no of indexes present inside the Image
call :GetImageCount "%InstallWim%"

if %ImageCount% equ 1 (
	echo.Impossible de supprimer l'index d'image isole.
	goto :Stop
)

echo.-------------------------------------------------------------------------------
echo.####Demarrage de la suppression de l'index des images WIM source ##############
echo.-------------------------------------------------------------------------------

:: Display Image Information
call :ShowImageInfo

:: Get Image Index No to Export
set /p ImageIndexNo=Entrez le Numero de l'index d'image WIM ['Q'uit] : 
echo.

:: Checking for Image Index Validation
if not defined ImageIndexNo (
	echo.Numero d'index entre non valide, la plage valide est  [1,...%ImageCount%, 'Q'uit]
	echo.
	pause
	goto :WIMDelete
)

if /i "%ImageIndexNo%" equ "Q" goto :WIMManager

echo.-------------------------------------------------------------------------------
echo.Suppression d'une image WIM source [Install.wim, Index : %ImageIndexNo%].
echo.-------------------------------------------------------------------------------
call :DeleteImage "%InstallWim%", %ImageIndexNo%
echo.-------------------------------------------------------------------------------
echo.####Fin de la suppression de l'index des images WIM source ####################
echo.-------------------------------------------------------------------------------
:Stop
echo.
echo.===============================================================================
echo.
pause

:: Returning to WIM Manager Menu
goto :WIMManager
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Export WIM Index to Source WIM Image or New WIM Image
::-------------------------------------------------------------------------------------------
:WIMExport

setlocal

set WimImageFileName=
set Export2NewImage=

cls
echo.===============================================================================
echo.                     MSMG ToolKit - Exporter l'index WIM 
echo.===============================================================================
echo.

:: Checking whether Windows Source Install Image file exist
if not exist "%InstallWim%" (
	echo.Impossible de trouver le fichier Image d'installation 
	echo.^<DVD\Sources\install.wim^> du programme d'installation de Windows.
	echo.
	echo.Veuillez copier le fichier image d'installation de l'installation 
	echo.de Windows dans le dossier respectif. 
	goto :Stop
)

echo.-------------------------------------------------------------------------------
echo.####Demarrage de l'exportation de l'index d'image source WIM ##################
echo.-------------------------------------------------------------------------------

:: Display Image Information
call :ShowImageInfo

:: Get Image Index No to Export
if "%ImageCount%" equ "1" (
	set /p ImageIndexNo=Entrer le Numero d'index d'image WIM  ['Q'uit] : 
) else set /p ImageIndexNo=Entrer le Numero de l'index d'image WIM [Range : 1,...%ImageCount%, 'A'll, 'Q'uit] : 

:: Checking for Image Index Validation
if not defined ImageIndexNo (
	echo.
	echo.Numero d'index saisi non valide, la plage valide est [1,...%ImageCount%, 'A'll, 'Q'uit]
	echo.
	pause
	goto :WIMExport
)

if /i "%ImageIndexNo%" equ "Q" goto :WIMManager

echo.
choice /C:YN /N /M "Voulez-vous exporter vers une nouvelle image WIM ? ['Y'es/'N'o] : "
if errorlevel 2 set "Export2NewImage=No"
if errorlevel 1 set "Export2NewImage=Yes"

if "%Export2NewImage%" equ "Yes" (
	echo.
	set /p WimImageFileName=Enter WIM Image Filename without [.wim] : 
	set "WimImageFileName=!WimImageFileName!.wim"
)

echo.
echo.-------------------------------------------------------------------------------
echo.####Exportation de l'index d'image source WIM #################################
echo.-------------------------------------------------------------------------------
echo.

if /i "%ImageIndexNo%" equ "A" (
	for /l %%i in (1, 1, %ImageCount%) do (
		echo.-------------------------------------------------------------------------------
		if "!Export2NewImage!" equ "Yes" echo.Exportation d'une image WIM source [Install.wim, Index : %%i] vers [%WimImageFileName%].
		if "!Export2NewImage!" equ "No" echo.Exportation de l'image WIM source  [Install.wim, Index : %%i] vers [Install.wim].
		echo.-------------------------------------------------------------------------------
		if "!Export2NewImage!" equ "Yes" call :ExportImageIndex "%InstallWim%", %%i, "%DVD%\sources\%WimImageFileName%", "WIM", "No"
		if "!Export2NewImage!" equ "No" call :ExportImageIndex "%InstallWim%", %%i, "%InstallWim%", "WIM", "No"
	)
) else (
	for %%i in (%ImageIndexNo%) do (
		echo.-------------------------------------------------------------------------------
		if "!Export2NewImage!" equ "Yes" echo.Exportation d'une image WIM source [Install.wim, Index : %%i] vers [%WimImageFileName%]... 
		if "!Export2NewImage!" equ "No" echo.Exportation d'une image WIM source  [Install.wim, Index : %%i] vers [Install.wim]...
		echo.-------------------------------------------------------------------------------
		if "!Export2NewImage!" equ "Yes" call :ExportImageIndex "%InstallWim%", %%i, "%DVD%\sources\%WimImageFileName%", "WIM", "No"
		if "!Export2NewImage!" equ "No" call :ExportImageIndex "%InstallWim%", %%i, "%InstallWim%", "WIM", "No"
	)
)

echo.-------------------------------------------------------------------------------
echo.####L'exportation de l'index des images WIM source est terminee ###############
echo.-------------------------------------------------------------------------------
:Stop
echo.
echo.===============================================================================
echo.
pause

set WimImageFileName=
set Export2NewImage=

endlocal

:: Returning to WIM Manager Menu
goto :WIMManager
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: MSMG Toolkit - Convert WIM Image to ESD Image
::-------------------------------------------------------------------------------------------
:WIMConvert

cls
echo.===============================================================================
echo.             MSMG ToolKit - Convertir une image WIM en image ESD
echo.===============================================================================
echo.

:: Checking whether Windows Source Install Image file exist
if not exist "%InstallWim%" (
	echo.Impossible de trouver le fichier Image d'installation 
	echo.^<DVD\Sources\install.wim^> de Windows ... 
	echo.
	echo.Veuillez copier le fichier d'image d'installation de Windows
	echo.dans le dossier respectif.
	goto :Stop
)

echo.-------------------------------------------------------------------------------
echo.####Demarrage de la conversion d'une image WIM en image ESD ###################
echo.-------------------------------------------------------------------------------

:: Getting Image Index Number to Service
call :GetImageIndexNo "%InstallWim%"

:: Checking for Image Index Validation
if not defined ImageIndexNo (
	echo.
	echo.Numero d'index non valide entre, la plage valide est [1, ...%ImageCount%, 'A'll, 'Q'uit]
	echo.
	pause
	goto :WIMConvert
)

if /i "%ImageIndexNo%" equ "Q" goto :WIMManager

echo.
echo.-------------------------------------------------------------------------------
echo.####Conversion d'une image WIM en image ESD ###################################
echo.-------------------------------------------------------------------------------

:: Exporting Source Image to ESD Image
if /i "%ImageIndexNo%" equ "A" (
	call :ExportImage "%InstallWim%", "%InstallEsd%", "ESD", "No"
) else (
	for %%i in (%ImageIndexNo%) do (
		call :ExportImageIndex "%InstallWim%", %%i, "%InstallEsd%", "ESD", "No"
	)
)

:: Deleting Source Image File
call :RemoveFile "%InstallWim%"

echo.-------------------------------------------------------------------------------
echo.####Conversion de l'image WIM en image ESD terminee ###########################
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

:: Returning to WIM Manager Menu
goto :WIMManager
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Split WIM Image
::-------------------------------------------------------------------------------------------
:WIMSplit

setlocal

set WimImageSplitFileSize=

cls
echo.===============================================================================
echo.                      MSMG ToolKit - Diviser Image WIM 
echo.===============================================================================
echo.

:: Checking whether Windows Source Install Image file exist
if not exist "%InstallWim%" (
	echo.Impossible de trouver le fichier Image d'installation 
	echo.^<DVD\Sources\install.wim^> de Windows ... 
	echo.
	echo.Veuillez copier le fichier d'image d'installation de Windows
	echo.dans le dossier respectif. 
	goto :Stop
)

echo.-------------------------------------------------------------------------------
echo.####Demarrage de la division de l'image WIM source  ###########################
echo.-------------------------------------------------------------------------------
echo.
set /p WimImageSplitFileSize=Entrer la taille du fichier de fractionnement d'image WIM en Mo : 
echo.
echo.-------------------------------------------------------------------------------
echo.Division de l'image WIM source [Install.wim]
echo.-------------------------------------------------------------------------------

call :SplitImage "%InstallWim%", "%DVD%\sources\install.swm", %WimImageSplitFileSize%
call :RemoveFile "%InstallWim%"

echo.-------------------------------------------------------------------------------
echo.####Image WIM source de fractionnement termine ################################
echo.-------------------------------------------------------------------------------
:Stop
echo.
echo.===============================================================================
echo.
pause

set WimImageSplitFileSize=

endlocal

:: Returning to WIM Manager Menu
goto :WIMManager
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Merge Splitted WIM Image
::-------------------------------------------------------------------------------------------
:WIMMerge

cls
echo.===============================================================================
echo.                MSMG ToolKit - Fusionner l'image WIM fractionnee 
echo.===============================================================================
echo.

:: Checking whether Windows Source Install Image file exist
if not exist "%InstallWim%" (
	echo.Impossible de trouver le fichier Image d'installation 
	echo.^<DVD\Sources\install.wim^> de Windows. 
	echo.
	echo.Veuillez copier le fichier d'image d'installation de Windows 
	echo.dans le dossier respectif. 
	goto :Stop
)

echo.-------------------------------------------------------------------------------
echo.####Demarrage de la fusion d'une image WIM source fractionnee #################
echo.-------------------------------------------------------------------------------
echo.
echo.-------------------------------------------------------------------------------
echo.Fusion de l'image WIM source fractionnee [Install.swm] avec [Install.wim].
echo.-------------------------------------------------------------------------------

call :MergeImage "%DVD%\sources\install", "%InstallWim%"
call :RemoveFile "%DVD%\sources\*.swm"

echo.-------------------------------------------------------------------------------
echo.####Fusion de l'image WIM source divisee terminee #############################
echo.-------------------------------------------------------------------------------
:Stop
echo.
echo.===============================================================================
echo.
pause

:: Returning to WIM Manager Menu
goto :WIMManager
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Upgrade WIM Index Edition
::-------------------------------------------------------------------------------------------
:WIMUpgrade

setlocal

set SourceEdition=
set TargetEdition=
set Flag=
set Edition=
set Name=
set Description=
set DisplayName=
set DisplayDescription=

cls
echo.===============================================================================
echo.                 MSMG ToolKit - Mettre a niveau l'edition WIM 
echo.===============================================================================

:: Checking whether Windows Source Install Image file exist
if not exist "%InstallWim%" (
	echo.
	echo.Impossible de trouver le fichier Image d'installation 
	echo.^<DVD\Sources\install.wim^> de Windows.
	echo.
	echo.Veuillez copier le fichier d'image d'installation de Windows 
	echo.dans le dossier respectif. 
	goto :Stop
)

:: Display Image Information
call :ShowImageInfo

:: Get Image Index No to Upgrade
set /p ImageIndexNo=Entrer le numero d'index d'image WIM ['Q'uit] : 

:: Checking for Image Index Validation
if not defined ImageIndexNo (
	echo.
	echo.N ° d'index saisi invalide... 
	echo.
	pause
	goto :WIMUpgrade
)

if /i "%ImageIndexNo%" equ "Q" goto :WIMManager

:: Getting selected Image Index Information
call :GetImageIndexInfo "%InstallWim%", %ImageIndexNo% >nul

:: Setting selected Source OS version
if "%ImageVersion%" equ "6.1.7601" set "SelectedSourceOS=w7"
if "%ImageVersion%" equ "6.3.9600" set "SelectedSourceOS=w81"
if "%ImageVersion:~0,-6%" equ "10.0" set "SelectedSourceOS=w10"
echo.

:: Checking whether the selected Source OS is a Windows 7 Enterprise Edition
if "%SelectedSourceOS%" equ "w7" if "%ImageFlag%" equ "Enterprise" (
	echo.Windows 7 Entreprise Edition ne peut pas etre mis a niveau. 
	echo.
	echo.===============================================================================
	echo.
	pause
	goto :WIMManager
)

:: Checking whether the selected Source OS is a Windows 7 Enterprise N Edition
if "%SelectedSourceOS%" equ "w7" if "%ImageFlag%" equ "EnterpriseN" (
	echo.Windows 7 Entreprise N Edition ne peut pas etre mis a niveau. 
	echo.
	echo.===============================================================================
	echo.
	pause
	goto :WIMManager
)

:: Checking whether the selected Source OS is a Windows 7 Enterprise K Edition
if "%SelectedSourceOS%" equ "w7" if "%ImageFlag%" equ "EnterpriseK" (
	echo.Windows 7 Entreprise K Edition ne peut pas etre mis a niveau. 
	echo.
	echo.===============================================================================
	echo.
	pause
	goto :WIMManager
)

:: Checking whether the selected Source OS is a Windows 7 Enterprise KN Edition
if "%SelectedSourceOS%" equ "w7" if "%ImageFlag%" equ "EnterpriseKN" (
	echo.Windows 7 Entreprise KN Edition ne peut pas etre mis a niveau. 
	echo.
	echo.===============================================================================
	echo.
	pause
	goto :WIMManager
)

:: Checking whether the selected Source OS is a Windows 7 Ultimate Edition
if "%SelectedSourceOS%" equ "w7" if "%ImageFlag%" equ "Ultimate" (
	echo.Windows 7 Ultimate Edition ne peut pas etre mis a niveau. 
	echo.
	echo.===============================================================================
	echo.
	pause
	goto :WIMManager
)

:: Checking whether the selected Source OS is a Windows 7 Ultimate N Edition
if "%SelectedSourceOS%" equ "w7" if "%ImageFlag%" equ "UltimateN" (
	echo.Windows 7 Ultimate N Edition ne peut pas etre mis a niveau. 
	echo.
	echo.===============================================================================
	echo.
	pause
	goto :WIMManager
)

:: Checking whether the selected Source OS is a Windows 7 Ultimate K Edition
if "%SelectedSourceOS%" equ "w7" if "%ImageFlag%" equ "UltimateK" (
	echo.Windows 7 Ultimate K Edition ne peut pas etre mis a niveau. 
	echo.
	echo.===============================================================================
	echo.
	pause
	goto :WIMManager
)

:: Checking whether the selected Source OS is a Windows 7 Ultimate KN Edition
if "%SelectedSourceOS%" equ "w7" if "%ImageFlag%" equ "UltimateKN" (
	echo.Windows 7 Ultimate KN Edition ne peut pas etre mis a niveau. 
	echo.
	echo.===============================================================================
	echo.
	pause
	goto :WIMManager
)

:: Checking whether the selected Source OS is a Windows 8.1 Pro with Media Center Edition
if "%ImageFlag%" equ "ProfessionalWMC" (
	echo.Windows 8.1 Pro avec Media Center Edition ne peut pas etre mis a niveau. 
	echo.
	echo.===============================================================================
	echo.
	pause
	goto :WIMManager
)

:: Checking whether the selected Source OS is a Windows 8.1 Pro N Edition
if "%SelectedSourceOS%" equ "w81" if "%ImageFlag%" equ "ProfessionalN" (
	echo.Windows 8.1 Pro N Edition ne peut pas etre mis a niveau. 
	echo.
	echo.===============================================================================
	echo.
	pause
	goto :WIMManager
)

:: Checking whether the selected Source OS is a Windows 8.1 Enterprise Edition
if "%SelectedSourceOS%" equ "w81" if "%ImageFlag%" equ "Enterprise" (
	echo.Windows 8.1 Entreprise Edition ne peut pas etre mis a niveau. 
	echo.
	echo.===============================================================================
	echo.
	pause
	goto :WIMManager
)

:: Checking whether the selected Source OS is a Windows 8.1 Enterprise N Edition
if "%SelectedSourceOS%" equ "w81" if "%ImageFlag%" equ "EnterpriseN" (
	echo.Windows 8.1 Entreprise N Edition ne peut pas etre mis a niveau. 
	echo.
	echo.===============================================================================
	echo.
	pause
	goto :WIMManager
)

:: Checking whether the selected Source OS is a Windows 8.1 Embedded Industry Pro/Enterprise Edition
if "%SelectedSourceOS%" equ "w81" if "%ImageFlag%" equ "EmbeddedIndustry" (
	echo.Windows Embedded Industrie Pro Edition ne peut pas etre mis a niveau. 
	echo.
	echo.===============================================================================
	echo.
	pause
	goto :WIMManager
)

:: Checking whether the selected Source OS is a Windows 8.1 Embedded Industry Enterprise Edition
if "%SelectedSourceOS%" equ "w81" if "%ImageFlag%" equ "EmbeddedIndustryE" (
	echo.Windows Embedded Industrie Entreprise Edition ne peut pas etre mis a niveau. 
	echo.
	echo.===============================================================================
	echo.
	pause
	goto :WIMManager
)

:: Checking whether the selected Source OS is a Windows Server 2012 R2 Datacenter Core Edition
if "%SelectedSourceOS%" equ "w81" if "%ImageFlag%" equ "ServerDataCenterCore" (
	echo.Windows Server 2012 R2 Datacenter Core Edition ne peut pas etre mis a niveau. 
	echo.
	echo.===============================================================================
	echo.
	pause
	goto :WIMManager
)

:: Checking whether the selected Source OS is a Windows Server 2012 R2 Datacenter Edition
if "%SelectedSourceOS%" equ "w81" if "%ImageFlag%" equ "ServerDataCenter" (
	echo.Windows Server 2012 R2 Datacenter Edition ne peut pas etre mis a niveau. 
	echo.
	echo.===============================================================================
	echo.
	pause
	goto :WIMManager
)

:: Checking whether the selected Source OS is a Windows Server 2012 R2 Foundation Edition
if "%SelectedSourceOS%" equ "w81" if "%ImageFlag%" equ "ServerWinFoundation" (
	echo.Windows Server 2012 R2 Foundation Edition ne peut pas etre mis a niveau. 
	echo.
	echo.===============================================================================
	echo.
	pause
	goto :WIMManager
)

:: Checking whether the selected Source OS is a Windows Storage Server 2012 R2 Standard Edition
if "%SelectedSourceOS%" equ "w81" if "%ImageFlag%" equ "ServerStorageStandard" (
	echo.Windows Storage Server 2012 R2 Standard Edition ne peut pas etre mis a niveau. 
	echo.
	echo.===============================================================================
	echo.
	pause
	goto :WIMManager
)

:: Checking whether the selected Source OS is a Windows Storage Server 2012 R2 Workgroup Edition
if "%SelectedSourceOS%" equ "w81" if "%ImageFlag%" equ "ServerStorageWorkgroup" (
	echo.Windows Storage Server 2012 R2 Workgroup Edition ne peut pas etre mis a niveau. 
	echo.
	echo.===============================================================================
	echo.
	pause
	goto :WIMManager
)

:: Checking whether the selected Source OS is a Windows 10 Enterprise Edition
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "10240" if "%ImageFlag%" equ "Enterprise" (
	echo.Windows 10 Entreprise Edition ne peut pas etre mis a niveau. 
	echo.
	echo.===============================================================================
	echo.
	pause
	goto :WIMManager
)

:: Checking whether the selected Source OS is a Windows 10 Enterprise N Edition
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "10240" if "%ImageFlag%" equ "EnterpriseN" (
	echo.Windows 10 Edition ne peut pas etre mis a niveau. 
	echo.
	echo.===============================================================================
	echo.
	pause
	goto :WIMManager
)

:: Checking whether the selected Source OS is a Windows 10 S Edition
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "16299" if "%ImageEdition%" equ "Cloud" (
	echo.Windows 10 S Edition ne peut pas etre mis a niveau. 
	echo.
	echo.===============================================================================
	echo.
	pause
	goto :WIMManager
)

:: Checking whether the selected Source OS is a Windows 10 S N Edition
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "16299" if "%ImageEdition%" equ "CloudN" (
	echo.Windows 10 S N Edition ne peut pas etre mis a niveau. 
	echo.
	echo.===============================================================================
	echo.
	pause
	goto :WIMManager
)

:: Checking whether the selected Source OS is a Windows 10 Professional Edition
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "16299" if "%ImageFlag%" equ "Professional" (
	echo.Windows 10 Professionel Edition ne peut pas etre mis a niveau.
	echo.
	echo.===============================================================================
	echo.
	pause
	goto :WIMManager
)

:: Checking whether the selected Source OS is a Windows 10 Professional N Edition
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "16299" if "%ImageFlag%" equ "ProfessionalN" (
	echo.Windows 10 Professionel G Edition ne peut pas etre mis a niveau. 
	echo.
	echo.===============================================================================
	echo.
	pause
	goto :WIMManager
)

:: Checking whether the selected Source OS is a Windows 10 Enterprise G Edition
if "%ImageFlag%" equ "EnterpriseG" (
	echo.Windows 10 Enterprise G Edition ne peut pas etre mis a niveau. 
	echo.
	echo.===============================================================================
	echo.
	pause
	goto :WIMManager
)

:: Checking whether the selected Source OS is a Windows 10 Enterprise GN Edition
if "%ImageFlag%" equ "EnterpriseGN" (
	echo.Windows 10 Enterprise GN Edition ne peut pas etre mis a niveau. 
	echo.
	echo.===============================================================================
	echo.
	pause
	goto :WIMManager
)

:: Checking whether the selected Source OS is a Windows 10 Enterprise LTSB Edition
if "%ImageFlag%" equ "EnterpriseS" (
	if "%ImageBuild%" equ "10240" echo.Windows 10 Enterprise 2015 LTSB Edition ne peut pas etre mis a niveau... 
	if "%ImageBuild%" equ "14393" echo.Windows 10 Enterprise 2016 LTSB Edition ne peut pas etre mis a niveau... 
	if "%ImageBuild%" equ "17763" echo.Windows 10 Enterprise 2019 LTSB Edition ne peut pas etre mis a niveau... 
	echo.
	echo.===============================================================================
	echo.
	pause
	goto :WIMManager
)

:: Checking whether the selected Source OS is a Windows 10 Enterprise N LTSB Edition
if "%ImageFlag%" equ "EnterpriseSN" (
	if "%ImageBuild%" equ "10240" echo.Windows 10 Enterprise N 2015 LTSB Edition ne peut pas etre mis a niveau... 
	if "%ImageBuild%" equ "14393" echo.Windows 10 Enterprise N 2016 LTSB Edition ne peut pas etre mis a niveau... 
	if "%ImageBuild%" equ "17763" echo.Windows 10 Enterprise N 2019 LTSB Edition ne peut pas etre mis a niveau... 
	echo.
	echo.===============================================================================
	echo.
	pause
	goto :WIMManager
)

:: Checking whether the selected Source OS is a Windows 10 Education Edition
if "%ImageFlag%" equ "Education" (
	echo.Windows 10 Education Edition ne peut pas etre mis a niveau. 
	echo.
	echo.===============================================================================
	echo.
	pause
	goto :WIMManager
)

:: Checking whether the selected Source OS is a Windows 10 Education N Edition
if "%ImageFlag%" equ "EducationN" (
	echo.Windows 10 Education N Edition ne peut pas etre mis a niveau. 
	echo.
	echo.===============================================================================
	echo.
	pause
	goto :WIMManager
)

:: Checking whether the selected Source OS is a Windows Hyper Server 2016 Edition
if "%SelectedSourceOS%" equ "w10" if "%ImageFlag%" equ "ServerHyper" (
	echo.Windows Hyper-V Server 2016 Edition ne peut pas etre mis a niveau. 
	echo.
	echo.===============================================================================
	echo.
	pause
	goto :WIMManager
)

:: Checking whether the selected Source OS is a Windows Server 2016 Azure Core Edition
if "%SelectedSourceOS%" equ "w10" if "%ImageFlag%" equ "ServerAzureCor" (
	echo.Windows Server 2016 Azure Core Edition ne peut pas etre mis a niveau. 
	echo.
	echo.===============================================================================
	echo.
	pause
	goto :WIMManager
)

:: Checking whether the selected Source OS is a Windows Server 2016 Datacenter Edition
if "%SelectedSourceOS%" equ "w10" if "%ImageFlag%" equ "ServerDatacenter" (
	echo.Windows Server 2016 Datacenter Edition ne peut pas etre mis a niveau.
	echo.
	echo.===============================================================================
	echo.
	pause
	goto :WIMManager
)

:: Checking whether the selected Source OS is a Windows Storage Server 2016 Standard Edition
if "%SelectedSourceOS%" equ "w10" if "%ImageFlag%" equ "ServerStorageStandard" (
	echo.Windows Storage Server 2016 Standard Edition ne peut pas etre mis a niveau.
	echo.
	echo.===============================================================================
	echo.
	pause
	goto :WIMManager
)

:: Checking whether the selected Source OS is a Windows Storage Server 2016 Workgroup Edition
if "%SelectedSourceOS%" equ "w10" if "%ImageFlag%" equ "ServerStorageWorkgroup" (
	echo.Windows Storage Server 2016 Workgroup Edition ne peut pas etre mis a niveau. 
	echo.
	echo.===============================================================================
	echo.
	pause
	goto :WIMManager
)

set SourceEdition=%ImageFlag%

echo.-------------------------------------------------------------------------------
echo.####Demarrage de la mise a niveau de WIM Image Edition ########################
echo.-------------------------------------------------------------------------------
echo.
echo.-------------------------------------------------------------------------------
echo.Montage de l'image [Install.wim, Index : %ImageIndexNo%] sur ^<\Mount\Install^> 
echo.-------------------------------------------------------------------------------
call :MountImage "%InstallWim%", %ImageIndexNo%, "%InstallMount%"
echo.-------------------------------------------------------------------------------
echo.
echo.-------------------------------------------------------------------------------
echo.Obtention des éditions cibles... 
echo.-------------------------------------------------------------------------------
echo.
for /f "tokens=2 delims=:" %%a in ('%DISM% /Image:"%InstallMount%" /Get-TargetEditions ^| find "Target Edition"') do (echo. %%a)
echo.
:: Get Target Edition
set /p TargetEdition=Entrer l'édition cible : 
echo.

:: Checking whether the Selected Source OS is a Windows 8.1 Pro Retail Edition
if "%SelectedSourceOS%" equ "w81" if "%ImageEdition%" equ "Professional" if "%TargetEdition%" equ "ProfessionalWMC" (
	echo.Verifier si l'image source est Windows 8.1 Pro Edition ou non. 
	echo.
	%DISM% /Format:Table /Image:"%InstallMount%" /Get-Packages | findstr /c:"GVLK-Package" >nul
	if not errorlevel 1 (
		echo.La source selectionnee n'est pas une edition commerciale de Windows 8.1 Pro. 
		echo.
		echo.Veuillez utiliser le systeme Windows 8.1 Pro Retail Edition comme source.
		goto :Stop
	)
)
echo.-------------------------------------------------------------------------------
if "%SelectedSourceOS%" equ "w7" if "%ImageInstallationType%" equ "Client" echo.Upgrading Windows 7 %SourceEdition% to %TargetEdition%...
if "%SelectedSourceOS%" equ "w7" if "%ImageInstallationType:~,6%" equ "Server" echo.Upgrading Windows Server 2008 R2 %SourceEdition% to %TargetEdition%...
if "%SelectedSourceOS%" equ "w81" if "%ImageInstallationType%" equ "Client" echo.Upgrading Windows 8.1 %SourceEdition% to %TargetEdition%...
if "%SelectedSourceOS%" equ "w81" if "%ImageInstallationType%" equ "Embedded" echo.Upgrading Windows 8.1 Embedded %SourceEdition% to %TargetEdition%...
if "%SelectedSourceOS%" equ "w81" if "%ImageInstallationType:~,6%" equ "Server" echo.Upgrading Windows Server 2012 R2 %SourceEdition% to %TargetEdition%...
if "%SelectedSourceOS%" equ "w10" if "%ImageInstallationType%" equ "Client" echo.Upgrading Windows 10 %SourceEdition% to %TargetEdition%...
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "14393" if "%ImageInstallationType:~,6%" equ "Server" echo.Upgrading Windows Server 2016 %SourceEdition% to %TargetEdition%...
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "15063" if "%ImageInstallationType:~,6%" equ "Server" echo.Upgrading Windows Server v1709 %SourceEdition% to %TargetEdition%...
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "16299" if "%ImageInstallationType:~,6%" equ "Server" echo.Upgrading Windows Server v1803 %SourceEdition% to %TargetEdition%...
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "17134" if "%ImageInstallationType:~,6%" equ "Server" echo.Upgrading Windows Server v1809 %SourceEdition% to %TargetEdition%...
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "17763" if "%ImageInstallationType:~,6%" equ "Server" echo.Upgrading Windows Server 2019 %SourceEdition% to %TargetEdition%...
if "%SelectedSourceOS%" equ "w10" if "%ImageBuild%" equ "18362" if "%ImageInstallationType:~,6%" equ "Server" echo.Upgrading Windows Server v1903/v1909 %SourceEdition% to %TargetEdition%...

echo.-------------------------------------------------------------------------------
%DISM% /Image:"%InstallMount%" /Set-Edition:%TargetEdition%
echo.
echo.-------------------------------------------------------------------------------
echo.Demontage de l'image [Install.wim, Index : %ImageIndexNo%]
echo.-------------------------------------------------------------------------------
call :UnMountImage "%InstallMount%", "Commit"
echo.-------------------------------------------------------------------------------
echo.####Application des proprietes de l'edition d'image WIM cible #################
echo.-------------------------------------------------------------------------------
echo.
if "%SelectedSourceOS%" equ "w7"  (
	if "%TargetEdition%" equ "HomeBasic" (
		set "Flag=HomeBasic"
		set "Edition=HomeBasic"
		set "Name=Windows 7 HOMEBASIC"
		set "Description=Windows 7 HOMEBASIC"
		set "DisplayName=Windows 7 Home Basic"
		set "DisplayDescription=Windows 7 Home Basic"
	)

	if "%TargetEdition%" equ "HomePremium" (
		set "Flag=HomePremium"
		set "Edition=HomePremium"
		set "Name=Windows 7 HOMEPREMIUM"
		set "Description=Windows 7 HOMEPREMIUM"
		set "DisplayName=Windows 7 Home Premium"
		set "DisplayDescription=Windows 7 Home Premium"
	)

	if "%TargetEdition%" equ "Professional" (
		set "Flag=Professional"
		set "Edition=Professional"
		set "Name=Windows 7 PROFESSIONAL"
		set "Description=Windows 7 PROFESSIONAL"
		set "DisplayName=Windows 7 Professional"
		set "DisplayDescription=Windows 7 Professional"
	)

	if "%TargetEdition%" equ "Ultimate" (
		set "Flag=Ultimate"
		set "Edition=Ultimate"
		set "Name=Windows 7 ULTIMATE"
		set "Description=Windows 7 ULTIMATE"
		set "DisplayName=Windows 7 Ultimate"
		set "DisplayDescription=Windows 7 Ultimate"
	)

	if "%TargetEdition%" equ "HomeBasicN" (
		set "Flag=HomeBasicN"
		set "Edition=HomeBasicN"
		set "Name=Windows 7 HOMEBASICN"
		set "Description=Windows 7 HOMEBASICN"
		set "DisplayName=Windows 7 Home Basic N"
		set "DisplayDescription=Windows 7 Home Basic N"
	)

	if "%TargetEdition%" equ "HomePremiumN" (
		set "Flag=HomePremiumN"
		set "Edition=HomePremiumN"
		set "Name=Windows 7 HOMEPREMIUMN"
		set "Description=Windows 7 HOMEPREMIUMN"
		set "DisplayName=Windows 7 Home Premium N"
		set "DisplayDescription=Windows 7 Home Premium N"
	)

	if "%TargetEdition%" equ "ProfessionalN" (
		set "Flag=ProfessionalN"
		set "Edition=ProfessionalN"
		set "Name=Windows 7 PROFESSIONALN"
		set "Description=Windows 7 PROFESSIONALN"
		set "DisplayName=Windows 7 Professional N"
		set "DisplayDescription=Windows 7 Professional N"
	)

	if "%TargetEdition%" equ "UltimateN" (
		set "Flag=UltimateN"
		set "Edition=UltimateN"
		set "Name=Windows 7 ULTIMATEN"
		set "Description=Windows 7 ULTIMATEN"
		set "DisplayName=Windows 7 Ultimate N"
		set "DisplayDescription=Windows 7 Ultimate N"
	)

	if "%TargetEdition%" equ "HomeBasicK" (
		set "Flag=HomeBasicK"
		set "Edition=HomeBasicK"
		set "Name=Windows 7 HOMEBASICK"
		set "Description=Windows 7 HOMEBASICK"
		set "DisplayName=Windows 7 Home Basic K"
		set "DisplayDescription=Windows 7 Home Basic K"
	)

	if "%TargetEdition%" equ "HomePremiumK" (
		set "Flag=HomePremiumK"
		set "Edition=HomePremiumK"
		set "Name=Windows 7 HOMEPREMIUMK"
		set "Description=Windows 7 HOMEPREMIUMK"
		set "DisplayName=Windows 7 Home Premium K"
		set "DisplayDescription=Windows 7 Home Premium K"
	)

	if "%TargetEdition%" equ "ProfessionalK" (
		set "Flag=ProfessionalK"
		set "Edition=ProfessionalK"
		set "Name=Windows 7 PROFESSIONALK"
		set "Description=Windows 7 PROFESSIONALK"
		set "DisplayName=Windows 7 Professional K"
		set "DisplayDescription=Windows 7 Professional K"
	)

	if "%TargetEdition%" equ "UltimateK" (
		set "Flag=UltimateK"
		set "Edition=UltimateK"
		set "Name=Windows 7 ULTIMATEK"
		set "Description=Windows 7 ULTIMATEK"
		set "DisplayName=Windows 7 Ultimate K"
		set "DisplayDescription=Windows 7 Ultimate K"
	)

	if "%TargetEdition%" equ "HomeBasicKN" (
		set "Flag=HomeBasicKN"
		set "Edition=HomeBasicKN"
		set "Name=Windows 7 HOMEBASICKN"
		set "Description=Windows 7 HOMEBASICKN"
		set "DisplayName=Windows 7 Home Basic KN"
		set "DisplayDescription=Windows 7 Home Basic KN"
	)

	if "%TargetEdition%" equ "HomePremiumKN" (
		set "Flag=HomePremiumKN"
		set "Edition=HomePremiumKN"
		set "Name=Windows 7 HOMEPREMIUMKN"
		set "Description=Windows 7 HOMEPREMIUMKN"
		set "DisplayName=Windows 7 Home Premium KN"
		set "DisplayDescription=Windows 7 Home Premium KN"
	)

	if "%TargetEdition%" equ "ProfessionalKN" (
		set "Flag=ProfessionalKN"
		set "Edition=ProfessionalKN"
		set "Name=Windows 7 PROFESSIONALKN"
		set "Description=Windows 7 PROFESSIONALKN"
		set "DisplayName=Windows 7 Professional KN"
		set "DisplayDescription=Windows 7 Professional KN"
	)

	if "%TargetEdition%" equ "UltimateKN" (
		set "Flag=UltimateKN"
		set "Edition=UltimateKN"
		set "Name=Windows 7 ULTIMATEKN"
		set "Description=Windows 7 ULTIMATEKN"
		set "DisplayName=Windows 7 Ultimate KN"
		set "DisplayDescription=Windows 7 Ultimate KN"
	)

	if "%TargetEdition%" equ "ServerStandardCore" (
		set "Flag=ServerStandardCore"
		set "Edition=ServerStandard"
		set "Name=Windows Server 2008 R2 SERVERSTANDARDCORE"
		set "Description=Windows Server 2008 R2 SERVERSTANDARDCORE"
		set "DisplayName=Windows Server 2008 R2 Standard ^(Server Core Installation^)"
		set "DisplayDescription=Cette option installe une installation minimale de Windows Server sans l'interface utilisateur Windows standard et avec un sous-ensemble de roles serveur qui peuvent etre geres a partir d'une invite de commandes, ce qui reduit les exigences de gestion et la surface d'attaque."
	)

	if "%TargetEdition%" equ "ServerEnterpriseCore" (
		set "Flag=ServerEnterpriseCore"
		set "Edition=ServerEnterprise"
		set "Name=Windows Server 2008 R2 SERVERENTERPRISECORE"
		set "Description=Windows Server 2008 R2 SERVERENTERPRISECORE"
		set "DisplayName=Windows Server 2008 R2 Enterprise ^(Server Core Installation^)"
		set "DisplayDescription=Cette option installe une installation minimale de Windows Server sans l'interface utilisateur Windows standard et avec un sous-ensemble de roles serveur qui peuvent etre geres a partir d'une invite de commandes, ce qui reduit les exigences de gestion et la surface d'attaque."
	)

	if "%TargetEdition%" equ "ServerDatacenterCore" (
		set "Flag=ServerDataCenterCore"
		set "Edition=ServerDatacenter"
		set "Name=Windows Server 2008 R2 SERVERDATACENTERCORE"
		set "Description=Windows Server 2008 R2 SERVERDATACENTERCORE"
		set "DisplayName=Windows Server 2008 R2 Datacenter ^(Server Core Installation^)"
		set "DisplayDescription=Cette option installe une installation minimale de Windows Server sans l'interface utilisateur Windows standard et avec un sous-ensemble de roles serveur qui peuvent etre geres a partir d'une invite de commandes, ce qui reduit les exigences de gestion et la surface d'attaque."
	)

	if "%TargetEdition%" equ "ServerStandard" (
		set "Flag=ServerStandard"
		set "Edition=ServerStandard"
		set "Name=Windows Server 2008 R2 SERVERSTANDARD"
		set "Description=Windows Server 2008 R2 SERVERSTANDARD"
		set "DisplayName=Windows Server 2008 R2 Standard ^(Full Installation^)"
		set "DisplayDescription=Cette option installe l'installation complete de Windows Server. Cette installation inclut toute l'interface utilisateur et prend en charge tous les roles de serveur."
	)

	if "%TargetEdition%" equ "ServerEnterprise" (
		set "Flag=ServerEnterprise"
		set "Edition=ServerEnterprise"
		set "Name=Windows Server 2008 R2 SERVERENTERPRISE"
		set "Description=Windows Server 2008 R2 SERVERENTERPRISE"
		set "DisplayName=Windows Server 2008 R2 Enterprise ^(Full Installation^)"
		set "DisplayDescription=Cette option installe l'installation complete de Windows Server. Cette installation inclut toute l'interface utilisateur et prend en charge tous les roles de serveur."
	)

	if "%TargetEdition%" equ "ServerDatacenter" (
		set "Flag=ServerDataCenter"
		set "Edition=ServerDatacenter"
		set "Name=Windows Server 2008 R2 SERVERDATACENTER"
		set "Description=Windows Server 2008 R2 SERVERDATACENTER"
		set "DisplayName=Windows Server 2008 R2 Datacenter ^(Full Installation^)"
		set "DisplayDescription=Cette option installe l'installation complete de Windows Server. Cette installation inclut toute l'interface utilisateur et prend en charge tous les roles de serveur."
	)
)

if "%SelectedSourceOS%" equ "w81" (
	if "%TargetEdition%" equ "Core" (
		set "Flag=Core"
		set "Edition=Core"
		set "Name=Windows 8.1 Core"
		set "Description=Windows 8.1 Core"
		set "DisplayName=Windows 8.1 Core"
		set "DisplayDescription=Windows 8.1 Core"
	)

	if "%TargetEdition%" equ "Professional" (
		set "Flag=Professional"
		set "Edition=Professional"
		set "Name=Windows 8.1 Pro"
		set "Description=Windows 8.1 Pro"
		set "DisplayName=Windows 8.1 Pro"
		set "DisplayDescription=Windows 8.1 Pro"
	)

	if "%TargetEdition%" equ "ProfessionalWMC" (
		set "Flag=ProfessionalWMC"
		set "Edition=ProfessionalWMC"
		set "Name=Windows 8.1 Pro WMC"
		set "Description=Windows 8.1 Pro WMC"
		set "DisplayName=Windows 8.1 Pro with Media Center"
		set "DisplayDescription=Windows 8.1 Pro with Media Center"
	)

	if "%TargetEdition%" equ "ProfessionalN" (
		set "Flag=ProfessionalN"
		set "Edition=ProfessionalN"
		set "Name=Windows 8.1 Pro N"
		set "Description=Windows 8.1 Pro N"
		set "DisplayName=Windows 8.1 Pro N"
		set "DisplayDescription=Windows 8.1 Pro N"
	)

	if "%TargetEdition%" equ "ServerDatacenterCore" (
		set "Flag=ServerDatacenterCore"
		set "Edition=ServerDatacenterCore"
		set "Name=Windows Server 2012 R2 Datacenter ^(Server Core Installation^)"
		set "Description=Cette option ^(recommandee^) reduit la gestion et la maintenance en installant uniquement ce qui est necessaire pour executer la plupart des roles serveur et des applications. Il n'inclut pas d'interface graphique, mais vous pouvez entierement gerer le serveur localement ou a distance avec Windows PowerShell ou d'autres outils. Vous pouvez passer ulterieurement a une autre option d'installation. Voir \"Options d’installation de Windows Server.\""
		set "DisplayName=Windows Server 2012 R2 Datacenter ^(Server Core Installation^)"
		set "DisplayDescription=Cette option ^(recommandee^) reduit la gestion et la maintenance en installant uniquement ce qui est necessaire pour executer la plupart des roles serveur et des applications. Il n'inclut pas d'interface graphique, mais vous pouvez entierement gerer le serveur localement ou a distance avec Windows PowerShell ou d'autres outils. Vous pouvez passer ulterieurement a une autre option d'installation. Voir \"Options d’installation de Windows Server.\""
	)

	if "%TargetEdition%" equ "ServerStandard" (
		set "Flag=ServerStandard"
		set "Edition=ServerStandard"
		set "Name=Windows Server 2012 R2 Standard ^(Server with a GUI^)"
		set "Description=This option is useful when a GUI is required-for example, to provide backward compatibility for an application that cannot be run on a Server Core installation. All server roles and features are supported. You can switch to a different installation option later. See \"Windows Server Installation Options.\""
		set "DisplayName=Windows Server 2012 R2 Standard ^(Server with a GUI^)"
		set "DisplayDescription=Cette option est utile lorsqu'une interface graphique est requise, par exemple, pour fournir une compatibilite descendante pour une application qui ne peut pas etre executee sur une installation Server Core. Tous les roles et fonctionnalites de serveur sont pris en charge. Vous pouvez passer ulterieurement à une autre option d'installation. Voir \"Options d’installation de Windows Server .\""
	)

	if "%TargetEdition%" equ "ServerDatacenter" (
		set "Flag=ServerDatacenter"
		set "Edition=ServerDatacenter"
		set "Name=Windows Server 2012 R2 Datacenter ^(Server with a GUI^)"
		set "Description=This option is useful when a GUI is required-for example, to provide backward compatibility for an application that cannot be run on a Server Core installation. All server roles and features are supported. You can switch to a different installation option later. See \"Windows Server Installation Options.\""
		set "DisplayName=Windows Server 2012 R2 Datacenter ^(Server with a GUI^)"
		set "DisplayDescription=Cette option est utile lorsqu'une interface graphique est requise, par exemple, pour fournir une compatibilite descendante pour une application qui ne peut pas etre executee sur une installation Server Core. Tous les roles et fonctionnalites de serveur sont pris en charge. Vous pouvez passer ulterieurement à une autre option d'installation. Voir \"Options d’installation de Windows Server .\""
	)
)

if "%SelectedSourceOS%" equ "w10" (
	if "%TargetEdition%" equ "Core" (
		set "Flag=Core"
		set "Edition=Core"
		set "Name=Windows 10 Home"
		set "Description=Windows 10 Home"
		set "DisplayName=Windows 10 Home"
		set "DisplayDescription=Windows 10 Home"
	)

	if "%TargetEdition%" equ "CoreN" (
		set "Flag=CoreN"
		set "Edition=CoreN"
		set "Name=Windows 10 Home N"
		set "Description=Windows 10 Home N"
		set "DisplayName=Windows 10 Home N"
		set "DisplayDescription=Windows 10 Home N"
	)

	if "%TargetEdition%" equ "Professional" (
		set "Flag=Professional"
		set "Edition=Professional"
		set "Name=Windows 10 Pro"
		set "Description=Windows 10 Pro"
		set "DisplayName=Windows 10 Pro"
		set "DisplayDescription=Windows 10 Pro"
	)

	if "%TargetEdition%" equ "ProfessionalN" (
		set "Flag=ProfessionalN"
		set "Edition=ProfessionalN"
		set "Name=Windows 10 Pro N"
		set "Description=Windows 10 Pro N"
		set "DisplayName=Windows 10 Pro N"
		set "DisplayDescription=Windows 10 Pro N"
	)

	if "%TargetEdition%" equ "ProfessionalCountrySpecific" (
		set "Flag=ProfessionalCountrySpecific"
		set "Edition=ProfessionalCountrySpecific"
		set "Name=Windows 10 Pro CountrySpecific"
		set "Description=Windows 10 Pro CountrySpecific"
		set "DisplayName=Windows 10 Pro CountrySpecific"
		set "DisplayDescription=Windows 10 Pro CountrySpecific"
	)

	if "%TargetEdition%" equ "ProfessionalSingleLanguage" (
		set "Flag=ProfessionalSingleLanguage"
		set "Edition=ProfessionalSingleLanguage"
		set "Name=Windows 10 Pro Single Language"
		set "Description=Windows 10 Pro Single Language"
		set "DisplayName=Windows 10 Pro Single Language"
		set "DisplayDescription=Windows 10 Pro Single Language"
	)

	if "%TargetEdition%" equ "Education" (
		set "Flag=Education"
		set "Edition=Education"
		set "Name=Windows 10 Education"
		set "Description=Windows 10 Education"
		set "DisplayName=Windows 10 Education"
		set "DisplayDescription=Windows 10 Education"
	)

	if "%TargetEdition%" equ "EducationN" (
		set "Flag=EducationN"
		set "Edition=EducationN"
		set "Name=Windows 10 Education N"
		set "Description=Windows 10 Education N"
		set "DisplayName=Windows 10 Education N"
		set "DisplayDescription=Windows 10 Education N"
	)

	if "%TargetEdition%" equ "Enterprise" (
		set "Flag=Enterprise"
		set "Edition=Enterprise"
		set "Name=Windows 10 Enterprise"
		set "Description=Windows 10 Enterprise"
		set "DisplayName=Windows 10 Enterprise"
		set "DisplayDescription=Windows 10 Enterprise"
	)

	if "%TargetEdition%" equ "EnterpriseN" (
		set "Flag=EnterpriseN"
		set "Edition=EnterpriseN"
		set "Name=Windows 10 Enterprise N"
		set "Description=Windows 10 Enterprise N"
		set "DisplayName=Windows 10 Enterprise N"
		set "DisplayDescription=Windows 10 Enterprise N"
	)

	if "%TargetEdition%" equ "EnterpriseG" (
		set "Flag=EnterpriseG"
		set "Edition=EnterpriseG"
		set "Name=Windows 10 Enterprise G"
		set "Description=Windows 10 Enterprise G"
		set "DisplayName=Windows 10 Enterprise G"
		set "DisplayDescription=Windows 10 Enterprise G"
	)

	if "%TargetEdition%" equ "EnterpriseGN" (
		set "Flag=EnterpriseGN"
		set "Edition=EnterpriseGN"
		set "Name=Windows 10 Enterprise GN"
		set "Description=Windows 10 Enterprise GN"
		set "DisplayName=Windows 10 Enterprise GN"
		set "DisplayDescription=Windows 10 Enterprise GN"
	)

	if "%TargetEdition%" equ "ProfessionalEducation" (
		set "Flag=ProfessionalEducation"
		set "Edition=ProfessionalEducation"
		set "Name=Windows 10 Pro Education"
		set "Description=Windows 10 Pro Education"
		set "DisplayName=Windows 10 Pro Education"
		set "DisplayDescription=Windows 10 Pro Education"
	)

	if "%TargetEdition%" equ "ProfessionalEducationN" (
		set "Flag=ProfessionalEducationN"
		set "Edition=ProfessionalEducationN"
		set "Name=Windows 10 Pro EducationN"
		set "Description=Windows 10 Pro Education N"
		set "DisplayName=Windows 10 Pro Education N"
		set "DisplayDescription=Windows 10 Pro Education N"
	)

	if "%TargetEdition%" equ "ProfessionalWorkstation" (
		set "Flag=ProfessionalWorkstation"
		set "Edition=ProfessionalWorkstation"
		set "Name=Windows 10 Pro for Workstations"
		set "Description=Windows 10 Pro for Workstations"
		set "DisplayName=Windows 10 Pro for Workstations"
		set "DisplayDescription=Windows 10 Pro for Workstations"
	)

	if "%TargetEdition%" equ "ProfessionalWorkstationN" (
		set "Flag=ProfessionalWorkstationN"
		set "Edition=ProfessionalWorkstationN"
		set "Name=Windows 10 Pro N for Workstations"
		set "Description=Windows 10 Pro N for Workstations"
		set "DisplayName=Windows 10 Pro N for Workstations"
		set "DisplayDescription=Windows 10 Pro N for Workstations"
	)

	if "%TargetEdition%" equ "ServerRdsh" (
		set "Flag=ServerRdsh"
		set "Edition=ServerRdsh"
		set "Name=Windows 10 Enterprise for Remote Sessions"
		set "Description=Windows 10 Enterprise for Remote Sessions"
		set "DisplayName=Windows 10 Enterprise for Remote Sessions"
		set "DisplayDescription=Windows 10 Enterprise for Remote Sessions"
	)

	if "%ImageBuild%" equ "14393" if "%ImageInstallationType%" equ "Server Core" if "%SourceEdition%" equ "ServerStandard" if "%TargetEdition%" equ "ServerAzureCor" (
		set "Flag=ServerAzureCor"
		set "Edition=ServerAzureCor"
		set "Name=Windows Server 2016 SERVERAZURECORE"
		set "Description=Windows Server 2016 SERVERAZURECORE"
		set "DisplayName=Windows Server 2016 Azure"
		set "DisplayDescription=Cette option ^(recommandee^) réduit la gestion et la maintenance en installant uniquement ce qui est necessaire pour executer la plupart des roles serveur et des applications. Il n'inclut pas d'interface graphique, mais vous pouvez entierement gerer le serveur localement ou a distance avec Windows PowerShell ou d'autres outils. Pour plus de details, voir \"Options d’installation de Windows Server.\""
	)

	if "%ImageBuild%" equ "14393" if "%ImageInstallationType%" equ "Server Core" if "%SourceEdition%" equ "ServerStandard" if "%TargetEdition%" equ "ServerDatacenter" (
		set "Flag=ServerDataCenterCore"
		set "Edition=ServerDatacenter"
		set "Name=Windows Server 2016 SERVERDATACENTERCORE"
		set "Description=Windows Server 2016 SERVERDATACENTERCORE"
		set "DisplayName=Windows Server 2016 Datacenter"
		set "DisplayDescription=Cette option ^(recommandee^) réduit la gestion et la maintenance en installant uniquement ce qui est necessaire pour executer la plupart des roles serveur et des applications. Il n'inclut pas d'interface graphique, mais vous pouvez entierement gerer le serveur localement ou a distance avec Windows PowerShell ou d'autres outils. Pour plus de details, voir \"Options d’installation de Windows Server.\""
	)

	if "%ImageBuild%" equ "14393" if "%ImageInstallationType%" equ "Server" if "%SourceEdition%" equ "ServerSolution" if "%TargetEdition%" equ "ServerStandard" (
		set "Flag=ServerStandard"
		set "Edition=ServerStandard"
		set "Name=Windows Server 2016 SERVERSTANDARD"
		set "Description=Windows Server 2016 SERVERSTANDARD"
		set "DisplayName=Windows Server 2016 Standard ^(Desktop Experience^)"
		set "DisplayDescription=Cette option est utile lorsqu'une interface graphique est requise, par exemple, pour fournir une compatibilite descendante pour une application qui ne peut pas etre executee sur une installation Server Core. Tous les roles et fonctionnalites de serveur sont pris en charge. Pour plus de details, voir \"Options d’installation de Windows Server.\""
	)

	if "%ImageBuild%" equ "14393" if "%ImageInstallationType%" equ "Server" if "%SourceEdition%" equ "ServerStandard" if "%TargetEdition%" equ "ServerDatacenter" (
		set "Flag=ServerDataCenter"
		set "Edition=ServerDatacenter"
		set "Name=Windows Server 2016 SERVERDATACENTER"
		set "Description=Windows Server 2016 SERVERDATACENTER"
		set "DisplayName=Windows Server 2016 Datacenter ^(Desktop Experience^)"
		set "DisplayDescription=Cette option est utile lorsqu'une interface graphique est requise, par exemple, pour fournir une compatibilite descendante pour une application qui ne peut pas etre executee sur une installation Server Core. Tous les roles et fonctionnalites de serveur sont pris en charge. Pour plus de details, voir \"Options d’installation de Windows Server.\""
	)

	if "%ImageBuild%" equ "17763" if "%ImageInstallationType%" equ "Server" if "%SourceEdition%" equ "ServerSolution" if "%TargetEdition%" equ "ServerStandard" (
		set "Flag=ServerStandard"
		set "Edition=ServerStandard"
		set "Name=Windows Server 2019 SERVERSTANDARD"
		set "Description=Windows Server 2019 SERVERSTANDARD"
		set "DisplayName=Windows Server 2019 Standard ^(Desktop Experience^)"
		set "DisplayDescription=Cette option installe l'environnement graphique complet de Windows, consommant de l'espace disque supplementaire. Cela peut etre utile si vous souhaitez utiliser le bureau Windows ou avoir une application qui en a besoin."
	)

	if "%ImageBuild%" equ "17763" if "%ImageInstallationType%" equ "Server" if "%SourceEdition%" equ "ServerStandard" if "%TargetEdition%" equ "ServerDatacenter" (
		set "Flag=ServerDataCenter"
		set "Edition=ServerDatacenter"
		set "Name=Windows Server 2019 SERVERDATACENTER"
		set "Description=Windows Server 2019 SERVERDATACENTER"
		set "DisplayName=Windows Server 2019 Datacenter ^(Desktop Experience^)"
		set "DisplayDescription=Cette option installe l'environnement graphique complet de Windows, consommant de l'espace disque supplementaire. Cela peut etre utile si vous souhaitez utiliser le bureau Windows ou avoir une application qui en a besoin."
	)
)

:: Setting Image Flag, Name and Description to reflect Target Edition
echo.Setting Image [Display Name] to "%DisplayName%"...
echo.Setting Image [Display Description] to "%DisplayDescription%"...
echo.Setting Image [Flag] to "%Flag%"...
echo.Setting Image [Edition] to "%Edition%"...
echo.
%WimLibImagex% info "%InstallWim%" %ImageIndexNo% "%Name%" "%Description%" --image-property DISPLAYNAME="%DisplayName%" --image-property DISPLAYDESCRIPTION="%DisplayDescription%" --image-property FLAGS="%Flag%" >nul
echo.-------------------------------------------------------------------------------
echo.####Copie du fichier de configuration EI.CFG dans le dossier ^<DVD\sources^>  #
echo.-------------------------------------------------------------------------------
echo.
echo.Copie du fichier EI.CFG de l'edition "%TargetEdition%" 
echo.dans le dossier ^<DVD\sources^> 
if exist "%DVD%\sources\EI.CFG" del /f /q "%DVD%\sources\EI.CFG" >nul
(
	echo.[EditionID]
	echo.%TargetEdition%
	echo.
	echo.[Channel]
	echo.Retail
	echo.
	echo.[VL]
	echo.0
)>"%DVD%\sources\EI.CFG"
echo.
echo.-------------------------------------------------------------------------------
echo.####Mise a niveau de l'edition d'image WIM source terminee  ###################
echo.-------------------------------------------------------------------------------
:Stop
echo.
echo.===============================================================================
echo.
pause

set SourceEdition=
set TargetEdition=
set Flag=
set Edition=
set Name=
set Description=
set DisplayName=
set DisplayDescription=

endlocal

:: Returning to WIM Manager Menu
goto :WIMManager
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Capture a Drive or Folder to a WIM Image
::-------------------------------------------------------------------------------------------
:WIMCapture

setlocal

set SourceDriveFolder=
set TargetWimImageFileName=
set TargetWimImageName=
set TargetWimImageDescription=
set TargetWimImageEditionFlag=
set BootFlag=

cls
echo.===============================================================================
echo.         MSMG ToolKit - Capturer un lecteur ou un dossier en image WIM
echo.===============================================================================
echo.
echo.-------------------------------------------------------------------------------
echo.####Demarrage de la capture d'un lecteur ou d'un dossier en image WIM #########
echo.-------------------------------------------------------------------------------
echo.
:: Get Source Drive or folder path to be Captuerd to WIM Image
set /p SourceDriveFolder=Entrer un lecteur source ou un chemin de dossier valide : 
echo.
:: Get Target WIM Image File Name
set /p TargetWimImageFileName=Entrer le nom de fichier de l'image WIM cible : 
echo.
:: Get Target WIM Image Name
set /p TargetWimImageName=Entrer le nom de l'image WIM cible : 
echo.
:: Get Target WIM Image Description
set /p TargetWimImageDescription=Entrer la description de l'image WIM cible : 
echo.
:: Get Target WIM Image Editon Flag
set /p TargetWimImageEditionFlag=Entrer l'edition d'image WIM cible  : 
echo.
:: Get Bootable Flag Status
choice /C:YN /N /M "Rendre l'image WIM cible amorcable  ? ['Y'es/'N'o] : "
if errorlevel 2 set BootFlag=No
if not errorlevel 2 set BootFlag=Yes
echo.
echo.-------------------------------------------------------------------------------
echo.####Capture d'un lecteur ou d'un dossier sur une image WIM ####################
echo.-------------------------------------------------------------------------------
call :CaptureImage "%DVD%\sources\%TargetWimImageFileName%", "%SourceDriveFolder%", %TargetWimImageName%, %TargetWimImageDescription%, %BootFlag%
echo.-------------------------------------------------------------------------------
echo.####Definition de l'indicateur, du nom et de la description de l'image WIM ####
echo.-------------------------------------------------------------------------------
echo.
:: Setting WIM Image Flag, Name and Description to reflect Target Edition
echo.Reglage de l'image WIM [Nom] sur "%TargetWimImageName%".
echo.
echo.Reglage de l'image WIM [Description] sur "%TargetWimImageDescription%".
echo.
echo.Définition de l'image WIM [Flag] sur "%TargetWimImageEditionFlag%".
%Imagex% /Flags "%TargetWimImageEditionFlag%" /Info "%DVD%\sources\%TargetWimImageFileName%" 1 %TargetWimImageName% %TargetWimImageDescription% >nul
echo.
echo.-------------------------------------------------------------------------------
echo.####Capture terminee du lecteur ou du dossier en image WIM ####################
echo.-------------------------------------------------------------------------------
:Stop
echo.
echo.===============================================================================
echo.
pause

set SourceDriveFolder=
set TargetWimImageFileName=
set TargetWimImageName=
set TargetWimImageDescription=
set TargetWimImageEditionFlag=
set BootFlag=

endlocal

:: Returning to WIM Manager Menu
goto :WIMManager
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Apply a WIM Image Index to a Drive or Folder
::-------------------------------------------------------------------------------------------
:WIMApply

setlocal

set TargetDriveFolder=

cls
echo.===============================================================================
echo.  MSMG ToolKit - Appliquer un index d'images WIM a un lecteur ou a un dossier 
echo.===============================================================================
echo.

:: Checking whether Windows Source Install Image file exist
if not exist "%InstallWim%" (
	echo.Impossible de trouver le fichier Image d'installation 
	echo.^<DVD\Sources\install.wim^> de Windows ... 
	echo.
	echo.Veuillez copier le fichier d'image d'installation de Windows
	echo.dans le dossier respectif. 
	goto :Stop
)

echo.-------------------------------------------------------------------------------
echo.####Demarrage de l'application d'un index d'images WIM à un lecteur... ########
echo.-------------------------------------------------------------------------------

:: Display Image Information
call :ShowImageInfo

:: Get Image Index No to Export
set /p ImageIndexNo=Entrez le numero d'index d'image WIM  ['Q'uit] : 

:: Checking for Image Index Validation
if not defined ImageIndexNo (
	echo.
	echo.Numero d'index saisi invalide... 
	echo.
	pause
	goto :WIMApply
)

if /i "%ImageIndexNo%" equ "Q" goto :WIMManager

:: Get Target Drive or folder path to Apply the WIM Image Index
echo.
set /p TargetDriveFolder=Entrer le lecteur cible ou le chemin du dossier : 
echo.
echo.-------------------------------------------------------------------------------
echo.####Application d'un index d'images WIM a un lecteur ou a un dossier ##########
echo.-------------------------------------------------------------------------------
echo.
call :ApplyImage "%InstallWim%", %ImageIndexNo%, %TargetDriveFolder%
echo.-------------------------------------------------------------------------------
echo.####Application d'un index d'images WIM à un lecteur ou a un dossier termine ##
echo.-------------------------------------------------------------------------------
:Stop
echo.
echo.===============================================================================
echo.
pause

set TargetDriveFolder=

endlocal

:: Returning to WIM Manager Menu
goto :WIMManager
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Cleanup a WIM Image Index
::-------------------------------------------------------------------------------------------
:WIMCleanUp

setlocal

set CleanupOption=

cls
echo.===============================================================================
echo.                 MSMG ToolKit - Nettoyer un index d'image WIM 
echo.===============================================================================
echo.

:: Checking whether Windows Source Install Image file exist
if not exist "%InstallWim%" (
	echo.Impossible de trouver le fichier Image d'installation 
	echo.^<DVD\Sources\install.wim^> de Windows. 
	echo.
	echo.Veuillez copier le fichier d'image d'installation de Windows  
	echo.dans le dossier respectif. 
	goto :Stop
)

echo.  [1]  Image de nettoyage
echo.
echo.  [2]  Nettoyer l'image avec CheckHealth
echo.
echo.  [3]  Nettoyer l'image avec ScanHealth 
echo.
echo.
echo.
echo.
echo.
echo.
echo.
echo.
echo.
echo.
echo.  [X]   Retour
echo.
echo.===============================================================================
echo.
choice /C:123X /N /M "Entrer votre choix : "
if errorlevel 4 goto :ToolsMenu
if errorlevel 3 set "CleanupOption=ScanHealth"
if errorlevel 2 set "CleanupOption=CheckHealth"
if errorlevel 1 set "CleanupOption=CleanupImage"

cls
echo.===============================================================================
echo.                 MSMG ToolKit - Nettoyer un index d'image WIM
echo.===============================================================================
echo.
echo.-------------------------------------------------------------------------------
if "%CleanupOption%" equ "CleanupImage" echo.####Image WIM source de départ  Cleanup##########################################
if "%CleanupOption%" equ "CheckHealth" echo.####Demarrage du nettoyage d'image source WIM avec Check Health ########################
if "%CleanupOption%" equ "ScanHealth" echo.####Demarrage du nettoyage d'image source WIM avec Scan Health #########################
echo.-------------------------------------------------------------------------------

:: Display Image Information
call :ShowImageInfo

:: Get Image Index No to Clean
set /p ImageIndexNo=Entrez le Numero d'index d'image WIM ['Q'uit] : 

:: Checking for Image Index Validation
if not defined ImageIndexNo (
	echo.
	echo.Numero d'index saisi invalide.
	echo.
	pause
	goto :WIMCleanUp
)

if /i "%ImageIndexNo%" equ "Q" goto :WIMManager

:: Getting Selected Image Index Information
call :GetImageIndexInfo "%InstallWim%", %ImageIndexNo% >nul

:: Setting Selected Source OS
if "%ImageVersion%" equ "6.1.7601" set "SelectedSourceOS=w7"
if "%ImageVersion%" equ "6.3.9600" set "SelectedSourceOS=w81"
if "%ImageVersion:~0,-6%" equ "10.0" set "SelectedSourceOS=w10"

echo.
echo.-------------------------------------------------------------------------------
if "%CleanupOption%" equ "CleanupImage" echo.####Source WIM Image Cleanup###################################################
if "%CleanupOption%" equ "CheckHealth" echo.####Source WIM Image Cleanup with Check Health#################################
if "%CleanupOption%" equ "ScanHealth" echo.####Source WIM Image Cleanup with Scan Health##################################
echo.-------------------------------------------------------------------------------
echo.
echo.-------------------------------------------------------------------------------
echo.Montage [Install.wim, Index : %ImageIndexNo%] Image WIM sur ^<\Mount\Install^>. 
echo.-------------------------------------------------------------------------------
call :MountImage "%InstallWim%", %ImageIndexNo%, "%InstallMount%"
echo.-------------------------------------------------------------------------------
echo.Execution de [Install.wim, Index : %ImageIndexNo%] Nettoyage d'image WIM.
echo.-------------------------------------------------------------------------------
if "%CleanupOption%" equ "CleanupImage" (
	if "%SelectedSourceOS%" equ "w7" call :CleanupImage "%InstallMount%", "SPSupersededHideSP"
	if "%SelectedSourceOS%" neq "w7" call :CleanupImage "%InstallMount%", "ComponentCleanupResetBase"
) else (
	call :CleanupImage "%InstallMount%", "ComponentCleanup", "%CleanupOption%"
)
echo.-------------------------------------------------------------------------------
echo.Application des modifications et Demontage [Install.wim, Index : %ImageIndexNo%] Image WIM... 
echo.-------------------------------------------------------------------------------
call :UnMountImage "%InstallMount%", "Commit"
echo.-------------------------------------------------------------------------------
if "%CleanupOption%" equ "CleanupImage" echo.####Nettoyage d'image WIM source termine ##########################################
if "%CleanupOption%" equ "CheckHealth" echo.####Nettoyage d'image WIM source termine avec Check Health ########################
if "%CleanupOption%" equ "ScanHealth" echo.####Nettoyage d'image WIM source termine avec etat de la numerisation #########################
echo.-------------------------------------------------------------------------------

:Stop
echo.
echo.===============================================================================
echo.
pause

set CleanupOption=

endlocal

:: Returning to WIM Manager Menu
goto :WIMManager
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Show MSMG ToolKit Debug Information
::-------------------------------------------------------------------------------------------
:Debug

cls
echo.===============================================================================
echo.                     MSMG ToolKit - Informations de debogage 
echo.===============================================================================
echo.
echo. HostArchitecture=%HostArchitecture%
echo. SelectedSourceOS=%SelectedSourceOS%
echo. IsSourceSelected=%IsSourceSelected%
echo. IsDialogsEnabled=%IsDialogsEnabled%
echo. IsLogsEnabled=%IsLogsEnabled%
echo.
echo.
echo.
echo. ImageIndexNo=%ImageIndexNo%
echo. ImageArchitecture=%ImageArchitecture%
echo. ImageBuild=%ImageBuild%
echo. ImageVersion=%ImageVersion%
echo. ImageServicePackBuild=%ImageServicePackBuild%
echo. ImageServicePackLevel=%ImageServicePackLevel%
echo. ImageDefaultLanguage=%ImageDefaultLanguage%
echo. ImageCount=%ImageCount%
echo.
echo.===============================================================================
echo.
pause

:: Returning to Tools Menu
goto :ToolsMenu
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: MSMG ToolKit - Options Menu
::-------------------------------------------------------------------------------------------
:Options

cls
echo.===============================================================================
echo.                          MSMG ToolKit - Menu Options
echo.===============================================================================
echo.
echo.  [1]   Definir les parametres de couleur de ToolKit 
echo.
if "%IsDialogsEnabled%" equ "No" echo.  [2]   Activer les boites de dialogue Info/Avertissement ToolKit 
if "%IsDialogsEnabled%" equ "Yes" echo.  [2]   Desactiver les boites de dialogue Info/Avertissement ToolKit 
echo.
if "%IsLogsEnabled%" equ "No" echo.  [3]   Activer la génération de journaux ToolKit 
if "%IsLogsEnabled%" equ "Yes" echo.  [3]   Desactiver la generation de journaux ToolKit 
echo.
if "%IsImageRegistryLoaded%" equ "No" echo.  [4]   Charger le registre d'images 
if "%IsImageRegistryLoaded%" equ "Yes" echo.  [4]   Decharger le registre d'images 
echo.
echo.
echo.
echo.
echo.
echo.
echo.
echo.
echo.  [X]   Retour
echo.
echo.===============================================================================
echo.
choice /C:1234X /N /M "Entrer votre choix : "
if errorlevel 5 goto :ToolsMenu
if errorlevel 4 (
	if "%IsImageRegistryLoaded%" equ "No" (
		cls
		echo.===============================================================================
		echo.                        MSMG ToolKit - Registre d'images
		echo.===============================================================================
		echo.
		:: Checking whether Source OS is Selected
		if "%IsSourceSelected%" equ "No" (
			echo.Le systeme d'exploitation source n'est pas selectionne, 
			echo.veuillez selectionner dans le menu "Source". 
			echo.
			echo.===============================================================================
			echo.
			pause
			goto :MainMenu
		)
		
		for /l %%i in (1, 1, %ImageCount%) do (
			echo.Chargement du registre d'images... 
			call :MountImageRegistry "%InstallMount%\%%i"
		)

		set "IsImageRegistryLoaded=Yes"
		echo.
		echo.[HKEY_LOCAL_MACHINE\TK_SOFTWARE]         -^> [HKEY_LOCAL_MACHINE\SOFTWARE]
		echo.[HKEY_LOCAL_MACHINE\TK_SOFTWARE\Classes] -^> [HKEY_CLASSES_ROOT]
		echo.[HKEY_LOCAL_MACHINE\TK_SYSTEM]           -^> [HKEY_LOCAL_MACHINE\SYSTEM]
		echo.[HKEY_LOCAL_MACHINE\TK_NTUSER]           -^> [HKEY_CURRENT_USER]
		echo.[HKEY_LOCAL_MACHINE\TK_DEFAULT]          -^> [HKEY_USERS\.Default]
		echo.
		echo.Chargement du registre d'images termine...
		echo.
		echo.===============================================================================
		echo.
		pause
	)
	if "%IsImageRegistryLoaded%" equ "Yes" (
		cls
		echo.===============================================================================
		echo.                        MSMG ToolKit - Registre d'images 
		echo.===============================================================================
		echo.
		echo.Dechargement du registre d'images... 
		call :UnMountImageRegistry
		set "IsImageRegistryLoaded=No"
		echo.
		echo.Dechargement du registre d'images termine... 
		echo.
		echo.===============================================================================
		echo.
		pause
	)
	goto :Toolsmenu
)
if errorlevel 3 (
	if "%IsLogsEnabled%" equ "No" set "IsLogsEnabled=Yes"
	if "%IsLogsEnabled%" equ "Yes" set "IsLogsEnabled=No"
	goto :Toolsmenu
)
if errorlevel 2 (
	if "%IsDialogsEnabled%" equ "No" set "IsDialogsEnabled=Yes"
	if "%IsDialogsEnabled%" equ "Yes" set "IsDialogsEnabled=No"
	goto :Toolsmenu
)
if errorlevel 1 goto :SetTkColor

::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Set ToolKit Color Settings
::-------------------------------------------------------------------------------------------
:SetTkColor

cls
echo.===============================================================================
echo.          MSMG ToolKit - Definir les parametres de couleur de ToolKit 
echo.===============================================================================
echo. Liste des couleurs d'arriere-plan/de premier plan disponibles : 
echo.
echo.  [1]  Black - White                [F]  Aqua         - Blue
echo.  [2]  Black - Light Green          [G]  Aqua         - Light Blue
echo.  [3]  Black - Light Aqua           [H]  Aqua         - Light Yellow
echo.  [4]  Black - Light Red            [I]  Red          - Light Green
echo.  [5]  Black - Light Yellow         [J]  Red          - Light Aqua
echo.  [6]  Black - Bright White         [K]  Red          - Light Yellow
echo.  [7]  Blue  - White                [L]  Red          - Bright White
echo.  [8]  Blue  - Light Green          [M]  Light Blue   - White
echo.  [9]  Blue  - Light Aqua           [N]  Light Blue   - Light Green
echo.  [A]  Blue  - Light Red            [O]  Light Blue   - Light Aqua
echo.  [B]  Blue  - Light Purple         [P]  Light Blue   - Light Yellow
echo.  [C]  Blue  - Light Yellow         [Q]  Light Blue   - Bright White
echo.  [D]  Blue  - Bright White         [R]  Bright White - Black
echo.  [E]  Aqua  - Black                [S]  Bright White - Blue
echo.
echo.  [X]  Retour
echo.===============================================================================
echo.
choice /C:123456789ABCDEFGHIJKLMNoPQRSX /N /M "Entrer votre choix : "
if errorlevel 29 goto :Options
if errorlevel 28 color F1
if errorlevel 27 color F0
if errorlevel 26 color 9F
if errorlevel 25 color 9E
if errorlevel 24 color 9B
if errorlevel 23 color 9A
if errorlevel 22 color 97
if errorlevel 21 color 4F
if errorlevel 20 color 4E
if errorlevel 19 color 4B
if errorlevel 18 color 4A
if errorlevel 17 color 3E
if errorlevel 16 color 39
if errorlevel 15 color 31
if errorlevel 14 color 30
if errorlevel 13 color 1F
if errorlevel 12 color 1E
if errorlevel 11 color 1D
if errorlevel 10 color 1C
if errorlevel 9  color 1B
if errorlevel 8  color 1A
if errorlevel 7  color 17
if errorlevel 6  color 0F
if errorlevel 5  color 0E
if errorlevel 4  color 0C
if errorlevel 3  color 0B
if errorlevel 2  color 0A
if errorlevel 1  color 07

:: Returning to Tools Menu
goto :ToolsMenu
::-------------------------------------------------------------------------------------------

:: ############################################################################################
:: MSMG ToolKit DISM Functions
:: ############################################################################################

::-------------------------------------------------------------------------------------------
:: Function to get Image Index Count
:: Input Parameters [ %~1 : Image Filename ]
::-------------------------------------------------------------------------------------------
:GetImageCount

:: Finding total no of Indexes present in the Image.
for /f "tokens=2 delims=: " %%a in ('%DISM% /Get-ImageInfo /ImageFile:%~1 ^| findstr /i Index') do (set ImageCount=%%a)

goto :eof
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to display Image Information
::-------------------------------------------------------------------------------------------
:ShowImageInfo

set "ImageInfo=%Temp%\ImageInfo.txt"

call :RemoveFile %ImageInfo%

:: Get total no of Indexes present in the Image.
call :GetImageCount "%InstallWim%"

echo.
echo.Lecture des informations sur l'image 
echo.
:: List all the Indexes in the Image.
echo.===============================================================================>>%ImageInfo%
echo.^| Index ^| Arch ^| Name>>%ImageInfo%
echo.===============================================================================>>%ImageInfo%
for /f "tokens=2 delims=: " %%a in ('%DISM% /Get-WimInfo /WimFile:%InstallWim% ^| findstr /i Index') do (
	for /f "tokens=2 delims=: " %%b in ('%DISM% /Get-WimInfo /WimFile:%InstallWim% /Index:%%a ^| findstr /i Architecture') do (
		for /f "tokens=2 delims=:" %%c in ('%DISM% /Get-WimInfo /WimFile:%InstallWim% /Index:%%a ^| findstr /i Name') do (
			if "%%b" neq "arm64" (
				if %%a leq 9 echo.^|   %%a   ^| %%b  ^|%%c>>%ImageInfo%
				if %%a gtr 9 if %%a lss 99 echo.^|   %%a  ^| %%b  ^|%%c>>%ImageInfo%
				if %%a gtr 99 echo.^|   %%a ^| %%b  ^|%%c>>%ImageInfo%
			)
			if "%%b" equ "arm64" (
				if %%a leq 9 echo.^|   %%a   ^| %%b^|%%c>>%ImageInfo%
				if %%a gtr 9 if %%a lss 99 echo.^|   %%a  ^| %%b^|%%c>>%ImageInfo%
				if %%a gtr 99 echo.^|   %%a ^| %%b^|%%c>>%ImageInfo%
			)
		)
	)
)

type %ImageInfo%
call :RemoveFile %ImageInfo%

echo.===============================================================================
echo.

goto :eof
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to get Image Index number to service
:: Input Parameters [ %~1 : Image Filename ]
::-------------------------------------------------------------------------------------------
:GetImageIndexNo

:: Display the list of avaialble Image Indexes.
call :ShowImageInfo

if "%ImageCount%" equ "1" (
	set /p ImageIndexNo=Entrer le numero d'index d'image  ['Q'uit] : 
) else set /p ImageIndexNo=Entrer le numero d'index d'image [Range : 1,...%ImageCount% or 'A'll 'Q'uit] : 

goto :eof
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to get Image Index Architecture
:: Input Parameters [ %~1 : Image Filename, %~2 : Image Index No ]
::-------------------------------------------------------------------------------------------
:GetImageArchitecture

for /f "tokens=2 delims=: " %%a in ('%DISM% /Get-ImageInfo /ImageFile:"%~1" /Index:%~2 ^| findstr /i Architecture') do (set ImageArchitecture=%%a)

goto :eof
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to get Image Index Edition
:: Input Parameters [ %~1 : Image Filename, %~2 : Image Index No ]
::-------------------------------------------------------------------------------------------
:GetImageEdition

for /f "tokens=2 delims=: " %%f in ('%DISM% /Get-ImageInfo /ImageFile:"%~1" /Index:%~2 ^| findstr /i Edition') do (set ImageEdition=%%f)

goto :eof
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to get Image Index Information
:: Input Parameters [%~1 : Image Filename, %~2 : Image Index No]
::-------------------------------------------------------------------------------------------
:GetImageIndexInfo

for /f "tokens=2 delims=:" %%a in ('%DISM% /Get-ImageInfo /ImageFile:"%~1" /Index:%~2 ^| findstr /i Name') do (set ImageName=%%a)
for /f "tokens=2 delims=:" %%b in ('%DISM% /Get-ImageInfo /ImageFile:"%~1" /Index:%~2 ^| findstr /i Description') do (set ImageDescription=%%b)
for /f "tokens=2 delims=: " %%c in ('%DISM% /Get-ImageInfo /ImageFile:"%~1" /Index:%~2 ^| findstr /i Architecture') do (set ImageArchitecture=%%c)
for /f "tokens=2 delims=: " %%d in ('%DISM% /Get-ImageInfo /ImageFile:"%~1" /Index:%~2 ^| findstr /i Version') do (set ImageVersion=%%d)
for /f "tokens=2 delims=:" %%e in ('%DISM% /Get-ImageInfo /ImageFile:"%~1" /Index:%~2 ^| find "ServicePack Build"') do (set ImageServicePackBuild=%%e)
for /f "tokens=2 delims=:" %%f in ('%DISM% /Get-ImageInfo /ImageFile:"%~1" /Index:%~2 ^| find "ServicePack Level"') do (set ImageServicePackLevel=%%f)
for /f "tokens=2 delims=: " %%g in ('%DISM% /Get-ImageInfo /ImageFile:"%~1" /Index:%~2 ^| findstr /i Edition') do (set ImageEdition=%%g)
for /f "tokens=2 delims=:<> " %%h in ('%Imagex% /info "%~1" %~2 ^| findstr /i Flag') do (set ImageFlag=%%h)
for /f "tokens=2 delims=:" %%i in ('%DISM% /Get-ImageInfo /ImageFile:"%~1" /Index:%~2 ^| findstr /i Installation') do (set ImageInstallationType=%%i)
for /f "tokens=* delims=" %%j in ('%DISM% /Get-ImageInfo /ImageFile:"%~1" /Index:%~2 ^| findstr /i Default') do (set ImageDefaultLanguage=%%j)

set "ImageName=%ImageName:~1%"
set "ImageDescription=%ImageDescription:~1%"
if "%ImageVersion:~0,-6%" neq "10.0" set "ImageBuild=%ImageVersion:~4,4%"
if "%ImageVersion:~0,-6%" equ "10.0" set "ImageBuild=%ImageVersion:~5,5%"
set "ImageServicePackBuild=%ImageServicePackBuild:~1%"
set "ImageServicePackLevel=%ImageServicePackLevel:~1%"
set "ImageInstallationType=%ImageInstallationType:~1%"
set "ImageDefaultLanguage=%ImageDefaultLanguage:~1,-10%"

if "%ImageFlag%" equ "" set "ImageFlag=%ImageEdition%"

if "%ImageInstallationType:~,6%" equ "Server" set "ImageDescription=%ImageDescription:(=[%"
if "%ImageInstallationType:~,6%" equ "Server" set "ImageDescription=%ImageDescription:)=]%"

goto :eof
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Mount a Image
:: Input Parameters [ %~1 : Image Filename, %~2 : Image Index No, %~3 : Image Mount folder ]
::-------------------------------------------------------------------------------------------
:MountImage

%DISM% /Mount-Image /ImageFile:%~1 /Index:%~2 /MountDir:%~3
echo.

goto :eof
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Un-Mount the Mounted Image
:: Input Parameters [ %~1 : Image Mount Folder, %~2 : Image Commit / Discard Option ]
::-------------------------------------------------------------------------------------------
:UnMountImage

%DISM% /Unmount-Image /MountDir:%~1 /%~2
echo.

goto :eof
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to delete a selected Image Index from a Image
:: Input Parameters [ %~1 : Image Filename, %~2 : Image Index No ]
::-------------------------------------------------------------------------------------------
:DeleteImage

%DISM% /Delete-Image /ImageFile:%~1 /Index:%~2
echo.

goto :eof
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to rename a selected Image Index Information
:: Input Parameters [ %~1 : Image Filename, %~2 : Image Index No, %~3 : Image Name, %~4 : Image Description ]
::-------------------------------------------------------------------------------------------
:RenameImage

%Imagex% /Info %~1 %~2 "%~3" "%~4"

goto :eof
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to split a Image
:: Input Parameters [ %~1 : Image Filename, %~2 : Image Split Filename, %~3 : Image Split Size in MB ]
::-------------------------------------------------------------------------------------------
:SplitImage

%DISM% /Split-Image /ImageFile:%~1 /SWMFile:%~2 /FileSize:%~3
echo.

goto :eof
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to merge a splitted Image
:: Input Parameters [ %~1 : Image Splitted Filename without Extension, %~2 : Image Filename ]
::-------------------------------------------------------------------------------------------
:MergeImage

%Imagex% /ref %~1*.swm /Check /Export %~1.swm * %~2

goto :eof
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to apply a Image to a drive or a folder
:: Input Parameters [ %~1 : Image Filename, %~2 : Image Index No, %~3 : Image Apply Drive or folder Name ]
::-------------------------------------------------------------------------------------------
:ApplyImage

%DISM% /Apply-Image /ImageFile:%~1 /Index:%~2 /ApplyDir:%~3\ /CheckIntegrity /Verify
echo.

goto :eof
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to capture a drive or a folder to a Image
:: Input Parameters [ %~1 : Image Filename, %~2 : Capture Drive or Folder Name,
::                    %~3 : Index Name,  %~4 : Index Description, %~5 : Bootable or Not Options ]
::-------------------------------------------------------------------------------------------
:CaptureImage

if "%~5" equ "Yes" %DISM% /Capture-Image /Imagefile:%~1 /CaptureDir:%~2 /Name:"%~3" /Description:"%~4" /ConfigFile:%WimConfigFile% /Bootable /Compress:Max /CheckIntegrity /Verify
if "%~5" equ "No" %DISM% /Capture-Image /Imagefile:%~1 /CaptureDir:%~2 /Name:"%~3" /Description:"%~4" /ConfigFile:%WimConfigFile% /Compress:Max /CheckIntegrity /Verify
echo.

goto :eof
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to append another Image to Image
:: Input Parameters [ %~1 : Image Filename, %~2 : Capture Drive or Folder Name,
::                    %~3 : Index Name,  %~4 : Index Description, %~5 : Bootable or Not Option ]
::-------------------------------------------------------------------------------------------
:AppendImage

if "%~5" equ "Yes" %DISM% /Append-Image /Imagefile:%~1 /CaptureDir:%~2 /Name:"%~3" /Description:"%~4" /ConfigFile:%WimConfigFile% /Bootable /CheckIntegrity /Verify
if "%~5" equ "No" %DISM% /Append-Image /Imagefile:%~1 /CaptureDir:%~2 /Name:"%~3" /Description:"%~4" /ConfigFile:%WimConfigFile% /CheckIntegrity /Verify
echo.

goto :eof
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to export a select Image Index with Maximum/Recovery compression
:: Input Parameters [ %~1 : Source Image Filename, %~2 : Source Image Index No,
::                    %~3 : Target Image Filename, %~4 : Image Format, %~5 : Bootable or Not Option ]
::-------------------------------------------------------------------------------------------
:ExportImageIndex

if "%~4" equ "WIM" if "%~5" equ "Yes" %DISM% /Export-Image /SourceImageFile:%~1 /SourceIndex:%~2 /DestinationImageFile:%~3 /CheckIntegrity /Compress:Max /Bootable
if "%~4" equ "WIM" if "%~5" equ "No" %DISM% /Export-Image /SourceImageFile:%~1 /SourceIndex:%~2 /DestinationImageFile:%~3 /CheckIntegrity /Compress:Max
if "%~4" equ "ESD" if "%~5" equ "Yes" %DISM% /Export-Image /SourceImageFile:%~1 /SourceIndex:%~2 /DestinationImageFile:%~3 /CheckIntegrity /Compress:Recovery /Bootable
if "%~4" equ "ESD" if "%~5" equ "No" %DISM% /Export-Image /SourceImageFile:%~1 /SourceIndex:%~2 /DestinationImageFile:%~3 /CheckIntegrity /Compress:Recovery
echo.

goto :eof
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to export all Image Indexes with Maximum/Recovery compression
:: Input Parameters [ %~1 : Source Image Filename, %~2 : Target Image Filename, %~3 : Image Format, %~4 : Bootable or Not Option ]
::-------------------------------------------------------------------------------------------
:ExportImage

if "%~3" equ "WIM" if "%~4" equ "Yes" %DISM% /Export-Image /SourceImageFile:%~1 /All /DestinationImageFile:%~2 /CheckIntegrity /Compress:Max /Bootable
if "%~3" equ "WIM" if "%~4" equ "No" %DISM% /Export-Image /SourceImageFile:%~1 /All /DestinationImageFile:%~2 /CheckIntegrity /Compress:Max
if "%~3" equ "ESD" if "%~4" equ "Yes" %DISM% /Export-Image /SourceImageFile:%~1 /All /DestinationImageFile:%~2 /CheckIntegrity /Compress:Recovery /Bootable
if "%~3" equ "ESD" if "%~4" equ "No" %DISM% /Export-Image /SourceImageFile:%~1 /All /DestinationImageFile:%~2 /CheckIntegrity /Compress:Recovery
echo.

goto :eof
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to cleanup a Image
:: Input Parameters [ %~1 : Image Mount Path, %~2 : Option  ]
::-------------------------------------------------------------------------------------------
:CleanupImage

setlocal

set "CleanupOption=%~2"

if "%CleanupOption%" equ "SPSupersededHideSP" (
	%DISM% /Image:%~1 /Cleanup-Image /SPSuperseded /HideSP
)

if "%CleanupOption%" equ "ComponentCleanupResetBase" (
	%DISM% /Image:%~1 /Cleanup-Image /StartComponentCleanup /ResetBase
)

if "%CleanupOption%" equ "CheckHealth" (
	%DISM% /Image:%~1 /Cleanup-Image /CheckHealth
)

if "%CleanupOption%" equ "ScanHealth" (
	%DISM% /Image:%~1 /Cleanup-Image /ScanHealth
)

echo.

endlocal

goto :eof
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to add driver packages to Image
:: Input Parameters [ %~1 : Image Mount Path, %~2 : Drivers Packages Path ]
::-------------------------------------------------------------------------------------------
:AddDriver

%DISM% /Image:%~1 /Add-Driver /Driver:%~2 /ForceUnsigned /Recurse
echo.

goto :eof
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to enable a feature inside a Image
:: Input Parameters [ %~1 : Image Mount Path, %~2 : Feature Name ]
::-------------------------------------------------------------------------------------------
:EnableFeature

%DISM% /Image:%~1 /Enable-Feature /FeatureName:%~2
echo.

goto :eof
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to disable a feature inside a Image
:: Input Parameters [ %~1 : Image Mount Path, %~2 : Feature Name ]
::-------------------------------------------------------------------------------------------
:DisableFeature

%DISM% /Image:%~1 /Disable-Feature /FeatureName:%~2
echo.

goto :eof
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to export a list of packages present inside a Image to a file
:: Input Parameters [ %~1 : Image Mount Path, %~2 : Filename ]
::-------------------------------------------------------------------------------------------
:GetPackages

%DISM% /Get-Packages /Image:%~1 > %Logs%\%~2

goto :eof
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to export the list of features present inside a Image to a file
:: Input Parameters [ %~1 : Image Mount Path, %~2 : Filename ]
::-------------------------------------------------------------------------------------------
:GetFeatures

%DISM% /Get-Features /Format:Table /Image:%~1 > %Logs%\%~2

goto :eof
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to add a Package to Image
:: Input Parameters [ %~1 : Image Mount Path, %~2 : Packages Path / Package Name ]
::-------------------------------------------------------------------------------------------
:AddPackage

%DISM% /Image:%~1 /Add-Package /PackagePath:%~2
echo.

goto :eof
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to remove a Package from a Image
:: Input Parameters [ %~1 : Image Mount Path, %~2 : Packages Path / Package Name ]
::-------------------------------------------------------------------------------------------
:RemovePackage

%DISM% /Image:%~1 /Remove-Package /PackageName:%~2
echo.

goto :eof
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to add a provisioned appx package to a Image
:: Input Parameters [ %~1 : Image Mount Path, %~2 : App Name, %~3 : App Package Path, %~4 : App Dependency Packages Path, %~5 : App License Path ]
::-------------------------------------------------------------------------------------------
:AddProvisionedAppxPackage

echo.-------------------------------------------------------------------------------
echo.Integration du package Appx %~2 provisionne... 
echo.-------------------------------------------------------------------------------
%DISM% /Image:%~1 /Add-ProvisionedAppxPackage /PackagePath:%~3 %~4 /LicensePath:%~5
echo.

goto :eof
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to remove provisioned appx package from the Image
:: Input Parameters [ %~1 : Image Mount Path, %~2 : App Name, %~3 : Package Name ]
::-------------------------------------------------------------------------------------------
:RemoveProvisionedAppxPackage

setlocal

set PackageName=

echo.-------------------------------------------------------------------------------
echo.Suppression du package Appx %~2 provisionne... 
echo.-------------------------------------------------------------------------------

:: Getting Provisioned Appx Package list
for /f "tokens=2 delims=: " %%a in ('%DISM% /Image:%~1 /Get-ProvisionedAppxPackages ^| find /I "PackageName : %~3"') do (set PackageName=%%a)

if "%PackageName%" equ "" (
	echo.
	echo.Le package Appx provisionne specifie a deja ete supprime... 
) else (
	:: Removing Provisioned Appx Package from the Image
	%DISM% /Image:%~1 /Remove-ProvisionedAppxPackage /PackageName:%PackageName%
)

echo.

set PackageName=

endlocal

goto :eof
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to remove the default application associations from the Windows image
:: Input Parameters [ %~1 : Image Mount Path ]
::-------------------------------------------------------------------------------------------
:RemoveDefaultAppAssociations

%DISM% /Image:%~1 /Remove-DefaultAppAssociations

goto :eof
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to import a set of default application associations to a Windows image
:: Input Parameters [ %~1 : Image Mount Path, %~2 : App Association XML Filename ]
::-------------------------------------------------------------------------------------------
:ImportDefaultAppAssociations

%DISM% /Image:%~1 /Import-DefaultAppAssociations:%~2

goto :eof
::-------------------------------------------------------------------------------------------

:: ############################################################################################
:: MSMG ToolKit Misc Functions
:: ############################################################################################

::-------------------------------------------------------------------------------------------
:: Function to remove a Locked/Hidden Windows Package from the Image
:: Input Parameters [ %~1 : Image Mount Path, %~2 : Package Description, %~3 : Package Name ]
::-------------------------------------------------------------------------------------------
:RemoveLockedPackage

setlocal

set PackageName=

echo.-------------------------------------------------------------------------------
echo.Removing %~2 Package...
echo.-------------------------------------------------------------------------------

:: Making Locked/Hidden Windows Package visible
call :UnHidePackage "%~1", %~3

:: Getting Windows Package List
for /f "tokens=2 delims=:" %%a in ('%DISM% /Image:%~1 /Get-Packages ^| find /I "%~3"') do ( set PackageName=%%a )

if "%PackageName%" neq "" (
	if "%SelectedSourceOS%" equ "w7" (
		for /f "tokens=* delims= " %%a in ("%PackageName%") do set PackageName=%%a
		for /l %%a in (1,1,31) do if "!PackageName:~-1!" equ " " set PackageName=!PackageName:~0,-1!
	)
	if "%SelectedSourceOS%" neq "w7" set PackageName=%PackageName:~1,-1%
)

if "%PackageName%" equ "" (
	echo.
	echo.Le package specifie a deja ete supprime... 
	echo.
) else (
	:: Removing Windows Package from the Image
	%DISM% /Image:%~1 /Remove-Package /PackageName:%PackageName%
	echo.
)

set PackageName=

endlocal

goto :eof
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to mount Image Registry
:: Input Parameters [ %~1 : Image Mount Path ]
::-------------------------------------------------------------------------------------------
:MountImageRegistry

:: Mounting Image Registry for Offline Editing
reg load HKLM\TK_COMPONENTS "%~1\Windows\System32\config\COMPONENTS" >nul
reg load HKLM\TK_DEFAULT "%~1\Windows\System32\config\default" >nul
reg load HKLM\TK_NTUSER "%~1\Users\Default\ntuser.dat" >nul
reg load HKLM\TK_SOFTWARE "%~1\Windows\System32\config\SOFTWARE" >nul
reg load HKLM\TK_SYSTEM "%~1\Windows\System32\config\SYSTEM" >nul

goto :eof
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to unmount Image Registry
:: Input Parameters [ None ]
::-------------------------------------------------------------------------------------------
:UnMountImageRegistry

:: Un-Mounting Image Registry
reg unload HKLM\TK_COMPONENTS >nul 2>&1
reg unload HKLM\TK_DRIVERS >nul 2>&1
reg unload HKLM\TK_DEFAULT >nul 2>&1
reg unload HKLM\TK_NTUSER >nul 2>&1
reg unload HKLM\TK_SCHEMA >nul 2>&1
reg unload HKLM\TK_SOFTWARE >nul 2>&1
reg unload HKLM\TK_SYSTEM >nul 2>&1

goto :eof
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to import registry settings to Image Registry
:: Input Parameters [ %~1 : Import Registry file Name ]
::-------------------------------------------------------------------------------------------
:ImportRegistry2Image

:: Importing registry settings to Image Registry
reg import "%~1"

goto :eof
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to Create a Folder
:: Input Parameters [ %~1 : Foldername ]
::-------------------------------------------------------------------------------------------
:CreateFolder

if not exist "%~1" md "%~1" >nul

goto :eof
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to delete a file(s)
:: Input Parameters [ %~1 : Filename ]
::-------------------------------------------------------------------------------------------
:RemoveFile

if exist "%~1" del /f /q "%~1" >nul

goto :eof
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to delete a folder(s)
:: Input Parameters [ %~1 : Foldername ]
::-------------------------------------------------------------------------------------------
:RemoveFolder

if exist "%~1" rd /q /s "%~1" >nul

goto :eof
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to unhide a Windows Component Package
:: Input Parameters [ %~1 : Image Mount Path, %~2 : Package Name ]
::-------------------------------------------------------------------------------------------
:UnHidePackage

setlocal

set RegistryKey=

:: Mounting Image Registry
call :MountImageRegistry "%~1" >nul

:: Retriving Package Registry Key Path
for /f "tokens=* delims=" %%a in ('reg query "HKLM\TK_SOFTWARE\Microsoft\Windows\CurrentVersion\Component Based Servicing\Packages" /f "%~2" ^| find /I "%~2"') do ( set "RegistryKey=%%a" )

:: Making Windows Components Package visible
reg add "%RegistryKey%" /v Visibility /t REG_DWORD /d 1 /f >nul 2>&1
reg add "%RegistryKey%" /v DefVis /t REG_DWORD /d 2 /f >nul 2>&1
reg delete "%RegistryKey%\Owners" /f >nul 2>&1

:: Un-Mounting Image Registry
call :UnMountImageRegistry

set RegistryKey=

endlocal

goto :eof
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Cleanup MSMG Toolkit's temporary files and folders
::-------------------------------------------------------------------------------------------
:CleanUp

echo.Demarrage du nettoyage... 
echo.
echo.Nettoyage des points de montage du registre d'images... 
call :UnMountImageRegistry
echo.
echo.Nettoyage des points de montage de l'image... 
Dism.exe /English /Quiet /Unmount-Wim /MountDir:"%BootMount%\1" /Discard >nul
Dism.exe /English /Quiet /Unmount-Wim /MountDir:"%BootMount%\2" /Discard >nul

for /l %%i in (1, 1, 50) do (
	if exist "%WinReMount%\%%i\Windows" Dism.exe /English /Unmount-Wim /MountDir:"%WinReMount%\%%i" /Discard >nul
	if exist "%InstallMount%\%%i\Windows" Dism.exe /English /Unmount-Wim /MountDir:"%InstallMount%\%%i" /Discard >nul
)

Dism.exe /English /Cleanup-Mountpoints >nul
Dism.exe /English /Cleanup-Wim >nul

:: Cleaning Up Images Mount Points Folders
call :RemoveFolder "%BootMount%"
call :CreateFolder "%BootMount%\1"
call :CreateFolder "%BootMount%\2"
call :RemoveFolder "%InstallMount%"
call :CreateFolder "%InstallMount%"
call :RemoveFolder "%WinReMount%"
call :CreateFolder "%WinReMount%"
echo.

:: Cleaning Up Logs Folders
echo.Nettoyage des fichiers journaux... 
call :RemoveFolder "%Logs%"
call :CreateFolder "%Logs%"
echo.

:: Cleaning Up Temporary files Folders
echo.Nettoyage des fichiers temporaires... 
call :RemoveFolder "%Temp%"
call :CreateFolder "%Temp%"

echo.
echo.Nettoyage termine... 
echo.

goto :eof
::-------------------------------------------------------------------------------------------

::-------------------------------------------------------------------------------------------
:: Function to quit MSMG Toolkit
::-------------------------------------------------------------------------------------------
:Quit

cls
echo.===============================================================================
echo. 	                    MSMG ToolKit - Quitter
echo.===============================================================================
echo.
if "%IsSourceSelected%" equ "Yes" (
	echo.Le systeme d'exploitation source est selectionne, veuillez choisir 
	echo.Enregistrer/Supprimer dans le menu principal "Appliquer". 
	echo.
	echo.===============================================================================
	echo.
	pause

	goto :Mainmenu
)
echo.Execution de l'operation de post-nettoyage, veuillez patienter... 
echo.
call :CleanUp
echo.Merci et Credits a tous chez MDL... 
echo.
echo.Quitter MSMG ToolKit...
echo.
echo.===============================================================================
echo.
pause

:: Restoring DOS Window Size
reg delete "HKCU\Console\%%SystemRoot%%_system32_cmd.exe" /f >nul

color 00
endlocal EnableExtensions EnableDelayedExpansion

exit